/**
 * @파일명 : common_util.js
 * @작성자 : 최정동
 * @생성일 : 2018. 7. 05. 오전 9:35:00
 * @메뉴명 : JS 유틸 파일 
 */


var getHtmlName = function(){
	var _strIdx = window.location.href.indexOf('/html');
	var _endIdx = window.location.href.indexOf(".html");
	var _pageName = window.location.href.substring(_strIdx+6, _endIdx);

	return _pageName; 
};
function cryptoRandom(){
	var array = new Uint32Array(1),
		max = Math.pow(2, 32),
		randomValue = window.crypto.getRandomValues(array)[0] / max;
	return randomValue;
}
function getRandom(power) {//1=>=>1~9, 2=>1~999
	var _range= Math.pow(10, power);
	return Math.floor(cryptoRandom() * _range);
}
var DisplayHtmlName = function(){
	
}
var ScriptUtil = {
 	getHtmlName : function(){
 		var _strIdx = window.location.href.indexOf('/html');
		var _endIdx = window.location.href.indexOf(".html");
		var _pageName = window.location.href.substring(_strIdx+6, _endIdx);

		return _pageName; 
 	},

 	DPHtmlTest : function(){
 		var tmp = document.createElement("div");
		tmp.setAttribute("id", "tmpPageNameId");
		tmp.style.cssText = "position:absolute;left:0;top:0px;font-size:1.5rem;color:red;z-index:9999";
		tmp.innerText = ScriptUtil.getHtmlName();
		document.body.insertBefore(tmp, document.body.firstChild);
		document.querySelector("#tmpPageNameId").style.left = document.body.clientWidth/2 - document.querySelector("#tmpPageNameId").clientWidth/2 + "px";
	} 	
};

// config.js - 개발/운영 여부 등 boolean값, 서버 이름 등 상수값 정의
// 통신URL(전문) interface.js에 정리
// Date - moment 사용
// CommonEvent.js - 공통 이벤트 처리 ( 이전버튼, )



/// commonEvent.js




////// Date.js
var DateUtil = {
	ymd_div : "-",
	hms_div : ":",


	getYMD : function(date){
		if(arguments.length == 0){
			return moment().format("YYYY"+ this.ymd_div + "MM" + this.ymd_div + "DD");
		}else{
			return moment(date).format("YYYY"+ this.ymd_div + "MM" + this.ymd_div + "DD");
		}
	},

	getY : function(date){
		if(arguments.length == 0){
			return moment().format("YYYY");
		}else{
			return moment(date).format("YYYY");
		}
	}
	,getYM : function(date){
		if(arguments.length == 0){
			return moment().format("YYYY"+ this.ymd_div + "MM");
		}else{
			return moment(date).format("YYYY"+ this.ymd_div + "MM");
		}
	},

	getHMS : function(date){
		if(arguments.length == 0){
			return moment().format("HH" + this.hms_div + "mm" + this.hms_div + "ss");
		}else{
			return moment(date).format("HH" + this.hms_div + "mm" + this.hms_div + "ss");
		}
	},

	getHM : function(date){
		if(arguments.length == 0){
			return moment().format("HH" + this.hms_div + "mm" + this.hms_div);
		}else{
			return moment(date).format("HH" + this.hms_div + "mm" + this.hms_div);
		}
	},

	monthDiff : function(_fromDt, _toDt){
		var from = moment([_fromDt.substr(0,4), Number(_fromDt.substr(4,2)) - 1]);
		var to = moment([_toDt.substr(0,4), Number(_toDt.substr(4,2)) - 1]);
		
		return from.diff(to, "months");
	},

	setDateDiff : function(_addDay, _nowDate){
		if(arguments.length == 0){
			return moment().add(_addDay, 'day').format('YYYY' + this.ymd_div + 'MM' + this.ymd_div + 'DD');
		}else{
			return moment(extractNumber(_nowDate), 'YYYYMMDD').add(_addDay, 'day').format('YYYY' + this.ymd_div + 'MM' + this.ymd_div + 'DD');
		}	
	}
};

/**
 * 시간 형태 변경
 * @param str
 * @returns
 */
var setTimeFormat = function(str, format) {
	if(isEmpty(str)) str = "today";
	if(isEmpty(format)) format = "HH:mm";
	if(str == 'today') {
		return moment().format(format);
	} else {
		if (str.length == 6) {
			return moment(extractNumber(str), 'HHmmss').format(format);
		} else {
			return moment(extractNumber(str), 'HHmm').format(format);
		}
	}
};

/**
 * 날짜 더하기 빼기
 * @param _nowDate 기본 날짜
 * @param _addDay 연산될 날짜
 * @returns
 */
var setDateAddOrSub = function(_nowDate, _addDay) {
	if(_nowDate == 'today') {
		return moment().add(_addDay, 'day').format('YYYY-MM-DD');
	} else {
		return moment(extractNumber(_nowDate), 'YYYYMMDD').add(_addDay, 'day').format('YYYY-MM-DD');
	}
};

/**
 * 날짜 차이 계산
 * @param _fromDt 기준 날짜(YYYYMMDD)
 * @param _toDt 연산될 날짜(YYYYMMDD)
 * @param falg 차이 계산할 기준(y-년, m-월, d-일)
 * @returns
 */
var dateDiff = function(_fromDt, _toDt, flag) {
	var from = moment([_fromDt.substr(0,4), Number(_fromDt.substr(4,2)) - 1, Number(_fromDt.substr(6, 2))]);
	var to = moment([_toDt.substr(0,4), Number(_toDt.substr(4,2)) - 1, Number(_toDt.substr(6, 2))]);

	switch(flag) {
		case "y":
			flag = "years";
			break;
		case "m":
			flag = "months";
			break;
		case "d":
			flag = "days";
			break;
	}

	return from.diff(to, flag);
};


/**
 * D-day 카운트 (Date 형식 혹은 YYYY-MM-DD)
 * 숫자만 나오도록
 */
var dDayDiff = function(_nowDate, _endDate){
    var diffDate1 = _nowDate instanceof Date ? _nowDate : new Date(_nowDate);
    var diffDate2 = _endDate instanceof Date ? _endDate : new Date(_endDate);

    diffDate1 = new Date(diffDate1.getFullYear(), diffDate1.getMonth()+1, diffDate1.getDate());
    diffDate2 = new Date(diffDate2.getFullYear(), diffDate2.getMonth()+1, diffDate2.getDate());

    var diff = diffDate2.getTime() - diffDate1.getTime();
    diff = Math.ceil(diff / (1000*3600*24));

    return diff;
}


/**
 * 날짜변형
 */
var parseDate = function(str){
    var y = str.substring(0,4);
    var m = str.substring(5,7);
    var d = str.substring(8,10);
    return y+m+d;
}


/**
 * str yyyy-mm-dd 처럼 연월일 사이에 다른 스트링이 있어야 함.
 * 날짜변형2
 */
var parseDate2 = function(str){
    var y = str.substring(0,4);
    var m = str.substring(5,7);
    var d = str.substring(8,10);
    return y+"."+m+"."+d;
}

/**
 * 날짜변형3
 */
var parseDate3 = function(str){
    if(isNull(str)){
        return "";
    }
    var y = str.substring(0,4);
    var m = str.substring(4,6);
    var d = str.substring(6,8);
    var hh = str.substring(8,10);
    var mm = str.substring(10,12);
    var ss = str.substring(12,14);
    return y+"-"+m+"-"+d+" "+hh+":"+mm+":"+ss;
}

/**
 * 요일 구하기 (요일) 형식
 * 받는값 YYYYMMDD 형식 string
 */
var changeDate = function(date){
	var week = ["일", "월", "화", "수", "목", "금", "토"];
	var dayOfWeek = week[new Date(date.substring(0,4),(date.substring(4,6)-1),date.substring(6,8)).getDay()];
    return "("+dayOfWeek+")"
}

/**
 * 숫자만 추출
 * @param str
 * @returns
 */
var extractNumber = function(str) {
	try {
		return str.replace(/[^0-9]/g, '');
	} catch (e) {
		return str;
	}
};

/**
 * 세자리 단위로 콤마를 표기하고 삭제한다 
 * @param str
 * @returns
 */
var comma = {
	add: function (str) {
		if (!Number(str)) {	//숫자가 아닐때에만
			str = extractNumber(String(str));
		} else {
			str = String(str);
		}
		try {
			//맨 앞 0 제거
			//return str.replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,');
			if (str == "0") return str;
			return str.replace(/(^0+)/, "").replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,');
		} catch (e) {
			return str;
		}
	},
	
	remove : function(str){
		str = String(str);
		try {
			return str.replace(/[^\d]+/g, '');
		} catch (e) {
			return str;
		}
	}
};

/**
 * 값의 존재 여부 확인
 */
var isEmpty = function (obj) {
	
	var hasOwnProperty = Object.prototype.hasOwnProperty;
	if (typeof obj == "number") obj = obj+"";

    if (obj == null) return true;
    if (obj == undefined) return true;

    if (obj.length > 0)    return false;
    if (obj.length === 0)  return true;

    for (var key in obj) {
        if (hasOwnProperty.call(obj, key)) return false;
    }
	//if (typeof obj == "boolean") obj = obj+"";
    return true;
};

/**
 * 값의 존재 여부 확인 return str
 */
var isEmptyStr = function (obj) {
	
	var hasOwnProperty = Object.prototype.hasOwnProperty;
	if (typeof obj == "number") obj = obj+"";

    if (obj == null) return '';
    if (obj == undefined) return '';

    if (obj.length > 0)    return obj;
    if (obj.length === 0)  return '';

    for (var key in obj) {
        if (hasOwnProperty.call(obj, key)) return obj;
    }

    return '';
};

/**
 * 엔터값을 <br> 태그로 변환
 * @param str
 * @returns {string|*}
 */
var replaceBrTag = function (str) {
	if (str == undefined || str == null) {
		return "";
	}

	str = str.replace(/\r\n/ig, '<br>');
	str = str.replace(/\\n/ig, '<br>');
	str = str.replace(/\n/ig, '<br>');
	return str;
}
/**
 * 원하는 길이 만큼 0으로 채운 문자 반환 
 * Ex) zeroPad("22", "5") => "00022"
 * @param str
 * @param length
 * @return String
 */
var zeroPad = function(str, length){
	str += '';
	return str.length < length ? zeroPad("0"+str, length) : str;	
}

/**
 * 리스트 팝업에 맞게 데이터 변환
 * @param Arr
 * @param key
 * @param value
 * @returns Array
 */
var getListPopArr = function(Arr, key, value) {
	var tmpArr = [];
	if(key || value) {
		for(var i = 0; i < Arr.length; i++){
			var tmpObj = {};
			tmpObj.title = Arr[i][key]; 
			tmpObj.value = Arr[i][value];
			tmpArr.push(tmpObj);				
		}
	} else {
		for(var i = 0; i < Arr.length; i++){
			var tmpObj = {};
			tmpObj.title = Arr[i];
			tmpObj.value = Arr[i];
			tmpArr.push(tmpObj);
		}
	}
	
	return tmpArr;
};

/**
 * 원하는 길이 만큼 원하는 값으로 채운 문자 반환 
 * Ex) lpad("3", "-", 5) => "----3"
 * @param s : 문자열
 * @param c : 원하는 문자
 * @param n : 원하는 길이
 * @return String
 */
var lpad = function(s, c, n) {
	var _s = typeof s == "number" ? s.toString() : s;
    if (! _s || ! c || s.length >= n) {
        return _s;
    }
 
    var max = (n - _s.length)/c.length;
    for (var i = 0; i < max; i++) {
    	_s = c + _s;
    }
    
    return _s;
}

/**
 * object 복사
 * obj : 복사할 데이터
 */
var clone = function(obj){
	if (obj === null || typeof(obj) !== 'object')
		return obj;
	
	var copy = obj.constructor();
	for (var attr in obj) {
		if (obj.hasOwnProperty(attr)) {
			copy[attr] = obj[attr];
		}
	}
	return copy;
}

/**
 * 정렬
 * obj : 데이터
 * key : 정렬 key
 * desc : 정렬 방식 설정(true/false) true - 내림차순 10~1 false - 오름차순 1~10
 */
var sorting = function(obj, key, desc){
	var compare = function(a,b) {
		if (a[key] < b[key])
			return desc ? 1 : -1;
		if (a[key] > b[key])
			return desc ? -1 : 1;
		return 0;
	}
	return obj.sort(compare);
}

var sortingParams = function(obj, key, key2, desc){
	var compare = function(a,b) {
		if (a[key] < b[key])
			return desc ? 1 : -1;
		if (a[key] > b[key])
			return desc ? -1 : 1;

		if (a[key2] < b[key2])
			return desc ? 1 : -1;
		if (b[key2] < a[key2])
			return desc ? -1 : 1;
		return 0;
	}
	return obj.sort(compare);
}

/**
 * obj의 특정값 추출
 * obj : 데이터를 추출할 obj
 */
var objVals = function(obj){
	return Object.keys(obj).map(function(key) {
	    return obj[key];
	});
};

/**
 * 아이디 검사식 
 * @param id (input #id)
 * @returns
 */
var onKeyupFilter = function(id){
	var this_id = document.getElementById(id);
	
	this_id.onkeyup = function(event){
        event = event || window.event;
        var _val = this.value.trim();
        this.value = _val.replace(/[ \{\}\[\]\/?.,;:|\)*~`!^\-_+┼<>@\#$%&\'\"\\\(\=]/gi, '');       
	}
}

/**
 * 패스워드 특수문자 체크(<>()'#) 하여 들어간 특수문자가 무엇인지 찾아줌
 * @param pw
 * @returns string
 */
function regExpPwCheck(pw){
    //함수를 호출하여 특수문자 검증 시작.
    var str = pw;
    var regExp = /[\<\>\(\)\'\#\&\=\;\:\+]/gi;	// /[ 이안에 \를 쓰고 제거할 패턴입력 ex)\# ]/gi
    var regExpArr = ['<','>','(',')','\'','#','&','=',';',':','+'];
    var resultStr = '';
    if(regExp.test(str)){
    		for(var i=0; i<str.length; i++){
    			if(!resultStr){	//찾은것이 없다면
    				for(var j=0; j<regExpArr.length; j++){
        				if(str[i] ==  regExpArr[j]){
        					resultStr = regExpArr[j];
        					break;
        				}
        			}
    			}else{
    				break;
    			}
    		}
    		return resultStr;
    }else{
    		return resultStr;
    }
}
/**
 * 패스워드 특수문자 체크(?!*$) 하여 들어간 특수문자가 무엇인지 찾아줌
 * @param pw
 * @returns string
 */
function regExpPwPossible(pw){	
    //함수를 호출하여 특수문자 검증 시작.
	var regexp = /([0-9a-zA-Z!$*,?@[\]^`{}~])/; // 숫자,영문,특수문자
        for( var i=0; i<pw.length; i++){
            if(pw.charAt(i) != " " && regexp.test(pw.charAt(i)) == false){
            	if(pw.length <= 7){
            		MPopup.alert('영문,숫자,특수문자의 조합으로 8~15자까지 입력해주세요.');
            	}else if(pw.length >= 16){
            		MPopup.alert('영문,숫자,특수문자의 조합으로 8~15자까지 입력해주세요.');
            	}else{
            		MPopup.alert(pw.charAt(i) + "는 입력불가능한 문자입니다.\n특수문자 !$*,?@[]^`{}~을 사용해서 입력해 주세요");
            	}
             
             	return false;
            }
        }
        return true;
}

function regExpEmailPossible(str) {
	var reg_email = /^([0-9a-zA-Z_\.-]+)@([0-9a-zA-Z_-]+)(\.[0-9a-zA-Z_-]+){1,2}$/;
	if (!reg_email.test(str)) {
		return false;
	} else {
		return true;
	}
}

/**
 * 공백 제거
 * @param str
 */
var strTrim = function(str){
	return str.replace(/\s/gi, '').replace(/ /g, '');
};

var getBytes = function(src){
	var i=0;
	var sum=0;
	for(i=0; i<src.length; i++,sum++){
		if(escape(src.charAt(i)).length>4) sum++;
	}
	return sum;
};

var cleanXSS = function(value){
	value = value.replace(/&lt;/gi, "<");
	value = value.replace(/&gt;/gi, ">");
	value = value.replace(/&#40;/gi, "(");
	value = value.replace(/&#41;/gi, ")");
	value = value.replace(/&#39;/gi, "'");
	
	return value;
};

/**
 * JSON Array 순서에 맞게 변경(숫자인 경우)
 * jsonArr : jsonArray
 * desc : 정렬 방식 설정(true/false) true - 내림차순 10~1 false - 오름차순 1~10
 * 
 */
var sortJsonArrayList = function(jsonArr, key, desc){
	var returnList = jsonArr.sort(function(a,b){
		if(desc == true){
			return parseFloat(b[key]) - parseFloat(a[key]);
		}else{
			return parseFloat(a[key]) - parseFloat(b[key]);
		}
	});
	
	return returnList;
};

var convertDistanceToUnit = function(unit, distance) {
	// 단위 (0: feet, 1: km, 2: meter , 3: miles)
	var convertVal;
	switch (unit) {
		case 0:
			convertVal = parseInt(distance/3281);
			break;
		case 1:
			convertVal = distance;
			break;
		case 2:
			convertVal = parseInt(distance/1000);
			break;
		case 3:
			convertVal = parseInt(distance*1.609);
			break;
	};
	return convertVal;
}
String.format = function() {
	var string = arguments[0];

	for (var i = 1; i < arguments.length; i++) {
		var regEx = new RegExp("\\{" + (i - 1) + "\\}", "gm");
		string = string.replace(regEx, arguments[i]);
	}

	return string;
}

function getDistance(aLocation, zLocation ){
	var ax = aLocation.lat;
	var ay = aLocation.lng;
	var zx = zLocation.lat;
	var zy = zLocation.lng;
	function deg2rad(deg){
		return deg * (Math.PI/180);
	}
	var r = 6371; //지구의 반지름(km)
	var dLat = deg2rad(zx-ax);
	var dLon = deg2rad(zy-ay);
	var a = Math.sin(dLat/2) * Math.sin(dLat/2) + Math.cos(deg2rad(ax)) * Math.cos(deg2rad(zx)) * Math.sin(dLon/2) * Math.sin(dLon/2);
	var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
	var d = r * c; // Distance in km
	COMMON_FUNCTION.TOOL.DEBUG.showTalk(d);
	return d;
}

/*
- 파일 구조
www/js/common -> 공통으로 사용할 스크립트 생성
www/js/libs/ -> 사용할 라이브러리에 따라 폴더 생성 (jquery, date, chart 등등)
www/js/ui -> 비지니스 업무에 관련하여 폴더 생성
--------------------------------------------------
기본 샘플로 제공할 파일들 목록
common.js -> M.onReady 등 상태 함수 정의
commonUtil.js -> 추후 추가 삭제
config.js -> isDev 등 설정 파일
interface.js -> 전문 목록
mcore_api.js -> morpheus api 래핑
constant.js -> 비즈니스 로직에서 사용할 상수 (int, string, object) 등 정의

--------------------------------------------------

** 각 개발자들에게 사용해본 스크립트 라이브러리 중 괜찮은 파일 목록 취합

--------------------------------------------------

*/