/**
 * 연계되는 링크 URL 정리
 * dev 와 prd가 다른 도메인의 링크가 위치함.
 * URL : 연계되는 URL 주소
 * MENU : 해당 URL의 메뉴 정보
 * TYPE : RED(기아멤버스), KIA(기아홈페이지), AUTON(오토엔), ETC(기타)
 */
CONSTANT.RED_LOGIN_URL = CONSTANT.RED_URL_PREFIX + "kr/klgi/appLogin.do";									// 웹뷰로 기아멤버스 연동 시 로그인 보낼 URL
//CONSTANT.KIA_LOGIN_URL = CONSTANT.KIA_LOGIN_URL_PREFIX + "api/kia_korea/base/mb01/MemberProfile.appViewPage";	// 웹뷰로 기아 홈페이지 연동 시 로그인 보낼 URL
CONSTANT.KIA_LOGIN_URL = CONSTANT.KIA_LOGIN_URL_PREFIX + "kr/services/ko/authentication.deeplink";	// 웹뷰로 기아 홈페이지 연동 시 로그인 보낼 URL
CONSTANT.LINK_URL = {
    KIA_RNW_810_0000 : {
        URL : "https://mkia.auton.kr/index/mainMall",
        MENU : "카앤라이프몰",
        TYPE : "LINK"
    },
    /**
     * 회원가입
     */
    KIA_RNW_070_0000 : {
        URL : CONSTANT.WEB_URL_PREFIX+ "common/auth/join.do",
        MENU : "회원가입",
        TYPE : ""
    },
    KIA_RNW_093_5000 : {
        URL : CONSTANT.WEB_URL_PREFIX + "common/auth/memberDrop.do",
        MENU : "회원탈퇴",
        TYPE : ""
    },
    KIA_MOB_810_1041 : {
        URL : CONSTANT.WEB_URL_PREFIX + "common/auth/newMemberDrop.do",
        MENU : "CCSP 도입 회원탈퇴",
        TYPE : ""
    },
    KIA_RNW_0D2_3000 : {
        URL : CONSTANT.WEB_URL_PREFIX + "common/auth/joinRedMembers.do",
        MENU : "기아자동차의 멤버십 서비스 가입",
        TYPE : ""
    },
    KIA_RNW_931_0000 : {
        // URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/ksvc/ksvc_direction.do",
        URL : "https://ownersmanual.kia.com/main", // 2024.08.02 [KIAVIK-2555] 사용설명서 url변경
        MENU : "차량관리 > 매뉴얼 > 사용설명서",
        TYPE : "RED"
    },
    KIA_MOB_810_1043 : {
        URL : CONSTANT.WEB_URL_PREFIX + "common/auth/checkHp.do",
        MENU : "본인인증 휴대폰으로 찾기",
        TYPE : ""
    },
    KIA_MOB_810_1044 : {
        URL : CONSTANT.WEB_URL_PREFIX + "common/auth/ipinPop.do",
        MENU : "본인인증 아이핀으로 찾기",
        TYPE : ""
    },
    KIA_MOB_810_1045 : {
        URL : CONSTANT.WEB_URL_PREFIX + "check/ccspId.do",
        MENU : "통합회원 가입상태 추가정보 등록",
        TYPE : ""
    },
    /**
     * 차량
     */
    KIA_MOB_100_1100	 : {
        URL : "https://play.kia.com/run/testDriveList.do",
        MENU : "차량 > 시승기",		// 2차에는 개발로 변경 예정
        TYPE : "ETC"
    },

    KIA_MOB_100_1001	 : {
        URL : "",
        MENU : "차량 > 전체모델 > 상세 화면",		// 2차에는 개발로 변경 예정
        TYPE : "ETC"
    },

    KIA_MOB_000_1112	 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/vehicles/k3/features.html",
        MENU : "메인 > K3 마이크로",
        TYPE : "ETC"
    },

    KIA_MOB_000_1113	 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/vehicles/sk3/features.html",
        MENU : "메인 > 스포티지",
        TYPE : "ETC"
    },

    KIA_MOB_000_1050	 : { //"https://play.kia.com/run/testDriveDetail.do?ctntsNo=4630"  기존
        URL : "https://play.kia.com/run/testDriveDetail.do?ctntsNo=4728", //변경 04_16
        MENU : "팝업 > 오늘의 카썰",
        TYPE : "ETC"
    },

    /**
     * 구매/체험
     */
    KIA_MOB_200_1000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/build-your-car/vehicle-lineup.html",
        MENU : "구매/체험 > 온라인견적",
        TYPE : "KIA"
    },

    KIA_RNW_312_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/build-your-car/vehicle-lineup.html",
        MENU : "구매/체험 > 온라인견적",
        TYPE : "KIA"
    },

    KIA_RNW_314_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/catalog-price.html",
        MENU : "구매/체험 > 가격표/카탈로그",
        TYPE : "KIA"
    },

    KIA_MOB_200_1200 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/comparisons/comparisons-select-korea01-01.html",
        MENU : "구매/체험 > 경쟁차비교",
        TYPE : "KIA"
    },

    KIA_RNW_313_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/special-offers/default.html",
        MENU : "구매/체험 > 구매혜택 > 이달의 구매혜택",
        TYPE : "KIA"
    },

    KIA_MOB_200_1301 : {
//		URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/special-offers/default.html",
        URL : "https://www.hyundaicard.com/cpb/ev/CPBEV0101_02.hc?cmssCntnId=215898&searchWord=",
        MENU : "현대카드 > 이달의 구매혜택",
        TYPE : "ETC"
    },

    KIA_MOB_200_1302 : {
        URL : "https://www.hyundaicard.com/cpf/ll/CPFLL0101_01.hc",
        MENU : "현대카드 > 장기카드대출",
        TYPE : "ETC"
    },

    KIA_MOB_200_1400 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/branch/branch-list.html",
        MENU : "구매/체험 > 영업망안내",
        TYPE : "KIA"
    },

    KIA_RNW_350_0000 : {
        // https://staging-www.kia.com/kr/experience-center/test-service/default.html?loginFlag=login
        URL : CONSTANT.KIA_URL_PREFIX + "kr/experience-center/test-service/default.html?loginFlag=login",
        MENU : "구매/체험 > 시승예약서비스",
        TYPE : "KIA"
    },

    KIA_MOB_200_1600 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/experience-center/display-car/default.html",
        MENU : "구매/체험 > 전시차조회",
        TYPE : "KIA"
    },

    KIA_RNW_340_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/branch/branch-list.html",
        MENU : "구매/체험 > 영업망안내",
        TYPE : "KIA"
    },

    KIA_RNW_350_0000 : {
        // https://staging-www.kia.com/kr/experience-center/test-service/default.html?loginFlag=login
        URL : CONSTANT.KIA_URL_PREFIX + "kr/experience-center/test-service/default.html?loginFlag=login",
        MENU : "구매/체험 > 시승예약서비스",
        TYPE : "KIA"
    },

    KIA_RNW_360_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/experience-center/display-car/default.html",
        MENU : "구매/체험 > 전시차조회",
        TYPE : "KIA"
    },

    KIA_MOB_200_1900 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/mobility-program/kia-flex.html",
        MENU : "차량구매 >구매정보 > KiaFlex",
        TYPE : "KIA"
    },

    KIA_RNW_332_1000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/mobility-program/kia-flex.html",
        MENU : "차량구매 >구매정보 > KiaFlex",
        TYPE : "KIA"
    },

    KIA_MOB_200_1311 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/point/point_save.do",
        MENU : "구매/체험 > 구매혜택 > 멤버십 혜택 > 포인트 적립/사용처",
        TYPE : "RED"
    },

    KIA_MOB_200_1312 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/point/point_intro.do",
        MENU : "구매/체험 > 구매혜택 > 멤버십 혜택 > 포인트 활용방법",
        TYPE : "RED"
    },

    KIA_MOB_200_1313 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/care/period_inspection.do",
        MENU : "구매/체험 > 구매혜택 > 멤버십 혜택 > 정기점검 서비스 바로가기",
        TYPE : "RED"
    },

    KIA_MOB_200_1314 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/care/go_out.do",
        MENU : "구매/체험 > 구매혜택 > 멤버십 혜택 > 긴급출동/무상견인 바로가기",
        TYPE : "RED"
    },

    // KIA_MOB_200_1315 : { // 쇼핑몰 바로가기 아직 기획서 url이 안나옴 08_16
    // 	URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/point/point_save.do",
    // 	MENU : "구매/체험 > 구매혜택 > 멤버십 혜택 > 쇼핑몰 바로가기",
    // 	TYPE : "RED"
    // },

    KIA_MOB_200_1332 : {
        URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=K&cardWcd=MRDED2&eventCode=00000",
        // URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=&cardWcd=MRDE2&eventCode=00000",
        MENU : "구매/체험 > 구매혜택 > 금융 혜택 > KIA_REDMEMBERS 신용카드 Edition2",
        TYPE : "ETC"
    },

    KIA_MOB_200_1333 : {
//		URL : "https://www.hyundaicard.com/cpc/ca/CPCCA0101_01.hc?cardWcd=MPRDE2&eventCode=",
        URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=&cardWcd=MPRDE2&eventCode=00000",
        MENU : "구매/체험 > 구매혜택 > 금융 혜택 > KIA_REDMEMBERS Platinum 신용카드",
        TYPE : "ETC"
    },

    KIA_MOB_200_1334 : {
//		URL : "https://www.hyundaicard.com/cpc/ca/CPCCA0101_01.hc?cardWcd=M3PRDE2&eventCode=",
        URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=&cardWcd=M3PRDE2&eventCode=00000=",
        MENU : "구매/체험 > 구매혜택 > 금융 혜택 > KIA_REDMEMBERS Platinum PLUS 신용카드",
        TYPE : "ETC"
    },

    KIA_MOB_200_1335 : {
        URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=K&cardWcd=MRDSC&eventCode=00000",
        // URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=&cardWcd=MRDSCR&eventCode=00000",
        MENU : "구매/체험 > 구매혜택 > 금융 혜택 > KIA_REDMEMBERS 경차전용카드(유류세환급)",
        TYPE : "ETC"
    },
    KIA_MOB_200_1336 : {
        URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=K&cardWcd=MRDSCR&eventCode=00000",
        // URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=&cardWcd=MRDSC&eventCode=00000",
        MENU : "구매/체험 > 구매혜택 > 금융 혜택 > KIA_REDMEMBERS 경차전용카드(비환급)",
        TYPE : "ETC"
    },
    KIA_MOB_200_1337 : {
        URL : "https://www.hyundaicard.com/cpc/cr/CPCCR0201_01.hc?cardflag=K&cardWcd=MRDEV",
        MENU : "구매/체험 > 구매혜택 > 금융 혜택 > KIA_REDMEMBERS 전기차 신용카드",
        TYPE : "ETC"
    },
    KIA_MOB_200_1701 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/fare.html",
        MENU : "구매정보 > 장기렌터카 > 단기렌터카 이용안내",
        TYPE : "KIA"
    },
    KIA_RNW_331_4000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/fare.html",
        MENU : "구매정보 > 장기렌터카 > 단기렌터카 이용안내",
        TYPE : "KIA"
    },
    KIA_MOB_200_1702 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/FAQ/faq-list.html",
        MENU : "구매정보 > 장기렌터카 > FAQ",
        TYPE : "KIA"
    },
    KIA_RNW_331_5000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/FAQ/faq-list.html",
        MENU : "구매정보 > 장기렌터카 > FAQ",
        TYPE : "KIA"
    },
    KIA_MOB_200_1703 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/branch/branch-list.html",
        MENU : "구매정보 > 장기렌터카 > 장기렌터카 구입 및 상담",
        TYPE : "KIA"
    },
    KIA_RNW_331_7000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/branch/branch-list.html",
        MENU : "구매정보 > 장기렌터카 > 장기렌터카 구입 및 상담",
        TYPE : "KIA"
    },
    KIA_MOB_200_1704 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/branch.html",
        MENU : "구매정보 > 장기렌터카 > 장비 및 반납 문의",
        TYPE : "KIA"
    },
    KIA_RNW_331_2000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/branch.html",
        MENU : "구매정보 > 장기렌터카 > 장비 및 반납 문의",
        TYPE : "KIA"
    },
    KIA_MOB_200_1705 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/merit.html",
        MENU : "구매/체험 > 구매혜택 > 기아렌터카 > 장기렌터카 장점",
        TYPE : "KIA"
    },
    KIA_MOB_200_1706 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/compare.html",
        MENU : "구매/체험 > 구매혜택 > 기아렌터카 > 리스, 일반 구매 비교",
        TYPE : "KIA"
    },
    KIA_MOB_200_1707 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/free-rent-maintenance.html",
        MENU : "구매정보 > 장기렌터카 > 무상대차 가능 업체 조회",
        TYPE : "KIA"
    },
    KIA_RNW_331_6000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/free-rent-maintenance.html",
        MENU : "구매정보 > 장기렌터카 > 무상대차 가능 업체 조회",
        TYPE : "KIA"
    },
    KIA_MOB_200_1708 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/promotion.html",
        MENU : "구매/체험 > 구매혜택 > 기아렌터카 > 기아렌터카 프로모션",
        TYPE : "KIA"
    },
    KIA_RNW_331_1000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/promotion.html",
        MENU : "구매/체험 > 구매혜택 > 기아렌터카 > 기아렌터카 프로모션",
        TYPE : "KIA"
    },
    KIA_MOB_200_1709 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/guide.html",
        MENU : "구매정보 > 장기렌터카 > 장기렌터카 이용 안내",
        TYPE : "KIA"
    },
    KIA_RNW_331_3000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/rent-car-service/guide.html",
        MENU : "구매정보 > 장기렌터카 > 장기렌터카 이용 안내",
        TYPE : "KIA"
    },
    KIA_MOB_200_1800 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/green-guide/default.html",
        MENU : "구매/체험 > 친환경차 구매가이드",
        TYPE : "KIA"
    },
    KIA_RNW_322_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/green-guide/default.html",
        MENU : "구매/체험 > 친환경차 구매가이드",
        TYPE : "KIA"
    },

    KIA_RNW_331_8000 : {
        URL : "https://rental.kia.com/m/home?utm_source=mykia&utm_medium=direct&utm_campaign=menu&utm_id=home",
        MENU : "전체 메뉴 > 기아렌터카",
        TYPE : "KIA"
    },

    KIA_RNW_331_8001 : {
        URL : "https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/authorizeSSO?client_id=b41fa411-35e4-4539-bc93-d96d6662b799&redirect_uri=https://connectstore.kia.com/kr/ccsp/redirect?utm_source=mykia&response_type=code&state=ccsp",
        MENU : "전체 메뉴 > 기아 커넥트 스토어",
        TYPE : "KIA"
    },

    KIA_RNW_331_8002 : {
//        URL : "https://stg.kr-ccapi.kia.com/api/v1/user/oauth2/authorize?client_id=fe687ce1-fc05-4d47-8b7d-37bd2e22527f&state=%7B%22redirect%22%3A%22https%3A%2F%2Fstg-cpo.kia.com%2Fmanufacturer%2Fcertification%2F%22%7D&response_type=code&redirect_uri=https://stg-cpo.kia.com/authorizeBridge",
        URL : "https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/authorizeSSO?client_id=e9925e39-0a25-4a1e-bdb0-30cfdacaaf07&state=%7B%22redirect%22%3A%22https%3A%2F%2Fcpo.kia.com%2Fmanufacturer%2Fcertification%2F%22%7D&response_type=code&redirect_uri=https://cpo.kia.com/authorizeBridge",
        MENU : "전체 메뉴 > 기아 인증 중고차",
        TYPE : "KIA"
    },

    KIA_RNW_331_8003 : {
//        URL : "https://stg.kr-ccapi.kia.com/api/v1/user/oauth2/authorize?client_id=fe687ce1-fc05-4d47-8b7d-37bd2e22527f&state=%7B%22redirect%22%3A%22https%3A%2F%2Fstg-cpo.kia.com%2Fcs%2F%22%7D&response_type=code&redirect_uri=https://stg-cpo.kia.com/authorizeBridge",
        URL : "https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/authorizeSSO?client_id=e9925e39-0a25-4a1e-bdb0-30cfdacaaf07&state=%7B%22redirect%22%3A%22https%3A%2F%2Fcpo.kia.com%2Fcs%2F%22%7D&response_type=code&redirect_uri=https://cpo.kia.com/authorizeBridge",
        MENU : "기아 인증 중고차 > 자세히 보기",
        TYPE : "KIA"
    },

    KIA_RNW_331_8004 : {
//        URL : "https://stg.kr-ccapi.kia.com/api/v1/user/oauth2/authorize?client_id=fe687ce1-fc05-4d47-8b7d-37bd2e22527f&state=%7B%22redirect%22%3A%22https%3A%2F%2Fstg-cpo.kia.com%2Fpurchases%2Festimate%2F%22%7D&response_type=code&redirect_uri=https://stg-cpo.kia.com/authorizeBridge",
        URL : "https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/authorizeSSO?client_id=e9925e39-0a25-4a1e-bdb0-30cfdacaaf07&state=%7B%22redirect%22%3A%22https%3A%2F%2Fcpo.kia.com%2Fpurchases%2Festimate%2F%22%7D&response_type=code&redirect_uri=https://cpo.kia.com/authorizeBridge",
        MENU : "기아 인증 중고차 > 차 시세 확인 하기",
        TYPE : "KIA"
    },
    KIA_RNW_331_8005 : {
//        URL : "https://stg.kr-ccapi.kia.com/api/v1/user/oauth2/authorizeSSO?client_id=fe687ce1-fc05-4d47-8b7d-37bd2e22527f&state=%7B%22redirect%22%3A%22https%3A%2F%2Fstg-cpo.kia.com%2Fproducts%2F%22%7D&response_type=code&redirect_uri=https://stg-cpo.kia.com/authorizeBridge",
        URL : "https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/authorizeSSO?client_id=e9925e39-0a25-4a1e-bdb0-30cfdacaaf07&state=%7B%22redirect%22%3A%22https%3A%2F%2Fcpo.kia.com%2Fproducts%2F%22%7D&response_type=code&redirect_uri=https://cpo.kia.com/authorizeBridge",
        MENU : "기아 인증 중고차 > 차량 보러가기",
        TYPE : "KIA"
    },
    KIA_RNW_441_0000 : {
        URL : "https://www.youtube.com/embed/4OyzviAHfH4",
        //임시
        //URL : "https://staging-www.kia.com/kr/experience-center/flagship.html",
        MENU : "구매/체험 > Play AR > Play AR 튜토리얼",
        TYPE : "ETC"
    },

    KIA_MOB_200_2000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/experience-center/flagship.html",
        //임시
        //URL : "https://staging-www.kia.com/kr/experience-center/flagship.html",
        MENU : "구매/체험 > Kia 체험거점",
        TYPE : "KIA"
    },

    KIA_RNW_450_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/experience-center/flagship.html",
        //임시
        //URL : "https://staging-www.kia.com/kr/experience-center/flagship.html",
        MENU : "구매/체험 > Kia 체험거점",
        TYPE : "KIA"
    },

    KIA_MOB_200_2001 : {
        URL : "https://kia360.kia.com",
        MENU : "구매/체험 > Kia 360",
        TYPE : "KIA"
    },

    KIA_RNW_460_0000 : {
        URL : "https://kia360.kia.com",
        MENU : "구매/체험 > Kia 360",
        TYPE : "KIA"
    },

    KIA_MOB_200_2002 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/kia-ev/total-cost-of-ownership/index.html",
        //임시
        //URL : "https://staging-www.kia.com/kr/kia-ev/total-cost-of-ownership/index.html",
        MENU : "Kia EV > TCO 계산기",
        TYPE : "KIA"
    },
    KIA_RNW_420_0000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kdks/kmcc/comm_service_intro.do",
        MENU : "KIA MEMBERS > 여러분의 자동차 이야기를 들려주세요",
        TYPE : "RED"
    },

    KIA_RNW_127_3000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/kmpg/selectMyPageCkbCarInfo.do",
        MENU : "차량관리 > 내 차 관리 > 차량 정보 설정",
        TYPE : "RED"
    },

    KIA_MOB_500_1500 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kmgt/car_spec/car_spec_select.do",
        MENU : "차량관리 > 내 차 관리 > 차량 사양조회",
        TYPE : "RED"
    },

    KIA_MOB_510_1300 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/knet/bf_svc/knet_hitech_svc_list.do",
        MENU : "차량관리 > 정비예약 > 하이테크 컨설팅",
        TYPE : "RED"
    },

    KIA_MOB_520_1101 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/point/point_use.do",
        MENU : "차량관리 > 멤버십 > 사용처 안내 ",
        TYPE : "RED"
    },

    KIA_MOB_520_1200 : {
        URL : CONSTANT.BLUE_URL + "/kiaVikTransList.jsp",
        MENU : "차량관리 > 내 차 관리 > 구매 내역 리스트",
        TYPE : "RED"
    },

    KIA_MOB_520_1201 : {
        URL : CONSTANT.BLUE_URL + "/kiaVikRequest.jsp",
        MENU : "차량관리 > 내 차 관리 > 신차구매",
        TYPE : "RED"
    },

    KIA_MOB_520_1202 : {
        URL : CONSTANT.BLUE_CARD_URL + "myp/manageMyPay.do",
        MENU : "차량관리 > 내 차 관리 > 간편결제카드조회",
        TYPE : "RED"
    },

    KIA_MOB_530_1000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/kmgt/selectCkbMain.do",
        MENU : "차량관리 > 차계부",
        TYPE : "RED"
    },

    KIA_MOB_530_1001 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/kmgt/statistics02.do",
        MENU : "차량관리 > 차계부 > 통계관리",
        TYPE : "RED"
    },

    KIA_MOB_560_1100 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/ksvc/ksvc_direction.do",
        MENU : "차량관리 > 매뉴얼 > 사용설명서",
        TYPE : "RED"
    },

    KIA_MOB_570_1000 : {
        URL : "http://www.mobis.co.kr/customer/sub-main/index.do",
        MENU : "차량관리 > 부품가격",
        TYPE : "ETC"
    },

    /**
     * 서비스가이드
     */
    KIA_MOB_420_1000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kmgt/navi/kmgt_navi_guide.do",
        MENU : "서비스가이드 > 내비게이션 업데이트",
        TYPE : "RED"
    },

    KIA_MOB_300_1000 : {
        URL : "http://pr.kia.com/ko/main.do",
        MENU : "기아스토리 > 브랜드 소식",
        TYPE : "ETC"
    },

    KIA_MOB_400_1000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_credit_card_01.do",
        MENU : "KIA MEMBERS > 멤버십 혜택 > 제휴처 안내",
        TYPE : "RED"
    },

    KIA_MOB_400_1001 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_plus.do",
        MENU : "서비스가이드 > 멤버십 안내 > KIA MEMBERS",
        TYPE : "RED"
    },

    KIA_MOB_400_1002 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_thek9.do",
        MENU : "서비스가이드 > 멤버십 안내 > THE K9",
        TYPE : "RED"
    },

    KIA_MOB_400_1003 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_k9.do",
        MENU : "서비스가이드 > 멤버십 안내 > K9",
        TYPE : "RED"
    },

    KIA_MOB_400_1004 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_stinger.do",
        MENU : "서비스가이드 > 멤버십 안내 > STINGER",
        TYPE : "RED"
    },

    KIA_MOB_400_1005 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_credit_card_01.do",
        MENU : "서비스가이드 > 멤버십 안내 > 제휴카드",
        TYPE : "RED"
    },

    KIA_MOB_400_1006 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/point/point_save.do",
        MENU : "멤버십 혜택 > 멤버십 안내 > 포인트 적립 안내",
        TYPE : "RED"
    },

    KIA_MOB_400_1007 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/point/point_use.do",
        MENU : "멤버십 혜택 > 멤버십 안내 > 포인트 사용처 안내",
        TYPE : "RED"
    },

    KIA_MOB_400_1008 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_credit_card_01.do",
        MENU : "멤버십 혜택 > 멤버십 안내 > 멤버십 카드 안내",
        TYPE : "RED"
    },

    KIA_MOB_400_1009 : {
        URL : CONSTANT.RED_URL_PREFIX + "/kr/view/web/krdm/guide/members_partnership_mobile_card.do",
        MENU : "멤버십 혜택 > 멤버십 안내 > EV 멤버십 카드 안내",
        TYPE : "RED"
    },

    KIA_MOB_410_1001 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/knet/knet_warranty_guide.do",
        MENU : "서비스가이드 > 서비스안내 > 보증수리 안내",
        TYPE : "RED"
    },

    KIA_MOB_410_1002 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/knet/knet_door_to_door.do",
        MENU : "서비스가이드 > 서비스안내 > 도어 투 도어",
        TYPE : "RED"
    },

    KIA_MOB_410_1003 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/knet/knet_service_info_03.do",
        MENU : "서비스가이드 > 서비스안내 > ONE STOP 서비스",
        TYPE : "RED"
    },

    /**
     * 고객센터
     */
    KIA_MOB_700_1001 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/customer-service/experience-kia/faq-list.html",
        MENU : "고객센터 > FAQ > 기아 홈페이지 FAQ",
        TYPE : "KIA"
    },
    KIA_MOB_700_1002 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kutl/kutl_faq.do",
        MENU : "고객센터 > FAQ > 기아멤버스 FAQ",
        TYPE : "RED"
    },
    KIA_MOB_750_1001 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_thek9.do",
        MENU : "고객센터 > 컨시어지 > THE MEMBERSHIP K9",
        TYPE : "RED"
    },
    KIA_MOB_750_1002 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_k9.do",
        MENU : "고객센터 > 컨시어지 > THE K9 MEMBERSHIP",
        TYPE : "RED"
    },
    KIA_MOB_750_1003 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_stinger.do",
        MENU : "고객센터 > 컨시어지 > THE K9 STINGER",
        TYPE : "RED"
    },
    KIA_MOB_750_1004 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/customer-service/online-counsel/default.html?code=car",
        MENU : "1:1 문의",
        TYPE : "KIA"
    },
    KIA_MOB_750_1005 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/customer-service/online-counsel/default.html?",
        MENU : "VIK VOICE",
        TYPE : "KIA"
    },
    KIA_RNW_315_0000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/shopping-tools/quick-counsel/intro.html?",
        MENU : "구매상담/문의",
        TYPE : "KIA"
    },
    KIA_MOB_750_1007 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/guide/members_partnership_mobile_card.do",
        MENU : "고객센터 > 컨시어지 > EV Members",
        TYPE : "KIA"
    },

    KIA_MOB_750_1200 : {
        URL : "https://connect.kia.com/kr/02_guide/owner_free01.html",
        MENU : "UVO",
        TYPE : "UVO"
    },
    KIA_RNW_125_0000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kdks/info/qdks_kdk_service_intro.do",
        MENU : "KIA Digital Key",
        TYPE : "RED"
    },
    KIA_MOB_750_1400 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kdks/pay/qdks_kp_service_intro.do",
        MENU : "KUA Pay",
        TYPE : "RED"
    },
    KIA_MOB_750_1700 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/kdks/info/qdks_ondemand_info.do",
        MENU : "Digital Key 온디맨드",
        TYPE : "RED"
    },
    KIA_MOB_760_1000 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/my/default.html",
        MENU : "문의/신청내역",
        TYPE : "KIA"
    },
    /**
     * 탁송
     */
    KIA_RNW_127_1000 : {
        URL : "https://smartwap.glovis.net/mgr/delivery/deliveryState.jsp",
        MENU : "차량관리 > 계약 및 출고 관리(출고전) > 탁송",
        TYPE : "ETC"
    },

    /**
     * 카&라이프
     */
    KIA_MOB_600_1001 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A000000",
        MENU : "카&라이프 > 서비스안내",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/serviceInfo"
    },
    KIA_MOB_600_1002 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A020000",
        MENU : "카&라이프 > 용품쇼핑",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/index/productMall"
    },
    KIA_MOB_600_1003 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A030000",
        MENU : "카&라이프 > 차량케어",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/index/carCare"
    },
    KIA_MOB_600_1004 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A040100",
        MENU : "카&라이프 > 차량운행",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/run/parking/parking_main"
    },
    KIA_MOB_600_1005 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A050100",
        MENU : "카&라이프 > 중고차 > 시세조회",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/used_car_mall"
    },
    KIA_MOB_600_1006 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A050200",
        MENU : "카&라이프 > 중고차 > 내차경매",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/used_car_auction"
    },
    KIA_MOB_600_1007 : {
        URL : "http://o2m.kr/m/index.php",
        MENU : "카&라이프 > 스커트",
        TYPE : "AUTON"
    },
    //TODO : 시연용 추후 변경 혹은 삭제 예정
    KIA_MOB_600_1008 : {
        URL : "https://www.hyundaicapital.com/mbrssvc/selview/CPMSSV0101.hc",
        MENU : "카&라이프 > 시세/경매",
        TYPE : "ETC"
    },
    KIA_MOB_600_1009 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A050300",
        MENU : "카&라이프 > 카&라이프TV",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/index/eventMall#1329^1828"
    },
    KIA_MOB_600_1010 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/P000000",
        MENU : "카&라이프 > 화끈한이벤트",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/index/eventMall#1329^1828"
    },
    KIA_MOB_600_1011 : {
        URL : CONSTANT.AUTON_URL_PREFIX + "/a/A050300",
        MENU : "카&라이프 > 오토엔이벤트",
        TYPE : "AUTON",
        PATH : "https://carnlife.auton.kr/index/eventMall#1874^1874"
    },
    KIA_MOB_550_1001 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/vehicles/k9/microsite.html",
        MENU : "고급차 > k9 브랜드 스토리",
        TYPE : "KIA"
    },
    KIA_MOB_550_1002 : {
        URL : CONSTANT.KIA_URL_PREFIX + "kr/vehicles/stinger/features.html",
        MENU : "고급차 > 스팅어 브랜드 스토리",
        TYPE : "KIA"
    },
    KIA_RNW_251_0000 : {
        URL : "http://101.1.44.82:3081/qf_lgin.do?",
        MENU : "고급차 > k9 프리미엄케어 예약",
        TYPE : "KIA"
    },
    KIA_RNW_251_1000 : {
        URL : "http://101.1.44.82:3080/qf_lgin.do?",
        MENU : "고급차 > 스팅어 프리미엄케어 예약",
        TYPE : "KIA"
    },
    KIA_RNW_252_2000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/knet/knet_freecare.do",
        MENU : "고급차  > 프리케어 안내",
        TYPE : "RED"
    },
    KIA_RNW_252_3000 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/view/web/krdm/ebbvt/ebbvt_info.do",
        MENU : "전체메뉴 > EV9 전용혜택",
        TYPE : "RED"
    },

    /**
     * CCSP 화면
     */
    KIA_MOB_000_3000 : {
        URL : "https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/authorize?client_id=87cbd297-ce6b-4601-bee9-1f0433d94d96&redirect_uri=https://prd.kr-ccapi.kia.com/api/v1/user/oauth2/redirect&response_type=code&state=test&scope=url.find",
        MENU : "CCSP ID 및 비밀번호 찾기",
        TYPE : "CCSP"
    },
    KIA_RNW_0D3_1010 : {
        //URL : "https://stg.kr-ccapi.kia.com/web/v1/portal?sso=true", // 검증
        URL : "https://prd.kr-ccapi.kia.com/web/v1/portal?sso=true", // 운영
        MENU : "HMG ID 내 정보 변경 페이지",
        TYPE : "CCSP"
    },
    /**
     * 마이페이지 화면
     */
    KIA_MOB_830_1011 : {
        URL : CONSTANT.RED_URL_PREFIX + "kr/kmrd/selectMyRedInfo.do",
        MENU : "메인 > 마이페이지",
        TYPE : "RED"
    },

    /**
     * KIAVIK-925 통합 개인정보처리방침 적용
     */
    KIA_MOB_900_1000 : {
        URL : "https://privacy.kia.com/overview/full-policy",
        MENU : "메인 > 마이페이지",
        TYPE : "RED"
    },

    /**
     * 충전 로밍 서비스 제공 약관
     */
    KIA_MOB_900_1009 : {
        URL : "https://m.members.kia.com/kr/view/web/kutl/kutl_roaming.do",
        MENU : "메인 > 마이페이지",
        TYPE : "RED"
    },

    /**
     * 구독형 충전 요금제 제공 약관
     */
    KIA_MOB_900_1010 : {
        URL : "https://m.members.kia.com/kr/view/web/kutl/kutl_subscription.do",
        MENU : "메인 > 마이페이지",
        TYPE : "RED"
    },

    /**
     * 충전 로밍 서비스 및 구독형 충전 요금제 중개 약관
     */
    KIA_MOB_900_1011 : {
        URL : "https://m.members.kia.com/kr/view/web/kutl/kutl_mediation.do",
        MENU : "메인 > 마이페이지",
        TYPE : "RED"
    },

    /**
     * 웹뷰 - 기아 e-라이프 패키지
     */
    KIA_MOB_900_2000 : {
        URL : CONFIG.IS_DEV ? "http://58.87.47.137/kr/view/web/krdm/guide/ev_recharge_solution.do" : "https://m.members.kia.com/kr/view/web/krdm/guide/ev_recharge_solution.do",
        MENU : "전체 메뉴 > 기아 e-라이프 패키지",
        TYPE : "RED"
    },

    /**
     * 웹뷰 - 에스트래픽 그린패스 상품 안내 화면
     */
    KIA_RNW_500_1000 : {
        URL : CONFIG.IS_DEV ? "https://kia-test.sscharger.co/home?partnerType=myKiaPaid&ci=" : "https://kia.sscharger.co/home?partnerType=myKiaPaid&ci=",
        MENU : "그린패스 상품 안내",
        TYPE : ""
    }
};