/**
 * @파일명 : interface.js
 * @작성자 : 최정동
 * @생성일 : 2018. 7. 05. 오전 9:21:00
 * @메뉴명 : 전문 통신 목록 파일
 */


var inf = {
	carmgmt : {
		carAllModel : {
			url : "carmgmt/carAllModel",
			nm : "전체 모델 조회"
		},
		carAllModelV2 : {
            url : "carmgmt/carAllModelV2",
            nm : "전체 모델 조회 V2"
        },
		carVehicle : {
			url : "carmgmt/carVehicle",
			nm : "선호차종조회"			
		}
	},
	
	carinfo : {
		carContractPayInfo : {
			url : "carinfo/carContractPayInfo",
			nm : "구매대금 영세 조회"
		},
		warrantInfoList : {
			url : "carinfo/warrantInfoList",
			nm : "차량보증기간 조회"
		},
		csmrLuxuryCarInfo : {
			url : "carinfo/csmrLuxuryCarInfo",
			nm : "고객 고급차종 조회 "
		},
		csmrLuxuryCarAliasInfo : {
			url : "carinfo/csmrLuxuryCarAliasInfo",
			nm : "고객 고급차종 조회 V2"
		},
		whsnIngInfo : {
			url : "carinfo/whsnIngInfo",
			nm : "작업진행 현황 조회 "
		},
		TaaSOdometerNbattery : {
			url: "car/ev/tassOdometerNbattery",
			nm: "TaaS 주행정보 조회"
		},
		TaaSAgreeYnReg : {
			url: "car/ev/tassAgreeYnReg",
			nm: "TaaS 개인정보이용동의여부 등록"
		}
	},
	
	car : {
		avgFuelInfo : {
			url : "car/avgFuelInfo",
			nm : "최종주행거리, 평균연비조회"
		},
		carInfo : {
			url : "car/carInfo",
			nm : "보유차량정보 조회"
		},
		contInfo : {
			url : "car/contInfo",
			nm : "계약출고정보 조회"
		},
		eachContInfo : {
			url : "car/eachContInfo",
			nm : "계약출고정보 조회"
		},
		delRealDriver : {
			url : "car/delRealDriver",
			nm : "실운행자 삭제"
		},
		distInfo : {
			url : "car/distInfo",
			nm : "주행거리정보 조회"
		},
		insertDist : {
			url : "car/insertDist",
			nm : "주행거리입력"
		},
		reqRealDriver : {
			url : "car/reqRealDriver",
			nm : "실운행자 등록"
		},
		selectRealDriverList : {
			url : "car/selectRealDriverList",
			nm : "실운행자 리스트 조회"
		},
		mbrInfo : {
			url : "car/mbrInfo",
			nm : "실운행자 등록전, 회원가입 여부 확인"
		},
		driverAgreeYn : {
			url : "car/driverAgreeYn",
			nm : "실운행자 등록동의 확인"
		},
		newCarAd : {
			url : "car/Ad",
			nm : "신차 광고"
		},
		updateMainAutoq : {
			url : "car/updateMainAutoq",
			nm : "전담오토큐 변경"
		}
	},

	carInfoUpdate : {
		selectCarInfo : {
			url : "carInfo/selectCarInfo",
			nm : "차량정보 수정 전 조회"
		},
		selectCarUseCodeList : {
			url : "carInfo/selectCarUseCodeList",
			nm : "차량용도 구분 통합코드 조회"
		},
		selectFuelList : {
			url : "carInfo/selectFuelList",
			nm : "연료 구분 코드 조회"
		},
		updateCarInfo : {
			url : "carInfo/updateCarInfo",
			nm : "차량 정보 수정"
		}
	},
	
	carservice : {
		autoqDetailInfo : {
			url : "carservice/autoqDetailInfo",
			nm : "오토큐 상세정보 조회"
		},
		autoqRsvInfo : {
			url : "carservice/autoqRsvInfo",
			nm : "오토큐 정비 예약 조회"
		},
		autoqRsvReg : {
			url : "carservice/autoqRsvReg",
			nm : "오토큐 정비 예약 등록"
		},
		autoqServiceTypeList : {
			url : "carservice/autoqServiceTypeList",
			nm : "서비스구분 목록"
		},
		myAutoqAsnInfo : {
			url : "carservice/myAutoqAsnInfo",
			nm : "전담오토큐 조회"
		},
		schAutoqCeqBanList : {
			url : "carservice/schAutoqCeqBanList",
			nm : "오토큐 정비반 조회"
		},
		nearAutoqInfoList : {
			url : "carservice/nearAutoqInfoList",
			nm : "가까운 오토큐 찾기"
		},
		schAutoqList : {
			url : "carservice/schAutoqList",
			nm : "오토큐 검색"
		},
		schAutoqYmdList : {
			url : "carservice/schAutoqYmdList",
			nm : "오토큐 정비가능 일자(시간) 검색" //일자와 시간이 하나의전문으로 변경됨 (2018.10.24)
		},
		schGugunList : {
			url : "carservice/schGugunList",
			nm : "구군검색"
		},
		schSidoList : {
			url : "carservice/schSidoList",
			nm : "시도검색"
		},
		repairRprType : {
			url : "carservice/repairRprType",
			nm : "정비항목"
		},
		autoqRsvHistInfoList : {
			url : "carservice/autoqRsvHistInfoList",
			nm : "정비예약 내역"
		},
		autoqRsvDetailInfo : {
			url : "carservice/autoqRsvDetailInfo",
			nm : "정비예약 상세"
		},
		autoqRsvCancel : {
			url : "carservice/autoqRsvCancel",
			nm : "예약취소"
		},
		autoqDtdRsvReg : {
			url : "carservice/autoqDtdRsvReg",
			nm : "정비예약-dtd 예약 등록"
		},
		dtdRsvReg : {
			url : "carservice/dtdRsvReg",
			nm : "door To door 예약"
		},
		dtdRsvHistInfoList : {
			url : "carservice/dtdRsvHistInfoList",
			nm : "door to door 예약내역"
		},
		dtdRsvCancel : {
			url : "carservice/dtdRsvCancel",
			nm : "door to door 예약취소"
		},
		isRsvYnInfo : {
			url : "carservice/isRsvYnInfo",
			nm : "정비 예약 여부 및 dtd 예약 여부"
		},
		dtdDtmInfo : {
			url : "carservice/dtdDtmInfo",
			nm : "D2D 날짜"
		},
		dtdRsvHistInfo : {
			url : "carservice/dtdRsvHistInfo",
			nm : "door to door 예약 상세 내역"
		}
		
	},

	carnlife : {
		carList : {
			url : "carandlife/carList",
			nm : "차량관리 내차관리 보유차량 리스트 조회"
		}
	},
	
	carspec : {
		specInfoList : {
			url : "carspec/specInfoList",
			nm : "차량스펙 조회"
		}
	},
	
	card : {
		cardChngIssue : {
			url : "card/cardChngIssue",
			nm : "카드교체발급 신청"			
		},
		cardList : {
			url : "card/cardList",
			nm : "보유카드현황 조회"			
		},
		cardReIssue : {
			url : "card/cardReIssue",
			nm : "카드재발급 신청"			
		},
		dlvStts : {
			url : "card/dlvStts", //사용시 checkVerifyUrl() 사용
			nm : "카드배송현황 조회"			
		},
		mainCardList : {
			url : "card/mainCardList", //사용시 checkVerifyUrl() 사용
			nm : "바코드 생성시 보유카드 조회"
		},
		pssblExchngList : {
			url : "card/pssblExchngList",
			nm : "교체발급가능 카드리스트 조회"
		},
		pssblReIssueList : {
			url : "card/pssblReIssueList",
			nm : "재발급가능 카드리스트 조회"
		}
	},
	
	common : {
		mbrUnqNo : {
			url : "cm/mbrUnqNo",
			nm : "회원고유번호 조회 성공"
		},
		encBase64 : {
			url : "cm/encBase64",
			nm : "인코딩 base64"
		},
        decBase64 : {
            url : "cm/decBase64",
            nm : "디코딩 base64"
        },
		encAESService : {
			url : "AesCmm/encAESService",       // aes-cmm-controller
			nm : "서비스 AES 암호화 서버 요청"        //  AUTON : 카앤라이프, RED : 멤버스, KIA : 기아, STRAFFIC : STraffic, DKC : 디지털키 등
		},
		decAESService : {
			url : "AesCmm/decAESService",
			nm : "서비스 AES 복호화 서버 요청"
		}
	},
	
	event : {
		attendanceEvent : {
			url : "event/attendanceEvent",
			nm : "출석체크 이벤트 참여"			
		},
		detailEvent : {
			url : "event/detailEvent",
			nm : "이벤트상세 조회"			
		},
		endEventList : {
			url : "event/endEventList",
			nm : "이벤트목록_종료이벤트 리스트 조회"			
		},
		eventList : {
			url : "event/eventList",
			nm : "이벤트목록_진행중인이벤트 리스트 조회"			
		},
		endEventListV2 : {
			url : "event/endEventListV2",
			nm : "이벤트목록_종료이벤트 리스트 조회"
		},
		eventListV2 : {
			url : "event/eventListV2",
			nm : "이벤트목록_진행중인이벤트 리스트 조회"
		},
		eventAllList : {
            url : "event/eventAllList",
            nm : "이벤트목록_모든 이벤트 리스트 조회"
        },
		pickEventList : {
			url : "event/pickEventList",
			nm : "이벤트목록_당첨자발표리스트 조회"			
		},
		pickdetailEvent : {
			url : "event/pickdetailEvent",
			nm : "당첨자발표상세 조회"			
		},
		selectAttendance : {
			url : "event/selectAttendance",
			nm : "출석체크 날짜 조회"			
		},
		getEventDate : {
			url : "event/getEventDate",
			nm : "날짜 조회"			
		},
		reviewApply : {
			url : "kiaevent/kiaStoryApply",
			nm : "리뷰이벤트 등록"			
		},
		reviewCancel : {
			url : "kiaevent/kiaStoryDelete",
			nm : "리뷰이벤트 취소"			
		},
		kiaKboApply : { 
			url : "kiaevent/kiaKboApply",
			nm : "기아 야구이벤트 응모"			
		},
		kiaStoryEventApply : {
		    url : "kiaevent/kiaStoryEventApply",
		    nm : "주행거리 행운이벤트 등록"
		},
		kiaStoryDtmSearch : {
		    url : "kiaevent/kiaStoryDtmSearch",
		    nm : "당일 기아이벤트 응모 조회"
		},
        eventCareList : {
            url : "event/eventCareList",
            nm : "카케어/라이프케어 이벤트 조회"
        },
        allEventCareList : {
            url : "event/allEventCareList",
            nm : "카케어/라이프케어 모든 이벤트 조회"
        },
        careEndEventList : {
            url : "event/careEndEventList",
            nm : "카케어/라이프케어 종료 이벤트 조회"
        },
        carCareServiceList : {
            url : "event/carCareServiceList",
            nm : "하이테크 컨설팅 서비스 조회"
        },
        kiaBrandServiceList : {
            url : "event/kiaBrandServiceList",
            nm : "기아브랜드관 목록 조회"
        }

	},
	
	fido : {
		selectFidoCertInfo : {
			url : "fido/selectFidoCertInfo",
			nm : "Fido Authcode 생성(숫자 4자리 인증번호)"			
		},
		selectFidoVerifyInfo : {
			url : "fido/selectFidoVerifyInfo",
			nm : "Fido 검증"			
		}
	},
	
	main : {
		BeforeLogin : {
			url : "main/BeforeLogin",
			nm : "메인_로그인전"			
		},
        BeforeLoginV2 : {
            url : "main/BeforeLoginV2",
            nm : "메인_로그인전"
        },
		mainLayerPopup : {
			url : "main/mainLayerPopup",
			nm : "메인 화면 진입 시 레이어 팝업"			
		},
		mainList : {
			url : "main/mainList",
			nm : "로그인 후 정보조회"			
		},
		notiCnt : {
			url : "main/notiCnt",
			nm : "메인_알림 카운"
		},
        carAgreeStandBy : {
            url : "main/carAgreeStandBy",
            nm : "실운행자 동의전 리스트"
        }
	},
	
	member : {
		changePw : {
			url : "member/changePw",
			nm : "비밀번호변경"			
		},
		chkEmlOverlap : {
			url : "member/chkEmlOverlap",
			nm : "회원가입이메일중복체크(Web용 API)"			
		},
		chkEmlOverlapApp : {
			url : "member/chkEmlOverlapApp",
			nm : "회원가입이메일중복체크(App용 API)"			
		},
		chkIdOverlap : {
			url : "member/chkIdOverlap",
			nm : "회원가입아이디중복체크(Web용 API)"			
		},
		chkMemberJoin : {
			url : "member/chkMemberJoin",
			nm : "회원가입전회원조회"
		},
		dropMember : {
			url : "member/dropMember",
			nm : "회원탈퇴"			
		},
		findId : {
			url : "member/findId",
			nm : "아이디찾기(핸드폰번호or이메일주소)"			
		},
		findPw : {
			url : "member/findPw",
			nm : "비밀번호찾기(핸드폰번호or이메일주소)"			
		},
		getCi : {
			url : "member/getCi",
			nm : "selectCiCnfmToCRMS"			
		},
		login : {
			url : "member/login",
			nm : "로그인"			
		},
        verifyLogin : {
            url : "member/verifyLogin",
            nm : "로그인"
        },
		memberJoin : {
			url : "member/memberJoint",
			nm : "회원가입(Web용 API)"			
		},
		memberJoinCcsp : {
			url : "member/memberJoinCcsp",
			nm : "회원가입(ccsp용 API)"			
		},
		select : {
			url : "member/select",
			nm : "회원 정보 조회"
		},
		authBfPw : {
			url : "member/authBfPw",
			nm : "아이디 인증"			
		},
		srcSmanRc : {
			url : "member/srcSmanRc",
			nm : "영업사원조회"			
		},
		srchMbrRc : {
			url : "member/srchMbrRc",
			nm : "회원 조회"			
		},
		insertMbrRc : {
			url : "member/insertMbrRC",
			nm : "추천인 등록"			
		},
		selectMbrRc : {
			url : "member/selectMbrRC",
			nm : "추천인 등록 여부 조회"			
		},
		deleteMbrRc : {
			url : "member/deleteMbrRC",
			nm : "추천인 등록 삭제"			
		},
		changePwNew : {
			url : "member/changePwNew",
			nm : "비밀번호변경 2019"			
		},
		changePwCcsp : {
			url : "member/changePwCcsp",
			nm : "비밀번호변경 2019 CCSP"			
		},
		selectSha256 : {
			url : "member/selectCi2aes256",
			nm : "Sha256암호"			
		},
		mrkgId : {
			url : "member/mrkgMemberId",
			nm : "마케팅동의 조회 팝업"			
		}
	},
	
	msg : {
		msgList : {
			url : "msg/msgList",
			nm : "메세지함_메세지 수신 목록 조회"
		},
		msgDetail : {
			url : "msg/msgDetail",
			nm : "메세지함_메세지 수신 여부 등록"
		},
		changeStateReceived : {
			url : "msg/changeStateReceived",
			nm : "메세지 상태 변경 - 수신 확인"
		}
	},
	
	mykia : {
		mycar : {
			carInfoDelete : {
				url : "mykia/mycar/carInfoDelete",
				nm : "차량관리내차관리보유차량삭제"
			},
			carInfoInsert : {
				url : "mykia/mycar/carInfoInsert",
				nm : "차량관리내차관리보유차량등록"
			},
			carInfoUpdate : {
				url : "mykia/mycar/carInfoUpdate",
				nm : "차량관리내차관리기본차량정보 수정"
			},
			carInfoUseUpdate : {
				url : "mykia/mycar/carInfoUseUpdate",
				nm : "차량관리내차관리보유차량_사용여부 수정"
			},
			carList : {
				url : "mykia/mycar/carList",
				nm : "차량관리내차관리보유차량리스트 조회"
			},
			carSearchSelect : {
				url : "mykia/mycar/carSearchSelect",
				nm : "차량관리내차관리보유차량확인"
			},
			mainCarList : {
                url : "mykia/mycar/mainCarList",
                nm : "메인내차량리스트조회"
            },
            mainCarListLight : {
                url : "mykia/mycar/mainCarListLight",
                nm : "메인내차량리스트조회(계약차량없음)"
            },
            carInfo : {
                url : "mykia/mycar/carInfo",
                nm : "보유차량상세 조회"
            },
            regCarId : {
                url : "mykia/mycar/regCarId",
                nm : "datahub carid 등록"
            },
		}
	},
	
	setting : {
		myInfo : {
			url : "setting/myInfo",
			nm : "설정-내 정보 수정 조회"
		},
		myInfoUpdate : {
			url : "setting/myInfoUpdate",
			nm : "설정-내 정보 수정"
		},
/*
        //checkVerifyUrl() api로 대체
		verifyMyInfo : {
			url : "setting/verifyMyInfo",
			nm : "설정-내 정보 수정 조회"
		},
		verifyMyInfoUpdate : {
			url : "setting/verifyMyInfoUpdate",
			nm : "설정-내 정보 수정"
		},
*/
		rcpmUpdate : {
			url : "setting/rcpmUpdate",
			nm : "설정-광고성 정보 수신동의 변경"
		},
		pushMidnYnUpdate : {
		    url : "setting/pushMidnYnUpdate",
		    nm : "설정-심야 푸시 수신동의 변경"
		}
	},
	
	notification : {
		select : {
			url : "notification/select",
			nm : "공지 사항 목록 조회"
		},
		
		detail : {
			url : "notification/detail",
			nm : "공지 사항 상세"
		}
	},
	
	owncar : {
		select : {
			url : "owncar/select",
			nm : "보유 차량 목록 조회"
		},
		updateOwncarList : {
			url : "owncar/updateOwncarList",
			nm : "보유 차량 목록 동기화"
		}
	},
	
	point : {
		exntMilgList : {
			url : "point/exntMilgList",
			nm : "소멸예정포인트내역 조회"
		},
		extFlcMilg : {
			url : "point/extFlcMilg",
			nm : "소멸예정,적립예정 포인트 조회"
		},
		pointInfo : {
			url : "point/pointInfo",
			nm : "보유포인트 조회"
		},
		useMilgList : {
			url : "point/useMilgList",
			nm : "이용포인트내역 조회"
		}
	},
	
	push : {
		mktAgree : {
			url : "push/mktAgree",
			nm : "광고성정보 활용동의 설정"
		},
		pushAgree : {
			url : "push/pushAgree",
			nm : "push동의 설정"
		},
		pushOnOff : {
			url : "push/pushOnOff",
			nm : "push 설정 ON/OFF"
		},
		selectAgree : {
			url : "push/selectAgree",
			nm : "광고성정보 활용동의, push동의 조회"
		},
		regist : {
			url : "push/regist",
			nm : "PUSH 서비스 등록"
		},
		selectKsw : {
			url : "push/selectPushKsw",
			nm : "PUSH 서비스 등록"
		},
		updateKsw : {
			url : "push/updatePushKsw",
			nm : "PUSH 서비스 등록"
		}
	},
	
	recall : {
		freeCareList : {
			url : "recall/freeCareList",
			nm : "프리케어 목록"
		},
		freeCareTargetInfo : {
			url : "recall/freeCareTargetInfo",
			nm : "프리케어 대상차량 조회"
		},
		recallList : {
			url : "recall/recallList",
			nm : "부품별 리콜 목록"
		},
		freeCareGrnMonths : {
			url : "recall/freeCareGrnMonths",
			nm : "프리케어 만료 일자 조회"
		}
	},
	
	repair : {
		periodicRepairHistInfo : {
			url : "repair/periodicRepairHistInfo",
			nm : "정기점검 조회"
		},
		periodicRepairList : {
		    url : "repair/periodicRepairList",
		    nm : "정기점검이력 조회"
		},
		repairHistDetailInfoList : {
			url : "repair/repairHistDetailInfoList",
			nm : "정비이력 상세조회"
		},
		repairHistList : {
			url : "repair/repairHistList",
			nm : "정비이력"
		},
		repairHistList1 : {
			url : "repair/repairHistList1",
			nm : "정비이력"
		},
		repairHistListVer2 : {
		    url : "repair/repairHistListVer2",
		    nm : "일반보증 정비이력"
		},
		emergencyCall : {
			url : "repair/emergencyInfo",
			nm : "긴급출동"
		}
	},
	
	smart : {
		doorToDoorRsvdReg : {
			url : "smart/doorToDoorRsvdReg",
			nm : "door to door 예약 등록"
		},
		whsnConfirmInfo : {
			url : "smart/whsnConfirmInfo",
			nm : "입고확인증 조회"
		},
		whsnEsimateInfo : {
			url : "smart/whsnEsimateInfo",
			nm : "견적서 조회"
		},
		whsnInfo : {
			url : "smart/whsnInfo",
			nm : "최근입고 일자 및 업체 조회"
		},
		whsnIngInfo : {
			url : "smart/whsnIngInfo",
			nm : "작업진행 상태 조회"
		},
		whsnPhotoInfoList : {
			url : "smart/whsnPhotoInfoList",
			nm : "수리전후 사진 조회"
		},
		whsnReportInfo : {
			url : "smart/whsnReportInfo",
			nm : "점검 명세서 조회"
		},
		smartOnStop : {
			url : "smart/smartOnStop",
			nm : "smartOnStop 조회"
		}
	},
	faq : {
		select : {
			url : "faq/select",
			nm : "FAQ 목록 조회"
		},
		search : {
			url : "faq/search",
			nm : "FAQ 목록 검색"
		},
		detail : {
			url : "faq/detail",
			nm : "FAQ 상세"
		},
		faqCcdCnt : {
		    url : "faq/faqCcdCnt",
		    nm : "FAQ 탭 카운트"
		}
	},
	
	profile : {
		changeProfile : {
			url : "profile/modified",
			nm : "프로필 수정"
		}
	},
	file : {
		upload : {
			url : "file/upload",
			nm : "파일 업로드"
		}
	},
	
	kiastory : {
		certificationWinner : {
			url : "kiastory/certificationWinner",
			nm : "출고인증 당첨자 리스트 조회"
		},
		kiaStoryApply : {
			url : "kiastory/kiaStoryApply",
			nm : "기아스토리 응모하기"
		},
		kiaStoryApplyInfo : {
			url : "kiastory/kiaStoryApplyInfo",
			nm : "기아스토리 응모내역 조회"
		},
		kiaStoryInfo : {
			url : "kiastory/kiaStoryInfo",
			nm : "모두의 기아스토리 상세 조회"
		},
		kiaStoryLike : {
			url : "kiastory/kiaStoryLike",
			nm : "기아스토리 좋아요 상태 업데이트"
		},
		kiaStoryList : {
			url : "kiastory/kiaStoryList",
			nm : "모두의 기아스토리 리스트 조회"
		},
		kiaStoryMasterpiece : {
			url : "kiastory/kiaStoryMasterpiece",
			nm : "기아스토리 우수작 리스트 조회"
		},
		likeYn : {
			url : "kiastory/likeYn",
			nm : "좋아요여부 조회"
		},
		main : {
			url : "kiastory/main",
			nm : "기아스토리 메인 조회"
		}
	},
	
	allInfo : {
		carInfoList : {
			url : "carInfo/carInfoList",
			nm : "차량정보"
		}
	},
	
	terms : {
		selectTermsAgreeYn : {
			url : "terms/selectTermsAgreeYn",
			nm : "약관동의여부"
		},
		
		selectTermsHistory : {
			url : "terms/selectTermsHistory",
			nm : "약관 개정 이력 조회"
		},
		
		selectTermsHistoryDetail : {
			url : "terms/selectTermsHistoryDetail",
			nm : "약관 개정 이력 상세조회"
		},
		
		setTermsYn : {
			url : "terms/setTermsYn",
			nm : "약관동의 동의 및 거부"
		},
		
		updateDriverThirdPersonTerms : {
			url : "terms/updateDriverThirdPersonTerms",
			nm : "(실운행자)제3자 제공동의 약관 동의 업데이트"
		},
		
		updateMpointTerms : {
			url : "terms/updateMpointTerms",
			nm : "현대M포인트 약관 동의 업데이트"
		},
		
		updateOwnerThirdPersonTerms : {
			url : "terms/updateOwnerThirdPersonTerms",
			nm : "(차주)제3자 제공동의 약관 동의 업데이트"
		}
	},

	ckb : {
		regParc : {
			url : "ckb/regParc",
			nm : "제휴사 정보 받기 설정"
		},

		insertCycle : {
			url : "ckb/insertCycle",
			nm : "소모품목록 교환주기 설정"
		},

		parcList : {
			url : "ckb/parcList",
			nm : "제휴사 정보 받기"
		}, 

		distMonthSum : {
			url : "ckb/distMonthSum",
			nm : "운행내역 조회월 포함이전 12개월 조회"
		},

		expInfo : {
			url : "ckb/expInfo",
			nm : "차계부 요약 화면"
		},

		rofType : {
			url : "ckb/rofType",
			nm : "연비 계산방식 설정"
		},

		regExpInfo : {
			url : "ckb/regExpInfo",
			nm : "비용등록"
		},

		exchCycle : {
			url : "ckb/exchCycle",
			nm : "소모품 조회 "
		},

		ckbSttg : {
			url : "ckb/ckbSttg",
			nm : "차계부 등록"
		},

		ckbRegYn : {
			url : "ckb/ckbRegYn",
			nm : "차계부 조회"
		},

		distMonthSum : {
			url : "ckb/distMonthSum",
			nm : "운행내역 12개월 조회 "
		},

		ckbExpMonthSum : {
			url : "ckb/ckbExpMonthSum",
			nm : "월별 비용항목 12개월"
		},

		expForMonth : {
			url : "ckb/expForMonth",
			nm : "차량관리 비용 "
		},
		
		oilFor3Mon : {
			url : "ckb/oilFor3Mon",
			nm : "운행내역 3개월 평균 연비 조회"
		},

		expendList : { //
			url : "ckb/expendList",
			nm : "비용리스트 조회"
		},

		delExpendList : { //ckb
			url : "ckb/deleteExpendList",
			nm : "비용리스트 삭제"
		},
	
		beforeRegExpInfo : { //ckb
			url : "ckb/beforeRegExpInfo",
			nm : "비용리스트 자세히"
		},

		ckbDelCar : { 
			url : "ckb/deleteCkbMgmtSubjCarsInfo",
			nm : "관리차량 데이터 삭제"
		},

		deleteCkbCarsList : { 
			url : "ckb/deleteCkbCarsList",
			nm : "차량 삭제 리스트"
		},

		recoveryCkbCars : { 
			url : "ckb/recoveryCkbCars",
			nm : "삭제 차량 복구"
		},
		
	},
	
	quiz : {
		quizReg : {
			url : "quiz/quizReg",
			nm : "퀴즈 이벤트 참여 등록"
		},
		
		quizYn : {
			url : "quiz/quizYn",
			nm : "퀴즈 이벤트 중복 참여 여부"
		},

		repairReg : {
			url : "quiz/repairReg",
			nm : "설맞이 이벤트 참여 등록"
		},

		quizFinalYn : {
			url : "quiz/quizFinalYn",
			nm : "응모이벤트 응모마감 확인"
		},

		prizeDraw : {
			url : "quiz/prizeDraw",
			nm : "상품 확인"
		},

		prizeYn : {
			url : "quiz/prizeYn",
			nm : "상품 참여 확인"
		},

		
		selectJoin : {
			url : "quiz/selectJoin",
			nm : "mma 조회"
		},
	},
	
	hyundai : {
		accountPoint : {
			url : "hyundai/accountPoint",
			nm : "구매통장포인트 조회"
		},
		detailMpoint : {
			url : "hyundai/detailMpoint",
			nm : "현대M포인트 상세조회"
		},
		saveAutoPoint : {
			url : "hyundai/saveAutoPoint",
			nm : "세이브오토포인트 조회"
		},
		selectMpoint : {
			url : "hyundai/selectMpoint",
			nm : "현대M포인트조회"
		}
	},

	kianews : {
		newsReadYn : {
			url : "kianews/newsReadYn",
			nm : "뉴스 뱃지"
		},

		select : {
			url : "kianews/select",
			nm : "뉴스 목록"
		},

        selectV2 : {
            url : "kianews/selectV2",
            nm : "뉴스 목록"
        },

        kiaSelect : {
            url : "kianews/kiaSelect",
            nm : "채널 기아"
        },
	},

	myPage : {
		selMyPage : {
			url : "main/myPage",
			nm : "마이페이지 조회"
		},

		AfterLogin : {
			url : "main/AfterLogin",
			nm : "로그인 후 메인"
		},

        AfterLoginV2 : {
            url : "main/AfterLoginV2",
            nm : "로그인 후 메인"
        }
	},

	newMember : { 
		login : {
			url : "newMember/login",
			nm : "자동 로그인"
		}
	},

	coupon : { 
		couponSelect : {
			url : "coupon/couponSelect",
			nm : "쿠폰 목록"
		},
		couponReg : {
			url : "coupon/cponReg",
			nm : "쿠폰 등록"
		},
		couponDetail : {
			url : "coupon/couponDetailSelect",
			nm : "쿠폰 상세"
		},
		cponRepairReg : {
			url : "coupon/cponRepairReg",
			nm : "이벤트 쿠폰 등록"
		}
	}, 

	autoCam : { 
		autoCamPwdInfo : {
			url : "autocam/autoCamPwdInfo",
			nm : "오토캠 가능여부"
		},
		autoCamViewCnt : {
			url : "autocam/autoCamViewCnt",
			nm : "카운트증가"
		}
	},

	survey : {
	    surveyList : {
	        url : "survey/surveyList",
	        nm : "설문 목록 조회"
	    },
	    surveyInfo : {
	        url : "survey/surveyInfo",
	        nm : "설문 상세 조회"
	    },
	    surveyReg : {
	        url : "survey/surveyReg",
	        nm : "설문 등록"
	    },
	    selectSurveyCheck : {
	        url : "survey/selectSurveyCheck",
	        nm : "설문 참여 여부 조회"
	    } 
	},

    code : {
        appVersion : {
            url : "code/appVersion",
            nm : "앱 최신 버전 조회"
        },
        selectList : {
            url : "code/selectList",
            nm : "운영기관 공통코드 리스트 조회"
        },
    },

    ev : {
        evMngReg : {
            url : "evmng/evMngReg",
            nm : "EV멤버십 등록"
        },

    },
    evCharger : {
        schEvChargerStation : {
            url : "evCharger/schEvChargerStation",
            name : "EV 충전소 정보 조회"
        },
        schEvChargerStatus : {
            url : "evCharger/schEvChargerStatus",
            name : "EV 충전기 상태 조회"
        },
        schEvChargerFavoriteList : {
            url : "evCharger/schEvChargerFavoriteList",
            name : "EV 충전소 즐겨찾기 리스트 조회"
        },
        evChargerFavoriteReg : {
            url : "evCharger/evChargerFavoriteReg",
            name : "EV 충전소 즐겨찾기 [등록/삭제]"
        },
    },
	dkc: {
		getResCheckService: {
			url: "dataHub/resCheckService",
			nm: "디지털키 서비스 가입 대상자 확인 요청"
		}
	},
};
