/**
 * @파일명 : mcore_api.js
 * @작성자 : 최정동
 * @생성일 : 2018. 7. 05. 오전 9:21:00
 * @메뉴명 : 모피어스 관련 API 정리 파일
 */


/**
 * Core Api
 */

//[KIAVIK-518] 로그인 정보 유실
// 현상이 발생한 페이지만 추가.
var _pm = PATH_MANAGER;
var LOGIN_PAGE = [PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml,PATH_MANAGER.KIA_RNW_120_0000_2.nameWithHtml,PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml,
    PATH_MANAGER.KIA_RNW_212_0000.nameWithHtml, PATH_MANAGER.KIA_RNW_220_0000.nameWithHtml,
    PATH_MANAGER.KIA_RNW_230_0000.nameWithHtml, PATH_MANAGER.KIA_RNW_245_1000.nameWithHtml, PATH_MANAGER.KIA_RNW_243_1000.nameWithHtml,
    PATH_MANAGER.KIA_RNW_212_6000.nameWithHtml, PATH_MANAGER.KIA_RNW_091_0000.nameWithHtml, PATH_MANAGER.KIA_RNW_420_0000.nameWithHtml,
    PATH_MANAGER.KIA_RNW_710_0000.nameWithHtml, PATH_MANAGER.KIA_RNW_714_1000.nameWithHtml];

// Navigator 관련 API
var MNavigator = {
    os: function (os) {
        if (arguments.length == 1) {
            return M.navigator.os(os);
        } else {
            return M.navigator.os();
        }
    },

    device: function (os, version) {
        if (arguments.length == 2) {
            return M.navigator.device(os, version);
        } else if (arguments.length == 1) {
            return M.navigator.device(os);
        } else if (arguments.length == 0) {
            return M.navigator.device();
        }
    },

    browser: function (name, version) {
        if (arguments.length == 2) {
            return M.navigator.browser(name, version);
        } else if (arguments.length == 1) {
            return M.navigator.browser(name);
        } else if (arguments.length == 0) {
            return M.navigator.browser();
        }
    }
};

// PAGE 관련 API
var MPage = {
    info: function (keyPath) {
        return M.page.info(keyPath);
    },

    defer: function (enabled, time) {
        if (enabled) {
            M.page.defer(enabled, time);
        } else {
            M.page.defer(enabled);
        }
    },

    html: function (options) {
        // 화면 이동시 공통 처리
        var _options = options;
        M.page.html(_options);
    },

    back: function (options) {
        var _options = options;
        M.page.back(_options);
    },

    remove: function (url) {
        M.page.remove(url);
    },

    replace: function (options) {
        var _options = options;
        M.page.replace(_options);
    },

    activity: function (options) {
        //if(MInfo.device().os.name != "pc"){
        if (PGV.device.os.name != 'pc') {
            // TODO : 기아홈페이지 또는 기아멤버스 이동의 경우 통합앱의 로그인 여부를 체크하여 token 값을 보내도록 처리
            var _options = options;

            /**
             * 기아멤버스, 기아홈페이지로 이동 시 통합 앱 로그인이 되어 있는 경우 로그인 정보 넘기기
             * TODO
             * : 기아멤버스, 기아홈페이지 호출 URL 나오면 CONSTANT.RED_LOGIN_URL, CONSTANT.KIA_LOGIN_URL 세팅
             * : RED_CRTEC_KEY,KIA_CRTEC_KEY 세팅 하기
             * 개발 후 주석 해제!!!!!
             */

                // 링크된 URL Google Analytics에 전송
            var gaLinkName = searchGaLinkName(_options.param.requestURL);
            if (isEmpty(gaLinkName) == false) {
                screenViewGa(gaLinkName);
            }

            if (_options.className == "WebviewActivity" && (_options.param.requestURL.startsWith(CONSTANT.RED_URL_PREFIX)
                || _options.param.requestURL.startsWith(CONSTANT.KIA_URL_PREFIX)
                || _options.param.requestURL.startsWith(CONSTANT.RED_URL_OLD_PREFIX))) {
                //[KIAVIK-344] 레드멤버스 도메인 변경 예외처리.
                // 이전 도메인으로 들어오는 경우 일괄 변경.
                if (_options.param.requestURL.startsWith(CONSTANT.RED_URL_OLD_PREFIX)) {
                    _options.param.requestURL = _options.param.requestURL.replace(CONSTANT.RED_URL_OLD_PREFIX, CONSTANT.RED_URL_PREFIX);
                }

                if(!isEmpty(PGV.loginInfo)){
                    var reqUrl = _options.param.requestURL.startsWith(CONSTANT.RED_URL_PREFIX) == true ? CONSTANT.RED_LOGIN_URL : CONSTANT.KIA_LOGIN_URL;		// 고정된 기아멤버스, 기아홈페이지 URL
                    var returnUrl = _options.param.requestURL;		// 로그인 처리 후 실제 이동할 URL
                    _options.param.method = CONSTANT.NET_MTHD.POST;
                    _options.param.requestURL = reqUrl;
                    // TODO : 추후 기아 홈페이지 특정 페이지 체크하여 위도, 경도 값 파라미터 넘기기
                    _options.param.postData = makeKiaRedPostData(returnUrl);
                }else{
                    _options.param.method = CONSTANT.NET_MTHD.GET;
                }
            } else {
                if (!isEmpty(_options.param.postData) && _options.param.method == CONSTANT.NET_MTHD.POST) {
                    var _tmpPostData = _options.param.postData;
                    var _changePostData = "";
                    var _changePostData = "";
                    for (var i in _tmpPostData) {
                        _changePostData += i + "=" + _tmpPostData[i];
                        _changePostData += "&";
                    }
                    _options.param.postData = _changePostData.substr(0, _changePostData.length - 1);
                }
            }

            if (isEmpty(_options.actionType)) _options.actionType = "NO_HISTORY";

            M.page.activity(_options);
        } else {
            MPopup.alert("PC 에뮬레이터에서는 웹뷰 기능을 제공하지 않습니다.");
        }

    }
};

// DATA 관련 API
var MData = {
    param: function (key, value) {
        if (arguments.length == 0) {
            return M.data.param() || {};
        } else if (arguments.length == 1) {
            return M.data.param(key);
        } else if (arguments.length == 2) {
            M.data.param(key, value);

        }
    },

    removeParam: function (key) {
        if (arguments.length == 0) {
            M.data.removeParam();
        } else if (arguments.length == 1) {
            M.data.removeParam(key);
        }
    },

    global: function (key, value) {
        if (arguments.length == 0) {
            return M.data.global() || {};
        } else if (arguments.length == 1) {
            return M.data.global(key);
        } else if (arguments.length == 2) {
            M.data.global(key, value);
        }
    },

    removeGlobal: function (key) {
        if (arguments.length == 0) {
            M.data.removeGlobal();
        } else if (arguments.length == 1) {
            M.data.removeGlobal(key);
        }
    },

    storage: function (key, value) {
//		if(arguments.length == 0){
//			return M.data.storage() || {};
//		}else 
        if (arguments.length == 1) {
            var _getKey = key;

            //if(MInfo.device().os.name != 'pc'){
            //if(PGV.device.os.name != 'pc'){
            _getKey = Base64.encode(key);
            var returnVal = exWNDecryptString(M.data.storage(_getKey));
            try {
                if (typeof JSON.parse(returnVal) == "object") {
                    return JSON.parse(returnVal);
                } else {
                    return returnVal;
                }
            } catch (e) {
                return returnVal;
            }
//				return Base64.decode(exWNDecryptString(M.data.storage(_getKey)));
            //}else{
            //	return M.data.storage(_getKey);
            //}
        } else if (arguments.length == 2) {
            var _setKey = key;
            var _setValue = value;
            //if(MInfo.device().os.name != 'pc'){
            if (PGV.device.os.name != 'pc') {
                _setKey = Base64.encode(key);

                if (typeof value == "object") {
                    value = JSON.stringify(value);
                }

                _setValue = exWNEncryptString(value);
            }

            M.data.storage(_setKey, _setValue);
        }
    },

    removeStorage: function (key) {
//		if(arguments.length == 0){
//			M.data.removeStorage();
//		}else 
        if (arguments.length == 1) {
            var _getKey = key;
            //if(MInfo.device().os.name != 'pc'){
            if (PGV.device.os.name != 'pc') {
                _getKey = Base64.encode(key);
            }

            M.data.removeStorage(_getKey);
        }
    }
};

// AES 128
var MSec = {
    encrypt: function (value) {
        var encObj = M.sec.encrypt(value);
        return encObj.status == "SUCCESS" ? encObj.result : "";
    },

    decrypt: function (value) {
        var decObj = M.sec.decrypt(value);
        return decObj.status == "SUCCESS" ? decObj.result : "";
    }
};

var MInfo = {
    version: function () {
        return M.info.version();
    },

    memory: function () {
        return M.info.memory();
    },

    device: function (keyPath) {
        if (arguments.length == 0) {
            return M.info.device();
        } else if (arguments.length == 1) {
            return M.info.device(keyPath);
        }
    },

    stack: function (index) {
        if (arguments.length == 0) {
            return M.info.stack();
        } else if (arguments.length == 1) {
            return M.info.stack(index);
        }
    }
};

var MApps = {
    browser: function (url, encoding) {
        M.apps.browser(url, encoding || "UTF-8");
    },

    remove: function (packageName) {
        if (MInfo.device.toLowerCase() == "android") {
            M.apps.remove(packageName);
        } else {
            MPopup.alert("지원하지 않는 OS 입니다.");
        }
    },

    info: function (packageNm) {
        return M.apps.info(packageNm);
    },

    open: function (packageNm, params) {
        if (arguments.length == 1) {
            M.apps.open(packageNm);
        } else {
            M.apps.open(packageNm, params);
        }
    },

    store: function (packageNm) {
        M.apps.store(packageNm);
    }
};

var MSys = {
    call: function (telNum) {
        //if(MInfo.device().os.name.toLowerCase() == 'ios'){
        if (PGV.device.os.name.toLowerCase() == 'ios' || PGV.device.os.name.toLowerCase() == 'ipados') {
            M.sys.call(telNum);
        } else {
            location.href = "tel:" + telNum;
        }

    }
};


/**
 * Addon Api
 */


var MMedia = {
    camera: function (options) {
        M.media.camera({
            path: options.path || "/",
            mediaType: options.mediaType || "PHOTO",
            saveAlbum: options.saveAlbum || false,
            callback: function (status, result, option) {
                getPushDataWhenNotMorpheusView();
                if (options.callback) {
                    options.callback(status, result, option);
                }
            }
        });
    },

    album: function (options) {
        if (!options.path) {
            MPopup.alert("이미지 경로를 입력해주세요.");
            return;
        }
        M.media.album({
            path: options.path,
            onfinish: function (status, result, option) {
                getPushDataWhenNotMorpheusView();
                if (options.callback) {
                    options.callback(status, result, option);
                }
            }
        });
    },

    info: function (options) {
        M.media.info({
            path: options.path || "/",
            mediaType: options.mediaType || "PHOTO",
            callback: function (status, result) {
                if (options.callback) {
                    options.callback(status, result);
                }
            }
        });
    },

    picker: function (options) {
        M.media.picker({
            mode: options.mode || "SINGLE",
            media: options.media || "PHOTO",
            path: options.path || null,
            column: options.column || 3,
            callback: function (status, result) {
                getPushDataWhenNotMorpheusView();
                if (options.callback) {
                    options.callback(status, result);
                }
            }
        });
    },

    optimize: function (options) {
        M.media.optimize({
            source: options.source,
            destination: options.destination,
            overwrite: options.overwrite || true,
            quality: options.quality || "0.5",
            format: options.format || "JPG",
            callback: function (result) {
                if (options.callback) {
                    options.callback(result);
                }
            }
        });
    },

    crop: function (options) {
        M.media.crop({
            source: options.source,
            destination: options.destination,
            dimension: {
                width: options.width,
                height: options.height
            },
            optimize: options.optimize || 0.8,
            format: options.format || "JPG",
            callback: function (result) {
                if (options.callback) {
                    options.callback(result);
                }
            }
        });
    }
};


var MNet = {
    /* rnw api 용 : sync, 콜백함수 실행 */
    httpSend: function (options) {
        if(options.isMock&&CONSTANT.IS_SVR_REF_MOCK){
            var apiId = !isEmpty(options.path.apiId)?options.path.apiId:options.sendData.apiId;
            var response = _MOCK_RES[apiId].response.body;
            options.callback(response);
        }else{
            if (options.indicatorYn != "N") {
                exWNShowIndicator();
            }
            if (isEmpty(options.retryData)) {
                options.retryData = {count: 0};
            } else {
                console.log("httpSend second call " + options.path);
            }
            if(isEmpty(options.path.apiId)){
                options.path.apiId=null;
            }
            var sendData = isEmpty(options.path.apiId)?options.sendData:$.extend(options.sendData, {apiId: options.path.apiId})|| {};
            M.net.http.send({
                method: options.method,
                server: CONSTANT.SEND_SERVER,		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
                path: options.path.url,
                timeout: options.timeout || 30000,   //[KIAVIK-458] default time 수정 211006 보유차량이 많은 경우 조회실패가 되는 경우가 있어 운영 15000 > 30000 으로 변경
                data: sendData,
                userData: PGV.loginInfo ? {pKey: PGV.loginInfo.pKey} : {},		// 20201015 p_key 헤더에 추가
                indicator: {
                    show: false
                },
                success: function (receivedData, setting) {
                    var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));

                    // 로그인 정보
                    // if(options.path == "member/login" && receivedData.resultCode == "200" && receivedData.pwStCcd != "2"){
                    // 	PGV.loginInfo = receivedData;	//전역변수에저장
                    // 	MData.global('loginInfo', PGV.loginInfo);

                    // 	// 로그인 후 로그인 페이지 남아 있을 경우 삭제
                    // 	stackRemove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
                    // }
                    // 추후 공통처리가 필요한 경우 해당 부분에 처리
                    //test code
                    //cleanXSSData.errorCode = "";
                    //cleanXSSData.errorMsg = "";
                    if (!isEmpty(cleanXSSData.errorCode) && !isEmpty(cleanXSSData.errorMsg)) {
                        if (cleanXSSData.errorCode == "500" && cleanXSSData.errorMsg.indexOf("Server Error!") > -1 && options.retryData.count == 0) {
                            console.log("retry count options:" + options.path.url + ", receivedData=" + receivedData);
                            options.retryData.count = 1;
                            MNet.httpSend(options);
                            return;
                        }
                        exWNHideIndicator();
                        //KIAVIK-356 error log
                        sendSentryApiErrorLog(options.path.url, cleanXSSData.errorCode, cleanXSSData.errorMsg, options.sendData);
                        console.log("network error: code=" + receivedData.errorCode + ", msg=" + receivedData.errorMsg + ", path=" + options.path.url);
                        if (options.errorCallback) {
                            options.errorCallback(cleanXSSData.errorCode, cleanXSSData.errorMsg);
                        } else {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    } else {
                        if (options.callback) {
                            options.callback(cleanXSSData);
                        }
                    }

                },

                error: function (errorCode, errorMessage, setting) {
                    exWNHideIndicator();

                    //405 : param error , 408 : p_key error
                    //TODO
                    //사용자 알림 추가 필요~~
                    if (errorCode == 405 || errorCode == 408) {
                        sendSentryApiPkeyErrorLog(options.path.url, errorCode, errorMessage, options.sendData, PGV.loginInfo ? PGV.loginInfo.pKey : "empty");
                        //[KIAVIK-398] pkey error 예외처리
                        if (errorCode == 405) {
                            //초기화 이후 팝업 노출.
                            M.data.removeGlobal("loginMain");
                            M.data.removeGlobal("loginCarList");
                            M.data.removeGlobal("loginNoti");
                            M.data.removeGlobal("loginLuxury");
                            //로그인 정보 초기화
                            MData.removeStorage("accessToken");
                            MData.removeStorage("PUSH_ALARM_CHECK");
                            M.net.cookie.clear();

                            MData.removeGlobal('loginInfo');
                            PGV.loginInfo = '';

                            MPopup.alert({
                                message: "로그인 정보가 변경되어 재로그인이 필요합니다.",
                                buttons: ["확인"],
                                callback: function (idx) {
                                    //일단 무조건 현재 페이지로.
                                    var _page = PGV.currentPage;
                                    var _startIdx = _page.indexOf("_RNW_");
                                    var _returnUrl = "../" + _page.substr(_startIdx + 5, 3) + "/" + _page;
                                    var _params = {};
                                    if (_page.substr(_startIdx + 5, 4) == "1000") {
                                        _returnUrl = "../" + _page.substr(_startIdx + 5, 4) + "/" + _page;
                                    }
                                    var param = {
                                        returnLink: _returnUrl,
                                        returnParams: _params
                                    }
                                    ccspLogin(param);
                                }
                            });
                        } else {
                            //408 error
                            if (!PGV.runningAutoLogin) {
                                console.log("pkey is expired retry autoLogin!(httpSend)");
                                PGV.runningAutoLogin = true;
                                autoLoginFunction(true);
                            } else {
                                console.log("already autoLogin call(by pkey expired");
                            }
                            setTimeout(function () {
                                console.log("retry httpSend");
                                //로그인 정보가 정상적으로 설정 된 경우에만 재시도.
                                if (!isEmpty(PGV.loginInfo)) {
                                    MNet.httpSend(options);
                                }
                            }, CONSTANT.RETRY_LOGIN_TIMEOUT);
                        }

                    } else if ((errorCode == "999" || errorCode == "9996" || errorCode == "9998") && options.retryData.count == 0) {
                        //KIAVIK-356 error log
                        //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        console.log(errorCode + " error retry count options:" + options.path.url);
                        options.retryData.count = 1;
                        MNet.httpSend(options);
                        return;
                    } else {
                        //KIAVIK-356 error log
                        sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        // 추후 공통처리가 필요한 경우 해당 부분에 처리
                        if (options.errorCallback) {
                            options.errorCallback(errorCode, errorMessage);
                        } else {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    }
                    console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path.url);
                }
            });
        }
    },
    /* asis api 용 : sync, 콜백함수 실행  , path에 url 자체를 넘김 */
    httpSendAsIs: function (options) {
        if(options.isMock&&CONSTANT.IS_SVR_REF_MOCK){
            var apiId = !isEmpty(options.path.apiId)?options.path.apiId:options.sendData.apiId;
            if(isEmpty(apiId)){
                var arr = options.path.split("/");
                apiId = arr[arr.length-1];
            }
            try {
                var response = _MOCK_RES[apiId].response.body;
                options.callback(response);
            }catch(e){
                COMMON_FUNCTION.TOOL.DEBUG.showTalk( e);
                options.callback({"resultCode":"5000","resultMsg":"Mock check"});
            }
        }else{
            if (options.indicatorYn != "N") {
                exWNShowIndicator();
            }
            if (isEmpty(options.retryData)) {
                options.retryData = {count: 0};
            } else {
                console.log("httpSend second call " + options.path);
            }
            if(isEmpty(options.path.apiId)){
                options.path.apiId=null;
            }
            var path = options.path;
            if(typeof path == 'object'){
                if(!isEmpty(path.url))path = path.url;
            }




            M.net.http.send({
                server: CONSTANT.SEND_SERVER,		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
                path: path,
                timeout: options.timeout || 30000,   //[KIAVIK-458] default time 수정 211006 보유차량이 많은 경우 조회실패가 되는 경우가 있어 운영 15000 > 30000 으로 변경
                data: options.sendData || {},
                userData: PGV.loginInfo ? {pKey: PGV.loginInfo.pKey} : {},		// 20201015 p_key 헤더에 추가
                indicator: {
                    show: false
                },

                success: function (receivedData, setting) {
                    COMMON_FUNCTION.TOOL.DEBUG.showTalk("from : " + options.path.url);
                    COMMON_FUNCTION.TOOL.DEBUG.showTalk(receivedData);
                    var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));

                    // 로그인 정보
                    // if(options.path == "member/login" && receivedData.resultCode == "200" && receivedData.pwStCcd != "2"){
                    // 	PGV.loginInfo = receivedData;	//전역변수에저장
                    // 	MData.global('loginInfo', PGV.loginInfo);

                    // 	// 로그인 후 로그인 페이지 남아 있을 경우 삭제
                    // 	stackRemove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
                    // }
                    // 추후 공통처리가 필요한 경우 해당 부분에 처리
                    //test code
                    //cleanXSSData.errorCode = "";
                    //cleanXSSData.errorMsg = "";
                    if (!isEmpty(cleanXSSData.errorCode) && !isEmpty(cleanXSSData.errorMsg)) {
                        if (cleanXSSData.errorCode == "500" && cleanXSSData.errorMsg.indexOf("Server Error!") > -1 && options.retryData.count == 0) {
                            console.log("retry count options:" + options.path + ", receivedData=" + receivedData);
                            options.retryData.count = 1;
                            MNet.httpSendAsIs(options);
                            return;
                        }
                        exWNHideIndicator();
                        //KIAVIK-356 error log
                        sendSentryApiErrorLog(options.path, cleanXSSData.errorCode, cleanXSSData.errorMsg, options.sendData);
                        console.log("network error: code=" + receivedData.errorCode + ", msg=" + receivedData.errorMsg + ", path=" + options.path);
                        if (options.errorCallback) {
                            options.errorCallback(cleanXSSData.errorCode, cleanXSSData.errorMsg);
                        } else {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    } else {
                        if (options.callback) {
                            options.callback(cleanXSSData);
                        }
                    }

                },

                error: function (errorCode, errorMessage, setting) {
                    exWNHideIndicator();

                    //405 : param error , 408 : p_key error
                    //TODO
                    //사용자 알림 추가 필요~~
                    if (errorCode == 405 || errorCode == 408) {
                        sendSentryApiPkeyErrorLog(options.path, errorCode, errorMessage, options.sendData, PGV.loginInfo ? PGV.loginInfo.pKey : "empty");
                        //[KIAVIK-398] pkey error 예외처리
                        if (errorCode == 405) {
                            //초기화 이후 팝업 노출.
                            M.data.removeGlobal("loginMain");
                            M.data.removeGlobal("loginCarList");
                            M.data.removeGlobal("loginNoti");
                            M.data.removeGlobal("loginLuxury");
                            //로그인 정보 초기화
                            MData.removeStorage("accessToken");
                            MData.removeStorage("PUSH_ALARM_CHECK");
                            M.net.cookie.clear();

                            MData.removeGlobal('loginInfo');
                            PGV.loginInfo = '';

                            MPopup.alert({
                                message: "로그인 정보가 변경되어 재로그인이 필요합니다.",
                                buttons: ["확인"],
                                callback: function (idx) {
                                    //일단 무조건 현재 페이지로.
                                    var _page = PGV.currentPage;
                                    var _startIdx = _page.indexOf("_RNW_");
                                    var _returnUrl = "../" + _page.substr(_startIdx + 5, 3) + "/" + _page;
                                    var _params = {};
                                    if (_page.substr(_startIdx + 5, 4) == "1000") {
                                        _returnUrl = "../" + _page.substr(_startIdx + 5, 4) + "/" + _page;
                                    }
                                    var param = {
                                        returnLink: _returnUrl,
                                        returnParams: _params
                                    }
                                    ccspLogin(param);
                                }
                            });
                        } else {
                            //408 error
                            if (!PGV.runningAutoLogin) {
                                console.log("pkey is expired retry autoLogin!(httpSend)");
                                PGV.runningAutoLogin = true;
                                autoLoginFunction(true);
                            } else {
                                console.log("already autoLogin call(by pkey expired");
                            }
                            setTimeout(function () {
                                console.log("retry httpSend");
                                //로그인 정보가 정상적으로 설정 된 경우에만 재시도.
                                if (!isEmpty(PGV.loginInfo)) {
                                    MNet.httpSendAsIs(options);
                                }
                            }, CONSTANT.RETRY_LOGIN_TIMEOUT);
                        }

                    } else if ((errorCode == "999" || errorCode == "9996" || errorCode == "9998") && options.retryData.count == 0) {
                        //KIAVIK-356 error log
                        //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        console.log(errorCode + " error retry count options:" + options.path);
                        options.retryData.count = 1;
                        MNet.httpSendAsIs(options);
                        return;
                    } else {
                        //KIAVIK-356 error log
                        sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        // 추후 공통처리가 필요한 경우 해당 부분에 처리
                        if (options.errorCallback) {
                            options.errorCallback(errorCode, errorMessage);
                        } else {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    }
                    console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
                }
            });
        }
    },
    /* 케이스마텍 추헌남 - Promise httpSend 작성 */
    /* rnw api 용 : sync, 결과값을 리턴 */
    httpSendAsync: function (options) {
        return new Promise(function (resolve, reject) {
            if(!isEmpty(options.path.url) && options.path.url.indexOf('rnw/')!==0){
                /** as-is Api */
                MNet.httpSendAsyncAsIs(options)
                    .then(resolve);
            }else{
                if (options.indicatorYn != "N") {
                    exWNShowIndicator();
                }
                if (isEmpty(options.retryData)) {
                    options.retryData = {count: 0};
                } else {
                    console.log("httpSend second call " + options.path);
                }

                // 케이스마텍 추헌남 - MOCKUP API용일 경우의 MockupAPIResponseProvider resolve
                if (options.isMock&&CONSTANT.IS_SVR_REF_MOCK) {
                    MockupAPIResponseProvider(options.path, options.isMock.delay, options.isMock.isToReject)
                        .then(function (response){
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("from : " + options.path.url);
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk(response);
                            if (options.indicatorYn != "N") {
                                exWNHideIndicator();
                            }
                            if (response.body) {
                                resolve(response.body);
                            } else {
                                resolve(response);
                            }
                        });
                }else{
                    if(isEmpty(options.path.apiId)){
                        console.error("path.apiId empty");
                    }

                    if(!isEmpty(options.path.apiId)){
                        if(!options){
                            options = {}
                        }
                        if(!options.sendData){
                            options["sendData"] = {}
                        }
                        if(!options.sendData.apiId){
                            options.sendData["apiId"] = null;
                        }
                        options.sendData.apiId = options.path.apiId;
                    }
                    M.net.http.send({
                        server: CONSTANT.SEND_SERVER,		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
                        path: options.path.url,
                        timeout: options.timeout || 30000,   //[KIAVIK-458] default time 수정 211006 보유차량이 많은 경우 조회실패가 되는 경우가 있어 운영 15000 > 30000 으로 변경
                        data: options.sendData,
                        userData: PGV.loginInfo ? {pKey: PGV.loginInfo.pKey} : {},		// 20201015 p_key 헤더에 추가
                        indicator: {
                            show: false
                        },

                        success: function (receivedData, setting) {
                            var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("from : " + options.path.url);
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk(receivedData);
                            // 로그인 정보
                            // if(options.path == "member/login" && receivedData.resultCode == "200" && receivedData.pwStCcd != "2"){
                            // 	PGV.loginInfo = receivedData;	//전역변수에저장
                            // 	MData.global('loginInfo', PGV.loginInfo);

                            // 	// 로그인 후 로그인 페이지 남아 있을 경우 삭제
                            // 	stackRemove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
                            // }
                            // 추후 공통처리가 필요한 경우 해당 부분에 처리
                            //test code
                            //cleanXSSData.errorCode = "";
                            //cleanXSSData.errorMsg = "";
                            if (!isEmpty(cleanXSSData.errorCode) && !isEmpty(cleanXSSData.errorMsg)) {
                                if (cleanXSSData.errorCode == "500" && cleanXSSData.errorMsg.indexOf("Server Error!") > -1 && options.retryData.count == 0) {
                                    console.log("retry count options:" + options.path.url + ", receivedData=" + receivedData);
                                    options.retryData.count = 1;
                                    MNet.httpSendAsync(options);
                                    return;
                                }
                                exWNHideIndicator();
                                //KIAVIK-356 error log
                                sendSentryApiErrorLog(options.path, cleanXSSData.errorCode, cleanXSSData.errorMsg, options.sendData);
                                console.log("network error: code=" + receivedData.errorCode + ", msg=" + receivedData.errorMsg + ", path=" + options.path.url);

                                //케이스마텍 추헌남 - 여기부터 아래까지 수정하였습니다.
                                if (options.errorPopupEnabled) MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                                if (cleanXSSData.errorCode && cleanXSSData.errorMsg) reject(cleanXSSData.errorCode, cleanXSSData.errorMsg);
                                resolve(cleanXSSData);
                            }
                            else{
                                resolve(cleanXSSData);
                            }
                        },

                        error: function (errorCode, errorMessage, setting) {
                            exWNHideIndicator();

                            //405 : param error , 408 : p_key error
                            //TODO
                            //사용자 알림 추가 필요~~
                            if (errorCode == 405 || errorCode == 408) {
                                sendSentryApiPkeyErrorLog(options.path.url, errorCode, errorMessage, options.sendData, PGV.loginInfo ? PGV.loginInfo.pKey : "empty");
                                //[KIAVIK-398] pkey error 예외처리
                                if (errorCode == 405) {
                                    //초기화 이후 팝업 노출.
                                    M.data.removeGlobal("loginMain");
                                    M.data.removeGlobal("loginCarList");
                                    M.data.removeGlobal("loginNoti");
                                    M.data.removeGlobal("loginLuxury");
                                    //로그인 정보 초기화
                                    MData.removeStorage("accessToken");
                                    MData.removeStorage("PUSH_ALARM_CHECK");
                                    M.net.cookie.clear();

                                    MData.removeGlobal('loginInfo');
                                    PGV.loginInfo = '';

                                    MPopup.alert({
                                        message: "로그인 정보가 변경되어 재로그인이 필요합니다.",
                                        buttons: ["확인"],
                                        callback: function (idx) {
                                            //일단 무조건 현재 페이지로.
                                            var _page = PGV.currentPage;
                                            var _startIdx = _page.indexOf("_RNW_");
                                            var _returnUrl = "../" + _page.substr(_startIdx + 5, 3) + "/" + _page;
                                            var _params = {};
                                            if (_page.substr(_startIdx + 5, 4) == "1000") {
                                                _returnUrl = "../" + _page.substr(_startIdx + 5, 4) + "/" + _page;
                                            }
                                            var param = {
                                                returnLink: _returnUrl,
                                                returnParams: _params
                                            }
                                            ccspLogin(param);
                                        }
                                    });
                                } else {
                                    //408 error
                                    if (!PGV.runningAutoLogin) {
                                        console.log("pkey is expired retry autoLogin!(httpSend)");
                                        PGV.runningAutoLogin = true;
                                        autoLoginFunction(true);
                                    } else {
                                        console.log("already autoLogin call(by pkey expired");
                                    }
                                    setTimeout(function () {
                                        console.log("retry httpSend");
                                        //로그인 정보가 정상적으로 설정 된 경우에만 재시도.
                                        if (!isEmpty(PGV.loginInfo)) {
                                            MNet.httpSendAsync(options);
                                        }
                                    }, CONSTANT.RETRY_LOGIN_TIMEOUT);
                                }
                            }
                            else if ((errorCode == "999" || errorCode == "9996" || errorCode == "9998") && options.retryData.count == 0) {
                                //KIAVIK-356 error log
                                //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                                COMMON_FUNCTION.TOOL.DEBUG.showTalk(params);
                                console.log(errorCode + " error retry count options:" + options.path.url);
                            //     options.retryData.count = 1;
                            //     MNet.httpSendAsync(options); //async의 경우 리트라이는 개별 로직으로 수행하기.
                            // }
                            // else {
                                if(CONFIG.IS_DEV&&isEmpty(options.path.apiId)&&errorCode =="400"){
                                    console.error("errorCode : "+errorCode+"- "+errorMessage+", AS-IS API 요청불가");
                                }
                                //KIAVIK-356 error log
                                sendSentryApiErrorLog(options.path.url, errorCode, errorMessage, options.sendData);
                                // 추후 공통처리가 필요한 경우 해당 부분에 처리
                                //케이스마텍 추헌남 - 여기부터 아래까지 수정하였습니다.
                                if (options.errorPopupEnabled) MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                                if (errorCode && errorMessage) {
                                    var errorObject = {"errorCode": errorCode, "errorMessage": errorMessage};
                                    resolve(errorObject);
                                } else {
                                    resolve({"errorCode": "notDefined", "errorMessage": "notDefined"});
                                }
                            }
                        }
                    });
                }

            }

        });
    },
    /** 22.3.14 서버side as-is api & tobe api 병행 사용결정에 따라  */
    /* asis api 용 : sync, 결과값을 리턴 */
    httpSendAsyncAsIs: function (options) {
        return new Promise(function (resolve, reject) {
            if (options.indicatorYn != "N") {
                exWNShowIndicator();
            }
            if (isEmpty(options.retryData)) {
                options.retryData = {count: 0};
            } else {
                console.log("httpSend second call " + options.path);
            }

            // 케이스마텍 추헌남 - MOCKUP API용일 경우의 MockupAPIResponseProvider resolve
            if (!isEmpty(options.isMock)&&CONSTANT.IS_SVR_REF_MOCK) {//가끔 통신장애가 발생해서.
                MockupAPIResponseProvider(options.path, options.isMock.delay, options.isMock.isToReject)
                    .then(function (response){
                        exWNHideIndicator();
                        if (response.body) {
                            resolve(response.body);
                        } else {
                            resolve(response);
                        }
                    });
            }else{
                console.log("as is api may not have mock response");
                if(isEmpty(options.path.apiId)){
                    options.path.apiId=null;
                }
                var sendData = isEmpty(options.path.apiId)?options.sendData:$.extend(options.sendData, {apiId: options.path.apiId})|| {};
                M.net.http.send({
                    server: CONSTANT.SEND_SERVER,		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
                    path: typeof options.path.url === "string" ? options.path.url : options.path,
                    timeout: options.timeout || 30000,   //[KIAVIK-458] default time 수정 211006 보유차량이 많은 경우 조회실패가 되는 경우가 있어 운영 15000 > 30000 으로 변경
                    data: sendData,
                    userData: PGV.loginInfo ? {pKey: PGV.loginInfo.pKey} : {},		// 20201015 p_key 헤더에 추가
                    indicator: {
                        show: false
                    },

                    success: function (receivedData, setting) {
                        COMMON_FUNCTION.TOOL.DEBUG.showTalk("from : " + (typeof options.path.url === "string" ? options.path.url : options.path));
                        COMMON_FUNCTION.TOOL.DEBUG.showTalk(receivedData);
                        var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                        if (!isEmpty(cleanXSSData.errorCode) && !isEmpty(cleanXSSData.errorMsg)) {
                            if (cleanXSSData.errorCode == "500" && cleanXSSData.errorMsg.indexOf("Server Error!") > -1 && options.retryData.count == 0) {
                                console.log("retry count options:" + options.path + ", receivedData=" + receivedData);
                                options.retryData.count = 1;
                                MNet.httpSendAsyncAsIs(options);
                                return;
                            }
                            if (options.indicatorYn != "N") {
                                exWNHideIndicator();
                            }
                            //KIAVIK-356 error log
                            sendSentryApiErrorLog(options.path, cleanXSSData.errorCode, cleanXSSData.errorMsg, options.sendData);
                            console.log("network error: code=" + receivedData.errorCode + ", msg=" + receivedData.errorMsg + ", path=" + options.path);

                            //케이스마텍 추헌남 - 여기부터 아래까지 수정하였습니다.
                            if (options.errorPopupEnabled) MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                            if (cleanXSSData.errorCode && cleanXSSData.errorMsg) reject(cleanXSSData.errorCode, cleanXSSData.errorMsg);
                            resolve(cleanXSSData);
                        }else{
                            resolve(cleanXSSData);
                        }
                    },

                    error: function (errorCode, errorMessage, setting) {
                        if (options.indicatorYn != "N") {
                            exWNHideIndicator();
                        }

                        //405 : param error , 408 : p_key error
                        //TODO
                        //사용자 알림 추가 필요~~
                        if (errorCode == 405 || errorCode == 408) {
                            sendSentryApiPkeyErrorLog(options.path, errorCode, errorMessage, options.sendData, PGV.loginInfo ? PGV.loginInfo.pKey : "empty");
                            //[KIAVIK-398] pkey error 예외처리
                            if (errorCode == 405) {
                                //초기화 이후 팝업 노출.
                                M.data.removeGlobal("loginMain");
                                M.data.removeGlobal("loginCarList");
                                M.data.removeGlobal("loginNoti");
                                M.data.removeGlobal("loginLuxury");
                                //로그인 정보 초기화
                                MData.removeStorage("accessToken");
                                MData.removeStorage("PUSH_ALARM_CHECK");
                                M.net.cookie.clear();

                                MData.removeGlobal('loginInfo');
                                PGV.loginInfo = '';

                                MPopup.alert({
                                    message: "로그인 정보가 변경되어 재로그인이 필요합니다.",
                                    buttons: ["확인"],
                                    callback: function (idx) {
                                        //일단 무조건 현재 페이지로.
                                        var _page = PGV.currentPage;
                                        var _startIdx = _page.indexOf("_RNW_");
                                        var _returnUrl = "../" + _page.substr(_startIdx + 5, 3) + "/" + _page;
                                        var _params = {};
                                        if (_page.substr(_startIdx + 5, 4) == "1000") {
                                            _returnUrl = "../" + _page.substr(_startIdx + 5, 4) + "/" + _page;
                                        }
                                        var param = {
                                            returnLink: _returnUrl,
                                            returnParams: _params
                                        }
                                        ccspLogin(param);
                                    }
                                });
                            } else {
                                //408 error
                                if (!PGV.runningAutoLogin) {
                                    console.log("pkey is expired retry autoLogin!(httpSend)");
                                    PGV.runningAutoLogin = true;
                                    autoLoginFunction(true);
                                } else {
                                    console.log("already autoLogin call(by pkey expired");
                                }
                                setTimeout(function () {
                                    console.log("retry httpSend");
                                    //로그인 정보가 정상적으로 설정 된 경우에만 재시도.
                                    if (!isEmpty(PGV.loginInfo)) {
                                        MNet.httpSendAsync(options);
                                    }
                                }, CONSTANT.RETRY_LOGIN_TIMEOUT);
                            }

                        } else if ((errorCode == "999" || errorCode == "9996" || errorCode == "9998") && options.retryData.count == 0) {
                            //KIAVIK-356 error log
                            //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                            console.log(errorCode + " error retry count options:" + options.path);
                            options.retryData.count = 1;
                            MNet.httpSendAsync(options);
                            return;
                        } else {
                            //KIAVIK-356 error log
                            sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                            // 추후 공통처리가 필요한 경우 해당 부분에 처리
                            //케이스마텍 추헌남 - 여기부터 아래까지 수정하였습니다.
                            if (options.errorPopupEnabled) MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                            if (errorCode && errorMessage) {
                                reject(errorCode, errorMessage);
                            } else {
                                resolve({errorCode: errorCode, errorMessage: errorMessage});
                            }
                        }
                        console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);

                    }
                });
            }

        })
    },
    upload: function (options) {
        //if(MInfo.device().os.name != "pc"){
        if (PGV.device.os.name != 'pc') {
            exWNShowIndicator();
        }
        M.net.http.upload({
            url: CONSTANT.IMG_URL_PREFIX + "/api/" + options.path,		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
            headers: {},           //"content-type" : "multipart/form-data;charset=utf-8","User-Agent" : "Tridentr"
            params: options.sendData,
            body: options.files || [],
            encoding: 'UTF-8',
            timeout: options.timeout || 20000,			// 추후 기본 값 변경
            indicator: {
                show: false
            },
            finish: function (statusCd, header, body, status, errMsg, setting) {
                if (statusCd == -1) {
                    MPopup.alert('네트워크 연결 시 문제가 발생하였습니다. 잠시 후 다시 시도해 주십시오.');
                    exWNHideIndicator();
                    return false;
                }

                receivedData = JSON.parse(body);
                var code = receivedData.head.resultCode;
                var msg = receivedData.head.resultMsg;
                if (code == "200") {
                    options.callback(receivedData.body);
                } else {
                    exWNHideIndicator();
                    MPopup.alert(msg);
                }

            },
            progress: function (total, current) {
            }
        });
    }
};

var MNet_Hub = {
    httpSend: function (options) {
        if (options.indicatorYn != "N") {
            exWNShowIndicator();
        }

        var timer = setTimeout(function(){
            exWNHideIndicator();
            sendSentryApiCCSErrorLog(options.path, "timeout", "timeout", "", options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
            resolve({errorCode: "timeout", errorMessage: "timeout"});
        } , 6000);

        M.net.http.send({
            server: CONFIG.IS_DEV ? "HTTP_DATA_HUB_DEV" : "HTTP_DATA_HUB_REAL",
            path: options.path,
            method: options.method,
            //timeout: options.timeout || CONFIG.IS_DEV ? "HTTP_DATA_HUB_DEV" : "HTTP_DATA_HUB_REAL",
            
            //임시코드 추후에 앱 업데이트시 해당사항 적용해서 배포
            timeout: options.timeout || 5000,
            data: options.sendData || {},
            userData: PGV.loginInfo ? {accessToken: PGV.loginInfo.accessToken, commonRest: true} : {commonRest: true},
            indicator: {
                show: false
            },

            success: function (receivedData, setting) {
                clearTimeout(timer);
                var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                if (Object.keys(receivedData).length == 0) {
                    cleanXSSData = "";
                }

                if (options.callback) {
                    options.callback(cleanXSSData);
                }
            },

            error: function (errorCode, errorMessage, setting) {
                clearTimeout(timer);
                exWNHideIndicator();
                var isSend = true;
                if (options.path.includes("ismaster")) {
                    //UVO 미창작 차량의 경우 보통 4002 CCS 정확히 답변 못받음.
                    //로그가 많이 남을것을 예상하여 예외처리.
                    if (!isEmpty(errorMessage.errCode) && errorMessage.errCode == 4002) {
                        isSend = false;
                    }
                } else if (!isEmpty(errorCode) && errorCode == 404) {
                    //CCS 4045 error가 너무 많이 발생. 임시로 404 에러 예외처리.
                    //원칙은 native에서 예외처리를 해야함.
                    isSend = false;
                }

                if (isSend) {
                    sendSentryApiCCSErrorLog(options.path, errorCode, errorMessage, options.backup, options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
                }
                //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                // 추후 공통처리가 필요한 경우 해당 부분에 처리
                if (options.errorCallback) {
                    options.errorCallback(errorCode, errorMessage);
                } else {
                    MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                }

                console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
            }
        });
    },
    /* 케이스마텍 추헌남 - Promise httpSend 작성 */
    httpSendAsync: function (options) {
        return new Promise(function (resolve, reject) {
            if (options.indicatorYn != "N") {
                exWNShowIndicator();
            }
            //dhyang
            //console.log("accesstoken:" + PGV.loginInfo.accessToken);

            // 케이스마텍 추헌남 - MOCKUP API용일 경우의 MockupAPIResponseProvider resolve
            if (options.isMock&&CONSTANT.IS_HUB_REF_MOCK) {
                MockupAPIResponseProvider(options.path, options.isMock.delay, options.isMock.isToReject)
                    .then(function (response){
                        if (options.indicatorYn != "N") {
                            exWNHideIndicator();
                        }
                        if (response.body) {
                            resolve(response.body);
                        } else {
                            resolve(response);
                        }
                    });
            }else{

                var timer = setTimeout(function(){
                    exWNHideIndicator();
                    sendSentryApiCCSErrorLog(options.path, "timeout", "timeout", "", options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
                    resolve({errorCode: "timeout", errorMessage: "timeout"});
                } , 6000);


                M.net.http.send({
                    server: CONFIG.IS_DEV ? "HTTP_DATA_HUB_DEV" : "HTTP_DATA_HUB_REAL",
                    path: options.path,
                    method: options.method,
//                    timeout: options.timeout || CONFIG.IS_DEV ? "HTTP_DATA_HUB_DEV" : "HTTP_DATA_HUB_REAL",
                    //임시코드 추후에 앱 업데이트시 해당사항 적용해서 배포
                    timeout: options.timeout || 5000,
                    data: options.sendData || {},
                    userData: PGV.loginInfo ? {
                        accessToken: PGV.loginInfo.accessToken,
                        commonRest: true
                    } : {commonRest: true},
                    indicator: {
                        show: false
                    },

                    success: function (receivedData, setting) {
                        clearTimeout(timer);
                        var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                        if (Object.keys(receivedData).length == 0) {
                            cleanXSSData = "";
                        }

                        resolve(cleanXSSData);
                    },

                    error: function (errorCode, errorMessage, setting) {
                        exWNHideIndicator();
                        clearTimeout(timer);
                        var isSend = true;
                        if (options.path.indexOf("ismaster") > -1) {
                            //UVO 미창작 차량의 경우 보통 4002 CCS 정확히 답변 못받음.
                            //로그가 많이 남을것을 예상하여 예외처리.
                            if (!isEmpty(errorMessage.errCode) && errorMessage.errCode == 4002) {
                                isSend = false;
                            }
                        } else if (!isEmpty(errorCode) && errorCode == 404) {
                            //CCS 4045 error가 너무 많이 발생. 임시로 404 에러 예외처리.
                            //원칙은 native에서 예외처리를 해야함.
                            isSend = false;
                        }

                        if (isSend) {
                            sendSentryApiCCSErrorLog(options.path, errorCode, errorMessage, options.backup, options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
                        }
                        //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        // 추후 공통처리가 필요한 경우 해당 부분에 처리

                        //케이스마텍 추헌남 - 여기부터 아래까지 수정하였습니다.

                        console.log("Error Path : " + options.path );
                        console.log("Error errorCode : " + errorCode );
                        console.log("Error errorMessage : " + errorMessage );
                        if (options.errorPopupEnabled) {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                        if (errorCode && errorMessage) {
                            resolve({errorCode: errorCode, errorMessage: errorMessage});
                        } else {
                            resolve({errorCode: errorCode, errorMessage: errorMessage});
                        }

                    }
                });
            }
        })
    }
};

var MNet_DKC = {
    httpSend: function (options) {
        if (options.indicatorYn != "N") {
            exWNShowIndicator();
        }
        //dhyang
        //console.log("accesstoken:" + PGV.loginInfo.accessToken);

        M.net.http.send({
            server: CONFIG.IS_DEV ? "HTTP_DKC_DEV" : "HTTP_DKC_REAL",
            path: options.path,
            method: options.method,
            timeout: options.timeout || (CONFIG.IS_DEV ? 30000 : 10000),
            data: options.sendData || {},
            userData: PGV.loginInfo ? {
                accessKey: CONSTANT.DKC_ACCESS_KEY,
                channel: "VIK",
                commonRest: true
            } : {commonRest: true},
            indicator: {
                show: false
            },

            success: function (receivedData, setting) {
                var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                console.log("mcore_api.js dkc httpsend success", cleanXSSData);
                if (Object.keys(receivedData).length == 0) {
                    cleanXSSData = "";
                }

                if (options.callback) {
                    options.callback(cleanXSSData);
                }
            },

            error: function (errorCode, errorMessage, setting) {
                exWNHideIndicator();
                console.log("mcore_api.js dkc httpsend error", errorCode, errorMessage, setting);
                var isSend = true;
                /*if (options.path.includes("ismaster")) {
                    //UVO 미창작 차량의 경우 보통 4002 CCS 정확히 답변 못받음.
                    //로그가 많이 남을것을 예상하여 예외처리.
                    if (!isEmpty(errorMessage.errCode) && errorMessage.errCode == 4002) {
                        isSend = false;
                    }
                }*/

                if (isSend) {
                    sendSentryApiCCSErrorLog(options.path, errorCode, errorMessage, options.backup, options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
                }
                //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                // 추후 공통처리가 필요한 경우 해당 부분에 처리
                if (options.errorCallback) {
                    options.errorCallback(errorCode, errorMessage);
                } else {
                    MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                }

                console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
            }
        });
    },
    /* 케이스마텍 추헌남 - Promise httpSend 작성 */
    httpSendAsync: function (options) {
        return new Promise(function (resolve, reject) {
            if (options.indicatorYn != "N") {
                exWNShowIndicator();
            }
            //dhyang
            //console.log("accesstoken:" + PGV.loginInfo.accessToken);

            // 케이스마텍 추헌남 - MOCKUP API용일 경우의 MockupAPIResponseProvider resolve
            if (options.isMock) {
                MockupAPIResponseProvider(options.path, options.isMock.delay, options.isMock.isToReject).then(function (response) {
                    exWNHideIndicator();
                    resolve(response);
                });
            }else{
                M.net.http.send({
                    server: CONFIG.IS_DEV ? "HTTP_DKC_DEV" : "HTTP_DKC_REAL",
                    path: options.path,
                    method: options.method,
                    timeout: options.timeout || (CONFIG.IS_DEV ? 30000 : 10000),
                    data: options.sendData || {},
                    userData: PGV.loginInfo ? {
                        accessKey: CONSTANT.DKC_ACCESS_KEY,
                        channel: "VIK",
                        commonRest: true
                    } : {commonRest: true},
                    indicator: {
                        show: false
                    },

                    success: function (receivedData, setting) {
                        var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                        console.log("mcore_api.js dkc httpsend success", cleanXSSData);
                        if (Object.keys(receivedData).length == 0) {
                            cleanXSSData = "";
                        }

                        resolve(cleanXSSData);
                    },

                    error: function (errorCode, errorMessage, setting) {
                        exWNHideIndicator();
                        console.log("mcore_api.js dkc httpsend error", errorCode, errorMessage, setting);
                        var isSend = true;
                        /*if (options.path.includes("ismaster")) {
                            //UVO 미창작 차량의 경우 보통 4002 CCS 정확히 답변 못받음.
                            //로그가 많이 남을것을 예상하여 예외처리.
                            if (!isEmpty(errorMessage.errCode) && errorMessage.errCode == 4002) {
                                isSend = false;
                            }
                        }*/

                        if (isSend) {
                            sendSentryApiCCSErrorLog(options.path, errorCode, errorMessage, options.backup, options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
                        }
                        //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        // 추후 공통처리가 필요한 경우 해당 부분에 처리
                        //케이스마텍 추헌남 - 여기부터 아래까지 수정하였습니다.
                        if (options.errorPopupEnabled) MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        if (errorCode && errorMessage) {
                            reject({errorCode: errorCode, errorMessage: errorMessage});
                        } else {
                            resolve({errorCode: errorCode, errorMessage: errorMessage});
                        }

                        console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
                    }
                });
            }

        })
    }
};

var MPopup = {
    alert: function (options) {
        if (typeof options == "string") {
            M.pop.alert({
                title: "알림",
                message: options,
                buttons: ["확인"],
                callback: function (idx) {
                    if (options.callback) {
                        options.callback(idx);
                    }
                }
            });
        } else {
            M.pop.alert({
                title: options.title || "알림",
                message: options.message || "",
                buttons: options.buttons || ["확인"],
                callback: function (idx) {
                    if (options.callback) {
                        options.callback(idx);
                    }
                }
            });
        }

    },

    confirm: function (options) {
        M.pop.alert({
            title: options.title || "알림",
            message: options.message || "",
            buttons: options.buttons || ["취소", "확인"],
            callback: function (idx) {
                if (options.callback) {
                    options.callback(idx);
                }
            }
        });
    },

    date: function (options, callback) {
        M.pop.date({
            type: options.type || "YMD",
            initDate: options.initDate || moment().format("YYYYMMDD"),
            startDate: options.startDate || "19000101",
            endDate: options.endDate || "21001231",
            minDate: options.minDate || "19000101",
            maxDate: options.maxDate || "21001231",
        }, function (result, setting) {
            if (callback) {
                callback(result, setting);
            }
        });
    },

    listSingle: function (options, callback) {
        if (!options.list) {
            this.alert("목록을 세팅해주세요.");
            return;
        }

        M.pop.list({
            mode: "SINGLE",
            title: options.title || "알림",
            buttons: options.buttons || ["취소", "확인"],
            list: options.list || [],
            selected: options.selected || 0
        }, function (buttonIdx, rowInfo, setting) {
            if (callback) {
                callback(buttonIdx, rowInfo, setting);
            }
        });
    },

    listMulti: function (options, callback) {
        if (!options.list) {
            this.alert("목록을 세팅해주세요.");
            return;
        }
        M.pop.list({
            mode: "MULTI",
            title: options.title || "알림",
            buttons: options.buttons || ["취소", "확인"],
            list: options.list || [],
            selected: options.selected || [0]
        }, function (buttonIdx, rowInfo, setting) {
            if (callback) {
                callback(buttonIdx, rowInfo, setting);
            }
        });
    },

    instance: function (param) {
        if (typeof param == "object") {
            M.pop.instance({
                message: param.message,
                time: param.time || "SHORT"
            });
        } else {
            M.pop.instance({
                message: param
            });
        }
    }
};



/** PlayMap 통신 (구) */
var MNet_PlayMap = {
    httpSend : function(options) {
        options.IS_PREVIOUS_VERSION = true;
        MNet_RoutoMap.httpSend(options);
    }
}
/** RoutoMap 통신 (신) 2022 */
var MNet_RoutoMap = {
    httpSend : function(options) {
        //if (options.indicatorYn != "N") {
        exWNShowIndicator();
        //}
        alert('path: ' + options.path);

        var headers = options.userData || {}
        alert('headers: ' + JSON.stringify(headers));

        var params = options.sendData || {}
        alert('params: ' + JSON.stringify(params));

        var mthdString = options.method || CONSTANT.NET_MTHD.POST
        alert('mthdString: ' + mthdString);
        if (mthdString == CONSTANT.NET_MTHD.GET) {
            options.path = options.path + '?' + $.param(params)
        }
        if (options.ajax != true) {
            M.net.http.send({
                server : options.IS_PREVIOUS_VERSION == true ? "HTTP_PLAY_MAP_REAL" : "HTTP_ROUTO_MAP_REAL",
                path : options.path,
                method : mthdString,
                userData: {authCode:CONSTANT.ROUTO_MAP_API_KEY},
                data : params,
                timeout : options.timeout || (CONFIG.IS_DEV ? 150000 : 150000),
                indicator : {
                    show : false
                },
                success : function(receivedData, setting) {
                    var JSONString = JSON.stringify(receivedData);
                    alert(JSONString);
                    exWNHideIndicator();
                    var obj = JSON.parse(JSONString);
                    if (Object.keys(receivedData).length == 0) {
                        obj = "";
                    }
                    if (options.callback) {
                        options.callback(obj);
                    }
                },
                error : function(errorCode, errorMessage, setting) {
                    alert("Routo network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
                    exWNHideIndicator();
                    if (options.errorCallback) {
                        options.errorCallback(errorCode, errorMessage);
                    } else {
                        MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                    }
                }
            });
        } else {
            MNet_RoutoMap.httpSendAsync({method : mthdString,
                sendData: JSON.stringify(params)})
                .then(function(response) {
                    exWNHideIndicator();
                    if (response && response.status == 'success') {
                        var JSONString = JSON.stringify(response);
                        alert(JSONString);
                        var obj = JSON.parse(JSONString);
                        if (Object.keys(receivedData).length == 0) {
                            obj = "";
                        }
                        if (options.callback) {
                            options.callback(obj);
                        }
                    } else {
                        if (options.errorCallback) {
                            options.errorCallback('-1', '해당 Routo/Play Map API 요청에 실패하였습니다.');
                        } else {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    }
                });
        }
    },
    httpSendAsync: function(options){
        return new Promise(function(resolve, reject){
            //if (options.indicatorYn != "N") {
            exWNShowIndicator();
            //}

            var headers = options.userData || {}

            var params = options.sendData || {}
            COMMON_FUNCTION.TOOL.DEBUG.showTalk(params);

            var mthdString = options.method || CONSTANT.NET_MTHD.POST
            alert('method: ' + mthdString);
            if (mthdString == CONSTANT.NET_MTHD.GET) {
                options.path = options.path + '?' + $.param(params)
            }
            M.net.http.send({
                server : options.IS_PREVIOUS_VERSION == true ? "HTTP_PLAY_MAP_REAL" : "HTTP_ROUTO_MAP_REAL",
                path : options.path,
                method : mthdString,
                userData: {authCode:CONSTANT.ROUTO_MAP_API_KEY},
                data : params,
                timeout : options.timeout || (CONFIG.IS_DEV ? 150000 : 150000),
                indicator : {
                    show : false
                },
                success : function(receivedData, setting) {
                    var JSONString = JSON.stringify(receivedData);
                    alert(JSONString);
                    exWNHideIndicator();
                    var obj = JSON.parse(JSONString);
                    if (Object.keys(receivedData).length == 0) {
                        obj = "";
                    }
                    resolve(obj);
                },
                error : function(errorCode, errorMessage, setting) {
                    alert("Routo network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
                    exWNHideIndicator();
                    reject(errorCode, errorMessage);
                    if(options.showPopupOnError) MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                }
            });
        })
    }
};

/**
 * 모피어스 화면 상태 이벤트 공통 영역
 *
 */


M.onReady(function (event) {

    console.log("mcore_api.js > M.onReady()");
    //alert("mcore.api.js> onReady()");
    if (typeof MStatus === "object" && typeof MStatus.onReady == "function") {
        // M.onReady 공통 처리
        PGV = new PGVManager(); //현재화면 글로벌 변수 생성
        PGV.currentPage = MPage.info().currentPage;
        initGoogleAnalytics();

        var routoJsNeedPage = [
            // PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml,
            // PATH_MANAGER.KIA_RNW_120_0000_2.nameWithHtml,
            // PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml,
            PATH_MANAGER.KIA_RNW_123_0000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_242_0000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_242_2000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_243_3000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_243_3100.nameWithHtml,
            PATH_MANAGER.KIA_RNW_580_0000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_583_0000.nameWithHtml,
            ];
        var isRoutoJsNeedPage= false;
        if(routoJsNeedPage.includes(PGV.currentPage)) {
            isRoutoJsNeedPage=true;
            KIA_REMOTE_CDN.injectionRoutoJs();
        }
        var loginData = MData.global('loginInfo');
        if (loginData) {
            PGV.loginInfo = loginData;
            console.log("login");
            // 서버에서 받은 아이디가 있다면 공백 제거 로직 추가
            if (isEmpty(PGV.loginInfo) == false) {
                PGV.loginInfo.mbrId = $.trim(PGV.loginInfo.mbrId);
                //KIAVIK-356 sentry
                //if (typeof Sentry != "undefined") Sentry.setUser({ id: PGV.loginInfo.mbrId });
            }

            /* !!! 케이스마텍 추헌남 - 현재 해당 코드 주석처리 되어 있어 KIA_MOB => KIA__MOB로 바꾸었습니다. */
            // if(PGV.currentPage != "KIA__MOB_000_1300.html"){//로그인페이지 사용x
            //     stackRemove("KIA__MOB_000_1300.html");
            // }
            // if(PGV.currentPage != "KIA__MOB_810_1060.html"){//지문등록 사용x
            //     stackRemove("KIA__MOB_810_1060.html");
            // }
            /* 스플래쉬 닫기 */
            if (PGV.currentPage != PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml) {
                stackRemove(PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml);
            }
            /* 홈 닫기 */
            var homes = [PATH_MANAGER.KIA_RNW_110_0000.nameWithHtml,
                PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml,
                PATH_MANAGER.KIA_RNW_120_0000_2.nameWithHtml,
                PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml];
            if (homes.includes(PGV.currentPage)) {
                for(var i=1;i<homes.length;i++){
                    stackRemove(homes[i]);
                }
            }


            //[KIAVIK-398] 로그인 데이터가 있는경우 pkey 만료 체크
            if (checkPkeyExpired()) {
                console.log("pkey is expired retry autoLogin!(onReady)");
                eventLog("pkey_check", "", "autoLogin");
                autoLoginFunction(true);
                setTimeout(function () {
                    console.log("retry onReady (" + event + ")");
                    onReadyCommon(event);
                }, CONSTANT.RETRY_LOGIN_TIMEOUT);
                return;
            } else {
                eventLog("pkey_check", "", "common");
            }
            // 페이지 별로 공유되는 기초 데이터
            var _passData = M.data.global("passData")||null;
            PGV.passData = _passData;

        } else {
            console.log("before_login");
            //[KIAVIK-388] 비로그인 상태에서 Push 수신 -> 선택 -> 화면 이동 -> backkey
            //intro 대기 상태.
            //비로그인 상태라도 Intro가 남아 있으면 삭제.
            if (PGV.currentPage != PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml) {
                stackRemove(PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml);
            }
            //[KIAVIK-518] 로그인 정보 유실
            var needLogin = LOGIN_PAGE.includes(PGV.currentPage);
            if (needLogin) {
                eventLog("login_info_check", "", "autoLogin");
                autoLoginFunction(true);
                setTimeout(function () {
                    console.log("retry onReady (" + event + ")");
                    onReadyCommon(event);
                }, CONSTANT.RETRY_LOGIN_TIMEOUT);
                return;
            }
        }
        if(isRoutoJsNeedPage){
            var loadCounter = 0;
            var checkRouto = setInterval(function(){
                loadCounter++;
                if (loadCounter === 100) {
                    clearInterval(checkRouto);
                    onReadyCommon(event);
                    console.error("checkRouto function at mcore_api.js : routo 로딩 타임 아웃");
                }
                try {
                    console.log(KIA_ROUTO);
                    /* 2024.05.24 typeof null 도 object 라서 온전히 로딩 되었는지 판단할 수 없음 isEmpty 사용으로 변경 */
                    if (!isEmpty(KIA_ROUTO)) {
                        clearInterval(checkRouto);
                        onReadyCommon(event);
                    }
                } catch (e) {}
            }, 100);
        }else{
            onReadyCommon(event);
        }
    }
});

var onReadyCommon = function (event) {
    /*    if(PGV.currentPage == PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml){
            PGV.loginInfo = {};
        }*/
    if (MData.param('needGc') == 'Y') {	//garbageCollector가 필요한 페이지 일 경우 garbageCollector호출
        garbageCollector();
        MData.removeParam('needGc');
    }

    // 공통 이벤트 처리
    //console.log("commonEvent()");
    console.log(commonEvent);
    for (var i = 0; i < Object.keys(commonEvent).length; i++) {
        var key = Object.keys(commonEvent)[i];
        commonEvent[key]();
    }
    //console.log("commonEvent() end");

    // 스크롤 높이 계산
    setresize();

    // TOP 버튼 추가
    addTopBtn();

    // 맞춤 메뉴 설정 값 없는 경우 추가하기
    //[KIAVIK-389] 함수 내부에서 오류 발생.
    //사용하지 않는 부분이라 삭제.
    //makeCustomMenuList();

    // 1차 오픈시 뱃지 제거
    $("em.badge").remove();

    // 구글 아날리틱스
    //initGoogleAnalytics();
    screenViewGa();


    //console.log("sub onReady()");
    MStatus.onReady(event);
    // fnSetup();
}

M.onHide(function (event) {
    if (typeof MStatus.onHide == "function") {
        // M.onHide 공통 처리
        MStatus.onHide(event);
    }
});

M.onRestore(function (event) {
    console.log("mcore_api.js > M.onRestore()");
    /**
     * ccsp 로그인 후 처리 화면
     */
    if (!isEmpty(MData.param("ccspLoginInfo"))) {
        var loginData = MData.param("ccspLoginInfo");
        console.log("ccspLoginInfo");
        MData.removeParam("ccspLoginInfo");
        MData.removeStorage("accessToken");

        eventLog("mbrId", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, loginData.mbrId);
        if (isEmpty(loginData.mbrId)) {
            var msg = "로그인 정보를 불러올 수 없습니다.\n";
            msg += "아래 고객 센터로 문의해 주시기 바랍니다.\n";
            msg += "080-200-2000";
            MPopup.alert(msg);
            return;
        }

        MData.storage("accessToken", loginData.refreshToken);
        setLoginInfo(loginData);

        ccspSucessPageMove(); // ccsp 로그인 시
        eventLog("ccspLogin", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "login_end");
    }

    // 맞춤 설정 메뉴 변경 시 공통 처리
//	var isCustomMenuChange = MData.param("isCustomMenuChange");
//	if(isCustomMenuChange == "Y"){
    if ($("#totalMenuWrap").length > 0) {
        $("#totalMenuWrap .cusmn-list").html(makeCustomMenu());
        // 카앤라이프 뒤로가기 화면 나오면 주석제거 하면됨 04/18
        if (PGV.currentPage == PATH_MANAGER.KIA_RNW_810_0000.nameWithHtml) {
            var $allListElements = $('li button.btn-2dep.act');
            var autonPageNm = $('#autonPage').find($allListElements).data("autonUrl");
            var _path = CONSTANT.LINK_URL[autonPageNm].PATH;
            MData.removeGlobal("autonPath");
            MData.global("autonPath", _path);
        }
        //카앤라이프 뒤로가기 화면 나오면 주석제거 하면됨 04/18
    }
//	}

    //모피어스 화면이 아닌 곳에서 복귀한 경우 푸쉬 알림
    getPushDataWhenNotMorpheusView();

    /* !!! 케이스마텍 추헌남 - 현재 해당 코드 주석처리 되어 있어 KIA_MOB => KIA__MOB로 바꾸었습니다. */
    // 맞춤 메뉴 설정이 로그인 후 화면 인 경우 해당 화면에서도 맞춤 메뉴를 변경해야 하기 때문에 파라미터 값 해당 페이지에서 삭제
//	if(PGV.currentPage.indexOf("KIA__MOB_000_1110") == -1){
//		MData.removeParam("isCustomMenuChange");
//	}

    if (isEmpty(MData.global('loginInfo')) == false) {
        if (isEmpty(PGV.loginInfo) == true) {
            PGV.loginInfo = MData.global('loginInfo');
        }
        // 서버에서 받은 아이디가 있다면 공백 제거 로직 추가
        if (isEmpty(PGV.loginInfo) == false) {
            PGV.loginInfo.mbrId = $.trim(PGV.loginInfo.mbrId);
            //KIAVIK-356 sentry
            //if (typeof Sentry != "undefined") Sentry.setUser({ id: PGV.loginInfo.mbrId });
        }

        $("#totalMenu_custNm").html('<button type="button" class="type-txt">' + getShowingName(PGV.loginInfo.mbrNm) + '</button>님');
        $("#totalMenu_custNm").removeClass("none");
        $("#totalMenu_loginBtn").addClass("none");
        /* !!! 케이스마텍 추헌남 - 현재 해당 코드 주석처리 되어 있어 KIA_MOB => KIA__MOB로 바꾸었습니다. */
        // 로그인 후 로그인 페이지 남아 있을 경우 삭제
//		stackRemove(PATH_MANAGER.KIA_RNW_060_0000.nameWithHtml);
//		stackRemove("KIA__MOB_810_1060.html");

        if (PGV.currentPage != PATH_MANAGER.KIA_RNW_060_0000.nameWithHtml) {
            stackRemove(PATH_MANAGER.KIA_RNW_060_0000.nameWithHtml);
        }
        if (PGV.currentPage != "KIA_MOB_810_1060.html") {
            stackRemove("KIA_MOB_810_1060.html");
        }
        if (PGV.currentPage != PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml) {
            stackRemove(PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml);
        }
        /* 홈 닫기 */
        var homes = [PATH_MANAGER.KIA_RNW_110_0000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml,
            PATH_MANAGER.KIA_RNW_120_0000_2.nameWithHtml,
            PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml];
        var  homePath= M.data.param("homePath");
        if(!isEmpty(homePath)){
            M.data.remove("homePath");
            M.page.html({url:homePath});
        }else{

            if (homes.includes(PGV.currentPage)) {
                for(var i=1;i<homes.length;i++){
                    setTimeout(function rm(){
                        stackRemove(homes[i]);
                        clearTimeout(rm);
                    },1000);

                }
            }
        }
    } else {
        $("#totalMenu_custNm").addClass("none");
        $("#totalMenu_loginBtn").removeClass("none");
    }

    if (isEmpty(MData.global('loginInfo'))) {
        PGV.loginInfo = null;
    }

    if (typeof MStatus.onRestore == "function") {
        //푸쉬 알림 표시 체크
        // M.onRestore 공통 처리
        MStatus.onRestore(event);
    }
});



M.onBack(function (event) {

    console.log("onBack()");
    if (exWNIsLiveIndicator() == "Y") {
        return;
    }

    if (typeof PGV == "undefined") {
        console.log("PGV not yet created!!")
        return;
    }
    if (MData.storage("wrongPwFlag") == 'Y') { // 비밀번호 5회 틀렸을시
        MData.storage("wrongPwFlag", 'N');

        MPage.html({
            url: PATH_MANAGER.KIA_RNW_060_0000.path,
            action: "CLEAR_TOP",
            animate: "MODAL_DOWN"
        });
        return;
    }
    ;
    if (MData.storage("resetPwFlag") == 'Y') { // 비밀번호 5회 틀렸을시
        MData.storage("resetPwFlag", 'N');

        MPopup.confirm({
            message: '개인정보 보호를 위해 비밀번호 변경이 반드시 필요합니다.\n비밀번호를 변경하지 않을 경우 로그인 전 상태로 이동합니다.\n그래도 닫으시겠어요?',
            buttons: ["취소", "확인"],
            callback: function (idx) {
                if (idx == 1) { // 확인
                    MPage.html({
                        url: PATH_MANAGER.KIA_RNW_110_0000.path,
                        action: "CLEAR_TOP",
                        animate: "MODAL_DOWN"
                    });
                    return false;
                }
            }
        });
        return;
    }
    ;



    // 리뷰등록 이벤트
    if (PGV.currentPage == "KIA_RNW_411_1100.html") {
        if ($("#popWrap").hasClass("none") != true) {
            return;
        }else{
            MPage.back();
        }
    }

    // 리뷰 페이지 외 팝업동작, 소모품 교체 상세페이지도 제외(캘린더로 백키가 안 먹음)
    if ($(".popup-wrap").length > 0 && PGV.currentPage != PATH_MANAGER.KIA_RNW_411_1100.nameWithHtml && PGV.currentPage != PATH_MANAGER.KIA_RNW_420_0000.nameWithHtml
        && PGV.currentPage != PATH_MANAGER.KIA_RNW_231_0000.nameWithHtml
        ) {
        //TODO
        //dhyang
        //popup 종료시 animation 필요하나?
        if($(".popup-wrap:visible").length > 0){
            var popup = $(".popup-wrap").eq($(".popup-wrap").length - 1);
            var type = popup.get(0).getAttribute("animation_type");
            var isBackKeyDisabled = popup.attr("data-disable-back-key") === "Y";
            if (type == "slideUp") {
                popup.slideUp(CONSTANT.POPUP_ANIMATION_DURATION, function () {
                    customPopup.remove(popup);
                });
            } else {
                var popId = popup.get(0).getAttribute("id");
                switch (popId) {        // KIAVIK-473 예약완료후 백키 눌렀을 때 정비 예약 화면 안뜨도록
                    case "rsvComPopup" :
                        allInputValueClear();
                        if (PGV.dtodFlag == "Y") {
                            MPage.html({
                                url: PATH_MANAGER.KIA_RNW_244_2000.path,
                                param: {
                                    selectedFreeCareList: PGV.dtodFreeCareData,
                                    titleText: "Y",
                                    carInfo: PGV.ownCarInfoList[PGV.carSelectIndex],
                                    reserveData: PGV.reserveData
                                }
                            });
                        } else {
                            MPage.back({
                                animate: "MODAL_DOWN",
                                orientation: "DEFAULT",
                                param: {
                                    popupFlag: "Y",
                                    selectVinNumber: ""
                                }
                            });
                        }
                        break;
                    case "searchResultPopup" :
                        // [KIAVIK-673] 고객센터 backkey
                        if (popup.hasClass("on")) {
                            popup.removeClass("on");
                        } else {
                            MPage.back(event);
                        }
                        break;
                    case "calPopupWrap":
                        //달력 팝업 삭제 방지 및 팝업닫기
                        popup.closest('.popup-layer').fadeOut('fast');
                        $('body').removeClass('js-overflow-hidden');
                        break;
                    default :
                        if(!isBackKeyDisabled){
                            //as-is
                            // customPopup.remove($(".popup-wrap").eq($(".popup-wrap").length - 1)); // 팝업 삭제

                            //tobe- 테스트중.
                            /** 팝업열린상태로 backKey 눌렀을 때 공통처리. */
                            var _$pops = $("div.popup-layer");//as-is popup은 popup-layer로 감싸져있고,
                            if(_$pops.length>0){//to-be에서(home) 팝업이 여러개 열리게 됨.
                                // var homeTabPopup = ["popup_0B0_0000","popup_128_0000","popup_129_0000"];
                                // if (homeTabPopup.includes(popId)) {
                                if (typeof MyKiaBottomTab == 'object'&&MyKiaBottomTab.currentPage=='home') {
                                    //홈팝업에서는 백키 이벤트 없음.
                                }else{
                                    if(_$pops.length=1){
                                        $('body').removeClass('js-filter-list-fixed');
                                        $(".wrapper").removeClass("donemove");
                                    }
                                    _$pops.eq(0).remove();
                                }
                            }else{
                                //as-is popup은 popup-layer로 감싸져있지가 않다.
                                customPopup.remove($(".popup-wrap").eq($(".popup-wrap").length - 1)); // 팝업 삭제
                            }
                        }
                        break;
                }
            }
            return;
        }
    }
    ;
    COMMON_FUNCTION.TOOL.UI.handleBackKey();

    // [KIAVIK-400] customPopup.get 으로 생성된 팝업 외 이벤트 상세 iframe 에서 생성되는 백키 처리
    if (PGV.currentPage == PATH_MANAGER.KIA_RNW_411_1000.nameWithHtml) {
        //MPage.back({}); // 2020.06.05 추가 이벤트 상세페이지라면 뒤로가기
        onBackNoSubmitEvt("KEY");
        return;
    }
    ;

    if ($("#totalMenuWrap").length > 0 && !$("#totalMenuWrap").hasClass("none")) {
        customPopup.addClass($("#totalMenuWrap"));
        return;
    }

    //카앤라이프 뒤로가기 화면 나오면 주석제거 하면됨 04/18
    if (PGV.currentPage == PATH_MANAGER.KIA_RNW_810_0000.nameWithHtml) {
        var iframeWrap = document.getElementById("iframeWrap").contentWindow;
        var h = window.history;

        if (PGV.firstPageYn == "N") {
            h.back()
            return;
        } else {
            PGV.evtCd = "";
            MData.removeGlobal("autonPath");     // [KIAVIK-399] 오토앤 첫페이지 경로 삭제
        }
    }

    // 마케팅 동의 여부 체크 하기위해 새로 추가 2019.05.21
    if (PGV.currentPage == PATH_MANAGER.KIA_RNW_093_3000.nameWithHtml) {
        if (PGV.adEvtCheck == "Y") {
            MPage.back({
                param: {mkYn: "Y"}
            });
            return;
        } else {
            MPage.back({
                param: {mkYn: "N"}
            });
            return;
        }
    }
    //[KIAVIK-494] stack이 1개일때는 Mpage.back이 아닌 메일 호출.
    if ((M.page.stack().length > 1)
        && (PGV.currentPage == PATH_MANAGER.KIA_RNW_212_0000.nameWithHtml
            || PGV.currentPage == PATH_MANAGER.KIA_RNW_245_1000.nameWithHtml
            || PGV.currentPage == PATH_MANAGER.KIA_RNW_245_2100.nameWithHtml)
        && !isEmpty(PGV.myCarInfoList)) {
        //[KIAVIK-105] 출고 정보 변경 노티 화면에서는 vin 정보 획득을 못하는 경우가 있음.
        var index = $("#carSelectBtn").attr("data-select-idx");
        MPage.back({
            param: {
                popupFlag: "Y",
                selectVinNumber: isEmpty(index) ? "" : (PGV.myCarInfoList[index].vin || "")
            }
        });
        return;
    }

    //차계부 상세 내역에서 차계부 메인으로 돌아올 때, 새로고침 하기 위함.(2022-05-13)
    if (PGV.currentPage == PATH_MANAGER.KIA_RNW_223_0000.nameWithHtml) {
        MPage.back({
            param : {isRefresh : "Y"}
        });
        return;
    }

    lastStackHandler(event);//common.js
});

M.onDestroy(function (event) {
    if (typeof MStatus.onDestroy == "function") {
        // M.onDestroy 공통 처리
        MStatus.onDestroy(event);
    }
});

M.onPause(function (event) {
    if (typeof MStatus.onPause == "function") {
        // M.onPause 공통처리
        MStatus.onPause(event);
    }
});

M.onResume(function (event) {
    console.log("mcore_api.js > M.onResume()");
    //[KIAVIK-398] pkey error 예외처리
    if (checkPkeyExpired()) {
        console.log("pkey is expired retry autoLogin!(onResume)");
        autoLoginFunction(true);
        setTimeout(function () {
            console.log("retry onResume (" + event + ")");
            M.onResume(event);
        }, CONSTANT.RETRY_LOGIN_TIMEOUT);
        return;
    }
    if (typeof MStatus.onResume == "function") {
        console.log("onResume()");
        // M.onResume 공통처리
        if (PGV.device.os.name.toLowerCase() == 'ios' || PGV.device.os.name.toLowerCase() == 'ipados') {
            deepLinkProcess();
        }
        MStatus.onResume(event);
    }
});
