/**
 * @파일명 : KIA_RNW_010_0000.js
 * @작성자 : 정목단
 * @생성일 : 2022. 1. 24.
 * @DESC : 전체메뉴노출[X], 접근권한( 미로그인[O] 차량미보유[O]   계약차량보유[O]   내연보유[O]   EV보유[O] )
 */
var Intro = {
    init: function (){
        console.log("Intro.init()");
        //1. 네트워크 체크
        Intro.alertIfNotOnLine(); // IF NOT THEN return;
        //native로 이동
        MData.storage("autoLogin", "N");
        PGV.appOS = PGV.device.os.name.toLowerCase();

        if(PGV.appOS == 'ios' || PGV.appOS == 'ipados'){
            WN2Common('exWNSetLightBarStyle', "true");
        }
        Intro.doPreResourceUpdate();
    },
    alertIfNotOnLine: function () {
        if (navigator.onLine == false) {
            MPopup.alert({
                message : "네트워크에 접속할 수 없습니다.\n네트워크 연결 상태를 확인하시고\n앱을 다시 실행해주세요.",
                buttons : ["확인"],
                callback : function(idx){
                    M.sys.exit();
                }
            });
            return;
        }
    },
    doPreResourceUpdate: function() {
        //Resouce Update
        // 모피어스 에뮬레이터 실행시 아래 소스 실행.
        // PGV.device.os = {name: "Android", version: "29"};
        if(PGV.device.os.name == "pc"){
            Intro.getTokenInfo().then(Intro.preResouceUpdate);
        }else{
            //[KIAVIK-330]권장 업데이트
            Intro.updateAppVersion();
            if(CONFIG.IS_DEV == false) MData.global("encodeUTF8", "TRUE");
            var vik_database = M.data.storage("vik_database");
            //ios는 속도가 빨라서 firebase read 하기전 check 로직이 수행됨.
            //firebase 상태 변경하면 다음 실행시 체크됨.
            if (!isEmpty(vik_database)) {
                eventLog("app_alive_check", "intro", "database");
                //console.log("isAlive=" + vik_database.server_check.isAlive + ", guideTxt=" + vik_database.server_check.guideTxt);
                if(vik_database.server_check.isAlive == "Y"){
                    //console.log("appAliveCheck() end");
                    Intro.getTokenInfo().then(Intro.preResouceUpdate);
                }else{
                    MPopup.alert({
                        message : vik_database.server_check.guideTxt,
                        buttons : ["종료"],
                        callback : function(idx){
                            M.sys.exit();
                        }
                    });
                }
                return;
            }
            eventLog("app_alive_check", "intro", "ExAjax");
            PGV.isAppAliveCheck = false;
            ExAjax.ajax({
                url : CONSTANT.SERVER_URL_PREFIX + "appAliveCheck.html",
                body : "",
                type     : CONSTANT.NET_MTHD.GET, // POST, GET
                encoding : 'UTF-8', // UTF-8 , EUC-KR
                header   : {},
                success : function(data) {
                    if (PGV.isAppAliveCheck) return;
                    PGV.isAppAliveCheck = true;
                    try {
                        var checkDataObj = Intro.parseData(data);
                        if(checkDataObj.isAlive == "Y"){
                            //console.log("appAliveCheck() end");
                            Intro.getTokenInfo().then(Intro.preResouceUpdate);
                        }else{
                            MPopup.alert({
                                message : checkDataObj.guideTxt,
                                buttons : ["종료"],
                                callback : function(idx){
                                    M.sys.exit();
                                }
                            });
                        }
                    } catch(e) {
                        PGV.isAppAliveCheck = true;
                        SNTR.sendSentryVIKErrorLog("appAliveCheck", e);
                        Intro.getTokenInfo().then(Intro.preResouceUpdate);
                    }
                },
                fail : function(errorMsg) {
                    PGV.isAppAliveCheck = true;
                    Intro.getTokenInfo().then(Intro.preResouceUpdate);
                }
            });

            setTimeout(function(){
                if (!PGV.isAppAliveCheck) {
                    PGV.isAppAliveCheck = true;
                    eventLog("app_alive_check_time_out", "intro", "ExAjax");
                    SNTR.sendSentryVIKErrorLog("appAliveCheck time out", "time out");
                    Intro.getTokenInfo().then(Intro.preResouceUpdate);
                }
            }, 2000);

        }
    },
    getTokenInfo: function () {
        return new Promise(function (resolve){
            var fcmToken = getFCMToken(); //푸시토큰 전역저장함.
            var loadCounter = 0;
            var checkFcmToken = setInterval(function () {
                loadCounter++;
                if (loadCounter === 100) {
                    clearInterval(checkFcmToken);
                    resolve(true);
                }
                try {
                    fcmToken = MData.global("FCMToken");
                    if (!isEmpty(fcmToken)) {
                        clearInterval(checkFcmToken);
                        resolve(true);
                    }
                } catch (e) {
                }
            }, 100);

        });
    },
    //리소스 업데이트 전 처리
    preResouceUpdate: function(){
        //M.net.cookie.clear();
        console.log("preResouceUpdate()");
        var resource_target = PGV.appInfo.manifest.resource.target;
        if(resource_target == "app"){
            var timeout = 1000;
            var accessToken = MData.storage("accessToken");
            if (!isEmpty(accessToken)) {
                timeout = 10;
            }
            //alert("line 131 accessToken:" + accessToken);
            var tiemObj = setTimeout(function(){
                Intro.fnSetSplashVideo();

                if(CMMLogin.checkPermission() === 'true'&&!isEmpty(accessToken)){
                    //ccsp로그인
                    clearTimeout(tiemObj);
                    CMMLogin.autoLoginFunction();
                }else{
                    clearTimeout(tiemObj);
                    CMMLogin.launcherMain();
                }

            }, timeout);
        }
        else{
            PGV.animateCompleteYn = "N";
            PGV.resourceUpdateYn = "N";
            PGV.setTimeoutId = setTimeout(function(){
                PGV.animateCompleteYn = "Y";
                Intro.completeResourceUpdate();
            }, 10);

            var _resVersion = parseInt(PGV.appInfo.resource.current_version);
            var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));	// 앱 버전

            // 앱이 가지고 있는 리소스 버전이므로, 비교 값이 0이 아닐 수 있음
            // 버전 배포시 리소스 버전 확인여 해당 버전으로 설정 필요.
            var resourceObj = Intro.getResourceObj(_appVersion);
            if(resourceObj.isLocalResource && (_resVersion < resourceObj.checkVersion)){
                console.log("unzip resource!!");
                M.zip.unzip({
                    path: resourceObj.resourcePath,
                    destination: 'doc://',
                    overwrite: true,
                    indicator: false,
                    callback: function(status) {
                        //console.log("resource update status=" + status);
                        if(status == "SUCCESS"){
                            // 리소스 서버 배포 버전을 고려하여, 값을 전달
                            // 리소스 배포 서버에서 전체배포된 버전이 10이라면, 000010 으로 배포
                            M.execute("exSetResourceVersion", resourceObj.resourceVersion); // UX 2.0 배포 리소스 버전 v256
                            // 배포 서버에 10이 최종이라면, 클라이언트는 zip 해제된 파일의 버전이 10이 되므로,
                            // 리소스 업데이트 요청시, 서버에서 배포할 리소스가 없다고 처리 됨
                            //[KIAVIK-330]권장 업데이트
                            //requestResouceUpdate();
                            Intro.appVersionCheck();
                        }else {
                            //[KIAVIK-330]권장 업데이트
                            //requestResouceUpdate();
                            Intro.appVersionCheck();
                        }
                    }
                });
            }else{
                Intro.appVersionCheck();
            }

        }
    },
    //리소스 업데이트 요청
    requestResouceUpdate: function(){
        var retryOrExit = function (idx){
            if(idx == 1){
                M.net.res.retry();
            } else {
                M.sys.exit();
            }
        }
        M.net.res.update({
            finish : function(status, info, option) {
                if(info){
                    MData.global('APP_VERSION_INFO', info);
                }
                var confirm={};

                switch (status) {
                    case 'SUCCESS':
                        var progressBar = document.getElementsByClassName("progress-bar");
                        progressBar[0].style.width = '100%';
                        PGV.resourceUpdateYn = "Y";
                        Intro.completeResourceUpdate();
                        break;
                    case 'SUCCESS_AND_REFRESH':
//                        M.page.replace(PGV.currentPage);
                          M.page.html({url:PATH_MANAGER.KIA_RNW_010_0000.path});
                          //stackRemove(PGV.currentPage);
                        break;
                    case 'RECOMMENDED_APP_UPDATING':
                        confirm.message="설치된 앱이 낮은 버전입니다.\n업데이트 하시겠습니까?";
                        confirm.callbackFunc=function (idx) {
                            if(idx == 1){
                                var appUrl = info.app_version_info.download_market_url;
                                M.apps.browser(appUrl);
                            } else {
                                M.page.html(_nextPage, {action:"CLEAR_TOP", delay:600});
                            }
                        }
                        break;
                    case 'FORCED_APP_UPDATING':
                        confirm.message="설치된 앱이 낮은 버전입니다.\n업데이트 하시겠습니까?";
                        confirm.callbackFunc=function (idx) {
                            if(idx == 1){
                                var appUrl = info.app_version_info.download_market_url;
                                M.apps.browser(appUrl);
                            } else {
                                M.sys.exit();
                            }
                        }
                        break;
                    // 라이센스 체크 에러
                    case 'LICENSE_IS_NOT_EXISTENCE':
                    // 라이센스 무결성 회손
                    case 'BROKEN_INTEGRITY_OF_LICENSE':
                    // 라이센스 기간 만료
                    case 'EXPIRED_LICENSE':
                        confirm.message = "라이센스 파일 검사 중 에러가 발생하였습니다. 라이센스 파일을 확인해 주시기 바랍니다.\n\n다시 시도하시겠습니까?";
                        confirm.callbackFunc = retryOrExit;
                        break;
                    case 'INSUFFICIENT_MEMORY':
                        confirm.message = "프로그램을 설치 할 수 있는 메모리가 부족합니다.\n\n다시 시도하시겠습니까?";
                        confirm.callbackFunc = retryOrExit;
                        break;
                    case 'EXT_MEM_NOT_AVAIL':
                        confirm.message = "외장 메모리 카드를 사용 할수 없습니다. 외장 메모리카드를 확인해주시기 바랍니다.\n\n다시 시도하시겠습니까?";
                        confirm.callbackFunc = retryOrExit;
                        break;
                    default:
                        confirm.message = "프로그램 초기화 및 리소스 업데이트 중 에러가 발생하였습니다.\n\n다시 시도하시겠습니까?";
                        confirm.callbackFunc = retryOrExit;
                        break;
                }

                if(!isEmpty(confirm)){
                    MPopup.confirm({
                        message:confirm.message,
                        callback : confirm.callbackFunc
                    });
                }
            },
            progress : function(total, read, remain, percentage, option) {
                var progressBarWidth = Math.max( Math.min( percentage, 100 ), 0 ) + "%";
                var progressBar = document.getElementsByClassName("progress-bar");
                progressBar[0].style.width = progressBarWidth;
            },
            error : function(errCode, errMsg, option){
                M.debug.error("** error : ", errCode, errMsg);
                MPopup.confirm({
                    message : "프로그램 초기화 및 리소스 업데이트 중 에러가 발생하였습니다.\n\n다시 시도하시겠습니까?",
                    callback : retryOrExit
                });
            }
        });
    },
    //리소스 업데이트 완료 시
    completeResourceUpdate: function(){
        console.log("completeResourceUpdate");

        var _nextPage = PATH_MANAGER.KIA_RNW_110_0000.path;//미로그인 메인
        var hasAccessToken = !isEmpty(MData.storage("accessToken"));
        var isAutoLogin = MData.storage("autoLogin") == "Y" && !isEmpty(MData.storage("autoLoginId")) && !isEmpty(MData.storage("autoLoginPw"));
        var doPcCaseFunc=function (){
            if(hasAccessToken || isAutoLogin){
                CMMLogin.ccspLogin();
            }else{
                if(!getPushDataWhenClosedApp()){//push library
                    MPage.html({
                        url : _nextPage,
                        action:"CLEAR_TOP"
                    });
                }
            }
        };
        if(PGV.animateCompleteYn == "Y" && PGV.resourceUpdateYn == "Y") {
            PGV.animateCompleteYn = "N";
            PGV.resourceUpdateYn = "N";
            if(PGV.device.os.name !== "pc"){
                if(checkPermission() !== 'true'){
                    CMMLogin.launcherMain();
                }else {
                    if(hasAccessToken || isAutoLogin){
                        CMMLogin.autoLoginFunction();
                    }else{
                        CMMLogin.launcherMain();
                    }
                }
            }else {
                doPcCaseFunc();
            }

        }

    },

    appVersionCheck: function(){
        var currentVersion = M.data.storage("updatedAppVersion");
        currentVersion = Number(currentVersion.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));
        var appVersion = PGV.appInfo.app.version;
        appVersion=Number(appVersion.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));
        var isUpdateRequired = ( appVersion< currentVersion);
        if (isUpdateRequired) {
            var currentDate = moment().format("YYYYMMDD");
            console.log("today=" + currentDate);
            if (MData.storage("recommendUpdatePopup") != currentDate) {
                MData.storage("recommendUpdatePopup", currentDate);
                // ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
                // ga('send', 'event', "recommand_popup", 'noti', "app-update");
                eventLog("recommand_popup", 'noti', "app-update");
                MPopup.confirm({
                    message : "새로운 업데이트가 있습니다.\n업데이트 하시겠습니까?",
                    callback : function(idx){
                        if(idx == 1){
                            // ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
                            // ga('send', 'event', "recommand_move_store", 'button', PGV.appOS);
                            eventLog("recommand_move_store",  PGV.appOS, 'button');
                            //android의 경우 exit하면 ga 정보 전달 안됨.
                            setTimeout(function(){
                                var _id = CONSTANT.KIA_VIK_ANDROID_PACKAGE ;
                                if (PGV.appOS == 'ios' || PGV.appOS == 'ipados') {
                                    _id = CONSTANT.KIA_VIK_IOS_STORE_ID;
                                }
                                M.apps.store(_id);
                                M.sys.exit();
                            }, 200);

                        } else {
                            Intro.requestResouceUpdate();
                        }
                    }
                });
                return;
            }
        }
        Intro.requestResouceUpdate();
    },
    getDevCurrentAppVersion: function(appVer,_$el){
        if(PGV.appInfo.manifest.resource.target == "app" || CONFIG.IS_DEV == true){
            if(CONFIG.IS_DEV == true){
                appVer += ' TEST';
            }else{
                appVer += ' REAL';
            }
            appVer +=  '(' + PGV.appInfo.manifest.resource.target.toUpperCase() + ')';
            _$el.style.backgroundColor = "#ff0000";
            _$el.style.color = "#ffffff";
        }
        return appVer;
    },
    updateAppVersion: function(){//[KIAVIK-330]권장 업데이트 START
        console.log("Intro.updateAppVersion()");
        var _osId = "10"; // 10:android , 20: ios
        if(PGV.appOS == 'ios' || PGV.appOS == 'ipados'){
            _osId = "20";
        }
        MNet.httpSend({
            isMock: false,
            path : _API.SVR.CMM.code.appVersion.url,
            indicatorYn : "N",
            sendData : {
                osId : _osId,
                apiId: _API.SVR.CMM.code.appVersion.apiId,
            },
            callback : Intro.updateAppVersionCallback,
            errorCallback : function(code, msg){
                console.log("updateAppVersion error code=" + code + ", msg=" + msg);
                M.data.storage("updatedAppVersion", PGV.appInfo.app.version);
            }
        });
    },
    updateAppVersionCallback: function(receivedData){
        var code = receivedData.resultCode;
        var errMsg = receivedData.resultMsg;

        if(code == "200"){
            //console.log("appVersionCheckCallback version=" + receivedData.binVerStr);
            M.data.storage("updatedAppVersion", receivedData.binVerStr);
        } else {
            console.log("appVersionCheckCallback code=" + code + ", errMsg=" + errMsg);
            M.data.storage("updatedAppVersion", PGV.appInfo.app.version);
        }
    },
    parseData: function(tmpData){//device에 따라 데이터 파싱.
        if(wnIf.device == DT_IOS){
            tmpData = tmpData.replace(/\\/gi, '');
            tmpData = tmpData.replace(/<br>/gi, '\\n');
        }else{
            tmpData = tmpData.replace(/<br>/gi, '\\n');
        }
        return JSON.parse(tmpData);
    },
    getResourceObj: function(_appVersion) {
        var isLocalResource = false;
        var resourcePath = "";
        var resourceVersion = "";
        var checkVersion = 0;
        if(PGV.device.os.name.toLowerCase() == ('ios') ||PGV.device.os.name.toLowerCase() == ('ipados')){
            switch(_appVersion) {
                case 300:
                    isLocalResource = true;
                    resourcePath = "app://vik_resource_v670.zip";
                    resourceVersion = "000670";
                    checkVersion = 670;
                    break;
                case 301:
                    isLocalResource = true;
                    resourcePath = "app://vik_resource_v675.zip";
                    resourceVersion = "000675";
                    checkVersion = 675;
                    break;
                case 302:
                    isLocalResource = true;
                    resourcePath = "app://resource_v829.zip";
                    resourceVersion = "000829";
                    checkVersion = 829;
                    break;
                case 303:
                    isLocalResource = true;
                    resourcePath = "app://resource_v879.zip";
                    resourceVersion = "000879";
                    checkVersion = 879;
                    break;
                case 304:
                    isLocalResource = true;
                    resourcePath = "app://resource_v928.zip";
                    resourceVersion = "000928";
                    checkVersion = 928;
                    break;
                case 305:
                    isLocalResource = true;
                    resourcePath = "app://resource_v958.zip";
                    resourceVersion = "000958";
                    checkVersion = 958;
                    break;
                case 306:
                case 307:
                    isLocalResource = true;
                    resourcePath = "app://resource_v987.zip";
                    resourceVersion = "000987";
                    checkVersion = 987;
                    break;
                case 308:
                    isLocalResource = true;
                    resourcePath = "app://resource_v1032.zip";
                    resourceVersion = "001032";
                    checkVersion = 1032;
                    break;
            }
        }
        else {
            switch(_appVersion) {
                case 300:
                    isLocalResource = true;
                    resourcePath = "app://vik_resource_v670.zip";
                    resourceVersion = "000670";
                    checkVersion = 670;
                    break;
                case 301:
                case 302:
                    isLocalResource = true;
                    resourcePath = "app://vik_resource_v675.zip";
                    resourceVersion = "000675";
                    checkVersion = 675;
                    break;
                case 303:
                    isLocalResource = true;
                    resourcePath = "app://resource_v754.zip";
                    resourceVersion = "000754";
                    checkVersion = 754;
                    break;
                case 304:
                case 305:
                case 306:
                    isLocalResource = true;
                    resourcePath = "app://resource_v829.zip";
                    resourceVersion = "000829";
                    checkVersion = 829;
                    break;
                case 307:
                case 308:
                    isLocalResource = true;
                    resourcePath = "app://resource_v879.zip";
                    resourceVersion = "000879";
                    checkVersion = 879;
                    break;
                case 309:
                case 310:
                    isLocalResource = true;
                    resourcePath = "app://resource_v928.zip";
                    resourceVersion = "000928";
                    checkVersion = 928;
                    break;
                case 311:
                case 312:
                    isLocalResource = true;
                    resourcePath = "app://resource_v958.zip";
                    resourceVersion = "000958";
                    checkVersion = 958;
                    break;
                case 313:
                case 314:
                case 315:
                case 316:
                    isLocalResource = true;
                    resourcePath = "app://resource_v1032.zip";
                    resourceVersion = "001032";
                    checkVersion = 1032;
                    break;
            }
        }
        return {
            "isLocalResource":isLocalResource,
            "resourcePath":resourcePath,
            "resourceVersion":resourceVersion,
            "checkVersion":checkVersion
        };
    },
    fnSetSplashVideo: function () {
        function fnSetSplashProgress() {
            console.log("uiPromise 2-1-fnSetSplashProgress");
            var $progressItem = $('.js-progress-item');
            var $proresesBtn = $('.js-progress-btn');

            $('#splash_010_0000').find($progressItem).each(function(idx, item) {
                //console.log('idx', idx)
                //console.log('item', item)

                var setProgressData = [100];
                $(item).find('#splashProgressBar'+idx).css('width', setProgressData[idx]+'%');
            });
        }
        return new Promise(
            function (resolve){
                console.log("uiPromise 2");
                fnSetSplashProgress();
                $('#splashVideo').bind('ended', function() {
                    console.log('splashVideo end');
                    //$('#splashVideo').fadeOut('600');
                });
                resolve();
            }
        );

    }
}
/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){

        Intro.init();
        // splash 동영상 대신 이미지로 대체됨
//         // alert("xxxx");
//         var _$target=$("div.splash-video");
//         var uiPromise = new Promise(
//                 function (resolve){
//                     console.log("uiPromise 1");
//                     if(getOSType().toLowerCase() == 'android'){
//                         _$target.html('<video id="splashVideo" autoplay="" muted="" playsinline="" poster="" controls loop>' +
//                             '<source src="../../video/rnw/common/splash/splash_kia.mp4" type="video/mp4">' +
//                             '</video>');
//                         resolve();
//                     }
//                     /* 20220518//(Ina) iOS디바이스 splash동영상이미지 4초 재생 이후에 splash end이미지 호출 */
//                     else {
//                         _$target.html('<img id="splashPoster" class="splash-poster" src="../../img/rnw/common/splash/img_splash_poster.png">' +
//                             '<img src="../../video/rnw/common/splash/splash_kia.mp4" type="video/mp4">');
// //                        setTimeout(function() {
// //                            $('#splashPoster').show();
// //                        }, 4000);
//
//                         /* 20220624//인트로_IOS > UI 변경 */
// //                        var iosHtml =   "<div class='splash-photo'>"
// //                                    +      "<div class='cont-top'>"
// //                                    +          "<span>나만의 새로운 모빌리티 라이프</span>"
// //                                    +          "<p class='tit'>MyKia</p>"
// //                                    +      "</div>"
// //                                    +  "</div>";
// //
// //                        _$target.html(iosHtml);
// //                        _$target.html('<video id="splashVideo" autoplay="" muted="" playsinline="" poster="">' +
// //                            '<source src="../../video/rnw/common/splash/splash_kia.mp4" type="video/mp4">' +
// //                            '</video>');
//
//                         resolve();
//                     }
//                 }
//             )
//             // .then(Intro.fnSetSplashVideo)
//             .then(Intro.init);

    },

    onHide : function(event){

    },

    onRestore : function(event){

    },

    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
	onBack : function(){
        if(!($('#popup_050_0000:visible').length > 0)){
            MPage.back();
        }
	},

    onDestroy : function(event){

    },

    onPause : function(event){

    },

    onResume : function(event){

    }
};


