// 로그인/intro 에서 사용됨.
// M.Core의 커스텀
// WNInterface.js 의 커스텀

/**
 * 로그인/intro 에서 사용됨.
 * Core Api
 */

// Navigator 관련 API
var MNavigator = {
    os : function(os){
        if(arguments.length == 1){
            return M.navigator.os(os);
        }else{
            return M.navigator.os();
        }
    },

    device : function(os, version){
        if(arguments.length == 2){
            return M.navigator.device(os, version);
        }else if(arguments.length == 1){
            return M.navigator.device(os);
        }else if(arguments.length == 0){
            return M.navigator.device();
        }
    },

    browser : function(name, version){
        if(arguments.length == 2){
            return M.navigator.browser(name, version);
        }else if(arguments.length == 1){
            return M.navigator.browser(name);
        }else if(arguments.length == 0){
            return M.navigator.browser();
        }
    }
};

// PAGE 관련 API
var MPage = {
    info : function(keyPath){
        return M.page.info(keyPath);
    },

    defer : function(enabled, time){
        if(enabled){
            M.page.defer(enabled, time);
        }else{
            M.page.defer(enabled);
        }
    },

    html : function(options){
        // 화면 이동시 공통 처리
        var _options = options;
        M.page.html(_options);
    },

    back : function(options){
        var _options = options;
        M.page.back(_options);
    },

    remove : function(url){
        M.page.remove(url);
    },

    replace : function(options){
        var _options = options;
        M.page.replace(_options);
    },

    activity : function(options){
        if(MInfo.device().os.name != "pc"){
            // TODO : 기아홈페이지 또는 기아멤버스 이동의 경우 통합앱의 로그인 여부를 체크하여 token 값을 보내도록 처리
            var _options = options;

            /**
             * 기아멤버스, 기아홈페이지로 이동 시 통합 앱 로그인이 되어 있는 경우 로그인 정보 넘기기
             * TODO
             * : 기아멤버스, 기아홈페이지 호출 URL 나오면 CONSTANT.RED_LOGIN_URL, CONSTANT.KIA_LOGIN_URL 세팅
             * : RED_CRTEC_KEY,KIA_CRTEC_KEY 세팅 하기
             * 개발 후 주석 해제!!!!!
             */

                // 링크된 URL Google Analytics에 전송
            var gaLinkName = searchGaLinkName(_options.param.requestURL);
            if(isEmpty(gaLinkName) == false){
                screenViewGa(gaLinkName);
            }

            if(_options.className == "WebviewActivity" && (_options.param.requestURL.startsWith(CONSTANT.RED_URL_PREFIX)
                || _options.param.requestURL.startsWith(CONSTANT.KIA_URL_PREFIX)
                || _options.param.requestURL.startsWith(CONSTANT.RED_URL_OLD_PREFIX))){
                //[KIAVIK-344] 레드멤버스 도메인 변경 예외처리.
                // 이전 도메인으로 들어오는 경우 일괄 변경.
                if (_options.param.requestURL.startsWith(CONSTANT.RED_URL_OLD_PREFIX)) {
                    _options.param.requestURL = _options.param.requestURL.replace(CONSTANT.RED_URL_OLD_PREFIX,CONSTANT.RED_URL_PREFIX);
                }

                if(isEmpty(PGV.loginInfo) == false){
                    var reqUrl = _options.param.requestURL.startsWith(CONSTANT.RED_URL_PREFIX) == true ? CONSTANT.RED_LOGIN_URL : CONSTANT.KIA_LOGIN_URL;		// 고정된 기아멤버스, 기아홈페이지 URL
                    var returnUrl = _options.param.requestURL;		// 로그인 처리 후 실제 이동할 URL
                    _options.param.method = CONSTANT.NET_MTHD.POST;
                    _options.param.requestURL = reqUrl;
                    // TODO : 추후 기아 홈페이지 특정 페이지 체크하여 위도, 경도 값 파라미터 넘기기
                    _options.param.postData = makeKiaRedPostData(returnUrl);
                }else{
                    _options.param.method = CONSTANT.NET_MTHD.GET;
                }
            }else{
                if(!isEmpty(_options.param.postData) && _options.param.method == CONSTANT.NET_MTHD.POST){
                    var _tmpPostData = _options.param.postData;
                    var _changePostData = "";
                    var _changePostData = "";
                    for(var i in _tmpPostData){
                        _changePostData += i + "=" + _tmpPostData[i];
                        _changePostData += "&";
                    }
                    _options.param.postData = _changePostData.substr(0, _changePostData.length-1);
                }
            }

            if(isEmpty(_options.actionType)) _options.actionType = "NO_HISTORY";

            M.page.activity(_options);
        } else{
            MPopup.alert("PC 에뮬레이터에서는 웹뷰 기능을 제공하지 않습니다.");
        }

    }
};

// DATA 관련 API
var MData = {
    param : function(key, value){
        if(arguments.length == 0){
            return M.data.param() || {};
        }else if(arguments.length == 1) {
            return M.data.param(key);
        }else if(arguments.length == 2){
            //console.log("MDATA param: key = " + key);
            M.data.param(key, value);

        }
    },

    removeParam : function(key){
        if(arguments.length == 0){
            M.data.removeParam();
        }else if(arguments.length == 1){
            M.data.removeParam(key);
        }
    },

    global : function(key, value){
        if(arguments.length == 0){
            return M.data.global() || {};
        }else if(arguments.length == 1) {
            return M.data.global(key);
        }else if(arguments.length == 2){
            //console.log("MDATA global: key = " + key);
            M.data.global(key, value);
        }
    },

    removeGlobal : function(key){
        if(arguments.length == 0){
            M.data.removeGlobal();
        }else if(arguments.length == 1){
            M.data.removeGlobal(key);
        }
    },

    storage : function(key, value){
//		if(arguments.length == 0){
//			return M.data.storage() || {};
//		}else
        if(arguments.length == 1) {
            var _getKey = key;
            //if(MInfo.device().os.name != 'pc'){
            _getKey = Base64.encode(key);
            var returnVal = exWNDecryptString(M.data.storage(_getKey));
            try {
                if(typeof JSON.parse(returnVal) == "object"){
                    return JSON.parse(returnVal);
                }else{
                    return returnVal;
                }
            } catch (e) {
                return returnVal;
            }
//				return Base64.decode(exWNDecryptString(M.data.storage(_getKey)));
            //}else{
            //	return M.data.storage(_getKey);
            //}
        }else if(arguments.length == 2){
            var _setKey = key;
            var _setValue = value;
            //if(MInfo.device().os.name != 'pc'){
            _setKey = Base64.encode(key);

            if(typeof value == "object"){
                value = JSON.stringify(value);
            }

            _setValue = exWNEncryptString(value);
            //}

            M.data.storage(_setKey, _setValue);
        }
    },

    removeStorage : function(key){
//		if(arguments.length == 0){
//			M.data.removeStorage();
//		}else
        if(arguments.length == 1){
            var _getKey = key;
            //if(MInfo.device().os.name != 'pc'){
            _getKey = Base64.encode(key);
            //}

            M.data.removeStorage(_getKey);
        }
    }
};

// AES 128
var MSec = {
    encrypt : function(value){
        var encObj = M.sec.encrypt(value);
        return encObj.status == "SUCCESS" ? encObj.result : "";
    },

    decrypt : function(value){
        var decObj = M.sec.decrypt(value);
        return decObj.status == "SUCCESS" ? decObj.result : "";
    }
};

var MInfo = {
    version : function(){
        return M.info.version();
    },

    memory : function(){
        return M.info.memory();
    },

    device : function(keyPath){
        if(arguments.length == 0){
            return M.info.device();
        }else if(arguments.length == 1){
            return M.info.device(keyPath);
        }
    },

    stack : function(index){
        if(arguments.length == 0){
            return M.info.stack();
        }else if(arguments.length == 1){
            return M.info.stack(index);
        }
    }
};

var MApps = {
    browser : function(url, encoding){
        M.apps.browser(url, encoding || "UTF-8");
    },

    remove : function(packageName){
        if(MInfo.device.toLowerCase() == "android"){
            M.apps.remove(packageName);
        }else{
            MPopup.alert("지원하지 않는 OS 입니다.");
        }
    },

    info : function(packageNm){
        return M.apps.info(packageNm);
    },

    open : function(packageNm, params){
        if(arguments.length == 1){
            M.apps.open(packageNm);
        }else{
            M.apps.open(packageNm, params);
        }
    },

    store : function(packageNm){
        M.apps.store(packageNm);
    }
};

var MSys = {
    call : function(telNum){
        if(MInfo.device().os.name.toLowerCase() == 'ios'){
            M.sys.call(telNum);
        }else{
            location.href = "tel:"+telNum;
        }

    }
};


/**
 * Addon Api
 */

/** 서버api 전용  */
var MNet = {
    httpSend : function(options){
        // debugger;
        // console.log("options:" + options);
        if (options.isMock && CONSTANT.IS_SVR_REF_MOCK) {
            var response = _MOCK_RES[options.sendData.apiId].response.body;
            options.callback(response);
        }else{
            if (isEmpty(options.retryData)) {
                options.retryData = {count : 0 };
            } else {
                console.log("httpSend second call " + options.path);
            }

            M.net.http.send({
                server : CONFIG.IS_DEV ? "HTTP_DEV" : "HTTP_REAL",		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
                path : options.path,
                timeout : options.timeout || (CONFIG.IS_DEV ? 30000 : 30000),  //[KIAVIK-458] default time 수정 운영 15000 > 30000 수정
                data : options.sendData || {},
                userData : PGV.loginInfo ? {pKey : PGV.loginInfo.pKey} : {},		// 20201015 p_key 헤더에 추가
                indicator : {
                    show : false
                },
                success : function(receivedData, setting){
                    var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));

                    // 로그인 정보
                    // if(options.path == "member/login" && receivedData.resultCode == "200" && receivedData.pwStCcd != "2"){
                    // 	PGV.loginInfo = receivedData;	//전역변수에저장
                    // 	MData.global('loginInfo', PGV.loginInfo);

                    // 	// 로그인 후 로그인 페이지 남아 있을 경우 삭제
                    // 	stackRemove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
                    // }
                    // 추후 공통처리가 필요한 경우 해당 부분에 처리
                    //test code
                    //cleanXSSData.errorCode = "";
                    //cleanXSSData.errorMsg = "";
                    if(!isEmpty(cleanXSSData.errorCode) && !isEmpty(cleanXSSData.errorMsg)){
                        if (cleanXSSData.errorCode == "500" && cleanXSSData.errorMsg.indexOf("Server Error!") > -1 && options.retryData.count == 0) {
                            console.log("retry count options:" + options.path + ", receivedData=" + receivedData);
                            options.retryData.count = 1;
                            MNet.httpSend(options);
                            return;
                        }
                        //KIAVIK-356 error log
                        sendSentryApiErrorLog(options.path, cleanXSSData.errorCode, cleanXSSData.errorMsg, options.sendData);
                        console.log("network error: code=" + receivedData.errorCode + ", msg=" + receivedData.errorMsg  + ", path=" + options.path);
                        if (options.errorCallback) {
                            options.errorCallback(cleanXSSData.errorCode, cleanXSSData.errorMsg);
                        } else {
                            MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    } else {
                        if (options.callback) {
                            options.callback(cleanXSSData);
                        }
                    }

                },

                error : function(errorCode, errorMessage, setting){
                    //405 : param error , 408 : p_key error
                    console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);

                    if (errorCode == 405 || errorCode == 408) {
                        //[KIAVIK-458] error log
                        sendSentryApiPkeyErrorLog(options.path, errorCode, errorMessage, options.sendData, PGV.loginInfo ? PGV.loginInfo.pKey : "empty");
                        MPopup.alert({
                            message : "로그인 정보가 변경되어 재로그인이 필요합니다.",
                            buttons : ["확인"],
                            callback : function(idx){
                                //로그인 정보 초기화
                                //M.data.removeGlobal("AfterLoginV2");
                                M.data.removeGlobal("loginMain");
                                M.data.removeGlobal("loginCarList");
                                M.data.removeGlobal("loginNoti");
                                M.data.removeGlobal("loginLuxury");

                                MData.removeStorage("accessToken");
                                MData.removeStorage("PUSH_ALARM_CHECK");
                                M.net.cookie.clear();
                                MData.removeGlobal('loginInfo');
                                //KIAVIK-356 sentry
                                //if (typeof Sentry != "undefined") Sentry.setUser({ id: "" });
                                PGV.loginInfo = '';
                                //일단 무조건 현재 페이지로.
                                var _page = PGV.currentPage;
                                var _startIdx = _page.indexOf("_MOB_");
                                var _returnUrl = "../" + _page.substr(_startIdx+5, 3) + "/" + _page;
                                var _params = {};
                                if(_page.substr(_startIdx+5, 4) == "1000"){
                                    _returnUrl = "../" + _page.substr(_startIdx+5, 4) + "/" + _page;
                                }
                                var param = {
                                    returnLink : _returnUrl,
                                    returnParams : _params
                                }
                                ccspLogin(param);
                            }
                        });

                    } else if((errorCode == "999" || errorCode == "9996" || errorCode == "9998") && options.retryData.count == 0){
                        console.log(errorCode + " error retry count options:" + options.path);
                        options.retryData.count = 1;
                        MNet.httpSend(options);
                        return;
                    } else {
                        //[KIAVIK-458] error log
                        sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                        // 추후 공통처리가 필요한 경우 해당 부분에 처리
                        if (options.errorCallback) {
                            options.errorCallback(errorCode, errorMessage);
                        } else {
                            //MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                        }
                    }
                }
            });
        }
    },
    upload :function(options){

        M.net.http.upload({
            url : CONSTANT.IMG_URL_PREFIX +"/api/" + options.path,		// 추후 개발/운영에 따라 텍스트 정리하여 변수값으로 세팅
            headers : {},           //"content-type" : "multipart/form-data;charset=utf-8","User-Agent" : "Tridentr"
            params : options.sendData,
            body : options.files || [],
            encoding : 'UTF-8',
            timeout : options.timeout || 20000,			// 추후 기본 값 변경
            indicator : {
                show : false
            },
            finish : function(statusCd, header, body, status, errMsg, setting){
                if (statusCd == -1) {
                    MPopup.alert('네트워크 연결 시 문제가 발생하였습니다. 잠시 후 다시 시도해 주십시오.');
                    return false;
                }

                receivedData = JSON.parse(body);
                var code = receivedData.head.resultCode;
                var msg= receivedData.head.resultMsg;
                if(code == "200"){
                    options.callback(receivedData.body);
                }else{
                    MPopup.alert(msg);
                }

            },
            progress : function(total, current) {
            }
        });
    }
};

var MNet_Hub = {
    httpSend : function(options){

        //dhyang
        //console.log("accesstoken:" + PGV.loginInfo.accessToken);
        // debugger;
        // console.log("options:" + options);

        M.net.http.send({
            server : CONFIG.IS_DEV ? "HTTP_DATA_HUB_DEV" : "HTTP_DATA_HUB_REAL",
            path : options.path,
            method : options.method,
            timeout : options.timeout || (CONFIG.IS_DEV ? 30000 : 10000),
            data : options.sendData || {},
            userData : PGV.loginInfo ? {accessToken : PGV.loginInfo.accessToken, commonRest : true} : {commonRest : true},
            indicator : {
                show : false
            },

            success : function(receivedData, setting){
                var cleanXSSData = JSON.parse(cleanXSS(JSON.stringify(receivedData)));
                if (Object.keys(receivedData).length == 0) {
                    cleanXSSData = "";
                }

                if (options.callback) {
                    options.callback(cleanXSSData);
                }
            },

            error : function(errorCode, errorMessage, setting){
                var isSend = true;
                if (options.path.includes("ismaster")) {
                    //UVO 미창작 차량의 경우 보통 4002 CCS 정확히 답변 못받음.
                    //로그가 많이 남을것을 예상하여 예외처리.
                    if (!isEmpty(errorMessage.errCode) && errorMessage.errCode == 4002) {
                        isSend = false;
                    }
                }

                if (isSend) {
                    sendSentryApiCCSErrorLog(options.path, errorCode, errorMessage, options.backup, options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");
                }
                //sendSentryApiErrorLog(options.path, errorCode, errorMessage, options.sendData);
                // 추후 공통처리가 필요한 경우 해당 부분에 처리
                if (options.errorCallback) {
                    options.errorCallback(errorCode, errorMessage);
                } else {
                    MPopup.alert(CONSTANT.NETWORK_ERR_MSG);
                }

                console.log("network error: code=" + errorCode + ", msg=" + errorMessage + ", path=" + options.path);
            }
        });
    }
};

var MPopup = {
    alert : function(options){
        if(typeof options == "string"){
            M.pop.alert({
                title : "알림",
                message : options,
                buttons : ["확인"],
                callback : function(idx){
                    if(options.callback){
                        options.callback(idx);
                    }
                }
            });
        }else{
            M.pop.alert({
                title : options.title || "알림",
                message : options.message || "",
                buttons : options.buttons || ["확인"],
                callback : function(idx){
                    if(options.callback){
                        options.callback(idx);
                    }
                }
            });
        }

    },

    confirm : function(options){
        M.pop.alert({
            title : options.title || "알림",
            message : options.message || "",
            buttons : options.buttons || ["취소", "확인"],
            callback : function(idx){
                if(options.callback){
                    options.callback(idx);
                }
            }
        });
    },

    date : function(options, callback){
        M.pop.date({
            type : options.type || "YMD",
            initDate : options.initDate || moment().format("YYYYMMDD"),
            startDate : options.startDate || "19000101",
            endDate : options.endDate || "21001231",
            minDate : options.minDate || "19000101",
            maxDate : options.maxDate || "21001231",
        }, function(result, setting){
            if(callback){
                callback(result, setting);
            }
        });
    },

    listSingle : function(options, callback){
        if(!options.list){
            this.alert("목록을 세팅해주세요.");
            return;
        }

        M.pop.list({
            mode : "SINGLE",
            title : options.title || "알림",
            buttons : options.buttons || ["취소", "확인"],
            list : options.list || [],
            selected : options.selected || 0
        }, function(buttonIdx, rowInfo, setting){
            if(callback){
                callback(buttonIdx, rowInfo, setting);
            }
        });
    },

    listMulti : function(options, callback){
        if(!options.list){
            this.alert("목록을 세팅해주세요.");
            return;
        }
        M.pop.list({
            mode : "MULTI",
            title : options.title || "알림",
            buttons : options.buttons || ["취소", "확인"],
            list : options.list || [],
            selected : options.selected || [0]
        }, function(buttonIdx, rowInfo, setting){
            if(callback){
                callback(buttonIdx, rowInfo, setting);
            }
        });
    },

    instance : function(param){
        if(typeof param == "object"){
            M.pop.instance({
                message : param.message,
                time : param.time || "SHORT"
            });
        }else{
            M.pop.instance({
                message : param
            });
        }
    }
};
var getOSType = function(){
    return MNavigator.os();
};



/** ==================================<<!START WNInterface.js 중복 코드>>================================== **/
var ExAjax = new function() {

    this.cbfuncs = {};

    this.ajax = function(params) {
        var _type = (params.type == undefined || params.type == '') ? 'GET' : params.type;
        var _url  = params.url;
        if(params.url == undefined || params.url == '') {
            throw new Exception('url is null');
        }
        var _enc     = params.encoding == undefined ? 'UTF-8' : params.encoding;
        if(_enc != 'UTF-8' && _enc != 'EUC-KR') _enc = 'UTF-8';
        var _header  = params.header  == undefined ? {} : params.header;
        var _body    = params.body    == undefined ? '' : params.body;
        var _success = params.success == undefined ? function(){} : params.success;
        var _fail    = params.fail    == undefined ? function(){} : params.fail;

        var _s_cb_key = this.cbKeygen(_success);
        var _f_cb_key = this.cbKeygen(_fail);

        var _params = {
            type     : _type,
            url      : _url,
            header   : _header,
            body     : _body,
            encoding : _enc,
            success  : _s_cb_key,
            fail     : _f_cb_key,
        };
        WN2Common("exWNAjax", (JSON.stringify(_params)));
    };
    this.cbKeygen = function (cbfunc) {
        var key = '';
        while (true) {
            key = getRandom(17)+"";
            if (this.cbfuncs[key] == undefined) break;
        }
        this.cbfuncs[key] = cbfunc;

        return key;
    }
};
function cryptoRandom(){
    var array = new Uint32Array(1),
        max = Math.pow(2, 32),
        randomValue = window.crypto.getRandomValues(array)[0] / max;
    return randomValue;
}
function getRandom(power) {//1=>=>1~9, 2=>1~999
    var _range= Math.pow(10, power);
    return Math.floor(cryptoRandom() * _range);
}

/***
 * 암호화
 * @param src
 * @param key
 * @param ivkey
 * @returns {*|string}
 */
function exWNDecryptString(src, key, ivkey){	// storage key,value 복호화
    if(arguments.length == 1){
        return WN2Common('exWNDecryptString', src, "", "");
    }else if(arguments.length == 2){
        return WN2Common('exWNDecryptString', src, key, "");
    }else if(arguments.length == 3){
        return WN2Common('exWNDecryptString', src, key, ivkey);
    }
}
/***
 * 복호화
 * @param src
 * @param key
 * @param ivkey
 * @returns {*|string}
 */
function exWNEncryptString(src , key, ivkey){	// storage key,value 암호화
    if(arguments.length == 1){
        return WN2Common('exWNEncryptString', src, "", "");
    }else if(arguments.length == 2){
        return WN2Common('exWNEncryptString', src, key, "");
    }else if(arguments.length == 3){
        return WN2Common('exWNEncryptString', src, key, ivkey);
    }
}

function checkPermission() {	//필수권한 체크
    if(getOSType().toLowerCase() == "android"){
        return WN2Common('exWNcheckPermission');
    }else{
        return 	"true";
    }
}

var getFCMToken = function(_token) {	//전역토큰 -> 네이티브토큰(exWNgetFCMToken) -> 서버에 토큰저장(onRefreshFCMToken) -> getFCMToken재호출 전역에 저장.
    console.log("getFCMToken()--FCM Token 가져오기");
    var token = MData.global("FCMToken");
    if (!isEmpty(token)) {
        console.log("getFCMToken()-- Token 존재 : "+token);
        return token;
    }
    var _appOsCcd = wnIf.device == DT_ANDROID ? "AOS" : "IOS";
    if(_appOsCcd == "AOS"){
        if(isEmpty(_token)){
            console.log("AOS getFCMToken()-- Token 없어서 native exWNgetFCMToken 호출: "+token);
            WN2Common('exWNgetFCMToken');
            return;
        }else{
            token = _token;
        }
    }else{
        console.log("IOS getFCMToken()-- Token 없어서 native exWNgetFCMToken 호출: "+token);
        token = WN2Common('exWNgetFCMToken');
    }

    MData.global("FCMToken", token);
    return token;
}
/** ==================================<< WNInterface 중복 코드 END! >>================================== **/
/** ==================================<< !START Util성 코드 >>================================== **/
var isEmpty = function (obj) {

    var hasOwnProperty = Object.prototype.hasOwnProperty;
    if (typeof obj == "number") obj = obj+"";

    if (obj == null) return true;
    if (obj == undefined) return true;

    if (obj.length > 0)    return false;
    if (obj.length === 0)  return true;

    for (var key in obj) {
        if (hasOwnProperty.call(obj, key)) return false;
    }

    return true;
}

var cleanXSS = function(value){
    value = value.replace(/&lt;/gi, "<");
    value = value.replace(/&gt;/gi, ">");
    value = value.replace(/&#40;/gi, "(");
    value = value.replace(/&#41;/gi, ")");
    value = value.replace(/&#39;/gi, "'");

    return value;
};

/**
 *  특정 스택을 제거
 */
var stackRemove =function(_url){
    var stackInfo = MInfo.stack();
    for(var i=0; i<stackInfo.length; i++){
        var _os = MNavigator.os().toLowerCase();
        var path = ""
        if(_os == "android" || _os == "ios"){
            path =  stackInfo[i].path;
        }else{
            path =  stackInfo[i].key;
        }
        if(path.indexOf(_url) > -1){
            MPage.remove(path);
        }
    }
}

var checkVerifyUrl = function(url) {
    if (!isUseVerifyUrl()) {
        return url;
    }


    var _urls = url.split("/");
    var verifyUrl = "";
    for(var i in _urls){
        if (i == _urls.length - 1) {
            verifyUrl += "verify" + _urls[i][0].toUpperCase() + _urls[i].slice(1);//arr[i].replace(/\b[a-z]/, letter => letter.toUpperCase());
        } else {
            verifyUrl += _urls[i] + "/";
        }
    }

    return verifyUrl;
};

var isUseVerifyUrl = function() {
    var os = PGV.device.os.name.toLowerCase();
    var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));	// 앱 버전

    if (os == "android") {
        //Android 최근 버전이 1.1.10 => 해당 버전때문에 앞 3자리만 체크
        if(_appVersion < CONSTANT.USE_VERIFY_ANDROID_VERSION){
            return false;
        }
    } else {
        if(_appVersion < CONSTANT.USE_VERIFY_IOS_VERSION){
            return false;
        }
    }

    return true;
}
/** ==================================<< Util성 코드 END! >>================================== **/
var _MOCK_RES = {
    /* 공통_앱버전조회 */
    "RNW-CMM-1001": {
        response: {
            "body": {
                "resultCode": "200",
                "resultMsg": "정상적으로 처리 되었습니다.",
                "vinVer": "02.00.00",
                "binVerStr": "2.0.0",
                "platCd": "10",
                "platNm": "안드로이드",
                "dplyVer": "000311"
            },
        }
    },
    "RNW-CMM-3011": {
        response: {
            "body": {
                "resultCode": "200",
                "resultMsg": "정상적으로 처리 되었습니다.",
                "pushIdEqualYn": "N"
            }
        }
    },
    "RNW-CMM-3012": {
        response: {
            "body": {
                "resultCode": "200",
                "resultMsg": "정상적으로 처리 되었습니다."
            }
        }
    },
    "RNW-CMM-5001": {
        response: {
            "body": {
                "resultCode": "200",
                "resultMsg": "success",
            }
        }
    },
    "RNW-CMM-5002": {
        response: {
            "body": {
                "resultCode": "200",
                "resultMsg": "정상적으로 처리 되었습니다.",
                "myCarInfoListResDto": [
                    {
                        "vin": "KNAE251ABJS000687",
                        "vehlRepnCd": "CK",
                        "carRgstNo": "01너4277",
                        "mdlNm": "CK",
                        "carAlias": "애칭인가1",
                        "dispNo": 1,
                        "carOwnGbnCcd": "01",
                        "outerColorCd": "UD",
                        "outerColorNm": null,
                        "carImgUri": "http://www.url5Y.com",
                        "repCarImgUri": "http://www.url5Y.com",
                        "ownerNm": "강민영",
                        "ownerID": "mtest@test.com",
                        "agreeYn": null,
                        "rdmYn": "N",
                        "csmrMgmtNo": "A201706290000753",
                        "memEvYn": "N",
                        "luxuryYn": "Y",
                        "freeCareYn": "Y",
                        "contNo": null,
                        "contYmd": null,
                        "whotYmd": "20200513",
                        "master": null,
                        "carId": null,
                        "masterCarId": null,
                        "saleCarmdlEnNm": null
                    },
                    {
                        "vin": "KNAB1212BHT001122",
                        "vehlRepnCd": "PS",
                        "carRgstNo": "12가1234",
                        "mdlNm": "EV6",
                        "carAlias": null,
                        "dispNo": 2,
                        "carOwnGbnCcd": "01",
                        "outerColorCd": null,
                        "outerColorNm": null,
                        "carImgUri": null,
                        "repCarImgUri": null,
                        "ownerNm": "강민영",
                        "ownerID": "mtest@test.com",
                        "agreeYn": null,
                        "rdmYn": "N",
                        "csmrMgmtNo": "A201706290000753",
                        "memEvYn": "Y",
                        "luxuryYn": "N",
                        "freeCareYn": "N",
                        "contNo": null,
                        "contYmd": null,
                        "whotYmd": "20210520",
                        "master": null,
                        "carId": null,
                        "masterCarId": null,
                        "saleCarmdlEnNm": null
                    },
                    {
                        "vin": "KNAS2418BKS002001",
                        "vehlRepnCd": "JR",
                        "carRgstNo": "50나1111",
                        "mdlNm": "K9",
                        "carAlias": null,
                        "dispNo": 3,
                        "carOwnGbnCcd": "01",
                        "outerColorCd": null,
                        "outerColorNm": null,
                        "carImgUri": null,
                        "repCarImgUri": "http://www.url9Y.com",
                        "ownerNm": "강민영",
                        "ownerID": "mtest@test.com",
                        "agreeYn": null,
                        "rdmYn": "N",
                        "csmrMgmtNo": "A201706290000753",
                        "memEvYn": "N",
                        "luxuryYn": "Y",
                        "freeCareYn": "Y",
                        "contNo": null,
                        "contYmd": null,
                        "whotYmd": "20200411",
                        "master": "Y",
                        "carId": "B",
                        "masterCarId": "A",
                        "saleCarmdlEnNm": "EV6"
                    }
                ],
                "unDeliveryCarInfoListResDto": [{
                    "contNo": "strting",
                    "vin": "strting",
                    "vehlRepnCd": "strting",
                    "krspcNm": "strting",
                    "contYmd": "strting",
                    "whotYmd": "strting",
                    "outerColorCd": "strting",
                    "outerColorNm": "strting",
                    "carImgUri": "strting",
                    "repCarImgUri": "http://www.url5Y.com",
                    "carAmt": "strting",
                    "optAmt": "strting",
                    "basAmt": "strting",
                    "hbAmt": "strting",
                    "totSalAmt": "strting",
                    "empNm": "strting",
                    "empNo": "strting",
                }],

                "contCarListRnwResDto":
                    [],
            }
        }
    },
}