/* 2024.01.10 GA4 - GTM 적용 소스 반영
   기존 initGoogleAnalytics 는 initGoogleAnalytics_bak 으로 변경
   GTM-PG8H5B7C 적용 JS 적용 <head> 와 <body> 적용
   sceenName 이 없을 경우 보내지 않는다
 */
var initGoogleAnalytics = function() {
    window.dataLayer = window.dataLayer || [];

    (function(w,d,s,l,i,h){w[l]=w[l]||[];w[l].push({'gtm.start':
            new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(h)[0],
        j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
        'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.insertBefore(j, f.children[0]);
    })(window,document,'script','dataLayer','GTM-PG8H5B7C', 'head');

    injectIframeGA4();
}

var injectIframeGA4 = function () {
    var body = document.getElementsByTagName("body")[0];
    var noscript = document.createElement("noscript");
    var iframe = document.createElement("iframe");
    iframe.setAttribute("src", "https://www.googletagmanager.com/ns.html?id=GTM-PG8H5B7C");
    iframe.setAttribute("height", "0");
    iframe.setAttribute("width", "0");
    iframe.setAttribute("style", "display:none;visibility:hidden");
    noscript.appendChild(iframe);
    body.insertBefore(noscript, body.children[0]);
}

var sendGA4 = function(DataSend){
    window.dataLayer = window.dataLayer || [];
    dataLayer.push(DataSend);
    // console.log("sendGA4 : " + JSON.stringify(dataLayer));
}

var screenViewGa = function(screenName){
    var _screenName = "";
    if(arguments.length == 0){
        if(PATH_MANAGER[PGV.currentPage.split(".")[0]]){
            _screenName = PATH_MANAGER[PGV.currentPage.split(".")[0]].desc;
        }
    }else{
        _screenName = screenName;
    }

    if(!isEmpty(_screenName)){
        var DataSend = new Object();
        DataSend.event = 'ga_event';
        DataSend.event_name = 'screen_view';
        DataSend.appName = 'MyKia';
        DataSend.appVersion = M.info.app().app.version;
        DataSend.screenName = _screenName;
        sendGA4(DataSend);
    }
};

var eventLog = function(eventName, screenName, evAction) {
    var _screenName = "";
    var _action = evAction;
    if(isEmpty(screenName)){
        if(gaSendUrl.hasOwnProperty(PGV.currentPage.split(".")[0]) == true){
            _screenName = gaSendUrl[PGV.currentPage.split(".")[0]].pageNm;
        }
    }else{
        _screenName = screenName;
    }
    if (isEmpty(_action)) {
        _action = 'button';
    }

    // event
    if(!isEmpty(_screenName)){
        var DataSend = new Object();
        DataSend.event = 'ga_log';
        DataSend.event_name = eventName;
        DataSend.event_action = _action;
        DataSend.screenName = _screenName;
        sendGA4(DataSend);
    }
}

var searchGaLinkName = function(url){
    var keyName = "";
    for(var i in CONSTANT.LINK_URL){
        if(CONSTANT.LINK_URL[i].URL == url){
            keyName = i;
        }
    }

    var pageNm = "";
    if(gaSendUrl.hasOwnProperty(keyName) == true){
        pageNm = gaSendUrl[keyName].pageNm;
    }
    return pageNm;
};

var initGoogleAnalytics_bak = function(){
	(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
		(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
		m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
	})(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
	
	createGa();
};

var createGa = function(){
	//googleAnalytis clientId 저장 여부 확인 
	// var gaClientId = !isEmpty(MData.storage("gaClientId")) ? MData.storage("gaClientId") : "";
	//var gaClientId = MInfo.device().uuid;
	var gaClientId = PGV.device.uuid;
	//if(isEmpty(PGV.loginInfo) == false){ // 로그인 정보가 있는지 체크 20200518 로그인 없는 사용자도 받도록 수정
		if(!isEmpty(gaClientId)){
			ga('create', 'UA-125323119-1', {
			    'storage': 'none',
			    'clientId': gaClientId
		  	});
		  	ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
		  	//GA 연령/성별 통계 추가
		  	//ga('require', 'displayfeatures');
		 	ga(function(tracker) {
		  		MData.storage("gaClientId", tracker.get('clientId'));
		  		// console.log(MData.storage("gaClientId")); 
		  	});
		}
		//else{
			//ga('create', 'UA-125323119-1', 'auto');
			// console.log("don't have clientId"); 
		//}
	//}
	// 기존 GA 방식은 쿠키체크로 인해서 쿠키변경되면 새로운 유저로 인식 
	// ga('create', {
	// 	trackingId: 'UA-125323119-1',	//추적 ID
	// 	cookieDomain: 'auto',
	// 	userId: 'GUEST' //사용자 ID
	// });
};

var screenViewGa_bak = function(screenName){
	//if(isEmpty(PGV.loginInfo) == false){ // 로그인 정보가 있는지 체크 ga 추가 개발
		var _screenName = "";
		if(arguments.length == 0){
			if(PATH_MANAGER[PGV.currentPage.split(".")[0]]){ // 케이스마텍 추헌남 - hasOwnProperty 제거하였습니다.
				_screenName = PATH_MANAGER[PGV.currentPage.split(".")[0]].desc;
				// console.log("set_screenName1= "+_screenName); //ga 테스트 
			}
		}else{
			_screenName = screenName;
			// console.log("set_screenName2= "+screenName); //ga 테스트 
		}
		
		if(!isEmpty(_screenName)){
			// console.log("send_screenName= "+_screenName); //ga 테스트
			ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
			ga('send', 'screenview', {
				appName: 'KIA_VIK',
				appVersion : M.info.app().app.version,
				screenName: _screenName
			});
		}
	//}

};

var eventLog_bak = function(eventName, screenName, evAction) {
    var _screenName = "";
    var _action = evAction;
    if(isEmpty(screenName)){
        if(gaSendUrl.hasOwnProperty(PGV.currentPage.split(".")[0]) == true){
            _screenName = gaSendUrl[PGV.currentPage.split(".")[0]].pageNm;
        }
    }else{
        _screenName = screenName;
    }
    if (isEmpty(_action)) {
        _action = 'button';
    }

	if(!isEmpty(eventName)){
	    //console.log("send event log  eventName=" + eventName + ",screenName=" +_screenName + ",action=" + _action);
	    ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
    	ga('send', 'event', eventName, _action, _screenName);
    }
}

var VIKError = /*#__PURE__*/function (_Error) {
	_inherits(VIKError, _Error);
  
	var _super = _createSuper(VIKError);
  
	function VIKError(message, name) {
	  var _this;
  
	  _classCallCheck(this, VIKError);
  
	  _this = _super.call(this, message);
	  _this.name = "VIKError [" + name + "]";
	  return _this;
	}
  
	return _createClass(VIKError);
  }( /*#__PURE__*/_wrapNativeSuper(Error));
  
var VIKApiError = /*#__PURE__*/function (_Error2) {
_inherits(VIKApiError, _Error2);

var _super2 = _createSuper(VIKApiError);

function VIKApiError(message, name) {
  var _this2;

  _classCallCheck(this, VIKApiError);

  _this2 = _super2.call(this, message);
  _this2.name = "VIKApiError [" + name + "]";
  return _this2;
}

return _createClass(VIKApiError);
}( /*#__PURE__*/_wrapNativeSuper(Error));

var CCSApiError = /*#__PURE__*/function (_Error3) {
_inherits(CCSApiError, _Error3);

var _super3 = _createSuper(CCSApiError);

function CCSApiError(message, name) {
  var _this3;

  _classCallCheck(this, CCSApiError);

  _this3 = _super3.call(this, message);
  _this3.name = "CCSApiError [" + name + "]";
  return _this3;
}

return _createClass(CCSApiError);
}( /*#__PURE__*/_wrapNativeSuper(Error)); // STraffic Network Error Log 분리 (2021.07.19 네이버시스템-강보경)

var STrafficNetworkError = /*#__PURE__*/function (_Error4) {
_inherits(STrafficNetworkError, _Error4);

var _super4 = _createSuper(STrafficNetworkError);

function STrafficNetworkError(message, name) {
  var _this4;

  _classCallCheck(this, STrafficNetworkError);

  _this4 = _super4.call(this, message);
  _this4.name = "STrafficNetworkError [" + name + "]";
  return _this4;
}

return _createClass(STrafficNetworkError);
}( /*#__PURE__*/_wrapNativeSuper(Error)); // TMap Error Log 분리

var TMapError = /*#__PURE__*/function (_Error5) {
_inherits(TMapError, _Error5);

var _super5 = _createSuper(TMapError);

function TMapError(message, name) {
  var _this5;

  _classCallCheck(this, TMapError);

  _this5 = _super5.call(this, message);
  _this5.name = "TMapError [" + name + "]";
  return _this5;
}

return _createClass(TMapError);
}( /*#__PURE__*/_wrapNativeSuper(Error)); // Routo Map Error Log 분리

var RoutoMapError = /*#__PURE__*/function (_Error6) {
	_inherits(RoutoMapError, _Error6);
  
	var _super6 = _createSuper(RoutoMapError);
  
	function RoutoMapError(message, name) {
	  var _this6;
  
	  _classCallCheck(this, RoutoMapError);
  
	  _this6 = _super6.call(this, message);
	  _this6.name = "RoutoMapError [" + name + "]";
	  return _this6;
	}
  
	return _createClass(RoutoMapError);
  }( /*#__PURE__*/_wrapNativeSuper(Error));


var sendSentryApiPkeyErrorLog = function(path, code, msg, data, pkey) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function(scope) {
        scope.setTag("path", path);
        scope.setTag("errorCode", code);
        scope.setTag("errorMessage", msg);
        if (data) {
            for (var key in data) {
                scope.setExtra(key, data[key]);
            }
        }
        scope.setExtra("p_key", pkey);
        scope.setLevel("warning");
        var codePath = path + ":" + code;
        //Sentry.captureMessage("httpSend Error [" + path + "]");
        Sentry.captureException(new VIKApiError("httpSend Error [" + codePath +"]", codePath));
    });
}

var sendSentryApiErrorLog = function(path, code, msg, data) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function(scope) {
        scope.setTag("path", path);
        scope.setTag("errorCode", code);
        scope.setTag("errorMessage", msg);
        if (data) {
            for (var key in data) {
                scope.setExtra(key, isEmpty(data[key]) ? "no" : "yes");
            }
        }
        scope.setLevel("warning");
        var codePath = path + ":" + code;
        //Sentry.captureMessage("httpSend Error [" + path + "]");
        Sentry.captureException(new VIKApiError("httpSend Error [" + codePath +"]", codePath));
    });
}

var sendSentryVIKErrorLog = function(path, msg) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;

    Sentry.captureException(new VIKError("VIKError Error [" + msg +"]", path));
}

var sendSentryApiCCSErrorLog = function(path, code, msg, param, data, auth) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function(scope) {
        scope.setTag("path", path);
        scope.setTag("errorCode", code);

        if (msg && (typeof msg != "string")) {
            scope.setExtra("msg", JSON.stringify(msg));
        } else {
            scope.setTag("errorMessage", msg);
        }

        //개인정보는 암호화해서 전달.
        if (param && (typeof param != "string")) {
            scope.setExtra("param", exWNEncryptString(JSON.stringify(param)));
        }

        if (data && (typeof data != "string")) {
            scope.setExtra("data", exWNEncryptString(JSON.stringify(data)));
        }


        //accessToken은 첨부 유무만.
        //scope.setExtra("access", isEmpty(auth) ? "NO" : "YES");
        //임시로 수집
        scope.setExtra("access", auth);

        scope.setLevel("warning");
        var codePath = path + ":" + code;

        Sentry.captureException(new CCSApiError("CCS Error [" + codePath +"]", codePath));
    });
}

// STraffic Network Error Log 분리 (2021.07.19 네이버시스템-강보경)
var sendSTrafficApiErrorLog = function(path, code, msg, param, data, auth){
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function(scope) {
        scope.setTag("path", path);
        scope.setTag("errorCode", code);

        if (msg && (typeof msg != "string")) {
            scope.setExtra("msg", JSON.stringify(msg));
        } else {
            scope.setTag("errorMessage", msg);
        }

        //개인정보는 암호화해서 전달.
        if (param && (typeof param != "string")) {
            scope.setExtra("param", exWNEncryptString(JSON.stringify(param)));
        }

        if (data && (typeof data != "string")) {
            scope.setExtra("data", exWNEncryptString(JSON.stringify(data)));
        }


        //accessToken은 첨부 유무만.
//        scope.setExtra("access", isEmpty(auth) ? "NO" : "YES");

        scope.setLevel("warning");
        var codePath = path + ":" + code;

        Sentry.captureException(new STrafficNetworkError("STraffic Network Error [" + codePath +"]", codePath));
    });
}

// TMap Error Log 분리
var sendTMapErrorLog = function( code, msg){
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function(scope) {
        scope.setTag("errorCode", code);

        if (msg && (typeof msg != "string")) {
            scope.setExtra("msg", JSON.stringify(msg));
        } else {
            scope.setTag("errorMessage", msg);
        }

        scope.setLevel("warning");
        var codePath = "TMap :" + code;

        Sentry.captureException(new TMapError("TMap Error [" + codePath +"]", codePath));
    });
}

// Routo Map Error Log 분리
var sendRoutoMapErrorLog = function( code, msg){
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function(scope) {
        scope.setTag("errorCode", code);

        if (msg && (typeof msg != "string")) {
            scope.setExtra("msg", JSON.stringify(msg));
        } else {
            scope.setTag("errorMessage", msg);
        }

        scope.setLevel("warning");
        var codePath = "RoutoMap :" + code;

        Sentry.captureException(new RoutoMapError("RoutoMap Error [" + codePath +"]", codePath));
    });
}

var SNTR = {
  sendSentryApiPkeyErrorLog: function sendSentryApiPkeyErrorLog(path, code, msg, data, pkey) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function (scope) {
      scope.setTag("path", path);
      scope.setTag("errorCode", code);
      scope.setTag("errorMessage", msg);

      if (data) {
        for (var key in data) {
          scope.setExtra(key, data[key]);
        }
      }

      scope.setExtra("p_key", pkey);
      scope.setLevel("warning");
      var codePath = path + ":" + code; //Sentry.captureMessage("httpSend Error [" + path + "]");

      Sentry.captureException(new VIKApiError("httpSend Error [" + codePath + "]", codePath));
    });
  },
  sendSentryApiErrorLog: function sendSentryApiErrorLog(path, code, msg, data) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function (scope) {
      scope.setTag("path", path);
      scope.setTag("errorCode", code);
      scope.setTag("errorMessage", msg);

      if (data) {
        for (var key in data) {
          scope.setExtra(key, isEmpty(data[key]) ? "no" : "yes");
        }
      }

      scope.setLevel("warning");
      var codePath = path + ":" + code; //Sentry.captureMessage("httpSend Error [" + path + "]");

      Sentry.captureException(new VIKApiError("httpSend Error [" + codePath + "]", codePath));
    });
  },
  sendSentryVIKErrorLog: function sendSentryVIKErrorLog(path, msg) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.captureException(new VIKError("VIKError Error [" + msg + "]", path));
  },
  sendSentryApiCCSErrorLog: function sendSentryApiCCSErrorLog(path, code, msg, param, data, auth) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function (scope) {
      scope.setTag("path", path);
      scope.setTag("errorCode", code);

      if (msg && typeof msg != "string") {
        scope.setExtra("msg", JSON.stringify(msg));
      } else {
        scope.setTag("errorMessage", msg);
      } //개인정보는 암호화해서 전달.


      if (param && typeof param != "string") {
        scope.setExtra("param", exWNEncryptString(JSON.stringify(param)));
      }

      if (data && typeof data != "string") {
        scope.setExtra("data", exWNEncryptString(JSON.stringify(data)));
      } //accessToken은 첨부 유무만.
      //scope.setExtra("access", isEmpty(auth) ? "NO" : "YES");
      //임시로 수집


      scope.setExtra("access", auth);
      scope.setLevel("warning");
      var codePath = path + ":" + code;
      Sentry.captureException(new CCSApiError("CCS Error [" + codePath + "]", codePath));
    });
  },
  // STraffic Network Error Log 분리 (2021.07.19 네이버시스템-강보경)
  sendSTrafficApiErrorLog: function sendSTrafficApiErrorLog(path, code, msg, param, data, auth) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function (scope) {
      scope.setTag("path", path);
      scope.setTag("errorCode", code);

      if (msg && typeof msg != "string") {
        scope.setExtra("msg", JSON.stringify(msg));
      } else {
        scope.setTag("errorMessage", msg);
      } //개인정보는 암호화해서 전달.


      if (param && typeof param != "string") {
        scope.setExtra("param", exWNEncryptString(JSON.stringify(param)));
      }

      if (data && typeof data != "string") {
        scope.setExtra("data", exWNEncryptString(JSON.stringify(data)));
      } //accessToken은 첨부 유무만.
      //        scope.setExtra("access", isEmpty(auth) ? "NO" : "YES");


      scope.setLevel("warning");
      var codePath = path + ":" + code;
      Sentry.captureException(new STrafficNetworkError("STraffic Network Error [" + codePath + "]", codePath));
    });
  },
  // TMap Error Log 분리
  sendTMapErrorLog: function sendTMapErrorLog(code, msg) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function (scope) {
      scope.setTag("errorCode", code);

      if (msg && typeof msg != "string") {
        scope.setExtra("msg", JSON.stringify(msg));
      } else {
        scope.setTag("errorMessage", msg);
      }

      scope.setLevel("warning");
      var codePath = "TMap :" + code;
      Sentry.captureException(new TMapError("TMap Error [" + codePath + "]", codePath));
    });
  },
  // Routo Map Error Log 분리
  sendRoutoMapErrorLog: function sendRoutoMapErrorLog(code, msg) {
    if (typeof Sentry === "undefined") return;
    if (CONFIG.IS_SENTRY == false) return;
    Sentry.withScope(function (scope) {
      scope.setTag("errorCode", code);

      if (msg && typeof msg != "string") {
        scope.setExtra("msg", JSON.stringify(msg));
      } else {
        scope.setTag("errorMessage", msg);
      }

      scope.setLevel("warning");
      var codePath = "RoutoMap :" + code;
      Sentry.captureException(new RoutoMapError("RoutoMap Error [" + codePath + "]", codePath));
    });
  }
};
var gaSendUrl = {
	KIA_RNW_931_0000 : {pageNm : "매뉴얼 > 사용설명서", type : "WEB"}, // AS-IS 코드 활용을 위해 임의 추가
	KIA_MOB_000_1000 : {pageNm : "인트로", type : "PAGE"},
	KIA_MOB_000_1010 : {pageNm : "앱 접근권한 안내", type : "PAGE"},
	KIA_MOB_000_1020 : {pageNm : "온보딩", type : "PAGE"},
	KIA_MOB_000_1030 : {pageNm : "이벤트/공지사항 팝업", type : "POPUP(GET)"},   // 페이지 존재, 사용안함
	KIA_MOB_000_1040 : {pageNm : "Push On 알림 팝업", type : "POPUP(GET)"},
	KIA_MOB_000_1050 : {pageNm : "오늘의 카썰", type : "POPUP(GET)"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1100 : {pageNm : "메인(로그인 전)", type : "PAGE"},
	KIA_MOB_000_1101 : {pageNm : "마이페이지 > 서비스 이용 약관 > MyKia 개인정보 처리 방침", type : "PAGE"},
	KIA_MOB_000_1102 : {pageNm : "마이페이지 > 서비스 이용 약관 > MyKia 이용 약관", type : "PAGE"},
	KIA_MOB_000_1103 : {pageNm : "채널기아 팝업", type : "POPUP(GET)"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1104 : {pageNm : "마케팅 이용동의", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1105 : {pageNm : "기아멤버스 웹사이트", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1106 : {pageNm : "기아멤버스 이용약관", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1107 : {pageNm : "필수적 개인정보 수집·이용에 대한 동의", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1110 : {pageNm : "메인(로그인 후)", type : "PAGE"},
	KIA_MOB_000_1111 : {pageNm : "차량등록 안내 팝업", type : "POPUP(GET)"},    // 페이지 존재, 퍼블 적용 확인필요
	KIA_MOB_000_1112 : {pageNm : "메인 > K3 마이크로", type : "POPUP(GET)"},    // 페이지 없음
	KIA_MOB_000_1113 : {pageNm : "메인 > 스포티지", type : "POPUP(GET)"},    // 페이지 없음
	KIA_MOB_000_1120 : {pageNm : "메인(로그인 후)", type : ""},    // 페이지 없음
	KIA_MOB_000_1122 : {pageNm : "주행거리 입력 팝업", type : "POPUP(GET)"},
	KIA_MOB_000_1123 : {pageNm : "모바일 카드", type : "PAGE"},    // 페이지 없음
	KIA_MOB_000_1124 : {pageNm : "현대카드 M 포인트 조회 설정", type : "PAGE"},
	KIA_MOB_000_1125 : {pageNm : "M 포인트 개인정보 제공동의 약관", type : "PAGE"},
	KIA_MOB_000_1126 : {pageNm : "현대카드 M 포인트 조회 팝업", type : "POPUP(GET)"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1130 : {pageNm : "비밀번호 변경 안내 팝업", type : "POPUP(GET)"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1200 : {pageNm : "메인(전체메뉴)", type : "PAGE"},
	KIA_MOB_000_1300 : {pageNm : "로그인", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1310 : {pageNm : "아이디 찾기", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_000_1400 : {pageNm : "회원가입", type : "WEB"},    // 페이지 없음
	KIA_MOB_000_1500 : {pageNm : "음성인식 안내", type : "POPUP(GET)"},    // 페이지 존재, 퍼블 적용 확인필요
	KIA_MOB_000_2000 : {pageNm : "메인 > 온드미디어(VIK NEWS)", type : "PAGE"},    // 페이지 없음
	KIA_MOB_100_1000 : {pageNm : "전체 모델 > 차량 정보", type : "PAGE"},
	KIA_MOB_100_1010 : {pageNm : "Kia EV > 차량 정보", type : "PAGE"},
	KIA_MOB_100_1001 : {pageNm : "차량 상세화면", type : "WEB"},
	KIA_MOB_100_1100 : {pageNm : "시승기", type : "WEB"},    // 페이지 url 없음
	KIA_MOB_100_1101 : {pageNm : "시승기 상세화면", type : "PAGE"},    // 페이지 존재, 퍼블 적용 확인필요
	KIA_MOB_100_1200 : {pageNm : "신차 광고", type : "PAGE"},    // 페이지 존재, 퍼블 적용 확인필요
	KIA_MOB_100_1300 : {pageNm : "메인(차량구매)", type : "PAGE"},
	KIA_MOB_200_1000 : {pageNm : "구매 정보 > 온라인견적", type : "WEB"},
	KIA_MOB_200_1100 : {pageNm : "구매 정보 > 가격표/카탈로그", type : "WEB"},
	KIA_MOB_200_1200 : {pageNm : "경쟁차비교", type : "WEB"},    // 페이지 없음
	KIA_RNW_313_0000 : {pageNm : "구매 정보 > 이달의 구매혜택", type : "WEB"},
	KIA_MOB_200_1301 : {pageNm : "이달의 구매혜택(현대카드)", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1302 : {pageNm : "장기카드대출(현대카드)", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1310 : {pageNm : "멤버십 혜택", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_200_1311 : {pageNm : "멤버십 혜택 > 포인트 적립/사용", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1312 : {pageNm : "멤버십 혜택 > 포인트 활용방법", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1313 : {pageNm : "멤버십 혜택 > 정기점검 서비스", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1314 : {pageNm : "멤버십 혜택 > 긴급출동/무상견인", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1330 : {pageNm : "기아차전용카드", type : "PAGE"},    // 페이지 없음
	KIA_MOB_200_1331 : {pageNm : "기아차 경차전용카드", type : "TAB"},    // 페이지 존재, 사용안함
	KIA_MOB_200_1332 : {pageNm : "금융 혜택 > KIA_REDMEMBERS 신용카드", type : "WEB"},    // 페이지 없음
	KIA_MOB_200_1333 : {pageNm : "금융 혜택 > KIA_REDMEMBERS Platinum 신용카드", type : "WEB"},    // 페이지 없음
	KIA_MOB_200_1334 : {pageNm : "금융 혜택 > KIA_REDMEMBERS Platinum PLUS 신용카드", type : "WEB"},    // 페이지 없음
	KIA_MOB_200_1335 : {pageNm : "금융 혜택 > KIA_REDMEMBERS 경차전용카드(유류세환급)", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1336 : {pageNm : "금융 혜택 > KIA_REDMEMBERS 경차전용카드", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1337 : {pageNm : "금융 혜택 > KIA_REDMEMBERS 전기차 신용카드", type : "WEB"},    // 페이지 없음
	KIA_MOB_200_1338 : {pageNm : "기아차 전기차전용카드", type : "TAB"},    // 호출 페이지 없음
	KIA_MOB_200_1400 : {pageNm : "상담/체험 > 영업망 조회", type : "WEB"},
	KIA_MOB_200_1500 : {pageNm : "상담/체험 > 시승 안내", type : "WEB"},
	KIA_MOB_200_1600 : {pageNm : "상담/체험 > 전시차 조회", type : "WEB"},
	KIA_MOB_200_1700 : {pageNm : "구매 정보 > 장기렌터카", type : "PAGE"},
	KIA_MOB_200_1701 : {pageNm : "구매 정보 > 장기렌터카 > 단기렌터카 이용안내", type : "WEB"},
	KIA_MOB_200_1702 : {pageNm : "구매 정보 > 장기렌터카 > FAQ", type : "WEB"},
	KIA_MOB_200_1703 : {pageNm : "구매 정보 > 장기렌터카 > 장기렌터카 구입 및 상담", type : "WEB"},
	KIA_MOB_200_1704 : {pageNm : "구매 정보 > 장기렌터카 > 정비 및 반납 문의", type : "WEB"},
	KIA_MOB_200_1705 : {pageNm : "구매 정보 > 장기렌터카 > 장기렌터카 장점", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1706 : {pageNm : "구매 정보 > 장기렌터카 > 리스, 일반 구매 비교", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_200_1707 : {pageNm : "구매 정보 > 장기렌터카 > 무상대차 가능업체 조회", type : "WEB"},
	KIA_MOB_200_1708 : {pageNm : "구매 정보 > 장기렌터카 > 기아렌터카 프로모션", type : "WEB"},
    KIA_MOB_200_1709 : {pageNm : "구매 정보 > 장기렌터카 > 장기렌터카 이용안내", type : "WEB"},
    KIA_MOB_200_1710 : {pageNm : "구매 정보 > 장기렌터카 > 장기렌터카 구비서류 안내", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_200_1800 : {pageNm : "구매 정보 > 전기차 구매가이드", type : "WEB"},
	KIA_MOB_200_1900 : {pageNm : "구매 정보 > KiaFlex", type : "WEB"},
    KIA_MOB_200_2000 : {pageNm : "상담/체험 > Kia 체험거", type : "WEB"},
    KIA_MOB_200_2001 : {pageNm : "상담/체험 > Kia360", type : "WEB"},
    KIA_MOB_200_2002 : {pageNm : "Kia EV > TCO 계산기", type : "WEB"},
	KIA_MOB_300_1000 : {pageNm : "브랜드 소식", type : "WEB"},    // 페이지 없음
	KIA_MOB_300_1400 : {pageNm : "소모품관리", type : "PAGE"},    // 페이지 없음
	KIA_MOB_300_1410 : {pageNm : "정비이력", type : "PAGE"},    // 페이지 없음
	KIA_MOB_300_1430 : {pageNm : "소모품관리 수정", type : "PAGE"},    // 페이지 없음
	KIA_MOB_310_1000 : {pageNm : "모터쇼", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_320_1000 : {pageNm : "이벤트", type : "PAGE"},
	KIA_MOB_320_1001 : {pageNm : "이벤트 > 개인정보 동의", type : "PAGE"},
	KIA_MOB_320_1010 : {pageNm : "이벤트 > 이벤트 상세", type : "PAGE"},
	KIA_MOB_320_1100 : {pageNm : "이벤트 > 종료 이벤트", type : "TAB"},
	KIA_MOB_320_1110 : {pageNm : "이벤트 > 종료 이벤트 상세", type : ""},			//이벤트 상세와 겹침
	KIA_MOB_320_1200 : {pageNm : "당첨자발표 목록", type : "PAGE"},
	KIA_MOB_320_1210 : {pageNm : "당첨자발표 상세", type : ""},			//이벤트 상세와 겹침 
	KIA_MOB_330_1000 : {pageNm : "전체 모델 > 채널 기아", type : "PAGE"},
	KIA_MOB_340_1000 : {pageNm : "KIA Story", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1010 : {pageNm : "응모하기", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1011 : {pageNm : "응모내역", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1012 : {pageNm : "게시물등록", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1020 : {pageNm : "모두의 KIA Story 목록", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1021 : {pageNm : "모두의 KIA Story 상세", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1100 : {pageNm : "출고인증", type : "TAB"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1200 : {pageNm : "KIA Story 우수작", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1201 : {pageNm : "KIA Story 우수작 상세", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_340_1210 : {pageNm : "출고인증샷 당첨자", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_350_1000 : {pageNm : "MyKia", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_360_1000 : {pageNm : "설문", type : "PAGE"},
	KIA_MOB_360_1010 : {pageNm : "설문 > 설문 상세", type : "PAGE"},
	KIA_MOB_360_1011 : {pageNm : "설문 > 설문 완료", type : "PAGE"},
	KIA_MOB_400_1000 : {pageNm : "멤버십 혜택 > 멤버십 안내", type : "PAGE"},
	KIA_MOB_400_1001 : {pageNm : "멤버십 혜택 > 멤버십 안내 > KIA MEMBERS", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_400_1002 : {pageNm : "멤버십 혜택 > 멤버십 안내 > THE K9", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_400_1003 : {pageNm : "멤버십 혜택 > 멤버십 안내 > K9", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_400_1004 : {pageNm : "멤버십 혜택 > 멤버십 안내 > STINGER", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_400_1005 : {pageNm : "멤버십 안내 > 제휴카드", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_400_1006 : {pageNm : "멤버십 혜택 > 멤버십 안내 > 포인트 적립 안내", type : "WEB"},
	KIA_MOB_400_1007 : {pageNm : "멤버십 혜택 > 멤버십 안내 > 포인트 사용처 안내", type : "WEB"},
	KIA_MOB_400_1008 : {pageNm : "멤버십 혜택 > 멤버십 안내 > 멤버십 카드 안내", type : "WEB"},
	KIA_MOB_400_1009 : {pageNm : "멤버십 혜택 > 멤버십 안내 > EV 멤버십 카드 안내", type : "WEB"},
	KIA_MOB_410_1000 : {pageNm : "서비스 안내", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_410_1001 : {pageNm : "과잉정비보상 서비스 안내", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_410_1002 : {pageNm : "서비스안내 > 도어 투 도어", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_410_1003 : {pageNm : "서비스안내 > ONE STOP 서비스", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_410_1004 : {pageNm : "서비스안내 > 프리케어 서비스", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_420_1000 : {pageNm : "내비게이션 업데이트", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_500_0000 : {pageNm : "메인(내차관리)", type : "PAGE"},
	KIA_MOB_500_1000 : {pageNm : "내 차 관리 > 내 차 정보", type : "PAGE"},
	KIA_MOB_500_1001 : {pageNm : "리콜 안내 팝업", type : "POPUP(GET)"},
	KIA_MOB_500_1002 : {pageNm : "리콜 안내문 팝업", type : "POPUP(GET)"},    // 페이지 존재, 사용안함
	KIA_MOB_500_1003 : {pageNm : "전담 AUTO Q 팝업", type : ""}, 		//AUTO Q 상세와 겹침, 사용안함
	KIA_MOB_500_1010 : {pageNm : "프리케어", type : "TAB"},    // 페이지 존재, 사용안함
	KIA_MOB_500_1011 : {pageNm : "내 차 관리 > 내 차 정보 > 프리케어안내", type : "WEB"},
	KIA_MOB_500_1020 : {pageNm : "실운행자", type : "TAB"},
	KIA_MOB_500_1021 : {pageNm : "내 차 관리 > 내 차 정보 > 실 운행자 등록-검색", type : "PAGE"},
	KIA_MOB_500_1022 : {pageNm : "내 차 관리 > 내 차 정보 > 실 운행자 등록-관계", type : "PAGE"},
	KIA_MOB_500_1023 : {pageNm : "내 차 관리 > 내 차 정보 > 실 운행자 등록-완료", type : "PAGE"},
	KIA_MOB_500_1024 : {pageNm : "개인정보 제3자 제공동의-실운행자가 차주에 대한", type : "PAGE"}, //현재 사용안함
	KIA_MOB_500_1025 : {pageNm : "실 운행자 등록동의 팝업", type : "POPUP(GET)"},
	KIA_MOB_500_1030 : {pageNm : "계약 및 출고정보 팝업", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_500_1031 : {pageNm : "차량구입대금 명세서", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_500_1040 : {pageNm : "내 차 관리 > 내 차 정보 > 사양", type : "PAGE"},
	KIA_MOB_500_1060 : {pageNm : "내 차 관리 > 내 차 정보 > 계약 및 출고정보", type : "PAGE"},
	KIA_MOB_500_1060_P : {pageNm : "내 차 관리 > 내 차 정보 > 계약 및 출고 관리(출고전) > 탁송", type : "WEB"},
	KIA_MOB_500_1061 : {pageNm : "차량정보 (차량구입대금 명세서)", type : "TAB"},		//500_1000이랑 겹침
	KIA_MOB_500_1070 : {pageNm : "차량정보", type : ""},		//기아차 미 보유 회원 / 500_1000이랑 겹침, 사용안함
	KIA_MOB_500_1080 : {pageNm : "내 차 관리 > 내 차 정보 > 차량정보수정", type : "PAGE"},
	KIA_MOB_500_1081 : {pageNm : "내 차 관리 > 내 차 정보 > 차량정보수정 사진등록 팝업", type : "POPUP(GET)"},
	KIA_MOB_500_1100 : {pageNm : "내 차 관리 > 정비 이력", type : "PAGE"},
	KIA_MOB_500_1101 : {pageNm : "내 차 관리 > 정비 이력 > 정기 점검", type : "TAB"},
	KIA_MOB_500_1200 : {pageNm : "내 차 관리 > 정비 이력 > 정기 점검 > 정기 점검 상세", type : "PAGE"},
	KIA_MOB_500_1300 : {pageNm : "오토캠", type : "PAGE"},
	KIA_MOB_500_1301 : {pageNm : "오토캠 상세", type : "EVENT"},    // 페이지 존재, 사용안함
	KIA_MOB_500_1400 : {pageNm : "내 차 관리 > 내 차 정보 > 차량 데이터 복구", type : "PAGE"},
	KIA_MOB_500_1500 : {pageNm : "차량 데이터 관리", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_510_1000 : {pageNm : "토탈예약센터", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_510_1100 : {pageNm : "정비/서비스 > AUTO Q 검색", type : "PAGE"},
	KIA_MOB_510_1102 : {pageNm : "정비/서비스 > AUTO Q 검색 > AUTO Q 상세", type : "PAGE"},
	KIA_MOB_510_1103 : {pageNm : "정비/서비스 > AUTO Q 검색-키워드 검색", type : "TAB"},
	KIA_MOB_510_1300 : {pageNm : "정비/서비스 > 정비편의 서비스", type : "PAGE"},
	KIA_MOB_520_1000 : {pageNm : "내카드/포인트", type : "PAGE"},
	KIA_MOB_520_1001 : {pageNm : "Kia Members Point-소멸 예정", type : "TAB"},
	KIA_MOB_520_1010 : {pageNm : "Kia Members Point", type : "PAGE"},
	KIA_MOB_520_1011 : {pageNm : "M Point(적립/사용/만료)-사용", type : "TAB"},
	KIA_MOB_520_1012 : {pageNm : "M Point(적립/사용/만료)-적립", type : "TAB"},
	KIA_MOB_520_1013 : {pageNm : "M Point(적립/사용/만료)-만료", type : "TAB"},
	KIA_MOB_520_1020 : {pageNm : "M Point", type : "PAGE"},
	KIA_MOB_520_1030 : {pageNm : "멤버십 혜택 > 카케어 프로그램 > 진행중 프로그램", type : "PAGE"},
	KIA_MOB_520_1031 : {pageNm : "멤버십 혜택 > 카케어 프로그램 > 종료된 프로그램", type : "TAB"},
	KIA_MOB_520_1040 : {pageNm : "멤버십 혜택 > 라이프케어 프로그램 > 진행중 프로그램", type : "PAGE"},
    KIA_MOB_520_1041 : {pageNm : "멤버십 혜택 > 라이프케어 프로그램 > 종료된 프로그램", type : "TAB"},
	KIA_MOB_520_1100 : {pageNm : "보유 카드", type : "PAGE"},    // 페이지 없음
	KIA_MOB_520_1101 : {pageNm : "Kia Members Point > 사용처 안내", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_520_1110 : {pageNm : "내카드/포인트 > 카드 재발급", type : "PAGE"},
	KIA_MOB_520_1111 : {pageNm : "내카드/포인트 > 카드 재발급 > 카드 재발급 신청", type : "PAGE"},
	KIA_MOB_520_1120 : {pageNm : "내카드/포인트 > 카드교체발급", type : "TAB"},     // 사용안함
	KIA_MOB_520_1121 : {pageNm : "내카드/포인트 > 카드 재발급 > 카드 교체발급 신청", type : "PAGE"},
	KIA_MOB_520_1200 : {pageNm : "간편결제-결제 내역", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_520_1201 : {pageNm : "간편결제 신차구매", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_520_1202 : {pageNm : "간편결제 내 카드조회", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_530_1000 : {pageNm : "내 차 관리 > 차계부 관리 > 제휴사 정보받기", type : "PAGE"},
	KIA_MOB_530_1010 : {pageNm : "내 차 관리 > 차계부 관리", type : "PAGE"},
	KIA_MOB_530_1020 : {pageNm : "내 차 관리 > 차계부 관리 > 연비 계산방식 설정", type : "PAGE"},
	KIA_MOB_530_1030 : {pageNm : "내 차 관리 > 차계부 관리-비용관리", type : "TAB"},
	KIA_MOB_530_1031 : {pageNm : "내 차 관리 > 차계부 관리 > 비용등록-주유", type : "TAB"},
	KIA_MOB_530_1032 : {pageNm : "내 차 관리 > 차계부 관리 > 비용등록-정비", type : "TAB"},
	KIA_MOB_530_1033 : {pageNm : "내 차 관리 > 차계부 관리 > 비용등록-기타", type : "TAB"},
	KIA_MOB_530_1040 : {pageNm : "내 차 관리 > 차계부 관리 > 차트-운행내역", type : "TAB"},	//차계부 차트
	KIA_MOB_530_1041 : {pageNm : "내 차 관리 > 차계부 관리 > 차트-지출내역", type : "TAB"},
	KIA_MOB_540_1000 : {pageNm : "내 차 관리 > 소모품 관리", type : "PAGE"},
	KIA_MOB_540_1010 : {pageNm : "내 차 관리 > 소모품 관리 > 소모품 관리 주기-직접 입력", type : "TAB"},
	KIA_MOB_540_1011 : {pageNm : "내 차 관리 > 소모품 관리 > 소모품 관리 주기-매뉴얼 기준", type : "TAB"},
	KIA_MOB_540_1020 : {pageNm : "정비이력", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_550_1000 : {pageNm : "내 차 관리 > 고급차 특화 서비스", type : "PAGE"},
	KIA_MOB_550_1001 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > K9 브랜드 스토리", type : "WEB"},	//브랜드 스토리 k9
	KIA_MOB_550_1002 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > 스팅어 브랜드 스토리", type : "WEB"},	//브랜드 스토리 스팅어
	KIA_MOB_550_1003 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > k9 프리미엄 케어예약", type : "WEB"},	//k9 프리미엄 케어예약
	KIA_MOB_550_1004 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > 스팅어 프리미엄 케어예약", type : "WEB"},	//스팅어 프리미엄 케어예약
	KIA_MOB_550_1005 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > 프리케어안내", type : "WEB"},
	KIA_MOB_550_1100 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > 프리케어", type : "PAGE"},
	KIA_MOB_550_1200 : {pageNm : "AUTO Q 검색", type : ""},	//오토큐 검색과 겹침 550_1201, 550_1202
    KIA_MOB_550_1201 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > 고급차 AUTO Q 검색", type : ""},	//오토큐 검색과 겹침
    KIA_MOB_550_1202 : {pageNm : "내 차 관리 > 고급차 특화 서비스 > 고급차 AUTO Q 예약", type : ""},	//오토큐 검색과 겹침
	KIA_MOB_550_1210 : {pageNm : "정비/서비스 > 정비 예약", type : "PAGE"},	//정비예약
	KIA_MOB_550_1211 : {pageNm : "정비/서비스 > 정비 예약 > 나의 정비 예약", type : "PAGE"},     // 나의 정비 예약
	KIA_MOB_550_1212 : {pageNm : "정비/서비스 > 정비 예약 > 나의 정비 예약-도어 투 도어 예약", type : "TAB"},
	KIA_MOB_550_1213 : {pageNm : "정비/서비스 > 정비 예약-예약완료", type : "PAGE"},
	KIA_MOB_550_1214 : {pageNm : "AUTO Q 예약 > 예약내역", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_550_1220 : {pageNm : "정비/서비스 > 정비 예약 > 나의 정비 예약 > 정비 예약 상세", type : "PAGE"},
	KIA_MOB_550_1230 : {pageNm : "정비/서비스 > 정비 예약 > 도어 투 도어 서비스 안내", type : "PAGE"},
	KIA_MOB_550_1240 : {pageNm : "도어 투 도어 서비스 예약", type : "PAGE"},
	KIA_MOB_550_1250 : {pageNm : "Door to Door 예약조회", type : "TAB"},        // 페이지 존재, 사용안함
	KIA_MOB_550_1300 : {pageNm : "Smart One Stop 서비스", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_550_1310 : {pageNm : "Smart One Stop 인덱스", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_550_1311 : {pageNm : "입고확인증", type : "PDF"},    // 호출 페이지 사용안함
	KIA_MOB_550_1312 : {pageNm : "견적서", type : "PDF"},    // 호출 페이지 사용안함
	KIA_MOB_550_1313 : {pageNm : "정비진행 현황", type : "PAGE"},
	KIA_MOB_550_1314 : {pageNm : "수리 전, 후 사진 조회", type : "PAGE"},    // 페이지 존재, 퍼블 적용 확인필요
	KIA_MOB_550_1315 : {pageNm : "정비, 점검 명세서", type : "PDF"},    // 호출 페이지 사용안함
	KIA_MOB_560_1000 : {pageNm : "매뉴얼 > 기아 오너스매뉴얼", type : "PAGE"},
	KIA_MOB_560_1100 : {pageNm : "매뉴얼 > 사용설명서", type : "WEB"},
	KIA_MOB_560_1111 : {pageNm : "내 차량 사용설명서", type : ""},		// 560_1100 검색 후 결과, 560_1100 이 웹이라 사용 안함
	KIA_MOB_560_1200 : {pageNm : "전체 모델 > Play AR(증강현실) 체험", type : "PAGE"},
	KIA_MOB_570_1000 : {pageNm : "부품가격", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1000 : {pageNm : "카앤라이프몰", type : "PAGE"},
	KIA_MOB_600_1001 : {pageNm : "카앤라이프몰 > 안내", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1002 : {pageNm : "카앤라이프몰 > 자동차 용품", type : "WEB"},       // iframe
	KIA_MOB_600_1003 : {pageNm : "카앤라이프몰 > 카케어/생활편의", type : "WEB"},       // iframe
	KIA_MOB_600_1004 : {pageNm : "카앤라이프몰 > 차량운행", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1005 : {pageNm : "카앤라이프몰 > 시세조회", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1006 : {pageNm : "카앤라이프몰 > 내차경매", type : "WEB"},    // 호출 페이지 없음
	// KIA_MOB_600_1007 : {pageNm : "스커트", type : "WEB"},
	KIA_MOB_600_1008 : {pageNm : "카앤라이프몰 > 내 차 시세", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1009 : {pageNm : "카앤라이프몰 > TV", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1010 : {pageNm : "카앤라이프몰 > 화끈한 이벤트", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_600_1011 : {pageNm : "카앤라이프몰 > 오토엔 이벤트", type : "WEB"},	    // 호출 페이지 없음
    KIA_MOB_600_1100 : {pageNm : "카앤라이프몰 > 기아브랜드관", type : "PAGE"},	    // 호출 페이지 없음
	KIA_MOB_620_1000 : {pageNm : "보험견적", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_700_1000 : {pageNm : "고객센터", type : "PAGE"},
	KIA_MOB_700_1001 : {pageNm : "FAQ > 기아 홈페이지 FAQ", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_700_1002 : {pageNm : "FAQ > 기아멤버스 FAQ", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_700_1010 : {pageNm : "고객센터 > 1:1상담", type : "PAGE"},
	KIA_MOB_710_1000 : {pageNm : "공지사항", type : "PAGE"},
	KIA_MOB_710_1010 : {pageNm : "공지사항 상세", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_720_1000 : {pageNm : "응급조치", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_730_1000 : {pageNm : "고객상담(콜센터 연결)", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_730_1002 : {pageNm : "카카오톡 채팅상담", type : "EVENT"},    // 호출 페이지 없음
	KIA_MOB_730_1010 : {pageNm : "1:1문의 - 문의하기", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_730_1020 : {pageNm : "1:1문의 - 문의내역", type : "PAGE"},    // 페이지 존재, 사용안함
	// KIA_MOB_730_1020 : {pageNm : "1대1 문의", type : "PAGE"},
	KIA_MOB_740_1000 : {pageNm : "긴급출동안내", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_740_1010 : {pageNm : "무상견인", type : "TAB"},    // 페이지 존재, 사용안함
	KIA_MOB_750_1000 : {pageNm : "멤버십 혜택 > THE MEMBERSHIP 컨시어지", type : "PAGE"},
	KIA_MOB_750_1001 : {pageNm : "멤버십 혜택 > THE MEMBERSHIP 컨시어지 > THE MEMBERSHIP K9", type : "WEB"},
	KIA_MOB_750_1002 : {pageNm : "멤버십 혜택 > THE MEMBERSHIP 컨시어지 > THE K9 MEMBERSHIP", type : "WEB"},
	KIA_MOB_750_1003 : {pageNm : "멤버십 혜택 > THE MEMBERSHIP 컨시어지 > THE K9 STINGER", type : "WEB"},
	KIA_MOB_750_1004 : {pageNm : "1:1 문의", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_750_1005 : {pageNm : "VIK VOICE", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_750_1006 : {pageNm : "구매 상담 신청", type : "WEB"},
	KIA_MOB_750_1100 : {pageNm : "KIA CONNECTED", type : "PAGE"},       // 페이지 존재, 사용안함
	KIA_MOB_750_1200 : {pageNm : "커넥티드 서비스 > UVO > UVO 가입 안내", type : "WEB"},
	KIA_MOB_750_1201 : {pageNm : "커넥티드 서비스 > UVO", type : "TAB"},
	KIA_MOB_750_1300 : {pageNm : "커넥티드 서비스 > KIA Digital Key", type : "WEB"},
	KIA_MOB_750_1400 : {pageNm : "커넥티드 서비스 > KIA Pay > 서비스 상세 안내", type : "WEB"},
	KIA_MOB_750_1401 : {pageNm : "커넥티드 서비스 > KIA Pay", type : "TAB"},
    KIA_MOB_750_1500 : {pageNm : "Kia EV > 온디맨드 픽업충전", type : "PAGE"},
    KIA_MOB_750_1600 : {pageNm : "Kia EV > E-Pit", type : "PAGE"},
    KIA_MOB_750_1700 : {pageNm : "커넥티드 서비스 > Digital Key 온디맨드", type : "PAGE"},
	KIA_MOB_760_1000 : {pageNm : "문의/신청내역", type : "WEB"},      // 호출 페이지 사용안함
	KIA_MOB_800_1000 : {pageNm : "알림", type : "PAGE"},
	KIA_MOB_810_1000 : {pageNm : "설정", type : "PAGE"},
	KIA_MOB_810_1001 : {pageNm : "설정 > 푸시 상세설정", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_810_1010 : {pageNm : "마이페이지 > 서비스 이용 약관 > 위치기반 서비스 이용 약관", type : "PAGE"},
	KIA_MOB_810_1020 : {pageNm : "차량 프로필 설정(여러대)", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_810_1021 : {pageNm : "차량 프로필 수정(한대)", type : "PAGE"},       // 페이지 존재, 사용안함
	KIA_MOB_810_1022 : {pageNm : "사진 크게보기 팝업", type : "PAGE"},
	KIA_MOB_810_1023 : {pageNm : "사진등록 팝업", type : "POPUP(GET)"},
	KIA_MOB_810_1030 : {pageNm : "비밀번호 입력", type : "PAGE"},
	KIA_MOB_810_1031 : {pageNm : "마이페이지 > 추가정보 수정", type : "PAGE"},
	KIA_MOB_810_1032 : {pageNm : "우편번호 검색", type : "PAGE"},
	KIA_MOB_810_1040 : {pageNm : "회원 탈퇴", type : "WEB"},        // 구버전
	KIA_MOB_810_1041 : {pageNm : "CCSP 회원 탈퇴", type : "WEB"},
	KIA_MOB_810_1042 : {pageNm : "기아 멤버십 서비스 가입", type : "WEB"},
	KIA_MOB_810_1043 : {pageNm : "본인인증 휴대폰으로 찾기", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_810_1044 : {pageNm : "본인인증 아이핀으로 찾기", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_810_1045 : {pageNm : "통합회원 가입상태 추가정보 등록", type : "WEB"},    // 호출 페이지 없음
	KIA_MOB_810_1050 : {pageNm : "마이페이지 > 회원 정보 수정 > 비밀번호 변경", type : "PAGE"},
	KIA_MOB_810_1060 : {pageNm : "지문등록 팝업", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_810_1070 : {pageNm : "설정 > 추천인 등록", type : "PAGE"},
	KIA_MOB_810_1071 : {pageNm : "설정 > 추천인 등록 > 사원 조회결과", type : "PAGE"},
	KIA_MOB_810_1072 : {pageNm : "설정 > 추천인 등록 > 추천인 선택결과", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_810_1073 : {pageNm : "설정 > 추천인 등록 > 오토큐 조회결과", type : "PAGE"},
    KIA_MOB_810_1080 : {pageNm : "안내팝업", type : "POPUP(GET)"},
	KIA_MOB_820_1000 : {pageNm : "메세지함 > 할인쿠폰함 목록", type : "PAGE"},
	KIA_MOB_820_1001 : {pageNm : "메세지함 > 할인쿠폰함 상세", type : "PAGE"},
	KIA_MOB_820_1010 : {pageNm : "메세지함 > 할인쿠폰함 상세", type : "PAGE"},    // 페이지 존재, 사용안함
	KIA_MOB_830_1000 : {pageNm : "메인(마이페이지)", type : "PAGE"},
	KIA_MOB_830_1001 : {pageNm : "마이페이지 > 등록된 차량", type : "PAGE"},
	KIA_MOB_830_1010 : {pageNm : "마이페이지 > 내차관리", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_830_1011 : {pageNm : "마이페이지 > 내차관리 > 가입서비스", type : "WEB"},    // 호출 페이지 없음
    KIA_MOB_900_1000 : {pageNm : "마이페이지 > 서비스 이용 약관", type : "PAGE"},
    KIA_MOB_900_1009 : {pageNm : "마이페이지 > 충전 로밍 서비스 제공 약관", type : "PAGE"},
    KIA_MOB_900_1010 : {pageNm : "마이페이지 > 구독형 충전 요금제 제공 약관", type : "PAGE"},
    KIA_MOB_900_1011 : {pageNm : "마이페이지 > 충전 로밍 서비스 및 구독형 충전 요금제 중개 약관", type : "PAGE"},
	KIA_MOB_900_1001 : {pageNm : "(필수)개인정보 수집 및 이용", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1002 : {pageNm : "(선택)개인정보 수집 및 이용", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1003 : {pageNm : "(필수)개인정보 수집 및 이용-기아멤버스", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1004 : {pageNm : "기아멤버스 온라인 이용약관", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1005 : {pageNm : "홈페이지 이용약관", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1006 : {pageNm : "기아멤버스 홈페이지 개인정보 처리방침", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1007 : {pageNm : "기아 홈페이지 개인정보 처리방침", type : "PAGE"},    // 호출 페이지 없음
	KIA_MOB_900_1008 : {pageNm : "내 차 관리 > 내 차 정보 > 실 운행자 등록-관계 > 개인정보 제3자 제공동의", type : "PAGE"},
	KIA_MOB_2000_1000 : {pageNm : "전기 충전 결제 인증 팝업", type : "PAGE"},
	KIA_MOB_2000_1001 : {pageNm : "NFC", type : "PAGE"},
	KIA_MOB_2000_1002 : {pageNm : "QR 생성", type : "PAGE"},
	KIA_MOB_2000_1100 : {pageNm : "충전내역", type : "PAGE"},
	KIA_MOB_2000_1200 : {pageNm : "SSCharger 충전카드 발급", type : "PAGE"},
	KIA_MOB_2000_1210 : {pageNm : "결제 카드 등록", type : "PAGE"},
	KIA_MOB_2000_1211 : {pageNm : "에스트래픽 충전카드 발급", type : "PAGE"},
	KIA_MOB_2000_1212 : {pageNm : "간편결제 재등록", type : "PAGE"},
	KIA_MOB_2000_1300 : {pageNm : "충전서비스 설정", type : "PAGE"},
	KIA_MOB_2000_1400 : {pageNm : "메인(전기차 충전)", type : "PAGE"},
	KIA_MOB_2000_1401 : {pageNm : "전기차 충전", type : "PAGE"}
};

// TODO : 컨텐츠 내에서 버튼 클릭시 뜨는 이벤트 확인
