/**
 * @파일명 : interface_specs.js
 * @작성자 : 정목단
 * @생성일 : 2022. 2. 17.
 * @메뉴명 : 전문 통신 목록 파일
 * @설명 : 2022 앱리뉴얼에 따라 많은 api가 신규생성됨에 따라, as-is와 구분을 위해 별도 생성함.
 * as-is와 중복되는 api가 존재할 수 있음.
 */

var _API = {};
_API.SVR = {};// 서버API
_API.HUB = {};// 데이터허브API(KIA developers)
/**라우투맵*/
_API.ROUTO = {
    rgeocode: {
        url: "rgeocode",
        nm: "Reverse Geocoding"
    },
    directions: {
        pedestrian:
        {
            url: "directions/pedestrian",
            nm: "도보경로탐색"
        }
    },

}
    ;
/**APP서버 : 공통*/
_API.SVR.CMM = {
    code: {
        appVersion: {
            apiId: "RNW-CMM-1001",
            url: "rnw/code/appVersion",
            name: "앱OS별 최신 버전 조회"
        },
        selectList: {
            url: "code/selectList",
            nm: "운영기관 공통코드 리스트 조회"
        },
        locationConnCsmrInfoRgst:{
            apiId: "RNW-CMM-9100",
            url: "rnw/cmm/locationConnCsmrInfoRgst",
            nm: "위치기반서비스 접속정보 등록"
        }
    },
    wtrsd: {
        wethRsetDustyInfo: {
            apiId: "RNW-CMM-2001",
            url: "rnw/wtrsd/WethRsetDustyInfoReq",
            name: "날씨/일출일몰/대기정보요청"
        }
    },
    main: {
        notiNotReadCnt: {
            apiId: "RNW-CMM-3001",
            url: "rnw/main/notiNotReadCnt",
            name: "알림뱃지"
        },
        mktPop: {
            apiId: "RNW-CMM-9001",
            url: "rnw/main/mktPop",
            name: "마케팅 팝업"
        },
        carAgreeStandBy: {
            apiId: "RNW-CMM-6001",
            url: "rnw/main/carAgreeStandBy",
            name: "실운행자 동의 대기차량 목록조회"
        },
        newCarList: {
            apiId: "RNW-HOM-2001",
            url: "rnw/main/newCarList",
            name: "신차광고 차량조회"
        },
    },
    car: {
        driverAgreeYn: {
            apiId: "RNW-CMM-6002",
            url: "rnw/car/driverAgreeYn",
            name: "실운행자 동의등록"
        },
    },
    msg: {
        msgList: {
            apiId: "RNW-CMM-3002",
            url: "rnw/msg/msgList",
            name: "알림목록조회"
        },
        changeStateReceived: {
            apiId: "RNW-CMM-3003",
            url: "rnw/msg/changeStateReceived",
            name: "알림읽음수신"
        },
        receiveMsg: {
            apiId: "RNW-CMM-3004",
            url: "rnw/msg/receiveMsg",
            name: "알림메시지수신(단말기에서 메시지 수신)"
        },
    },
    push: {
        chkEqualPushId: {
            apiId: "RNW-CMM-3011",
            url: "rnw/push/chkEqualPushId",
            name: "PushID 동일여부 조회"
        },
        regist: {
            apiId: "RNW-CMM-3012",
            url: "rnw/push/regist",
            name: "PushID 등록"
        },
    },
    property: {
        propSearch: {
            apiId: "RNW-CMM-9002",
            url: "rnw/cmm/property/propSearch",
            name: "프로퍼티(스미싱) 조회"
        }
    },
    "screen": {
        "screenInfo": {
            apiId: "RNW-CMM-4001",
            url: "rnw/screen/screenInfo",
            name: "메뉴 정보"
        },
    },
    owncar: {
        updateOwncarList: {
            apiId: "RNW-CMM-5001",
            url: "rnw/owncar/updateOwncarList",
            name: "차량정보동기화"
        },

    },
    crd: {
        holdCardReq: {
            apiId: "RNW-CRD-1001",
            url: "rnw/crd/info/holdCardReq",
            name: "보유카드 조회(멤버스/정유사카드)"
        },
        gsCaltexJoinReq: {
            apiId: "RNW-CRD-2001",
            url: "rnw/crd/join/gsCaltexJoinReq",
            name: "정유사가입-GS칼텍스 가입정보요청"
        },
        gsCaltexJoin: {
            apiId: "RNW-CRD-2002",
            url: "rnw/crd/join/gsCaltexJoin",
            name: "정유사가입-GS칼텍스"
        },
        soilJoin: {
            apiId: "RNW-CRD-2003",
            url: "rnw/crd/join/soilJoin",
            name: "정유사 가입-S OIL(예정)"
        },
        hydOilBankJoin: {
            apiId: "RNW-CRD-2004",
            url: "rnw/crd/join/hydOilBankJoin",
            name: "정유사 가입-현대오일뱅크"
        },
        mbJoinTerm: {
            apiId: "RNW-CRD-2005",
            url: "rnw/crd/join/mbJoinTerm",
            name: "정유사 회원연동 해지"
        },
        autoqInfoGetRegConYn: {
            apiId: "RNW-CRD-3001",
            url: "rnw/crd/autoq/autoqInfoGetRegConYn",
            name: "오토큐 제휴사정보받기 등록여부 확인"
        },
        autoqGetReg: {
            apiId: "RNW-CRD-3002",
            url: "rnw/crd/autoq/autoqGetReg",
            name: "오토큐 제휴사 받기 등록"
        },
        autoqRegDel:{
            apiId:"RNW-CRD-3003",
            url:"rnw/crd/autoq/autoqRegDel",
            name:"오토큐 제휴사 등록 해제"
        },
        memberEvCardReq: {
            apiId: "RNW-CRD-1002",
            url: "rnw/crd/info/memberEvCardReq",
            name: "멤버스 EV카드 조회"
        }
    },
    terms: {
        selectGpsTermsAgreeYn: {
            apiId: "RNW-CMM-8001",
            url: "rnw/terms/selectGpsTermsAgreeYn",
            name: "위치 약관동의 확인"
        },
    },
    card: {
        cardMbrList: {
            apiId: "RNW-MYP-1001",
            url: "rnw/card/cardMbrList",
            name: "멤버스카드 조회"
        }
    },
    myp: {
        mypage: {
            kiaFamilyList: {
                apiId: "RNW-MYP-1002",
                url: "rnw/myp/mypage/kiaFamilyList",
                name: "기아 패밀리 조회"

            },
            dcsComExpBase: {
                apiId: "RNW-MYP-1003",
                url: "rnw/myp/mypage/dcsComExpBase",
                name: "기아 패밀리 조회"

            }
        }
    },
    mykia: {
        mycar: {
            mainCarList: {
                apiId: "RNW-CMM-5002",
                url: "rnw/mykia/mycar/mainCarList",
                name: "보유/계약차량 조회"
            },
            regCarId: {
                apiId: "RNW-CMM-5003",
                url: "rnw/mykia/mycar/regCarId",
                name: "CCS 가입차량 등록"
            },
        },

    },
}
/** APP서버 : 내 차 관리 */
_API.SVR.MYCAR = {
    mci: {
        expMgmt: {
            apiId: "RNW-MCI-1001",
            url: "rnw/mci/insight/expMgmt",
            name: "소모품관리"
        },
        aveMonSpd: {
            apiId: "RNW-MCI-2001",
            url: "rnw/mci/insight/aveMonSpd",
            name: "월 평균지출금액(차계부)"
        },
        aveExpByItm: {
            apiId: "RNW-MCI-2002",
            url: "rnw/mci/insight/aveExpByItm",
            name: "항목별 평균지출내역(차계부)"
        },
        remCarIns: {
            apiId: "RNW-MCI-3001",
            url: "rnw/mci/insight/remCarIns",
            name: "남은 자동차할부"
        },
        remCarInsDel: {
            apiId: "RNW-MCI-3002",
            url: "rnw/mci/insight/remCarInsDel",
            name: "남은 자동차할부 삭제"
        },
        insPreInq: {
            apiId: "RNW-MCI-4001",
            url: "rnw/mci/insight/insPreInq",
            name: "보험료 조회"
        },
        InsPreDel: {
            apiId: "RNW-MCI-4002",
            url: "rnw/mci/insight/insPreDel",
            name: "보험료 삭제"
        }
    },
    car: {
        distInfo: {
            apiId: "RNW-CKB-1001",
            url: "rnw/car/distInfo",
            name: "누적주행거리 조회 (차계부)"
        },
        insertDist: {
            apiId: "RNW-CKB-1002",
            url: "rnw/car/insertDist",
            name: "누적주행거리 입력(차계부)"
        },

    },
    ckb: {
        exchCycle: {
            apiId: "RNW-EXC-1001",
            url: "rnw/ckb/exchCycle",
            name: "소모품목록 조회"
        },
        exchCycleDtl: {
            apiId: "RNW-EXC-1002",
            url: "rnw/ckb/exchCycleDtl",
            name: "소모품교체내역조회"
        },
        insertCycle: {
            apiId: "RNW-EXC-1003",
            url: "rnw/ckb/insertCycle",
            name: "교환주기 설정"
        },
        regExpInfoGods: {
            apiId: "RNW-EXC-1004",
            url: "rnw/ckb/regExpInfoGods",
            name: "소모품 교체등록"
        },
        delExchCycleDtl: {
            apiId: "RNW-EXC-1005",
            url: "rnw/ckb/delExchCycleDtl",
            name: "소모품 교체 내역 삭제"
        },
        expForMonth: {
            apiId: "RNW-CKB-2001",
            url: "rnw/ckb/expForMonth",
            name: "월별 지출요약 / 지출비교"
        },
        expendList: {
            apiId: "RNW-CKB-2002",
            url: "rnw/ckb/expendList",
            name: "월별 지출 상세내역"
        },
        deleteExpend: {
            apiId: "RNW-CKB-2003",
            url: "rnw/ckb/deleteExpend",
            name: "상세내역 삭제"
        },
        updateExpend: {
            apiId: "RNW-CKB-2004",
            url: "rnw/ckb/updateExpend",
            name: "(주유) 상세내역 수정"
        },
        regExpInfoOil: {
            apiId: "RNW-CKB-3001",
            url: "rnw/ckb/regExpInfoOil",
            name: "주유 차계부 등록"
        },
        regExpInfoRpr: {
            apiId: "RNW-CKB-3002",
            url: "rnw/ckb/regExpInfoRpr",
            name: "정비 차계부 등록"
        },
        regExpInfoEtc: {
            apiId: "RNW-CKB-3003",
            url: "rnw/ckb/regExpInfoEtc",
            name: "기타 차계부 등록"
        },
        regInsuInfo: {
            apiId: "RNW-CKB-3004",
            url: "rnw/ckb/regInsuInfo",
            name: "보험 등록"
        },
        regIstmInfo: {
            apiId: "RNW-CKB-3005",
            url: "rnw/ckb/regIstmInfo",
            name: "할부 등록"
        },
        downloadExpend: {
            apiId: "RNW-CKB-2005",
            url: "rnw/ckb/downloadExpend",
            name: "차계부 다운로드"
        },
        expForDay: {
            apiId: "RNW-CKB-2006",
            url: "rnw/ckb/expForMonthSum",
            name: "금월 지출금액 합 조회"
        },
        mainBookUpdate: {
            apiId: "RNW-CKB-4002",
            url: "rnw/ckb/mainBookUpdate",
            name: "정비 차계부 수정"
        },
        etcBookUpdate: {
            apiId: "RNW-CKB-4003",
            url: "rnw/ckb/etcBookUpdate",
            name: "기타 차계부 수정"
        },
        insuContInfoInq: {
            apiId: "RNW-CKB-4004",
            url: "rnw/ckb/insuContInfoInq",
            name: "보험 계약정보 조회"
        },
        corrOfMontPrem: {
            apiId: "RNW-CKB-4005",
            url: "rnw/ckb/corrOfMontPrem",
            name: "납입월 보험료 수정"
        },
        instContInfoInq: {
            apiId: "RNW-CKB-4006",
            url: "rnw/ckb/instContInfoInq",
            name: "할부 계약정보 조회"
        },
        modiMontInst: {
            apiId: "RNW-CKB-4007",
            url: "rnw/ckb/modiMontInst",
            name: "납부 월할부금 수정"
        }
    },
    insight: {
        insight: {
            apiId: "RNW-RPR-1001",
            url: "rnw/insight/insight",
            name: "정비 인사이트"
        }
    },
    autocam: {
        autoCamViewCnt: {
            apiId: "RNW-RPR-1002",
            url: "rnw/autocam/autoCamViewCnt",
            name: "오토캠 카운트 증가"
        },
        autoCamPwdInfo: {//as-is사용 맞음.
            url: "autocam/autoCamPwdInfo",
            nm: "오토캠 가능여부"
        },


    },
    carService: {
        myAutoqAsnInfo_search: {
            apiId: "RNW-RPR-2002",
            url: "rnw/carService/myAutoqAsnInfo",
            name: "전담 오토큐검색"
        },
        autoqServiceTypeList: {
            apiId: "RNW-RPR-2003",
            url: "rnw/carService/autoqServiceTypeList",
            name: "정비소(오토큐) 서비스 구분코드 검색"
        },
        nearAutoqInfoList: {
            apiId: "RNW-RPR-2004",
            url: "rnw/carService/nearAutoqInfoList",
            name: "가까운 정비소(오토큐) 검색"
        },
        schAutoqList: {
            apiId: "RNW-RPR-2005",
            url: "rnw/carService/schAutoqList",
            name: "정비소(오토큐) 키워드 검색"
        },
        autoqDetailInfo: {
            apiId: "RNW-RPR-2006",
            url: "rnw/carService/autoqDetailInfo",
            name: "정비소(오토큐) 상세 검색"
        },
        updateMainAutoq: {
            apiId: "RNW-RPR-2007",
            url: "rnw/car/updateMainAutoq", // <- ??? (질문) 주소가 carService가 아님 케이스마텍 추헌남
            name: "전담오토큐 지정(설정/변경)"
        },
        isRsvYnInfo: {
            apiId: "RNW-RPR-3001",
            url: "rnw/carService/isRsvYnInfo",
            name: "차량 정비예약여부 확인 & 프리케어 조회"
        },
        myAutoqAsnInfo_view: {
            apiId: "RNW-RPR-3002",
            url: "rnw/carService/myAutoqAsnInfoGet",
            name: "전담오토큐 조회"
        },
        schAutoqYmdList: {
            apiId: "RNW-RPR-3003",
            url: "rnw/carService/schAutoqYmdList",
            name: "전담오토큐 예약가능 일자/일시 검색"
        },
        autoqRsvReq: {
            apiId: "RNW-RPR-3004",
            url: "rnw/carService/autoqRsvReg",
            name: "정비(오토큐)예약 신청"
        },
        dtdRsvReg: {
            apiId: "RNW-RPR-4002",
            url: "rnw/carService/dtdRsvReg",
            name: "도어투도어 예약신청"
        },
        autoqRsvHistInfoList: {
            apiId: "RNW-RPR-5001",
            url: "rnw/carService/autoqRsvHistInfoList",
            name: "정비(오토큐) 예약현황 조회"
        },
        autoqRsvDetailInfo: {
            apiId: "RNW-RPR-5002",
            url: "rnw/carService/autoqRsvDetailInfo",
            name: "정비(오토큐) 예약상세 조회"
        },
        autoqRsvCancel: {
            apiId: "RNW-RPR-5003",
            url: "rnw/carService/autoqRsvCancel",
            name: "정비예약 취소"
        },
        dtdRsvHistInfoList: {
            apiId: "RNW-RPR-5004",
            url: "rnw/carService/dtdRsvHistInfoList",
            name: "도어투도어 예약현황 조회"
        },
        dtdRsvHistInfo: {
            apiId: "RNW-RPR-5005",
            url: "rnw/carService/dtdRsvHistInfo",
            name: "도어투도어 예약상세 조회"
        },
        dtdRsvCancel: {
            apiId: "RNW-RPR-5006",
            url: "rnw/carService/dtdRsvCancel",
            name: "도어투도어 예약취소"
        },
    },
    repair: {
        repairHistList: {
            apiId: "RNW-RPR-6001",
            url: "rnw/repair/repairHistList",
            name: "정비이력 목록 조회"
        },
        periodicRepairList: {
            apiId: "RNW-RPR-6002",
            url: "rnw/repair/periodicRepairList",
            name: "정기점검시행일자 조회"
        },
        periodicRepairHistInfo: {
            apiId: "RNW-RPR-6003",
            url: "rnw/repair/periodicRepairHistInfo",
            name: "정기점검 상세조회"
        },
    },
    event: {
        carCareServiceList: {
            apiId: "RNW-RPR-7001",
            url: "rnw/event/carCareServiceList",
            name: "정비편의 서비스"
        },
        detailEvent: {
            url: "event/detailEvent",
            nm: "이벤트상세 조회"
        },
    },
    recall: {
        freeCareList: {
            apiId: "RNW-RPR-8001",
            url: "rnw/recall/freeCareList",
            name: "고급차량의 프리케어 조회"
        },
    }
};
/** APP서버 : HOME */
_API.SVR.HOME = {
    hom: {
        homIns: {
            apiId: "RNW-HOM-1001",
            url: "rnw/hom/insight/homIns",
            name: "HOME 인사이트"
        }
    },

    "car": {
        "selectRealDriverList": {
            apiId: "RNW-HOM-4003",
            url: "rnw/car/selectRealDriverList",
            name: "(소유주가) 실운행자 목록조회"
        },
        "delRealDriver": {
            apiId: "RNW-HOM-4004",
            url: "rnw/car/delRealDriver",
            name: "(소유주가) 실운행자 삭제"
        },
        "mbrInfo": {
            apiId: "RNW-HOM-4005",
            url: "rnw/car/mbrInfo",
            name: "(소유주가) 실운행자 등록 – 통합DB/레드멤버스 회원여부 체크"
        },
        "eachContInfo": {
            apiId: "RNW-HOM-7001",
            url: "rnw/car/eachContInfo",
            name: "계약정보 조회 – 계약/출고정보 ( 출고 후 1년이후 차량 ) "
        },


    },

    "ckb": {
        "deleteCkbCarsList": {
            apiId: "RNW-HOM-2002",
            url: "rnw/ckb/deleteCkbCarsList",
            name: "삭제차량목록조회"
        },
        "recoveryCkbCars": {
            apiId: "RNW-HOM-2003",
            url: "rnw/ckb/recoveryCkbCars",
            name: "삭제차량 복구"
        },
        "deleteCkbMgmtSubjCarsInfo": {
            apiId: "RNW-HOM-5005",
            url: "rnw/ckb/deleteCkbMgmtSubjCarsInfo",
            name: "(소유주가) 차량삭제"
        },
    },

    "mykia": {
        "mycar": {
            "representCarUpdate":
            {
                apiId: "RNW-HOM-4001",
                url: "rnw/mykia/mycar/representCarUpdate",
                name: "대표차량 등록"
            }
        }
    },
    "recall": {
        "recallList": {
            apiId: "RNW-HOM-4002",
            url: "rnw/recall/recallList",
            name: "무상수리 대상차량 리콜목록 조회"
        }

    },
    "carinfo": {
        "regRealDriver": {
            apiId: "RNW-HOM-4006",
            url: "rnw/carinfo/regRealDriver",
            name: "(소유주가) 실운행자 등록 "
        },
        "warrantInfoList": {
            apiId: "RNW-HOM-4007",
            url: "rnw/carinfo/warrantInfoList",
            name: "보증기간 조회"
        },
        "selectCarInfo": {
            apiId: "RNW-HOM-5001",
            url: "rnw/carInfo/selectCarInfo",
            name: "차량정보조회 - 차량상세조회"
        },
        "selectCarUseCodeList": {
            apiId: "RNW-HOM-5002",
            url: "rnw/carInfo/selectCarUseCodeList",
            name: "차량용도 구분코드 조회 "
        },
        "selectFuelList": {
            apiId: "RNW-HOM-5003",
            url: "rnw/carInfo/selectFuelList",
            name: "연료구분코드 조회 "
        },
        "updateCarInfo": {
            apiId: "RNW-HOM-5004",
            url: "rnw/carInfo/updateCarInfo",
            name: "차량정보 수정/저장 "
        },
        "carContractPayInfo": {
            apiId: "RNW-HOM-7002",
            url: "rnw/carinfo/carContractPayInfo",
            name: "계약정보 조회 – 차량구매정보 ( 출고 1년이전 차량 )"
        },
        "TaaSOdometerNbattery": {
            apiId: "RNW-HOM-8001",
            url: "rnw/car/ev/tassOdometerNbattery",
            name: "TaaS 주행정보 조회"
        },
        "TaaSAgreeYnReg": {
            apiId: "RNW-HOM-8002",
            url: "rnw/car/ev/tassAgreeYnReg",
            name: "TaaS 개인정보이용동의여부 등록"
        }
    },
    "carspec": {
        "specInfoList": {
            apiId: "RNW-HOM-6001",
            url: "rnw/carspec/specInfoList",
            name: "차량사양정보 조회"
        },


    },
};
/** APP서버 : EV 충전소 */
_API.SVR.EV = {
    evCharger: {
        schEvChargerFavoriteList: {
            apiId: "RNW-EVC-1001",
            url: "rnw/evCharger/schEvChargerFavoriteList",
            name: "나만의 충전소 목록조회"
        },
        evChargerFavoriteReg: {
            apiId: "RNW-EVC-1002",
            url: "rnw/evCharger/evChargerFavoriteReg",
            name: "나만의 충전소 등록/삭제"
        },
        schEvChargerStation: {
            apiId: "RNW-EVC-2001",
            url: "rnw/evCharger/schEvChargerStation",
            name: "가까운 충전소 목록조회"
        },
        schEvChargerStationDtl: {
            apiId: "RNW-EVC-2002",
            url: "rnw/evCharger/schEvChargerStationDtl",
            name: "충전소 상세조회"
        }
    },
    evmng: {
        evMngReg: {
            apiId: "RNW-EVC-3001",
            url: "rnw/evmng/evMngReg",
            name: "ev가입여부를 멤버스에 전달"
        },
        sscMemCardInfoReq: {
            apiId: "RNW-EVC-4001",
            url: "rnw/evmng/sscMemCardInfoReq",
            name: "SK일렉링크 회원카드 정보 조회"
        },
        sccCredit: {
            apiId: "RNW-EVC-5001",
            url: "rnw/evmng/sscGetCreditBalanceTotalInquiry",
            name: "SK일렉링크 충전 크레딧"
        },
        sccCreditUseList: {
            apiId: "RNW-EVC-5002",
            url: "rnw/evmng/sscGetCreditUseListInquiry",
            name: "SK일렉링크 충전 크레딧 상세사용 리스트"
        }
    }
};
/** APP서버 : KIA STORY */
_API.SVR.STORY = {
    "event": {
        "eventAllList": {
            apiId: "RNW-KAS-1001",
            url: "rnw/event/eventAllList",
            name: "이벤트 목록조회"
        },
        "eventReg": {
            apiId: "RNW-KAS-2003",
            url: "rnw/event/eventReg",
            name: "이벤트 로그 수집"
        },
        "BeforeLoginV2": {
            apiId: "RNW-KAS-3001",
            url: "rnw/event/BeforeLoginV2",
            name: "기아스토리 > Event > 참여,제휴 이벤트 목록조회"
        }
    },
    "survey": {
        "surveyList": {
            apiId: "RNW-KAS-1002",
            url: "rnw/survey/surveyList",
            name: "설문 목록조회"
        }
    },
    "kianews": {
        "kiaSelect": {
            apiId: "RNW-KAS-1003",
            url: "rnw/kianews/kiaSelect",
            name: "채널 기아"
        }
    },
    "기아스토리": {
        "기아스토리_메인화면_이벤트_목록조회_진행중": {
            apiId: "RNW-KAS-1001",
            url: "rnw/서비스구분1정의/[서비스구분2정의]/서비스정의.do",
            name: "기아스토리 메인화면-이벤트 목록조회(진행중)"
        },
        "기아스토리_메인화면_설문_목록조회_진행중": {
            apiId: "RNW-KAS-1002",
            url: "rnw/서비스구분1정의/[서비스구분3정의]/서비스정의.do",
            name: "기아스토리 메인화면-설문 목록조회(진행중)"
        },
        "기아스토리_메인화면_채널기아": {
            apiId: "RNW-KAS-1003",
            url: "rnw/서비스구분1정의/[서비스구분3정의]/서비스정의.do",
            name: "기아스토리 메인화면-채널기아"
        }
    },
};
/** APP서버 : 차량구매 */
_API.SVR.BUY = {
    "main": {
        "populCarList": {
            apiId: "RNW-CRS-1001",
            url: "rnw/main/populCarList",
            name: "차량구매메인 인기차량조회"
        }
    },
    "차량구매": {
        "메인_인기차량_The Best_조회": {
            apiId: "RNW-CRS-1001",
            url: "rnw/서비스구분1정의/[서비스구분2정의]/서비스정의.do",
            name: "메인 – 인기차량(The Best) 조회"
        },
        "차량모델_목록조회": {
            apiId: "RNW-CRS-1002",
            url: "rnw/서비스구분1정의/[서비스구분3정의]/서비스정의.do",
            name: "차량모델 목록조회"
        }
    }
};



/** 데이터허브 */
_API.HUB = {
    carMaster: {
        apiId: "carMaster",
        path: null,
        verifyUrl: function (userId, vin) { // CCS 연동 가능 여부 조회 (GET)
            this.path = String.format('api/v1/profile/users/{0}/car/ismaster?vin={1}', userId, vin);
            return this;
        },
    },
    registerVehicle: {
        apiId: "registerVehicle",
        path: null,
        verifyUrl: function (userId) { // Register User Vehicle (POST)
            this.path = String.format('api/v1/profile/users/{0}/cars', userId);
            return this;
        },
    },
    vehicle: {
        apiId: "vehicle",
        path: null,
        verifyUrl: function (userId) { // Get List of Registered Vehicles (GET) (DELETE)
            this.path = String.format('api/v1/profile/users/{0}/cars', userId);
            return this;
        },
    },
    agreements: {
        apiId: "agreements",
        path: null,
        verifyUrl: function (userId, carId, token) { // 목적 외 동의 여부 및 수집 동의 조회(GET) // token은 임시로 넣음. -> ccs에서 제거 예정.
            this.path = String.format('api/v1/data-service/agreements?userId={0}&carId={1}&token={2}', userId, carId, token);
            return this;
        },
    },
    agreementsWeb: {
        apiId: "agreementsWeb",
        path: null,
        verifyUrl: function (token, userId, carId) { // 데이터마일즈 약관 동의 페이지 URL
            this.path = String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service/agreements?token={0}&userId={1}&carId={2}', token, userId, carId);
            return this;
        },
    },
    web: {
        apiId: "web",
        path: null,
        verifyUrl: function (token, userId, carId) { // 데이터마일즈 페이지 URL
            this.path = String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service?token={0}&userId={1}&carId={2}', token, userId, carId);
            return this;
        },
    },
    safeDriveWeb: {// /web/v1/data-service/ubi?token={token}&userId={userId}&carId={carId}
        apiId: "safeDriveWeb",
        path: null,
        verifyUrl: function (token, userId, carId) {
            this.path = String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service/ubi?token={0}&userId={1}&carId={2}', token, userId,carId);
            return this;
        },
    },
    safeDriveIntroduceWeb: {
        apiId: "safeDriveIntroduceWeb",
        path: null,
        verifyUrl: function (token, userId, carId) {
            this.path = String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service/safe-drive-habit-introduce?token={0}&carId={1}&userId={2}', token, carId, userId);
            return this;
        },
    },
    odometer: {
        apiId: "odometer",
        path: null,
        verifyUrl: function (carId) { // 누적 운행 거리 조회. 시동 종료 시점을 기준으로 업데이트되며, 2개월 미운행 차량의 데이터는 조회 불가(GET)
            this.path = String.format('api/v1/car/status/{0}/odometer', carId);
            return this;
        },
    },
    dte: {
        apiId: "dte",
        path: null,
        verifyUrl: function (carId) { // 차량의 주행 가능 거리를 조회하는 API 입니다. 시동 종료 시점을 기준으로 업데이트되며, 2개월 미운행 차량의 데이터는 조회 불가(GET)
            this.path = String.format('api/v1/car/status/{0}/dte', carId);
            return this;
        },
    },
    ubiTarget: {
        apiId: "ubiTarget",
        path: null,
        verifyUrl: function (carId) { // 안전운전점수 가입 여부 조회(GET)
            this.path = String.format('api/v1/car/model/{0}/ubi/target', carId);
            return this;
        },
    },
    ubiDetail: {
        apiId: "ubiDetail",
        path: null,
        verifyUrl: function (carId) { // 안전운전점수 상세 조회(GET)
            this.path = String.format('api/v1/car/model/{0}/ubi/detail', carId);
            return this;
        },
    },
    ubi: {
        apiId: "ubi",
        path: null,
        verifyUrl: function (carId) { // 운전 습관을 기반으로 산출한 안전운전점수를 조회(GET)
            this.path = String.format('api/v1/car/model/{0}/ubi', carId);
            return this;
        },
    },
    evStatus: {
        apiId: "evStatus",
        path: null,
        verifyUrl: function (carId) { // 전기차량 상태 조회(GET)
            this.path = String.format('api/v1/car/status/{0}/evStatus', carId);
            return this;
        },
    },
    evCharging: {
        apiId: "evCharging",
        path: null,
        verifyUrl: function (carId) { // 전기차 차량의 충전 중 정보를 조회하는 API(GET)
            this.path = String.format('api/v1/car/status/{0}/ev/charging', carId);
            return this;
        },
    },
    evBattery: {
        apiId: "evBattery",
        path: null,
        verifyUrl: function (carId) { // 전기차 차량의 배터리 잔량 정보를 조회하는 API(GET)
            this.path = String.format('api/v1/car/status/{0}/ev/battery', carId);
            return this;
        },
    },
    evDte: {
        apiId: "evDte",
        path: null,
        verifyUrl: function (carId) { // 전기차 차량의 주행 가능 거리를 조회하는 API(GET)
            this.path = String.format('api/v1/car/status/{0}/ev/dte', carId);
            return this;
        },
    },
    reserveData: {
        apiId: "reserveData",
        path: null,
        verifyUrl: function (userId, vin, startDate, endDate) { // dkc 예약상태 조회(GET)
            this.path = String.format('api/v1/data-service/dkc/?emailId={0}&vin={1}&status=&reserveStartDate={2}&reserveEndDate={3}', userId, vin, startDate, endDate);
            return this;
        },
    },
    fuelLevel: {
        apiId: "fuelLevel",
        path: null,
        verifyUrl: function (carId) { // 최종 연료 상태 조회(GET)
            this.path = String.format('api/v1/car/status/{0}/fuelLevel', carId);
            return this;
        }
    },
    parklocation: {
        apiId: "parklocation",
        path: null,
        verifyUrl: function (carId) { // 최종 주차 위치 조회(GET)
            this.path = String.format('api/v1/car/status/{0}/parklocation', carId);
            return this;
        }
    },
    dtc: {
        apiId: "dtc",
        path: null,
        verifyUrl: function (carId) { // 최종 주차 위치 조회(GET)
            this.path = String.format('api/v1/car/status/{0}/dtc', carId);
            return this;
        }
    },
    dkcWeb: {
        apiId: "dkcWeb",
        path: null,
        verifyUrl: function (token, userId, carId) { // dkc 데이터허브 URL
            this.path = String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service/dkc-introduce?token={0}&carId={1}&userId={2}', token, carId, userId);
            return this;
        }
    },

};

_API.ASIS = {
    "KIA_MOB_520_1201": {
        "apiId": "KIA_MOB_520_1201",
        "url": "https://devpg.bluewalnut.co.kr/kiaVik/kiaVikRequest.jsp",
        "name": "차량관리 > 내 차 관리 > 신차구매"
    },
    "KIA_MOB_520_1202": {
        "apiId": "KIA_MOB_520_1202",
        "url": "https://devbpay.bluewalnut.co.kr/myp/manageMyPay.do",
        "name": "차량관리 > 내 차 관리 > 간편결제카드조회"
    },
    "KIA_MOB_600_1002": {
        "apiId": "KIA_MOB_600_1002",
        "url": "https://devcarnlife.auton.kr/a/A020000",
        "name": "카&라이프 > 용품쇼핑"
    },
    "KIA_MOB_750_1004": {
        "apiId": "KIA_MOB_750_1004",
        "url": "https://staging-www.kia.com/kr/customer-service/online-counsel/default.html?code=car",
        "name": "1:1 문의"
    },
    "KIA_MOB_750_1005": {
        "apiId": "KIA_MOB_750_1005",
        "url": "https://staging-www.kia.com/kr/customer-service/online-counsel/default.html?",
        "name": "VIK VOICE"
    },
    "KIA_MOB_810_1043": {
        "apiId": "KIA_MOB_810_1043",
        "url": "http://dev-logon.kia.com/common/auth/checkHp.do",
        "name": "본인인증 휴대폰으로 찾기"
    },
    "KIA_MOB_810_1044": {
        "apiId": "KIA_MOB_810_1044",
        "url": "http://dev-logon.kia.com/common/auth/ipinPop.do",
        "name": "본인인증 아이핀으로 찾기"
    }
};

_API.SVR.EVENT = {
    benefitCheck: {
        apiId : "RNW-KAS-2004",
        url : "rnw/event/eventRegYn",
        nm  : "베네핏 이벤트 참여 여부 확인"
    },
    benefitSend : {
        apiId : "RNW-KAS-4001",
        url : "rnw/event/benefitSend",
        nm  : "베네핏 이벤트 신청"
    },
    benefitReSend : {
        apiId : "RNW-KAS-4002",
        url : "rnw/event/benefitResend",
        nm  : "베네핏 이벤트 재신청"
    },
    eventEligibilityYn : {
        apiId : "RNW-KAS-2005",
        url : "rnw/event/eventEligibilityYn",
        nm  : "이벤트 참여 가능(적임) 여부"
    }
}
