/**
 * @파일명 : push.manager.js
 * @작성자 : 최정동
 * @생성일 : 2018. 9. 19. 오후 3:41:09
 * @메뉴명 :
 */


//forground push Notification template 생성 
function addPushNoti(title, message, extData){
//	message = message.replace(/\n/g, "<br/>");	//기획요청에 의해 수정
	extData = extData || "/";
	var template = 
	'<div data-ext="'+extData+'" class="push-popup" style="display: block;top:-7rem; z-index:999;">'+
		'<div class="push-popup-container">'+
			'<div>'+
				'<span class="GroupName">'+title+'</span>'+
				'<span class="alarm">'+message+'</span>'+
			'</div>'+
			'<button class="close-push-noti" aria-label="팝업 닫기"></button>'+
		'</div>'+
	'</div>';

    showNotification( $(template) );
 }

// push Notification UI노출 
function showNotification( $el ){
	var _$pushPop = $(".push-popup");
	
	if( $(".push-popup").length > 0 ){
		_$pushPop.last().after($el);
	}else{
		$("body").prepend($el);    
	}
	var textWidth = $(".push-popup").outerWidth() - $(".push-popup-container > img").outerWidth() - $(".close-push-noti").outerWidth() - parseInt($(".push-popup").css("padding-left")) - parseInt($(".push-popup").css("padding-right")) - 10;
	$(".alarm").css("width", textWidth + "px");
	
	$el.siblings().find(".push-popup").off("click.pushNoti");
    
    //ui내에 닫기버튼 클릭시 ui삭제
	$el.find(".close-push-noti").on("click", function(){
		$el.remove();
	});

	$el.one("click.pushNoti", function(){
		$el.remove();
		onReceiveNotification($el.attr("data-ext"), "NOTIFICATION", $(".push-popup .GroupName").text(), $(".push-popup .alarm").text());
	});
	
	M.sys.vibration();		//진동 
	
	$el.animate({top:0}, 300, function(){
		$el.siblings().find(".push-popup").remove();
		
		setTimeout(function(){
			$el.animate({top: "-7rem"}, 200, function(){
				$el.remove();
			});
		}, 5000 );//일정 시간 후 자동 숨김       
	});
}

//푸시 이벤트
var onReceiveNotification = function(data, from, title, message) {
    console.log("onReceiveNotification");

	var dataArr = data.split('|');

	if(from == "NOTIFICATION"){ 	//NOTI를 통해서 들어온 경우
		if(isEmpty(PGV.sendData)){
			pushAction(data);
		}else{
			pushAction(PGV.sendData);
		}
	}else{		//포 그라운드 상황에서 알림이 들어온 경우
		PGV.sendData = data;
		addPushNoti(title, message, data);
	}
    //[KIAVIK-388] 비로그인 상태에서 Push 수신한 경우
	//if(dataArr[2] && MData.storage("autoLoginId")){	//메세지No와 자동로그인한 ID가 있다면 읽음 처리 전문 호출
	if(dataArr[2] && !isEmpty(PGV.loginInfo) && !isEmpty(PGV.loginInfo.mbrId)){	//메세지No와 자동로그인한 ID가 있다면 읽음 처리 전문 호출
		MNet.httpSend({
			path : inf.msg.changeStateReceived.url,
			sendData : {
				//mbrId : MData.storage("autoLoginId"),
				mbrId : PGV.loginInfo.mbrId,
				pushMsgNo : String(dataArr[2])
			},
			indicatorYn : "N",
			callback : function(receivedData){
				//아무것도 처리 하지않음
//				var code = receivedData.resultCode;
//				var msg = receivedData.resultMsg;
//				
//				if(code != "200"){
//					
//				}
			},
			errorCallback : function(errorCode, errorMessage) {
				//아무것도 처리 하지않음
			}
		});
	}
}

/**
 * PUSH 사용자 등록
 * 1. 로그인 시에는 파라미터 없이 호출
 * 2. onRefreshFCMPushTokenCallback 함수 호출 될 경우 token값 포함하여 호출
 */
var idx=0;
var onRefreshFCMToken = function(refreshToken){
	console.log("onRefreshFCMToken > token "+idx+" : "+refreshToken);
	var _appOsCcd = wnIf.device == DT_ANDROID ? "AOS" : "IOS";
	var _pushTokenkey = getFCMToken(refreshToken);
	console.log("onRefreshFCMToken > _pushTokenkey:"+_pushTokenkey);
	eventLog("tokenKey", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, _pushTokenkey);
	if(PGV.loginInfo && !isEmpty(_pushTokenkey)){
		var options = {
			sendData : {
				apiId: _API.SVR.CMM.push.regist.apiId,
				appOsCcd : _appOsCcd,
				mbrId : PGV.loginInfo.mbrId,
				pushTokenkey : _pushTokenkey
			},
			indicatorYn : "N",
			callback : function(receivedData){
				var code = receivedData.resultCode;
				var msg = receivedData.resultMsg;
				console.log("onRefreshFCMToken > 푸시 토큰 등록 요청 결과 : "+msg);
				if(code != "200"){
					MPopup.instance("푸시 서비스 등록에 실패했습니다.");
				}
			}
		};
		if (PGV.currentPage == PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml) {
			options.path = _API.SVR.CMM.push.regist.url;
			MNet.httpSend(options);
		}else{
			options.path = _API.SVR.CMM.push.regist;
			MNet.httpSend(options);
		}

	}
};

/**
* 푸시 이벤트
*/
var pushAction = function(data){
	PGV.sendData = "";
	var dataArr = data.split('|');
	
	switch(dataArr[0]){
		case "00" :		// 링크인 경우
			if(dataArr[1] == 'null'){
//				MPage.html({
//					url : PATH_MANAGER.KIA_RNW_091_0000.path
//				});
			}else{
				MPage.activity({
					className : "WebviewActivity",
					actionType : "CLEAR_TOP",
					param : {
						method : CONSTANT.NET_MTHD.GET,
						requestURL : dataArr[1]
					}
				});
			}
			break;
		case "01" :  	//로그인
			if(isEmpty(PGV.loginInfo) && PGV.currentPage != PATH_MANAGER.KIA_RNW_060_0000.nameWithHtml){
				//ccsp로그인
				var param = {}
				ccspLogin(param);
			}
		    break;

		case "02" : 	//이벤트
		case "PEVE" :
        	MNet.httpSendAsIs({
        		path : inf.event.detailEvent.url,
        		sendData : {
        			evtNo : dataArr[1]
        		},
        		callback : function(receivedData){
        		    exWNHideIndicator();
        		    var code = receivedData.resultCode;
        		    var msg = receivedData.resultMsg;
                    if(code == "200"){

                        if(receivedData.lingUrl.indexOf("http") > -1){      // 웹뷰일 경우
                            if(receivedData.lingUrl.indexOf("https://givecard.kakaomobility.com") > -1){     // 20211216 이벤트 임의 수정 (음주운전예방 browser실행)
                                MApps.browser(url);
                            }else{
                                MPage.activity({
                                    className : "WebviewActivity",
                                    param : {
                                        method : CONSTANT.NET_MTHD.GET,
                                        requestURL : receivedData.lingUrl
                                    }
                                });
                            }
                            return;
                        }else if(receivedData.lingUrl.indexOf("carnLife") > -1){        // 카앤라이프일경우
                            var carNlifeChek = receivedData.lingUrl.split("@");
                            if(!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "carnLife"){     // 카앤라이프일경우 이벤트 등록 형식 carnLife@/a/M070100@621
                                MPage.html({
                                    url : PATH_MANAGER.KIA_RNW_810_0000.path,
                                    param : {
                                        rUrl : CONSTANT.AUTON_URL_PREFIX + carNlifeChek[1],
                                        evtCd : isEmpty(carNlifeChek[2]) ? "" : carNlifeChek[2],
                                        evtYN : "N"
                                    }
                                });
                            }
                         	return;
                        }else{      // 상세페이지일 경우
                            MPage.html({
                                url : PATH_MANAGER.KIA_RNW_411_1000.path,
                                param : {
                                    evtNo : dataArr[1],		// 이벤트 번호
                                    eventType : "msg"	// 이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
                                }
                            });
                            return false;
                        }
                    }
        		}
        	});
		    break;

		case "03" : 	//신차안내
//			MPage.html({
//				url : PATH_MANAGER.KIA_RNW_300_0000.path
//			});
		    break;

		case "04" : 	//이달의 구매혜택
			// var _url = CONSTANT.LINK_URL.KIA_RNW_313_0000.URL;
			// MPage.activity({
			// 	className : "WebviewActivity",
			// 	param : {
			// 		method : CONSTANT.NET_MTHD.GET,
			// 		requestURL : _url
			// 	}
			// });
		    break;

		case "05" : 	//공지사항
			MPage.html({
				url : PATH_MANAGER.KIA_RNW_620_0000.path,
				param : {
					notiNo : dataArr[1]
				}
			});
		    break;

		case "06" : 	//입고확인증 2018 11 30 추가
			var pushDatas = JSON.parse(dataArr[3]);
			if(!isEmpty(pushDatas)){
				repairPushService("06", pushDatas);
			}
		    break;

		case "07" : 	//견적서
			var pushDatas = JSON.parse(dataArr[3]);
			if(!isEmpty(pushDatas)){
				repairPushService("07", pushDatas);
			}
		    break;

		case "08" : 	//점검 명세서
			var pushDatas = JSON.parse(dataArr[3]);
			if(!isEmpty(pushDatas)){
				repairPushService("08", pushDatas);
			}
		    break;

		case "09" : 	//수리 전후 사진 
			var pushDatas = JSON.parse(dataArr[3]);
			if(!isEmpty(pushDatas)){
				repairPushService("09", pushDatas);
			}
		    break;

		case "10" : 	//정비 진행 현황 
			var pushDatas = JSON.parse(dataArr[3]);
			if(!isEmpty(pushDatas)){
				repairPushService("10", pushDatas);
			}
		    break;

		case "11" : 	//보유 쿠폰함
        case "12" : 	//다운 쿠폰함
        case "PCOU" : 	//쿠폰함
			if(!isEmpty(PGV.loginInfo)){
				MPage.html({
					url : PATH_MANAGER.KIA_RNW_0D3_3100.path
				});
			}else{
				//ccsp로그인
				var param = {
					returnLink : PATH_MANAGER.KIA_RNW_0D3_3100.path,
					returnParams : {}
				}
				ccspLogin(param);
			}
		    break;

		case "13" : 	//간편 결제 
			if(!isEmpty(PGV.loginInfo)){
				getBluePay();
			}
		    break;

		case "14" : 	//설문
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_421_0000.path,
                param : {
                    srvyNo : dataArr[1],		// 설문 번호
                }
            });
            break;

        case "15" :     //autocam
            PGV.autoCapmInfo = {};
            var pushDatas = JSON.parse(dataArr[3]);
            var _appVersion = M.info.app().app.version;	// 앱 버전
            var _osName = MInfo.device().os.name; // OS 이름 (Android, iOS)
            var _osVersion = MInfo.device().os.version;		// OS 버전
            var _vin = pushDatas.vin;   //차대번호
            var _hpno = !isEmpty(PGV.loginInfo) ? PGV.loginInfo.hpno : "";  // 전화번호
            if(_osName =="Android" && _appVersion != "1.1.6" &&  _appVersion != "1.1.5" && parseInt(_osVersion) >=23){
                if(!isEmpty(PGV.loginInfo)){
                    MNet.httpSend({
                        path : inf.autoCam.autoCamPwdInfo.url,
                        sendData : {
                            vin : _vin,
                            hpno : _hpno
                        },
                        callback : function(receivedData){
                            exWNHideIndicator();
                            var code = receivedData.resultCode;
                            var msg = receivedData.resultMsg;
                            if(code == "200"){
                                // api 호출 후 정보 확인
                                PGV.autoCapmInfo = {
                                    atcmId : receivedData.atcmId,//"skbuser1",
                                    atcmEbc : receivedData.atcmEbc,//"a1234567890",
                                    camId : receivedData.camId,//"49189",
                                    viewCnt : receivedData.viewCnt,//"2",
                                    asnNm : receivedData.asnNm,//"테스트지점"
                                    vin : receivedData.vin,//"테스트지점"
                                    repnAsnCd : receivedData.repnAsnCd,//"MX0100",
                                    rgstLftCd : receivedData.rgstLftCd,//"01",
                                    trtmSn : receivedData.trtmSn,//"1",
                                    trtmYmd : receivedData.trtmYmd//"20171213"
                                }
                                if(!isEmpty(PGV.autoCapmInfo)){
                                    MPage.html({
                                        url : PATH_MANAGER.KIA_RNW_247_1000.path,
                                        param : {
                                            autoCapmInfo : PGV.autoCapmInfo
                                        }
                                    });
                                }
                            }else{
                                MPopup.alert({
                                    message : "오토캠 조회 대상이 아닙니다.",
                                    callback : function(idx){
                                        if(!isEmpty(PGV.loginInfo)){
                                            MPage.html({
                                                url : PATH_MANAGER.KIA_RNW_120_0000.path,
                                                action : 'CLEAR_TOP',
                                                animate : "SLIDE_LEFT"
                                            });
                                        }else{
                                            MPage.html({
                                                url : PATH_MANAGER.KIA_RNW_120_0000.path,
                                                action : 'CLEAR_TOP',
                                                animate : "SLIDE_LEFT"
                                            });
                                        }
                                    }
                                });
                            }
                        }
                    });
                }else{
                    var msg = "로그인 후 이용이 가능합니다.\n로그인 하시겠어요?"
                    var _returnUrl = PATH_MANAGER.KIA_RNW_091_0000.path;        // 로그인 후 메세지함으로 이동
                    var _params = {};
                    MPopup.confirm({
                        message : msg,
                        buttons : ["취소", "로그인"],
                        callback : function(idx){
                            if(idx == 1){ // 로그인 눌렀을때
								var param = {
									returnLink : _returnUrl,
									returnParams : _params
								}
								ccspLogin(param);
                                return false;
                            }else{
                                return false;
                            }
                        }

                    });
                }
            }else{
                // android 가 아니거나 버전이 낮을경우 못봄
                MPopup.alert({
                    message : "해당 기종은 오토캠 서비스를 지원하지 않습니다.",
                    callback : function(idx){
                        if(!isEmpty(PGV.loginInfo)){
                            MPage.html({
                                url : PATH_MANAGER.KIA_RNW_120_0000.path,
                                action : 'CLEAR_TOP',
                                animate : "SLIDE_LEFT"
                            });
                        }else{
                            MPage.html({
                                url : PATH_MANAGER.KIA_RNW_120_0000.path,
                                action : 'CLEAR_TOP',
                                animate : "SLIDE_LEFT"
                            });
                        }
                    }
                });
            }
            break;

        case "16" :     //ksw 차량정비현황
			var pushDatas = JSON.parse(dataArr[3]);
			if(!isEmpty(pushDatas)){
				MPage.html({
                    url : PATH_MANAGER.KIA_RNW_247_0000.path,
                    param : {
                        repairFlag : "03",
                        carNo : pushDatas.carNo,
                        hpNo : pushDatas.hpNo
                    }
                });
			}
            break;

        case "PACC" :     //차계부
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_220_0000.path
            });
            break;

        case "PCHR" :     //차계부
        case "PMTA" :     //차계부
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_220_0000.path
            });
            break;

		default :
			if(MData.global("PUSH_APP_INIT") == 'Y'){	//앱이 초기화되고 들어왔다면
				var _page = PATH_MANAGER.KIA_RNW_120_0000;
				if(MData.global('loginInfo')){	//로그인이 되어있다면 tobe에서는 한 화면분기로 나뉨
					MPage.html({
						url : _page.path,
						action : 'CLEAR_TOP'
					});
				}else{
					MPage.html({
						url : _page.path,
						action : 'CLEAR_TOP'
					});
				}
			}else{	//앱이 초기화 되지 않고 백그라운드 나 포어그라운드에 있다가 들어왔다면
				
			}
		MData.removeGlobal("PUSH_APP_INIT");
		break;
	}


	// if(PGV.loginInfo){
	// 	MPage.html({
	// 		url : PATH_MANAGER.KIA_RNW_620_0000.path,
	// 		param : {
	// 			notiNo : dataArr[1],
	// 			//TODO 파라미터 삭제 필요
	// 			notiTitle : "PUSH를 통한 공지사항 진입",
	// 			notiDate : "YYYY-MM-DD(PUSH)"
	// 		}
	// 	});
	// }else{
	// 	MPopup.confirm({
	// 		message : "공지사항은 로그인 후 이용이 가능합니다.\n로그인 하시겠어요?",
	// 		callback : function(idx){
	// 			if(idx == 1){ // 로그인 눌렀을때
	// 				MPage.html({
	// 					url : PATH_MANAGER.KIA_RNW_060_0000.path,
	// 					param : {
	// 						returnLink : PATH_MANAGER.KIA_RNW_620_0000.path,
	// 						returnParams : {
	// 							notiNo : dataArr[1],
	// 							//TODO 파라미터 삭제 필요
	// 							notiTitle : "PUSH를 통한 공지사항 진입",
	// 							notiDate : "YYYY-MM-DD(PUSH)"
	// 						}
	// 					}
	// 				});
	// 				return;
	// 			}else{ 
	// 				return false;
	// 			}
	// 		}
	// 	});
	// }
}

/**
* 앱이 죽어있는 상태에서 푸시를 타고 들어온 경우 푸시 확인
*/
var getPushDataWhenClosedApp = function(){
	var data = MData.global("PUSH_DATA");
	var title = MData.global("PUSH_TITLE");
	var message = MData.global("PUSH_MESSAGE");
	
	if(!isEmpty(data) || !isEmpty(title) || !isEmpty(message)){
		MData.removeGlobal("PUSH_DATA");
		MData.removeGlobal("PUSH_TITLE");
		MData.removeGlobal("PUSH_MESSAGE");
		MData.global("PUSH_APP_INIT", 'Y');

		if(MInfo.device().os.name == "Android"){
			onReceiveNotification(data, "NOTIFICATION", title, message);
		}else{
			onReceiveNotification(data, "NOTIFICATION", message, title);	//ios는 네이티브에서 셋팅하는 위치가 바뀜
		}
		return true;
	}

	return false;
}



/**
* 모피어스 화면이 아닌 다른 화면(카메라, 갤러리, 커스텀 웹뷰 등)에서 모피어스 화면으로 복귀한 경우 푸시 확인
*/
var getPushDataWhenNotMorpheusView = function(){
	var data = MData.global("PUSH_FORE_DATA");
	var title = MData.global("PUSH_FORE_TITLE");
	var message = MData.global("PUSH_FORE_MESSAGE");

	if(!isEmpty(data) || !isEmpty(title) || !isEmpty(message)){
		MData.removeGlobal("PUSH_FORE_DATA");
		MData.removeGlobal("PUSH_FORE_TITLE");
		MData.removeGlobal("PUSH_FORE_MESSAGE");

		if(MInfo.device().os.name == "Android"){
			onReceiveNotification(data, "DIRECT", title, message);
		}else{
			onReceiveNotification(data, "DIRECT", message, title); //ios는 네이티브에서 셋팅하는 위치가 바뀜
		}
	}
}
