/**

 @파일명 : KIA_RNW_0D1_0000.js
 @작성자 : 정목단
 @생성일 : 2022.03.19
 @메뉴명 : 알림목록
 @DESC : 전체메뉴노출[X]	로그인[0]
 */
var notiMng;
var KIA_RNW_0D1_0000 ={
    init: function(){
        notiMng = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var backFlag = MData.param("backFlag");
        if(backFlag != "Y"){
            garbageCollector();//common.js
        }
        notiMng.getMsgList()
            .then(notiMng.uiMsgList)
            .finally(
                function(){
                    notiMng.setEventListner();
                    console.log("page : " + PGV.currentPage + "initiolizing END")
                }
            );
    },
    postMsgReadStatus: function (data) {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.msg.changeStateReceived,
            sendData: {
                mbrId: PGV.loginInfo.mbrId,
                pushMsgNo: data.pushMsgNo
            },
            indicatorYn: "Y",
        };
        return MNet.httpSendAsync(options);
    },
    setEventListner: function(){
        function setPublisherEventListener() {
            var _sliderFilterList = new Swiper('.slider-filter-list', {
                spaceBetween:0,
                slidesPerView:'auto',
                //centeredSlides:true,
                loopedSlides:1,
                loop: false,
                speed:300,
                grapCursor:true,
                observer:true,
                observParents:true,
                resistanceRatio:0 //드래그 저항비율 제어
            });

            $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
                e.preventDefault();
                var getSlideIdx = $(this).data('slide-index');
                //console.log('getSlideIdx', getSlideIdx)
                _sliderFilterList.slideTo(getSlideIdx, 300, false);
                $('.slider-filter-list').find('.active').removeClass('active');
                $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
            });
            fnAccodian();//ui_rnw.js
        }

        setPublisherEventListener();

        //닫기
        $(".btn-close").off("click").on("click", function(){
            var options = {animate: "MODAL_UP"};
            if (!isEmpty(notiMng.readNoti)) {
                options.param={};
                options.param.readNoti = notiMng.readNoti;
            }
            MPage.back(options);
        });
        //메뉴카테고리 선택시
        $('div.swiper-slide').has(".btn-filter").on("click", function(){
            var that = this;
            var filterCd = $(that).data('pushFilterCd');
            var _$pushItemList = $("#msgList > li");
            if(filterCd==""){
                if(_$pushItemList.length>0){
                    $(".nodata-area").addClass("none");
                    $("#msgList > li").removeClass("none");
                }else{
                    $(".nodata-area").removeClass("none");
                }
            }else{
                $.each(_$pushItemList, function (idx,item){
                    var data = $(item).data('pushItemData');
                    if(data.pushClsCcd== filterCd){//맞는 카테고리

                        $(item).removeClass("none");
                    }else{//아닌카테고리
                        $(item).addClass("none");

                    }
                });
                var displayNoneLength = $("#msgList > li.none").length;
                if(_$pushItemList.length===displayNoneLength){
                    $(".nodata-area").removeClass("none");
                }else{
                    $(".nodata-area").addClass("none");
                }
            }
        });


        function doReadMsg(data) {
            if(!isEmpty(data.oldPushClsCcd)
                && (!(data.pushStateCcd === "10004" || (data.pushStateCcd === "10003"&&data.recYn==="Y")))){ // 20190510 수신 확인 추가
                return notiMng.postMsgReadStatus(data)
                    .then(
                        function (response) {
                            exWNHideIndicator();
                            if (!isEmpty(response) && response.resultCode == "200") {
                                notiMng.readNoti = "Y";
                                return true;
                            } else {
                                var msg;
                                if (!isEmpty(response) || !isEmpty(response.errorCode)) {
                                    if (!isEmpty(response.errorCode)) {//통신응답오류
                                        COMMON_FUNCTION.TOOL.DEBUG.showTalk("네트워크 통신 에러 : " + response.errorCode);
                                        msg = response.errorMessage;
                                    }
                                } else {
                                    msg = response.resultMsg;
                                }
                                MPopup.instance(msg);
                                return false;
                            }
                        }
                    );
            }
        }

        function goToLink(pushData) {
            notiMng.pushLinkProcess(pushData)
                .then(notiMng.pushLinkAction)
                .catch(
                    function (e) {
                        COMMON_FUNCTION.TOOL.DEBUG.showTalk(e);
                    }
                );
        }

        /* 메세지 클릭시 이벤트 */
        function confirmOnMessage() {
            var _$that = $(this);
            var pushData = _$that.closest('li').data('pushItemData');
            var _$doReadEl = _$that.closest("li").has(".active");
            //읽지 않은 메세지 읽음 처리
            if (!isEmpty(_$doReadEl)) {
                doReadMsg(pushData).then(function (isSuccess) {
                    if (isSuccess) _$that.closest('li').find(".ico-cont>i").removeClass("active");
                    exWNHideIndicator();
                });
            }

            //링크이동있으면 이동.
            var _$ahrefEl = $(this).parent("a");
            var _linkUrl = _$ahrefEl.data('pushLinkUrl');
            pushData.dataLinkUrl = _linkUrl;
            var _$linkIcon = _$ahrefEl.find("button.btn-arrow i.ico-arrow-css--link");
            if (!isEmpty(_$linkIcon)) {
                goToLink(pushData);
            }
        }
        // $("#msgList li button.btn-arrow").has("i.ico-arrow-css").on("click",function (e){
        //     confirmOnMessage.call(this);
        // });
        $("#msgList li button.btn-arrow").on("click",function (e){
            confirmOnMessage.call(this);
        });

        $("#msgList li div.div-table").off("click").on("click",function (e){
            confirmOnMessage.call(this);
        });
        /**  자세히 보기 클릭시 링크이동. */
        $("#msgList li button.push-link").has('em.push-link').off("click").on("click",function (e){
            var _linkUrl =  $(this).data('pushLinkUrl');
            var pushData = $(this).closest("li.push-item.active").data("pushItemData");
            pushData.dataLinkUrl = _linkUrl;
            goToLink(pushData);
        });

        exWNHideIndicator();
    },
    uiMsgList: function (receivedData) {
        var code;
        var msg;
        if(!isEmpty(receivedData.errorCode)){
            code = receivedData.errorCode;
            msg = receivedData.errorMessage;
            MPopup.alert(msg);
            return;
        }else{
            code = receivedData.resultCode;
            msg = receivedData.resultMsg;
            if (code == "200") {
                notiMng.uiAppendMsgList(receivedData.msgInfoListRnwResDto);
                PGV.totCnt = receivedData.totCnt;
                PGV.pageStart = receivedData.pageStart;
                PGV.pageEnd = receivedData.pageEnd;
            } else {
                $(".no-data").removeClass("none");
                $(".ipt-wrap").addClass("none");
                $("#msgList").addClass("none");
                if (code != "401" && code != "402") {
                    MPopup.alert(msg);
                }
            }
            return;
        }
    },
    uiAppendMsgList: function (msgInfoList) {
        var msgList = "";
        if(msgInfoList.length > 0){
            for(var i=0; i< msgInfoList.length; i++){
                var obj = msgInfoList[i];
                var sndDtm = moment(obj.sndDtm).format('YYYY.MM.DD');
                /* 수신확인에 대한 로직*/
                var isNewMessageClass = '';
                if (!isEmpty(obj.oldPushClsCcd)
                    && !(obj.pushStateCcd === "10004" || (obj.pushStateCcd === "10003" && obj.recYn === "Y"))) {	// 수신 확인 로직 추가 20190510
                    isNewMessageClass = 'active';
                }
                var contentIconClass =notiMng.DICT.notiType[obj.pushClsCcd].iconClass;
                var linkUrl = '';
                if(obj.pushClsCcd===obj.oldPushClsCcd){
                    linkUrl = isEmptyStr(obj.menuPath);
                }else{
                    if(obj.oldPushClsCcd == "00"){
                        //as-is 데이터규격의 메세지.
                        linkUrl = isEmptyStr(obj.menuPath);
                    }else{
                        linkUrl = isEmptyStr(obj.relEvtNo);
                    }
                }
                // obj.refId =linkUrl;//화면최종이동할 참조링크 정보 url이 될수도 게시물 번호가 될수도 있음.

                var title = // 모든  case 공통
                    "<div class='div-table'>"
                    + "  <div class='div-table-cell cell-01'>"
                    + "    <div class='ico-cont'>"
                    + "      <i class='"+ contentIconClass+' '+isNewMessageClass+"'></i>"
                    + "    </div>"
                    + "  </div>"
                    + "  <div class='div-table-cell cell-02'>"
                    + "    <div class='text-title'>"
                    + "      <h6 class='text-scale-06'>"
                    + "        <b>" +obj.msgTitle+"</b>"
                    + "      </h6>"
                    + "      <em class='date'>"+sndDtm+"</em>"
                    + "    </div>"
                    + "  </div>"
                    + "</div>";
                var titleArrowBtn = "";
                var headerInnerConts = "";
                var msgBody = "";
                if(isEmpty(obj.msg)){
                    if(isEmpty(linkUrl)){
                        //title only do nothing
                    }else{
                        //title + arrow btn
                        titleArrowBtn =
                            "<button type='button' class='btn-arrow push-link'>" +
                            "  <i class='ico-arrow-css--link'></i>" +
                            "</button>";
                    }
                    headerInnerConts =
                      "     <a href='javascript:void(0);' class='js-accordion-btn js-accordion-disabled' data-push-link-url='" + linkUrl + "'>"
                    +           title
                    +           titleArrowBtn
                    + "     </a>";
                }
                else{
                    titleArrowBtn =
                        "<button type='button' class='btn-arrow'>"
                        + "  <i class='ico-arrow-css'></i>"
                        + "</button>";
                    headerInnerConts =
                        "     <a href='javascript:void(0);' class='js-accordion-btn' data-push-link-url='" + linkUrl + "'>"
                        +           title
                        +           titleArrowBtn
                        + "     </a>";
                    if(isEmpty(linkUrl)){
                        //내용 보기
                        msgBody =
                            "<div class='panel-body js-accordion-body'>"
                            + "  <p>" +obj.msg+"</p>"
                            + "</div>";
                    }else{
                        //내용 보기 + 자세히 보기 링크 이동.
                        msgBody =
                            "<div class='panel-body js-accordion-body'>"
                            +"  <p>" +obj.msg+"</p>"
                            +"  <button type='button' class='btn-more push-link' data-push-link-url='"+linkUrl+"'>"
                            +"    <em class='text-underline c-font-primary push-link'>자세히 보기</em>"
                            +"  </button>"
                            +"</div>";
                    }
                }

                var dataJsonStr = (JSON.stringify(obj)).replaceAll("&", "&amp;")
                    .replaceAll("<", "&lt;")
                    .replaceAll(">", "&gt;")
                    .replaceAll("\\\"", "&quot;")
                    .replaceAll("'", "&#x27;")
                    .replaceAll("/", "&#x2F;");

                msgList +=
                    // "<li class='panel js-accordion-item push-item' data-push-item-data='"+JSON.stringify(obj)+"'>"
                    // "<li class='panel js-accordion-item push-item' data-push-item-data='"+encodeURIComponent(JSON.stringify(obj))+"'>"
                    "<li class='panel js-accordion-item push-item' data-push-item-data='"+dataJsonStr+"'>"
                    + "<div class='panel-header'>"
                    +  headerInnerConts
                    + "</div>"
                    + msgBody
                    +"</li>";
            }
            $("#msgList").append($(msgList));
            $("#msgList").removeClass("none");
            $(".nodata-area").addClass("none");
        }
        else{
            $("#msgList").addClass("none");
            $(".nodata-area").removeClass("none");
        }
    },
    getMsgList: function () {
        PGV.currentPageNo = 1;			// 현재 페이지 번호
        PGV.pageSize = 20;				// 받은 페이지의 총 개수
        PGV.totCnt = null;
        PGV.pageStart = null;
        PGV.pageEnd = null;
        PGV.msgCd = "all";         //all':이벤트전체
        PGV.select = 0;	 //리스트 팝업 선택
        PGV.readNoti = "N";
        $("#msgList").empty();
        var data = {
            apiId : _API.SVR.CMM.msg.msgList.apiId,//필수
            mbrId : PGV.loginInfo.mbrId,//필수
            currentPageNo : PGV.currentPageNo,
            pageSize : PGV.pageSize
        };
        return MNet.httpSendAsync({
            isMock: false,
            path : _API.SVR.CMM.msg.msgList,
            sendData : data,
        });


    },
    pushLinkProcess:function(data){
        return new Promise(function(resolve,reject){
            var LNTP ={activity:"activity",page:"page",browser:"browser", back:"back"}
            var linkInfo = {
                type: null,//activity,page,browser
                url:data.dataLinkUrl,//링크, 페이지경로
                param:{}//전달 파라미터
            }
            //todo PMTA|"15"|"16" - 정비의 경우 로직 변경 가능성 있음.
            if(data.oldPushClsCcd !==data.pushClsCcd){//as-is 기준 적용
                if (["02","15"].includes(data.oldPushClsCcd)){
                    var options={};
                    /**
                     * 1. 이벤트 상세조회
                     * 2. 외부링크, 카앤라이프, 이벤트로 구분
                     */
                    if(data.oldPushClsCcd=="02"){
                        options = {
                            path : inf.event.detailEvent.url,
                            sendData: {
                                evtNo: data.relEvtNo
                            },
                            method: CONSTANT.NET_MTHD.GET,
                        };
                        MNet.httpSendAsyncAsIs(options)
                            .then(
                                function(receivedData){
                                    exWNHideIndicator();
                                    var code = receivedData.resultCode;
                                    var msg = receivedData.resultMsg;
                                    if(code == "200") {
                                        var lingUrl = (receivedData.lingUrl||"");
                                        if (lingUrl.indexOf("http") > -1) {      // 웹뷰일 경우
                                            if (lingUrl.indexOf("https://givecard.kakaomobility.com") > -1) {     // 20211216 이벤트 임의 수정 (음주운전예방 browser실행)
                                                linkInfo.type = LNTP.browser;
                                            } else {
                                                linkInfo.type = LNTP.activity;
                                            }
                                            linkInfo.url = lingUrl;
                                            resolve(linkInfo);
                                        }
                                        else if (lingUrl.indexOf("carnLife") > -1) {        // 카앤라이프일경우
                                            var carNlifeChek = lingUrl.split("@");
                                            if (!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "carnLife") {     // 카앤라이프일경우 이벤트 등록 형식 carnLife@/a/M070100@621
                                                linkInfo.type = LNTP.page;
                                                linkInfo.url = PATH_MANAGER.KIA_RNW_810_0000.path;
                                                linkInfo.param = {
                                                    rUrl: CONSTANT.AUTON_URL_PREFIX + carNlifeChek[1],
                                                    evtCd: isEmpty(carNlifeChek[2]) ? "" : carNlifeChek[2],
                                                    evtYN: "N"
                                                }
                                            }
                                            resolve(linkInfo);
                                        }
                                        else {      // 상세페이지일 경우
                                            linkInfo.type = LNTP.page;
                                            linkInfo.url = PATH_MANAGER.KIA_RNW_721_0000_1.path;
                                            linkInfo.param = {
                                                evtNo: data.dataLinkUrl,		// 이벤트 번호
                                                eventType: "msg"	// 이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
                                            };
                                            resolve(linkInfo);
                                        }
                                    }
                                }
                            );
                    }
                    /**
                     * 1. 오토캠 가능여부 조회
                     */
                    else if(data.oldPushClsCcd=="15"){
                        PGV.autoCapmInfo = {};
                        var pushDatas = JSON.parse(PGV.pushData[PGV.pushMsgNo]);
                        var _appVersion = M.info.app().app.version;	// 앱 버전
                        var _osName = MInfo.device().os.name; // OS 이름 (Android, iOS)
                        var _osVersion = MInfo.device().os.version;		// OS 버전
                        var _vin = pushDatas.vin;   //차대번호
                        if(_osName =="Android" && _appVersion != "1.1.6" &&  _appVersion != "1.1.5" && parseInt(_osVersion) >=23){
                            options = {
                                path: _API.SVR.MYCAR.autoCam.autoCamPwdInfo.url,
                                sendData: {
                                    vin: data.vin,
                                    hpno: PGV.loginInfo.hpno
                                },
                                backup: data,
                            }
                            MNet.httpSendAsyncAsIs(options)
                                .then(
                                    function(receivedData){
                                        exWNHideIndicator();
                                        var code = receivedData.resultCode;
                                        var msg = receivedData.resultMsg;
                                        if(code == "200"){
                                            // api 호출 후 정보 확인
                                            PGV.autoCapmInfo = {
                                                atcmId : receivedData.atcmId,//"skbuser1",
                                                atcmEbc : receivedData.atcmEbc,//"a1234567890",
                                                camId : receivedData.camId,//"49189",
                                                viewCnt : receivedData.viewCnt,//"2",
                                                asnNm : receivedData.asnNm,//"테스트지점"
                                                vin : receivedData.vin,//"테스트지점"
                                                repnAsnCd : receivedData.repnAsnCd,//"MX0100",
                                                rgstLftCd : receivedData.rgstLftCd,//"01",
                                                trtmSn : receivedData.trtmSn,//"1",
                                                trtmYmd : receivedData.trtmYmd//"20171213"
                                            }
                                            if(!isEmpty(PGV.autoCapmInfo)){
                                                linkInfo.type = LNTP.page;
                                                linkInfo.url = PATH_MANAGER.KIA_RNW_247_1000.path;
                                                linkInfo.param = {autoCapmInfo : PGV.autoCapmInfo};
                                            }
                                            resolve(linkInfo);
                                        }
                                        else{
                                            MPopup.alert("해당 기종은 오토캠 서비스를 지원하지 않습니다.");
                                            return;
                                        }

                                    }
                                );
                        }

                    }

                }
                else{
                    switch(data.oldPushClsCcd){
                        /**링크*/
                        case "00" :
                            linkInfo.type = LNTP.activity;
                            if(isEmpty(data.dataLinkUrl)){
                                linkInfo.url = null;
                            }else{
                                linkInfo.url = data.dataLinkUrl
                            }
                            resolve(linkInfo);
                            break;
                        /**이달의 구매혜택*/
                        case "04" :
                            // linkInfo.type = LNTP.activity;
                            // linkInfo.url = CONSTANT.LINK_URL.KIA_RNW_313_0000.URL;
                            // resolve(linkInfo);
                            break;
                        /**신차안내==> 차량구매*/
                        case "03":
                            if(!isEmpty(PGV.loginInfo)&&!isEmpty(PGV.passData.selectCar))
                            linkInfo.type = LNTP.back;
                            linkInfo.url = null;
                            linkInfo.param = {"tabLevel1":"carbuy","tabLevel2":0};// todo 인덱스값으로 전달.인사이트[0]차계부[1]소모품[2]정비[3]
                            resolve(linkInfo);
                            break;
                        /**공지사항*/
                        case "05":
                            linkInfo.type = LNTP.page;
                            linkInfo.url = PATH_MANAGER.KIA_RNW_620_0000.path;
                            if(!isEmpty(data.dataLinkUrl)){//상세이동은
                                linkInfo.param = {
                                    notiNo : data.dataLinkUrl
                                };
                            }
                            resolve(linkInfo);
                            break;
                        /**쿠폰함*/
                        case "11":
                            linkInfo.type = LNTP.page;
                            linkInfo.url = PATH_MANAGER.KIA_RNW_0D3_3100.path;//"../000/KIA_RNW_0D3_3100"
                            resolve(linkInfo);
                            break;
                        /**다운 쿠폰함*/
                        case "12":
                            linkInfo.type = LNTP.page;
                            linkInfo.url = PATH_MANAGER.KIA_RNW_0D3_3100.path;
                            linkInfo.param = {
                                downYn : "Y"
                            };
                            resolve(linkInfo);
                            break;
                        /**설문*/
                        case "14":
                            linkInfo.type = LNTP.page;
                            linkInfo.url = PATH_MANAGER.KIA_RNW_420_0000.path;
                            linkInfo.param = {
                                srvyNo : data.dataLinkUrl
                            };
                            resolve(linkInfo);
                            break;
                        /**ksw 차량정비현황*/
                        case "16":
                            linkInfo.type = LNTP.page;
                            if(!isEmpty(pushDatas)){
                                linkInfo.url = PATH_MANAGER.KIA_RNW_420_0000.path;
                                linkInfo.param = {
                                    repairFlag : "03",
                                    carNo : data.carNo,
                                    hpNo : data.hpNo
                                };
                            }
                            resolve(linkInfo);
                            break;
                        default:
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("as-is 푸시 메뉴이동 : "+screenId);
                            reject(linkInfo);
                            break;
                    }
                }
            }
            else{
                //todo 링크이동/데이터 모양에 대해서 협의해야함.
                var screenId = data.menuPath;
                //todo as-is 처리내용 추가해야 함. 설문조사, 링크이동 등....
                var expected= true;
                switch(screenId){
                    case "KIA_RNW_220_0000": //(내차관리>차계부탭)
                        linkInfo.type = LNTP.back;
                        linkInfo.url = null;
                        linkInfo.param = {"tabLevel1":"mycar","tabLevel2":1};// todo 인덱스값으로 전달.인사이트[0]차계부[1]소모품[2]정비[3]

                        break;
                    case "KIA_RNW_230_0000": //(내차관리>소모품탭)
                        linkInfo.type = LNTP.back;
                        linkInfo.url = null;
                        linkInfo.param = {"tabLevel1":"mycar","tabLevel2":2};// todo 인덱스값으로 전달.인사이트[0]차계부[1]소모품[2]정비[3]

                        break;
                    case "KIA_RNW_0D3_3100": //(My Kia> 쿠폰 > 할인 쿠폰 탭) 다운로드가능탭으로 이동하기 위해서는  param에 downYn 'Y'를 셋팅해서 받아야한다
                        linkInfo.type = LNTP.page;
                        linkInfo.url = PATH_MANAGER["KIA_RNW_0D3_3100"].path;
                        linkInfo.param = null;
                        break;
                    case "KIA_RNW_560_0000": //(전체메뉴 > 충전 모니터링 화면)
                        linkInfo.type = LNTP.page;
                        linkInfo.url = PATH_MANAGER[screenId].path;
                        linkInfo.param = null;

                        break;
                    default:
                        expected=false;
                        COMMON_FUNCTION.TOOL.DEBUG.showTalk("TOBE 푸시 구분코드 : "+data.oldPushClsCcd);

                        break;

                }

                if(expected){
                    resolve(linkInfo);
                }else{
                    reject(linkInfo);
                }
            }
        });


    },
    pushLinkAction: function (linkInfo){
        if(isEmpty(linkInfo)||isEmpty(linkInfo.type)||(linkInfo.type!=="back"&&isEmpty(linkInfo.url))){
            return;
        }
        if(linkInfo.type=="page"){//app내 페이지 이동
            notiMng.pushLinkPage(linkInfo.url,linkInfo.param);
        }else if(linkInfo.type=="activity"){//외부 링크 웹뷰
            notiMng.pushLinkWebActivity(linkInfo.url);
        }else if(linkInfo.type=="back"){//홈귀속 메뉴로 이동.
            MPage.back({param:linkInfo.param});
        }else{//browser
            MApps.browser(linkInfo.url);
        }

    },
    pushLinkWebActivity :function(url){
        MPage.activity({
            className : "WebviewActivity",
            param : {
                method : CONSTANT.NET_MTHD.GET,
                requestURL : url
            }
        });
    },
    pushLinkPage:function(url,param){
        var options = {url : url,};
        if(!isEmpty(param)){
            options.param = param;
        }
        MPage.html(options);
    },
}
KIA_RNW_0D1_0000.DICT = {};
KIA_RNW_0D1_0000.DICT.notiType = {
    "PNOR":{cd:"PNOR",text:"일반",iconClass:"ico-normal"},
    "PNOT":{cd:"PNOT",text:"공지",iconClass:"ico-notice"},
    "PEVE":{cd:"PEVE",text:"이벤트",iconClass:"ico-event"},
    "PCOU":{cd:"PCOU",text:"쿠폰",iconClass:"ico-coupon"},
    "PACC":{cd:"PACC",text:"차계부",iconClass:"ico-carbook"},
    "PMTA":{cd:"PMTA",text:"정비",iconClass:"ico-repair"},
    "PCHR":{cd:"PCHR",text:"충전",iconClass:"ico-charge"},
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        // MyKiaBottomTab.activate({
        //     afterInit: function(){
        //         console.log("heyyy");
        //     },
        //     afterOpenedTheTab: function(){
        //         console.log("heyyy");
        //     }
        // });
        KIA_RNW_0D1_0000.init();
    },
    onHide : function(event){},
    onRestore : function(event){
        var activeTabLevel1 = MData.param("activeTabLevel1");
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    onBack : function(){
        var options = {animate: "MODAL_UP"};
        if (!isEmpty(notiMng.readNoti)) {
            options.param={};
            options.param.readNoti = notiMng.readNoti;
        }
        MPage.back(options);
    },
    onDestroy : function(event){},
    onPause : function(event){},
    onResume : function(event){}
};

//todo 목데이터 조정후 자세히보기/링크 등 오픈하기.
//todo 3-22
// 1. 알림목록 테스트
// 2. 바코드 페이지.
