/**

@파일명 : KIA_RNW_0D2_0000.js 
@작성자 : 정목단
@생성일 : 2022.05.21
@메뉴명 : 바코드 팝업
@DESC : 로그인[O]
*/ 
var barcodeMng; 
var KIA_RNW_0D2_0000 ={
    editableCardList :[],//편집가능한 카드목록(숨김처리포함)
    showableCardList : [],//바코드에 전시되는 카드목록(숨김처리불포함)
    allOilCards : [],//정유사카드(연동, 연동해지 포함, 미연동은 해당x)
    toLinkService :null,// 연결하고자 했던 정유사 서비스
    init: function(){
        // alert("XXXX");
        // debugger;
        barcodeMng = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        stackRemoveRvs(PATH_MANAGER.KIA_RNW_0D2_0000.nameWithHtml);
        stackRemoveRvs(PATH_MANAGER.KIA_RNW_0D2_2400.nameWithHtml);
        barcodeMng.checkRedMemberJoinWithPoint()
            .then((result) => this.getCardList(result))
            .then(
                function (result) {
                    const isMember = result.isMember;
                    const cards = result.cards;
                    const regularCardList = cards.cardMemberRnwResDto || [];
                    const oilCardList = cards.cardOilListRnwResDto || [];

                    // PGV.passData.gnb.barcode.cardList = cards;
                    let hasMembership = true;
                    let hasCard = true;
                    if(isMember === "false") { // 멤버십가입정보가 없다면,
                        hasMembership = false;
                    }
                    if(regularCardList.length + oilCardList.length == 0){ // 카드 전체 없으면 memberscard 없는것으로 동치
                        hasCard = false;
                    }
                    const sortCardList = barcodeMng.sortCardList(cards);// 멤버쉽|제휴사(숨김카드, 정유해제카드 포함됨)

                    if(hasMembership){
                        let showableCardList = barcodeMng.getShowableCardList(sortCardList);
                        let editableCard=[];
                        let allOilCards=[];
                        let isShowSomething= !isEmpty(showableCardList);
                        $.each(sortCardList,function (idx, item){
                            let isShow=false;
                            let isOilCard=false;
                            let isEditable=false;
                            // TODO: oilJoinYn 추가 속성에 따른 코드 수정 (완료)
                            if (item.cardType == "oil") {
                                if( item.oilJoinYn == "Y"){ // N 또는 P 또는 Q 인경우에는 isEditable, isShow 모두 false 유지
                                    isEditable=true;
                                    isShow = true;//정유사 연동해제 카드 제외한 카드목록 바코드순서변경팝업.
                                }
                                isOilCard=true;
                            }
                            // 노출리스트 empty=> 연동해지제외 모두  show 한다.
                            if(!isShowSomething) item.isCardDisplay=isShow;

                            if(isEditable){//순서변경, 노출여부 편집가능
                                editableCard.push(item);
                            }
                            if(isOilCard){
                                allOilCards.push(item);
                            }
                        });

                        if (!isShowSomething && isEmpty(showableCardList)) {
                            showableCardList = barcodeMng.getShowableCardList(sortCardList);
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("보유카드가 모두 숨김처리되어 전체 노출로 변경되었습니다.");
                            var revisedCardList = COMMON_FUNCTION.TOOL.CARD.getRevisedCardList(showableCardList,M.data.storage("myCardList"));
                            M.data.removeStorage("myCardList");
                            M.data.storage("myCardList",revisedCardList);
                        }

                        barcodeMng.editableCardList = editableCard;
                        barcodeMng.showableCardList = showableCardList;
                        barcodeMng.allOilCards = allOilCards;

                        barcodeMng.uiShowableCard(showableCardList,allOilCards)
                            .then(function(orderedCardList){
                                barcodeMng.setEventListner();
                                barcodeMng.setPublishingEventListener(orderedCardList);
                            })
                    } else {
                        var oilCards=sortCardList.filter(
                            function (item) {
                                var isShow = true;
                                if (item.cardType == "oil" && item.oilJoinYn == "N") {
                                    isShow = false;//정유사 연동해제 카드 제외한 카드목록 바코드순서변경팝업.
                                }
                                return item.isCardDisplay && isShow;
                            }
                        );
                        if(!isEmpty(oilCards)) COMMON_FUNCTION.TOOL.DEBUG.showTalk("멤버쉽에 가입해야 제휴사 카드를 볼 수 있습니다.");
                        barcodeMng.uiNotMember().then(barcodeMng.setEventListner);
                    }
                }
            )
            .then(barcodeMng.showPopup);
    },
    setEventListner: function(){

        /**
         * 카드순서 변경 버튼 클릭시
         */
        $('#mykia-edit-card-order-button').off().on("click", function(){
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_0D2_1000.path,
                param:{cardList : barcodeMng.editableCardList}
            })
        });
        //기아멤버쉽가입번튼 클릭시
        $("button.btn-kia-membership-join").on("click",function(){
            var _url = CONSTANT.LINK_URL.KIA_RNW_0D2_3000.URL;
            MPage.activity({
                className : "WebviewActivity",
                param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.POST, _url, {mbrId : PGV.loginInfo.mbrId})
            });
        });
    },
    setPublishingEventListener: function(orderedCardList){
        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderMembershipCard = new Swiper('.slider-membership-card', {
            slidesPerView:1,
            loop:true,
            speed:300,
            autoHeight: true,
            grabCursor:true,
            touchRatio: $('.slider-membership-card .swiper-slide').length > 1, // 슬라이드 영역 1개일경우 드래그 금지
            pagination: {
                el: '.membership-cont .swiper-pagination',
                clickable: true,
                dynamicBullets:true, // 20220530//(Ina)dynamicBullets 옵션추가
                dynamicMainBullets:8  // 20220530//(Ina)dynamicMainBullets 옵션추가
            },
            on: {
                /* 슬라이드 변경 시 해당 슬라이드 정보 바탕으로 하단 버튼 노출 여부 결정 필요함 */
                slideChange: function() {
                    var curNode = $(this.slides[this.activeIndex]);
                    //카드 순서 변경 숨기기
                    if(!isEmpty(curNode.find('div.membership-interlock'))){//제휴종합슬라이더.
                        $("#mykia-edit-card-order-button").hide();
                    }else{
                        $("#mykia-edit-card-order-button").show();
                    }

                    // 정유사 이벤트 매핑하기.
                    var nodeCardNumber = curNode.find('.membership-card').data('cardNumber');
                    var cardInfomation = curNode.find('.membership-card').data('cardInformaiton');

                    nodeCardNumber = nodeCardNumber && nodeCardNumber.toString();
                    var membersCard = _.find(orderedCardList, {milgMbrNo: nodeCardNumber});
                    var oilCard = _.find(orderedCardList, {oilCardNo: nodeCardNumber});
                    $('#mykia-disconnect').hide();
                    if(oilCard){
                        var oilCd = cardInfomation.cardTypeDesc;
                        $('#mykia-disconnect').show();
                        $('#mykia-disconnect').off("click").on("click", function(event){
                            event.preventDefault();
                            customPopup.get(
                                PATH_MANAGER.KIA_RNW_0D2_5000.path,
                                $("#popup_0D2_5000"),
                                function(item){//item==POP._0D2_5000.url's html
                                    var popId = "#popup_0D2_5000";
                                    if($(popId).length < 1){
                                        var screenHtml = $("<div></div>");
                                        screenHtml.append(item);
                                        $('body').append(screenHtml.find(popId));
                                    }
                                    RNW_UI.popupLayer({selId : popId});

                                    $(popId+"_DetailBtn").off("click").on("click",function(e){
                                        var activeCardInfo = $(".swiper-slide.swiper-slide-active>div").data();
                                        var options={
                                            isMock: false,
                                            path: _API.SVR.CMM.crd.mbJoinTerm,
                                            sendData: {mbrId: PGV.loginInfo.mbrId, wthOilCd:oilCd}};
                                        MNet.httpSendAsync(options)
                                            .then(
                                                function (response) {
                                                    exWNHideIndicator();
                                                    var msg;
                                                    customPopup.remove($("#popup_0D2_5000"));
                                                    if (response.resultCode == "200" && response.wthYn == 'Y') {
                                                        PGV.passData.gnb.barcode.cardList=null;
                                                        COMMON_FUNCTION.TOOL.CARD.spliceSavedCardList(activeCardInfo.cardNumber);
                                                        msg="제휴사 연동이 해제되었습니다.";
                                                        M.pop.instance(msg);
                                                        MPage.html({url: PATH_MANAGER.KIA_RNW_0D2_0000.path});
                                                    }else{
                                                        msg="제휴사 연동해제에 실패하였습니다.";
                                                        M.pop.instance(msg);
                                                    }

                                                }
                                            );

                                        e.preventDefault();
                                        $("#popup_0D2_5000").fadeOut('fast');
                                        $('body').removeClass('js-overflow-hidden');
                                    });

                                });

                        });
                    }

                }
            }

        });


        /**
         * 주유 정보 연동 버튼 클릭시
         * .swiper-slide-active-->스와이퍼에서 마지막 슬라이더를 복제하기 때문에 id등으로 찾을 수 없다.
         * 위 _sliderMembershipCard에서 슬라이더를 복제하기 때문에 나중에 이벤트셋팅해야한다.
         * */
        $('.mykia-oilpoints-section.SOIL button').on("click", function(event){
            var _$isActive = $(this).closest(".swiper-slide-active");
            if(_$isActive.length > 0){
                var oilCd = $(this).data('oilCd');
                barcodeMng.toLinkService = DICT.SVC_COMPANY[oilCd];
                barcodeMng.toLinkService.reloadOnRestore = true;
                var hasJoinHistory = $(this).data("hasJoinHistory")||"N";
                barcodeMng.toLinkService.cardNumber = $(this).attr("data-oil-card-no");

                if(hasJoinHistory==="Y") {// 재연동=> 약관동의 없음. GSCT의 경우 재연동없이 웹으로 재가입 진행.
                    customPopup.get(
                        PATH_MANAGER.KIA_RNW_0D2_6000.path,
                        $("#popup_0D2_6000"),
                        function(item){//item==POP._0D2_6000.url's html
                            var popId = "#popup_0D2_6000";
                            if($(popId).length < 1){
                                var screenHtml = $("<div></div>");
                                screenHtml.append(item);
                                $('body').append(screenHtml.find(popId));
                            }
                            RNW_UI.popupLayer({selId : popId});

                            $(popId+"_DetailBtn").on("click",function(e){
                                joinSOIL();
                                e.preventDefault();
                                $("#popup_0D2_6000").fadeOut('fast');
                                $('body').removeClass('js-overflow-hidden');
                            });

                        });
                }else {
                    joinSOIL();
                    event.preventDefault();
                    $("#popup_0D2_6000").fadeOut('fast');
                    $('body').removeClass('js-overflow-hidden');
                }
            }
        });
        $('.mykia-oilpoints-section.GSCT button').on("click", function(event){
            var _$isActive = $(this).closest(".swiper-slide-active");
            if(_$isActive.length > 0){
                var oilCd = $(this).data('oilCd');
                barcodeMng.toLinkService = DICT.SVC_COMPANY[oilCd];
                barcodeMng.toLinkService.reloadOnRestore = true;
                var hasJoinHistory = $(this).data("hasJoinHistory")||"N";
                barcodeMng.toLinkService.cardNumber = $(this).attr("data-oil-card-no");

                var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));
                joinGSCT();
                event.preventDefault();
                $("#popup_0D2_6000").fadeOut('fast');
                $('body').removeClass('js-overflow-hidden');
            }
        });

        $('.mykia-oilpoints-section.HDOL button').on("click", function(event){
            var _$isActive = $(this).closest(".swiper-slide-active");
            if(_$isActive.length > 0){
                var oilCd = $(this).data('oilCd');
                barcodeMng.toLinkService = DICT.SVC_COMPANY[oilCd];
                barcodeMng.toLinkService.reloadOnRestore = true;
                var hasJoinHistory = $(this).data("hasJoinHistory")||"N";
                barcodeMng.toLinkService.cardNumber = $(this).attr("data-oil-card-no");

                if(hasJoinHistory==="Y"){// 재연동=> 약관동의 없음. GSCT의 경우 재연동없이 웹으로 재가입 진행.
                    customPopup.get(
                        PATH_MANAGER.KIA_RNW_0D2_6000.path,
                        $("#popup_0D2_6000"),
                        function(item){//item==POP._0D2_6000.url's html
                            var popId = "#popup_0D2_6000";
                            if($(popId).length < 1){
                                var screenHtml = $("<div></div>");
                                screenHtml.append(item);
                                $('body').append(screenHtml.find(popId));
                            }
                            RNW_UI.popupLayer({selId : popId});

                            $(popId+"_DetailBtn").on("click",function(e){
                                if(CONSTANT.IS_HDOL_SVC_OPEN){
                                    joinHDOL();
                                }
                                else{
                                    MPopup.alert("아직 준비중입니다.\n빠른 시일 내에 서비스 제공할 예정입니다.");
                                }
                                e.preventDefault();
                                $("#popup_0D2_6000").fadeOut('fast');
                                $('body').removeClass('js-overflow-hidden');
                            });

                        });
                } else if(hasJoinHistory === "P") {
                    if(CONSTANT.IS_HDOL_SVC_OPEN){
                        joinHDOL();
                    }else{
                        MPopup.alert("아직 준비중입니다.\n빠른 시일 내에 서비스 제공할 예정입니다.");
                    }
                    event.preventDefault();
                    $("#popup_0D2_6000").fadeOut('fast');
                    $('body').removeClass('js-overflow-hidden');
                } else {
                    // hasJoinHistory가 N 또는 Q일때
                    if(CONSTANT.IS_HDOL_SVC_OPEN){
                        joinHDOL();
                    }else{
                        MPopup.alert("아직 준비중입니다.\n빠른 시일 내에 서비스 제공할 예정입니다.");
                    }
                    event.preventDefault();
                    $("#popup_0D2_6000").fadeOut('fast');
                    $('body').removeClass('js-overflow-hidden');
                }
            }
        });

        function joinGSCT() {
            //1. 서버로 부터 인증정보 받아오기.
            barcodeMng.getGsCaltexJoinReq()
                .then(
                    function (response) {
                        if (response.resultCode === "200") {

                            // todo 요청 필수 값검증 처리하기. 대기, 신상철 차장님 api 문의요청드림.
                            var serverData = response.crdGsctWebCnntRnwDto;
                            if(isEmpty(serverData)){
                                COMMON_FUNCTION.TOOL.DEBUG.showTalk("GS 칼텍스 회원가입 쿼리스트링 요청에 대한 응답이 EMPTY입니다.");
                                return;
                            }
                            var keys = ["regWebUrl", "accessToken", "refreshToken", "ccoCd", "reqDivCode", "frnchseCd", "rtnUrl"];
                            var sendData = {};
                            $.each(keys, function (index, key) {
                                var value = serverData[key];

                                if (!isEmpty(serverData[key]) && isEmpty(value)) {
                                    throw new Error("check requiredParam( " + key + " )is null")
                                } else {
                                    switch (key) {
                                        case "accessToken":
                                            sendData["gsnpass-token"] = value
                                            break;
                                        case "refreshToken":
                                            sendData["gsnpass-ref-token"] = value
                                            break;
                                        case "ccoCd":
                                            sendData["ccoCode"] = value;
                                            break;
                                        case "frnchseCd":
                                            sendData["frnchseCode"] = value;
                                            break;
                                        case "regWebUrl":
                                        case "rtnUrl":
                                            sendData[key] = value;
                                            break;
                                        case "reqDivCode":
                                            sendData[key] = value;
                                            sendData["inFildDcntCode"] = "";
                                        default:
                                            break;
                                    }

                                }
                            });
                            var paramNames = Object.keys(sendData);
                            var requestUrl = sendData.regWebUrl + "?";
                            $.each(paramNames, function (index, key) {
                                if(index!==0) requestUrl += "&";
                                if (key !== "regWebUrl") {
                                    requestUrl += (key+"="+sendData[key]);
                                }
                            });

                            //2. 리다이렉트 페이지
                            //약관동의 웹뷰링크
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("requestUrl: "+requestUrl);
                            var options = {
                                className: "WebviewActivity",
                                param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam("GET", requestUrl)
                            };
                            if (PGV.device.os.name.toLowerCase() == 'ios' || PGV.device.os.name.toLowerCase() == 'ipados'){
                                options.param.contentType="text/html";
                            }
                            MPage.activity(options);


                        }
                    }
                )
                .then();
        }
        function joinHDOL() {
            //주유정보 연동 약관동의
            var pop = PATH_MANAGER.KIA_RNW_0D2_2300;
            if (PGV.currentPage != pop.nameWithHtml) {
                MPage.html({
                    url: pop.path,
                    param: {toLinkService: barcodeMng.toLinkService},
                });
            }
        }
        function joinSOIL() {
            //주유정보 연동 약관동의
            var pop = PATH_MANAGER.KIA_RNW_0D2_2300_2;
            if (PGV.currentPage != pop.nameWithHtml) {
                MPage.html({
                    url: pop.path,
                    param: {toLinkService: barcodeMng.toLinkService},
                });
            }
        }

        /**
         * 주유 정보 연동 안내 버튼 클릭시
         * .swiper-slide-active-->스와이퍼에서 마지막 슬라이더를 복제하기 때문에 id등으로 찾을 수 없다.
         */
        $('.mykia-connect-guide').on("click", function(){
            var _$isActive = $(this).closest(".swiper-slide-active");//todo swiper 동작관련, active가 꼭 보여지는게 아니라서 이베트 안먹음.
            if(_$isActive.length > 0){
                MPage.html({
                    path: PATH_MANAGER.KIA_RNW_0D2_2100.path
                });
            }
        });
    },
    checkRedMemberJoinWithPoint: function () {
        return MNet.httpSendAsyncAsIs({
            path: inf.point.extFlcMilg.url,
            sendData: {
                csetIfTypeCd: "04",
                csetIfValue: PGV.loginInfo.csmrMgmtNo
            }
        });
    },
    getCardList: function (response) {
        let checkRedMemberJoin = response.resultCode;
        return barcodeMng.getMembershipOilCardsList()
            .then(
                function(response){
                    var result = {};
                    var isMember = "200" === checkRedMemberJoin ?"true":"false";
                    var cards=null;
                    var totalCnt =0;

                    /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
                    COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(response);

                    if(response.resultCode==="200"){
                        var cardMemberRnwResDto = response.cardMemberRnwResDto;
                        var cardOilListRnwResDto = response.cardOilListRnwResDto;

                        totalCnt = (isEmpty(cardMemberRnwResDto)?0:cardMemberRnwResDto.length) +(isEmpty(cardOilListRnwResDto)?0:cardOilListRnwResDto.length);
                        if(totalCnt==0) response={};
                        cards = response;
                    }else{
                        cards = {};
                    }
                    cards.totalCnt = totalCnt;
                    // 2023.11.24 주유카드 리스트 글로벌 변수에 담기
                    PGV.passData.gnb.barcode.cardList = cards;
                    M.data.global("cardOilList",PGV.passData.gnb.barcode.cardList.cardOilListRnwResDto);
                    result.isMember = isMember;
                    result.cards = cards;
                    return result;
                }
            );
    },
    getMembershipOilCardsList : function(){
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.holdCardReq,
            sendData: {
                mbrId: PGV.loginInfo.mbrId
            }
        };
        return MNet.httpSendAsync(options);
    },
    sortCardList: function (cards){
        // 서버에서 받은 카드 리스트를 정렬
        var orderedCardList = COMMON_FUNCTION.TOOL.CARD.getOrderedFlattenCardList(cards);
        // 스토리지에 저장된 카드 정보로 노출여부와 순서를 보정한다.
        var storagedCardList = M.data.storage("myCardList");

        var revisedCardList=[];
        if(isEmpty(storagedCardList)){
            M.data.storage("myCardList",orderedCardList);
            revisedCardList = orderedCardList;
        }else{
            revisedCardList = COMMON_FUNCTION.TOOL.CARD.getRevisedCardList(storagedCardList,orderedCardList);
            M.data.removeStorage("myCardList");
            M.data.storage("myCardList",revisedCardList);
        }
        return revisedCardList;
    },
    getShowableCardList: function (sortCardList) {
        return sortCardList.filter(// 숨김처리한 카드는 빼고 ui 그리기.
            function (item) {
                var isShow = true;
                // TODO: oilJoinYn 추가 속성에 따라 isShow false 추가하기
                if (item.cardType == "oil" && item.oilJoinYn == "N") {
                    isShow = false;//정유사 연동해제 카드 제외한 카드목록 바코드순서변경팝업.
                }
                return item.isCardDisplay && isShow;
            }
        );
    },
    uiNotMember:function(){
        return new Promise(function(resolve){
            var template = document.querySelector("#temp-barcode-not-member");
            var target = document.querySelector(".section-01");
            target.innerHTML ="";
            target.appendChild(document.importNode(template.content, true));
            $(".section-01").removeClass("none");
            resolve();
        });
    },
    /**
     *
     * @param showCards :  "바코드로 보여줄 카드"
     * @param oilCards : "연동했거나, 연동했다 해지한 정유사 카드"
     * @returns {Promise}
     */
    uiShowableCard:function (showCards,oilCards){
        /**
         *
         * @param cardInfomation
         * @returns {string}
         */
        var htmlBarcodeSlider = function (cardInfomation) {
            var cardNumberText = "";
            for (var i = 0; i < cardInfomation.cardNumber.length; i++) {
                if (i % 4 === 0) {
                    cardNumberText += " " + cardInfomation.cardNumber[i];
                } else {
                    cardNumberText += cardInfomation.cardNumber[i];
                }
            }

            var templateString =
                "<div class='swiper-slide' data-card-display-order='" + cardInfomation.cardDisplayOrder + "'>" +
                "<div class='membership-card is-card' data-card-informaiton='" + JSON.stringify(cardInfomation) + "' data-card-number='" + cardInfomation.cardNumber + "'>" +
                "<div class='group-01'>" +
                "<div class='img-cont'>" +
                "<img class='img-card' src='" + cardInfomation.cardImagePath + "' alt=''/>"+
                // "<div class='bg-barcode' style='background-image:url(\"" + cardInfomation.cardImagePath + "\");'></div>" +
                "</div>" +
                "<div class='ticket-title'>" +
                "<div class='row'>" +
                "<span>" + cardInfomation.cardName + "</span>" +
                "</div>" +
                "<div class='row'>" +
                "<strong>" + (cardInfomation.cardPoint && parseInt(cardInfomation.cardPoint).toLocaleString()) + "</strong><i class='" + (cardInfomation.isRedPoint ? 'ico-point-red' : 'ico-point-black') + "'></i>" +
                "</div>" +
                "</div>" +
                "</div>" +
                "<div class='group-02'>" +
                "<div class='bg-cont d-flex align-items-center'>" +
                "<div class='bg-barcode'></div>" +
                "</div>" +
                "<em class='code'>" + cardNumberText + "</em>" +
                "</div>" +
                "</div>" +
                "</div>";
            return templateString;
        };
        return new Promise(function(resolve){
            var htmlString = "";
            var allSlider = $('#mykia-card-list div.swiper-slide');
            //슬라이더 초기화
            if(!isEmpty(allSlider)&&allSlider.length>1){
                // 카드상태 수정후  restore-> init 재실행시에 슬라이더가 중복으로 계속 생성되는 것 방지. html파일에 있는 정유서머리슬라이더를 남기고 모두 지운다.
                $('#mykia-card-list').find("div.swiper-slide").remove();
                // $('#mykia-card-list').find("div.swiper-slide:not([data-swiper-slide-index='"+showCards.length+"'])").remove();
            }
            //===============
            // 카드슬라이더 생성
            //===============
            var is1stCardType;
            for(var i = 0; i < showCards.length; i++){

                var aCard = showCards[i];
                if (!isEmpty(aCard) && aCard.isCardDisplay){
                    var cardNameType = aCard.cardType;
                    if(i==0) is1stCardType= cardNameType;
                    var currentCardName = aCard.cardName;
                    var currentCardNumber = aCard.cardNumber;
                    var currentCardPoint = aCard.cardPoint;
                    var currentCardImagePath = aCard.cardImgUrl;
                    var currentCardDisplayOrder = aCard.cardDisplayOrder;
                    var isCurrentRedPoint = aCard.cardType == "member" && !isEmpty(aCard.redPoint);
                    var cardTypeDesc = aCard.cardTypeDesc;

                    var cardInfomation = {
                        "cardName": currentCardName,
                        "cardNumber": currentCardNumber,
                        "cardPoint": currentCardPoint,
                        "cardImagePath": currentCardImagePath,
                        "cardDisplayOrder": currentCardDisplayOrder,
                        "isRedPoint": isCurrentRedPoint,
                        "cardTypeDesc":cardTypeDesc
                    };

                    htmlString += htmlBarcodeSlider(cardInfomation);
                }
            }

            $('#mykia-card-list').html("");
            $('#mykia-card-list').prepend($(htmlString));

            //바코드생성
            for(var i = 0; i < showCards.length; i++){
                var curNode = showCards[i];
                var currentCode = curNode.milgMbrNo || curNode.oilCardNo;
                COMMON_FUNCTION.TOOL.CARD.setBarcode(currentCode, '[data-card-display-order='+ curNode.cardDisplayOrder + '] .bg-barcode');
            }

            //===============
            //마지막 제휴사 연동 유도 슬라이더 가입하지 않은 정유사 존재시에만
            //===============

            // TODO: oilJoinYn 플래그에 따라 수정
            var soilCard = oilCards.find(function (item) {return item.oilCoCd=="SOIL" && item.oilJoinYn==="Y"; });
            var hdolCard = oilCards.find(function (item) {return item.oilCoCd=="HDOL" && (item.oilJoinYn==="Y" || item.oilJoinYn==="P" || item.oilJoinYn==="Q");});
            var gsctCard = oilCards.find(function (item) {return item.oilCoCd=="GSCT" && item.oilJoinYn==="Y"; });
            if(!isEmpty(soilCard)&&!isEmpty(hdolCard)&&!isEmpty(gsctCard)){
                //모든 정유사에 가입했기 때문에 정유사 가입 유도 슬라이더는 보여줄 필요가 없음.
            }
            else{
                //정유사종합 마지막 슬라이더 처리
                var lastSliderTemplate = document.querySelector("#temp-barcode-last-slider"); //템플릿
                var lastSlider = document.importNode(lastSliderTemplate.content, true); //템플릿 복제
                var oilPointsSection = lastSlider.querySelectorAll('.mykia-oilpoints-section');//템플릿에서 각 정유사 el 선택
                $(oilPointsSection).each(function(){
                    var oilStationType = $(this).data('type');
                    var curOilInfo = _.find(oilCards, {cardTypeDesc: oilStationType});
                    var lastHtml = '';
                    // TODO: oilJoinYn 플래그에 따른 수정 P: pending, Q: 탈퇴와같이 조회되지 않는 회원정보
                    if (curOilInfo) {
                        if(curOilInfo.failMessage === null) {
                            if(curOilInfo.oilJoinYn==="Y"){
                                lastHtml += (curOilInfo.oilPoint && parseInt(curOilInfo.oilPoint).toLocaleString() + '<i class="ico-point-black"></i>');
                            } else if(curOilInfo.oilJoinYn==="N"){
                                lastHtml += '<button type="button" class="btn-more" data-has-join-history="Y" data-oil-cd=' + oilStationType + ' data-oil-card-no=' + curOilInfo.cardNumber + '><em class="text-underline c-font-primary">주유 정보 연동</em></button>';
                            } else if(curOilInfo.oilJoinYn==="P"){ // P: 가입 승인 대기중 상태
                                lastHtml += '<button type="button" class="btn-more" data-has-join-history="Y" data-oil-cd=' + oilStationType + '><em class="text-underline c-font-primary">가입 승인 확인</em></button>';
                            } else if(curOilInfo.oilJoinYn==="Q"){ // Q: 탈퇴 등으로 조회되지 않는 회원정보 → 재가입 유도
                                lastHtml += '<button type="button" class="btn-more" data-has-join-history="Q" data-oil-cd=' + oilStationType + '><em class="text-underline c-font-primary">재가입요청</em></button>';
                            }
                        } else {
                            lastHtml += '<em class="text-underline c-font-primary">'+ curOilInfo.failMessage +'</em>';
                        }
                    }
                    else{
                        lastHtml += '<button type="button" class="btn-more" data-oil-cd=' + oilStationType + '><em class="text-underline c-font-primary">주유 정보 연동</em></button>';
                    }
                    $(this).html(lastHtml);
                });

                $('#mykia-card-list').append(lastSlider);
            }

            if(is1stCardType=="oil") $("#mykia-disconnect").hide();// 제휴사 연동 해제 숨기기. 슬라이더 넘길때 마다 보이고 안보이는 이벤트있음.
            if(isEmpty(htmlString)) {
                $("#mykia-edit-card-order-button").hide();
                $("#mykia-disconnect").hide();
            }
            $(".section-01").removeClass("none");
            resolve(showCards);
        })
    },
    getGsCaltexJoinReq : function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.gsCaltexJoinReq,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    },
    /**
     * postGsCaltexJoin
     * 웹뷰의 회원가입결과를 네이티브에서 잡아서,
     * common.js에 있는  onResultGSJoin 함수를 통해 아래 함수가 호출된다.
     * @param joinResult(redirect response)
     */
    redirectGsCaltexJoin : function (joinResult) {
        if (joinResult.resCode == '0000') {
            barcodeMng.postGsCaltexJoin(joinResult.cardNo)
                .then(
                    function (response) {
                        MPage.html({
                            url : PATH_MANAGER.KIA_RNW_0D2_2400.path,
                            param: {"toLinkService":barcodeMng.toLinkService,returnTarget:PATH_MANAGER.KIA_RNW_0D2_0000}
                        });
                    }
                );
        } else {

            alert('가입 실패');

        }

    },
    postGsCaltexJoin : function (cardNo) {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.gsCaltexJoin,
            sendData: {mbrId: PGV.loginInfo.mbrId,cardNo:cardNo},
        };
        return MNet.httpSendAsync(options);
    },
    /**
     * 제휴사 연동 유도 팝업띄우고, 팝업정보 저장하고
     */
    showPopup: function () {
        exWNHideIndicator();
        var isShowAble = CMM_POP_MNG.isShowable("0D2_4000");
        if (isShowAble) {
            customPopup
                .get(
                    PATH_MANAGER.KIA_RNW_0D2_4000.path,
                    $("#popup_0D2_4000"),
                    function (item) {//item==POP._0D2_4000.url's html
                        var popId = "#popup_0D2_4000";
                        if ($(popId).length < 1) {
                            var screenHtml = $("<div></div>");
                            screenHtml.append(item);
                            $('body').append(screenHtml.find(popId));
                        }
                        RNW_UI.popupLayer({selId: popId});
                        //todo 지우기
                        var passData = toAddPassData(PGV.passData);
                        MData.global("passData", passData);
                        $(popId + "_DetailBtn").on("click", function () {
                            var that = $(this);
                            var selectId = that.attr('id');
                            // 1. 제휴사 연동 탭 팝업띄우고, 팝업정보 저장하고
                            var pop = PATH_MANAGER.KIA_RNW_0D2_2100;
                            if (PGV.currentPage != pop.nameWithHtml) {
                                MPage.html({
                                    url: pop.path,
                                    animate: "MODAL_DOWN",
                                });
                            }
                        });
                        $(".js-popup-close-btn").click(function () {
                            var _$naverShow = $("div.popup-cont").find('input.pop-naver-show');
                            if (_$naverShow.is(":checked")) {
                                CMM_POP_MNG.modifyShowable("0D2_4000", false);
                            }
                        });

                    }
                );
        }else{

        }
    },

}
var DICT={
    SVC_COMPANY:{
        "HDOL":{
            cd : "HDOL",
            serviceTarget:"주유 내역",
            agreeAction: _API.SVR.CMM.crd.hydOilBankJoin,
            name:"HD현대오일뱅크",
            agreementDetail:{
                "trmsAgmtYn01": PATH_MANAGER.Term_HOB01,
                "trmsAgmtYn02": PATH_MANAGER.Term_HOB02,
                "trmsAgmtYn03": PATH_MANAGER.Term_HOB03,
                "trmsAgmtYn04": PATH_MANAGER.Term_HOB04,
            },
        },
        "SOIL":{
            cd : "SOIL",
            serviceTarget:"주유 내역",
            agreeAction: _API.SVR.CMM.crd.soilJoin,
            name:"S-OIL",
            agreementDetail:{
                "termsReq1": PATH_MANAGER.Term_SO01,
                "termsReq2": PATH_MANAGER.Term_SO02,
                "termsOpt1": PATH_MANAGER.Term_SO03,
            },
        },
        "GSCT":{
            cd : "GSCT",
            serviceTarget:"주유 내역",
            agreeAction: _API.SVR.CMM.crd.gsCaltexJoin,
            name:"GS 칼텍스",
            agreementDetail:null,
        },
        "AUTQ":{
            cd : "AUTQ",
            serviceTarget:"정비 내역",
            agreeAction: _API.SVR.CMM.crd,
            name:"Auto Q",
            agreementDetail:null,
        },
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_0D2_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        exWNHideIndicator();
        var params = MData.param();
        COMMON_FUNCTION.TOOL.DEBUG.showTalk(params);
        var someThingChanged=true;
        if(MData.param("isCardOrderDisplayChangedYn") == "Y"){
            MData.removeParam("isCardOrderDisplayChangedYn");
            MPage.html({url: PATH_MANAGER.KIA_RNW_0D2_0000.path});
        }
        else{
            someThingChanged=false;
        }
        if(MData.param("linkStatusChangedYn") == "Y"){
            MData.removeParam("linkStatusChangedYn");
            COMMON_FUNCTION.TOOL.CARD.spliceSavedCardList(barcodeMng.toLinkService.cardNumber);
            MPage.html({url: PATH_MANAGER.KIA_RNW_0D2_0000.path});
        }else{
            someThingChanged=false;
        }


        if(MData.param("joinRedMembership") == "Y"){
            MData.removeParam("joinRedMembership");
            MPage.html({url: PATH_MANAGER.KIA_RNW_0D2_0000.path});
        }else{
            someThingChanged=false;
        }

        // 2023.11.23 isCardOrderDisplayChangedYn, popupFlag, selectVinNumber 를 제외한 파라미터가 존재 하는지 check
        const { isCardOrderDisplayChangedYn, popupFlag, selectVinNumber, ..._params } = params;

        var gsReturns = null;
        if (!isEmpty(_params)) {
            gsReturns = {
                cardNo: params.cardNo, // "0190920022524193" "0190920022524193"
                resCode: params.resCode, // "0000" "0000"
                resMessage: params.resMessage, // "가입이 완료되었습니다." "가입이 완료되었습니다."
                returnUrl: params.returnUrl, // "vikapp://returnUrl?ccoCode=9981"
            }
        }
        if(!isEmpty(gsReturns)) {
            MData.removeParam();
            registGSCT(gsReturns)//common
                .then(function(response){
                    debugger;
                    if(typeof response == "string"){
                        MPopup.instance(response);
                    }else{
                        if(response.resultCode === "200" && response.regYn === "Y"){
                            MPage.html({
                                url : PATH_MANAGER.KIA_RNW_0D2_2400.path,
                                param: {"toLinkService":barcodeMng.toLinkService}
                            });
                        }else{
                            // MPopup.instance(response.resultMsg);
                        }
                    }
                });
        }else{
            if(!someThingChanged) barcodeMng.toLinkService={};
        }

    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
