/**

@파일명 : KIA_RNW_0D2_0000_2.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.10 
@메뉴명 : 카드 순서 변경 팝업
@DESC : 권한 확인 중
*/ 
var CurrPage; 
var KIA_RNW_0D2_1000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        exWNShowIndicator();
        CurrPage.cardList = MData.param("cardList")||[];
        MData.removeParam("cardList");
        if(isEmpty(CurrPage.cardList )){
            MPopup.instance("카드가 없습니다.");
            MPage.back();
        }
        CurrPage.setCardsSection(CurrPage.cardList)
            .then(CurrPage.setEventListner)
            .then(exWNHideIndicator);

    }, 
    setEventListner: function(){
        // 이벤트 리스너 붙이기
        $('#mykia-save-card-order').on("click", function(){
            var checkBoxes = $('ul.mykia-card-point-card-list div.chk-cont').find('input[type=checkbox]');
            var checkedEls = checkBoxes.parent().find(":checked");
            if(isEmpty(checkedEls)){
                MPopup.alert("모든 카드를 미노출 할 수 없습니다.\n" +
                    "최소 1개 카드의 체크박스를 체크해 주세요.");
               // checkBoxes.eq(0).prop("checked",true);
            }else{
                CurrPage.handleChangeCardOrder()
                    .then(
                        function (isSuccess) {
                            if (isSuccess) {
                                MPage.back({param: {isCardOrderDisplayChangedYn: "Y"}});
                            } else {
                                COMMON_FUNCTION.TOOL.DEBUG.showTalk("팝업 순서, 노출 저장 실패");
                            }
                        }
                    );
            }

        });
        // check박스 선택시.
        $('ul.mykia-card-point-card-list div.chk-cont').off().on("click",function (e){
            var _$checkBox = $(this).find('input[type=checkbox]');
            var toCheck = !_$checkBox.prop('checked');
            _$checkBox.prop('checked',toCheck);
        });
    },
    // getCardList: function () {
    //     return new Promise(
    //         function(resolve){
    //             if(!isEmpty(PGV.passData.gnb.barcode.cardList)){
    //                 resolve(PGV.passData.gnb.barcode.cardList);
    //             }
    //             else{
    //                 barcodeMng.getMembershipOilCardsList()
    //                     .then(
    //                         function(response){
    //                             var cards=null;
    //                             var totalCnt =0;
    //                             if(response.resultCode==="200"){
    //                                 var cardMemberRnwResDto = response.cardMemberRnwResDto;
    //                                 var cardOilListRnwResDto = response.cardOilListRnwResDto;
    //                                 totalCnt = (cardMemberRnwResDto.length||0)+(cardOilListRnwResDto.length||0);
    //                                 cards = response;
    //                             }else{
    //                                 cards = {};
    //                             }
    //                             PGV.passData.gnb.barcode.cardList = cards;
    //                             PGV.passData.gnb.barcode.cardList.totalCnt = totalCnt;
    //                             resolve(PGV.passData.gnb.barcode.cardList);
    //                         }
    //                     );
    //             }
    //         }
    //     );
    // },
    setCardsSection: function(orderedCardList){
        var parentThis = this;
        return new Promise(function(resolve){
            var htmlCardSlider = function(data){
                var html =
                "<li class='' data-card-informaiton='" + JSON.stringify(data) + "' data-cardnumber='" + data.cardNumber + "'>" +
                    "<div class='form-field'>" +
                        "<div class='chk-cont chk-size-m'>" +
                            "<input type='checkbox' name='" + data.cardName + "' " + (data.isCardDisplay ? 'checked' : '') + ">" +
                            "<label for='" + data.cardName + "'>" +
                                "<i class='" + data.cardIClass +"'></i>" + // 이 부분
                                "<span>" + data.cardName + "</span>" +
                            "</label>" +
                        "</div>" +
                    "</div>" +
                    "<button type='button' class='btn-swap'>" +
                        "<i class='ico-swap'></i>" +
                    "</button>" +
                "</li>";
                return html;
            }
            var htmlString = "";
            var cardListSection = $('ul.mykia-card-point-card-list');
            for (var i = 0; i < orderedCardList.length; i++){
                htmlString += htmlCardSlider(orderedCardList[i]);
            }
            cardListSection.html(htmlString);
            resolve();
        })
    },
    setSortable: function(){
        $('#sortable').sortable({
            cancel:'',
            handle : '.btn-swap',
            containment:'#sortable', // 20220530//(Ina) containment옵션추가, #sortable 안에서만 움직이도록 설정
        }).disableSelection();
    },
    handleChangeCardOrder: function(){
        return new Promise(
            function (resolve){
                try{
                    var tempProcessingCards = [];
                    var currentCardOrder = $('ul.mykia-card-point-card-list li');
                    for (var i = 0; i < currentCardOrder.length; i++){
                        var _$curNode = $(currentCardOrder[i]);
                        var data = _$curNode.data("cardInformaiton");
                        var isDisplay = $(_$curNode.find('input')).prop('checked');
                        data.isCardDisplay = isDisplay;
                        data.cardDisplayOrder = i;
                        tempProcessingCards.push(data);
                    }
                    M.data.removeStorage("myCardList");
                    M.data.storage("myCardList",tempProcessingCards);
                    resolve(true);
                }catch (e){
                    COMMON_FUNCTION.TOOL.DEBUG.showTalk("카드순서 및 노출 데이터 저장 중 오류 발생");
                    resolve(false);
                }
            }
        );

    },
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_0D2_1000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
