/**

 @파일명 : KIA_RNW_0D2_2100.js
 @작성자 : 케이스마텍 추헌남
 @생성일 : 2022.03.10
 @메뉴명 : 주유 정보 연동 탭
 @DESC : 권한 확인 중
 */
var oilLinkMng;
var KIA_RNW_0D2_2100 ={
    init: function(){
        oilLinkMng = this;
        oilLinkMng.setEventListner();
        console.log("page : " + PGV.currentPage + "initiolizing START");
    },

    /**
     * 주유사정보를 기반으로, 연동되지 않은 주유사에 대해 연동버튼을 노출한다.
     * @param cardOilListRnwResDto
     */
    uiBtnsActivate: function (cardOilListRnwResDto) {
        return new Promise(function (resolve){
            var _$oilLinkBtns = $('button.btn-link-3rd-service');
            var oilCdArr = [];
            var btnActiveInfo ={};
            _$oilLinkBtns.each(function (index, item){
                var _$btnEl = $(item);
                var oilCd = _$btnEl.data("oilCd");
                oilCdArr[index]=oilCd;
                btnActiveInfo[oilCd]={}
                btnActiveInfo[oilCd]["isAble"] = true;
                $.each(cardOilListRnwResDto, function (index, item) {
                    if(oilCd==item.oilCoCd ){
                        _$btnEl.attr("data-oil-card-no",item.oilCardNo);
                        if(item.oilJoinYn=="Y"){
                            btnActiveInfo[oilCd]["isAble"] = false;
                        }else if(item.oilJoinYn=="N"){//연동이력 존재함. 연동시 안내 팝업 있음.
                            _$btnEl.attr("data-has-join-history","Y");
                        }
                    }
                });
            });
            var oilServiceArr = Object.keys(btnActiveInfo);
            for (var i=0; i<oilServiceArr.length;i++){
                var oilCd = oilServiceArr[i];
                var query = '*[data-oil-cd="'+oilCd+'"]';
                if(btnActiveInfo[oilCd].isAble){
                    $(query).removeClass("none");
                }else{
                    $(query).addClass("none");
                }
            }
            resolve();
        });

    },
    getGsCaltexJoinReq : function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.gsCaltexJoinReq,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    },

    /**
     * 미사용 : GSCT의 경우, 약관관리는 GSCT에서 관리함. 재연동없이 매번연동함.
     * postGsCaltexJoin
     * 웹뷰의 회원가입결과를 네이티브에서 잡아서,
     * common.js에 있는  onResultGSJoin 함수를 통해 아래 함수가 호출된다.
     * @param joinResult(redirect response)
     */
    redirectGsCaltexJoin : function (joinResult) {
        return oilLinkMng.postGsCaltexJoin(joinResult.cardNo)
            .then(
                function (response) {
                    if(response.resultCode=="200"&&response.regYn=="Y"){
                        MPage.html({
                            url : PATH_MANAGER.KIA_RNW_0D2_2400.path,
                            param: {"toLinkService":oilLinkMng.toLinkService}
                        });
                    }else {
                        alert('가입 실패');
                    }
                });

    },
    setEventListner: function(){
        $(".btn-close").off("click").on("click", function(){
            MPage.back({param: {isCardOrderDisplayChangedYn: (reloadOnRestore?"Y":"N")}});
        });

        $('button.btn-link-3rd-service').not('.disabled').off("click").on("click",function (){
            var that = $(this);
            var oilCd = that.data("oilCd");
            oilLinkMng.toLinkService = DICT.SVC_COMPANY[oilCd];
            var hasJoinHistory = that.data("hasJoinHistory")||"N";
            oilLinkMng.toLinkService.cardNumber = $(this).attr("data-oil-card-no");
                if(hasJoinHistory=="Y"&&oilCd!="GSCT"){// 재연동=> 약관동의 없음. GSCT의 경우 재연동없이 웹으로 재가입 진행.
                customPopup.get(
                    PATH_MANAGER.KIA_RNW_0D2_6000.path,
                    $("#popup_0D2_6000"),
                    function(item){//item==POP._0D2_6000.url's html
                        var popId = "#popup_0D2_6000";
                        console.log(popId+" Func> ");
                        if($(popId).length < 1){
                            var screenHtml = $("<div></div>");
                            screenHtml.append(item);
                            $('body').append(screenHtml.find(popId));
                        }
                        RNW_UI.popupLayer({selId : popId});

                        $(popId+"_DetailBtn").on("click",function(e){
                            switch (oilCd) {
                                case "HDOL":
                                    if(CONSTANT.IS_HDOL_SVC_OPEN){
                                        joinHDOL();
                                    }
                                    else{
                                        MPopup.alert("아직 준비중입니다.\n빠른 시일 내에 서비스 제공할 예정입니다.");
                                    }
                                    break;
                                case "SOIL":
                                    joinSOIL();
                                    break;
                            }
                            e.preventDefault();
                            $("#popup_0D2_6000").fadeOut('fast');
                            $('body').removeClass('js-overflow-hidden');
                            customPopup.remove($("#popup_0D2_6000"));
                        });

                    });
            }else{
                switch (oilCd) {
                    case "GSCT":
                        var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));
                            joinGSCT();
                        break;
                    case "HDOL":
                        if(CONSTANT.IS_HDOL_SVC_OPEN){
                            joinHDOL();
                        }else{
                            MPopup.alert("아직 준비중입니다.\n빠른 시일 내에 서비스 제공할 예정입니다.");
                        }
                        break;
                    case "SOIL":
                        joinSOIL();
                        break;
                }
                e.preventDefault();
                $("#popup_0D2_6000").fadeOut('fast');
                $('body').removeClass('js-overflow-hidden');
            }
        });
        function joinGSCT() {
            //1. 서버로 부터 인증정보 받아오기.
            oilLinkMng.getGsCaltexJoinReq()
                .then(
                    function (response) {
                        exWNHideIndicator();
                        if (response.resultCode === "200") {

                            // todo 요청 필수 값검증 처리하기. 대기, 신상철 차장님 api 문의요청드림.
                            var serverData = response.crdGsctWebCnntRnwDto;
                            if(isEmpty(serverData)){
                                COMMON_FUNCTION.TOOL.DEBUG.showTalk("GS 칼텍스 회원가입 쿼리스트링 요청에 대한 응답이 EMPTY입니다.");
                                return;
                            }
                            var requestUrl = serverData.regWebUrl + "?";
                            var keys = [ "accessToken", "refreshToken", "ccoCd", "reqDivCode", "frnchseCd", "rtnUrl"];
                            var sendData = {};
                            $.each(keys, function (index, key) {
                                var value = serverData[key];
                                if (!isEmpty(serverData[key]) && isEmpty(value)) {
                                    throw new Error("check requiredParam( " + key + " )is null")
                                } else {
                                    switch (key) {
                                        case "accessToken":
                                            sendData["gsnpass-token"] = value;
                                            break;
                                        case "refreshToken":
                                            sendData["gsnpass-ref-token"] = value;
                                            break;
                                        case "ccoCd":
                                            sendData["ccoCode"] = value;
                                            break;
                                        case "frnchseCd":
                                            sendData["frnchseCode"] = value;
                                            break;
                                        case "rtnUrl":
                                            sendData[key] = value;
                                            break;
                                        case "reqDivCode":
                                            sendData[key] = value;
                                            sendData["inFildDcntCode"] = "";
                                        default:
                                            break;
                                    }

                                }
                            });
                            var paramNames = Object.keys(sendData);

                            $.each(paramNames, function (index, key) {
                                if(index!==0) requestUrl += "&";
                                if (key !== "regWebUrl") {
                                    requestUrl += (key+"="+sendData[key]);
                                }
                            });

                            //2. 리다이렉트 페이지
                            //약관동의 웹뷰링크
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("requestUrl: "+requestUrl);
                            var options = {
                                className: "WebviewActivity",
                                param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam("GET", requestUrl)
                            };
                            if (PGV.device.os.name.toLowerCase() == 'ios' || PGV.device.os.name.toLowerCase() == 'ipados'){
                                options.param.contentType="text/html";
                            }
                            MPage.activity(options);


                        }
                    }
                )
                .then();
        }
        function joinHDOL() {
            //주유정보 연동 약관동의
            var pop = PATH_MANAGER.KIA_RNW_0D2_2300;
            if (PGV.currentPage != pop.nameWithHtml) {
                MPage.html({
                    url: pop.path,
                    param: {toLinkService: oilLinkMng.toLinkService},
                });
            }
        }
        function joinSOIL() {
            //주유정보 연동 약관동의
            var pop = PATH_MANAGER.KIA_RNW_0D2_2300_2;
            if (PGV.currentPage != pop.nameWithHtml) {
                MPage.html({
                    url: pop.path,
                    param: {toLinkService: oilLinkMng.toLinkService},
                });
            }
        }
    },
    tabularNavigator: null,//탭콘트롤(NAVIGATOR_TABULAR)
    toLinkService :null,// 연결하고자 했던/하는 서비스

}
var reloadOnRestore=false;// 바코드리스트를 리로드할것인가
var DICT={
    SVC_COMPANY:{
        "HDOL":{
            cd : "HDOL",
            serviceTarget:"주유 내역",
            agreeAction: _API.SVR.CMM.crd.hydOilBankJoin,
            name:"현대오일뱅크",
            agreementDetail:{
                "trmsAgmtYn01":PATH_MANAGER.Term_HOB01,
                "trmsAgmtYn02":PATH_MANAGER.Term_HOB02,
                "trmsAgmtYn03":PATH_MANAGER.Term_HOB03,
                "trmsAgmtYn04":PATH_MANAGER.Term_HOB04,
            },
        },
        "SOIL":{
            cd : "SOIL",
            serviceTarget:"주유 내역",
            agreeAction: _API.SVR.CMM.crd.soilJoin,
            name:"S-OIL",
            agreementDetail:{
                "termsReq1": PATH_MANAGER.Term_SO01,
                "termsReq2": PATH_MANAGER.Term_SO02,
                "termsOpt1": PATH_MANAGER.Term_SO03,
            },
        },
        "GSCT":{
            cd : "GSCT",
            serviceTarget:"주유 내역",
            agreeAction: _API.SVR.CMM.crd.gsCaltexJoin,
            name:"GS 칼텍스",
            agreementDetail:null,
        },
        "AUTQ":{
            cd : "AUTQ",
            serviceTarget:"정비 내역",
            agreeAction: _API.SVR.CMM.crd,
            name:"Auto Q",
            agreementDetail:null,
        },
    }
}

function deactiveButtons(toLinkService) {
    var toNoneDisplaySelector = "#" + toLinkService.cd + "_serviceLinkBtn";
    if (!$(toNoneDisplaySelector).hasClass("none")) {
        $(toNoneDisplaySelector).addClass("disabled");
        // $(toNoneDisplaySelector).prop("disabled",true);
        var allCardInfo = M.data.storage("myCardList");
        //동일제휴서비스 카드 정보 삭제, 갱신하기 위해서.
        var newMyCardInfos = allCardInfo.filter(function (item) {
            return item.cardTypeDesc !== toLinkService.cd;
        });
        M.data.storage("myCardList", newMyCardInfos);
        reloadOnRestore = true;
    }

}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        var cardOilListRnwResDto = PGV.passData.gnb.barcode.cardList.cardOilListRnwResDto;
        if(isEmpty(cardOilListRnwResDto)){
            cardOilListRnwResDto = M.data.global("cardOilList");
            //M.data.removeGlobal("cardOilList");
        }else{
            //M.data.removeGlobal("cardOilList");
        }

        KIA_RNW_0D2_2100.uiBtnsActivate(cardOilListRnwResDto)
            .then(function (){
                var tabsMetaOpt = {
                    tabWrapperQueryString: "section",
                    tabs: $('.tabs').children(),
                    tabsMeta: [
                        {
                            page: {
                                useDOM: $('section'),
                                // pathManager: PATH_MANAGER.KIA_RNW_0D2_2100,
                                loadScript: false,/** 3.24 현재 main tab의 스크립크 리로드는 라이프사이클 (afterOpenedTheTab) 을 통해 가능*/
                                isMain: true
                            }
                        },
                        {
                            page: {
                                pathManager: PATH_MANAGER.KIA_RNW_0D2_2200,
                                loadScript: true,
                                isMain: false
                            }
                        }
                    ],
                    lifeCycles:{
                        afterInit: function(){
                            console.log("heyyy : afterInit");
                            exWNHideIndicator();
                        },
                        afterOpenedTheTab: function(){
                            console.log("heyyy : afterInit");
                            exWNHideIndicator();
                            if(this.currentTabIndex === 0){
                                KIA_RNW_0D2_2100.init();
                                return;
                            }
                            if(this.currentTabIndex === 1){
                                if(typeof KIA_RNW_0D2_2200=='object'){
                                    // KIA_RNW_0D2_2200.init();
                                }
                                return;
                            }
                            
                            fnIsFooterNav(); //footer 네비게이션 메뉴영역이 있는경우, 없는경우 제어

                        },
                        beforeOpeningTheTab: function (attemptingIndex, initMode, eventListenerClickedMode, globalAccessMode) {
                            return true;
                        }
                    },
                    viewerArea:$('#mykia-barcode-popup-tab-viewer'),
                    addEventListeners: true,
                };
                COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.init(tabsMetaOpt).then(function(resultTabularNavigator){
                    KIA_RNW_0D2_2100.tabularNavigator = resultTabularNavigator;
                });
            })
            .then(exWNHideIndicator);

        KIA_RNW_0D2_2100.init();
    },
    onHide : function(event){},
    onRestore : function(event){
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("heyyy :onRestore");
        var params = MData.param();
        COMMON_FUNCTION.TOOL.DEBUG.showTalk(params);
        //연동버튼 누른 서비스확인후
        var toLinkService = MData.param("toLinkService")||null;
        var tabIdx=KIA_RNW_0D2_2100.tabularNavigator.currentTabIndex;
        if(!isEmpty(toLinkService)){
            tabIdx = deactiveButtons(toLinkService, tabIdx);
            if (toLinkService.cd == 'AUTQ') tabIdx = 1;
            return tabIdx;
        }
        KIA_RNW_0D2_2100.tabularNavigator.open(tabIdx);

        // 2023.11.23 popupFlag, selectVinNumber 를 제외한 파라미터가 존재 하는지 check
        // 뒤로가기 시 공통 btn_prev_click 으로 인해 default msg 출력 방지
        const { popupFlag, selectVinNumber, ..._params } = params;
        // console.log(_params);

        // todo gs칼텍스 가입결과 판단후 결과페이지 이동.
        var gsReturns = null;
        if (!isEmpty(_params)) {
            gsReturns = {
                cardNo: params.cardNo, // "0190920022524193" "0190920022524193"
                resCode: params.resCode, // "0000" "0000"
                resMessage: params.resMessage, // "가입이 완료되었습니다." "가입이 완료되었습니다."
                returnUrl: params.returnUrl, // "vikapp://returnUrl?ccoCode=9981"
            }
        }
        if(!isEmpty(gsReturns)) {
            MData.removeParam();
            registGSCT(gsReturns)//common
                .then(function(response){
                    debugger;
                    if(typeof response == "string"){
                        MPopup.instance(response);
                    }else{
                        if(response.resultCode === "200" && response.regYn === "Y"){
                            MPage.html({
                                url : PATH_MANAGER.KIA_RNW_0D2_2400.path,
                                param: {"toLinkService":oilLinkMng.toLinkService}
                            });
                        }else{
                            MPopup.instance(response.resultMsg);
                        }
                    }
                });
        }

    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    onBack : function(){
        MPage.back({param: {isCardOrderDisplayChangedYn: (reloadOnRestore?"Y":"N")}});
    },
    onDestroy : function(event){},
    onPause : function(event){},
    onResume : function(event){
        console.log("heyyy :onResume");
    }
};
