/**

 @파일명 : KIA_RNW_0D2_2200.js
 @작성자 : 케이스마텍 추헌남
 @생성일 : 2022.03.10
 @메뉴명 : Auto Q 탭
 @DESC : 권한 확인 중
 */
var autoQLinkMng;
var KIA_RNW_0D2_2200 ={
    init: function(){
        autoQLinkMng = this;
        console.log("page : KIA_RNW_0D2_2200 :Auto Q 탭, initiolizing START");
        autoQLinkMng.toLinkService = DICT.SVC_COMPANY.AUTQ;
        // 오토큐가입유무의 판단api는 아직 서버에서 준비되지 않은상태
        // 아직 가입유무 판단할수 없다고 함.
        // 일단 스토리지에 저장해두고, 로그아웃시에 삭제함.
        //var storagedAutoqLinkedYn = M.data.storage("AUTQ_linked");
        //if(storagedAutoqLinkedYn=="Y"){
        //    $("#AUTQ_serviceLinkBtn").removeClass('none').addClass('none');
        //}else{
        //    $("#AUTQ_serviceLinkBtn").removeClass('none');
        //}
        autoQLinkMng.setEventListner();
        // 서버에서 판단할수 있게 되면 아래 프로세스로 ..
        autoQLinkMng.getAutoQLinkYn()
             .then(
                 function (response){
                     if(response.resultCode=="200"){
                         if(response.agreeYn=="N"){
                             // 연동 버튼 오픈
                             $("#AUTQ_serviceLinkBtn").removeClass('none');
                             $("#AUTQ_delLinkBtn").removeClass('none').addClass('none');
                         }else{
                             // 연동 해지 버튼 오픈
                             $("#AUTQ_serviceLinkBtn").removeClass('none').addClass('none');
                             $("#AUTQ_delLinkBtn").removeClass('none');
                         }
                     }else{
                         // 정상 응답이 아닐 경우 연동/연동해제 버튼 모두 미노출 처리
                         $("#AUTQ_serviceLinkBtn").removeClass('none');
                         $("#AUTQ_delLinkBtn").removeClass('none');
                         // 에러 메세지 송출
                         MPopup.instance(response.resultMsg);
                     }
                     autoQLinkMng.setEventListner();
                     return;
                 }
             );
    },
    toLinkService:null,
    setEventListner: function(){
        // $(".btn-close").off("click").on("click", function(){
        //     MPage.back({param: {isCardOrderDisplayChanged: reloadOnRestore}});
        // });
        $("#AUTQ_serviceLinkBtn").not('.disabled').off("click").on("click",function(){
            autoQLinkMng.postAutoQLink()
                .then(
                    function (response){
                        exWNHideIndicator();
                        if (!isEmpty(response.errorCode)) {//통신응답오류
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("네트워크 통신 에러 : "+response.errorCode);
                            MPopup.instance(response.errorMessage);
                        }else{
                            if(response.resultCode === "200" && response.agreeYn === "Y"){
                                autoQLinkMng.toLinkService.result='success';
                                //서버에서  autoq 가입유무 판단이 어렵다. 아직 데이터연동이 되지 않음. 로그아웃시 삭제한다.
                                // 서버 api로 판단할 수 있게 되면 관련 코드 모두 삭세요함.
                                //M.data.storage("AUTQ_linked","Y");
                                MPage.html({
                                    url : PATH_MANAGER.KIA_RNW_0D2_2400.path,
                                    param: {"toLinkService":autoQLinkMng.toLinkService}
                                });
                            }else{
                                MPopup.instance(response.resultMsg);
                                //todo 실패는 없는건가?
                                autoQLinkMng.toLinkService.result='fail';
                            }
                        }
                    }
                );
        });

        // Auto Q 연동 해제 안내 팝업 오픈
        $("#AUTQ_delLinkBtn").not('.disabled').off("click").on("click", function() {
            autoQLinkMng.showPopup();
        });

        exWNHideIndicator();
    },
    getAutoQLinkYn : function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.autoqInfoGetRegConYn,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    },
    postAutoQLink : function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.autoqGetReg,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    },
    delAutoQLink : function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.autoqRegDel,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    },
    /**
     * Auto Q 연동 해제 안내 팝업 오픈
     */
    showPopup: function () {
        exWNHideIndicator();
        // 1. 연동 해제 안내 팝업 오픈
        customPopup
            .get(
                PATH_MANAGER.KIA_RNW_0D2_2500.path,
                $("#popup_0D2_2500"),
                function (item) {//item==POP._0D2_2500.url's html
                    var popId = "#popup_0D2_2500";
                    if ($(popId).length < 1) {
                        var screenHtml = $("<div></div>");
                        screenHtml.append(item);
                        $('body').append(screenHtml.find(popId));
                    }
                    RNW_UI.popupLayer({selId: popId});
                    // 2. 연동 해제 API 호출
                    $(popId + "_DetailBtn").on("click", function () {
                        autoQLinkMng.delAutoQLink()
                            .then(
                                function (response){
                                    exWNHideIndicator();
                                    // 2-1. 연동 해제 완료 응답 수신
                                    if (response.resultCode === "200" && response.deleteYn === "Y") {
                                        // 3. 연동 해제 완료 팝업 오픈
                                        customPopup
                                            .get(
                                                PATH_MANAGER.KIA_RNW_0D2_2600.path,
                                                $("#popup_0D2_2600"),
                                                function (item) {//item==POP._0D2_2600.url's html
                                                    var popId = "#popup_0D2_2600";
                                                    if ($(popId).length < 1) {
                                                        var screenHtml = $("<div></div>");
                                                        screenHtml.append(item);
                                                        $('body').append(screenHtml.find(popId));
                                                        $('#todayDt').text(moment().format('(YYYY년 MM월 DD일)'));
                                                    }
                                                    RNW_UI.popupLayer({selId: popId});
                                                    // 4. 확인 버튼 클릭 시 연동 화면으로 이동
                                                    $(".btn-primary").click(function () {
                                                        MPage.html({
                                                            url : PATH_MANAGER.KIA_RNW_0D2_2100.path
                                                        });
                                                    });
                                            });
                                    }
                                    // 2-2. 에러 메시지 송출
                                    else {
                                        MPopup.instance(response.resultMsg);
                                    }
                                }
                            );
                    });
                    $(".js-popup-close-btn").click(function () {
                        var _$naverShow = $("div.popup-cont").find('input.pop-naver-show');
                    });
                }
            );
    },
}
KIA_RNW_0D2_2200.init();
/**
 * 모피어스 화면 상태 이벤트 함수
 */
// var MStatus = {
//     onReady : function(event){
//         console.log("onReady page : "+PGV.currentPage);
//         KIA_RNW_0D2_2200.init();
//     },
//     onHide : function(event){},
//     onRestore : function(event){},
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//     // onBack : function(){},
//     onDestroy : function(event){},
//     onPause : function(event){},
//     onResume : function(event){}
// };
