/**
@파일명 : KIA_RNW_0D2_2300_2_2.js
@작성자 : 케이스마텍 정목단
@생성일 : 2022.03.23
@메뉴명 : GNB_바코드팝업_제휴사 연동 안내 팝업_주유 정보 연동 약관 동의 팝업(S-OIL)
@DESC : 권한 확인 중
*/
var agreementMng;
var KIA_RNW_0D2_2300_2 = {
    init: function () {
        agreementMng = this;
        stackRemove("KIA_RNW_0D2_2300_2.html");
        console.log("page : " + PGV.currentPage + "initiolizing START");
        $('#service3rdLinkBtn').removeClass('disabled').addClass('disabled');
        var toLinkService = MData.param("toLinkService");
        MData.removeParam("toLinkService");
        agreementMng.toLinkService=toLinkService;
        // $('#service3rdLinkBtn').parent('div').data("3rdServiceInfo",JSON.stringify(toLinkService));
        agreementMng.setEventListner();
    },
    setEventListner: function () {
        // 전체 동의
        $('#chkAll').on('click', function (e) {
            fnSetToggleTerms();
        });
        function fnSetToggleTerms() {
            if ($('#chkAll').is(':checked')) {
                $("ul.terms-list").find('input.mykia-input').prop("checked",true)
                $('#service3rdLinkBtn').removeClass('disabled');
            }
            else {
                $("ul.terms-list").find('input.mykia-input').prop("checked",false)
                $('#service3rdLinkBtn').removeClass('disabled').addClass('disabled');
            }
            return true;
        }

        //todo 약관관리에 관한 결정에 따라 코딩해야 함.
        /**
         * 약관상세보기
         */
        $("button.btn-arrow-right").on("click", function(){
            var agreementName = $(this).parent('li').find('input.mykia-input').attr('name');
            var serviceName = agreementMng.toLinkService.cd;
            var agreementPath = agreementMng.toLinkService.agreementDetail[agreementName].path;
            MPage.html({url: agreementPath});
        });
        /**
         * 약관체크시(마케팅수신 체크는 아님) //todo 전체 체크에 대한 확인
         */
        var _$agreeEl = $("ul.terms-list").find("input.mykia-input");
        _$agreeEl.on("click", function(){
            var totalBoxesCnt = _$agreeEl.length;
            var totalMandatoryCnt = _$agreeEl.parent().find(".input-mandatory").length;
            var checkedTotalCnt = _$agreeEl.parent().find(":checked").length;
            var checkedMandatoryCnt = _$agreeEl.parent().find(".input-mandatory:checked").length;

            if (checkedMandatoryCnt === totalMandatoryCnt){
                $('#service3rdLinkBtn').removeClass('disabled');
            }
            else{
                $('#service3rdLinkBtn').removeClass('disabled').addClass('disabled');
            }

            if(checkedTotalCnt===totalBoxesCnt){
                $('#chkAll').prop('checked', true);
            }else{
                $('#chkAll').prop('checked', false);
            }
        });

        $('#service3rdLinkBtn').on("click", function(){
            var isEnable = !$(this).hasClass('disabled');
            if (isEnable) {
                var _$allCheckEl = $("input.mykia-input");
                var sendData ={mbrId : PGV.loginInfo.mbrId};
                $.each(_$allCheckEl,function(index, item){
                    var name = $(item).attr("name");
                    var value = $(item).is(":checked")?"Y":"N";
                    sendData[name] = value;
                });
                //서버에 요청하기
                // var toLinkService = JSON.parse($(this).parent('div').data("3rdServiceInfo"));
                if(!isEmpty(agreementMng.toLinkService)){
                    var options = {
                        isMock: false,
                        path: _API.SVR.CMM.crd.soilJoin,//toLinkService.agreeAction
                        sendData: sendData,
                    };
                    MNet.httpSendAsync(options)
                        .then(
                            function (response){
                                if (response.resultCode==="200"){
                                    if(response.regYn!=="Y"){
                                        agreementMng.toLinkService.result ="fail";
                                        msg= "제휴서비스 연동에 실패하였습니다.";
                                    }else{
                                        msg = response.resultMsg;
                                        agreementMng.toLinkService.result ="success";
                                        MPage.html({
                                            url : PATH_MANAGER.KIA_RNW_0D2_2400.path,
                                            param: {"toLinkService":agreementMng.toLinkService}
                                        });
                                    }
                                }else{
                                    //todo 실패는 없는건가?
                                    agreementMng.toLinkService.result ="fail";
                                    msg= "제휴서비스 연동에 실패하였습니다.";
                                }
                                MPopup.instance(msg);
                                exWNHideIndicator();
                            }
                        )
                    // .then(function(){
                    //     setTimeout(function(){
                    //         MPage.back({param:{"toLinkService":toLinkService}});
                    //     }, 300);
                    // })
                    ;

                }
            }else{
                //필수항목중 선택되지 않는 것이 있다.
            }
        })
    },
    handleConfirmButton: function(){
        console.log("yes");
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_0D2_2300_2.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {
        var closePage = MData.param("closePage");
        MData.removeParam("closePage");
        if(closePage){
            var toLinkService = MData.param("toLinkService");
            MData.removeParam("toLinkService");
            var param = {"toLinkService":toLinkService,linkStatusChangedYn:"Y"};
            MPage.back({param: param});
        }
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
