/**
@파일명 : KIA_RNW_0D3_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.24 
@메뉴명 : GNB_마이페이지
@DESC : 권한 확인 중
*/

var KIA_RNW_0D3_0000 = {
    kiaFamilyList: null,
    init: function () {
        var parentThis = this;

        this.setProfileCardSection();

        /* UI 출력 */
        Promise.all([
            this.checkNewVersion(),
            this.setKiaFamilySection(),
            this.setCouponSection(),
            this.checkRedMemberJoinWithPoint(),
            COMMON_FUNCTION.TOOL.CARD.loadCardsListAsIs()
        ])
        .then(function(response){
            const redMemberJoinResponse = response[3];
            const loadCardListResponse = response[4];

            if(redMemberJoinResponse.resultCode === "200") {
                // 소멸 예정 개인화 메시지 출력
                const targetPoint = parseInt(redMemberJoinResponse.exntMilgAmt);

                if(targetPoint > 0){
                    $("#mykia-mypage-main-personal-box-point").text(targetPoint.toLocaleString());
                    $("#mykia-mypage-main-personal-box").removeClass("none");
                }
                // 회원가입유도창 가리고, 카드없음창 보이기
                $(".not-member").addClass("none");
                $(".no-card").removeClass("none");
            }

            /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
            COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(loadCardListResponse);
            /* 카드 목록 출력 */
            var cardList = loadCardListResponse.cardListResDto;

            if(loadCardListResponse.resultCode === "200" && cardList && cardList.length > 0){
                parentThis.setOrderedCards(cardList)
                .then(function(orderedCardList){
                    parentThis.setEventListener();
                    parentThis.setPublisherEventListener();
                });
            } else{
                parentThis.setEventListener();
                parentThis.setPublisherEventListener();
            }

            /* 버전 관련하여 처리 */
            var currentVersion = PGV.appInfo && PGV.appInfo.app && PGV.appInfo.app.version;
            $('#mykia-mypage-current-version').text(currentVersion || "알 수 없음");
            
            if(response[0].binVerStr === currentVersion){
                $('#mykia-mypage-update').hide();    
            }
            else{
                $('#mykia-mypage-update').show();
                $("#mykia-mypage-update-button").on("click", function(){
                    var _id = CONSTANT.KIA_VIK_ANDROID_PACKAGE ;
                    if (PGV.device.os.name.toLowerCase() == 'ios' ||PGV.device.os.name.toLowerCase() == 'ipados') {
                        _id = CONSTANT.KIA_VIK_IOS_STORE_ID;
                    }
                    M.apps.store(_id);
                })
            }

            /* 케이스마텍 추헌남 - iOS 상에서 가입 버튼 제대로 동작하지 않아 이벤트 리스너 해당 함수에서 적용 */
            $("#mykia-mypage-main-join-membership, button.btn-memebr-join").on("click", function () {
                var _url = CONSTANT.LINK_URL.KIA_RNW_0D2_3000.URL;
                MPage.activity({
                    className: "WebviewActivity",
                    param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam("POST", _url, {
                        mbrId: PGV.loginInfo.mbrId
                    })
                });
            });

            $(document).on("click", "#termsUse", function(){
                MPage.html({
                    url : PATH_MANAGER.KIA_RNW_0D3_4100.path,
                    animate : 'MODAL_UP'
                });
            });
            //개인 정보 처리 방침
            $(document).on("click", "#privacyPolicy", function(){
                MPage.html({
                    url : PATH_MANAGER.KIA_RNW_0D3_4200.path,
                    animate : 'MODAL_UP'
                });
            });
            // 위치기반서비스 이용약관 버튼 클릭 시
            $(document).on("click", "#locTermsViewBtn", function(){
                MPage.html({
                    url : PATH_MANAGER.KIA_RNW_0D3_4300.path,
                    animate : "MODAL_UP"
                });
            });

            exWNHideIndicator();
        })
        .catch(function(e){
            COMMON_FUNCTION.TOOL.DEBUG.showAdvice(e);
            MPopup.alert("로드 중 오류가 발생하였습니다.\n\n" + e);
            exWNHideIndicator();
        })
    },
    setEventListener: function () {
        var parentThis = this;

        $('button.btn-prev').on("click", function(){
            MPage.back();
        });
        $("#mykia-mypage-go-to-carnlife").on("click", function(){
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_810_0000.path,
                param : {
                    rUrl : CONSTANT.AUTON_URL_PREFIX,
                    evtYN : "N"
                }
            }); 
        })
        $('[data-screenid]').on("click", function(){
            var currentScreenId = $(this).data('screenid');
            MPage.html({
                path: PATH_MANAGER[currentScreenId].path
            })
        })
        $("[data-link]").on("click", function(){
            MPage.activity({
                className: "WebviewActivity",
                param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam("GET", CONSTANT.LINK_URL.KIA_RNW_810_0000.URL)
            });
        })

        $("[data-custom]").on("click", function(){
            MPage.activity({
                className: "WebviewActivity",
                param: {
                    method: CONSTANT.NET_MTHD.GET,
                    requestURL: "https://m.members.kia.com/kr/view/web/kutl/kutl_event_lifecare_index.do"
                }
            });
        })


        $('#mykia-mypage-logout').on("click", function(){
            /* 로그아웃 함수 */
            M.data.removeGlobal("passData");
            MData.removeGlobal("crdType");  //카앤라이프몰 카드정보리스트
            MData.removeStorage("accessToken");
            MData.removeStorage("PUSH_ALARM_CHECK");
            M.data.removeStorage("popUpMng");//팝업다시보지않기 등 관리
            M.data.removeStorage("enable_receive_payment_info");//스미싱 on/off 값
            M.data.removeStorage("payment_info_list");// 스미싱데이터
            M.data.removeStorage("myCardList");// 보유카드순서
            //M.data.removeStorage("AUTQ_linked");// AutoQ 서비스 가입유무 삭제.
            M.net.cookie.clear();
            MData.removeGlobal('loginInfo');
            PGV.loginInfo = '';
            //todo check 미로그인 홈에 필요한 데이터가 있는가?
            //todo check 로그아웃결과를 알려줘야 하는가?
            COMMON_FUNCTION.TOOL.DATA.deleteMyKiaStorageByKey("insight");
            COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_0F0_0000.path, function(){
                this.find("#mykia-logout-confirm").off("click").on("click", function(){
                    MPage.html({
                        url : PATH_MANAGER.KIA_RNW_110_0000.path,
                        action : "CLEAR_TOP",
                        animate : "SLIDE_RIGHT",
                        param : {
                            settingRegistFlag : "Y"
                        }
                    });
                })
            })
        })
        $('#callQRpage').on("click", function(){
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_0D3_0100.path,
                animate : "MODAL_UP"
            });
        })
    },
    setCouponSection: function(){
        MNet.httpSendAsyncAsIs({
            indicatorYn : "N",
            path : inf.coupon.couponSelect.url,
            sendData : {
                mbrId : PGV.loginInfo.mbrId,
                expiresYn: "N"
            }
        })
        .then(function(response){
            if (response.resultCode === "200"){
                var couponList = response.couponListResDto;
                if (couponList && couponList.length > 0){
                    $("#mykia-mypage-coupon-count").text(couponList.length + "장");
                }
                else{
                    $("#mykia-mypage-coupon-count").text("0장");
                }
            }
            else{
                $("#mykia-mypage-coupon-count").text("0장");
            }
        })
    },
    checkRedMemberJoinWithPoint: function () {
        return MNet.httpSendAsyncAsIs({
            path: inf.point.extFlcMilg.url,
            sendData: {
                csetIfTypeCd: "04",
                csetIfValue: PGV.loginInfo.csmrMgmtNo
            }
        });
    },
    setProfileCardSection: function(){
        if(!isEmpty(PGV && PGV.loginInfo)){
            $('#mykia-username').text(PGV && PGV.loginInfo.mbrNm);
			$('#mykia-email').text(PGV && PGV.loginInfo.mbrId);
        }
    },
    setOrderedCards: function(orderedCardList){
        return new Promise(function(resolve){
            var cardNameDict = COMMON_FUNCTION.TOOL.CARD.getCardNameDict();
            var cardImgPathList = COMMON_FUNCTION.TOOL.CARD.getCardImagePathList();
            var htmlString = "";
            if(orderedCardList && orderedCardList.length > 0){
                for(var i = 0; i < orderedCardList.length; i++){
                    var curNode = orderedCardList[i];
                    if (curNode){
                        var cardNameType = curNode.crdKind || curNode.oilCoCd;
                        var currentCardName = curNode.crdKind || "카드 이름 없음";
                        var currentCardNumber = curNode.milgMbrNo || curNode.oilCardNo;
                        var currentCardPoint = curNode.redPoint || curNode.oilPoint || 0;
                        var currentCardImagePath = curNode.cardImgUrl;
                        var isCurrentRedPoint = curNode.redPoint ? true : false;
                        htmlString += (function(cardName, cardNumber, point, cardImagePath, cardDisplayOrder, isRedPoint){
                            var cardNumberText = "";
                            for (var i = 0; i < cardNumber.length; i++){
                                if (i % 4 === 0){
                                    cardNumberText += " " + cardNumber[i];
                                }
                                else{
                                    cardNumberText += cardNumber[i];
                                }
                            }
                            var templateString =
                                '<div class="swiper-slide" data-card-display-order="'+ cardDisplayOrder + '">' +
                                    '<div class="membership-card is-card" data-card-number="' + cardNumber +'">' +
                                        '<div class="group-01">' +
                                            '<div class="img-cont">' +
                                                '<img class="img-card" src="' + cardImagePath + '" alt="">' +
                                            '</div>' +
                                            '<div class="ticket-title">' +
                                                '<div class="row">' +
                                                    '<span>' + cardName + '</span>' +
                                                '</div>' +
                                                // '<div class="row">' +
                                                //     '<strong>' + (point && parseInt(point).toLocaleString()) + '</strong><i class="' + (isRedPoint ? "ico-point-red" : "ico-point-black") + '"></i>' +
                                                // '</div>' +
                                            '</div>' +
                                        '</div>' +
                                        '<div class="group-02">' +
                                            '<div class="bg-cont d-flex align-items-center">' +
                                                '<div class="bg-barcode"></div>' +
                                            '</div>' +
                                            '<em class="code">' + cardNumberText + '</em>' +
                                        '</div>' +
                                    '</div>' +
                                '</div>';
                            return templateString;
                        })(currentCardName, currentCardNumber, currentCardPoint, currentCardImagePath, i, isCurrentRedPoint);
                    }
                }
    
                $('#mykia-mypage-card-list').html(htmlString);
        
                for(var i = 0; i < orderedCardList.length; i++){
                    var curNode = orderedCardList[i];
                    var currentCode = curNode.milgMbrNo || curNode.oilCardNo;
                    COMMON_FUNCTION.TOOL.CARD.setBarcode(currentCode, '[data-card-display-order='+ i + '] .bg-barcode');
                }
            }
            
            resolve(orderedCardList);
        })
    },
    setKiaFamilySection: function(){
        var parentThis = this;
        MNet.httpSendAsync({
            indicatorYn : "N",
            path: _API.SVR.CMM.myp.mypage.kiaFamilyList,
            sendData: {
                osId : PGV.device.os.name === "Android" ? "10" : "20"
            },
            isMock: false
        }).then(function(response){
            if (response.resultCode === "200"){
                var kiaFamilyList = response.kiaFamilyListRnwResDto;
                parentThis.kiaFamilyList = kiaFamilyList;
                if(!isEmpty(kiaFamilyList)){
                    var successfullyAddedCount = 0;
                    var htmlString = "";
                    var containerStart = 
                        '<div class="swiper-slide">' +
                            '<div class="family-list">';
                    var containerEnd =
                            '</div>' +
                        '</div>';
                    for (var i = 0; i < kiaFamilyList.length; i++){
                        var curNode = kiaFamilyList[i];
                        if (curNode){
                            var menuName = curNode.fmlyNm;
                            var iconUrl = curNode.iconUrl;
                            var linkUrl = curNode.lnkUrl; //mykia-mypage-family

                            if(successfullyAddedCount % 4 === 0){
                                htmlString += containerStart;
                            }

                            if (menuName && iconUrl && linkUrl){
                                htmlString += (function(menuName, iconUrl, linkUrl, dataIndex){
                                    var templateString =
                                        '<dl class="d-flex align-items-center" data-mykia-family-link="' + linkUrl + '">' +
                                            '<dt><img src="' + iconUrl + '" alt=""></dt>' +
                                            '<dd>' + menuName + '</dd>' +
                                        '</dl>';
                                    return templateString;
                                })(menuName, iconUrl, linkUrl, (i + 1));
                            }

                            if(successfullyAddedCount % 4 === 3 || (i === kiaFamilyList.length - 1)){
                                htmlString += containerEnd;
                            }

                            successfullyAddedCount++;
                        }
                    }

                    $("#mykia-mypage-family").html(htmlString);

                    var _sliderMembershipFamily = new Swiper('.slider-membership-family', {
                        slidesPerView:'auto',
                        loop:true,
                        speed:300,
                        autoHeight: true,
                        grabCursor:true,
                        touchRatio: $('.slider-membership-family .swiper-slide').length > 1 ? true : false, // 슬라이드 영역 1개일경우 드래그 금지
                        pagination: {
                            el: '.membership-family .swiper-pagination',
                            clickable: true,
                        },
                    });

                    $('#mykia-mypage-family dl').on("click", function(){
                        var currentLink = $(this).data('mykia-family-link');

                        /* !!! 케이스마텍 추헌남 - 단순 서비스 안내 모피어스 페이지 혹은 웹뷰 URL 링크만 열게 될 예정이라서 복잡한 로직은 없습니다. */
                        var isLink = currentLink.indexOf("http://") !== -1 || currentLink.indexOf("https://") !== -1;
                        var isMorpheusPage = currentLink.indexOf("KIA_RNW_") !== -1;

                        if(!isEmpty(currentLink)){
                            if(isLink){
                                MPage.activity({
                                    className : "WebviewActivity",
                                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET. currentLink)
                                });
                            }
                            if(isMorpheusPage){
                                MPage.html({
                                    path: PATH_MANAGER[currentLink].path
                                })
                            }
                        }
                    });
                }
            }
        })
    },
    setPublisherEventListener: function(){
        var _sliderMembershipCard = new Swiper('.slider-membership-card', {
            slidesPerView:1,
            loop:true,
            speed:300,
            autoHeight: true,
            grabCursor:true,
            touchRatio: $('.slider-membership-card .swiper-slide').length > 1 ? true : false, // 슬라이드 영역 1개일경우 드래그 금지
            pagination: {
                el: '.membership-cont .swiper-pagination',
                clickable: true,
                dynamicBullets:true, // 20220530//(Ina)dynamicBullets 옵션추가
                dynamicMainBullets:8  // 20220530//(Ina)dynamicMainBullets 옵션추가
            },
        });
    },
    checkNewVersion: function(){
        return MNet.httpSendAsync({
            path: _API.SVR.CMM.code.appVersion,
            sendData:{
                mbrId: PGV.loginInfo.mbrId,
                osId : PGV.device.os.name === "Android" ? "10" : "20",
            },
            isMock: false
        });
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        // console.log("onReady page : " + PGV && PGV.currentPage || "");
        KIA_RNW_0D3_0000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {exWNHideIndicator()},
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    onBack : function(){
        if(!($('#popup_0F0_0000:visible').length > 0)){
            MPage.back()
        }
    },
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) {exWNHideIndicator()}
}; 
