/**
 * @파일명 : KIA_MOB_810_1050.js
 * @작성자 : 이현석
 * @생성일 : 2018. 8. 7. 오후 5:20:58
 * @메뉴명 : 비밀번호 변경
 */
 var pageInit = function(){
	stackRemove("KIA_MOB_810_1030.html");
	$("#userId").text(PGV.loginInfo.mbrId);
	/**
	 * 초기화
	 */
	setEvent();
	/**
	 * 화면 이벤트
	 */
	
};
/*
 *  비밀번호 변경 현재 비밀번호를 입력하는 부분이 있음 현재 비밀번호를 넣어서 
 */
var setEvent = function() {
	$(document).on("click", "#changePw", function(){
		/* !!! 케이스마텍 추헌남 - 기존 비밀번호 확인 로직 추가 */
		var userId = PGV.loginInfo.mbrId;
		var userPrevPw = $("#basicPw").val();
		var userNextPw = $("#userPw").val();
		if (!isEmpty(userPrevPw) && userPrevPw.length > 7) {
			if (isUseVerifyUrl()) {
				MNet.httpSendAsIs({
					path: inf.member.verifyLogin.url,
					sendData: {
						mbrId: userId.toLowerCase(),
						pw: btoa(userPrevPw)
					},
					callback: checkPreviousPasswordCallback
				});
			} else {
				MNet.httpSendAsIs({
					path: inf.member.login.url,
					sendData: {
						mbrId: userId.toLowerCase(),
						pw: userPrevPw
					},
					callback: checkPreviousPasswordCallback
				});
			}
			return false;
		} else {
			MPopup.alert('입력하신 기존 비밀번호가 일치하지 않습니다.');
			return false;
		}
	});	

	$(document).on("keyup", "#userPw, #userPwRe", function(){	//정보 인증 버튼 활성화
		var userPrevPw = $("#basicPw").val();
		var userPw = $("#userPw").val();
		var userPwRe = $("#userPwRe").val();

		var that = $("#changePw");
		
		var strSpace = /\s/;  // 공백체크
		if(strSpace.exec($("#userPw").val())) { //공백 체크
			$("#basicPw").focus();
			$("#basicPw").val($("#basicPw").val().replaceAll(' ','')); // 공백제거
	        return false;
	    }

	    if(strSpace.exec($("#userPw").val())) { //공백 체크
			$("#userPw").focus();
			$("#userPw").val($("#userPw").val().replaceAll(' ','')); // 공백제거
	        return false;
	    }

		if(strSpace.exec($("#userPwRe").val())) { //공백 체크
			$("#userPwRe").focus();
			$("#userPwRe").val($("#userPwRe").val().replaceAll(' ','')); // 공백제거
	        return false;
	    }

		if(userPrevPw.length > 7 && userPw.length > 7 && userPwRe.length > 7){
			that.prop('disabled', false);
		}else{
			that.prop('disabled', true);
		}
	});
}

var changePwApiCall = function(data) {
	var _url = checkVerifyUrl(inf.member.changePw.url);
	// [KIAVIK-682] chagnePwNew 임시 비밀번호 변경 오류로 api 변경
	// [KIAVIK-882] 보안 취약점 개선 - verifyChangePw api 변경
	data = Object.assign(data, {
        pwGbn : "0"     // 고정
    });
	MNet.httpSendAsIs({
		path : _url,
		sendData : data,
		callback : changePwApiCallBack
	});
};

var changePwApiCallBack = function(receivedData) {
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){ //비밀번호 변경 성공한경우
		if(!CONSTANT.IS_CCSP){ //CCSP가 아닌경우 
			if(MData.storage("fidoLogin") == "Y"){		// 지문로그인 등록이 되어 있는 상태인 경우
				MData.storage("fidoLoginPw", $("#userPw").val());
			}
			
			if(MData.storage("autoLogin") == "Y"){		// 자동로그인이 설정되어 있는 경우
				MData.storage("autoLoginPw", $("#userPw").val());
			}
			MData.storage("wrongPwFlag", 'N');
		}
		MPopup.alert({
			message : "비밀번호가 변경 되었습니다.",
			callback : function(){
				MPage.back();
			}
		});
	}else{
		MPopup.alert(msg);
		return false;
	}
};



/* !!! 케이스마텍 추헌남 - 기존 비밀번호 확인 API KIA_RNW_0D3_1100 으로부터 가져왔습니다. */

var isUseVerifyUrl = function () {
    var os = PGV.device.os.name.toLowerCase();
    var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g, "").replace(/(\d{3})(\d*)/, "$1"));	// 앱 버전

    if (os == "android") {
        //Android 최근 버전이 1.1.10 => 해당 버전때문에 앞 3자리만 체크
        if (_appVersion < CONSTANT.USE_VERIFY_ANDROID_VERSION) {
            return false;
        }
    } else {
        if (_appVersion < CONSTANT.USE_VERIFY_IOS_VERSION) {
            return false;
        }
    }

    return true;
}

// 기존 비밀번호 확인 콜백 + 비밀번호 변경 콜백
var checkPreviousPasswordCallback = function (receivedData) {
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;

	if (code == "200" && !isEmpty(receivedData.accessToken)) { // 인증 성공시
		var ObjBasicUserPw = $("#basicPw").val();
		var ObjUserPw = $("#userPw").val();
		var objUserPwRe = $("#userPwRe").val();
		
		if(!passwordCheck.changePw(ObjUserPw, objUserPwRe)){
			
			return false;
		};

		if(!passwordCheck.checkPw(ObjUserPw)){
			
			return false;
		};

		if(!passwordCheck.basicPw(ObjUserPw, ObjBasicUserPw)){

			return false;
		}

		var data = {
			mbrId : PGV.loginInfo.mbrId, // 사용자 ID
			pw : ObjUserPw	 // 신규 비번
		}
		changePwApiCall(data); 

	} else {
		if(receivedData.resultCode === "112"){
			MPopup.alert("입력하신 기존 비밀번호가 일치하지 않습니다.");
		}
		return false;
	}
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};