/**
 * @파일명 : KIA_MOB_810_1031.js / 리뉴얼 - KIA_RNW_0D3_1300.js
 * @작성자 : 이현석 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2022-03-25
 * @메뉴명 : 사용자 정보 수정
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	PGV.myInfo = new Object();
	PGV.carList = new Array();
	PGV.buyYArray = new Array();
	PGV.buyMArray = new Array();
	PGV.myCarSelect = 0;
	PGV.baseBallData = {};
	PGV.baseBallData.baseBallYn = "N";
	if(!isEmpty(MData.param("baseBallData"))){
		PGV.baseBallData = MData.param("baseBallData");
		MData.removeParam("baseBallData");
	}

	textlength();

	selectMyInfo(PGV.loginInfo.mbrId);
	/**
	 * 화면 이벤트
	 */
	setEvent();
	//screenViewGa(gaSendUrl["KIA_MOB_810_1031"].pageNm); //2020 공통으로 변경
};


var setEvent = function () {
	$(document).on("click", "#updateBtn", function(){	//정보수정
		if(myInfoValidation()){
			updateMyInfo();
		}		
	});

	$(document).on("keyup", ".phoneNumber", function() {
        $(this).val( $(this).val().replace(/[^0-9]/g, "").replace(/(^02|^0505|^1[0-9]{3}|^0[0-9]{2})([0-9]+)?([0-9]{4})$/,"$1-$2-$3").replace("--", "-") );
    });

    $(document).on("keyup", ".homeNumber", function() {
        $(this).val( $(this).val().replace(/[^0-9]/g, "").replace(/(^[0-9]{3}|^[0-9]{4})([0-9]{4})$/,"$1-$2").replace("--", "-") );
    });

	$(document).on("click", "#changePwBtn", function(){	//비밀번호 변경
		MPage.html({ //2019_04_19 비밀번호 로직 변경
			url : PATH_MANAGER.KIA_RNW_0D3_1200.path,
			animate : "MODAL_UP"
		});
	});

	// 전화번호 입력시
	$("#telD, #homeTelD, #companyTelD").on("input", function(){
		var $this = $(this);
		var _val = extractNumber($this.val());
		$this.val(_val);
	});

	// $(document).on("keyup", "#emailAdr", function(){	//이메일 입력
	// 	PGV.emailCheckFlag = "N";
	// });

	$(document).on("click", "#choiceCar", function(){	//선호 차량클릭	
		MPopup.listSingle({
			list : PGV.carList,
			title : "선호 차종 선택",
			selected : PGV.myCarSelect
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				$("#choiceCar").text(rowInfo.title);
				$("#choiceCar").data("value", rowInfo.value);
				// PGV.myInfo.ccd = rowInfo.value;
				PGV.myCarSelect = rowInfo.index; 
			}
			
		});
	});

	//이메일 중복 체크
	// $(document).on("click", "#checkEmailOverlapBtn", function(){
	// 	var email = $("#emailAdr").val(); // 이메일
	// 	if(isEmpty(email.emlAdr) || !emailCheck(email.emlAdr)){
	// 		selectChkEmlOverlapApp(email);
	// 	}
	// });

	// 자택 번호 앞자리  // 직장 번호 앞자리 
	$(document).on("click", "#homeTelF, #companyTelF", function(){
		telFirstPopUp($(this));
	});
	
	// 자택 번호 
	$(document).on("focusout", "#homeTelML", function(){
		var homeTel = $("#homeTelML").val().replace(/-/gi,"");
		if(homeTel.length >= 7){
			homeTel = String(extractNumber(homeTel)).replace(/([0-9]{3,4})([0-9]{4})/, "$1-$2");
			$("#homeTelML").val(homeTel);
		}
		
	});

	// 직장 번호  
	$(document).on("focusout", "#companyTelML", function(){
		var companyTel = $("#companyTelML").val().replace(/-/gi,"");
		if(companyTel.length >= 7){
			companyTel = String(extractNumber(companyTel)).replace(/([0-9]{3,4})([0-9]{4})/, "$1-$2");
			$("#companyTelML").val(companyTel);
		}
	});
/*
	// 휴대폰 번호 앞자리 
	$(document).on("click", "#telF", function(){
		mobFirstPopUp($(this));
	});
*/
	// 취소
	$(document).on("click", "#cancaleBtn", function(){
		MPage.back({
			animate : "MODAL_DOWN"
		});
	});
	
	// 우편번호 팝업 클릭 시
	$(document).on("click", "#homeZipSearchBtn, #wkplZipSearchBtn", function(){
		var param = {
			searchType : $(this).attr("id")
		};

		MPage.html({
			url : PATH_MANAGER.KIA_RNW_0D3_1310.path,
			animate : 'MODAL_UP',
			param : param
		});
	});

	$(document).on("click", "#buyY", function(){	//구매 예정일 YYYY
		MPopup.listSingle({
			list : PGV.buyYArray,
			title : "년도 선택",
			selected : PGV.buyYSelect
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				$("#buyY").text(rowInfo.title);
				$("#buyY").data("value", rowInfo.value);
				PGV.buyYSelect = rowInfo.index; 
				if(rowInfo.title == "년"){
					$("#buyM").text("월");
					$("#buyM").data("value", "");
					PGV.buyMSelect = 0; 
				}
			}
		});
	});

	$(document).on("click", "#buyM", function(){	//구매 예정일 MM
		var year = $("#buyY").text();
		if(year == "년"){
			MPopup.alert("년도를 선택 해주세요.");
			return false;
		};

		MPopup.listSingle({
			list : PGV.buyMArray,
			title : "월 선택",
			selected : PGV.buyMSelect
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				var today = parseInt(moment().format("YYYYMM"));
				var selectedDay = rowInfo.title;
				if(typeof selectedDay === "string" && selectedDay.trim() === "월"){
					MPopup.alert("월을 선택 해주세요.");
					return false;
				}
				selectedDay = parseInt($("#buyY").text() + selectedDay);
				if(today > selectedDay){
					MPopup.alert("구매 예정일이 현재보다 과거 입니다.");
					return false;
				}else{
					$("#buyM").text(rowInfo.title);
					$("#buyM").data("value", rowInfo.value);
					PGV.buyMSelect = rowInfo.index;
					PGV.myInfo.itrstMdlBuyYmd = $("#buyY").data("value") + $("#buyM").data("value"); 
				} 
			}
			
		});
	});
/*
	$(document).on("click", "#emrBtn", function(){	//이메일 선택 
		var listArray = [
		{title:'naver.com', value:'네이버'},
		{title:'daum.net', value:'다음'},
		{title:'nate.com', value:'네이트'},
		{title:'gmail.com', value:'구글'},
		{title:'hotmail.com', value:'핫메일'},
		{title:'yahoo.com', value:'야후'},
		{title:'직접입력', value:'write'}
		];
		MPopup.listSingle({
			list : listArray,
			title : "이메일 선택",
			selected : PGV.emrSelect
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				$("#emrBtn").text(rowInfo.title);
				if(rowInfo.value == "write"){
					$("#emailAdrD").val("");
					$("#emailAdrD").prop('disabled', false);
				}else{
					
					$("#emailAdrD").val(rowInfo.title);
					$("#emailAdrD").prop('disabled', true);
				}
				PGV.emrSelect = rowInfo.index; 
			}
			
		});
	});
*/
	var radioNum = 0;
	$(document).on("click", 'input:radio[name="pmatRcplGbnc"]', function(){	// 우편물 수령 라디오 박스
		// var $this = $('div[name="addressWrap"]').filter('[data-type="'+$(this).val()+'"]');
		// $('div[name="addressWrap"]').not($this).addClass("none");
		// $this.removeClass("none");
		var that = $(this);
		$("#homeAdrDetail, #wkplAdrDetail").prop("readonly", false);
		if(that.attr('id') == "post3" && radioNum == 0){
			if($(".home").hasClass("on")){
				$(".home").removeClass("on");
			}
			if($(".office").hasClass("on")){
				$(".office").removeClass("on");
			}
			radioNum = 1;
			$("#homeAdrDetail, #wkplAdrDetail").prop("readonly", true);
			checkAll("all");
		}else if(that.attr('value') == "HOME"){
			if($(".office").hasClass("on")){
				$(".office").removeClass("on");
			}
			$(".home").addClass("on");
			radioNum = 0;
			checkAll("noAll");
		}else if(that.attr('value') == "WKPL"){
			if($(".home").hasClass("on")){
				$(".home").removeClass("on");
			}
			$(".office").addClass("on");
			radioNum = 0;
			checkAll("noAll");
		}
	});
	
	$(document).on("click", '#homeDatas, #wkDatas', function(){	// 우편물 수령 라디오 박스
		var that = $(this);
		var selectId = that.attr('id');
		

		if(selectId == "homeDatas"){
			if(that.prop("checked")){
				$("#homeZipGuide").removeClass('none');
				$("#homeZip").addClass('none');
				$("#homeZipSearchBtn").val("");
				$("#homeAdrDetail").val("");
				// $("#homeAdrDetail").prop('disabled', true);
				$("#homeTelF").text("선택");
				$("#homeTelML").val("");
				$("#homeZip").text("");
				$("#homeZipGuide").addClass("txtclr-g");
				$("#homeZip, #homeTelML, #homeTelF, #homeZipSearchBtn, #homeZipSearchBtn, #homeAdrDetail").prop('disabled', true);
				$("#homeAdrDetail").prop("readonly", true);
			}else{
				$("#homeZipGuide").removeClass("txtclr-g");
				$("#homeZip, #homeTelML, #homeTelF, #homeZipSearchBtn, #homeZipSearchBtn, #homeAdrDetail").prop('disabled', false);
				$("#homeAdrDetail").prop("readonly", false);
				forAdress("home");
			}
		}else if(selectId == "wkDatas"){
			if(that.prop("checked")){
				$("#wkplZipGuide").removeClass('none');
				$("#wkplZip").addClass('none');
				$("#companyName").val("");
				$("#wkplZipSearchBtn").val("");
				$("#wkplAdrDetail").val("");
				// $("#wkplAdrDetail").prop('disabled', true);
				$("#companyTelF").text("선택");
				$("#companyTelML").val("");
				$("#wkplZip").text("");	
				$("#wkplZipGuide").addClass("txtclr-g");
				$("#wkplZip, #companyTelML, #companyTelF, #wkplAdr, #wkplZipSearchBtn, #companyName, #wkplAdrDetail").prop('disabled', true);
				$("#wkplAdrDetail").prop("readonly", true);
			}else{
				$("#wkplZipGuide").removeClass("txtclr-g");
				$("#wkplZip, #companyTelML, #companyTelF, #wkplAdr, #wkplZipSearchBtn, #companyName, #wkplAdrDetail").prop('disabled', false);
				$("#wkplAdrDetail").prop("readonly", false);
				forAdress("work");
			}
		}
	});

	$(document).on("change", 'input[name="mrkgRcpmYn"]', function(){
		var msg = "[MyKia]\n" + moment().format("YYYY년 MM월 DD일") + " 광고성 정보 수신동의가 ";
		if($(this).val() == "Y"){
			msg += "처리되었습니다.";
		}else{
			msg += "거부되었습니다.";
		}
		
		MPopup.alert(msg);
	});
};

// 선호 차량조회 
var selectFavoritCar = function(){
	MNet.httpSendAsIs({
		path : inf.carmgmt.carVehicle.url,
		callback : selectFavoritCarCallBack
	});
};
var checkAll = function(flag){		
	if(flag == "all"){
		$("#homeDatas").prop('checked', true);
		$("#wkDatas").prop('checked', true);
		$("#homeDatas").prop('disabled', true);
		$("#wkDatas").prop('disabled', true);

		$("#wkplZipGuide").removeClass('none');
		$("#wkplZip").addClass('none');
		$("#companyName").val("");
		$("#wkplZipSearchBtn").val("");
		$("#wkplAdrDetail").val("");
		// $("#wkplAdrDetail").prop('disabled', true);
		$("#companyTelF").text("선택");
		$("#companyTelML").val("");
		$("#wkplZip").text("");
		$("#homeZipGuide").removeClass('none');
		$("#homeZip").addClass('none');
		$("#homeZipSearchBtn").val("");
		$("#homeAdrDetail").val("");
		// $("#homeAdrDetail").prop('disabled', true);
		$("#homeTelF").text("선택");
		$("#homeTelML").val("");
		$("#homeZip").text("");

		$("#wkplZipGuide").addClass("txtclr-g");
		$("#homeZipGuide").addClass("txtclr-g");
		$("#homeZip, #homeTelML, #homeTelF, #homeZipSearchBtn, #homeZipSearchBtn").prop('disabled', true);
		$("#wkplZip, #companyTelML, #companyTelF, #wkplAdr, #wkplZipSearchBtn, #companyName").prop('disabled', true);
	}else{

		$("#homeDatas").prop('disabled', false);
		$("#wkDatas").prop('disabled', false);

		$("#homeDatas").prop('checked', false);
		$("#wkDatas").prop('checked', false);
		
		$("#wkplZipGuide").removeClass("txtclr-g");
		$("#homeZipGuide").removeClass("txtclr-g");
		$("#homeZip, #homeTelML, #homeTelF, #homeZipSearchBtn, #homeZipSearchBtn").prop('disabled', false);
		$("#wkplZip, #companyTelML, #companyTelF, #wkplAdr, #wkplZipSearchBtn, #companyName").prop('disabled', false);
		forAdress("all");
	}
	
}
// 선호 차량조회 콜백	
var selectFavoritCarCallBack = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	var listArray = [{
		title : "차량선택",
		value : ""
	}];

	var list = receivedData.carVehicleListResDto;
	if(code = "200"){
		for(var i = 0 ; i < list.length ; i++){
			listArray.push({
					title : list[i].ccdNm,
					value : list[i].ccd
				});
		}

		PGV.carList = listArray;
		
		for(var i = 0 ; i < listArray.length ; i++){
			var obj = listArray[i];
			if(obj.title == PGV.myInfo.ccdNm){
				PGV.myCarSelect = i;
				return false;
			}
		}
	}else{
		MPopup.alert(msg);
		return false;
	}
}

// 사용자 정보 조회
var selectMyInfo = function(userId){
	MNet.httpSendAsIs({
		path : checkVerifyUrl(inf.setting.myInfo.url),
		sendData : {
			mbrId : userId
		},
		callback : selectMyInfoCallBack
	});
};

//사용자 정보 조회 콜백
var selectMyInfoCallBack = function(receivedData) {
	objectValueNullCheck(receivedData);//null 이면 공백으로 변경
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){ // 인증 성공시
		PGV.myInfo = receivedData;
		
		// PGV.myInfo.mbrNm = obj.mbrNm; // 사용자 이름
		// PGV.myInfo.mbrId = obj.mbrId; // 사용자 id
		// // 사용자 집주소
		// PGV.myInfo.homeAdr = obj.homeAdr; 
		// PGV.myInfo.homeDtlAdr = obj.homeDtlAdr;
		// PGV.myInfo.homeZip = obj.homeZip;
		
		// PGV.myInfo.homeTelNo = obj.homeTelNo; // 사용자 자택 번호
		// // 사용자 회사, 학교 주소
		// PGV.myInfo.wkplAdr = obj.wkplAdr;
		// PGV.myInfo.wkplDtlAdr = obj.wkplDtlAdr;
		// PGV.myInfo.wkplZip = obj.wkplZip;
		
		// PGV.myInfo.wkplTelNo = obj.wkplTelNo; // 사용자 회사, 학교 번호
		// PGV.myInfo.wkplNm = obj.wkplNm;  // 사용자 회사, 학교 이름
		// PGV.myInfo.hpno = obj.hpno; // 사용자 폰 번호
		// PGV.myInfo.emlAdr = obj.emlAdr; // 사용자 이메일
		// PGV.myInfo.itrstMdlBuyYmd = obj.itrstMdlBuyYmd; // 구매예정일
		// PGV.myInfo.ccdNm = obj.ccdNm; // 차량이름
		// PGV.myInfo.ccd = obj.ccd; // 차량 번호 
		// PGV.myInfo.emlRcpmYn = obj.emlRcpmYn; // 이메일 광고 동의 
		// PGV.myInfo.smsRcpmYn = obj.smsRcpmYn; // 문자 광고 동의
		// PGV.myInfo.dmRcpmYn = obj.dmRcpmYn; // dm 광고 동의
		// PGV.myInfo.tmRcpmYn = obj.tmRcpmYn; // 전화 광고 동의
		// PGV.myInfo.mrkgRcpmYn = obj.mrkgRcpmYn; // 마케팅 수신 동의
		// PGV.myInfo.pmatRcplGbnCcd = obj.pmatRcplGbnCcd; // 상품 수령 주소 선택
		
		myInfoSetView();
		selectFavoritCar();
	}else{
		MPopup.alert(msg);
		return false;
	} 
};

// var selectChkEmlOverlapApp = function(email){
// 	MNet.httpSendAsIs({
// 		path : inf.member.chkEmlOverlapApp.url,
// 		callback : chkEmlOverlapAppCallBack,
// 		sendData : {
// 			emlAdr : email
// 		}
// 	});
// }

// var chkEmlOverlapAppCallBack = function(receivedData){
// 	exWNHideIndicator();
// 	var code = receivedData.resultCode;
// 	var msg = receivedData.resultMsg;
	
// 	if(code == "200"){
// 		PGV.emailCheckFlag = "Y";		
// 		return false;
// 	}else if(code == "107"){		//이미 가입된 정보가 있습니다.
// 		MPopup.alert("이미 가입된 정보가 있습니다.")
// 	}else{
// 		MPopup.alert(msg);
// 		return false;
// 	}
// }

//사용자 정보 업데이트 추후 필드값 나오면 추가
var updateMyInfo = function(userId){
	if(PGV.myInfo.pmatRcplGbnCcd == "N"){
		PGV.myInfo.homeRefrAdr = "";
		PGV.myInfo.wkplRefrAdr = "";
	};

	if(isEmpty(PGV.myInfo.homeZip)){
		PGV.myInfo.homeAdr = "";
	};

	if(isEmpty(PGV.myInfo.wkplZip)){
		PGV.myInfo.wkplAdr = "";
	}

	var dataKeyArr = ["ccd", "emlAdr", "itrstMdlBuyYmd", "mbrId", "mrkgRcpmYn", "pmatRcplGbnCcd", "homeRdMgmtNo", "homeRefrAdr", "wkplRdMgmtNo", "wkplRefrAdr", "homeAdr", "homeDtlAdr", "homeTelNo", "homeZip", "wkplAdr", "wkplDtlAdr", "wkplZip", "wkplTelNo", "wkplNm", "emlRcpmYn", "smsRcpmYn", "dmRcpmYn", "tmRcpmYn"],
	sendData = new Object();
	for(var index in dataKeyArr){
		var key = dataKeyArr[index];
		sendData[key] = PGV.myInfo[key] || "";
	}
	MNet.httpSendAsIs({
		path : checkVerifyUrl(inf.setting.myInfoUpdate.url),
		sendData : sendData,
		callback : updateMyInfoCallBack
	});
};

//사용자 정보 업데이트 콜백
var updateMyInfoCallBack = function(receivedData) {
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){ // 인증 성공시
		exWNHideIndicator();
		//loginInfo에 수정된 정보 넣기
		for(var key in PGV.loginInfo){
			if(PGV.myInfo[key]){
				PGV.loginInfo[key] = PGV.myInfo[key]
			}
		}
		
		MData.global('loginInfo', PGV.loginInfo);

		if(PGV.baseBallData.baseBallYn == "Y" && PGV.myInfo.pmatRcplGbnCcd != "N" && baseBallChk()){
			
			// 야구 이벤트 참석 
			MNet.httpSendAsIs({
				path : inf.quiz.quizReg.url,
				sendData : {
					mbrId : PGV.loginInfo.mbrId,
					evtNo : PGV.baseBallData.baseEvtNo
				},
				callback : function(receivedData){
					exWNHideIndicator();
					if(receivedData.resultCode == "200"){
						customPopup.get('KIA_MOB_810_1080.html', $('#warningLayerPop'), function(item) {
							var screenHtml = $('<div></div>');
							screenHtml.append(item);
							$('body').append(screenHtml.find('#warningLayerPop'));
							
							// 확인 버튼 클릭 시
							$("#warningBtn").on("click", function(){
								customPopup.remove($("#warningLayerPop"));
								MPage.back({
									param : {baseBallQuizYn : "Y"}
								});
							});
							
						});
					}else{
						MPopup.instance(CONSTANT.NETWORK_ERR_MSG);
					}
				}
			});
		}else{
			MPopup.alert({
				message : "수정완료 되었습니다.",
				callback : function(){
					/* 비밀번호 입력 Stack 삭제 */
					// MPage.remove(PATH_MANAGER.KIA_RNW_0D3_1100.nameWithHtml);
					// M.page.remove(PATH_MANAGER.KIA_RNW_0D3_1100.nameWithHtml);
					COMMON_FUNCTION.TOOL.COMPAT.pageRemove(PATH_MANAGER.KIA_RNW_0D3_1100.name);
					MPage.back();
				}
			});
		}
	}else{
		MPopup.alert(msg);
		return false;
	} 
};

// 사용자 정보 입력
var myInfoSetView = function(){
	$("#inputName").text(PGV.myInfo.mbrNm);
	$("#inputId").text(PGV.myInfo.mbrId);

	var homeAdress = "";

	if(!isEmpty(PGV.myInfo.homeRefrAdr.split(',')[1])){
		homeAdress = PGV.myInfo.homeAdr + '('+PGV.myInfo.homeRefrAdr.split(',')[1].trim()+')';
	}else{
		homeAdress = PGV.myInfo.homeAdr;
	}

	//집 주소
	$("#homeZipSearchBtn").val(homeAdress || "");
	$("#homeAdrDetail").val(PGV.myInfo.homeDtlAdr || "");
	setZipText("home", PGV.myInfo.homeZip);

	//집 전화번호
	if(!isEmpty(PGV.myInfo.homeTelNo)){
		var homeTel = PGV.myInfo.homeTelNo;
		homeTel = String(extractNumber(homeTel)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
		$("#homeTelF").text(homeTel[0]);
		$("#homeTelML").val(homeTel[1]);
	}else{
		$("#homeTelF").text("선택");
		$("#homeTelML").val("");
	}
	
	//직장 이름
	$("#companyName").val(PGV.myInfo.wkplNm || "");
	 
	var wkAdress = "";

	if(!isEmpty(PGV.myInfo.wkplRefrAdr.split(',')[1])){
		wkAdress = PGV.myInfo.wkplAdr + '('+PGV.myInfo.wkplRefrAdr.split(',')[1].trim()+')';
	}else{
		wkAdress = PGV.myInfo.wkplAdr;
	}

	 //직장 주소
	$("#wkplZipSearchBtn").val(wkAdress|| "");
	$("#wkplAdrDetail").val(PGV.myInfo.wkplDtlAdr || "");
	setZipText("wkpl", PGV.myInfo.wkplZip);

	//직장 전화번호
	if(!isEmpty(PGV.myInfo.wkplTelNo)){
		var companyTel = PGV.myInfo.wkplTelNo;
		companyTel = String(extractNumber(companyTel)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
		$("#companyTelF").text(companyTel[0]);
		$("#companyTelML").val(companyTel[1]);
	}else{
		$("#companyTelF").text("선택");
		$("#companyTelML").val("");
	}


	/*//핸드폰 번호
	var phoneNo = PGV.myInfo.hpno || "";
	phoneNo = String(extractNumber(phoneNo)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1-$2-$3").split(",");
	//$("#telF").text(phoneNo[0]);
	//$("#telM").val(phoneNo[1]);
	//$("#telL").val(phoneNo[2]);
	//$("#phoneNo").val(phoneNo);
	$("#phoneNo").text(phoneNo);*/


 	// 이메일
	//var emailArr = PGV.myInfo.emlAdr.split("@");
	//$("#emailAdrF").val(emailArr[0] || "");
	//$("#emailAdrD").val(emailArr[1] || "");
	$("#emailAdr").val(PGV.myInfo.emlAdr || "");

	//희망 구매 차량	
	$("#choiceCar").text(PGV.myInfo.ccdNm || "차량선택");
	$("#choiceCar").data("value", PGV.myInfo.ccd);
	$("#buyY").text(PGV.myInfo.itrstMdlBuyYmd ? PGV.myInfo.itrstMdlBuyYmd.substring(0, 4) : "년");
	$("#buyM").text(PGV.myInfo.itrstMdlBuyYmd ? PGV.myInfo.itrstMdlBuyYmd.substring(4, 6) : "월");

	$("#buyY").data("value", PGV.myInfo.itrstMdlBuyYmd ? PGV.myInfo.itrstMdlBuyYmd.substring(0, 4) : "");
	$("#buyM").data("value", PGV.myInfo.itrstMdlBuyYmd ? PGV.myInfo.itrstMdlBuyYmd.substring(4, 6) : "");

	// 수신 동의 0-이메일 1- SMS 2- Dm 3- 전화
	if(PGV.myInfo.emlRcpmYn == "Y"){
		$("#sendCheck").find('input:checkbox').eq(0).prop("checked", true); 
	}
	if(PGV.myInfo.smsRcpmYn == "Y"){
		$("#sendCheck").find('input:checkbox').eq(1).prop("checked", true); 
	}
	if(PGV.myInfo.dmRcpmYn == "Y"){
		$("#sendCheck").find('input:checkbox').eq(2).prop("checked", true); 
	}
	if(PGV.myInfo.tmRcpmYn == "Y"){
		$("#sendCheck").find('input:checkbox').eq(3).prop("checked", true); 
	}

	// 상품 배송 선택
	$('input:radio[name="pmatRcplGbnc"]').filter('[value="'+(PGV.myInfo.pmatRcplGbnCcd || "N")+'"]').click();
	// $('div[name="addressWrap"]').filter('[data-type="'+PGV.myInfo.pmatRcplGbnCcd+'"]').removeClass("none");

	// 마케팅 수신 동의
	$('input:radio[name="mrkgRcpmYn"]').filter('[value="'+(PGV.myInfo.mrkgRcpmYn || "N")+'"]').attr('checked', true);	


	//구매 희망 년월 리스트 생성
	PGV.itrstMdlBuyYmdArray = new Array();
	var itrstMdlBuyYear = PGV.myInfo.itrstMdlBuyYmd.substring(0, 4),
	itrstMdlBuyMoneth = PGV.myInfo.itrstMdlBuyYmd.substring(4, 6);

	var buyYArray = [{
		title : "년",
		value : ""
	}];

	var buyMArray = [{
		title : "월",
		value : ""
	}];

	for(var i = 0 ; i < 12 ; i++){
		var year = moment().add(i, 'year').format('YYYY'),
		month = zeroPad(i+1, 2);

		if(year == itrstMdlBuyYear){
			PGV.buyYSelect = i+1;
		}

		buyYArray.push({
			title : year,
			value : year
		});

		if(month == itrstMdlBuyMoneth){
			PGV.buyMSelect = i+1;
		}

		buyMArray.push({
			title : month,
			value : month
		});
	}

	PGV.buyMArray = buyMArray;
	PGV.buyYArray = buyYArray;

	/* !!! 케이스마텍 추헌남 - 상세주소 입력칸 상황에 따라 비활성화 */
	var infoAvailibiltyCheck = $("#homeDatas, #wkDatas");
	for (var i = 0; i < infoAvailibiltyCheck.length; i++){
		var curNode = infoAvailibiltyCheck[i];
		switch(curNode.id){
			case "homeDatas":
				if($(curNode).prop("checked")){
					$("#homeAdrDetail").attr("readonly", true);
				}
				break;
			case "wkDatas":
				if($(curNode).prop("checked")){
					$("#wkplAdrDetail").attr("readonly", true);
				}
				break;
		}	
	}
};

// 사용자 정보 가져오기
var myInfoValidation = function(){
	//필수 값
	//var hpNo = $("#telF").text() + $("#telM").val() + $("#telL").val();
//	var hpNo = $("#phoneNo").val().replace(/-/gi,"");
//	if(isEmpty(hpNo) || !isCellPhone(hpNo)){
//		MPopup.alert("휴대폰번호를 정확히 입력해 주세요.");
//		return false;
//	}

	var emlAdr = $.trim($("#emailAdr").val()); // 이메일
	if(isEmpty(emlAdr) || !emailCheck(emlAdr)){
		MPopup.alert("이메일주소를 정확히 입력해 주세요.");
		return false;
	}

	//자택 전화번호 체크
	var homeTelNo = extractNumber($("#homeTelF").text() + $("#homeTelML").val()).replace(/-/gi, "");
	if(!isEmpty(homeTelNo) && !isBasicPhone(homeTelNo)){
		MPopup.alert("자택 전화번호를 정확히 입력해 주세요.");
		return false;
	}

	//직장/학교 전화번호 체크
	var companyTelNo = extractNumber($("#companyTelF").text() + $("#companyTelML").val().replace(/-/gi,""));
	if(!isEmpty(companyTelNo) && !isBasicPhone(companyTelNo)){
		MPopup.alert("직장/학교 전화번호를 정확히 입력해 주세요.");
		return false;
	}

	//구매예정일 체크
	// var itrstMdlBuyYmd = 0;
	// if(!isEmpty($("#buyY").data("value"))) itrstMdlBuyYmd++;
	// if(!isEmpty() itrstMdlBuyYmd++;

	if(!isEmpty($("#buyY").data("value")) && isEmpty($("#buyM").data("value"))){		//하나만 입력 한 경우
		MPopup.alert("구매예정일을 정확히 입력해 주세요.");
		return false;
	}

    /*var hpNo = $("#phoneNo").val().replace(/-/gi,"");
	PGV.myInfo.hpno = hpNo;			//전화번호*/
	PGV.myInfo.emlAdr = emlAdr; 	//이메일

	PGV.myInfo.wkplTelNo = companyTelNo;		//직장/학교 전화번호
	PGV.myInfo.homeTelNo = homeTelNo;	//자택 전화번호

	PGV.myInfo.itrstMdlBuyYmd = $("#buyY").data("value") + $("#buyM").data("value"); 		//구매예정일

	// if(PGV.emailCheckFlag == "N"){
	// 	MPopup.alert("추가 이메일 중복 체크를 해주세요.");
	// 	return false;
	// }

	PGV.myInfo.pmatRcplGbnCcd = $('input:radio[name="pmatRcplGbnc"]:checked').val() || "";

	PGV.myInfo.homeDtlAdr = $("#homeAdrDetail").val();		//자택 상세 주소
	

//	PGV.myInfo.homeZip = $("#homeZip").text(); 		//자택우편번호

	
	
	PGV.myInfo.wkplNm = $("#companyName").val();		//직장/학교명


	PGV.myInfo.wkplDtlAdr = $("#wkplAdrDetail").val();	//직장/학교 상세 주소
	
	//PGV.myInfo.wkplZip = $("#wkplZip").text();					//직장/학교  우편번호


	//선호차종
	if(!isEmpty($("#choiceCar").data("value"))){
		PGV.myInfo.ccdNm = $("#choiceCar").text();
		PGV.myInfo.ccd = $("#choiceCar").data("value");
	}else{
		PGV.myInfo.ccdNm = "";
		PGV.myInfo.ccd = "";
	}
	
	// 수신 동의 0-이메일 1- SMS 2- Dm 3- 전화
	if($("#sendCheck").find('input:checkbox').eq(0).prop("checked")){
		PGV.myInfo.emlRcpmYn = "Y" 
	}else{
		PGV.myInfo.emlRcpmYn = "N"
	}
	if($("#sendCheck").find('input:checkbox').eq(1).prop("checked")){
		PGV.myInfo.smsRcpmYn = "Y" 
	}else{
		PGV.myInfo.smsRcpmYn = "N"
	}
	if($("#sendCheck").find('input:checkbox').eq(2).prop("checked")){
		PGV.myInfo.dmRcpmYn = "Y" 
	}else{
		PGV.myInfo.dmRcpmYn = "N"
	}
	if($("#sendCheck").find('input:checkbox').eq(3).prop("checked")){
		PGV.myInfo.tmRcpmYn = "Y" 
	}else{
		PGV.myInfo.tmRcpmYn = "N"
	}
	
	// 기획 변경으로 인해 주석 처리 - CJD 2018.10.30
//	PGV.myInfo.mrkgRcpmYn = $('input:radio[name="mrkgRcpmYn"]:checked').val() || "";		//동의/미동의

	return true;
}

var setZipText = function(type, zip){
/*
	if(!isEmpty(zip)){
		$("#"+type+"Zip").text(zip);
		$("#"+type+"ZipGuide").addClass("none");
		$("#"+type+"Zip").removeClass("none");	
		// $("#"+type+"AdrDetail").prop('disabled', false);
		 $("#"+type+"AdrDetail").parent().removeClass('none');
	}else{
		$("#"+type+"ZipGuide").removeClass("none");
		$("#"+type+"Zip").addClass("none");	
		// $("#"+type+"AdrDetail").prop('disabled', true);
		$("#"+type+"AdrDetail").parent().addClass('none');
	}
	*/
}

var forAdress = function(flag){
	if(flag == "home"){
		//집 주소
		var homeAdress = "";

		if(!isEmpty(PGV.myInfo.homeRefrAdr.split(',')[1])){
			homeAdress = PGV.myInfo.homeAdr + '('+PGV.myInfo.homeRefrAdr.split(',')[1].trim()+')';
		}else{
			homeAdress = PGV.myInfo.homeAdr;
		}

		$("#homeZipSearchBtn").val(homeAdress || "");
		
		$("#homeAdrDetail").val(PGV.myInfo.homeDtlAdr || "");
		setZipText("home", PGV.myInfo.homeZip);

		//집 전화번호
		if(!isEmpty(PGV.myInfo.homeTelNo)){
			var homeTel = PGV.myInfo.homeTelNo;
			homeTel = String(extractNumber(homeTel)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
			$("#homeTelF").text(homeTel[0]);
			$("#homeTelML").val(homeTel[1]);
		}else{
			$("#homeTelF").text("선택");
			$("#homeTelML").val("");
		}
	}else if(flag == "work"){
		//직장 이름
		$("#companyName").val(PGV.myInfo.wkplNm || "");
		 
		 //직장 주소
		
		var wkAdress = "";

		if(!isEmpty(PGV.myInfo.wkplRefrAdr.split(',')[1])){
			wkAdress = PGV.myInfo.wkplAdr + '('+PGV.myInfo.wkplRefrAdr.split(',')[1].trim()+')';
		}else{
			wkAdress = PGV.myInfo.wkplAdr;
		}

		$("#wkplZipSearchBtn").val(wkAdress || "");

		$("#wkplAdrDetail").val(PGV.myInfo.wkplDtlAdr || "");
		setZipText("wkpl", PGV.myInfo.wkplZip);

		//직장 전화번호
		if(!isEmpty(PGV.myInfo.wkplTelNo)){
			var companyTel = PGV.myInfo.wkplTelNo;
			companyTel = String(extractNumber(companyTel)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
			$("#companyTelF").text(companyTel[0]);
			$("#companyTelML").val(companyTel[1]);
		}else{
			$("#companyTelF").text("선택");
			$("#companyTelML").val("");
		}
	}else{
		var homeAdress = "";
		if(!isEmpty(PGV.myInfo.homeRefrAdr.split(',')[1])){
			homeAdress = PGV.myInfo.homeAdr + '('+PGV.myInfo.homeRefrAdr.split(',')[1].trim()+')';
		}else{
			homeAdress = PGV.myInfo.homeAdr;
		}
		//집 주소
		$("#homeZipSearchBtn").val(homeAdress || "");
		
		$("#homeAdrDetail").val(PGV.myInfo.homeDtlAdr || "");
		setZipText("home", PGV.myInfo.homeZip);

		//집 전화번호
		if(!isEmpty(PGV.myInfo.homeTelNo)){
			var homeTel = PGV.myInfo.homeTelNo;
			homeTel = String(extractNumber(homeTel)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
			$("#homeTelF").text(homeTel[0]);
			$("#homeTelML").val(homeTel[1]);
		}else{
			$("#homeTelF").text("선택");
			$("#homeTelML").val("");
		}
		//직장 이름
		$("#companyName").val(PGV.myInfo.wkplNm || "");
		 
		var wkAdress = "";

		if(!isEmpty(PGV.myInfo.wkplRefrAdr.split(',')[1])){
			wkAdress = PGV.myInfo.wkplAdr + '('+PGV.myInfo.wkplRefrAdr.split(',')[1].trim()+')';
		}else{
			wkAdress = PGV.myInfo.wkplAdr;
		}

		$("#wkplZipSearchBtn").val(wkAdress || "");
		$("#wkplAdrDetail").val(PGV.myInfo.wkplDtlAdr || "");
		setZipText("wkpl", PGV.myInfo.wkplZip);

		//직장 전화번호
		if(!isEmpty(PGV.myInfo.wkplTelNo)){
			var companyTel = PGV.myInfo.wkplTelNo;
			companyTel = String(extractNumber(companyTel)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
			$("#companyTelF").text(companyTel[0]);
			$("#companyTelML").val(companyTel[1]);
		}else{
			$("#companyTelF").text("선택");
			$("#companyTelML").val("");
		}
	}
}

var baseBallChk = function(){
	 if(!isEmpty(PGV.myInfo.homeZip) || !isEmpty(PGV.myInfo.homeAdr) || !isEmpty(PGV.myInfo.wkplZip)|| !isEmpty(PGV.myInfo.wkplAdr)){
        return true;
    }else{
        return false;
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){
		var adressData = MData.param("zipInfo");
		if(isEmpty(adressData) || isEmpty(MData.param("searchType"))){
			return;
		}
		if(MData.param("searchType") == "homeZipSearchBtn"){
			PGV.myInfo.homeAdr = adressData.fullAddr;
			PGV.myInfo.homeRdMgmtNo = adressData.buildingCode;
			PGV.myInfo.homeRefrAdr = adressData.extraAddr;
			PGV.myInfo.homeZip = adressData.zoneCode;
			var homeAdress = "";

			if(!isEmpty(PGV.myInfo.homeRefrAdr.split(',')[1])){
				homeAdress = PGV.myInfo.homeAdr + '('+PGV.myInfo.homeRefrAdr.split(',')[1].trim()+')';
			}else{
				homeAdress = PGV.myInfo.homeAdr;
			}

			$("#homeZipSearchBtn").val(homeAdress || "");
			setZipText("home", PGV.myInfo.homeZip);
		}else{
			PGV.myInfo.wkplAdr = adressData.fullAddr;
			PGV.myInfo.wkplRdMgmtNo = adressData.buildingCode;
			PGV.myInfo.wkplRefrAdr = adressData.extraAddr;
			PGV.myInfo.wkplZip = adressData.zoneCode;
			
			var wkAdress = "";

			if(!isEmpty(PGV.myInfo.wkplRefrAdr.split(',')[1])){
				wkAdress = PGV.myInfo.wkplAdr + '('+PGV.myInfo.wkplRefrAdr.split(',')[1].trim()+')';
			}else{
				wkAdress = PGV.myInfo.wkplAdr;
			}
			$("#wkplZipSearchBtn").val(wkAdress || "");
			setZipText("wkpl", PGV.myInfo.wkplZip);
		}
	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};
