/**
 * @파일명 : KIA_RNW_0D3_1400.js
 * @작성자 : 이현석 / 케이스마텍 추헌남 수정
 * @생성일 : 2022.03.17
 * @메뉴명 : 탈퇴 전 본인 확인
 */
 var pageInit = function () {
	/**
	 * 초기화
	 */
	// TODO:PGV.loginInfo 에서 사용자 아이디 가져오기 현재는 테스트를 위해 hott2473@naver.com 계정사용
	var titleData = MData.param("moveNm");
	if (!isEmpty(titleData)) {
		$("#titleText").text(titleData);
	};

	PGV.moveUrl = MData.param("moveFlag");

	M.data.removeGlobal("page_title");
	//title 변경은 html 하단 script(속도 이슈)

	MData.removeParam("moveNm");
	MData.removeParam("moveFlag");
	$("#infoModifyCheckBtn").addClass("disabled");
	/**
	 * 화면 이벤트
	 */
	setEvent();
	//screenViewGa(gaSendUrl["KIA_MOB_810_1030"].pageNm); //2020 공통으로 변경
};


var setEvent = function () {
	$(document).on("keyup", "#userPw", function () {	//정보 인증 버튼 활성화
		var userPw = $("#userPw").val();
		var that = $("#infoModifyCheckBtn");

		var strSpace = /\s/;  // 공백체크
		if (strSpace.exec($("#userPw").val())) { //공백 체크
			$("#userPw").focus();
			$("#userPw").val($("#userPw").val().replaceAll(' ', '')); // 공백제거
			return false;
		}

		if ((!isEmpty(userPw)) && userPw.length > 7) {
			that.removeClass("disabled");
		} else {
			that.addClass("disabled");
		}
	});


	$(document).on("click", "#infoModifyCheckBtn", function () {	//정보수정
		var userId = PGV.loginInfo.mbrId;
		var userPw = $("#userPw").val();
		if (!emailCheck(userId)) {
			MPopup.alert('입력하신 아이디 또는 비밀번호가 일치하지 않습니다.');
			return false;
		} else if (!isEmpty(userPw) && userPw.length > 7) {

			// var regExpPwCheckStr = regExpPwCheck(userPw);	//2018.10.18 요건에 의한 특수문자 체크로직 추가
			// if(regExpPwCheckStr){	//특수문자 체크
			// 	if(regExpPwCheckStr === '\''){
			// 		regExpPwCheckStr = ' \' ';
			// 	}
			// 	MPopup.alert({
			// 		message : '고객님이 입력하신 특수문자\"'+regExpPwCheckStr+'\"는\n사용할 수 없습니다.\n사용 불가한 특수문자 : < > ( ) \' # & = ; : +',
			// 		callback : function() {
			// 			$("#userPw").val('');
			// 		}
			// 	});
			// 	return false;
			// }
			if (isUseVerifyUrl()) {
				MNet.httpSendAsIs({
					path: inf.member.verifyLogin.url,
					sendData: {
						mbrId: userId.toLowerCase(),
						pw: btoa(userPw)
					},
					callback: loginCallBack
				});
			} else {
				MNet.httpSendAsIs({
					path: inf.member.login.url,
					sendData: {
						mbrId: userId.toLowerCase(),
						pw: userPw
					},
					callback: loginCallBack
				});
			}
			return false;
		} else {
			MPopup.alert('입력하신 아이디 또는 비밀번호가 일치하지 않습니다.');
			return false;
		}
	});
}

//인증 콜백
var loginCallBack = function (receivedData) {
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	var pwflag = receivedData.pwStCcd;
	var userPw = $("#userPw").val();

	if (code == "200" && !isEmpty(receivedData.accessToken)) { // 인증 성공시
		// 비밀번호 5회 틀렸을시 
		// if(pwflag == "2"){
		// 	$("#userPw").val("");
		// 	$("#infoModifyCheckBtn").prop('disabled', true);
		// 	wrongPw("로그인 비밀번호 5회 오류 입니다.");
		// 	return;
		// };
		if (PGV.moveUrl == "web") {
			$("#userPw").val("");
			var _url = CONSTANT.LINK_URL.KIA_MOB_810_1040.URL;
			if (CONSTANT.IS_CCSP) {
				_url = CONSTANT.LINK_URL.KIA_MOB_810_1041.URL;
			}
			MPage.activity({
				className: "WebviewActivity",
				// actionType: "CLEAR_TOP",
				param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.POST, _url, {
					mbrId: PGV.loginInfo.mbrId,
					mbrNm: PGV.loginInfo.mbrNm
				})
			});
			return;
		} else {
			var animate = '';
			if (PGV.moveUrl.includes('KIA_MOB_810_1031')) {
				animate = "MODAL_UP";
			}
			$("#userPw").val("");
			$("#infoModifyCheckBtn").addClass("disabled");
			MPage.html({
				url: PGV.moveUrl,
				param: {
					userPw: PGV.loginInfo.mbrId//$("#userId").val()
				},
				animate: animate
			});
			return;
		};

		// }else if(code == "102"){
		// 	MPopup.alert(msg);
		// 	$("#userPw").val("");
		// 	$("#infoModifyCheckBtn").prop('disabled', true);
		// 	$("#userPw").focus();
		// }else if(code == "108"){ // 로그인 비밀번호 5회 오류입니다.
		// 	$("#userPw").val("");
		// 	$("#infoModifyCheckBtn").prop('disabled', true);
		// 	wrongPw(msg);
		// 	return false;
		// }else if(code == "106"){ // 통합회원 가입상태 추가정보 등록
		// 	$("#userPw").val("");
		// 	$("#infoModifyCheckBtn").prop('disabled', true);
		// 	MPopup.alert({
		// 		message : msg,
		// 		buttons : ["취소", "가입하기"],
		// 		callback : function(index){
		// 			if(index == 1){
		// 				// TODO : URL 및 보내는 데이터 세팅
		// 				var _url = CONSTANT.LINK_URL.KIA_MOB_810_1045.URL;
		// 				MPage.activity({
		// 					className : "WebviewActivity",
		// 					param : {
		// 						method : CONSTANT.NET_MTHD.POST,
		// 						requestURL : _url,
		// 						postData : {
		// 							mbrId : receivedData.mbrId,
		// 							ccspId : receivedData.ccspId,
		// 							mbrPw : userPw
		// 						}
		// 					}
		// 				});
		// 			}else{
		// 				return false;
		// 			}
		// 		}
		// 	});
		// 	return false;
	} else {
		$("#userPw").val("");
		$("#infoModifyCheckBtn").addClass("disabled");
		MPopup.alert(msg);
		return false;
	}
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady: function (event) {
		pageInit();
	},

	onHide: function (event) {

	},

	onRestore: function (event) {

	},

	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
	//	onBack : function(){
	//
	//	},

	onDestroy: function (event) {

	},

	onPause: function (event) {

	},

	onResume: function (event) {

	}
};
