/**
 * @파일명 : KIA_MOB_000_1124.js
 * @작성자 : 최정동
 * @생성일 : 2018. 8. 24. 오전 11:55:47
 * @메뉴명 : 현대 M 포인트 개인정보 제공동의 팝업
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	
	// 이전 화면이 M포인트 메뉴 화면인 경우와 메인 화면인지 구분하기 위한 flag 값 세팅
	PGV.prevPage = isEmpty(MData.param("prevPage")) == false ? MData.param("prevPage") : "";
	MData.removeParam("prevPage");
	
	if(PGV.prevPage != ""){
		$(document).off("click", ".btn-close");
	}
	// screenViewGa(gaSendUrl["KIA_MOB_000_1124"].pageNm); //2020 공통으로 변경
	/**
	 * 화면 이벤트
	 */
	setEvent();
	
	
};

var setEvent = function() {
	// 닫기 버튼 클릭시
	$(document).on("click", "#cancelBtn", function(){
		if(PGV.prevPage != ""){
			MPopup.confirm({
				message : "M포인트는 개인정보 제공동의를 해 주셔야만 조회가 가능합니다. 동의처리가 되지 않아 이전 화면으로 이동합니다.",
				callback : function(idx){
					if(idx == 1){
						stackRemove(PGV.prevPage);
						setTimeout(function(){
							MPage.back();
						}, 300);
					}
				}
			});
		}else{
			$(".btn-close").trigger("click");
		}
	});
	
	// 동의하기 버튼 클릭 시
	$(document).on("click", "#agreeBtn", function(){
		if($("#agreeChk").prop("checked") == false){		// 개인정보 제공동의 체크하지 않은 경우
			MPopup.alert("M포인트는 개인정보 제공동의를 해 주셔야만 조회가 가능합니다.\n조회를 원하신다면 개인정보 제공동의를 체크 해 주세요.");
		}else{
			insertIndividualInfo();
		}
	});
	
	// 전체보기 버튼 클릭 시
	$(document).on("click", "#infoViewBtn", function(){
		MPage.html({
			url : PATH_MANAGER.KIA_RNW_0D3_1510.path,
			animate : "MODAL_UP"
		});
	});
};

/**
 * 현대M포인트 약관 동의 업데이트 전문
 */
var insertIndividualInfo = function(){
	MNet.httpSendAsIs({
		path : inf.terms.updateMpointTerms.url,
		sendData : {
			agrYn : "Y",
			mbrId : PGV.loginInfo.mbrId,
			termsItmCd : "107",		// 107 : M 포인트 약관
			termsKndCcd : "104"		// 104 : M 포인트
		},
		callback : insertIndividualInfoCallback
	});
};


/**
 * 현대M포인트 약관 동의 업데이트 콜백
 */
var insertIndividualInfoCallback = function(receivedData){
	exWNHideIndicator();	
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;

	if(code == "200"){
		if(MData.param("poinYn") == "Y"){
			MPage.html({
				url : "../520/KIA_MOB_520_1020.html",
				animate : "MODAL_DOWN"
			});
		}else{
			MPage.back({
				animate : "MODAL_DOWN",
				param : {
					mPointIndividualInfoSave : "Y"
				}
			});
		}
	}else{
		MPopup.alert(msg);
	}
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};