/**

 @파일명 : KIA_RNW_0D3_1820.js
 @작성자 : 케이스마텍 박영수
 @생성일 : 2022.11.15
 @메뉴명 : AOD 약관 동의 철회
 @DESC : 권한 확인 중
 */
var CurrPage;
var KIA_RNW_0D3_1820 = {
    hasKiaMembersCards: false,
    init: function () {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        CurrPage.getTaaSStatus().then(function (response) {
           if(!isEmpty(response.agreeDate)){
               var yearDate = response.agreeDate.substring(0,4);
               var monthDate = response.agreeDate.substring(4,6);
               var dayDate = response.agreeDate.substring(6,8);
               var date = "동의일 : "+yearDate+"년 "+monthDate+"월 "+dayDate+"일";
               $('#agreeDt').text(date);
           }
        });
        CurrPage.setEventListner();
    },
    notiSetting: null,
    setEventListner: function () {
        $('#serviceStop').on('click', function (e) {
            var popFunc = function (item) {

                var popId = "#popup_0D3_1830";
                if ($(popId).length < 1) {
                    var screenHtml = $("<div></div>");
                    screenHtml.append(item);
                    $('body').append(screenHtml.find(popId));
                }

                RNW_UI.popupLayer({selId: popId});
                $(".js-popup-close-btn").click(function () {
                    $("#popup_0D3_1830").remove();
                });
                $(".btn-primary").click(function () {
                    $("#popup_0D3_1830").remove();
                    CurrPage.endPopupOpen();
                });
            };
            $.get(PATH_MANAGER.KIA_RNW_0D3_1830.path, popFunc);
        });
    },
    endPopupOpen: function () {
        var getCurrentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
        MNet.httpSendAsync({
            path: _API.SVR.HOME.carinfo.TaaSAgreeYnReg,
            indicatorYn: "N",
            isMock: false,
            sendData: {
                apiId: "RNW-HOM-8002",
                mbrId: PGV.loginInfo.mbrId,
                vin: getCurrentScopeSelectCar.vin,
                agreeYn: "N"
            }
        })
            .then(
                function (response) {
                    if (response.resultCode == "200") {
                        var popFunc = function (item) {
                            var popId = "#popup_0D3_1840";
                            var lastNum = item.indexOf("endDt");
                            lastNum = lastNum + 7;
                            var frontItem = item.substring(0, lastNum);
                            var backItem = item.substring(lastNum);
                            var toDate = moment().format("(YYYY년 MM월 DD일)");

                            item = frontItem + toDate + backItem;
                            if ($(popId).length < 1) {
                                var screenHtml = $("<div></div>");
                                screenHtml.append(item);
                                $('body').append(screenHtml.find(popId));
                            }

                            RNW_UI.popupLayer({selId: popId});
                            $(".btn-primary").click(function () {
                                $("#popup_0D3_1840").remove();
                                MData.global("taasYn","taasN");
                                MPage.back();
                            });
                        };
                        $.get(PATH_MANAGER.KIA_RNW_0D3_1840.path, popFunc);
                    }else{
                        MPopup.alert(response.resultMsg);
                        return;
                    }
                });
    },
    getTaaSStatus: function(){
        var getCurrentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
        return new Promise(function(resolve){
            MNet.httpSendAsyncAsIs({
                path: _API.SVR.HOME.carinfo.TaaSOdometerNbattery,
                sendData: {
                    apiId : "RNW-HOM-8001",
                    mbrId : PGV.loginInfo.mbrId,
                    vin: getCurrentScopeSelectCar.vin
                },
                indicatorYn : "N"
            })
                .then(function(response){
                    if (response.resultCode == "200") {
                        resolve({
                            agreeDate: response.agreeDate,
                            isCode: response.resultCode,
                            isMsg: response.resultMsg
                        });
                    }
                    else{
                        resolve({
                            isCode: response.resultCode,
                            isMsg: response.resultMsg
                        });
                    }
                });
        })
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_0D3_1820.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {

    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    onBack : function(){MPage.back()},
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
};
