/**
 * @파일명 : KIA_MOB_520_1000.js / 리뉴얼 - KIA_RNW_0D3_2000.js
 * @작성자 : 최정동 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2022-03-25
 * @메뉴명 : 내카드/포인트
 */
var pageInit = function () {
    /**
     * 초기화
     */
    $("#cardWrap").addClass("none");
    $("#noMemberWrap").addClass("none");
    $("#pointWrap").addClass("none");


    // 소멸예정내역 기간 코드
    PGV.extinctExpectDateDivArr = [
        { title: moment().format("YYYY년"), value: moment().format("YYYY") },
        { title: moment().add(1, 'years').format("YYYY년"), value: moment().add(1, 'years').format("YYYY") }
    ];
    $("#extinctSelectBtn").html(moment().format("YYYY년"));
    // screenViewGa(gaSendUrl["KIA_MOB_520_1000"].pageNm); //2020 공통으로 변경

    checkRedMemberJoinWithPoint();

    /**
     * 화면 이벤트
     */
    setEvent();
};

var setEvent = function () {
    // 멤버십 가입하기 버튼 클릭 시
    $(document).on("click", "img.membercard, #membershipJoinBtn", function () {
        if($("#cardNoWrap").hasClass("none")) return;
        var _url = CONSTANT.LINK_URL.KIA_RNW_0D2_3000.URL;
        MPage.activity({
            className: "WebviewActivity",
            param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.POST, _url, {
                mbrId: PGV.loginInfo.mbrId
            })
        });
    });

    // 카드재발급 신청 버튼 클릭 시
    $(document).on("click", "[name='cardReissueBtn']", function () {
        MPage.html({
            url: PATH_MANAGER.KIA_RNW_0D3_2200.path,
            param: {
                cardNumber : $(this).data("card-number")
            }
        });
    });

    // 카드비밀번호 등록/수정 버튼 클릭 시
    $(document).on("click", "[name='cardPwUpdateBtn']", function () {
        var _url = CONSTANT.RED_URL_PREFIX + "kr/kmnb/isMbrCrdPwChk.do";
        MPage.activity({
            className: "WebviewActivity",
            param : {
                method : CONSTANT.NET_MTHD.POST,
                requestURL : _url,
                postData: makeKiaRedPostData(_url)
            }
        });
    });

    $("#redPointBtn").off("click").on("click", function () {
        MPage.html({
            url: PATH_MANAGER.KIA_RNW_0D3_2410.path,
            animate: "MODAL_UP"
        });
    });

    $("#mPointBtn").off("click").on("click", function () {
        MPage.html({
            url: PATH_MANAGER.KIA_RNW_0D3_2500.path,
            animate: "MODAL_UP"
        });
    });
};

/**
 * 기아멤버스 오프라인 회원 가입여부 체크
 */
var checkRedMemberJoinWithPoint = function () {
    MNet.httpSendAsIs({
        path: inf.point.extFlcMilg.url,
        sendData: {
            csetIfTypeCd: "04",
            csetIfValue: PGV.loginInfo.csmrMgmtNo
        },
        callback: checkRedMemberJoinWithPointCallback
    });
};

/**
 * 기아멤버스 오프라인 회원 가입여부 체크 콜백
 */
var checkRedMemberJoinWithPointCallback = function (receivedData) {
    // code 값에 따라 분기처리
    var code = receivedData.resultCode;
    exWNHideIndicator();
    $("#pointWrap").removeClass("none");
    if (code == "200") {
        $("#redPointWrap").removeClass("none");
        $("#redPoint").html(receivedData.redPoint !== "0" ? comma.add(receivedData.redPoint): "0");			// 사용가능 포인트
        $("#exntRedPoint").html(receivedData.exntMilgAmt !== "0" ? comma.add(receivedData.exntMilgAmt) : "0");	// 소멸예정 포인트(향후1년간)
        // 정상응답인 경우  멤버스 카드 조회, Mpoint 조회 실시
        checkRedMemberCard();

    } else {
        $("#redPointWrap").addClass("none");
        // 정상 아닌경우 cardlist가 0이였을때 표출하는 값
        // exWNHideIndicator();
        $("#cardWrap").addClass("none");
        $("#pointWrap").addClass("none");
        $("#noMemberWrap").removeClass("none");
    }
};


/**
 * 기아멤버스 오프라인 회원 카드 보유 여부 체크
 */
var checkRedMemberCard = function () {
    MNet.httpSendAsIs({
        path: checkVerifyUrl(inf.card.cardList.url),
        sendData: {
            csetIfTypeCd: "04",						// 승인 IF 구분코드 (01:카드번호, 02:CI, 03:회원고유번호, 04:고객관리번호) 04로 고정!! 08/22 -lhs
            csetIfValue: PGV.loginInfo.csmrMgmtNo			// 02:ci
        },
        callback: checkRedMemberCardCallback
    });
};

/**
 * 기아멤버스 오프라인 회원 여부 체크 콜백
 */
var checkRedMemberCardCallback = function (receivedData) {
    /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
    COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(receivedData);

    if (receivedData.resultCode == "200" && receivedData.cardListResDto.length > 0) {
        selectMpoint();
        setCardBarcodeList(receivedData.cardListResDto);
    } else {
        exWNHideIndicator();
        $("#cardWrap").addClass("none");
        $("#noCardWrap").removeClass("none");
    }
};

/**
 * 카드 목록 및 바코드 세팅
 */
var setCardBarcodeList = function (list) {
    if (isEmpty(list)) {
        $("#cardWrap").addClass("none");
        $("#pointWrap").addClass("none");
        $("#noMemberWrap").removeClass("none");
    } else {
        $("#cardWrap").removeClass("none");
        $("#noMemberWrap").addClass("none");
        var strBuff = '';
        for (var i = 0; i < list.length; i++) {
            strBuff += '<div class="swiper-slide">';
            strBuff += '    <div class="point-wrapbx">';
            strBuff += '        <div class="point-top">';
            strBuff += '            <div class="pimg-box">';
            strBuff += '                <img class="membercard" src="' + list[i].cardImgUrl + '" alt="' + list[i].crdKind + '">';
            strBuff += '            </div>';
            strBuff += '            <p class="sub-tit3" id="nameText">' + list[i].crdKind + '</p>';
            strBuff += '            <ul class="point-link">';
            strBuff += '                <li><button type="button" name="cardReissueBtn" data-card-number="' + list[i].milgMbrNo + '">카드 재발급</button></li>';
            strBuff += '                <li><button type="button" name="cardPwUpdateBtn">비밀번호 관리</button></li>';
            strBuff += '            </ul>';
            strBuff += '        </div>';
            strBuff += '        <div class="point-middle"></div>';
            strBuff += '            <div class="point-bottom">';
            strBuff += '                <div class="barcodewrap" data-barcode-num="' + list[i].milgMbrNo + '">';
            strBuff += '                    <div id="barcodeimg"></div>';
            strBuff += '                </div>';
            strBuff += '            </div>';
            strBuff += '        </div>';
            strBuff += '    </div>';
            strBuff += '</div>';
        }

        $("#cardSwiperWrap").html(strBuff);

        setBarcodes();
    }
};

var setBarcodes = function () {
    // 바코드 생성
    var barHeight = 80;
    var barCodeSettings = {
        bgColor: "#FFFFFF",
        barWidth: 4, // 5
        barHeight: barHeight,
        moduleSize: "3",
        fontSize: "13",
        marginHRI: barHeight,
        addQuietZone: "1"
    };

    var barcodeEl = $("[data-barcode-num]");

    for (var i = 0; i < barcodeEl.length; i++) {
        var barcodeNum = $(barcodeEl).eq(i).attr("data-barcode-num");
        $(barcodeEl).eq(i).barcode(barcodeNum, "code128", barCodeSettings);
    }

    if (barcodeEl.length > 1) {
        if (PGV.cardSwiper != null) {
            PGV.cardSwiper.destroy();
        }
        PGV.cardSwiper = new Swiper('.point-box .swiper-container', {
            loop: false,
            pagination: {
                el: '.point-box .swiper-pagination',
                clickable: true,
                dynamicBullets:true, // 20220530//(Ina)dynamicBullets 옵션추가
                dynamicMainBullets:8  // 20220530//(Ina)dynamicMainBullets 옵션추가                
            },
            autoplay: false,
            watchOverflow: true, //1page 인 경우 dot 미표출
        });
    }
};

/**
 * 기아멤버스 포인트 조회
 */
var selectRedPoint = function () {
    MNet.httpSendAsIs({
        path: inf.point.extFlcMilg.url,
        sendData: {
            csetIfTypeCd: "04",
            csetIfValue: PGV.loginInfo.csmrMgmtNo
        },
        callback: selectRedPointCallback
    });
};

/**
 * 기아멤버스 포인트 조회 콜백
 */
var selectRedPointCallback = function (receivedData) {
    var code = receivedData.resultCode;
    var msg = receivedData.resultMsg;
    exWNHideIndicator();
    $("#pointWrap").removeClass("none");
    if (code == "200") {
        $("#redPointWrap").removeClass("none");
        $("#redPoint").html(receivedData.redPoint !== "0" ? comma.add(receivedData.redPoint): "0");			// 사용가능 포인트
        $("#exntRedPoint").html(receivedData.exntMilgAmt !== "0" ? comma.add(receivedData.exntMilgAmt) : "0");	// 소멸예정 포인트(향후1년간)
    } else {
        $("#redPointWrap").addClass("none");
    }
};

var selectMpoint = function () {
    console.log("throwing : ", {
        ci: PGV.loginInfo.ci,					// ci
        mbrId: PGV.loginInfo.mbrId				// 로그인 아이디
    })
    MNet.httpSendAsIs({
        path: inf.hyundai.selectMpoint.url,
        sendData: {
            ci: PGV.loginInfo.ci,					// ci
            mbrId: PGV.loginInfo.mbrId				// 로그인 아이디
        },
        callback: selectMpointCallback
    });
};

/**
 * M포인트 신용회원여부, 약관동의여부 체크 및 M포인트 정보 조회 콜백
 */
var selectMpointCallback = function (receivedData) {
    console.log(receivedData)
    exWNHideIndicator();
    var code = receivedData.resultCode;
    var msg = receivedData.resultMsg;

    $("#pointWrap").removeClass("none");

    if (code == "200") {
        if (receivedData.rsltCd == "0000") {			// 신용회원인 경우
            //PGV.mPointInfo = receivedData;
            if (receivedData.mPointAgreeYn == "Y") {		// 약관 동의가 되어 있는 경우
                $("#mPointWrap").removeClass("none");
                $("#mPoint").text(comma.add(receivedData.prsnRemPnt));
                var extinctMPointText = comma.add(receivedData.prsnExtcPnt);
                extinctMPointText = extinctMPointText && extinctMPointText.toString().trim();
                extinctMPointText = extinctMPointText.length > 0 ? extinctMPointText : "0";
                $("#exntMPoint").text(extinctMPointText);
                return;
            }
        }
    }
    $("#mPointWrap").addClass("none");
    $("#mPoint").text("-");
    $("#exntMPoint").text("-");
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        pageInit();
    },

    onHide: function (event) {

    },

    onRestore: function (event) {
        if (MData.param("joinRedMembership") == "Y") {
            MData.removeParam("joinRedMembership");
            checkRedMemberJoinWithPoint();
        }

        // 210824 KIAVIK-821 발급 & 재발급 신청 변수 확인
        // Y라면 카드목록 갱신
        var isChanged = MData.global('REISSUE');
        if (isChanged == "Y") {
            checkRedMemberJoinWithPoint();
        }

    },

    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    //	onBack : function(){
    //
    //	},

    onDestroy: function (event) {

    },

    onPause: function (event) {

    },

    onResume: function (event) {

    }
};
