/**
 * @파일명 : KIA_MOB_520_1110.js
 * @작성자 : 최정동
 * @생성일 : 2018. 9. 28. 오전 11:06:45
 * @메뉴명 : 보유카드 > 카드재발급/카드교체발급
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */	
	
	/**
	 * 화면 이벤트
	 */
	setEvent();
	// screenViewGa(gaSendUrl["KIA_MOB_520_1110"].pageNm); //2020 공통으로 변경
};

var setEvent =function() {
	// 카드재발급/카드교체발급 탭 클릭 시
	$(document).on("click", "#cardIssueWrap > li > button", function(){
		$("#cardIssueWrap > li").removeClass("on");
		$(this).parent().addClass("on");
		
		if($("#cardIssueWrap > li").eq(0).hasClass("on")){
			screenViewGa(gaSendUrl["KIA_MOB_520_1110"].pageNm); 
			$("#cardReIssueWrap").removeClass("none");
			$("#cardChangeIssueWrap").addClass("none");
		}else{
			screenViewGa(gaSendUrl["KIA_MOB_520_1120"].pageNm); 
			$("#cardReIssueWrap").addClass("none");
			$("#cardChangeIssueWrap").removeClass("none");
		}
	});
	
	// 카드재발급 버튼 클릭 시
	$(document).on("click", "#reIssueBtn", function(){
		MNet.httpSendAsIs({
			path : checkVerifyUrl(inf.card.pssblReIssueList.url),
			sendData : {
				csetIfTypeCd : "04",
				csetIfValue : PGV.loginInfo.csmrMgmtNo
			},
			callback : function(receivedData){
				exWNHideIndicator();
				
				var code = receivedData.resultCode;
				var msg = receivedData.resultMsg;
				var cardList = receivedData.cardPssblReIssueListResDto || [];
				
				if(code == "200" && cardList.length > 0){
					var curCardIndex = _.findIndex(cardList, function(element){return element.milgMbrNoDec === MData.param("cardNumber")});
					curCardIndex = curCardIndex !== -1 ? curCardIndex : 0;
					MPage.html({
						url : PATH_MANAGER.KIA_RNW_0D3_2210.path,
						param : {
							cardList : cardList,
							currentSelectedCardIndex: curCardIndex
						}
					});
				}else{
					MPopup.alert("재발급 신청이 가능한 카드가 없습니다. 기아멤버스 카드를 보유하였으나, 재발급 신청이 되지 않는 경우, 고객센터 080-200-2000으로 연락해 주세요.");
				}
				
			}
		});
		
	});
	
	// 카드교체발급 버튼 클릭 시
	$(document).on("click", "#changeIssueBtn", function(){
		MNet.httpSendAsIs({
			path : checkVerifyUrl(inf.card.pssblExchngList.url),
			sendData : {
				csetIfTypeCd : "04",
				csetIfValue : PGV.loginInfo.csmrMgmtNo
			},
			callback : function(receivedData){
				exWNHideIndicator();
				
				var code = receivedData.resultCode;
				var msg = receivedData.resultMsg;
				var cardList = receivedData.cardExchngListResDto || [];
				var chngCardList = receivedData.cardPrmnCarListResDto || [];
				
				if(code == "200" && cardList.length > 0 && chngCardList.length > 0){
					MPage.html({
						url : PATH_MANAGER.KIA_RNW_0D3_2220.path,
						param : {
							cardList : cardList,
							chngCardList : chngCardList,
							cardNumber: MData.param("cardNumber")
						}
					});
				}else{
					MPopup.alert("교체 신청이 가능한 카드가 없습니다.  기아멤버스 카드를 보유하였으나, 교체발급 신청이 되지 않는 경우, 고객센터 080-200-2000으로 연락해 주세요.");
				}
			}
		});
		
		
	});
	
	// 현대카드 바로가기 버튼 클릭 시
	$(document).on("click", "#hyundaiCardBtn", function(){
		var _url = "https://www.hyundaicard.com/";
		MPage.activity({
			className : "WebviewActivity",
			param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, _url)
		});
	});
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};
