/**
 * @파일명 : KIA_MOB_520_1111.js
 * @작성자 : 이현석
 * @생성일 : 2018. 10. 1. 오후 3:41:55
 * @메뉴명 : 카드 재발급 신청
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */	
	PGV.myInfo = null;							// 개인 정보
	PGV.cardList = MData.param("cardList");		// 카드 목록 정보
	PGV.currentSelectedCardIndex = MData.param("currentSelectedCardIndex"); // 전전 페이지에서 선택한 카드 리스트 index
	
	// 재발급 사유 코드
	PGV.cardIssueReasonArr = [
		{title : "정지", value : "20"},
		{title : "정지(차량매각)", value : "21"},
		{title : "정지(분실)", value : "22"},
		{title : "정지(도난)", value : "23"},
		{title : "정지(파손)", value : "24"},
		{title : "정지(타인사용)", value : "25"},
		{title : "정지(유효기간만료)", value : "26"},
		{title : "정지(카드반송)", value : "27"},
		{title : "정지(회원정지)", value : "28"},
		{title : "정지(발급취소)", value : "29"},
		{title : "정지(미수령)", value : "2A"},
		{title : "정지(주소상이)", value : "2B"},
		{title : "정지(개명)", value : "2C"},
		{title : "정지(법인담당자변경)", value : "2D"},
		{title : "정지(제작오류))", value : "2E"}
	];
	
	$("#mbrNm").text(PGV.loginInfo.mbrNm);		// 이름
	$("#mbrId").text(PGV.loginInfo.mbrId);		// 아이디
	
	// 재발급 사유
	$("#reIssueReasonSelectBtn").val(PGV.cardIssueReasonArr[0].title);
	$("#reIssueReasonSelectBtn").attr("data-select-idx", "0");

	// 사용자 정보 조회
	selectMyInfo();

	// 사용자 카드 목록 세팅
	setCardList();

	// 카드 발급 종류 세팅
	setCardIssueType();

	/**
	 * 화면 이벤트
	 */
	setEvent();
	// screenViewGa(gaSendUrl["KIA_MOB_520_1111"].pageNm);//2020 공통으로 변경
};

var setEvent =function() {

	// 휴대폰 번호 앞자리 
	$(document).on("click", "#telF", function(){
		mobFirstPopUp($(this));
	});
	
	// 주소 팝업 클릭 시
	$(document).on("click", "#homeAdr", function(){
		var param = {
			searchType : $(this).attr("id")
		};

		MPage.html({
			url : PATH_MANAGER.KIA_RNW_0D3_1310.path,
			animate : 'MODAL_UP',
			param : param
		});
	});
	
	// 재발급 사유 버튼 클릭 시
	$(document).on("click", "#reIssueReasonSelectBtn", function(){
		var $this = $(this);
		MPopup.listSingle({
			list : PGV.cardIssueReasonArr,
			title : "재발급 사유",
			selected : $this.attr("data-select-idx")
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				$("#reIssueReasonSelectBtn").html(rowInfo.title);
				$("#reIssueReasonSelectBtn").attr("data-select-idx", rowInfo.index);
			}
		});
	});
	
	// 취소 버튼 클릭 시
	$("#cancelBtn").on("click", function(){
		MPopup.confirm({
			message : "재발급 신청을 취소하시겠습니까?",
			callback : function(idx){
				if(idx == 1){ // 로그인 눌렀을때
					MPage.back();
				}
			}
		});
	});
	
	// 신청 완료 버튼 클릭 시
	$("#completeBtn").on("click", function(){
		// 휴대폰 번호 체크
		var hpNo = $("#telF").text() + ($("#telML").val()).replace(/-/gi, "");
		if(isEmpty(hpNo) || !isCellPhone(hpNo)){
			MPopup.alert("휴대폰번호를 정확히 입력해 주세요."); 
			return;
		}
		
		// 주소 체크
		if(isEmpty(PGV.myInfo.homeAdr) || isEmpty($("#homeAdrDetail").val().trim())){
			MPopup.alert("주소를 입력하세요.");
			return;
		}
		
		// 발급 종류 체크
		if(isEmpty($("input[name='alpCrdKCd']:checked").val())){
			MPopup.alert("카드발급종류를 선택해 주세요.");
			return;
		}
		
		insertCardReIssue();
	});

    $(document).on("keyup", "#telML", function() {
        $(this).val( $(this).val().replace(/[^0-9]/g, "").replace(/(^[0-9]{3}|^[0-9]{4})([0-9]{4})$/,"$1-$2").replace("--", "-") );
    });
};

/**
 * 사용자 정보 조회
 */
var selectMyInfo = function(){
	MNet.httpSendAsIs({
		path : checkVerifyUrl(inf.setting.myInfo.url),
		sendData : {
			mbrId : PGV.loginInfo.mbrId
		},
		callback : selectMyInfoCallBack
	});
};

/**
 * 사용자 정보 조회 콜백
 */
var selectMyInfoCallBack = function(receivedData) {
	exWNHideIndicator();
	
	objectValueNullCheck(receivedData);//null 이면 공백으로 변경
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	
	if(code == "200"){
		PGV.myInfo = receivedData;
		
//		// 사용자 카드 목록 조회
//		selectCardList();
		
		// 사용자 정보 세팅
		myInfoSetView();
	}else{
		exWNHideIndicator();
		MPopup.alert(msg);
		return false;
	}
};

/**
 * 카드 리스트 세팅
 */
var setCardList = function(){
	for(var i=0; i<PGV.cardList.length; i++){
		var milgMbrNoDec = PGV.cardList[i].milgMbrNoDec;
		var milgMbrNo = PGV.cardList[i].milgMbrNo;
		if(PGV.cardList[i].credScnCd == "2"){
			PGV.cardList[i].title = milgMbrNoDec.substr(0,4) + "-XXXX-XXXX-" + milgMbrNoDec.substr(12);
			PGV.cardList[i].value = milgMbrNo;
		}
	}
	$("#cardReIssueSelectBtn").val(PGV.cardList[parseInt(PGV.currentSelectedCardIndex)].title);
	$("#cardReIssueSelectBtn").attr("data-select-idx", PGV.currentSelectedCardIndex);
	setCardIssueType();
	
	$(document).on("click", "#cardReIssueSelectBtn", function(){
		var $this = $(this);
		MPopup.listSingle({
			list : PGV.cardList,
			title : "카드 선택",
			selected : $this.attr("data-select-idx")
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				$("#cardReIssueSelectBtn").val(rowInfo.title);
				$("#cardReIssueSelectBtn").attr("data-select-idx", rowInfo.index);
			}
			setCardIssueType();
		});
	});	
};

/**
 * 카드재발급 신청
 */
var insertCardReIssue = function(){
    var telML = $("#telML").val().split("-");
	MNet.httpSendAsIs({
		path : checkVerifyUrl(inf.card.cardReIssue.url),
		sendData : {
			alpCrdKCd : $("input[name='alpCrdKCd']:checked").val(),		// ALP카드종류코드 (00-모바일카드 / 01-실물카드)
			ccpcRegnTn : $("#telF").text(),		// 전화번호 앞자리
			ccpcTexnTn : telML[0]||"",//$("#telM").val(),		// 전화번호 중간자리
			ccpcRearDgtTn : telML[1]||"",//$("#telL").val(),	// 전화번호 뒷자리
			crdRcvAdr : PGV.myInfo.homeAdr,			// 카드수령지주소
			crdRcvDtlAdr : $("#homeAdrDetail").val(),			// 카드수령지상세주소
			crdRcvScnCd : "1",			// 카드수령지 구분(집(1), 직장(2), 기타(3))
			crdRcvZip : PGV.myInfo.homeZip,			// 카드수령지우편번호
			credScnCd : PGV.cardList[$("#cardReIssueSelectBtn").attr("data-select-idx")].credScnCd,			// 신용여부(비신용카드: 2 / 신용카드: 1)
			csetIfTypeCd : "04",			// 승인IF구분코드(01:카드번호/02:CI/03:회원고유번호(blue/red)/04:고객관리번호(CRM식별번호))
			csetIfValue : PGV.loginInfo.csmrMgmtNo,			// 고객관리번호
			mbrUnqNo : "",			// 회원고유번호
			oldMbrNo : PGV.cardList[$("#cardReIssueSelectBtn").attr("data-select-idx")].value,			// 구카드번호 (암호화된것)
			pwmrNm : PGV.loginInfo.mbrNm,			// 요청자(개인인경우, 요청자/수령자 고객명이 들어가야함)
            rissRsonCd : PGV.cardIssueReasonArr[$("#reIssueReasonSelectBtn").attr("data-select-idx")].value,			// 재발행/교체발행하는 이유(신용카드인경우 (20)셋팅됨)
            bdMgmtNo : PGV.myInfo.homeRdMgmtNo,     // 건물번호 [KIAVIK-355]
            crdRcvRefrAdr : PGV.myInfo.homeRefrAdr,      // 참조주소
            mbrTypeCd : PGV.cardList[$("#cardReIssueSelectBtn").attr("data-select-idx")].mbrTypeCd||""          // [KIAVIK-641] 멤버십 유무 (1:일반, 6:전기차)
		},
		callback : insertCardReIssueCallback
	});
};

/**
 * 카드재발급 신청 콜백
 */
var insertCardReIssueCallback = function(receivedData){
	exWNHideIndicator();
	
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	
	if(code == "200"){
	    // KIAVIK-821 재발급 신청 변수 설정
	    MData.global('REISSUE', "Y");
		MPopup.alert({
			message : "신청이 완료되었습니다.",
			callback : function(idx){
				MPage.back();
			}
		});
	}else{
		MPopup.alert(msg);
		return false;
	}
};

// 카드 발급 종류 체크박스 설정
var setCardIssueType = function() {
    var mbrTypeCd = PGV.cardList[$("#cardReIssueSelectBtn").attr("data-select-idx")].mbrTypeCd;
    var memYN = PGV.loginInfo.evMemRegYn; // Y(가입)/N(미가입)
    if (mbrTypeCd == 6 && memYN == "N") { // 비회원 - 모바일 카드만 신청 가능
        $("input[name='alpCrdKCd'][id='mobileCard']").prop("checked", true);
        $("input[name='alpCrdKCd'][id='normalCard']").prop("checked", false);
        $("input[name='alpCrdKCd'][id='normalCard']").attr("disabled", true);
    }
	else{
		$("input[name='alpCrdKCd'][id='mobileCard']").prop("checked", true);
        $("input[name='alpCrdKCd'][id='normalCard']").prop("checked", false);
        $("input[name='alpCrdKCd'][id='normalCard']").attr("disabled", false);
	}
}

/**
 * 사용자 정보 세팅
 */
var myInfoSetView = function(){
	// 집 주소
	$("#homeAdr").val(PGV.myInfo.homeAdr || "");
	$("#homeAdrDetail").val(PGV.myInfo.homeDtlAdr || "");

	//핸드폰 번호 
	var phoneNo = PGV.myInfo.hpno || "";
	phoneNo = String(extractNumber(phoneNo)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2-$3").split(",");
	$("#telF").text(phoneNo[0]);
	$("#telML").val(phoneNo[1]);
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){
		if(isEmpty(MData.param("zipInfo")) == false){
			var adressData = MData.param("zipInfo");
			MData.removeParam("zipInfo");
			PGV.myInfo.homeAdr = adressData.fullAddr;
			PGV.myInfo.homeRdMgmtNo = adressData.buildingCode;
			PGV.myInfo.homeRefrAdr = adressData.extraAddr;
			PGV.myInfo.homeZip = adressData.zoneCode;
			var homeAdress = "";
			
			if(!isEmpty(PGV.myInfo.homeRefrAdr.split(',')[1])){
				homeAdress = PGV.myInfo.homeAdr + '('+PGV.myInfo.homeRefrAdr.split(',')[1].trim()+')';
			}else{
				homeAdress = PGV.myInfo.homeAdr;
			}
			
			$("#homeAdr").val(homeAdress || "");
		}
	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};