/**
@파일명 : KIA_RNW_0D3_2410.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.29
@메뉴명 : Kia Point 조회
@DESC : 권한 확인 중
*/

var KIA_RNW_0D3_2410 = {
    kiaFamilyList: null,
    init: function () {
        this.legacyInit();
    },
    setEventListener: function () {
    
    },
    legacyExternalFunctions: {
        checkRedMemberJoin: null
    },
    legacyInit: function(){
        var setEvent =function() {

            // 이용내역, 소멸예정 탭 클릭 시
            $(document).on("click", "[data-tab-name='listTab'] > li > button", function(){
                if($("[data-tab-name='listTab'] > li.active").eq(0).text().trim() == "이용 내역"){		// 이용내역 탭
                    screenViewGa(gaSendUrl["KIA_MOB_520_1010"].pageNm);
                    $("#useListWrap").removeClass("none");
                    $("#extinctListWrap").addClass("none");
                    $("#useListYesData").html('');
                    /* !!! 케이스마텍 추헌남 - 필터 리스트 보여주기 / 감추기 코드 추가 */
                    $('#useListDateSelectBtnContainer').removeClass('none');
                    $('#useListDivSelectBtnContainer').removeClass('none');
                    $('#extinctSelectBtnContainer').addClass('none');
                    $('#useListDivSelectBtnContainer').after($('#extinctSelectBtnContainer'));
                    selectUseList();
                }else{		// 소멸예정 탭
                    screenViewGa(gaSendUrl["KIA_MOB_520_1001"].pageNm);
                    $("#useListWrap").addClass("none");
                    $("#extinctListWrap").removeClass("none");
                    $("#extinctListYesData").html('');
                    /* !!! 케이스마텍 추헌남 - 필터 리스트 보여주기 / 감추기 코드 추가 */
                    $('#useListDateSelectBtnContainer').addClass('none');
                    $('#useListDivSelectBtnContainer').addClass('none');
                    $('#extinctSelectBtnContainer').removeClass('none');
                    $('#useListDateSelectBtnContainer').before($('#extinctSelectBtnContainer'));
                    selectExtinctExpectList();
                }
            });
        
            // 양도하기 버튼 클릭 시
            $(document).on("click", "#transferBtn", function(){
                var _url = CONSTANT.RED_URL_PREFIX + "kr/kmpg/selectPointTrfYn.do";
                MPage.activity({
                    className : "WebviewActivity",
                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.POST, _url)
                });
            });

            /* !!! 케이스마텍 추헌남 - scroll-loading이 css 구조상 동작하지 않아 대체 */
            $(window).scroll(function(){
                var remainingScrollBottom = $(document).height() - $(window).height() - $(window).scrollTop();
                if(Math.round(remainingScrollBottom) === 0){
                    console.log("called");
                    selectMoreListData();
                }
            })

            /* !!! 케이스마텍 추헌남 - select 동작 무효화처리 */
            $(document).on("mousedown", "#useListDivSelectBtn, #useListDateSelectBtn, #extinctSelectBtn", function(e){
                e.preventDefault();
            });
        
            // 이용내역 > 구분값 클릭 시
            $(document).on("click", "#useListDivSelectBtn", function(){
                var $this = $(this);
                MPopup.listSingle({
                    list : PGV.useListDivArr,
                    title : "구분 선택",
                    selected : $this.attr("data-select-idx") || 0
                }, function(buttonIdx, rowInfo, setting){
                    if(buttonIdx == 1){
                        if($this.attr("data-select-idx") != rowInfo.index){
                            $this.html('<option value="">' + rowInfo.title + '</option>');
                            $this.attr("data-select-idx", rowInfo.index);
                            listInit();
                        }
                    }
                });
            });
        
            // 이용내역 > 기간 클릭 시
            $(document).on("click", "#useListDateSelectBtn", function(){
                var $this = $(this);
                MPopup.listSingle({
                    list : PGV.useListDateDivArr,
                    title : "기간 선택",
                    selected : $this.attr("data-select-idx") || 0
                }, function(buttonIdx, rowInfo, setting){
                    if(buttonIdx == 1){
                        if($this.attr("data-select-idx") != rowInfo.index){
                            $this.html('<option value="">' + rowInfo.title + '</option>');
                            $this.attr("data-select-idx", rowInfo.index);
                            listInit();
                        }
                    }
                });
            });
        
            // 소멸예정내역 > 기간 클릭 시
            $(document).on("click", "#extinctSelectBtn", function(){
                var $this = $(this);
                MPopup.listSingle({
                    list : PGV.extinctExpectDateDivArr,
                    title : "기간 선택",
                    selected : $this.attr("data-select-idx") || 0
                }, function(buttonIdx, rowInfo, setting){
                    if(buttonIdx == 1){
                        if($this.attr("data-select-idx") != rowInfo.index){
                            $this.html('<option value="">' + rowInfo.title + '</option>');
                            $this.attr("data-select-idx", rowInfo.index);
                            listInit();
                        }
                    }
                });
            });
        };
        
        /**
         * 기아멤버스 오프라인 회원 여부 체크
         */
        var checkRedMemberJoin = function(){
            MNet.httpSendAsIs({
                path : checkVerifyUrl(inf.card.cardList.url),
                sendData : {
                    csetIfTypeCd : "04",						// 승인 IF 구분코드 (01:카드번호, 02:CI, 03:회원고유번호, 04:고객관리번호) 04로 고정!! 08/22 -lhs
                    csetIfValue : PGV.loginInfo.csmrMgmtNo			// 02:ci
                },
                callback : checkRedMemberJoinCallback
            });
        };

        this.legacyExternalFunctions["checkRedMemberJoin"] = checkRedMemberJoin;
        
        /**
         * 기아멤버스 오프라인 회원 여부 체크 콜백
         */
        var checkRedMemberJoinCallback = function(receivedData){
            /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
            COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(receivedData);

            if(receivedData.resultCode == "200" && receivedData.cardListResDto.length > 0){
                $("#cardWrap").removeClass("none");
                $("#noMemberWrap").addClass("none");
                selectRedPoint();
            }else{
                exWNHideIndicator();
                $("#cardWrap").addClass("none");
                $("#noMemberWrap").removeClass("none");
            }
        };
        
        
        /**
         * 기아멤버스 포인트 조회
         */
        var selectRedPoint = function(){
            MNet.httpSendAsIs({
                path : inf.point.extFlcMilg.url,
                sendData : {
                    csetIfTypeCd : "04",
                    csetIfValue : PGV.loginInfo.csmrMgmtNo
                },
                callback : selectRedPointCallback
            });
        };
        
        /**
         * 기아멤버스 포인트 조회 콜백
         */
        var selectRedPointCallback = function(receivedData){
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
        
            if(code == "200"){
                $("#availRedPoint").html(receivedData.redPoint !== "0" ? comma.add(receivedData.redPoint) : "0");			// 사용가능 포인트
                //$("#savingExpectPoint").html(comma.add(receivedData.flctMilgAmt) + "<em>p</em>");		// 적립예정 포인트
                $("#extinctExpectPoint").html(receivedData.exntMilgAmt !== "0" ? comma.add(receivedData.exntMilgAmt) : "0");	// 소멸예정 포인트(향후1년간)
        
                listInit();
            }else{
                exWNHideIndicator();
                MPopup.alert(msg);
            }
        };
        
        
        /**
         * 이용내역 리스트 조회
         */
        var selectUseList = function(){
            var selectDivIdx = $("#useListDivSelectBtn").attr("data-select-idx") || 0;
            var selectDateIdx = $("#useListDateSelectBtn").attr("data-select-idx") || 0;
        
            MNet.httpSendAsIs({
                path : inf.point.useMilgList.url,
                sendData : {
                    bztcTypeCd : PGV.useListDivArr[selectDivIdx].value,
                    csetIfTypeCd : "04",
                    csetIfValue : PGV.loginInfo.csmrMgmtNo,
                    currentPageNo : PGV.currentPageNo,
                    pageSize : PGV.pageSize,
                    period : PGV.useListDateDivArr[selectDateIdx].value,
                },
                callback : selectUseListCallback
            });
        };
        
        /**
         * 이용내역 리스트 조회 콜백
         */
        var selectUseListCallback = function(receivedData){
            exWNHideIndicator();
        
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
        
            if(code == "200"){
                PGV.totCnt  = receivedData.totCnt;
                PGV.pageStart = receivedData.pageStart;
                PGV.pageEnd = receivedData.pageEnd;
        
                var pointUseMilgList = receivedData.pointUseMilgListResDto;
                if(pointUseMilgList.length > 0){
                    var strBuff = '';
                    for(var i=0; i<pointUseMilgList.length; i++){
                        var milgUsedGb ="";
                        if (pointUseMilgList[i].milgUsedGb == "사용" || pointUseMilgList[i].milgUsedGb == "취소" || pointUseMilgList[i].milgUsedGb == "소멸") {
                            milgUsedGb = " point-txt"
                        }
                        strBuff += 
                            '<li>' +
                                '<div class="div-table">' +
                                    '<div class="div-table-cell cell-01">' +
                                        '<div class="info"><span>' + DateUtil.getYMD(pointUseMilgList[i].milgDate) +'</span></div>' +
                                        '<p>' + pointUseMilgList[i].milgUsedPlace + '</p>' +
                                    '</div>' +
                                    '<div class="div-table-cell cell-02">' +
                                        '<span' + (pointUseMilgList[i].milgAmt.indexOf("-") !== -1 ? ' class="c-font-brand-point"' : "") + '>' + pointUseMilgList[i].milgAmt + 'P</span>' +
                                    '</div>' +
                                '</div>' +
                            '</li>';
                    }
                    $("#useListYesData").append($(strBuff));
        
                    $("#useListYesData").removeClass("none");
                    $("#useListNoData").addClass("none");
                }else{
                    $("#useListYesData").addClass("none");
                    $("#useListNoData").removeClass("none");
                }
            }else{
                $("#useListYesData").addClass("none");
                $("#useListNoData").removeClass("none");
                MPopup.alert(msg);
            }
        };
        
        /**
         * 소멸예정내역 리스트 조회
         */
        var selectExtinctExpectList = function(){
            var selectDateIdx = $("#extinctSelectBtn").attr("data-select-idx") || 0;
            MNet.httpSendAsIs({
                path : inf.point.exntMilgList.url,
                sendData : {
                    csetIfTypeCd : "04",
                    csetIfValue : PGV.loginInfo.csmrMgmtNo,
                    currentPageNo : PGV.currentPageNo,
                    pageSize : PGV.pageSize,
                    year : extractNumber($("#extinctSelectBtn").text().trim())
                },
                callback : selectExtinctExpectListCallback
            });
        };
        
        /**
         * 소멸예정내역 리스트 조회 콜백
         */
        var selectExtinctExpectListCallback = function(receivedData){
            exWNHideIndicator();
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
            if(code == "200"){
                PGV.totCnt  = receivedData.totCnt;
                PGV.pageStart = receivedData.pageStart;
                PGV.pageEnd = receivedData.pageEnd;
        
                var pointExntList = receivedData.pointExntListResDto;
                if(pointExntList.length > 0){
                    var strBuff = '';
                    for(var i=0; i<pointExntList.length; i++){
                        strBuff += 
                            '<li>' +
                                '<div class="div-table">' +
                                    '<div class="div-table-cell cell-01">' +
                                        '<div class="info"><span>' + DateUtil.getYMD(pointExntList[i].enxtYyMm) +'</span></div>' +
                                        '<p>소멸 예정 포인트</p>' +
                                    '</div>' +
                                    '<div class="div-table-cell cell-02">' +
                                        '<span>' + comma.add(pointExntList[i].exntAmt) + 'P</span>' +
                                    '</div>' +
                                '</div>' +
                            '</li>';
                    }
        
                    $("#extinctListYesData").html($(strBuff));
        
                    $("#extinctListYesData").removeClass("none");
                    $("#extinctListNoData").addClass("none");
                }else{
                    $("#extinctListYesData").addClass("none");
                    $("#extinctListNoData").removeClass("none");
                }
            }else{
                $("#extinctListYesData").addClass("none");
                $("#extinctListNoData").removeClass("none");
                MPopup.alert(msg);
            }
        };
        
        /**
         * 리스트 정보 초기화
         */
        var listInit = function(){
            PGV.currentPageNo = 1;			// 현재 페이지 번호
            PGV.pageSize = 10;				// 받은 페이지의 총 개수
            PGV.totCnt = null;
            PGV.pageStart = null;
            PGV.pageEnd = null;
        
            $("#useListYesData").empty();
            $("#extinctListYesData").empty();
        
            if($("[data-tab-name='listTab'] > li.active").eq(0).text().trim() == "이용 내역"){
                selectUseList();
            }else{
                selectExtinctExpectList();
            }
        };
        
        /**
         * 하단 스크롤시 더보기 이벤트
         */
        var selectMoreListData = function(){
            var totalPageCnt = Math.ceil(PGV.totCnt/PGV.pageSize);	// 전체 페이지 수
        
            if(totalPageCnt > PGV.currentPageNo){
                PGV.currentPageNo = PGV.pageEnd/PGV.pageSize + 1;
                if($("[data-tab-name='listTab'] > li.active").eq(0).text().trim() == "이용 내역"){
                    selectUseList();
                }else{
                    selectExtinctExpectList();
                }
            }
        };

        this.legacyExternalFunctions["selectMoreListData"] = selectMoreListData;
        
        /**
         * 초기화
         */

        // 이용내역 구분 코드
        PGV.useListDivArr = [
            {title : "전체", value : "ALL"},
            {title : "적립", value : "21"},
            {title : "사용", value : "41"},
            {title : "할인", value : "51"},
            {title : "취소", value : "80"},
            {title : "소멸", value : "91"}
        ];

        // 이용내역 기간 코드
        PGV.useListDateDivArr = [
            {title : "최근 2주", value : "-14"},
            {title : "1개월", value : "-30"},
            {title : "3개월", value : "-90"},
            {title : "6개월", value : "-180"},
            {title : "12개월", value : "-365"}
        ];

        // 소멸예정내역 기간 코드
        PGV.extinctExpectDateDivArr = [
            {title : moment().format("YYYY년"), value : moment().format("YYYY")},
            {title : moment().add(1, 'years').format("YYYY년"), value : moment().add(1, 'years').format("YYYY")}
        ];
        $("#extinctSelectBtn").html('<option value="">' + moment().format("YYYY년") + '</option>');


        checkRedMemberJoin();

        /**
         * 화면 이벤트
         */
        setEvent();
    }, 
}

var selectMoreListData = function(){
    var curFunction = KIA_RNW_0D3_2410.legacyExternalFunctions.selectMoreListData;
    curFunction && curFunction();
}
/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        // console.log("onReady page : " + PGV && PGV.currentPage || "");
        KIA_RNW_0D3_2410.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {
        if(MData.param("joinRedMembership") == "Y"){
			MData.removeParam("joinRedMembership");
            var curFunction = KIA_RNW_0D3_2410.legacyExternalFunctions.checkRedMemberJoin;
			curFunction && curFunction();
		}
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
