/**
@파일명 : KIA_RNW_0D3_3100.js 
@작성자 : 케이스마텍 정목단
@생성일 : 2022.04.01
@메뉴명 : 쿠폰목록
@DESC : 권한 확인 중
*/

var pageInit = function(){
    /**
     * 초기화
     */

    /**
     * 화면 이벤트
     */
    //screenViewGa(gaSendUrl["KIA_MOB_820_1000"].pageNm); //2020 공통으로 변경


    if(!isEmpty(MData.param("downYn")) && MData.param("downYn") == "Y"){
        MData.removeParam("downYn");
        selectcopounList().then(setEvent); //다운로드 쿠폰함
    }else{
        selectcopounList("N").then(setEvent); // 쿠폰 목록 조회
    }
    // setEvent();
};

var setEvent = function(){

    /* !!! 케이스마텍 추헌남 - scroll-loading이 css 구조상 동작하지 않아 대체 */
    $(window).scroll(function(){
        var remainingScrollBottom = $(document).height() - $(window).height() - $(window).scrollTop();
        if(Math.round(remainingScrollBottom) === 0){
            console.log("called");
        }
    })
    $(".function-tab li button").on("click", function(){
        // 탭 클래스 변경
        $(".function-tab li button").parent().removeClass("on");
        var type = $(this).attr('data-tab-type');
        $('[data-tab-type="' + type + '"]').parent().addClass("on");

        //하단 컨텐츠 변경
        $("[data-content-type]").addClass("none");
        $('[data-content-type="' + type + '"]').removeClass("none");
        setView(type);
    });

    $("#dwCplist button.btn-cp-down").not(':disabled').off("click").on("click",function(){ //다운로드
        var $this = $(this);
        var cpNum = $this.prev().data("cpNo");
        var cptype = $this.prev().data("cpType");
        var limit = $this.prev().data("limYn");
        if(limit == "Y"){
            MPopup.alert("쿠폰이 모두 소진되었습니다.");
            return;
        };
        downCp(cpNum);
    });

    $("#myCpList button.btn-cp-down").not(':disabled').off("click").on("click", function(){ //상세
        var $this = $(this);
        var cpNum = $this.data("cpNo");
        var cptype = $this.data("cpType");
        var _url = PATH_MANAGER.KIA_RNW_0D3_3110.path;
        if(cptype == "1" || cptype == "2"){
            MPage.html({
                url : _url,//PATH_MANAGER.KIA_RNW_0D3_3110.path,
                param : {
                    cpNo : cpNum,		// 이벤트 번호
                    type : cptype	// 이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
                }
            });
            return false;
        }else{
            var _seqNo = $this.data("seqNo"); // 무상점검 번호
            MPage.html({
                url : _url,//PATH_MANAGER.KIA_RNW_0D3_3210.path,
                param : {
                    seqNo : _seqNo,		// 쿠폰 번호
                    cpNo : cpNum,		// 쿠폰 조회 번호
                    type : cptype	// 쿠폰 타입
                }
            });
            return false;
        }
    });
};


var setView = function(type) {
    if (type == "mycp") {
        $("#dwCplist").html('');
        selectcopounList("N").then(setEvent);
    } else {
        $("#myCpList").html('');
        selectcopounList().then(setEvent);
    }
}

/**
 * 할인 쿠폰함 리스트
 * expiresYn = N 이면 보유 쿠폰
 * expiresYn = "" 이면 다운가능 쿠폰
 */
var selectcopounList = function(flag){

    var _expiresYn = ""; // 다운가능 쿠폰
    if(!isEmpty(flag)){
        _expiresYn = flag; // 보유쿠폰

        $("#myCpList").data("cpChk", "myCp");
    }else{

        $("#myCpList").data("cpChk", "dwCp");
    }
    var options = {
        path : inf.coupon.couponSelect.url,
        sendData : {
            mbrId : PGV.loginInfo.mbrId,
            expiresYn: _expiresYn
        }};
    return  MNet.httpSendAsyncAsIs(options)
        .then(selectcopounListCallback)
        .then(function (response){
            if(!isEmpty(response)){
                if(response.type=="ownCp"){
                    setMyCpList(response.data);
                }else if(response.type=="downCp"){
                    setDwCplist(response.data);
                }
            }else{
                return;
            }
        });
}
var selectcopounList_asis = function(flag){
    var _expiresYn = ""; // 다운가능 쿠폰
    if(!isEmpty(flag)){
        _expiresYn = flag; // 보유쿠폰

        $("#myCpList").data("cpChk", "myCp");
    }else{

        $("#myCpList").data("cpChk", "dwCp");
    }
    MNet.httpSendAsIs({
        path : inf.coupon.couponSelect.url,
        sendData : {
            mbrId : PGV.loginInfo.mbrId,
            expiresYn: _expiresYn
        },
        callback : selectcopounListCallback
    });
}


/**
 * 할인 쿠폰함 리스트 콜백
 */
var selectcopounListCallback = function(receivedData){
    return new Promise(function (resolve){
        exWNHideIndicator();
        var code = receivedData.resultCode;
        var msg = receivedData.resultMsg;
        var couponList = receivedData.couponListResDto;
        if(code == "200"){
            if($("#myCpList").data("cpChk") == "myCp"){ // 보유 쿠폰
                if(couponList.length > 0){
                    $("#noCp").addClass('none');
                    $("#haveCp").removeClass("none");
                    $("#dwCplist").addClass("none");
                    $("#myCpList").removeClass("none");
                    $(".ico-noti").html("유효기간이 만료된 쿠폰은 자동으로 삭제됩니다.");
                    resolve({type:"ownCp",data:couponList});

                }else{
                    $("#haveCp").addClass("none");
                    $("#noCp").removeClass("none");
                    $("#noMy").removeClass('none');
                    $("#noDw").addClass("none");
                    resolve(null);

                }
            }else{ // 다운 쿠폰
                if(couponList.length > 0){
                    $("#noCp").addClass('none');
                    $("#haveCp").removeClass("none");
                    $("#myCpList").addClass("none");
                    $("#dwCplist").removeClass("none");
                    $(".ico-noti").html("다운기간이 만료된 쿠폰은 자동으로 삭제됩니다.");
                    resolve({type:"downCp",data:couponList});
                }else{
                    $("#haveCp").addClass("none");
                    $("#noCp").removeClass("none");
                    $("#noDw").removeClass('none');
                    $("#noMy").addClass("none");
                    resolve(null);
                }
            }
        }
        else{
            MPopup.alert(msg);
            $("#noCp").removeClass('none');
            $("#haveCp").addClass("none");
            if($("#myCpList").data("cpChk") == "myCp"){ // 보유 쿠폰
                $("#noMy").removeClass('none');
                $("#noDw").addClass("none");
            }else{ // 다운 쿠폰
                $("#noDw").removeClass('none');
                $("#noMy").addClass("none");
            }
            resolve(null);
        }});

};
/**
 * 보유쿠폰
 */
var setMyCpList = function(couponList){ //2019/01/30 ~ 2019/02/01
    return new Promise(function (resolve){
        var couponDatas = "";
        for (var i = 0; i < couponList.length; i++) {
            var obj = couponList[i];
            couponDatas += '        <li>';
            couponDatas += '            <div class="cp-item flex">';
            if(obj.cponType == "1"){
                //couponDatas +=			comma.add(obj.cponPri)+"원";
                couponDatas += '            <span class="tit">'+(comma.add(obj.cponPri)+"원")+'</span>';
                couponDatas += '            <span class="cp-ttl">'+obj.cponNm+'</span>';
            }else if(obj.cponType == "2"){
                //couponDatas +=			obj.cponPri+"%";
                couponDatas += '            <span class="tit">'+(obj.cponPri+"%")+'</span>';
                couponDatas += '            <span class="cp-ttl">'+obj.cponNm+'</span>';
            }else{ // cponNm 이 지정된 값이 없으면 cponType 이 3일때 무상점검 4일때 코로나로 cponNm 내려옴
                couponDatas += '            <span class="tit">'+(isEmpty(obj.cponTit) ? '무상점검' : obj.cponTit)+'</span>';
                couponDatas += '            <span class="cp-ttl">'+obj.cponNm+'</span>';
            }
            if(isEmpty(obj.cponStartDt)){
                couponDatas += '            <span class="date">기간제한없음</span>';
            }else{
                couponDatas += '            <span class="date">'+moment(obj.cponStartDt).format("YYYY-MM-DD")+' ~ '+moment(obj.cponEndDt).format("YYYY-MM-DD")+'</span>';
            }
            couponDatas += '            </div>'
            couponDatas += '            <button type="button" class="btn-cp-down" data-cp-type='+obj.cponType+' data-cp-no='+obj.cponNo+' data-seq-no='+obj.seqNo+' id="detailBtn_'+obj.seqNo+'">사용</button>';
            couponDatas += '        </li>';
        }

        $("#myCpList").html(couponDatas);
        resolve();
    });

};

/**
 * 다운 쿠폰
 */
var setDwCplist = function(couponList){ //2019/01/30 ~ 2019/02/01
    return new Promise(function (resolve){
        var couponDatas = "";
        for (var i = 0; i < couponList.length; i++) {
            var obj = couponList[i];
            couponDatas +=	'<li>';
            couponDatas +=		'<div class="cp-item flex" data-cp-type='+obj.cponType+' data-cp-no='+obj.cponNo+' data-lim-yn='+obj.limitYn+'>';
            if(obj.cponType == "1"){
                //couponDatas +=			comma.add(obj.cponPri)+"원";
                couponDatas += '<span class="tit">'+(comma.add(obj.cponPri)+"원")+'</span>';
            }else if(obj.cponType == "2"){
                //couponDatas +=			obj.cponPri+"%";
                couponDatas += '<span class="tit">'+(obj.cponPri+"%")+'</span>';
            }
            couponDatas +=			'<span class="cp-ttl">'+obj.cponNm+'</span>';
            if(isEmpty(obj.cponStartDt)){
                couponDatas +=			'<span class="date">기간제한없음</span>';
            }else{
                couponDatas +=			'<span class="date">'+moment(obj.cponStartDt).format("YYYY-MM-DD")+' ~ '+moment(obj.cponEndDt).format("YYYY-MM-DD")+'</span>';
            }
            couponDatas +=		'</div>';
            if(obj.cponDownYn == "N"){
                couponDatas +=		'<button type="button" class="btn-cp-down"  id="downBtn_'+i+'">다운</button>';
            }else{
                couponDatas +=		'<button type="button" class="btn-cp-down" disabled id="downBtn_'+i+'">다운</button>';
            }
            couponDatas +=	'</li>';
        }
        $("#dwCplist").html(couponDatas);
        resolve();
    });

};

/**
 * 쿠폰 다운로드
 */

var downCp = function(_cponNo){
    MNet.httpSendAsIs({
        path : inf.coupon.couponReg.url,
        sendData : {
            mbrId : PGV.loginInfo.mbrId,
            cponNo: _cponNo
        },
        callback : downCpCallback
    });
}

/**
 * 쿠폰 다운로드 콜백
 */
var downCpCallback = function(receivedData){
    exWNHideIndicator();
    var code = receivedData.resultCode;
    var msg = receivedData.resultMsg;
    var couponList = receivedData.couponListResDto;
    if(code == "200"){
        if(receivedData.regResult == "0005"){
            MPopup.alert("쿠폰이 모두 소진되었습니다.");
        }else{
            MPopup.instance("쿠폰이 발급되었습니다.");
        }
        $('#dwCpBtn').trigger("click");
    }else{
        MPopup.alert(msg);
    }
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        // console.log("onReady page : " + PGV && PGV.currentPage || "");
        pageInit();
    },
    onHide: function (event) { },
    onRestore: function (event) {

    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
