/**
@파일명 : KIA_RNW_0D3_3110.js 
@작성자 : 케이스마텍 정목단
@생성일 : 2022.04.01
@메뉴명 : 쿠폰목록
@DESC : 권한 확인 중
*/

var KIA_RNW_0D3_3110 = {
    init: function () {
        var legacy= new this.legacyInit();
        legacy.pageInit();
    },
    legacyInit: function(){
        /**
         * @파일명 : KIA_MOB_820_1000.js
         * @작성자 : 이현석
         * @생성일 : 2019. 1. 22. 오전 8:42:58
         * @메뉴명 : 할인쿠폰함
         */
        this.pageInit = function(){
            /**
             * 초기화
             */
            cpDetail(MData.param("cpNo")); // 쿠폰 상세 조회
            MData.removeParam("cpNo")
        };

        /**
         * 설맞이 쿠폰함 번호 획득 전문
         */

        var cpDetail = function(cpNo){
            MNet.httpSendAsIs({
                // isMock: true,
                path : inf.coupon.couponDetail.url,
                sendData : {
                    mbrId : PGV.loginInfo.mbrId,
                    cponNo: cpNo
                },
                callback : cpDetailCallback
            });

        }

        /**
         * 쿠폰함상세
         * 로얄은 아직 개발이 안됨
         */
        var cpDetailCallback = function(receivedData){
            exWNHideIndicator();
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
            var type = receivedData.cponType;
            if(code == "200"){
                if(type == "1" || type == "2"){  // 금액 할인
                    setNormalCoupon(receivedData);
                }else{ // 무상점검
                    setNewYearCoupon(receivedData, MData.param("seqNo"));
                    MData.removeParam("seqNo");
                }
            }else{
                MPopup.alert(msg);
            }
        };

        /**
         * 무상점검 쿠폰함
         */
        var setNewYearCoupon = function(obj, seqNo){ //2019/01/30 ~ 2019/02/01
            var hideData = PGV.loginInfo.mbrId.split("@");
            var mbrNm = PGV.loginInfo.mbrNm;
            var mbrId = hideId(hideData[0]) + "@"+ hideData[1];
            var yyyymm = moment(PGV.loginInfo.bthYmd).format("YYYY.MM");
            var phoNo = String(extractNumber(PGV.loginInfo.hpno)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2,$3").split(",");
            // cponLoc (쿠폰사용처) evtNo (현재 이벤트 넘버 - 210901 진행중인 공기케어 예외처리용 - 운영 302)
            // console.log("evtNo : "+obj.evtNo+", cponLoc : "+obj.cponLoc);

            if(!isEmpty(obj.cponTit))   $("p[name='couponTypeTitle']").html(obj.cponTit);      // 없을경우 기존 퍼블 사용
            $("p[name='couponTitle']").html(obj.cponNm);
            $("p[name='useDate']").text(moment(obj.cponStartDt).format("YYYY/MM/DD")+' - '+moment(obj.cponEndDt).format("YYYY/MM/DD"));
            if(!isEmpty(obj.cponLoc))   $("p[name='couponLocation']").html(obj.cponLoc);      // 없을경우 기존 퍼블 사용
            $("span[name='mbrNm']").text(mbrNm.substr(0,1)+"*"+mbrNm.substr(2)+"("+yyyymm + ")");
            $("span[name='mbrId']").text(mbrId);
            $("span[name='mbrPhone']").text("휴대폰 뒤 4자리 " + phoNo[2]);
            // 20210903 NO. K + yyyy + type + evtNo + seqNo 조합
            $(".coupon_num").text((obj.cponType == "4" ? 'NO. K' : 'NO. KF')+moment().format("YYYY")+''+(obj.evtNo == "302" ? '' : obj.cponType+obj.evtNo)+zeroPad(seqNo, 5));
            /*
                var couponDatas = "";
                couponDatas +=		'<div class="coupon-box newyear ny2020">';
                couponDatas +=			'<h2><strong>'+obj.cponNm+'</strong>특별 무상점검 서비스</h2>';
                couponDatas +=			'<div class="coupon-data-wrap">';
                couponDatas +=				'<div class="coupon-data">';
                couponDatas +=					'<div class="coupon-top">';
                couponDatas +=						'<p class="number txtclr-bk">NO. K'+moment().format("YYYY")+''+zeroPad(seqNo, 5)+'</p>';
                couponDatas +=						'<p class="title"><strong>차량 무상점검<br/>및 워셔액 보충</strong></p>';
                couponDatas +=						'<p class="sub">COUPON</p>';
                couponDatas +=					'</div>';
                couponDatas +=					'<div class="coupon-btm">';
                if(!isEmpty(obj.cponStartDt)){
                    couponDatas +=						'<p>사용기간<strong>'+moment(obj.cponStartDt).format("YYYY/MM/DD")+' - '+moment(obj.cponEndDt).format("YYYY/MM/DD")+'</strong></p>';
                }
                couponDatas +=						'<p>장소<strong>전국 서비스 센터 및 서비스 협력사</strong></p>';
                couponDatas +=					'</div>';
                couponDatas +=				'</div>';
                couponDatas +=			'</div>';
                couponDatas +=			'<div class="coupon-info">';
                couponDatas +=				'<p><strong>'+mbrNm.substr(0,1)+"*"+mbrNm.substr(2)+'</strong> '+yyyymm+'</p>';
                couponDatas +=				'<p>아이디 : '+mbrId+'</p>';
                couponDatas +=				'<p>휴대폰 뒤 4자리 : '+phoNo[2]+'</p>';
                couponDatas +=			'</div>';
                couponDatas +=			'<div class="coupon-sub">';
                couponDatas +=				'<strong>서비스협력사(오토큐) 방문시 쿠폰제시 바랍니다.<em>(직영 서비스센터 방문 고객은 쿠폰 불필요)</em></strong>';
                couponDatas +=				'<p>상기 사항은 현지사정으로 변경될 수 있습니다.</p>';
                couponDatas +=				'<p>자세한 사항은 고객센터(080-200-2000)로 문의하여 주시기 바랍니다. </p>';
                couponDatas +=			'</div>';
                couponDatas +=		'</div>';
                $("#newYear").html(couponDatas);
                */
            $("#newYear").removeClass('none');

        };

        /**
         * 금액, 할인 쿠폰함
         */
        var setNormalCoupon = function(obj){
            var hideData = PGV.loginInfo.mbrId.split("@");
            var mbrNm = PGV.loginInfo.mbrNm;
            var mbrId = hideId(hideData[0]) + "@"+ hideData[1];
            var yyyymm = moment(PGV.loginInfo.bthYmd).format("YYYY.MM");
            var phoNo = String(extractNumber(PGV.loginInfo.hpno)).replace(/(^02.{0}|^01.{1}|^[0-9]{3})([0-9]+)([0-9]{4})/, "$1,$2,$3").split(",");

            $("p[name='couponTitle']").text(obj.cponNm);
            $("p[name='useDate']").text(moment(obj.cponStartDt).format("YYYY/MM/DD")+' - '+moment(obj.cponEndDt).format("YYYY/MM/DD"));
            $("span[name='mbrNm']").text(mbrNm.substr(0,1)+"*"+mbrNm.substr(2)+"("+yyyymm + ")");
            $("span[name='mbrId']").text(mbrId);
            $("span[name='mbrPhone']").text("휴대폰 뒤 4자리 " + phoNo[2]);

            if(obj.cponType == "1"){
                $(".discount_num").html(comma.add(obj.cponPri) + '<em class="dsc_unit">원</em>');
            }else{
                $(".discount_num").html(comma.add(obj.cponPri) +'<em class="dsc_unit">%</em>');
            }

            $("#cponPrec").html(obj.cponPrec);
            $("#cponDesc").html(obj.cponDesc);

            /*
                var couponDatas = "";
                couponDatas +=	'<div class="coupon-box cp-normal">';
                couponDatas +=		'<h2><strong>MyKia</strong>'+obj.cponNm+'</h2>'//'<h2>'+obj.cponNm+'</h2>';
                couponDatas +=		'<div class="coupon-wrap">';
                couponDatas +=			'<div class="coupon">';
                couponDatas +=				'<p class="coupon-in">';
                if(obj.cponType == "1"){
                    couponDatas +=			'<span class="tie"><em class="pay">'+comma.add(obj.cponPri)+'</em><em class="unit">원</em></span>';
                }else{
                    couponDatas +=			'<span class="tie type-pct"><em class="pay">'+comma.add(obj.cponPri)+'</em><em class="unit">%</em></span>';
                }
                if(!isEmpty(obj.cponStartDt)){
                    couponDatas +=				'<span class="date">'+moment(obj.cponStartDt).format("YYYY/MM/DD")+' - '+moment(obj.cponEndDt).format("YYYY/MM/DD")+'</span>';
                }
                couponDatas +=				'</p>';
                couponDatas +=				'<span class="txt">COUPON</span>';
                couponDatas +=			'</div>';
                couponDatas +=			'<div class="coupon-info">';
                couponDatas +=				'<p><strong>'+mbrNm.substr(0,1)+"*"+mbrNm.substr(2)+'</strong> '+yyyymm+'</p>';
                couponDatas +=				'<p>아이디 : '+mbrId+'</p>';
                couponDatas +=				'<p>휴대폰 뒤 4자리 : '+phoNo[2]+'</p>';
                couponDatas +=			'</div>';
                couponDatas +=		'</div>';
                couponDatas +=		'<div class="coupon-sub">';
                couponDatas +=			''+obj.cponPrec+''; //<span>유의사항</span>
                couponDatas +=			'<ul class="cmt-list fit">';
                couponDatas +=				''+obj.cponDesc+''; // <li>- 본 쿠폰은 영업점에서 전달된 경우에 한해서 적용 가능 </li> 이런형식으로 내려와야함
                couponDatas +=			'</ul>';
                couponDatas +=		'</div>';
                couponDatas +=	'</div>';
            */
            $("#normal").removeClass('none');
//	$("#normal").html(couponDatas);
        };

        var hideId = function(s){
            var result = "";
            result = s.split("");
            var index = 4;
            if(result.length == 4){
                index = 2;
            }else if(result.length == 5){
                index = 3;
            }
            for(var i = index; i < result.length; i++){
                result[i] = "*";
            }
            return result.join("");
        }
    },
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        // console.log("onReady page : " + PGV && PGV.currentPage || "");
        KIA_RNW_0D3_3110.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {

    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
