/**
@파일명 : KIA_RNW_0D3_4300.js 
@작성자 : 케이스마텍 정목단
@생성일 : 2022.04.01
@메뉴명 : 서비스 이용 약관
@DESC : 권한 확인 중
*/

var KIA_RNW_0D3_4300 = {
    init: function () {
        var legacy= new this.legacyInit();
        legacy.pageInit();
    },
    legacyInit: function(){
        /**
         * @파일명 : KIA_MOB_810_1010.js
         * @작성자 : 최정동
         * @생성일 : 2018. 8. 23. 오후 5:47:05
         * @메뉴명 : 위치 정보 약관
         */
        this.pageInit = function(){
            /**
             * 초기화
             */

            selectTermsAgreeYn();

            PGV.dateList = [
                {title : "2024년 07월 22일 ~ 현재", value: "01"},
                {title : "2022년 05월 30일 ~ 2024년 07월 21일", value: "02"},
                {title : "2021년 04월 05일 ~ 2022년 05월 29일", value: "03"}
            ];

            $("#selectDateBtn").text("2024년 07월 22일 ~ 현재");
            PGV.selNum = 0;

            /**
             * 화면 이벤트
             */
            setEvent();
        };
        var setEvent = function(){
            $(document).on("click", "#locUseAgreeYnBtn", function(){
                var locUseAgreeYn = $(this).attr("agree");
                if (locUseAgreeYn == "Y") {
                    locUseAgreeYn = "N";
                    $("#locUseAgreeYnBtn").attr("agree", "N");
                } else {
                    locUseAgreeYn = "Y"
                    $("#locUseAgreeYnBtn").attr("agree", "Y");
                }
                updateTermsYn(locUseAgreeYn);
            });


            $(document).on("click", "#selectDateBtn", function(){
                            var $this = $(this);
                            MPopup.listSingle({
                                list : PGV.dateList ,
                                title : "이용약관",
                                selected : PGV.selNum
                            }, function(buttonIdx, rowInfo, setting){
                                if(buttonIdx == 1){
                                    $this.text(rowInfo.title);
                                    PGV.selNum = rowInfo.index;
                                    modificationCheck(rowInfo.value);
                                }
                            });
                        });
        };

        var modificationCheck = function(num){
            for (var i = 0; i < PGV.dateList.length; i++){
                var curNode = PGV.dateList[i];
                if(curNode.value === num){
                    $("#content_" + curNode.value).removeClass("none");
                }
                else{
                    $("#content_" + curNode.value).addClass("none");
                }
            }
        };
        /**
         * 위치정보 약관 상세 조회
         */
//        var selectTermsHistoryDetail = function(){
//            MNet.httpSendAsIs({
//                path : inf.terms.selectTermsHistoryDetail.url,
//                sendData : {
//                    rvsnDtm : "",
//                    termsItmCd: "109",
//                    termsKndCcd: "105"
//                },
//                callback : selectTermsHistoryDetailCallback
//            });
//        };
//
//        /**
//         * 위치정보 약관 상세 조회 콜백
//         */
//        var selectTermsHistoryDetailCallback = function(receivedData){
//            exWNHideIndicator();
//            var code = receivedData.resultCode;
//            var msg = receivedData.resultMsg;
//            if(code == "200"){
//                $("#contentWrap").html(receivedData.termsItmCont);
//                //console.log(receivedData);
//            }else{
//                MPopup.alert(msg);
//            }
//        };

        /**
         * 약관동의여부 조회 전문
         */
        var selectTermsAgreeYn = function(){
            if(isEmpty(PGV.loginInfo)) {
                $("#locUseAgreeYnBtn").addClass("none");
                return;
            }
            MNet.httpSendAsIs({
                path : inf.terms.selectTermsAgreeYn.url,
                sendData : {
                    agrYn : "",
                    mbrId: PGV.loginInfo.mbrId,
                    termsItmCd: "109",
                    termsKndCcd: "105"
                },
                callback : selectTermsAgreeYnCallback
            });
        };

        /**
         * 약관동의여부 조회 전문 콜백
         */
        var selectTermsAgreeYnCallback = function(receivedData){
            exWNHideIndicator();
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
            console.log("!!!!!!!!!!!!! "+receivedData.agrYn);
            if(code == "200"){
                $("#locUseAgreeYnBtn").removeClass("none");
                if(receivedData.agrYn == "Y"){
                    $("#locUseAgreeYnBtn").text("위치기반 서비스 이용약관 철회");
                    $("#locUseAgreeYnBtn").attr("agree", "Y");
                }else{
                    $("#locUseAgreeYnBtn").text("위치기반 서비스 이용약관 동의");
                    $("#locUseAgreeYnBtn").attr("aggree", "N");
                }
            }else{
                MPopup.alert(msg);
            }
        };

        /**
         * 약관동의 동의 및 거부
         */
        var updateTermsYn = function(locUseAgreeYn){
            MNet.httpSendAsIs({
                path : inf.terms.setTermsYn.url,
                sendData : {
                    agrYn : locUseAgreeYn,
                    mbrId: PGV.loginInfo.mbrId,
                    termsItmCd: "109",
                    termsKndCcd: "105"
                },
                callback : updateTermsYnCallback
            });
        };

        /**
         * 약관동의 동의 및 거부 콜백
         */
        var updateTermsYnCallback = function(receivedData){
            exWNHideIndicator();
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
            if(code == "200"){
                var changeMsg = "[MyKia]\n" + moment().format("YYYY년 MM월 DD일") + " 위치정보 이용동의";
                if($("#locUseAgreeYnBtn").attr("agree") == "Y"){
                    changeMsg += "가 처리되었습니다.";
                }else{
                    changeMsg += "를 해제하였습니다.";
                }
                MPopup.alert(changeMsg);
                selectTermsAgreeYn();
            }else{
                if($("#locUseAgreeYnBtn").attr("agree") == "Y"){
                    $("#locUseAgreeYnBtn").attr("agree", "N");
                }else{
                    $("#locUseAgreeYnBtn").attr("agree", "Y");
                }
                MPopup.alert(msg);
            }
        };

    }

}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        // console.log("onReady page : " + PGV && PGV.currentPage || "");
        KIA_RNW_0D3_4300.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {

    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
