/**
 * @파일명 : intro_login.js
 * @작성자 : 정목단
 * @생성일 : 2022. 1. 24.
 * @메뉴명 : 인트로
 */
/** ==================================<< !START MCORE API >>================================== **/
M.onReady(function (event) {

	// alert('stop!!');
	// debugger;

	sentryInit();

	if (typeof MStatus.onReady == "function") {
		// M.onReady 공통 처리
		var serverFlag = 'HTTP_DEV';	//현재 사용하려는 서버네임
		if (typeof PGV === "undefined") {
			PGV = {}; //현재화면 글로벌 변수 생성
		}
		PGV = CMMLogin.PGVManager(serverFlag);
		if (PGV.currentPage == PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml) {
			initGoogleAnalytics();
			screenViewGa();
			MStatus.onReady(event);
			return;
		}
	}

});

/**
 * 화면 이동 바로 현재 페이지에서 호출
 * 현재 화면의 데이타 저장 및 처리 등에 사용
 * */
M.onHide(function (event) {
	if (typeof MStatus.onHide == "function") {
		// M.onHide 공통 처리
		MStatus.onHide(event);
	}
});

/**
 * 해당 화면으로 다시 돌아왔을 때 호출
 * 데이타 갱신 등에 사용
 */
M.onRestore(function (event) {
	// ccsp 로그인 처리 화면
	if (!isEmpty(MData.param("ccspLoginInfo"))) {
		var loginData = MData.param("ccspLoginInfo");
		MData.removeParam("ccspLoginInfo");
		//MData.removeStorage("accessToken");
		MData.storage("accessToken", loginData.refreshToken);
		CMMLogin.setLoginInfo(loginData);
		CMMLogin.ccspSucessPageMove(); // ccsp 로그인 시
	}

	//모피어스 화면이 아닌 곳에서 복귀한 경우 푸쉬 알림
	getPushDataWhenNotMorpheusView();

	if (isEmpty(MData.global('loginInfo')) == false) {
		if (isEmpty(PGV.loginInfo) == true) {
			PGV.loginInfo = MData.global('loginInfo');
		}
		// 서버에서 받은 아이디가 있다면 공백 제거 로직 추가
		if (!isEmpty(PGV.loginInfo)) {
			if (!isEmpty(PGV.loginInfo.mbrId)) {
				PGV.loginInfo.mbrId = PGV.loginInfo.mbrId.trim();
			}
		}

		if (PGV.currentPage != PATH_MANAGER.KIA_RNW_060_0000.nameWithHtml) {
			stackRemove(PATH_MANAGER.KIA_RNW_060_0000.nameWithHtml);
		}
		if (PGV.currentPage != "KIA_MOB_810_1060.html") {
			stackRemove("KIA_MOB_810_1060.html");
		}
		if (PGV.currentPage != PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml) {
			stackRemove(PATH_MANAGER.KIA_RNW_010_0000.nameWithHtml);
		}

	} else {
		// not specific desc
	}

	if (isEmpty(MData.global('loginInfo'))) {
		PGV.loginInfo = null;
	}

	if (typeof MStatus.onRestore == "function") {
		//푸쉬 알림 표시 체크
		// M.onRestore 공통 처리
		MStatus.onRestore(event);
	}
});

/**
 * 현재 앱이 Background 상태로 바뀔때 현재 화면에서 호출
 */
M.onPause(function (event) {
	if (typeof MStatus.onPause == "function") {
		// M.onPause 공통처리
		MStatus.onPause(event);
	}
});

/**
 * Bakcground 상태의 앱이 다시 Forground 상태로 바뀔때 현재 화면에 호출
 */
M.onResume(function (event) {
	if (typeof MStatus.onResume == "function") {
		// M.onResume 공통처리
		MStatus.onResume(event);
	}
});

/**
 * 화면이 메모리에서 제거될때 마지막으로 호출
 * 데이타 보존이나 마무리를 위한 처리 등에 사용
 * 단, 앱의 종료시에는 호출되지 않음
 */
M.onDestroy(function (event) {
	if (typeof MStatus.onDestroy == "function") {
		// M.onDestroy 공통 처리
		MStatus.onDestroy(event);
	}
});
/** ==================================<< MCORE API END! >>================================== **/

/** ==================================<< !START 로그인 처리 로직 >>================================== **/
var cmmPopMng = function(){
	var getPopUpMng = function(){
		return M.data.storage("popUpMng");//초기값 "id":{no:"id", isShow:true, banTill:null}
	};
	var storagedMngPop = getPopUpMng();
	var managePops = {/** 외부에서 접근안됨. 여기에 리스트 추가하기 */
		"050_0000":{no:"050_0000"},
	};
	/**
	 * 해당 팝업을 노출해야 하는지 판단.
	 * @param popupId
	 * @returns {boolean}
	 */
	this.isShowable = function (popupId) {
		if(isEmpty(popupId)){
			console.error("check!! 해당 함수 필수값");
			return;
		}
		if (!isEmpty(managePops[popupId])) {//일단관리대상
			var thisPopMngInfo = storagedMngPop[popupId];
			if (!isEmpty(thisPopMngInfo)) {//스토리지에 저장된 정보있음.
				var show = thisPopMngInfo.isShow;
				if (show) {
					var banTill = thisPopMngInfo.banTill || null;
					if (!isEmpty(banTill) && banTill < moment().format('YYYYMMDD')) {
						return false;
					} else {
						return true;
					}
				}
				return false;
			}
		}else{
			console.log("관리대상아님. 해당 팝업에 대해 노출관리를 하기 위해서는 var cmmPopMng > managePops 에 기재해야함.")
		}
		return true;
	}
	/**
	 * 공통 팝업 노출 관리
	 * @param popupId(필수)
	 * @param isShow(필수)
	 * @param banTill(값이 있으면 isShow는 true여야 한다.)
	 */
	this.modifyShowable = function(popupId,isShow,banTill){
		if(isEmpty(popupId)&&isEmpty(isShow)){
			console.error("check!! 해당 함수 필수값");
			return;
		}
		if(isEmpty(storagedMngPop)){
			storagedMngPop ={};
		}
		if (!isEmpty(managePops[popupId])) {//일단관리대상
			if(isEmpty(storagedMngPop[popupId])){
				storagedMngPop[popupId] = {};
			}
			var thisPopMngInfo = storagedMngPop[popupId];
			if(isEmpty(thisPopMngInfo)){
				//초기화
				thisPopMngInfo["no"]= popupId;
				thisPopMngInfo["isShow"]= true;
				thisPopMngInfo["banTill"]= null;
			}
			if(isShow===false){
				thisPopMngInfo.isShow = isShow;
				thisPopMngInfo.banTill = null;
				if(!isEmpty(banTill)){
					if(!isEmpty(isShow) && isShow===false){
						console.error("check!! 팝업유예기간 존재시에 isShow는 무조건 true 입니다. ");
						return;
					}
				}
			}else{
				thisPopMngInfo.isShow = true;
				thisPopMngInfo.banTill = banTill;
			}

			storagedMngPop[popupId] = thisPopMngInfo;
			M.data.storage("popUpMng",storagedMngPop);
		}else{
			console.log("관리 대상 아님. 해당 팝업에 대해 노출관리를 하기 위해서는 var cmmPopMng > managePops 에 기재해야함.");
			return;
		}
	}
};
var CMM_POP_MNG = new cmmPopMng();
/**
 * [PGVManager 현재화면 글로벌 변수 생성자]
 * @param  {String} serverFlag 모피어스 서버 이름
 * @return {Object}            화면 글로벌 변수 객체
 */
var CMMLogin = {
	PGVManager: function PGVManager(serverFlag) {
		var appInfo = M.info.app();
		var apiServer = appInfo.manifest.network.http;
		var pgvObj = {};
		pgvObj.gwServer = apiServer[serverFlag].address;
		pgvObj.sendServer = serverFlag;
		pgvObj.appInfo = appInfo;
		pgvObj.device = M.info.device();
		pgvObj.currentPage = MPage.info().currentPage;
		return pgvObj;
	},
	toAddPassData : function(addingData){
		return $.extend(M.data.global("passData")||{}, addingData);
	},
	DISP : { /** 화면별로 분기되는 내용 정보 가짐 */
		NONE_CAR: {
			/** "has no car"*/
			name: "NONE_CAR",
			ccs: null,
			personalLink: {
				text: "차량데이터 복구",
				link: ""
			},
			show:null,
		},
		CONSTRUCT_CAR_ONLY: {
			/**  "only has constructed car"*/
			name: "CONSTRUCT_CAR_ONLY",
			ccs: null,
			personalLink: null,
			show:null,
		},
		HAS_CAR_ONLY: {
			/**  "has car with no data-link ccs etc"*/
			name: "HAS_CAR_ONLY",
			ccs: null,
			personalLink: null,
			show:null,
		},
		HAS_CAR_CCS_ENABLE: {
			/** registerable ccs : 중간상태값으로 최종사용되는 값이 아님. */
			name: "HAS_CAR_CCS_ENABLE",
			ccs: null,
			personalLink: null,
			show:null,
		},
		HAS_CAR_CCS: {
			/**  "an identical registerd car is exist"*/
			name: "HAS_CAR_CCS",
			ccs: null,
			personalLink: null,
			show:null,
		},
	},
	setLoginInfo:function(loginInfo){
		PGV.loginInfo = loginInfo;
		checkMkrpopUp();
		MData.global('loginInfo', PGV.loginInfo);

		if(isEmpty(PGV.loginInfo) == false){
			//PGV.loginInfo.mbrId = $.trim(PGV.loginInfo.mbrId);
			PGV.loginInfo.mbrId = PGV.loginInfo.mbrId.trim();
		}

		onRefreshFCMToken();//push

		// 로그인 후 로그인 페이지 남아 있을 경우 삭제
		stackRemove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
	},
	autoLoginFunction : function(){
		console.log("autoLoginFunction()");
		MNet.httpSend({
			// 자동로그인 "VANTYFJQXDYD6HB7AW7_KG"
			path : inf.newMember.login.url,
			indicatorYn : "N",
			sendData : {
				// accessToken : "",
				refreshToken : MData.storage("accessToken")
			},
			callback : function(receivedData){
				//exWNHideIndicator();
				var code = receivedData.resultCode;
				var msg = receivedData.resultMsg;
				//ccsp error 401 => 휴면계정, 403(미존재아이디)은 발생 가능성 없음.
				//자동 로그인 때만 발생.
				// 휴면계정일경우 로그인 화면 이동 -> 로그인 화면에서 id / pw 입력하면 휴면 자동 해제.
				if(code == "200" && (receivedData.loginFlag == "401" || receivedData.loginFlag == "403")){
					CMMLogin.ccspLogin();
				}else if(code == "200"){
					CMMLogin.setLoginInfo(receivedData);
					/** 푸시토큰 동일 여부 확인 */
					var token = MData.global("FCMToken")||null;
					if(!isEmpty(token)){
						CMMLogin.getChkEqualPushId();
					}
					else{
						CMMLogin.launcherLoginMain();
					}
					//로그인 만료시 401, 403 김철환 과장 및 공영식 부장이 만료 코드 확인 2019 10 22
				}else{
					MData.removeStorage("accessToken");
					MData.removeStorage("PUSH_ALARM_CHECK");
					MData.removeGlobal('loginInfo');
					//KIAVIK-356 sentry
					//if (typeof Sentry != "undefined") Sentry.setUser({ id: "" });
					M.net.cookie.clear();
//					if(!getPushDataWhenClosedApp()){//PUSH
						MPage.html({
							url : PATH_MANAGER.KIA_RNW_120_0000.path,
							action : 'CLEAR_TOP'
						});
//					}
					return false;
				}
			},
			errorCallback : function(errorCode, errorMessage){
				MPopup.alert(
					{
						message : CONSTANT.NETWORK_ERR_MSG,
						callback : function(idx) {
							M.sys.exit();
						}
					});
			}
		});

	},
	ccspLogin: function(params){
		if(!isEmpty(params)){
			PGV.returnLoginParam = params;
		}else{
			PGV.returnLoginParam = "";
		}
		MData.removeStorage("accessToken");
		MData.removeStorage("PUSH_ALARM_CHECK");
		MData.removeGlobal('loginInfo');
		//KIAVIK-356 sentry
		//if (typeof Sentry != "undefined")  Sentry.setUser({ id: "" });
		M.net.cookie.clear();
		var randomNumber=getRandom(20);
		var requestURL = CONSTANT.CCSP_LOGIN+"&signup_link="+randomNumber;

        var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));	// 앱 버전
        var activityName = "WebviewActivity";

		MPage.activity({
			className: activityName,
			param: {
				method: CONSTANT.NET_MTHD.GET,
				requestURL: requestURL
			}
		});
	},
	setLoginInfo: function(loginInfo) {
		PGV.loginInfo = loginInfo; //전역변수에저장
		//KIAVIK-356 sentry

		CMMLogin.getMkrpopUpInfo();
		MData.global('loginInfo', PGV.loginInfo);

		if (!isEmpty(PGV.loginInfo)&&!isEmpty(PGV.loginInfo.mbrId)) {
			//PGV.loginInfo.mbrId = $.trim(PGV.loginInfo.mbrId);
			PGV.loginInfo.mbrId = PGV.loginInfo.mbrId.trim();
		}
		//todo check 2022 사용자 컨펌 후 진행으로 변경.
		//onRefreshFCMToken(); //push js
		// 로그인 후 로그인 페이지 남아 있을 경우 삭제
		stackRemove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
	},
	callbackBeforeLogin: function(receivedData) {
		//console.log("callbackBeforeLogin()");
		var code = receivedData.resultCode;
		var msg = receivedData.resultMsg;
		PGV.callBeforeLogin = "Y";

		if (code == "200") {
			M.data.global("BeforeLoginV2", receivedData);
		}

		CMMLogin.launcherMain();
	},
	checkPermission: function() {
		//필수권한 체크
		if (getOSType().toLowerCase() == "android") {
			return WN2Common('exWNcheckPermission');
		} else {
			return "true";
		}
	},
	launcherMain: function() {
		console.log("launcherMain()");
		if (checkPermission() == 'true') {
//			if (!getPushDataWhenClosedApp()) {
				if (M.data.storage("checkOnBoarding") != "Y") {
					// 온보딩 화면을 보지 않은 경우
					MPage.html({
						url: PATH_MANAGER.KIA_RNW_030_0000.path,
						action: "CLEAR_TOP",
						animate: 'FADE'
					});
				} else {
					//로그인전 HOME
					if (PGV.device.os.name.toLowerCase() == 'android') {
						MPage.remove(PATH_MANAGER.KIA_RNW_110_0000.nameWithHtml);
					}

					MPage.html({
						url: PATH_MANAGER.KIA_RNW_110_0000.path,
						action: "CLEAR_TOP",
						animate: 'FADE'
					});
				}
//			}
		} else {
			MPage.html({
				url: PATH_MANAGER.KIA_RNW_020_0000.path,
				action: "CLEAR_TOP"
			});
		}
	},
	launcherLoginMain: function() {
//		if (!getPushDataWhenClosedApp()) {
			if (PGV.device.os.name.toLowerCase() == 'android') {
				MPage.remove(PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml);
			}
			//차량리스트 가지고 와서 화면 분기하기(
			// 일단 모두 PATH_MANAGER.KIA_RNW_120_0000 로 간다,
			// 화면을 분기하고 싶을때, 차량미보유자|계약차량만보유자|차량보유자 화면으로 분기할 수 있다.)
			var delay = 200;
			CMMLogin.getSynchronizeUserCarInfo();
			setTimeout(function getLandingHomePage(){
				var homePath = MData.param("HomePath");
				MData.removeParam("HomePath");
				if(isEmpty(homePath)){
					delay+=500;
					setTimeout(getLandingHomePage,delay);
				}else{
					MPage.html({
						url: homePath,
						// url : "../010/"+PGV.currentPage,
						action: 'CLEAR_TOP',
						animate: 'FADE'
					});
				}

			}, delay);
/* //interval형식
			var delay = 10;
			CMMLogin.getSynchronizeUserCarInfo();
			var trial =1;
			var fromTime ;
			setInterval(function getLandingHomePage(){
				var time = moment();//.format("YYYY-MM-DD HH:mm:ss")
				console.log(trial+" : "+time);
				if(trial==1)fromTime=time;
				trial++;
				var homePath = MData.param("HomePath");
				MData.removeParam("HomePath");
				if(isEmpty(homePath)){
					delay+=50;
					// clearInterval(getLandingHomePage,delay);
				}else{
					var toTime =moment();

					console.log("totalTime : "+fromTime.diff(toTime,'seconds'));
					MPage.html({
						url: homePath,
						// url : "../010/"+PGV.currentPage,
						action: 'CLEAR_TOP',
						animate: 'FADE'
					});
					clearInterval(getLandingHomePage);
				}

			}, delay);*/
//		}
	},
	// 마케팅동의 팝업 20191205 수신 동의 마케팅 동의 했을때
	getMkrpopUpInfo: function() {
		var isMrkgRcv = PGV.loginInfo.mrkgRcpmYn == "N" && MData.global("mkrpopUpYn") != "Y";

		if (isMrkgRcv) {
			PGV.mainServerDate = moment().format("YYYYMMDDHH");
			var mkrCheckYn = MData.storage("mkrCheckYn");

			if (!isEmpty(mkrCheckYn) && mkrCheckYn == "Y") {
				PGV.popYn = mkrCheckYn;
				MData.removeStorage("mkrCheckYn");
			} else {
				PGV.popYn = "N";
			}

			MNet.httpSend({
				path: inf.member.mrkgId.url,
				indicatorYn: "N",
				sendData: {
					mbrId: PGV.loginInfo.mbrId,
					mrkgRcpmYn: "N",
					popYn: PGV.popYn
				},
				callback: function(receivedData) {
					//exWNHideIndicator();
					var code = receivedData.resultCode;
					var msg = receivedData.resultMsg;
					var checkDt = receivedData.intervalDay; //  주기 현재 12/1알 호출이면 12/8에 팝업

					if (code == "200") {
						if (checkDt >= "7") {
							//20191205 공부장 초기화 로직 넣음 7일 이후 들어오고 다음번에 호출하면 초기화
							MData.global("mkrpopUpYn", "Y");
						}
					}
				}
			});
		}
	},
	ccspSucessPageMove: function() {
		if (Object.keys(PGV.returnLoginParam).length > 0) {
			var returnLoginParam = PGV.returnLoginParam;

			if (returnLoginParam.returnLink.includes('http://') || returnLoginParam.returnLink.includes('https://')) {
				if (returnLoginParam.returnParams.payCheck == "KIA_MOB_520_1201") {
					//신차구매
					getBluePay();
				} else if (returnLoginParam.returnParams.payCheck == "KIA_MOB_520_1202") {
					//간편결제카드조회
					getMyPay();
				} else {
					MPage.activity({
						className: "WebviewActivity",
						param: {
							method: CONSTANT.NET_MTHD.GET,
							requestURL: returnLoginParam.returnLink,
							headerName: "webview",
							postData: returnLoginParam.returnParams
						}
					});
				}
			} else if (returnLoginParam.backFlag == "Y") {
				MData.param("baseBallYn", "Y");
			} else {
				if (!isEmpty(returnLoginParam.returnParams.settingRegistFlag)) {
					PGV.settingRegistFlag = returnLoginParam.returnParams.settingRegistFlag;
				}

				;
				MPage.html({
					url: returnLoginParam.returnLink,
					param: returnLoginParam.returnParams,
					action: returnLoginParam.returnAction || 'CLEAR_TOP'
				});
			}
		} else {
			MPage.html({
				url: "../010/" + PGV.currentPage,
				action: 'CLEAR_TOP'
			});
		}
	},
	getSynchronizeUserCarInfo : function () {
		var sendData = {mbrId: PGV.loginInfo.mbrId,apiId:_API.SVR.CMM.owncar.updateOwncarList.apiId};
		return MNet.httpSend({
			isMock: false,
			path: _API.SVR.CMM.owncar.updateOwncarList.url,
			sendData: sendData,
			callback: function(syncResult){
				if (syncResult && syncResult.resultCode === "200") {
					console.log(syncResult.resultMsg);
					M.data.param("sync", true);
					CMMLogin.getOwnCarListInfo({mbrId:PGV.loginInfo.mbrId});
				}
			},

		});

	},
	getOwnCarListInfo : function (sendData) {
		sendData.apiId =_API.SVR.CMM.mykia.mycar.mainCarList.apiId;
					var homePath = null;
						var display ;
		display =CMMLogin.DISP.NONE_CAR;
		homePath = PATH_MANAGER.KIA_RNW_120_0000.path;
		MNet.httpSend({
			isMock: false,
			path: _API.SVR.CMM.mykia.mycar.mainCarList.url,
			sendData: sendData,
			indicatorYn : "N",
			callback :function(response){
				var myCarList= {myCarInfoListResDto:{},unDeliveryCarInfoListResDto:{}};
				if(response.resultCode=== "200"){
					if (!isEmpty(response.unDeliveryCarInfoListResDto)) {//계약차량
						myCarList.unDeliveryCarInfoListResDto = response.unDeliveryCarInfoListResDto;
					}
					/** 계약차만 혹은 미보유차량일 경우 그대로 프로세스 resolve 한다 */
					if (isEmpty(response.myCarInfoListResDto)) {//소유차량없고,
						myCarList.myCarInfoListResDto =null;
						if (!isEmpty(response.unDeliveryCarInfoListResDto)) {//계약차량 only
							console.log("계약차만있음");
							display =CMMLogin.DISP.CONSTRUCT_CAR_ONLY;
							homePath = PATH_MANAGER.KIA_RNW_120_0000_2.path;
						} else {
							console.log("차량보유한거 없음.");
							display =CMMLogin.DISP.NONE_CAR;
							homePath = PATH_MANAGER.KIA_RNW_120_0000.path;
						}
					}
					else {
						console.log("보유차량있음");
						display =CMMLogin.DISP.HAS_CAR_ONLY;
						myCarList.myCarInfoListResDto = response.myCarInfoListResDto;
						homePath = PATH_MANAGER.KIA_RNW_120_0000_3.path;
					}
					MData.param("HomePath",homePath);
					var passData = CMMLogin.toAddPassData({car: {"ownCarListInfo": myCarList},display:display});
					M.data.global("passData",passData);
				}else{
					MData.param("HomePath",homePath);
					MPopup.instance('차량보유목록 조회시 오류가 발생하였습니다.');
				return;
				}
			},
			errorCallback : function(errorCode, errorMessage){
				MData.param("HomePath",homePath);
				MPopup.instance('차량보유목록 조회시 오류가 발생하였습니다.');
				return ;
			}
		});
	},
	getChkEqualPushId: function(){
		var fcmToken = MData.global("FCMToken");
		//4test 실제 배포시 삭제 무방.
		if(PGV.appInfo.manifest.resource.target == "app"
			&& CONFIG.IS_DEV
			&& M.info.device().comm.brand==="Android") {
			//M.info.device().comm.brand==="Android"==>통신사없을때.
			fcmToken = "temp";
		}
		var sendData = {
			apiId : _API.SVR.CMM.push.chkEqualPushId.apiId,
			mbrId : PGV.loginInfo.mbrId,
			appOsCcd : PGV.appOS.toUpperCase()==="IOS"?"IOS":"AOS",
			pushTokenkey : fcmToken
		};
		MNet.httpSend({
			isMock: false,
			path : _API.SVR.CMM.push.chkEqualPushId.url,
			sendData : sendData,
			method : CONSTANT.NET_MTHD.POST,
			indicatorYn : "N",
			callback :function(receivedData){
				if(!isEmpty(receivedData)
					&& receivedData.resultCode==="200" && !isEmpty(receivedData.pushIdEqualYn)){
					MData.global("pushIdEqualYn",receivedData.pushIdEqualYn);
					if(receivedData.pushIdEqualYn==="N"){
						var fcmToken = MData.global("FCMToken");
						if(!isEmpty(fcmToken)) {
							CMMLogin.popupConfirmRegistPushToken();
						}else{
							CMMLogin.launcherLoginMain();
						}
					}else{
						CMMLogin.launcherLoginMain();
					}

				}else{
					console.error("getChkEqualPushId error : "+receivedData.resultMsg+"("+receivedData.resultCode+")");
					CMMLogin.launcherLoginMain();
				}

			},
			errorCallback :function(errorCode, errorMessage){
				console.error("getResourceObj error : "+errorMessage+"("+errorCode+")");
				CMMLogin.launcherLoginMain();
			}

		});
	},

	popupConfirmRegistPushToken: function () {

		$(".wrapper").addClass("donemove");

		var popFunc = function (item) {

			// var isShowAble = CMM_POP_MNG.isShowable("050_0000");
			// if(isShowAble){
			// }==> 다시보기 없음. 데이터로 판단함.
			var popId = "#popup_050_0000";
			console.log(popId + " Func> ");
			if ($(popId).length < 1) {
				var screenHtml = $("<div></div>");
				screenHtml.append(item);
				$('body').append(screenHtml.find(popId));
			}
			RNW_UI.popupLayer({selId: popId});

			var refreshPushTokenInfo = MData.param("refreshPushTokenInfo");
			MData.removeParam("refreshPushTokenInfo");

			$(popId).find('div.dim').off('click');
			$(popId + "_DetailBtn").on("click",
				function (e) {
					var sendData = {
						apiId: _API.SVR.CMM.push.regist.apiId,
						mbrId: PGV.loginInfo.mbrId,
						appOsCcd: PGV.appOS.toUpperCase() === "IOS" ? "IOS" : "AOS",
						pushTokenkey: MData.global("FCMToken")
					};
					MData.param("refreshPushTokenInfo",sendData);
					CMMLogin.postRegistPushToken(sendData);
				}
			);
			$(".js-popup-close-btn").click(function () {
				$("#popup_050_0000").remove();
				CMMLogin.launcherLoginMain();
			});
		};
		$.get(PATH_MANAGER.KIA_RNW_050_0000.path, popFunc);

		/*var message = "기존에 알림을 받으시던 스마트폰이 있습니다.\n\n알림을 수신할 스마트폰을 지금 사용 중이신 스마트폰으로 변경할까요?\n\n※ 변경 시, 지금 사용 중이신 스마트폰으로 알림을 받으실 수 있습니다.\n※미 변경 시, 이전에 사용하셨던 스마트폰으로 알림이 발송됩니다.";
		MPopup.alert({
			message : message,
			buttons : ["미변경", "변경"],
			callback : function(index){
				if (index == 1) {//변경
					var sendData = {
						apiId: _API.SVR.CMM.push.regist.apiId,
						mbrId: PGV.loginInfo.mbrId,
						appOsCcd: PGV.appOS.toUpperCase() === "IOS" ? "IOS" : "AOS",
						pushTokenkey: MData.global("FCMToken")
					};
					MData.param("refreshPushTokenInfo", sendData);
					CMMLogin.postRegistPushToken(sendData)
				} else {//미변경
					CMMLogin.launcherLoginMain();
				}
			}
		});*/
	},
	postRegistPushToken: function (sendData) {
		if(isEmpty(sendData)){
			console.error("no sendData");
		}else{

			MNet.httpSend({
				isMock : false,
				path : _API.SVR.CMM.push.regist.url,
				sendData : sendData,
				method : CONSTANT.NET_MTHD.POST,
				indicatorYn : "N",
				callback :function(receivedData){
					$("#popup_050_0000").remove();
					if(!isEmpty(receivedData)
						&& receivedData.resultCode==="200"){
						// CMM_POP_MNG.modifyShowable("050_0000", false); 다시 보지 않기 없음. 데이터로 판단함.
						CMMLogin.launcherLoginMain();
					}else{
						console.error("getChkEqualPushId error : "+receivedData.resultMsg+"("+receivedData.resultCode+")");
						SNTR.sendSentryVIKErrorLog("update push", receivedData.resultMsg);
						CMMLogin.launcherLoginMain();
					}
				},
				errorCallback :function(errorCode, errorMessage){
					$("#popup_050_0000").remove();
					console.error("getResourceObj error : "+errorMessage+"("+errorCode+")");
					SNTR.sendSentryVIKErrorLog("update push", receivedData.resultMsg);
					CMMLogin.launcherLoginMain();
				}
			});

		}
	},

};






/** ==================================<<이상 로그인 처리 로직 END! >>================================== **/

/** ==================================<< !START sentryInit  코드 >>================================== **/
//KIAVIK-356 sentry
//가장먼저 실행됨. asis 규칙대로 함.
var sentryInit = function () {
	if (typeof Sentry != "undefined" && typeof SENTRY_CONFIG != "undefined") {
		if (CONFIG.IS_SENTRY) {
			try {
				Sentry.init({
					dsn: SENTRY_CONFIG.DSN,
					integrations: (typeof Sentry.Integrations.BrowserTracing === "function") ? [new Sentry.Integrations.BrowserTracing()] : [],
					tracesSampleRate: CONFIG.SENTRY_SAMPLE_RATE,
					sampleRate: 1.0,
					autoSessionTracking: true,
					release: CONFIG.SENTRY_APP_RELEASE,
					beforeSend: function (event, hint) {
						event.tags = event.tags || {};
						event.user = event.user || {};
						if (typeof PGV != "undefined") {
							event.tags.appVersion = PGV.appInfo.app.version;
							if (!isEmpty(PGV.loginInfo)) {
								event.user.id = PGV.loginInfo.mbrId;
							}
							event.tags.resourceVersion = PGV.appInfo.resource.current_version;
						}
						return event;
					}
				});
			} catch (error) {
				console.log("sentry error!:" + error);
			}
		}
	}
}



/** ==================================<<!이상 sentryInit 코드 END>>================================== **/