/**
 @파일명 : KIA_RNW_110_0000.js
 @작성자 : 케이스마텍 추헌남
 @생성일 : 2022.01.26
 @메뉴명 : HOME 탭(미로그인)
 @DESC : 전체메뉴노출[X], 접근권한( 미로그인[O] 차량미보유[X]   계약차량보유[X]   내연보유[X]   EV보유[X] )
 */
var loginHome;
var KIA_RNW_110_0000 = function (){
    var that = this;
    that.gVals = {};
    that.init= function () {
        exWNShowIndicator();
        that.gVals.popUp = CMM_HOME.homePgvObj.popUp;
        setMarketingAreaBox();
        setMainVisualboxWeatherInfo();
        $("#mainContentWrap").removeClass("none");
        $('.swiper-slide #mykia-location-wrapper').hide();
        $('.swiper-slide #mykia-location-text').hide();
        CMM_HOME.popupManage();

        var deepLink = MData.global("DEEP_LINK");
        console.log(deepLink);
        if(!isEmpty(deepLink)){
            console.log("MDATA.global :: " , MData.global("DEEP_LINK"));
            //Driving-Insight DeepLink 처리
            if(deepLink.includes("driving-insight")){
                ccspLogin();
            }
        }
    },

        /* 함수들 정의 */
        /**
         * 날씨 및 미세먼지 정보 가져오기
         */
        setMainVisualboxWeatherInfo= function (coords) {
            $("div.swiper-wrapper").html("");
            function getDefaultSlider(url, html) {
                var url = "../../img/rnw/main/home/WEA006_" + ((getRandom(2) % 3) + 1) + ".jpg";
                var html = '<div class="swiper-slide" style="background-image:url(\'' + url + '\');">' +// todo '&#39' 테스트해보기
                    '  <div class="main-visual-box">' +
                    '    <div class="group-01">' +
                    '      <div class="row text-align-right">' +
                    '        <button type="button" class="btn-gps">' +
                    '          <i class="ico-gps" id="mykia-location-wrapper"></i><em id="mykia-location-text">조회중...</em>' +
                    '        </button>' +
                    '      </div>' +
                    '      <div class="row">' +
                    '        <h2 class="text-scale-02">' +
                    '          <b>반갑습니다.<br>MyKia입니다.</b>' +
                    '        </h2>' +
                    '      </div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>';
                return html;
            }
            var html = getDefaultSlider();
            $("div.swiper-wrapper").append($(html));
        };

        /**
         * DOM 요소에 대한 이벤트 리스너 등록
         */
        that.setEventListner= function () {
            loginHome.setPublisherEventListeners();
            COMMON_FUNCTION.TOOL.GNB.setEventListeners(); // 로그인버튼 이벤트 일괄 세팅(박민기)
            // $('#mykia-main-login').on("click", function(){
            //     ccspLogin();
            // })
            $('#mykia-start').off("click").on("click", function () {
                MPage.html({
                    url: PATH_MANAGER.KIA_RNW_111_0000.path
                });
            })
            $('[data-type=mycar]').off("click").on("click", function() {
                COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_080_0000.path, null, [
                    null,
                    function(){
                        ccspLogin();
                    }
                ])
            })
        },

        that.setPublisherEventListeners= function(){

            // ------------------------------
            // 	Scroll
            // ------------------------------			
            var $winTop = $(window).scrollTop();

            $(window).off("scroll").on("scroll",function(e) {

                fnSetHomeHeaderBgActive(); // 메인홈 header활성화
            });

            function fnSetHomeHeaderBgActive() {

                var $nowTop = $(this).scrollTop();

                // homeheader
                //var $homeHeader = $('#homeHeader');
                var $homeHeader = $('#mainWrap #homeHeader');
                var $homeHeaderHeight = $homeHeader.outerHeight();

                if ($nowTop > $homeHeaderHeight) {
                    $homeHeader.addClass('js-home-header-fixed');
                }
                else {
                    $homeHeader.removeClass('js-home-header-fixed');
                }

                $winTop = $nowTop;
            }
        },

        /**
         * 루프하는 Main Visual Box Swiper Slider 생성
         */
        createMainVisualBoxLoopSwiperSlider= function () {
            return new Promise(function(resolve){
                var _sliderVisual = new Swiper('.slider-main-visual', {
                    slidesPerView: 1,
                    //loop: true, //무한루프 동작 수정
                    // speed: 300,
                    //grabCursor:true,
                    touchRatio: $('.slider-main-visual .swiper-slide').length > 1 ? true : false, // 슬라이드 영역 1개일경우 드래그 금지
                    pagination: {
                        el: '.main-visual-cont .swiper-pagination',
                        clickable: true,
                    },
                    // autoplay: {
                    //     delay: 4000,
                    //     disableOnInteraction: false, // 사용자가 슬라이드 수동전환 하는경우 자동재생 멈추게 한다:true
                    // },
                });
                resolve(_sliderVisual);
            })
        },

        /**
         * 헤더 영역 스크롤시 발생하는 이벤트 리스너 등록 함수
         */
        setHeaderScrollEventListener= function () {
            var $winTop = $(window).scrollTop();

            $(window).scroll(function (e) {

                fnSetHomeHeaderBgActive(); // 메인홈 header활성화
            });

            function fnSetHomeHeaderBgActive() {

                var $nowTop = $(this).scrollTop();

                // homeheader
                var $homeHeader = $('#homeHeader');
                var $homeHeaderHeight = $homeHeader.outerHeight();

                if ($nowTop > $homeHeaderHeight) {
                    $homeHeader.addClass('js-home-header-fixed');
                }
                else {
                    $homeHeader.removeClass('js-home-header-fixed');
                }

                $winTop = $nowTop;
            }
        },

        /* 마케팅 영역 박스 채우기 */
        setMarketingAreaBox= function(){
            eventLog("newCarList", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
            MNet.httpSendAsync({
                path: _API.SVR.CMM.main.newCarList,
                isMock: false
            }).then(function(response){
                var bannerCarInfo = null;
                var currentAdImgSrc = null;
                var currentAdLinkHref = null;
                if (response.resultCode === "200"){
                    if(response.newCarListRnwResDto && response.newCarListRnwResDto.length > 0){
                        bannerCarInfo = response.newCarListRnwResDto[0];
                        currentAdImgSrc = CONSTANT.IMG_URL_PREFIX+ bannerCarInfo.savedFilePath + bannerCarInfo.savedFileNm;
                        currentAdLinkHref = bannerCarInfo.linkUrl;

                        var html = "";
                        if (currentAdImgSrc){
                            var prExp1 = !bannerCarInfo.prExp1 ? "" : bannerCarInfo.prExp1
                            html +=

                                '<div class="img-cont">' +
                                        '<img id="mykia-nonlogin-main-carinfo-banner" src="' +currentAdImgSrc + '" alt="">' +
                                '</div>' +

                                '<div class="main-visual-box">' +
                                    '<div class="group-01">' +
                                        '<h2 class="text-scale-02">' +
                                            '<b>' +
                                                prExp1 + '<br>' + bannerCarInfo.prExp2 + '<br>' + bannerCarInfo.prExp3 +
                                            '</b>' +
                                        '</h2>' +
                                    '</div>' +
                                '</div>' +

                                '<div class="btn-block">' +
                                    '<button type="button" class="btn-default" id="mykia-nonlogin-main-carinfo-banner-button">' +
                                        '<em>자세히 보기</em>' +
                                    '</button>' +
                                '</div>';


                            $('#mykia-nonlogin-main-carinfo-banner-container').html(html);
    //                            $('#mykia-nonlogin-main-carinfo-banner').attr('src', currentAdImgSrc);
                                $('#mykia-nonlogin-main-carinfo-banner-button').off("click").on("click", function(){
                                    eventLog("carinfoBannerButton", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "Webview");
                                    MPage.activity({
                                        className : "WebviewActivity",
                                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, currentAdLinkHref)
                                    });
                                })
                        };
                    }
                    else{
                        $("#mykia-nonlogin-main-carinfo-banner-container").addClass("none");
                    }
                }
                eventLog("newCarList", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
            })
        }
}


/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MyKiaBottomTab = null;
var CMM_HOME = null;
var MStatus = {
    onReady: function (event) {
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("onReady page : " + PGV.currentPage);
        CMM_HOME = new cmmHome();
        MyKiaBottomTab = MyKiaBottomTabInit();

        loginHome = new KIA_RNW_110_0000() ;
        loginHome.init();
        CMM_HOME.initBottomTab();
        
        COMMON_FUNCTION.TOOL.DATA.setMyKiaRenewalStorage();
        garbageAllRmv(); // 2024.04.11 HOME 로딩 시 garbage stack 제거
    },
    onHide: function (event) { },
    onRestore: function (event) {
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) {
        if(typeof KIA_RNW_210_0000 === "object"){
            if(KIA_RNW_210_0000.tabularNavigator){
                var pageIndex = KIA_RNW_210_0000.tabularNavigator.currentTabIndex;
                if (pageIndex === 0){
                    KIA_RNW_210_0000_2 && KIA_RNW_210_0000_2.setEachBoxByLoadedOrder();
                }
            }
        }
    }
}; 
