/**
 @파일명 : KIA_RNW_120_0000.js
 @작성자 : 정목단
 @생성일 : 2022.04.05
 @메뉴명 : HOME 탭 (차량 미 보유)
 @DESC : 로그인[O] 차량미보유[O]
 */


/****************
 *  ----------------------------------------------------------------------------------------
 *  */
var loginHome;
var KIA_RNW_120_0000 = function () {
    var that = this;
    that.gVals = null;
    that.init = function () {
        // 초기화
        that.gVals={};
        if(isEmpty(CMM_HOME))CMM_HOME = new cmmHome();
        that.gVals = CMM_HOME.homePgvObj;
        var thenIndex=1;
        eventLog("signedHomeCommonStart", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
        CMM_HOME.signedHomeCommonStart()/* 위치,날씨,홈로드검증 */
            .then(/** 날씨 슬라이더 로드, 신차광고 로드,안내콘텐츠|마케팅영역 */
                function(){
                    eventLog("signedHomeCommonStart", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                    return new Promise(function (resolve,reject){
                        Promise.allSettled([uiSliders(), uiNewCar()])
                            .then(
                                function (values) {
                                    var isLoadAll = true;
                                    for (var i = 0; i < values.length; i++) {
                                        isLoadAll = isLoadAll && (isLoadAll = values[i].status === "fulfilled" ? true : false);
                                    }
                                    if (isLoadAll) {
                                        resolve();
                                    } else {
                                        reject();
                                    }
                                }
                            );
                    });
                }
            )
            .then(
                function () {
                    loginHome.setEventListner()
                    /** todo intro에서 받은 출력팝업 확인해서 팝업띄우기. */
                    var passData = toAddPassData(that.gVals);
                    M.data.global("passData",passData);
                    PGV.passData = passData;
                }
            )
            .then(function(){
                MyKiaBottomTab = new MyKiaBottomTabInit();
            })
            .then(CMM_HOME.initBottomTab)//bottomTabNavigationInit
            .then(CMM_HOME.popupManage)/** 팝업콘트롤 */
            .then(function () {
                var msg = loginHome.importantMessege;
                if(!isEmpty(msg)&&typeof msg =='string'){
                   MPopup.alert(msg);
               }
            })
            .then(function(){
                getPushDataWhenClosedApp();
            })
            .catch(
                function (e) {
                    COMMON_FUNCTION.TOOL.DEBUG.showTalk( e);
                }
            );
    };

    that.setEventListner= function(){
        CMM_HOME.setUiEventListner();
        $("#newCarDetailLinkBtn").off("click").on("click", function(){
            var that = $(this);
            var adUrl = that.data('adUrl');
            MPage.activity({
                className : "WebviewActivity",
                param : {
                    method : CONSTANT.NET_MTHD.POST,
                    requestURL : adUrl
                }
            });
        });
    }

    /** 날씨 슬라이더 생성  */
    var htmlWeatherSlider = function (weatherInfo) {
        var weatherFcstResDto;
        var weatherSnrsResDto;
        var weatherAirPltnResDto;
        var weatherCase = {};
        var weatherVerifyIcon=null;
        var W_INSIGHT=null;
        var wkeys = Object.keys(CMM_HOME.dict.insight.W_INSIGHT);

        if(weatherInfo){
            weatherFcstResDto = weatherInfo.fcstResDto;
            weatherSnrsResDto = weatherInfo.snrsResDto;
            weatherAirPltnResDto = weatherInfo.airPltnResDto;

            if(!isEmpty(weatherFcstResDto)) {
                weatherVerifyIcon = CMM_HOME.verifyWeatherCase((weatherFcstResDto.pty||"x"), (weatherFcstResDto.rn1||"x"), (weatherFcstResDto.sky||"x"));
            }

            if(isEmpty(weatherCase.title)){
                W_INSIGHT = CMM_HOME.dict.insight.W_INSIGHT["WEA006"];
            }else{
                for (var i = 0; i < wkeys.length; i++) {
                    var obj = CMM_HOME.dict.insight.W_INSIGHT[wkeys[i]];
                    if (obj.desc === weatherCase.desc) {
                        W_INSIGHT = obj;
                        break;
                    }
                }
            }
        }else{
            weatherVerifyIcon = CMM_HOME.verifyWeatherCase("x","x","x");
            W_INSIGHT = CMM_HOME.dict.insight.W_INSIGHT["WEA006"];
        }

        W_INSIGHT.title = weatherVerifyIcon.title;
        W_INSIGHT.ico_class = weatherVerifyIcon.ico_class;
        that.gVals.main.weatherInfo.case = W_INSIGHT;
        var weatherInfo = that.gVals.main.weatherInfo;
        var imgCount = isEmpty(weatherInfo)||isEmpty(weatherInfo.case)?3:weatherInfo.case.imgCount;
        var randNumSuffix = (getRandom(2) % imgCount) + 1;
        var imgName=(!isEmpty(weatherInfo)&&!isEmpty(weatherInfo.case))?weatherInfo.case.cd+"_"+randNumSuffix:"WEA006_"+ randNumSuffix;
        var url ="../../img/rnw/main/home/"+ imgName+".jpg";
        /***
         * 날씨정보 오류시 처리 4case[날씨,미세먼지](11,10,01,00) 퍼블->KIA_RNW_110_0000.html 확인
         * */
        var weatherCase = that.gVals.main.weatherInfo.case;
        var html = '<div class="swiper-slide" style="background-image:url(\''+url+'\');">' ;
        html += CMM_HOME.htmlWeatherMainVisualBox(weatherInfo);
        html +=
        '                  <button type="button" class="btn-more" data-screenid="KIA_RNW_127_3000">' +//차량데이터 복구 팝업
        '                    <em class="text-underline c-font-white">차량 데이터 복구</em>' +
        '                  </button>';
        html += '</div>';//.swiper-slide end
        return html;

    };
    var uiSliders = function(homeInsight) {
        return new Promise(function (resolve){
            var htmlWeatherSliderDiv = htmlWeatherSlider(that.gVals.main.weatherInfo);
            var targetDiv = document.querySelector("#sliderTarget");
            $(targetDiv).append($(htmlWeatherSliderDiv));
            resolve();
        });
    }
    var uiNewCar = function() {
        return new Promise(function (resolve){
            eventLog("newCarAdList", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
            CMM_NET_SVR.getNewCarAdList()
                .then(
                    function(data){
                        if(data.resultCode==="200"&&!isEmpty(data.newCarListRnwResDto)){
                            var newCars = data.newCarListRnwResDto;
                            var bannerCarInfo = newCars[0];
                            var currentAdImgSrc = CONSTANT.IMG_URL_PREFIX+bannerCarInfo.savedFilePath+bannerCarInfo.savedFileNm;
                            var currentAdLinkHref = bannerCarInfo.linkUrl;
                            var html = "";

                            if (currentAdImgSrc){
                                var prExp1 = !bannerCarInfo.prExp1 ? "" : bannerCarInfo.prExp1
                                html +=

                                    '<div class="img-cont">' +
                                            '<img id="mykia-nonlogin-main-carinfo-banner" src="' +currentAdImgSrc + '" alt="">' +
                                    '</div>' +

                                    '<div class="main-visual-box">' +
                                        '<div class="group-01">' +
                                            '<h2 class="text-scale-02">' +
                                                '<b>' +
                                                    prExp1 + '<br>' + bannerCarInfo.prExp2 + '<br>' + bannerCarInfo.prExp3 +
                                                '</b>' +
                                            '</h2>' +
                                        '</div>' +
                                    '</div>' +

                                    '<div class="btn-block">' +
                                        '<button type="button" class="btn-default" id="mykia-nonlogin-main-carinfo-banner-button">' +
                                            '<em>자세히 보기</em>' +
                                        '</button>' +
                                    '</div>';


                                $('#mykia-nonlogin-main-carinfo-banner-container').html(html);
                                $('#mykia-nonlogin-main-carinfo-banner-button').off("click").on("click", function(){
                                    eventLog("carinfoBannerButton", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "Webview");
                                    MPage.activity({
                                        className : "WebviewActivity",
                                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, currentAdLinkHref)
                                    });
                                })
                            };
                            resolve();
                        }else{
                            $("section.section-01 div.carInfo-banner").addClass("none");
                            resolve();
                        }
                        eventLog("newCarAdList", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                    }
                );
        });
    }

}

// function initBottomTab() {
//     return MyKiaBottomTab.activate({
//         afterInit: function () {
//             console.log("heyyy");
//             exWNHideIndicator();
//             COMMON_FUNCTION.TOOL.UI.enableWebviewLinkListeners();
//             COMMON_FUNCTION.TOOL.UI.enableScreenIdListeners();
//             COMMON_FUNCTION.TOOL.GNB.setEventListeners();
//             COMMON_FUNCTION.TOOL.UI.ringTheBells();
//             // CMM_HOME.uiBottomMenu();
//             loginHome.setEventListner();
//         },
//         afterOpenedTheTab: function () {
//             console.log("heyyy");
//             exWNHideIndicator();
//             $(window).off("scroll");
//             $('body').removeClass('js-filter-list-fixed');
//             $(".wrapper").removeClass("donemove");
//             customPopup.remove($("div.popup-layer"));
//             console.log("heyyy afterInit");
//             COMMON_FUNCTION.TOOL.UI.enableWebviewLinkListeners();
//             COMMON_FUNCTION.TOOL.UI.enableScreenIdListeners();
//             COMMON_FUNCTION.TOOL.GNB.setEventListeners();
//             // COMMON_FUNCTION.TOOL.UI.ringTheBells();
//             // CMM_HOME.uiBottomMenu();
//             loginHome.setEventListner();
//             // alert(MyKiaBottomTab.currentPage);
//         }
//     });
// }

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MyKiaBottomTab = null;
var MStatus = {
    onReady: function (event) {
        CMM_HOME = new cmmHome();
        loginHome = new KIA_RNW_120_0000();
        loginHome.init();
        COMMON_FUNCTION.TOOL.DATA.setMyKiaRenewalStorage();
        garbageAllRmv(); // 2024.04.11 HOME 로딩 시 garbage stack 제거
    }, onHide: function (event) {
    }, onRestore: function (event) {
        console.log("heyyy :onRestore");
        var hasToHomeReload = (((MData.param("hasToHomeReload")).toLowerCase() === 'true') || false);
        MData.removeParam("hasToHomeReload");
        if(hasToHomeReload){
            exWNShowIndicator();
            var isUserCarsChanged = MData.param("isUserCarsChanged")=="true";
            MData.removeParam("isUserCarsChanged");
            if(isUserCarsChanged){
                MPage.html({
                    url : PATH_MANAGER[PGV.currentPage.split('.')[0]].path
                });
            }else{
                var changeSelectCar = MData.param("changeSelectCar") || null;
                // MData.removeParam("changeSelectCar");
                loginHome.gVals.car.selectCar =changeSelectCar;
                MyKiaBottomTab.open("home",hasToHomeReload);
            }
        }

        var tabLevel1 = MData.param("tabLevel1")||null;// 메뉴이동 뎁스 1,
        MData.removeParam("tabLevel1");
        var tabLevel2 = MData.param("tabLevel2")||null;
        MData.removeParam("tabLevel2");
        if(!isEmpty(tabLevel1)){
            COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.openSubtabGlobally(MyKiaBottomTab, tabLevel1, tabLevel2);
        }

        var readNoti = MData.param("readNoti") || null;// 메뉴이동 뎁스 1,
        MData.removeParam("readNoti");
        if(!isEmpty(readNoti)&&readNoti=="Y") COMMON_FUNCTION.TOOL.UI.ringTheBells();
        getPushDataWhenNotMorpheusView();
    }, // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy: function (event) {
    }, onPause: function (event) {
    }, onResume: function (event) {
    }
}

