/**
 @파일명 : KIA_RNW_121_0000.js
 @작성자 : 케이스마텍 정목단
 @생성일 : 2022.04.10
 @메뉴명 : HOME 탭 > data hub 안내 팝업
 @DESC : 로그인(O), 차량보유자(O)
 */
var CurrPage;

var KIA_RNW_121_0000 = {
    isCcsUpdated:false,
    init: function () {
        CurrPage = this;
        CurrPage.setEventListeners();
       
    },
    /**
     * DOM 요소에 대한 이벤트 리스너 등록
     */
    setEventListeners: function () {
        $("[data-link-hub-web]").off("click").on("click",function(){
            var thisBtn = this;
            var pageName = $(thisBtn).data("linkHubWeb");
            var loginInfo =PGV.loginInfo;
            var carId = PGV.passData.car.selectCar.carId;
            var _url = '';
            if(pageName=="KIA_RNW_121_1000"){
                _url = _API.HUB.agreementsWeb.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);
            }
            else if(pageName=="KIA_RNW_121_4000"){
                _url = _API.HUB.web.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);
            }
            else if(pageName=="KIA_RNW_121_4000_2"){
                _url = _API.HUB.safeDriveWeb.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);//데이터허브 오류로 해결시 주석해제 아래줄 삭제
                // _url = _API.HUB.agreementsWeb.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);
            }
            else if(pageName=="KIA_RNW_121_4000_3"){
                _url = _API.HUB.safeDriveIntroduceWeb.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);
            }
            MPage.activity({
                className : "WebviewActivity",
                param : {
                    method : CONSTANT.NET_MTHD.GET,
                    requestURL : _url.path,
                    bottomLayer : "disable"
                }
            });
            CurrPage.isCcsUpdated=true;
            $("[data-link-hub-web]").addClass("none");
            $("#registDoneBtn").removeClass("none");
        });

        $(".btn-close, #registDoneBtn").off("click").on("click", function(){
            var options = {};
            options.param={};
            options.param.isCcsUpdated = CurrPage.isCcsUpdated;
            MPage.back(options);
        });

    },
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_121_0000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) {
        if(CurrPage.isCcsUpdated){
            M.page.html({action : "CLEAR_TOP",url:PATH_MANAGER[PGV.currentPage.split('.')[0]].path,isCcsUpdated:CurrPage.isCcsUpdated});
        }
        if(typeof KIA_RNW_210_0000=='object'){
            if(KIA_RNW_210_0000.tabularNavigator){
                var pageIndex = KIA_RNW_210_0000.tabularNavigator.currentTabIndex;
                if (pageIndex === 0){
                    KIA_RNW_210_0000_2 && KIA_RNW_210_0000_2.setEachBoxByLoadedOrder();
                }
            }
        }
    }
}; 
