/**

 @파일명 : KIA_RNW_123_0000.js
 @작성자 : 케이스마텍 정목단
 @생성일 : 2022.04.12
 @메뉴명 : HOME>주차 위치 안내 팝업
 @DESC : 로그인&&차량보유&&데이터허브연동
 */
var CurrPage;

var KIA_RNW_123_0000 = {
    init: function () {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");

        var carId = PGV.passData.car.selectCar.carId;
        var vin = PGV.passData.car.selectCar.vin;
        var tassYn = PGV.passData.car.selectCar.tassYn;
        CurrPage.setLocationConn("5");
        exWNShowIndicator();
        if (tassYn == "Y") {
            CurrPage.getTerms()//위치서비스 약관 동의 조회
                .then(//동의 유무에 따라 위치조회  or 알럿+페이지 닫음 에러 throw
                    function (response) {
                        var code = response.resultCode;
                        var msg = response.resultMsg;
                        if (code == "200") {
                            if (response.agrYn == "Y") {
                                return true;
                            } else {
                                var _msg = "위치정보 서비스 이용을 위해 위치정보약관에 동의해 주세요.\n";
                                _msg += "[위치정보 이용약관 동의 경로]\n";
                                _msg += "마이페이지 > 서비스 이용약관 > 위치기반 서비스 이용 약관 > 위치기반 서비스 이용약관 동의";
                                MPopup.confirm({
                                    // message: "위치정보 이용약관에 동의하지 않아 위치정보를 가져올 수 없습니다.",
                                    message: _msg,
                                    buttons: ["확인"],
                                    callback: function (idx) {
                                        MPage.back();
                                    }
                                });
                                throw Error("wait");
                            }
                        } else {
                            MPopup.instance(msg);
                            MPage.back();
                        }
                    }
                )
                .then(// gps 조회 혹은 에러 throw
                    function (response) {
                        if (response) {
                            return CurrPage.getGPS();
                        } else {
                            MPage.back();
                        }
                    }
                )
                .then(// gps 결과 사용자위치 셋팅
                    function (response) {
                        if (!isEmpty(response)) {
                            if (typeof response == "string") {
                                MPopup.confirm({
                                    message: response,
                                    buttons: ["확인"],
                                    callback: function (idx) {
                                        MPage.back();
                                    }
                                });
                            } else {
                                if (!isEmpty(response) && typeof response == "object") {
                                    CurrPage.userLocation = {lat: response.lat, lng: response.lng};
                                    return true;
                                } else {
                                    MPage.back();
                                }
                            }
                        }
                    }
                )
                .then(// AOD api 최종주차위치 결과 조회 및 셋팅
                    function () {
                        return CurrPage.getTaaSStatus(vin)
                            .then(
                                function (carStatus) {
                                    if(carStatus.resultCode == "200") {
                                        if(!isEmpty(carStatus.latitude) && !isEmpty(carStatus.longitude)){
                                            var latitude = parseFloat(carStatus.latitude);
                                            var longitude = parseFloat(carStatus.longitude);
                                            //현재 위치로 지도그림.
                                            CurrPage.lastParkLocation = {
                                                lat: latitude,
                                                lng: longitude
                                            };
                                            //삼각함수로 두지점간의 차이가 3km 이하인지 확인하기.
                                            var dist = getDistance(CurrPage.userLocation, CurrPage.lastParkLocation);
                                            if (dist > 3) {
                                                MPopup.confirm({
                                                    message: "차량의 위치와 고객님의 위치가 너무 멀리 떨어져 있습니다.\n본 서비스는 차량과 고객님의 거리가 3km 이내 일 경우에만 제공됩니다.",
                                                    buttons: ["확인"],
                                                    callback: function (idx) {
                                                        MPage.back();
                                                    }
                                                });
                                                return false;
                                            } else {
                                                return true;
                                            }
                                        }else{
                                            MPopup.confirm({
                                                message: "죄송합니다.\n차량의 주차 위치 조회에 실패하였습니다.",
                                                buttons: ["확인"],
                                                callback: function (idx) {
                                                    MPage.back();
                                                }
                                            });
                                        }
                                    }else if(result.code == "101"){
                                        MPopup.confirm({
                                            message: "출발지와 차량 위치가 동일하여 경로 안내가 종료되었습니다.",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }else if(result.code == "102"){
                                        MPopup.confirm({
                                            message: "죄송합니다.\n출발지 또는 차량의 위치가 확인되지 않습니다.",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }else if(result.code == "103" || result.code == "211" || result.code == "212" || result.code == "301" || result.code == "302"){
                                        MPopup.confirm({
                                            message: "죄송합니다.\n경로 안내 서비스 실행에 실패하였습니다.\n 다시 시도해 주세요.",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }else if(result.code == "201"){
                                        MPopup.confirm({
                                            message: "죄송합니다.\n출발지 또는 차량 위치가 경로 안내 서비스 불가 지역입니다..",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }else if(result.code == "213"){
                                        MPopup.confirm({
                                            message: "죄송합니다.\n출발지와 차량 위치 간 거리가 도보로 길 안내 불가능한 거리 입니다.",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }else if(result.code == "214"){
                                        MPopup.confirm({
                                            message: "죄송합니다.\n출발지가 경로 안내 서비스 불가 지역 입니다.",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }else{
                                        MPopup.confirm({
                                            message: "죄송합니다.\n차량의 주차 위치 조회에 실패하였습니다.",
                                            buttons: ["확인"],
                                            callback: function (idx) {
                                                MPage.back();
                                            }
                                        });
                                    }
                                }
                            );
                    }
                )
                .then(// 최종주차위치 마커그리기
                    function (isSuccess) {
                        if (isSuccess) {
                            //현재 위치로 지도그림.
                            //최종주차 위치 요청시 뒤집어져서 옴.
                            var center = CurrPage.lastParkLocation;
                            CurrPage.map = new KIA_ROUTO.Map("routoMap", {
                                center: center,
                                zoom: 17,                                           // 지도 로딩 시 최초 표시 레벨
                                maxZoom: 19,                                        // 지도의 최대 표시 레벨
                                minZoom: 7,                                         // 지도의 최소 표시 레벨
                                blockRotation: true,                                // 지도의 회전 제한 여부
                                keyboardEventTarget: document,                      // 지도에서 keyboard의 Event를 받을 Target 결정
                                markerZIndex: 9990004,                                  // Marker 를 표시 할 레이어의 z-index 값
                                constrainResolution: true,                          // Zoom in/out 시 resolution에 따라 고정할 것인지 여부(중간에 멈추는 현상 제거)
                                restriction: {west: 124.60, south: 33.114, east: 131.875, north: 42.59}    //
                            });
                            CurrPage.map.setCenter(center);
                            var markerCar = new KIA_ROUTO.Marker({
                                position: center,
                                map: CurrPage.map,
                                icon: "../../img/rnw/main/home/icon_pin_car.png",
                                zIndex: 99
                            });
                            var markerUser = new KIA_ROUTO.Marker({
                                position: CurrPage.userLocation,
                                map: CurrPage.map,
                                icon: "../../img/rnw/main/home/icon_pin_user.png",
                                zIndex: 98
                            });
                        }
                    }
                )
                .then(CurrPage.fnSetMapCont) // 내위치 ui 그리기
                .catch(function (msg) {
                    switch (msg) {
                        case "wait":
                            //do nothing!!
                            break;
                        default:
                            break;
                    }
                })// 에러발생시 페이지 닫음.
                .finally(CurrPage.setEventListner);// 이벤트 메핑하기
        } else {
            CurrPage.getTerms()//위치서비스 약관 동의 조회
                .then(//동의 유무에 따라 위치조회  or 알럿+페이지 닫음 에러 throw
                    function (response) {
                        var code = response.resultCode;
                        var msg = response.resultMsg;
                        if (code == "200") {
                            if (response.agrYn == "Y") {
                                return true;
                            } else {
                                var _msg = "위치정보 서비스 이용을 위해 위치정보약관에 동의해 주세요.\n";
                                _msg += "[위치정보 이용약관 동의 경로]\n";
                                _msg += "마이페이지 > 서비스 이용약관 > 위치기반 서비스 이용 약관 > 위치기반 서비스 이용약관 동의";
                                MPopup.confirm({
                                    // message: "위치정보 이용약관에 동의하지 않아 위치정보를 가져올 수 없습니다.",
                                    message: _msg,
                                    buttons: ["확인"],
                                    callback: function (idx) {
                                        MPage.back();
                                    }
                                });
                                throw Error("wait");
                            }
                        } else {
                            MPopup.instance(msg);
                            MPage.back();
                        }
                    }
                )
                .then(// gps 조회 혹은 에러 throw
                    function (response) {
                        if (response) {
                            return CurrPage.getGPS();
                        } else {
                            MPage.back();
                        }
                    }
                )
                .then(// gps 결과 사용자위치 셋팅
                    function (response) {
                        if (!isEmpty(response)) {
                            if (typeof response == "string") {
                                MPopup.confirm({
                                    message: response,
                                    buttons: ["확인"],
                                    callback: function (idx) {
                                        MPage.back();
                                    }
                                });
                            } else {
                                if (!isEmpty(response) && typeof response == "object") {
                                    CurrPage.userLocation = {lat: response.lat, lng: response.lng};
                                    return true;
                                } else {
                                    MPage.back();
                                }
                            }
                            return false;
                        }
                    }
                )
                .then(// 데이터허브 api 최종주차위치 결가 조회 및 셋팅
                    function (isSuccess) {
                        if(!isSuccess) return false;
                        return CurrPage.getLastParkLocation(carId)
                            .then(
                                function (response) {
                                    if (!isEmpty(response.errorCode)) {//통신응답오류
                                        var msg = "";
                                        if (response.errorCode == "404") {
                                            msg = "주차 정보가 없습니다.";
                                            MPopup.alert({
                                                message: msg,
                                                callback: function () {
                                                    CurrPage.lastParkLocation = null;
                                                    MPage.back();
                                                },
                                            });
                                        } else {
                                            msg = "네트워크 통신 에러";
                                            MPopup.alert({
                                                message: msg + " : " + response.errorCode,
                                                callback: function () {
                                                    CurrPage.lastParkLocation = null;
                                                    MPage.back();
                                                },
                                            });
                                        }
                                        new Error(msg + " : " + response.errorCode);
                                        return false;
                                    } else {
                                        if (isEmpty(response.errId)) {

                                            //현재 위치로 지도그림.
                                            //최종주차 위치 요청시 뒤집어져서 옴.
                                            CurrPage.lastParkLocation = {lat: response.lat, lng: response.lon};
                                            //삼각함수로 두지점간의 차이가 3km 이하인지 확인하기.
                                            var dist = getDistance(CurrPage.userLocation, CurrPage.lastParkLocation);
                                            if (dist > 3) {
                                                MPopup.confirm({
                                                    message: "차량의 위치와 고객님의 위치가 너무 멀리 떨어져 있습니다.\n본 서비스는 차량과 고객님의 거리가 3km 이내 일 경우에만 제공됩니다.",
                                                    buttons: ["확인"],
                                                    callback: function (idx) {
                                                        MPage.back();
                                                    }
                                                });
                                                return false;
                                            } else {
                                                return true;
                                            }
                                        } else {
                                            CurrPage.lastParkLocation = null;
                                            MPage.back();
                                            return false;
                                        }
                                    }
                                }
                            );
                    }
                )
                .then(// 최종주차위치 마커그리기
                    function (isSuccess) {
                        if (isSuccess) {
                            //현재 위치로 지도그림.
                            //최종주차 위치 요청시 뒤집어져서 옴.
                            var center = CurrPage.lastParkLocation;
                            CurrPage.map = new KIA_ROUTO.Map("routoMap", {
                                center: center,
                                zoom: 17,                                           // 지도 로딩 시 최초 표시 레벨
                                maxZoom: 19,                                        // 지도의 최대 표시 레벨
                                minZoom: 7,                                         // 지도의 최소 표시 레벨
                                blockRotation: true,                                // 지도의 회전 제한 여부
                                keyboardEventTarget: document,                      // 지도에서 keyboard의 Event를 받을 Target 결정
                                markerZIndex: 9990004,                              // Marker 를 표시 할 레이어의 z-index 값
                                constrainResolution: true,                          // Zoom in/out 시 resolution에 따라 고정할 것인지 여부(중간에 멈추는 현상 제거)
                                restriction: {west: 124.60, south: 33.114, east: 131.875, north: 42.59}    //
                            });
                            CurrPage.map.setCenter(center);
                            var marker = new KIA_ROUTO.Marker({
                                position: center,
                                map: CurrPage.map,
                                icon: "../../img/rnw/main/home/icon_pin_car.png",
                                zIndex: 99
                            });
                        }
                    }
                )
                .then(CurrPage.fnSetMapCont) // 내위치 ui 그리기
                .catch(function (msg) {
                    switch (msg) {
                        case "wait":
                            //do nothing!!
                            break;
                        default:
                            break;
                    }
                })// 에러발생시 페이지 닫음.
                .finally(CurrPage.setEventListner);// 이벤트 메핑하기
        }
    },
    map: null,
    lastParkLocation: null,
    setEventListner: function () {
        exWNHideIndicator();
        CurrPage.setPublishEventListner();

        /**
         * 내위치 표시
         */
        $("button.btn-map-current").off().on("click", function () {
            CurrPage.map.setCenter(CurrPage.userLocation);
            //  사용자위치 마커 표시
            var marker = new KIA_ROUTO.Marker({
                position: CurrPage.userLocation,
                map: CurrPage.map,
                icon: "../../img/rnw/main/home/icon_pin_user.png",
                zIndex: 98
            });
        });

        /**
         *  도보로 길찾기
         *  */
        $("#findWorkPathBtn").off("click").on("click", function () {
            if ($("#findWorkPathBtn").is(".done")) {
                $(".btn-close").click();
                return;
            }

            exWNShowIndicator();
            var to = CurrPage.lastParkLocation;
            var from = CurrPage.userLocation;
            routoMapFindWorkPathAsync(from, to)
                .then(
                    function (result) {
                        exWNHideIndicator();
                        if (!isEmpty(result) && result.ResultCode == 0) {
                            console.dir(result);
                            //버튼 텍스트 변경
                            $("#findWorkPathBtn em").text("확인");
                            $("#findWorkPathBtn").addClass("done");
                            var _sum = result.RouteSummary;
                            var html = '';
                            if (!isEmpty(_sum)) {

                                var totalDistance = (_sum.TotalDistance / 1000).toFixed(1);//미터=>km
                                var totalTime = parseInt(_sum.TotalTime / 60);//초->분
                                html += '<div class="location-info d-flex">';
                                if (totalTime > 59) {
                                    var hour = parseInt(totalTime / 60);
                                    var min = hour % 60;
                                    html += '<span class="line">약 <em>' + hour + '</em>시간 <em>' + min + '</em>분</span>';
                                } else {
                                    html += '    <span class="line">약 <em>' + totalTime + '</em>분</span>';
                                }
                                html += '    <span>약 <em>' + totalDistance + '</em>km</span>';
                                html += '</div>';
                                $("#summeryTarget").find("div.btn-block").before($(html));
                            }

                            var _path = result.RouteShape;
                            var latLngList = result.RouteShape.map(function (item) {
                                return {lat: item.y, lng: item.x};
                            })
                            var polyline = null;

                            function createPolyline() {
                                if (polyline == null) {
                                    polyline = new KIA_ROUTO.Polyline({
                                        path: latLngList,
                                        strokeColor: "#5cf14a",
                                        strokeOpacity: 1.0,
                                        strokeWeight: 2,
                                        arrow: true,
                                        lineDash: [1, 6],
                                        map: CurrPage.map,
                                    });
                                }
                            }

                            CurrPage.map.clearMarker();
                            createPolyline();
                            var markerCar = new KIA_ROUTO.Marker({
                                position: to,
                                map: CurrPage.map,
                                icon: "../../img/rnw/main/home/icon_pin_car.png",
                                zIndex: 99
                            });
                            var markerUser = new KIA_ROUTO.Marker({
                                position: from,
                                map: CurrPage.map,
                                icon: "../../img/rnw/main/home/icon_pin_user.png",
                                zIndex: 98
                            });
                        } else {
                            console.error("err code: " + result.ResultCode + ", err msg : " + result.ErrorMsg);
                        }
                    }
                );
        });

    },
    setPublishEventListner: function () {

        function fnMapAreaCtrl() {
            var $mapCont = $('.js-map-cont:visible');
            var $navMapBtns = $('.js-nav-map-btns:visible');
            var $floatingLayer = $('.js-floating-layer:visible');
            var $draggableBtn = $('.js-draggable-btn:visible');
            var $floatingLayerBody = $('.js-floating-layer-body:visible');
            var $homeHeaderHeight = $('#homeHeader:visible').outerHeight();
            var $searchContentHeight = $('#searchContent:visible').outerHeight();
            var $draggableBtnHeight = $('.js-draggable-btn:visible').outerHeight();
            var floatingLayerInitTop = 42;

            // $('body').removeClass('js-overflow-hidden');
            fnGetMapAreaHeight(); // 처음 실행

            $('.js-floating-layer:visible').draggable({
                handle: $draggableBtn,
                axis: 'y',

                // 현재 이동이 발생하기 직전, 드래그하는 동안 마우스가 이동되는 동안 트리거
                drag: function (event, ui) {
                    //console.log('stopEvent', event)
                    //console.log('stopUI', ui)

                    //console.log('ui.offset.top', ui.offset.top)

                    // .js-floating-layer의 mintop, maxtop 높이를 잡아준다
                    var layerMinTop = 80;
                    var layerMaxTop = $searchContentHeight - 38;

                    console.log('ui.offset.top', ui.offset.top)
                    console.log('layerMinTop', layerMinTop)
                    console.log('layerMaxTop', layerMaxTop)

                    //if (ui.offset.top <= 80 || ui.offset.top >= 815) {
                    if (ui.offset.top <= layerMinTop || ui.offset.top >= layerMaxTop) {
                        return false;
                    }

                    // .floating-layer 확장 펼침 상태 : 버튼영역 비노출
                    // if (ui.offset.top <= 160) {
                    if (ui.offset.top <= (layerMinTop * 2)) {
                        $navMapBtns.addClass('js-hidden');
                    } else {
                        $navMapBtns.removeClass('js-hidden');
                    }

                    // .floating-layer 접힘 상태 : 검색버튼 노출
                    // if (ui.offset.top >= 700) {
                    if (ui.offset.top >= (layerMaxTop - layerMinTop)) {
                        $navMapBtns.find('.btn-map-search').removeClass('js-hidden');
                    } else {
                        $navMapBtns.find('.btn-map-search').addClass('js-hidden');
                    }

                    setTimeout(function () {
                        fnGetMapAreaHeight();
                    }, 600);
                },
                // 드래그 가능이 생성될 때 트리거
                create: function (event, ui) {
                },
                // 드래그가 시작될 때 트리거
                start: function (event, ui) {
                },
                // 드래그가 중지되면 트리거
                stop: function (event, ui) {
                },
            });

            function fnGetMapAreaHeight() {
                var mapContHeight;
                var floatingLayerBodyHeight;
                if ($floatingLayer.length > 0) {
                    // mapCont 높이값을 구한다
                    mapContHeight = $floatingLayer.offset().top - 5;
                    mapContHeight = mapContHeight / 10;
                    $mapCont.css('height', mapContHeight + 'rem');

                    // floating-layer-body 높이값을 구한다
                    floatingLayerBodyHeight = $searchContentHeight - ($floatingLayer.offset().top + $draggableBtnHeight + $homeHeaderHeight);
                    floatingLayerBodyHeight = floatingLayerBodyHeight / 10;
                    $floatingLayerBody.css('height', floatingLayerBodyHeight + 'rem');

                    //console.log('mapContHeight', mapContHeight)
                    //console.log('floatingLayerBodyHeight', floatingLayerBodyHeight)
                }
            }
        }

        // ------------------------------
        // 	Scroll
        // ------------------------------
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        var $floatingLayerBody = $('.js-floating-layer-body');

        /* 20220408//(Ina)$floatingLayerBody영역 scrollend 스크립트 추가(s) */
        $floatingLayerBody.scroll(function (e) {
            var $nowTop = $(this).scrollTop();

            fnMapAreaCtrl();

            if (($floatingLayerBody[0].scrollHeight - $floatingLayerBody.scrollTop()) == $floatingLayerBody.outerHeight()) {
                console.log('scrollEnd');
            }

            $winTop = $nowTop;
        });
        /* 20220408//(Ina)$floatingLayerBody영역 scrollend 스크립트 추가(e) */

        // ------------------------------
        // 	Map
        // ------------------------------
    },
    getLastParkLocation: function (_carId) {
        var options = {
            isMock: false,
            indicatorYn: "N",
            path: _API.HUB.parklocation.verifyUrl(_carId).path,
            method: CONSTANT.NET_MTHD.GET
        }
        return MNet_Hub.httpSendAsync(options);
    },
    getTaaSStatus: function(tvin){
        return new Promise(function(resolve){
            MNet.httpSendAsyncAsIs({
                path: _API.SVR.HOME.carinfo.TaaSOdometerNbattery,
                sendData: {
                    apiId : "RNW-HOM-8001",
                    mbrId : PGV.loginInfo.mbrId,
                    vin: tvin
                },
                indicatorYn : "N"
            })
                .then(function(response){
                    if (response.resultCode == "200") {
                        resolve(response);
                    }else{
                        resolve(response);
                    }
                });
        })
    },
    setLocationConn: function(num){
        var sendData = {
            apiId: 'RNW-CMM-9100',
            mbrId: PGV.loginInfo.mbrId,
            funnels: num
        }

        MNet.httpSend({
            path: _API.SVR.CMM.code.locationConnCsmrInfoRgst,
            indicatorYn: "N",
            sendData: sendData,
            isMock: false,
            callback : function(receivedData){
                var code = receivedData.resultCode;
            }
        })
    },
    fnSetMapCont: function () {
        var _mapCont;

        __mapCont = '';
        _mapCont += '<div class="map-cont js-map-cont">';
        _mapCont += '<div class="btn-map-transparent"></div>';
        _mapCont += '<div class="nav-map-btns js-nav-map-btns">';
        _mapCont += '<button type="button" class="btn-map-current case2" id="btnMapcurrent"><em class="blind">현위치로 이동</em></button>';
        // _mapCont += 		'<button type="button" class="btn-map-search js-hidden" id="btnMapSearch">현 지도에서 검색</button>';
        _mapCont += '</div>';
        _mapCont += '</div>';

        $('#routoMap').find('.ol-viewport').append(_mapCont);
    },

    getTerms: function () {
        var options = {//위치기반서비스 이용약관 동의유무check
            path: inf.terms.selectTermsAgreeYn.url,
            sendData: {
                agrYn: "",
                mbrId: PGV.loginInfo.mbrId,
                termsItmCd: "109",
                termsKndCcd: "105"
            },
        };
        return MNet.httpSendAsyncAsIs(options);
    },
    getGPS: function () {
        CurrPage.gpsInfo = null;
        return new Promise(function (resolve, reject) {
            function callBackGPSFunc(type, result) {
                if (type == CHECK_GPS_TYPE.SUCCESS) {
                    if (CONFIG.IS_DEV && isEmpty(result.coords)) {
                        CurrPage.gpsInfo = '위치정보를 가져올 수 없습니다.';
                    } else {
                        CurrPage.gpsInfo = {
                            lat: Math.abs(result.coords.latitude),
                            lng: Math.abs(result.coords.longitude)
                        };
                    }
                } else {
                    CurrPage.gpsInfo = '위치정보를 가져올 수 없습니다.';
                }
            };
            onResultGPS(callBackGPSFunc, true);
            var delay = 0;
            setTimeout(function getGpsInfo() {
                var hasResult = !isEmpty(CurrPage.gpsInfo) && (typeof CurrPage.gpsInfo == "string" || typeof CurrPage.gpsInfo == "object");
                if (hasResult) {
                    resolve(CurrPage.gpsInfo);
                    clearTimeout(getGpsInfo);
                } else {
                    delay += 500;
                    setTimeout(getGpsInfo, delay);
                }

            }, delay);
        })

    }
}
var setPublishOnReadyEventListner = function () {
    // ------------------------------
    // 	Slider
    // ------------------------------
    var _sliderFilterList = new Swiper('.slider-filter-list', {
        spaceBetween: 0,
        slidesPerView: 'auto',
        //centeredSlides:true,
        loopedSlides: 1,
        loop: false,
        speed: 300,
        grapCursor: true,
        observer: true,
        observParents: true,
        resistanceRatio: 0 //드래그 저항비율 제어
    });

    $('.slider-filter-list .swiper-slide').on('click', function (e) {
        e.preventDefault();
        var getSlideIdx = $(this).data('slide-index');
        //console.log('getSlideIdx', getSlideIdx)
        _sliderFilterList.slideTo(getSlideIdx, 300, false);
        $('.slider-filter-list').find('.active').removeClass('active');
        $('.slider-filter-list').find('.swiper-slide[data-slide-index=' + getSlideIdx + ']').addClass('active');
    });

};
/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        setPublishOnReadyEventListner();
        KIA_RNW_123_0000.init();
    },
    onHide: function (event) {
    },
    onRestore: function (event) {
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy: function (event) {
    },
    onPause: function (event) {
    },
    onResume: function (event) {
    }
};
