/**

@파일명 : KIA_RNW_126_0000.js 
@작성자 : 케이스마텍 정목단
@생성일 : 2022.04.13
@메뉴명 : 홈 > 내 차고
@DESC : 전체메뉴노출[X], 로그인[O] 차량보유[O]
*/ 
var CurrPage; 
var KIA_RNW_126_0000 ={
    representCarUpdate:false,
    currentScopeSelectCar:null,
    init: function(){ 
        CurrPage = this;
        if(isEmpty(CMM_HOME))CMM_HOME = new cmmHome();
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var car = PGV.passData.car;
        var myCar = isEmpty(car.myCarInfoListResDto)?[]:sortJsonArrayList(car.myCarInfoListResDto,"dispNo");
        var undeliveredCar = isEmpty(car.unDeliveryCarInfoListResDto)?[]:car.unDeliveryCarInfoListResDto;
        var cnt = myCar.length+undeliveredCar.length;
        CurrPage.uiTitle(cnt);
        if (cnt > 0) CurrPage.uiCarList(myCar, undeliveredCar);
        CurrPage.setEventListner();
    },
    setEventListner: function(){
        // do something..
        $("button.btn-star").off().on("click",function(e){
            e.stopPropagation();
            //todo 대표차량 변경하기 호출
            var _$this = $(this);
            var _vin = _$this.closest('div.div-item').data("carVin");
            var sendData ={mbrId: PGV.loginInfo.mbrId, vin:_vin};
            CMM_NET_SVR.postRepresentCarUpdate(sendData)
                .then(
                    function(response){
                        if(response.resultCode==="200"&&response.setupYn==="Y"){
                            $('button.btn-star i.ico-star').removeClass("off").addClass("off");
                            _$this.find("i.ico-star.off").removeClass("off");
                            PGV.passData.representCar = _$this.closest('div.div-item').data("carData");
                            CurrPage.representCarUpdate=true;
                            exWNHideIndicator();
                            MPopup.instance("대표차량이 변경되었습니다.");
                        }
                    }
                );

        });


        var homeSelectedCar = PGV.passData.car.selectCar;
        /***
         * 홈 차량 선택 변경
         */
        $("div.div-item").off().on("click",function(e){
            e.preventDefault();

            var _$thisBtn = $(this);
            var currentScopeSelectCar = _$thisBtn.closest("div.div-item").data("carData");

            var options = {param: {hasToHomeReload: false}};
            if($("div.div-carInfo div.div-item").length>1){
                var sameOwnCarWithHome = homeSelectedCar.vin !== currentScopeSelectCar.vin
                var isHomeSelectedContractCar = homeSelectedCar.isContract;
                var isThisSelectedContractCar = currentScopeSelectCar.isContract;
                if(isHomeSelectedContractCar&&isThisSelectedContractCar){//둘다계약차
                    if(homeSelectedCar.contNo !== currentScopeSelectCar.contNo){
                        options.param.hasToHomeReload = true;
                        options.param.changeSelectCar = currentScopeSelectCar;
                    }
                }else{
                    options.param.hasToHomeReload = true;
                    options.param.changeSelectCar = currentScopeSelectCar;
                }
            }

            MPage.back(options);
        });
        $("#moveToHomeBtn").off().on("click",function(e){
            e.preventDefault();
            var nowRepCarData = $('button i.ico-star').not('.off').closest('div.div-item').data("carData");
            if(isEmpty(nowRepCarData)) nowRepCarData = $("div.div-carInfo div.div-item").eq(0).data("carData");
            var options = {param: {hasToHomeReload: false}};
            if(homeSelectedCar.vin !== nowRepCarData.vin){
                options.param.hasToHomeReload = true;
                options.param.changeSelectCar = PGV.passData.car.selectCar;
            }
            MPage.back(options);
        });

    },
    uiTitle: function (cnt) {
        var html =
            '<h3 class="text-scale-03">' +
            '<b>'+PGV.loginInfo.mbrNm+'님의 차량은 <br> '+cnt+'대입니다.</b>' +
            '</h3>';
        $("div.myGarage").find(".div-title").html(html);
    },
    uiCarList:function(myCar, undeliveredCar){
        var html ="";
        for (var i = 0; i < myCar.length; i++) {
            var car = myCar[i];
            html+=CMM_HOME.htmlCarInfo(car);
        }
        for (var i = 0; i < undeliveredCar.length; i++) {
            var car = undeliveredCar[i];
            html+=CMM_HOME.htmlCarInfo(car);
        }
        $("div.myGarage .div-carInfo").html(html);
        var repVin = PGV.passData.representCar.vin;

        $('div.myGarage .div-carInfo').find('[data-car-vin='+repVin+']')
            .each(function(i,item){
               if(i==0){
                   $(this).find("i.ico-star").removeClass("off");
               }
            });

    },
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage);
        CMM_HOME = new cmmHome();
        KIA_RNW_126_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    onBack : function(){
        var currentScopeSelectCar = $('button i.ico-star').not('.off').closest('div.div-item').data("carData");
        if(isEmpty(currentScopeSelectCar)) currentScopeSelectCar = $("div.div-carInfo div.div-item").eq(0).data("carData");
        var options = {param: {hasToHomeReload: false}};
        if(PGV.passData.car.selectCar.vin !== currentScopeSelectCar.vin){
            options.param.hasToHomeReload = true;
            options.param.changeSelectCar = PGV.passData.car.selectCar;
        }
        MPage.back(options);
    },
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
