/**
 * @파일명 : KIA_MOB_500_1400.js==>KIA_RNW_127_3000.js
 * @작성자 : 이현석
 * @생성일 : 2019. 3. 4. 오후 1:41:39
 * @메뉴명 : 차량복구 
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	delCkbCarsList();
	/**
	 * 화면 이벤트
	 */
	setEvent();
	
};

var setEvent = function() {
	// 복구 버튼 클릭시 
	$(document).on("click", "[data-rgst-no]", function(){
		var carDelNo = $(this).data("rgstNo");
		var vin = $(this).data("vinNo");
		recoveryCkbCars(carDelNo, vin);
	});
	$("button.btn-close").off().on("click",function (e){
		e.preventDefault();
		var isRecoverCarData = MData.global("delUser");
		MData.removeGlobal("delUser");
		isRecoverCarData = isEmpty(isRecoverCarData)?false:isRecoverCarData;
		MPage.back({param:{hasToHomeReload:isRecoverCarData,isUserCarsChanged:isRecoverCarData}});
	});
};

/**
 * 차량 삭제 리스트 전문
 */
var delCkbCarsList = function(){
	MNet.httpSend({
		isMock: false,
		path : _API.SVR.HOME.ckb.deleteCkbCarsList,
		sendData : {mbrId: PGV.loginInfo.mbrId},
		callback : delCkbCarsListCallBack
	});
}

/**
 * 차량 삭제 리스트 콜백
 */
var delCkbCarsListCallBack = function(receivedData){
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	var delCarList = receivedData.deleteCarListRnwResDto;
	var realList = [];
	if(code == "200"){
		for (var i = 0; i < delCarList.length; i++) {
			var obj = delCarList[i];
			if(obj.existNo == "Y"){
				realList.push(obj);
			}
		};
		
		makeList(realList);
	}else{
		$(".no-data").removeClass('none');
		MPopup.alert(msg);
	}
};

var makeList = function(list){
	exWNHideIndicator();
	var strBuffD = '';
	$("#delCarList").html('');
	if(list.length > 0){
		for (var i = 0; i < list.length; i++) {
				var obj = list[i];
				if(obj.existNo == "Y"){
                    strBuffD += '<li>';
                    strBuffD += '   <p class="sub-tit">'+$.trim(obj.carNo)+'('+$.trim(obj.ckRcdNm)+')</p>';
                    //strBuffD += '   <p class="cmt-point-txt">'+$.trim(obj.delDateCount)+'일 후 영구삭제</p>';
                    strBuffD += '   <button class="link mt12" type="button" data-rgst-no='+$.trim(obj.delRgstNo)+' data-vin-no='+$.trim(obj.vin)+'>복구</button>';
                    strBuffD += '</li>';
				}
			}
		$(".no-data").addClass('none');
		$("#delCarList").removeClass('none');	
		$("#delCarList").html(strBuffD);		
	}else{
		$(".no-data").removeClass('none');
		$("#delCarList").addClass('none');
	}
}

/**
 * 복구 전문 
 */
var recoveryCkbCars = function(carDelNo, vin){
	MNet.httpSend({
		isMock: false,
		path : _API.SVR.HOME.ckb.recoveryCkbCars,
		sendData : {
			mbrId : PGV.loginInfo.mbrId,
		    vin : vin,
		    delRgstNo : carDelNo
		},
		callback : recoveryCkbCarsCallback
	});
};


/**
 * 복구 콜백 전문 2019년 03
 */
var recoveryCkbCarsCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){
		synchCheck();
		return false;
	}else{
		MPopup.alert(msg);
		return false;
	}
};

/**
 * 동기화
 */
var synchCheck = function(){
	MNet.httpSend({
		path : _API.SVR.CMM.owncar.updateOwncarList,
		sendData : {
			mbrId : PGV.loginInfo.mbrId	// 04:고객관리번호
		},
		callback : synchCheckCallback
	});
};


/**
 * 동기화 콜백 전문
 */
var synchCheckCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;

	if(code == "200"){
		MPopup.instance(msg);
		MData.global("delUser", true);
		garbageAll(); // 중간 스택 제거
		stackRemove("KIA_RNW_127_0000.html");
		delCkbCarsList();
	}else{
		MData.global("delUser", false);
		MPopup.instance("차량 데이터 복구에 실패하였습니다.");
	}
	return;
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
	onBack : function(){
		var isRecoverCarData = MData.global("delUser");
		MData.removeGlobal("delUser");
		isRecoverCarData = isEmpty(isRecoverCarData)?false:isRecoverCarData;
		MPage.back({param:{hasToHomeReload:isRecoverCarData}});
	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};