/**
 * @파일명 : KIA_MOB_500_1040.js
 * @작성자 : 이현석
 * @생성일 : 2018. 8. 9. 오전 11:57:05
 * @메뉴명 : 사양정보
 */
var pageInit = function(){
	/**
	 * 초기화
	 */
	PGV.carInfo = MData.param("carInfo");
	MData.removeParam("carInfo");
    if(!isEmpty(PGV.carInfo)){
        $("#carNm").html(PGV.carInfo.mdlNm);
    }
	selectSpecInfoList();
	// screenViewGa(gaSendUrl["KIA_MOB_500_1040"].pageNm);//2020 공통으로 변경

	/**
	 * 화면 이벤트
	 */
	setEvent();
	
};

var setEvent = function() {
    //탭 콘텐츠 펼침
    $('.accordion .title').on('click', function(){
        if($(this).parent('.accordion').hasClass('on')){
            $(this).parent('.accordion').removeClass('on');
        }
        else {
            $('.accordion').removeClass('on');
            $(this).parent('.accordion').addClass('on');
        }
    });


	$(document).on("click", ".tab button", function(){	//사양정보 디테일
		var that = $(this);
		var specDetail = "";
		var idx = null;
		if(that.parent().hasClass("on")){
			return false
		};
		for(var i=0; i<PGV.carSpec.length; i++){
			if(PGV.carSpec[i].cateNm == that.text()){
				idx = i;
			};
		};
		
		$(".tab button").parent().removeClass("on");
		that.parent().addClass("on");
		
		if(PGV.carSpec[idx] && !isEmpty(PGV.carSpec[idx])){
			var list = PGV.carSpec[idx].specInfoListResDto || [];
			for(var i=0; i<list.length; i++){
				var obj = list[i];
				specDetail += '<tr><th>'+obj.cate2+'</th>';
				specDetail += '<td>'+obj.optName+'</td></tr>'
			}
			$("#specDetail").html(specDetail);
		}

		if(isEmpty(specDetail)){
			showingViewIsData(false);
		}else{
			showingViewIsData(true);
		}
		
	});	
};

/**
 * 차량스펙 조회
 */
var selectSpecInfoList = function(){
	MNet.httpSend({
		isMock:false,
		path : _API.SVR.HOME.carspec.specInfoList,
		sendData : {
			vin: PGV.carInfo.vin,
			mbrId: PGV.loginInfo.mbrId
		},
		callback : selectSpecInfoListCallBack
	});
};

var selectSpecInfoListCallBack = function(receivedData){
	exWNHideIndicator();
	var resultCode = receivedData.resultCode;
	var resultMsg = receivedData.resultMsg;
	var specArray = receivedData.specGroupListRnwResDto;
	if(resultCode == "200"){
		makeHtml(specArray);
	}else{
		MPopup.alert(resultMsg);
	}
}

var makeHtml = function(specArray){
    if(specArray == null){
        // 차량 사양 정보 없을때
        $("#carSpecWrap").addClass("none");
        $("#noCarSpecData").removeClass("none");
        return;
    }
	var listArray = [];
	var sortListArray = ["제원","편의","안전","외관","시트"];
	var idx = null;

    // TODO : length > 0 체크 추가
    if(specArray.length > 0){

        for(var i=0; i<sortListArray.length; i++){
            var cateArray = [];
            var _idx = _.findIndex(specArray, {cateNm : sortListArray[i]});
			if(_idx>-1){
				var specInfoListRnwResDto = specArray[_idx].specInfoListRnwResDto;
				for(var j=0; j<specInfoListRnwResDto.length; j++){
					cateArray.push(specInfoListRnwResDto[j]);
				}
            	listArray.push(cateArray);
			}
        }

        PGV.carSpec = listArray;

        for(var i=0; i<listArray.length; i++){
            var specDetail = "";
            for(var j=0; j<listArray[i].length; j++){
                specDetail += '             <li class="">';
                specDetail += '                 <div class="listbox">';
                specDetail += '                     <p class="sub-tit">'+listArray[i][j].cate2+'</p>';
                specDetail += '                     <span class="sub-tit algn-r">'+listArray[i][j].optName+'</span>';
                specDetail += '                 </div>';
                specDetail += '             </li>';
            }
            $("#specIdx"+i).append(specDetail);
        }

	}else{
	    // 차량 사양 정보 없을때
	    $("#carSpecWrap").addClass("none");
	    $("#noCarSpecData").removeClass("none");
	}
}


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};