/**
 * @파일명 : KIA_MOB_500_1060.js===>KIA_RNW_127_5000.js
 * @작성자 : 이현석
 * @생성일 : 2018. 8. 9. 오전 11:57:05
 * @메뉴명 : 차량출고 계약정보
 */
var pageInit = function(){
	/**
	 * 초기화
	 */
	PGV.carInfo = MData.param("carInfo");
	MData.removeParam("carInfo");
	// screenViewGa(gaSendUrl["KIA_MOB_500_1040"].pageNm);//2020 공통으로 변경

	var proccessIntro = new Promise(function(resolve){
		selectCarContInfo();
		selectReceiptInfo();
		resolve();
	});
	proccessIntro.then(setEvent).finally(exWNHideIndicator);
	
};

var setEvent = function() {
    //탭 콘텐츠 펼침
    $('.accordion .title').on('click', function(){
        if($(this).parent('.accordion').hasClass('on')){
            $(this).parent('.accordion').removeClass('on');
        }
        else {
            $('.accordion').removeClass('on');
            $(this).parent('.accordion').addClass('on');
        }
    });

    // info 팝업
    $('.btn-infoPop').on('click',function(){
        //console.log('dfd' + $(this).hasClass('on'));
        if($(this).hasClass('on')){
            $(this).removeClass('on');
            $(this).parents('tr').next('.btn-infowrap').removeClass('on');
        }
        else {
            $('.btn-infoPop').removeClass('on');
            $('.btn-infowrap').removeClass('on');
            $(this).addClass('on');
            $(this).parents('tr').next('.btn-infowrap').addClass('on');
        }
    });
    $('.btn-infowrap').on('click',function(){
        $(this).removeClass('on');
        $(this).prev('tr').children('td').find('.btn-infoPop').removeClass('on');
        $(this).prev('tr').children('th').find('.btn-infoPop').removeClass('on');
    });
    // - info 팝업
};


/**
 * 계약 및 출고내역 조회 contractInfoBtn
 */
var selectCarContInfo = function(){
	var selectCarContInfoCallback = function (receivedData) {
		exWNHideIndicator();
		var resultCode = receivedData.resultCode;
		var resultMsg = receivedData.resultMsg;
		var now = moment(new Date()); //todays date

		if (resultCode == "200") {
			if(isEmpty(receivedData.contNo)){ 		//데이터 없을 경우
				$("#contractYearBefore").addClass('none');
				$("#contractYearAfter").removeClass('none');
				return false;
			}
			$("#contractYearBefore").removeClass('none');
			var releaseDay = receivedData.dlvDy;
			$("#krspcNm").html(receivedData.krspcNm);						// 계약차종명
			$("#contNum").html(receivedData.contNo);							// 계약번호
			var purchaseAmount = isEmpty(receivedData.totSalAmt)?"0":comma.add(receivedData.totSalAmt);
			$("#purchaseAmount").html(purchaseAmount + " 원");	// 구입금액
			var deliveryAmount = isEmpty(receivedData.tpAmt)?"0":comma.add(receivedData.tpAmt);
			$("#deliveryAmount").html(deliveryAmount + " 원");	// 인도금 입금액
			$("#contDate").html(DateUtil.getYMD(receivedData.contDy));		// 계약일
			if (!isEmpty(releaseDay)) {
				var end = moment(releaseDay); // another date
				var duration = moment.duration(now.diff(end));
				var days = duration.asDays();
				if (15 > days) {
					//$("#releaseDate").html(DateUtil.getYMD(releaseDay)+'<button type="button" class="btn-txt right" data-link-url="KIA_MOB_500_1060_P">탁송조회</button>');		// 실제출고일
					$("#releaseDate").html(DateUtil.getYMD(releaseDay));		// 실제출고일
				} else {
					$("#releaseDate").html(DateUtil.getYMD(releaseDay));		// 실제출고일
				}
			}


			$("#marketingPerson").html(isEmpty(receivedData.empNm) ? "-" : receivedData.empNm);					// 영업담당
		} else if (resultCode == "400") {
			MPopup.instance("계약정보 조회에 실패하였습니다.");
			$("#contractYearBefore").addClass('none');
			$("#contractYearAfter").removeClass('none');
		} else {
			MPopup.alert(resultMsg);
		}
	}
	var sendData = {
		mbrId: PGV.loginInfo.mbrId,
		vin : PGV.carInfo.vin // 차대 번호 추가 09/17
	};
	MNet.httpSend({
		isMock: false,
		path : _API.SVR.HOME.car.eachContInfo,
		sendData : sendData,
		callback : selectCarContInfoCallback,
		errorCallback : function (errCode,errMsg){
			MPopup.instance("오류가 발생하였습니다.");
			return;
		}
	});
};

/**
 * 차량구입대금 명세서 조회 purchaseInfoBtn
 */
var selectReceiptInfo = function(){
	var selectReceiptInfoCallback = function(receivedData){
		exWNHideIndicator();
		objectValueNullCheck(receivedData);//null 이면 공백으로 변경
		var resultCode = receivedData.resultCode;
		var resultMsg = receivedData.resultMsg;
		if(resultCode !== "200"){
			//MPopup.instance("구입대금 명세 조회에 실패하였습니다.");
			$("#oneYearBefore").addClass('none');
			$("#oneYearAfter").removeClass('none'); //1년이 지나면 데이터 안보여줌
			return false;
		}
		else{
			if(isEmpty(receivedData.saleCnttNo)){ 		//데이터 없을 경우
				$("#oneYearBefore").addClass('none');
				$("#oneYearAfter").removeClass('none');
				return false;
			}

			var startTime = moment(receivedData.dlvDy).format();//출고일
			var endTime = moment().format();
			var chkDay = moment.duration(moment(endTime).diff(startTime));
			var days = chkDay.asDays();

			if(365 > days){
				$("#oneYearBefore").removeClass('none'); //1년이 지나면 데이터 안보여줌
				$("#oneYearAfter").addClass('none');
			}else{
				$("#oneYearBefore").addClass('none');
				$("#oneYearAfter").removeClass('none'); //1년이 지나면 데이터 안보여줌
				return false;
			}
			//포인트 합
			var pointTotalCacul = function(A_1, A_2, A_3, B_1, B_2, B_3){
				var pointA = parseInt(A_1) + parseInt(A_2) + parseInt(A_3);
				var pointB = parseInt(B_1) + parseInt(B_2) + parseInt(B_3);
				var totalPoint = pointA + pointB;
				return totalPoint;
			}

			var pointTotal = pointTotalCacul(receivedData.spntRcpsAmt, receivedData.crdPRcpsAmt, receivedData.alpPRcpsAmt, receivedData.spntAmt, receivedData.crdPAmt, receivedData.alpPAmt);

			//차량구입내역
			//$("#textPoint").html('('+receivedData.saleMdlNm+')차량구입시 총(<em class="txtclr-r">'+comma.add(pointTotal)+'</em>)포인트를 사용하셨습니다.<br />(포인트 사용 ⓐ+ⓑ)' ) //상위 차량구매 포인트 관련
			var carPrice=isEmpty(receivedData.carPce)?"0":comma.add(receivedData.carPce);
			$("#carPrice").text(carPrice+" 원");		// 차량가격
			var cnsgSalsAmt=isEmpty(receivedData.cnsgSalsAmt)?"0":comma.add(receivedData.cnsgSalsAmt);
			$("#cnsgSalsAmt").text(cnsgSalsAmt+" 원");		// 탁송료
			var dcAmt=isEmpty(receivedData.dcAmt)?"0":comma.add(receivedData.dcAmt);
			$("#dcAmt").text(dcAmt+" 원");			// 당사할인
			var spntRcpsAmt=isEmpty(receivedData.spntRcpsAmt)?"0":comma.add(receivedData.spntRcpsAmt);
			$("#spntRcpsAmt").text(spntRcpsAmt+" P");			// 세이프포인트
			var crdPRcpsAmt=isEmpty(receivedData.crdPRcpsAmt)?"0":comma.add(receivedData.crdPRcpsAmt);
			$("#crdPRcpsAmt").text(crdPRcpsAmt+" P");			// M포인트
			var alpPRcpsAmt=isEmpty(receivedData.alpPRcpsAmt)?"0":comma.add(receivedData.alpPRcpsAmt);
			$("#alpPRcpsAmt").text(alpPRcpsAmt+" P");			// 기아멤버스
			var istmIntVat=isEmpty(receivedData.istmIntRt)?"0":comma.add(receivedData.istmIntRt);
			$("#istmIntVat").text(istmIntVat+" 원");			// 자체할부이자
			var carPuchFAmt=isEmpty(receivedData.istmIntVat)?"0":comma.add(receivedData.istmIntVat);
			$("#carPuchFAmt").text(carPuchFAmt+" 원");			// 할부이자부가세
			var totalPrice=isEmpty(receivedData.carPuchFAmt)?"0":comma.add(receivedData.carPuchFAmt);
			$("#totalPrice").text(totalPrice+" 원");			// 판매가격


			//차량입금내역
			var n1RcpsAmt=isEmpty(receivedData.whotPreRcpsAmt)?"0":comma.add(receivedData.whotPreRcpsAmt);
			$("#n1RcpsAmt").text(n1RcpsAmt+" 원");			// 출하 전
			var n2RcpsAmt=isEmpty(receivedData.n1RcpsAmt)?"0":comma.add(receivedData.n1RcpsAmt);
			$("#n2RcpsAmt").text(n2RcpsAmt+" 원");			// 출하 후
			var istbPrnpAmt=isEmpty(receivedData.istbPrnpAmt)?"0":comma.add(receivedData.istbPrnpAmt);
			$("#istbPrnpAmt").text(istbPrnpAmt+" 원");	   //카드 결제
			var spntAmt=isEmpty(receivedData.spntAmt)?"0":comma.add(receivedData.spntAmt);
			$("#spntAmt").text(spntAmt+" P");	       //세이프포인트 입금
			var crdPAmt=isEmpty(receivedData.crdPAmt)?"0":comma.add(receivedData.crdPAmt);
			$("#crdPAmt").text(crdPAmt+" P");	       //M포인트 사용
			var alpPAmt=isEmpty(receivedData.alpPAmt)?"0":comma.add(receivedData.alpPAmt);
			$("#alpPAmt").text(alpPAmt+" P");	       //기아멤버스 사용
			var istaPrnpAmt=isEmpty(receivedData.istaPrnpAmt)?"0":comma.add(receivedData.istaPrnpAmt);
			$("#istaPrnpAmt").text(istaPrnpAmt+" 원");		// 할부원금
			var totalPricePuls=isEmpty(receivedData.rcpsAmt)?"0":comma.add(receivedData.rcpsAmt);
			$("#totalPricePuls").text(totalPricePuls+" 원");	// 판매가격

			// 작성일
			// $("#sndYmd").html('('+moment(receivedData.sndYmd).format("YYYY-MM-DD")+') 기준');

		}
	};
	MNet.httpSend({
		isMock: false,
		path :  _API.SVR.HOME.carinfo.carContractPayInfo,
		sendData : {
			mbrId : PGV.loginInfo.mbrId,
			vin : PGV.carInfo.vin
		},
		callback : selectReceiptInfoCallback,
		errorCallback : function (errCode,errMsg){
			COMMON_FUNCTION.TOOL.DEBUG.showTalk("errCode: "+errCode+"1년이후 차량 검색조건 오류 에러.");
			$("#oneYearBefore").addClass('none');
			$("#oneYearAfter").removeClass('none'); //1년이 지나면 데이터 안보여줌
			return false;
		}
	});
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady: function (event) {
		pageInit();
	},
	onHide: function (event) {},
	onRestore: function (event) {},
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
	// onBack : function(){},
	onDestroy: function (event) {},
	onPause: function (event) {},
	onResume: function (event) {}
};