/**
 * @파일명 : KIA_MOB_500_1080.js==>KIA_RNW_127_6000
 * @작성자 : 이현석
 * @생성일 : 2018. 8. 23. 오후 7:00:59
 * @메뉴명 : 차량정보수정
 */
var CMM_HOME = null;
var pageInit = function(){
	/**
	 * 초기화
	 */
	if(isEmpty(CMM_HOME))CMM_HOME = new cmmHome();
	/* !!! 케이스마텍 추헌남 - 정비 예약에서도 해당 페이지로 옵니다. 정비 예약 관련 페이지를 스택에서 다 지우기 위해 추가하였습니다. */
	COMMON_FUNCTION.TOOL.UI.myKiaReserveInterface.deleteAllReservePageStacks();
	PGV.carInfo = MData.param("carInfo"); // 페이지 나오고 화면 나오면 작업 	
	PGV.carUseCodeList = null;			// 차량 용도 리스트
	PGV.carFuelCodeList = null;			// 차량 연료 리스트
	Promise.allSettled([uiCarInfo(PGV.carInfo),selectCarUseCodeList()])
		.then(function(values){
			var isLoadAll=true;
			for(var i =0 ; i < values.length ;i++){
				isLoadAll += values[i].status === "fulfilled" ? true : false;
			}
			if(isLoadAll){
				return true;
			}else{
				return false;
			}
		})
		.then(setEvent)
		.then(exWNHideIndicator);
};

var setEvent = function() {

	//저장버튼
	$("#saveExpBtn").off("click").on("click", function(){	//차량 정보 압데이트
	    var returnNow = false;

	    $('.ipt-wrap').removeClass('error');
	    $(".ast").each(function(e){
	        var $chkEl = $(this).parent().next();
	        var astTxt = "";
	        if($chkEl.hasClass('ipt-wrap')){
                astTxt = $chkEl.children().prop('tagName') == "INPUT" ? $chkEl.children().val() : ($chkEl.children().prop('tagName') == "UL" ? $('input[name="alpTmScnCd"]:checked').val() : $chkEl.children().text());
	        }

	        if(astTxt == "" || astTxt == undefined){
	            $chkEl.addClass('error');
	        }

	        if($chkEl.hasClass("error")){
                $(this).get(0).scrollIntoView(true);
                returnNow = true;
                return false;
            }
	    });

	    if(returnNow){
            return;
        }

		updateCarInfo();
	});	

	//취소버튼
	$("#delExpBtn").off("click").on("click", function(){	//취소
		$(".btn-close").trigger("click");
	});

	// 배기량 입력 시
	$("#ccInput").off("click").on("input", function(){
		var $this = $(this);
		var _val = comma.add(parseInt(extractNumber($this.val())));
		$this.val(_val);
	});

	// 출고시기영역
	$("#calendarPop").off("click").on("click", function(){
		COMMON_FUNCTION.TOOL.UI.showCalendarPopup("#calendarPop");
	});
	// 차량 용도 클릭 시
	$("#carUseTypeBtn").off("click").on("click", function(){
		var $this = $(this);
		MPopup.listSingle({
			list : PGV.carUseCodeList,
			title : "차량용도",
			selected : $this.find('input').attr('data-select-idx')
		}, function(buttonIdx, rowInfo, setting){
			if(buttonIdx == 1){
				$this.find("input").attr("data-select-idx", rowInfo.index);
				$this.find("input").attr("data-select-cd", rowInfo.value);
				$this.find("input").val(rowInfo.title);
			}
		});
	});
	
	// 차량 삭제 버튼 2019 0304
	$("#delCarBtn").off("click").on("click", function(){
		function openPop_KIA_RNW_127_6100() {//차량 삭제 확인 팝업
			customPopup.get(PATH_MANAGER.KIA_RNW_127_6100.path, $("#popup_127_6100"), function(item){
				if($("#popup_127_6100").length < 1){
					var screenHtml = $("<div></div>");
					screenHtml.append(item);
					$('body').append(screenHtml.find('#popup_127_6100'));

					$("#popDetailBtn").on("click", function(){
						try{
							var options = {
								isMock: false,
								indicatorYn:"Y",
								path:  _API.SVR.HOME.ckb.deleteCkbMgmtSubjCarsInfo,
								sendData:  {
									mbrId: PGV.loginInfo.mbrId,
									vin: PGV.carInfo.vin
								},
							};
							MNet.httpSendAsync(options)
								.then(
									function(response){
										exWNHideIndicator();
										if(response.resultCode==="200"&&response.delYn==="Y"){
											//홈으로 돌아감
											MData.global("passData");
											delete PGV.passData;
											customPopup.remove($("#popup_127_6100"));
											stackRemove("KIA_RNW_127_0000.html");//내차정보
											MPopup.instance(response.resultMsg);
											MPage.back({param:{hasToHomeReload:true,isUserCarsChanged:true}});
										}else{
											MPopup.instance("차량 삭제 실패");
										}
									}
								);
						}catch(e){
							MPopup.instance("차량 삭제 실패");
							customPopup.remove($("#popup_127_6100"));
						}

					});
				}
				//누적 주행거리 값
				$("#trvgDist").val($("#distInfo").find('span').text());

				RNW_UI.popupLayer({selId : '#popup_127_6100'});
			});
		}
		openPop_KIA_RNW_127_6100();
	});
	// //사용주유 클릭 시
	// $(document).on("click", "#useEnerBtn", function(){
	// 	var $this = $(this);
	// 	MPopup.listSingle({
	// 		list : PGV.carFuelCodeList,
	// 		title : "사용주유",
	// 		selected : $this.attr("data-select-idx")
	// 	}, function(buttonIdx, rowInfo, setting){
	// 		if(buttonIdx == 1){
	// 			$this.attr("data-select-idx", rowInfo.index);
	// 			$this.attr("data-select-cd", rowInfo.value);
	// 			$this.text(rowInfo.title);
	// 		}
	// 	});
	// });
	/*$(document).on("click", "#whodYmdBtn", function(){	//년
    var today = moment().format("YYYYMMDD");
    MPopup.date({
        initDate : $("#whodYmdBtn").attr("data-select-date"),
        endDate : today
    }, function(result, setting){
        if(result.status == "SUCCESS"){
            $("#whodYmdBtn").text(result.yyyy+"년 "+result.MM+"월 "+result.dd+"일");
            $("#whodYmdBtn").attr("data-select-date", result.yyyy + "" + result.MM + "" + result.dd);
        }
    });
});*/

};

//현재 팝업 닫기
var closePopup = function(){
	MPage.back({
		animate : "MODAL_DOWN",
		param : {
			settingRegistFlag : "Y"
		}
	});
};

/**
 * 차량 정보 조회 전문
 */
var uiCarInfo = function(info){
	$("#carNm").text(info.mdlNm);							// 차종
	$("#carVin").text(info.vin);
	/**
	 * 차량 정보 조회 전문 콜백
	 */
	var selectCarInfoCallBack = function(receivedData){
		var code = receivedData.resultCode;
		var msg = receivedData.resultMsg;

		if(code == "200"){
			$("#carUseType").text(receivedData.useGb || "");		// 용도
			$("#carUseType").val(receivedData.useGb || "");		// 용도
			var engXhstQty = comma.add(receivedData.engXhstQty) || null;
			$("#ccInput").val(engXhstQty);	// 배기량
			$("#carAlias").val(receivedData.carAlias);
			var fuelNm = receivedData.fuelNm || "";
			if(PGV.carInfo.memEvYn!="N"){
				$("#energyTypeEv button").addClass("active");
				$("#energyTypeEv").removeClass("none");
			}else{
				if(!isEmpty(fuelNm)){
					$("#energyTypeOil button").removeClass("active");
					$("#energyTypeOil em").each(function(idx,item){
						if($(this).text()==fuelNm){
							$(this).closest("button").addClass("active");
						}
					});
				}
				$("#ccInputArea").removeClass("none");//배기량 입력필드 보이기
				$("#energyTypeOil").removeClass("none");
				// $("#energyTypeEv").remove();
			}
			// 자동 or 수동 여부 체크
			var missionVal = typeof receivedData.mission == "string" ? receivedData.mission.trim() : "";
			$("#carMissionType button").removeClass("active");
			if(missionVal == "A"){
				$("#carMissionType button.auto-mission").addClass("active");
			}else if(missionVal == "M"){
				$("#carMissionType button.stick-mission").addClass("active");
			}

			//[KIAVIK-340] 공백 제거.
			if (!isEmpty(receivedData.carRgstNo)) {
				$("#carNumber").val(receivedData.carRgstNo.replace(" ", ""));			// 차번호
			}
			// var whotYmd = receivedData.whotYmd || moment().format("YYYY0101"); // 출고일로 변경 필요
			var whotYmd = receivedData.whotYmd || PGV.carInfo.whotYmd; // 2024.02.23 default 변경
			if(whotYmd.length == 6){
				whotYmd = whotYmd + "01";
			}else if(whotYmd.length == 4){
				whotYmd = whotYmd + "0101";
			}
			var whotYmdText = moment(whotYmd).format("YYYY년 MM월 DD일");
			$("#whodYmdBtn").val(whotYmdText);		// 출고일
			$("#whodYmdBtn").text(whotYmdText);		// 출고일
			$("#whodYmdBtn").attr("data-select-date", extractNumber(whotYmd));

		}else{
			MPopup.alert(msg);
		}
	};
	MNet.httpSend({
		indicatorYn:"N",
		path : _API.SVR.HOME.carinfo.selectCarInfo,
		sendData : {
		    vin: PGV.carInfo.vin,
            mbrId : PGV.loginInfo.mbrId,
            vehlRepnCd : PGV.carInfo.vehlRepnCd
		},
		callback : selectCarInfoCallBack
	});
}

/**
 * 차량용도 구분 통합코드 조회
 */
var selectCarUseCodeList = function(){
	/**
	 * 차량용도 구분 통합코드 조회 콜백
	 */
	var selectCarUseCodeListCallback = function(receivedData){
		var code = receivedData.resultCode;
		var msg = receivedData.resultMsg;

		if(code == "200"&&!isEmpty(receivedData.ccdListRnwResDto)){
			PGV.carUseCodeList = getListArr(receivedData.ccdListRnwResDto, "ccdNm", "ccd");
			var selectIdx = isEmpty($("#carUseTypeBtn").text()) ? 0 : _.findIndex(PGV.carUseCodeList, {title : $("#carUseTypeBtn").text()});

			if(selectIdx > -1){
				$("#carUseTypeBtn").attr("data-select-idx", selectIdx);
				$("#carUseTypeBtn").attr("data-select-cd", PGV.carUseCodeList[selectIdx].value);
				$("#carUseTypeBtn").text(PGV.carUseCodeList[selectIdx].title);
			}

		}else{
			MPopup.alert(msg);
		}
	};
	MNet.httpSend({
		indicatorYn:"N",
		path : _API.SVR.HOME.carinfo.selectCarUseCodeList,
		sendData : {mbrId: PGV.loginInfo.mbrId},
		callback : selectCarUseCodeListCallback
	});
};


/**
 * 차량 정보 수정 업데이트
 */
var updateCarInfo = function(){
	/* 3. 차량수정요청 후 처리 */
	var afterModifyFinish = function(receivedData){
		exWNHideIndicator();
		objectValueNullCheck(receivedData);//null 이면 공백으로 변경
		var resultCode = receivedData.resultCode;
		var resultMsg = receivedData.resultMsg;
		var carContractPayInfoList = receivedData.carContractPayInfoListResDto;
		if(!isEmpty(receivedData.errorCode)){
			MPopup.instance(receivedData.errorMessage);
		}else{
			if(resultCode == "200"){
				MPopup.alert({
					message : "차량 정보를 수정했습니다.",

					callback : function(idx){
						var oldCarInfo = PGV.carInfo;
						CMM_HOME.collectCarListInfo()
							.then(
								function (ownCarListInfo) {
									var newCars = ownCarListInfo.myCarInfoListResDto;
									var theCar = newCars.find(function (i, item) {
										return item.vin = oldCarInfo.vin;
									});
									PGV.carInfo = theCar;
									return theCar;
								}
							).then(
							function (theCar) {
								MPage.html({
									url: PATH_MANAGER.KIA_RNW_127_0000.path,
									param: {
										passCar: theCar,
										isUserCarsChanged:true
									}
								});
							}
						);

					}
				});
			}
			else{
				MPopup.instance(resultMsg);
			}
		}
	}
	/* 2.서버에 수정요청 */
	var postModifyCarInfo = function(){
		var _engXhstQty = !isEmpty($("#ccInput").val())?$("#ccInput").val().replaceAll(",",""):null;
		var _alpTmScnCd = !isEmpty($("#missionTypeTarget button.active"))?$("#missionTypeTarget button.active").data("codeValue"):null;
		var carUseTypeCode = $("#carUseTypeBtn").find("input").data("selectCd");
		var _carUseUsfScnCd = !isEmpty(carUseTypeCode)?carUseTypeCode:null;
		var options = {
			path: _API.SVR.HOME.carinfo.updateCarInfo,
			sendData: {
				mbrId: PGV.loginInfo.mbrId,//회원ID	string		Y
				vin: PGV.carInfo.vin,//차대번호	string		Y
				carRgstNo: $("#carNumber").val(),//차량번호	string		Y
				carAlias: $("#carAlias").val(),//차량애칭	string		Y
				whotYmd: extractNumber($("#whodYmdBtn").val()),//출고일	string		Y  "YYYY년 MM월 DD일".replace(/([가-힣])/g,"").replaceAll(" ","")
				engXhstQty: _engXhstQty,//배기량	string		N
				fuelNm: $("#energyTypeTarget button.active em").text(),//유종명	string		Y
				alpTmScnCd: _alpTmScnCd,//미션	string		N
				carUseUsfScnCd: _carUseUsfScnCd,//차량용도	string		N
				vehlRepnCd: PGV.carInfo.vehlRepnCd	//차종코드	string		N
			}
		};
		MNet.httpSendAsync(options).then(afterModifyFinish);
	}
	/* 1. 유효성체크*/
	var checkValidation = function(){
		/* 차량번호 유효성 검사*/
		function chkCarNum(carNo) {
			if(carNo == '미입력' || carNo == '차량번호') {
				return true;
			}
			else {
				var deny_pattern = /[ㄱ-힝a-zA-Z0-9-]/gi;
				var result = carNo.replace(deny_pattern, "");
				if(result.length > 0){
					return false;
				}

				carNo = carNo.replace(/[\s\(\)\.,\[\]_-]/g, "");
				var carNo_left = carNo.substring(0, carNo.length - 4);
				var carNo_right = carNo.substring(carNo.length - 4, carNo.length);

				if(chkFirstCarNo(carNo_left) && eval("(/^[0-9]{4}$/).test(carNo_right)")) {
					return true;
				}
				else {
					return false;
				}
			}
		}
		/* 차량번호 유효성 검사*/
		function chkFirstCarNo(carNo) {
			var chkHan = false;
			if(carNo.length >= 2 && carNo.length <= 6) {
				for(var i = 0; i < carNo.length; i++) {
					var isChar = "";
					if(carNo.charCodeAt(i) >= 44032 && carNo.charCodeAt(i) <= 55203) {
						isChar = "han";
					}
					else if(carNo.charCodeAt(i) >= 48 && carNo.charCodeAt(i) <= 57) {
						isChar = "num";
					}

					if(isChar == "") return false;
					else if(isChar == "han") chkHan = true;
				}
			}

			if(chkHan == false) {
				return false;
			}

			return true;
		}

		var carNumber = $("#carNumber").val();
		// if(isEmpty($("#carAlias").val())) {
		// 	MPopup.alert("차량 애칭을 입력해 주세요.");
		// }else
		if(isEmpty(carNumber)){
			MPopup.alert("차량번호를 입력해 주세요.");
		}else if(carNumber.indexOf(" ") >= 0){
			MPopup.alert("차량번호에 공백을 제거해 주세요.");
		}else if (carNumber.indexOf("￠") >= 0 || carNumber.indexOf("Ξ") >= 0 || carNumber.indexOf("Г") >= 0) {
			MPopup.alert("차량번호에 허용되지 않는 특수문자를 입력하셨습니다.");
		}else if(getBytes(carNumber) > 12){
			MPopup.alert("[서울12가3456], [12가3456]등 차량번호 전체를 입력해 주세요.");
		}else if(!chkCarNum(carNumber)){
			MPopup.alert("[서울12가3456], [12가3456]등 차량번호 전체를 입력해 주세요.\n차량번호에 특수문자의 사용은 제한됩니다.");
		}else if(isEmpty($("#whodYmdBtn").val())){
			MPopup.alert("출고일을 확인해 주세요.");
		}else if($("#energyTypeTarget button.active").length == 0){
			MPopup.alert("유종을 확인해 주세요.");
			// }else if(isEmpty($("#carUseTypeBtn").find("input").attr("data-select-cd"))){
			// 	MPopup.alert("차량용도를 확인해 주세요.");
			// }else if(isEmpty($("#useEnerBtn").text())){
			// 	MPopup.alert("사용주유를 확인해 주세요.");
			// }else if($("#missionTypeTarget button.active").length == 0){
			// 	MPopup.alert("미션을 확인해 주세요.");
		}else{
			return true;
		}
		return false;
	}
	if(checkValidation()){
		MPopup.confirm({
			message : "차량정보를 수정하시겠어요?",
			buttons : ["취소", "확인"],
			callback : function(idx){
				if(idx == 1){
				    // TODO : 810_1021 changeProfile
					postModifyCarInfo();
				}
			}
		})
	}
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady: function (event) {
		exWNShowIndicator();

		pageInit();
	},
	onHide: function (event) {},
	onRestore: function (event) {exWNShowIndicator();},
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
	// onBack : function(){},
	onDestroy: function (event) {},
	onPause: function (event) {},
	onResume: function (event) {}
};