/**

@파일명 : KIA_RNW_127_7000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.02.28 
@메뉴명 : 실운행자 등록 팝업
@DESC : 권한 확인 중
*/

var CurrPage;

var KIA_RNW_127_7000 = {
    driverList:null,
    init: function() {
        CurrPage = this;
        var carInfo = MData.param("carInfo");
        PGV.carInfo = carInfo;
        MData.removeParam("carInfo");
        KIA_RNW_127_7000.driverList = carInfo.ownDriverInfoListResDto;

        var pageInit = function () {
            /**
             * 초기화
             */
            // 전페이지 또는 PGV에 적용 해둔 데이터로 사용자가 선택한 차량 번호와 이름 입력
            var carNm = getCarRgstNoText(carInfo.carRgstNo);

            //if(!isEmpty(carInfo.mdlNm)){
            //	carNm += '('+carInfo.mdlNm+')';
            //}

            $("#carNm").html(carNm + " 차량에 등록할 <br>실운행자의 아이디와 이름을 입력해 주세요");
            /**
             * 화면 이벤트
             */
            setEvent();
            // screenViewGa(gaSendUrl["KIA_MOB_500_1021"].pageNm);//2020 공통으로 변경

        };

        var setEvent = function () {
            $(document).on("keyup", "input", function () {
                carInfo.driverId = $.trim($("#userId").val());
                carInfo.driverNm = $("#userName").val();

                if (!isEmpty(carInfo.driverId) && !isEmpty(carInfo.driverNm)) {
                    $("#chkDriveBtn").prop("disabled", false);
                } else {
                    $("#chkDriveBtn").prop("disabled", true);
                }
            });

            $(document).on("click", "#chkDriveBtn", function () {
                // if(!regExpEmailPossible(carInfo.driverId.trim())){
                //     MPopup.instance("이메일 형식이 아닙니다.");
                //     $("#userId").focus();
                //     return;
                // }else {
                // }
                var data = {
                    mbrId: PGV.loginInfo.mbrId,
                    rdmId: carInfo.driverId.trim(),
                    rdmName: carInfo.driverNm.trim()
                }
                chkDriver(data);

            });
        }
        // 기아멤버스 확인
        var chkDriver = function (_data) {
            MNet.httpSend({
                path: _API.SVR.HOME.car.mbrInfo,
                sendData: _data,
                callback: chkDriverCallBack,
                errorCallback : function(errorCode, errorMessage){
                    MPopup.alert('검색결과가 없습니다.');
                    return false;
                }
            });
        };
        // 기아멤버스 확인 콜백
        var chkDriverCallBack = function (receivedData) {
            exWNHideIndicator();
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
            var useDriverYN = "N";
            if (code == "200") {
                carInfo.driverCsmrMgmtNo = receivedData.csmrMgmtNo;

                for (var i in KIA_RNW_127_7000.driverList) {
                    if ((KIA_RNW_127_7000.driverList[i].csmrMgmtNo == carInfo.driverCsmrMgmtNo) && KIA_RNW_127_7000.driverList[i].agreeYn != "N") {
                        useDriverYN = "Y";
                    }
                };

                if (useDriverYN == "Y") {
                    MPopup.alert({
                        message: "이미 등록된 실운행자 입니다.",
                        callback: function () {
                            MPage.back();
                            return false;
                        }
                    });
                } else {
                    MPage.html({
                        url: PATH_MANAGER.KIA_RNW_127_7100.path,
                        animate: "MODAL_UP",
                        param: {
                            carInfoParam: carInfo
                        }
                    });
                }
            } else {
                MPopup.alert('검색결과가 없습니다.');
                return false;
            }
        };

        pageInit();
    }
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_127_7000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) { },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
