/**
 @파일명 : common_home.js
 @작성자 : 정목단
 @생성일 : 2022.04.05
 @메뉴명 : HOME 탭 (로그인) 공통함수
 @DESC : 로그인[O]
 */

var cmmHome = function(){
    this.recentDrivingSeviceOn=false; //TODO 최근주행정보 api 7월 오픈예정.
// ------------------------------
// 	home 전역변수 (S)
// ------------------------------
    /** enum dictionary */
    this.dict={
        disp :{
            NONE_CAR: {
                /** "has no car"*/
                name: "NONE_CAR",
                ccs: null,
                personalLink: {
                    text: "차량 데이터 복구",
                    link: ""
                },
                show:null,
            },
            CONSTRUCT_CAR_ONLY: {
                /**  "only has constructed car"*/
                name: "CONSTRUCT_CAR_ONLY",
                ccs: null,
                personalLink: null,
                show:null,
            },
            HAS_CAR_ONLY: {
                /**  "has car with no data-link ccs etc"*/
                name: "HAS_CAR_ONLY",
                ccs: null,
                personalLink: null,
                show:null,
            },
            HAS_CAR_CCS_ENABLE: {
                /** registerable ccs : 중간상태값으로 최종사용되는 값이 아님. */
                name: "HAS_CAR_CCS_ENABLE",
                ccs: null,
                personalLink: null,
                show:null,
            },
            HAS_CAR_CCS: {
                /**  "an identical registerd car is exist"*/
                name: "HAS_CAR_CCS",
                ccs: {
                    dataHub: false,
                    ubi: false,
                    drivingLog : false,
                },
                personalLink: null,
                show:null,
            },
        },

        /**
         * 화면분기
         * 1:동의함, 0: 동의필요함 외 9,8해당없음
         * 업데이트 약관 존재 result | ccsSubAgreeYn | ubiSubAgreeYn&&ubiAgreeYn | ubiSupportYn |최근주행정보(미정)
         * 첫번째 "0"으로 시작시 업데이트 약관 존재함.
         * "01"으로 시작, 즉 ccsSubAgreeYn 미동의 일때, 처리 동일(0100|0101|0110)
         * =====<< 화면분기처리 >>=======
         * dataHubLinkBtn //신규 데이타허브 연동
         * dataHubLinkBanner //데이터 허브 재연동 배너
         * ubiAndDrivingLinkCntsAndBtn // ubi,최근주행 연동 유도 배너 +버튼
         * drivingLogLinkCntsAndBtn //최근주행정보 연동 유도 배너 + 버튼
         * ubiInfo // 안전운전점수 영역
         * drivingLog //최근주행정보 영역
         * newServceAgreements // 신규서비스가 존재, 데이터 허브페이지 유도 배너
         * */
        dispDetail :{
            "10000":[],
            "10010":["dataHubLinkBtn"],//주행 데이터 (신규) 연동 버튼
            "10100":["dataHubLinkBanner"],
            "10110":["dataHubLinkBanner","ubiInfo"],
            "11000":[],
            "11010":["ubiLinkCntsAndBtn"],
            "11100":[],
            "11110":["ubiInfo"],
            /* ccsSubAgreeYn 약관동의 필요함 */
            "01000":["dataHubLinkBanner"],
            "01010":["dataHubLinkBanner", "ubiLinkCntsAndBtn"],
            /* 신규서비스 약관동의 필요함 */
            "01100":["newServceAgreements"],
            "01110":["ubiInfo","newServceAgreements"],
        },
        dispDetail_after_open_recent_driving :{//todo 최근주행서비스 오픈시.
            "1000":["dataHubLinkBtn"],//주행 데이터 (신규) 연동 버튼
            "1111":["ubiInfo","drivingLog"],
            "1011":["dataHubLinkBanner","ubiInfo","drivingLog"],//주행데이터 재 연동
            "1001":["dataHubLinkBanner", "ubiLinkCntsAndBtn","drivingLog"],//주행데이터 재 연동
            "1010":["dataHubLinkBanner","ubiInfo","drivingLogLinkCntsAndBtn"],//주행데이터 재 연동
            "1100":["ubiAndDrivingLinkCntsAndBtn"],
            "1101":["ubiLinkCntsAndBtn","drivingLog"],
            "1110":["ubiInfo","drivingLogLinkCntsAndBtn"],
            /* ccsSubAgreeYn 약관동의 필요함 */
            "0100":["dataHubLinkBanner", "ubiAndDrivingLinkCntsAndBtn"],
            "0101":["dataHubLinkBanner", "ubiLinkCntsAndBtn","drivingLog"],
            "0110":["dataHubLinkBanner", "ubiInfo","drivingLogLinkCntsAndBtn"],
            /* 신규서비스 약관동의 필요함 */
            "0111":["ubiInfo","drivingLog","newServceAgreements"],
        },
        insight:{
            P_INSIGHT: {
                /** 순서 : 우선순위 */
                "MTA002": {
                    cd: "MTA002",
                    imgCount: 3,
                    desc: "정비중",
                    font_class: "c-bg-brand-point",
                    text: "LIVE",
                    msg: "정비 현황을 실시간으로 확인해 보세요",
                    buttons: [{link: "KIA_RNW_247_2000", text: "오토캠 시청"},{link: "KIA_RNW_247_0000", text: "정비 진행 현황"}]
                },
                "MTA001": {
                    cd: "MTA001",
                    imgCount: 3,
                    desc: "진단코드감지",
                    font_class: "c-bg-brand-point",
                    text: "진단 필요",
                    msg: null,
                    buttons: [{link: "KIA_RNW_243_1000", text: "정비 예약"}, {link: "KIA_RNW_122_0000", text: "상세 진단 안내"}]
                },
                "CHR002": {
                    cd: "CHR002",
                    imgCount: 3,
                    desc: "배터리 충전 중",
                    font_class: "c-bg-brand-point",
                    text: "충전",
                    msg: "",
                    buttons: null
                },
                "CHR001": {
                    cd: "CHR001",
                    imgCount: 3,
                    desc: "배터리잔량 20% 이하",
                    font_class: "c-bg-brand-point",
                    text: "주의",
                    msg: "배터리를 충전해 주세요",
                    buttons: [{link: "KIA_RNW_580_0000", text: "충전소 검색"}, {link: "KIA_RNW_590_0000", text: "온디맨드 픽업충전"}]
                },
            },
            W_INSIGHT : {/** 순서 : 우선순위 */
                WEA001: {cd:"WEA001", desc: "눈-약함", text:"", ico_class: "",imgCount:3},
                WEA002: {cd:"WEA002", desc: "눈-강함", text:"", ico_class: "",imgCount:3},
                WEA003: {cd:"WEA003", desc: "비-약함", text:"", ico_class: "",imgCount:3},
                WEA004: {cd:"WEA004", desc: "비-강함", text:"", ico_class: "",imgCount:3},
                WEA005: {cd:"WEA005", desc: "흐림", text:"", ico_class: "",imgCount:3},
                WEA006: {cd:"WEA006", desc: "맑음", text:"", ico_class: "",imgCount:3},
            },
        },
        weather:{
            DUST : {
                "1": {cd:"1", text: "좋음", font_class: "dust-status-good"},
                "2": {cd:"2", text: "보통", font_class: "dust-status-normal"},
                "3": {cd:"3", text: "나쁨", font_class: "dust-status-bad"},
                "4": {cd:"4", text: "매우나쁨", font_class: "dust-status-verybad"},//todo  class 없음  css
                "X": {cd:"X", text: "예외발생", font_class: ""},
            },
            DAY : {
                "D": {cd:"D", desc: "낮", class: ""},
                "N": {cd:"N", desc: "밤", class: ""},
                "X": {cd:"X", text: "예외발생", font_class: ""},
            },
            PLUG_TYPE:{
                "0" :{cd:"0",desc:"DC charger" },
                "1" :{cd:"1",desc:"AC w/ 240V" },
                "2" :{cd:"2",desc:"AC w/ 120V" },
            }
        }

    }
    this.homePgvObj=  { /** 전역변수 */
        push: {},
        location: {lat: null, lng: null, state: null,city:null,detail:{}},
        display: {
            name: null,
            ccs: {
                dataHub: false,
                ubi: false,
                drivingLog: false,
            },
            personalLink: {
                text: null,
                link: null
            }
        },//DISP 매핑됨.
        representCar:{},//대표차량
        car: {// app server 차량정보
            myCarInfoListResDto: {},
            unDeliveryCarInfoListResDto: {},
            csmrLuxuryCarInfoListResDto: {},
            carAgreeStandBy:{},
            selectCar: {},//별도 선택없이 주차량/디폴트 차량으로.
            isUndeliveryCarOnly:false,
            isEv: false,
            carType:"",
            distInfo:{trvgDist:null},//차계부 주행거리
            dkc:{registerInfo:{}},
        },
        ccs: {//datahub 차량정보
            isMaster: {},
            registerdCar: {},//이번에 등록된 차량
            registerdCarsInfo : {},//현재 등록된 모든 차량
            agreements: {},
            ev: {
                charging: {},
                battery: {},
                dte: {},
            },
            oil: {
                dte: {},
                fuelLevel: {},
            },
            dtcList: {},
            odometer: {},//ccs주행거리
            ubi:{},
            recentDriving:{},
            selectCar:{},
            dkc: {
                reserveData: {}
            }
        },
        AOD: { //AOD 정보 저장
            aodYn: {},
            vin: {},
            agreeYn: {},
            agreeDate: {},
            odometer: {},
            drvDistance: {},
            batteryStatus: {},
            batteryCharge: {},
            remainTime: {},
            regDtm: {},
            regYn: {},
            latitude: {},
            longitude: {}
        },
        benefitCar: {
            benefitYn: {},
            benefitGrade: {},
            benefitEventNo: {},
            benefitCarNo: {},
            benefitRegYn: {}
        },
        popUp: { //!!! home에서 열리는 팝업은 체이닝되어 있습니다. 우선순위에 따라 노출되고, 선순위팝업이 닫히고 나면, 후순위 팝업이 열립니다.
            //wait,open,close,ignore==> close 되면 다음 dispNo,active true인 팝업을 open. 처음부터 파업 열필요 없으면 ignore
            // constructCarPop: {
            //     cd: "constructCarPop",
            //     dispNo: ?,
            //     active: false,
            //     status: "wait",
            //     data: null,
            //     popFunc: null
            // },
            realDriverRegisterPop: {//실운행자등록팝업
                cd: "realDriverRegisterPop",
                dispNo: 1,
                active: false,
                status: "wait",
                data: null,
                popFunc: null
            },
            oilTopUpRegisterPop: {//sms 주유내역등록팝업
                cd: "oilTopUpRegisterPop",
                dispNo: 2,
                active: false,
                status: "wait",
                data: null,
                popFunc: null
            },
            marketingPop: {//마케팅팝업
                cd: "marketingPop",
                dispNo: 3,
                active: false,
                status: "wait",
                data: null,
                popFunc: null
            },
            /* 2024.07.04 봉고3 LPDI 차량 무상 수리 팝업 임시 추가 */
            marketingPop_bongo: {//마케팅팝업
                cd: "marketingPop_bongo",
                dispNo: 4,
                active: false,
                status: "wait",
                data: null,
                popFunc: null
            },
        },
        main: {
            msgCnt: "noData",
            weatherInfo: {
                fcstResDto: {}, snrsResDto: {}, airPltnResDto: {},
                case: {},
                dayCdInfo: {},
                dust: {},
            },
            uiLoadAll: false,
            homeInsight: {},
            additionalSlider:{},
        },
        request: {
            /** todo bad idea */
            insightRequest: {
                mbrId: !isEmpty(PGV.loginInfo)?PGV.loginInfo.mbrId:null,// 회원ID
                vin: null,// 차대번호
                carRgstNo: null,// 차량번호
                hpNo: !isEmpty(PGV.loginInfo)?PGV.loginInfo.hpno:null,// 휴대전화번호
                evCarDivCd: "OL",// EV차량구분코드(EV,OL)
                btryChrg20Yn: null,// 배터리잔량20%여부
                btryChrgYn: null,// 충전중여부
                fuelRmn20Yn: null,// 주유잔량20%여부
                fltCndYn: null,// 고장상태여부
                lat: null,// 위도
                lng: null,// 경도
            },
            ccsCarRegisterToSeverRequest: {
                carId: null,
                csmrMgmtNo: !isEmpty(PGV.loginInfo)?PGV.loginInfo.csmrMgmtNo:null,
                master: null,
                masterCarId: null,
                saleCarmdlEnNm: null,
                vin: null
            },
        },

        gnb:{
            push:{},
            barcode:{
                cardList:{},
            },
            myPage:{}
        },
    };
    var homePgvHandler = {
        get: function (target, property) {
            //devLog.dir(property, target[property]);
            return target[property];
        }, set: function (target, property, value) {
            if (target.hasOwnProperty(property)) {

                if(property=="trvgDist"){
                    console.log("누적주행거리 : "+value);
                }
                if(property=="selectCar"){/** 선택차량 값 정해지면. */
                    if(!isEmpty(target[property])&&target[property].vin !=value.vin ){
                        //메인리로딩.
                    }
                    if(isEmpty(target[property])&&!isEmpty(value) ){
                    }
                }
                if(property=="msgCnt") {
                    if(typeof Number(target[property]) ==='number'){
                        COMMON_FUNCTION.TOOL.UI.ringTheBells();
                    }
                }
            }
            target[property] = value;
            // devLog.dir(property);
        },

    };
    this.homePgvProxy = function (obj) {
        if(isEmpty(obj)){
            obj = homePgvObj;
        }
        var res = null;
        try {
            if(obj!=null){
                var keys = Object.keys(obj);
                if (keys.length > 0 && typeof obj === 'object') {
                    res = new Proxy(obj, homePgvHandler);
                    for (var j in keys) {
                        if(!isEmpty(obj[keys[j]])&&typeof obj[keys[j]]=== 'object'){
                            var childrenKey = Object.keys(obj[keys[j]]);
                            if (childrenKey.length > 0) {
                                for (var i in childrenKey) {
                                    if (obj[keys[j]] !== null) {
                                        res[keys[j]] = this.homePgvProxy(obj[keys[j]]);
                                    }
                                }
                            }
                        }
                    }
                }
            }else{
                res = new Proxy(obj, homePgvHandler);
            }
        }catch(e){
            if(!isEmpty(e.name) && e.name === "TypeError"){

            }
            console.error(e);
        }
        return res;
    };
    this.makeAuditObject=function(obj,handler){
        var res = null;
        try {
            if(!isEmpty(obj)){
                var keys = Object.keys(obj);
                if (keys.length > 0 && typeof obj === 'object') {
                    res = new Proxy(obj, handler);
                    for (var j in keys) {
                        if(!isEmpty(obj[keys[j]])&&typeof obj[keys[j]]=== 'object'){
                            var childrenKey = Object.keys(obj[keys[j]]);
                            if (childrenKey.length > 0) {
                                for (var i in childrenKey) {
                                    if (obj[keys[j]] !== null) {
                                        res[keys[j]] = this.makeAuditObject(obj[keys[j]],handler);
                                    }
                                }
                            }
                        }
                    }
                }else{
                    if(typeof obj ==='string'){
                        res = new Proxy(new String(obj), handler);
                    }
                    if(typeof obj ==='number'){
                        res = new Proxy(new Number(obj), handler);
                    }
                    if(typeof obj ==='boolean'){
                        res = new Proxy(new Boolean(obj), handler);
                    }
                }
            }else{
                //do nothing!
            }
        }catch(e){
            if(!isEmpty(e.name) && e.name === "TypeError"){

            }
            console.error(e);
        }
        return res;
    }
// ------------------------------
// 	!-- home 전역변수 (E)
// 	home  공통 함수 (S)
// ------------------------------
    /** home 차량정보 ui */
    this.uiSelectCarInfo = function (carData,selector){
        if(isEmpty(carData)){
            if(!isEmpty(PGV)&&!isEmpty(PGV.passData)&&!isEmpty(PGV.passData.car)){
                carData = PGV.passData.car.selectCar;
            }else{
                COMMON_FUNCTION.TOOL.DEBUG.showTalk( "check 전역변수 PGV");
            }

        }
        var carHtml;
        if (!isEmpty(carData)) {
            var carName ;
            var silhouette ="../../img/rnw/main/home/img_carInfo_silhouette.png";
            var carImgUri= !isEmpty(carData.carImgUri)?carData.carImgUri:carData.repCarImgUri;
            carImgUri = !isEmpty(carImgUri)?carImgUri: silhouette;
            if(carData.isContract){
                // 계약 차량의 경우 mdlNm ,carAlias 없음.
                carName = !isEmpty(carData.krspcNm) ? carData.krspcNm : "-";
                carHtml = '<div class="div-table">' ;
                if(!isEmpty(carImgUri)){
                    carHtml+=
                        '   <div class="div-table">' +
                        '     <div class="div-table-cell cell-01">' +
                        '       <img src="'+ carImgUri +'" alt="">' +
                        '     </div>' +
                        '     <div class="div-table-cell cell-02">' +
                        '       <div class="row">' +
                        '         <div class="text-info">' +
                        '           <p>'+carName+'</p><p></p>' +
                        '         </div>' +
                        '       </div>' +
                        '     </div>' +
                        '   </div>';
                }else{
                    carHtml+=
                        '   <div class="div-table-cell">' +
                        '     <div class="text-info">' +
                        '       <p>'+carName+'</p><p></p>' +
                        '     </div>' +
                        '   </div>';
                }
                carHtml +='</div>';
            }
            else{
                var btnStar = "";//실운행자
                if(carData.rdmYn!=="Y"){//소유자
                    if (carData.dispNo == "1") {
                        btnStar=
                            '<button type="button" class="btn-star">' +
                            '  <i class="ico-star off"></i>' +
                            '</button>';
                    }else{
                        if(PGV.currentPage == PATH_MANAGER.KIA_RNW_126_0000.nameWithHtml){
                            btnStar=
                                '<button type="button" class="btn-star">' +
                                '  <i class="ico-star off"></i>' +
                                '</button>';
                        }
                        else{
                            btnStar='';
                                // '<button type="button" class="btn-star">' +
                                // '  <i class="ico-star off"></i>' +
                                // '</button>';
                        }
                    }
                }
                carName = isEmpty(carData.carAlias) ? carData.mdlNm : carData.carAlias;


                carHtml= '<div class="div-table">' ;
                carHtml+=                    '                  <div class="div-table-cell cell-01">' ;
                carHtml+=                    '                    <img src="'+ carImgUri +'" alt="">' ;
                carHtml+=                    '                  </div>' ;
                carHtml+=                    '                  <div class="div-table-cell cell-02">' ;
                carHtml+=                    '                    <div class="row">' ;
                carHtml+=                    '                      <div class="text-title">' ;
                carHtml+=                    '                        <h4 class="text-scale-04">'+(carName||"-")+'</h4>' ;
                carHtml+=                    btnStar;
                carHtml+=                    '                      </div>' ;
                carHtml+=                    '                    </div>' ;
                carHtml+=                    '                    <div class="row">' ;
                carHtml+=                    '                      <div class="text-info">' ;
                carHtml+=                    '                        <span>'+(carData.mdlNm||"-")+'</span>' ;
                if(!isEmpty(carData.carRgstNo.trim())){
                    carHtml+=                    '                                                <span>'+(carData.carRgstNo||"")+'</span>' ;
                }
                carHtml+=                    '                      </div>' ;
                carHtml+=                    '                    </div>' ;
                carHtml+=                    '                  </div>' ;
                carHtml+=                    '                </div>';
            }
            var btnLink = "";
            var buttonHtml ="";
            if (!isEmpty(selector) && selector.startsWith("#home")) {
                var btnLink = ' data-screenid="KIA_RNW_126_0000"';
                buttonHtml='                  <button type="button" class="btn-arrow-right">' +
                    '                   <i class="ico-arrow-right">' +
                    '                  </button>';
            }
            if (!isEmpty(selector)) {
                $(selector).html("");
                $(selector).append($(carHtml));
                $(selector).append($(buttonHtml));
                if (selector.startsWith("#home")) {
                    $(selector).attr("data-screenid","KIA_RNW_126_0000");
                }
                return;
            }else{
                return carHtml + buttonHtml;
            }
        }
    }
    /** 내차고 차량목록 */
    this.htmlCarInfo=function(carData){
        var divItemHtml =  "<div class='div-item' data-car-vin='"+carData.vin+"' data-car-data='"+JSON.stringify(carData)+"'>";
        divItemHtml +=CMM_HOME.uiSelectCarInfo(carData);
        divItemHtml +="</div>";
        var wrapperDiv = $("<div></div>").append($(divItemHtml));
        return wrapperDiv.html();
    };
    /** 날씨정보로 날씨 케이스 구분 */
    this.verifyWeatherCase = function (pty, rn1, sky) {
        var weather_case={title:"",ico_class:"",desc:""};
        if(isNaN(Number(pty))
            ||isNaN(Number(sky))){
            //예외발생으로 X  값이 오는 경우임.
            return weather_case;
        }
        var snow = ["3", "7"];
        var rainy = ["1", "4", "5"];
        var snowRain = ["2","6"];
        var clear = ["1", "2", "3"];
        var gloomy = ["2","3","4"];
        if (pty === "0") {//강수없음, default
            if (clear.includes(sky)) {
                weather_case.title = "맑음";
                weather_case.ico_class="sunny";
            }
            if (gloomy.includes(sky)) {
                weather_case.title = "흐림";
                weather_case.ico_class="gloomy";
            }

        } else {
            if (snow.includes(pty)) {
                weather_case.title = "눈";
                weather_case.ico_class="snow";
            } else if (rainy.includes(pty)) {
                weather_case.title = "비";
                weather_case.ico_class="rainy";
            } else if (snowRain.includes(pty)) {
                weather_case.title = "눈";
                // weather_case.title = "비/눈";
                weather_case.ico_class="snowrain";
            }

            /*
            "A : 문자열 ""1.0mm 미만"" or 실수값 1.00~29.9mm
            C : 문자열 ""30.0~50.0mm"" or 문자열 ""50.mm 이상"")
            ""X"" 예외발생"*/
            var isRnMsgShow =true;
            var rn_light_str = "1.0mm 미만";
            var rn_heavy_str = "50.0mm 이상";
            var rn_light_range = [1.00, 29.9];
            var rn_heavy = [30.00, 50.0];
            if (isRnMsgShow&&!isEmpty(rn1)) {
                if(rn1.includes(rn_light_str)||
                    rn1.includes(rn_heavy_str)){
                    if (rn_light_str === rn1) {
                        weather_case.desc = weather_case.title + "-약함";
                    } else if (rn_heavy_str === rn1) {
                        weather_case.desc = weather_case.title + "-강함";
                    }
                }else{
                    var floatRn1 = rn1.replace("mm","");
                    if(typeof parseFloat(floatRn1)!=="number"&&rn1.includes("~")){
                        if (parseFloat(floatRn1) >= rn_light_range[0] && parseFloat(floatRn1) < rn_light_range[1]) {
                            weather_case.desc = weather_case.title + "-약함";
                        } else if (parseFloat(floatRn1) >= rn_heavy[0] && parseFloat(floatRn1) < rn_heavy[1]) {
                            weather_case.desc = weather_case.title + "-강함";
                        }
                    }else{
                        if(rn1==="30.0~50.0mm"){
                            weather_case.desc = weather_case.title + "-강함";
                        }else{
                            weather_case.desc = weather_case.title + "-약함";
                        }
                    }
                }

                if (Number(rn1)) {//숫자만 온경우.

                } else {
                    if(weather_case.title.indexOf('함') == -1 ){
                        if (rn_light_str === rn1) {
                            weather_case.desc = weather_case.title + "-약함";
                        } else if (rn_heavy_str === rn1) {
                            weather_case.desc = weather_case.title + "-강함";
                        }
                    }
                }
            }

        }
        if (!weather_case) {
            COMMON_FUNCTION.TOOL.DEBUG.showTalk( "weather_case verify==> empty");
        }else{
            if(isEmpty(weather_case.desc)) weather_case.desc=weather_case.title;
        }

        return weather_case;
    };
    /** 로그인 홈 공통 스타트,gps,날씨,차량정보, 페이지리로딩*/
    this.signedHomeCommonStart = function(intro_selectCar) {

        return collectGpsWeatherInfos()/** 1.gps,날씨 */
            .then(this.collectCarListInfo) /** 2.보유차량, 계약 차량 */
            .then(
                function (ownCarListInfo) {
                    /** 차량데이터 검증결과, 차량보유 홈이 아니라 다른 페이지인지 재검증 */
                    if(!isEmpty(loginHome))loginHome.gVals.display = CMM_HOME.dict.disp["HAS_CAR_ONLY"];//임시상태임.
                    CMM_HOME.reloadLoginHome(ownCarListInfo,intro_selectCar);
                    return ownCarListInfo;
                }
            );
    };
    /** 1.gps, 2.gps_kor 3.weather */
    var collectGpsWeatherInfos =  function() {
        var phase=0;
        // return onResultGPSAsync(true)/** gps정보획득 */
        return COMMON_FUNCTION.TOOL.GPS.getGPSCoordsAsync()
            .then(/** gps 주소명 획득 */
                function (gps) {
                    if (!isEmpty(gps)) {
                        var lat;
                        var lng;
                        if (!isEmpty(gps)) {
                            lat = gps.latitude;
                            lng = gps.longtitude;
                        } else {
                            lat = CONSTANT.DEFAULTS_LOCATION.LAT;
                            lng = CONSTANT.DEFAULTS_LOCATION.LNG;
                        }
                        return routoMapReverseGeocodeAsync(lat, lng);
                        // return routoMapReverseGeocodeAsync(Math.abs(lat), Math.abs(lng));
                    }else{
                        return null;
                    }
                }
            )
            .then(/**gps 정보 기반 날씨정보 획득*/
                function (gpsKor) {

                    var defaultGpsKor = {
                        jibun:{lat:CONSTANT.DEFAULTS_LOCATION.LAT,lng:CONSTANT.DEFAULTS_LOCATION.LNG},
                        administrative:{state:"서울시",city:"서초구"},
                        gpsInfo:null
                    };

                    var gpsData;

                    if(!gpsKor ||  gpsKor.errorCode){
                        gpsData = defaultGpsKor;
                    }else{
                        gpsData = !isEmpty(gpsKor)&&!isEmpty(gpsKor.result)? gpsKor.result[0]:defaultGpsKor;
                        console.log(gpsData);
                    }

                    if(!gpsData.jibun || !gpsData.jibun.lat){
                        gpsData = defaultGpsKor;
                    }

                    // todo 글로벌에 저장해야 한다.
                    loginHome.gVals.location = {
                        lat: gpsData.jibun.lat,
                        lng: gpsData.jibun.lng,
                        state: gpsData.administrative.state,
                        city: gpsData.administrative.city,
                        gpsInfo: gpsData
                    };
                    try {
                        return CMM_NET_SVR.getWethRsetDustyInfo({
                            mbrId: PGV.loginInfo.mbrId,
                            lat: isEmpty(gpsData)?defaultGpsKor.jibun.lat:gpsData.jibun.lat,
                            lng: isEmpty(gpsData)?defaultGpsKor.jibun.lng:gpsData.jibun.lng
                        });
                    } catch (e) {
                        return null;
                    }
                }
            )
            .then(/**날씨정보 글로벌 셋팅*/
                function (response) {
                if (!isEmpty(response) && !isEmpty(response.resultCode) && response.resultCode === "200") {
                        if (!isEmpty(response.weatherSnrsResDto)) {
                            loginHome.gVals.main.weatherInfo.snrsResDto = response.weatherSnrsResDto;
                        }
                        if (!isEmpty(response.weatherAirPltnResDto)) {
                            loginHome.gVals.main.weatherInfo.airPltnResDto = response.weatherAirPltnResDto;
                            var dust1 = CMM_HOME.dict.weather.DUST[response.weatherAirPltnResDto.pm10Grd];//미세
                            var dust2 = CMM_HOME.dict.weather.DUST[response.weatherAirPltnResDto.pm25Grd];//초미세
                            loginHome.gVals.main.weatherInfo.dust = {pm10Grd: dust1, pm25Grd: dust2};
                        }
                        if (!isEmpty(response.weatherFcstResDto)) {
                            loginHome.gVals.main.weatherInfo.fcstResDto = response.weatherFcstResDto;
                            // 후에 HOME인사이트 API 호출시 , 서버에서 변환해서 줌
                            // that.gVals.main.response.case = verifyWeatherCase(pty, rn1, sky);
                        }
                    }else{
                        loginHome.gVals.main.weatherInfo= {};
                    }

                }
            )
    };
    /** 차량정보 서버에서 받아오기 */
    this.collectCarListInfo = function() {
        var phase =0;
        return new Promise(//화면분기값을 resolve 한다.
            function (resolve, reject) {
                var ownCarListInfoFromIntro = MData.global("ownCarListInfo")||null;//인트로에서 넘어옴.
                if(!isEmpty(ownCarListInfoFromIntro)){
                    resolve(ownCarListInfoFromIntro);
                }else{
                    var defaultCar=null;
                    CMM_NET_SVR.getSynchronizeUserCarInfo()
                        .then(/**동기화후 차량보유데이터*/
                            function (syncResult) {
                                if (syncResult && syncResult.resultCode === "200") {
                                    return CMM_NET_SVR.getOwnCarListInfo();
                                }else{
                                    return null;
                                }
                            }
                        )
                        .then(
                            function(response){
                                if(response.resultCode=== "200"){
                                    var data = { myCarInfoListResDto:response.myCarInfoListResDto,
                                        unDeliveryCarInfoListResDto:response.unDeliveryCarInfoListResDto};

                                        for (var i=0; i<data.myCarInfoListResDto.length; i++){
                                            data.myCarInfoListResDto[i].isContract = false;
                                        }

                                        for (var i=0; i<data.unDeliveryCarInfoListResDto.length; i++){
                                            data.unDeliveryCarInfoListResDto[i].isContract = true;
                                        }

                                    resolve(data);
                                }else{
                                    loginHome.importantMessege="보유하신 차량 정보가 확인되지 않습니다．\n" +
                                        "고객센터에 문의 바랍니다．";
                                    resolve(null);
                                }
                            }
                        )
                        .catch(function (e) {
                            resolve(null);
                            loginHome.importantMessege="보유하신 차량 정보가 확인되지 않습니다．\n" +
                                "고객센터에 문의 바랍니다．";
                            COMMON_FUNCTION.TOOL.DEBUG.showTalk( e);
                        });
                }


            });
    };
    /** 페이지리로딩 */
    this.reloadLoginHome = function(carListInfo,intro_selectCar){//carListInfo="RNW-CMM-5002" response
        //미로그인 홈이 아니라 로그인 홈으로 로드 해야 함.
        var loginedHome;
        var options = {
            action: 'CLEAR_TOP',
            animate: 'FADE',
            param:{}
        };
        if(isEmpty(carListInfo)){
            loginedHome = PATH_MANAGER.KIA_RNW_120_0000;
        }else{
            var undeliveryCarList = carListInfo.unDeliveryCarInfoListResDto;
            var myCarList = carListInfo.myCarInfoListResDto;
            var undeliveryCarListLen = !isEmpty(undeliveryCarList)?undeliveryCarList.length:0;
            var myCarListLen = !isEmpty(myCarList)?myCarList.length:0;
            if(isEmpty(undeliveryCarList)&&isEmpty(myCarList)){
                intro_selectCar=null;
            }
            if(isEmpty(intro_selectCar)){//스플래시->home 진입 즉, 선택차량 따로 없음.
                if(undeliveryCarListLen>0 && myCarListLen ===0) {
                    //계약차만 있음.
                    loginedHome = PATH_MANAGER.KIA_RNW_120_0000_2;
                }else{
                    if(myCarListLen>0){
                        loginedHome = PATH_MANAGER.KIA_RNW_120_0000_3;
                    }else{
                        loginedHome = PATH_MANAGER.KIA_RNW_120_0000;
                    }
                }
            }
            else{//홈 -> 차량변경

                if(intro_selectCar.isContract && myCarListLen ===0) {//계약차량보유 only home
                    loginedHome = PATH_MANAGER.KIA_RNW_120_0000_2;
                }
                else{
                    if(!isEmpty(intro_selectCar.vin)||intro_selectCar.isContract) {
                        loginedHome = PATH_MANAGER.KIA_RNW_120_0000_3;
                    }else{
                        loginedHome = PATH_MANAGER.KIA_RNW_120_0000;
                    }
                }
            }
            loginHome.gVals.car.myCarInfoListResDto=myCarList;
            loginHome.gVals.car.unDeliveryCarInfoListResDto=undeliveryCarList;
            if(PGV.currentPage!==loginedHome.nameWithHtml){
                if(!isEmpty(loginedHome.path)){
                    if(!isEmpty(intro_selectCar))options.param.intro_selectCar = intro_selectCar;
                }
            }else{
                if(!isEmpty(intro_selectCar))options.param.intro_selectCar = intro_selectCar;
            }
        }
        options.url=loginedHome.path;
        MPage.html(options);
    };
    this.setUiEventListner = function (){
        fnTooltipBtn();
        // if(!isEmpty($('.js-tooltip-btn')))fnTooltipBtn();//ui_rnw에서 이벤트 매핑 안됨. 안전운전점수 툴팁.
        function fnSetHomeHeaderBgActive() {

            var $nowTop = $(this).scrollTop();

            // homeheader
            var $homeHeader = $('div.pg-main #homeHeader');
            var $homeHeaderHeight = $homeHeader.outerHeight();

            if ($nowTop > $homeHeaderHeight) {
                $homeHeader.addClass('js-home-header-fixed');
            } else {
                $homeHeader.removeClass('js-home-header-fixed');
            }

            $winTop = $nowTop;
        }

        // ubi chart 관련 함수.
        function fnSetEchartsDrivingDataSafety() {

            var _$chart = document.getElementById('echartsDrivingDataSafety');
            if(!isEmpty($(_$chart))){
                function fnSetDataOffsetCenter() {
                    var $winWidth = $(window).innerWidth();
                    var nDistance;

                    nDistance = ($winWidth >= 768) ? 93 : 89;

                    return nDistance;
                }
                var _echartsDrivingDataSafety = echarts.init(_$chart);
                var _echartsDrivingDataSafety_option;

                _echartsDrivingDataSafety_option = {
                    tooltip: {
                        borderWidth: 0,
                        axisPointer: {
                            type: ''
                        },
                        textStyle: {
                            fontSize: 1.3 + 'rem',
                            fontFamily: 'KiaSignature',
                        },
                        //formatter: '{a} <br/>{b} : {c}%',
                        formatter: function (value) {

                            var _value0_data = '';
                            _value0_data += '<div class="tooltip-cont d-flex">';
                            _value0_data += '<span class="tooltip-name"><i class="ico-circle" style="background-color:#05141f;"></i>안전운전 점수 :</span>';
                            _value0_data += '<span class="tooltip-value">' + value.data.value + '%' + '</span>';
                            _value0_data += '</div>'

                            return _value0_data;

                        }
                    },
                    series: [

                        // gauge layer1 : 게이지그래프, center value
                        {
                            type: 'gauge',
                            //center: ['50%', '50%'],

                            startAngle: 180,
                            endAngle: 0,
                            min: 0,
                            max: 100,
                            itemStyle: {
                                color: '#05141f',
                            },
                            progress: {
                                show: true,
                                roundCap: false,
                                width: 33,
                            },
                            axisLine: {
                                show: true,
                                roundCap: false,
                                color: '#f4f4f1',

                                lineStyle: {
                                    width: 33
                                }

                            },
                            axisTick: {
                                show: false,
                            },
                            splitLine: {
                                show: false,
                            },
                            pointer: {
                                show: false,
                            },
                            axisLabel: {
                                show: false,
                                height: 20,
                                fontFamily: 'KiaSignature',
                                fontSize: 1.2 + 'rem',
                                //fontWeight: 'bolder',
                                color: '#939598',
                                //distance: -10,
                                formatter: function (value) {
                                    if (value == 0 || value == 100) {
                                        return value;
                                    }
                                },
                            },
                            title: {
                                show: true,
                                offsetCenter: ['0', '18%'],
                                fontFamily: 'KiaSignature',
                                fontSize: 1.4 + 'rem',
                                color: '#05141f'
                            },
                            detail: {
                                //width: '100%',
                                borderRadius: 0,
                                offsetCenter: ['0', '-12%'],
                                valueAnimation: true,
                                //fontFamily:'KiaSignature',
                                fontSize: 4.8 + 'rem',
                                color: '#05141f',
                                // formatter: function (value) {
                                //   return '{value|' + value.toFixed(0) + '}{unit|km/h}';
                                // },
                            },
                            data: [
                                {
                                    value: loginHome.gVals.ccs.ubi.safetyDrvScore || 0,
                                    // name: '전일대비 14점 ▲',
                                }
                            ]
                        },

                        // gauge layer2 : 게이지그래프 눈금표
                        {
                            type: 'gauge',
                            z: 10,
                            startAngle: 500,
                            endAngle: 0,
                            min: 0,
                            max: 0,
                            progress: {
                                show: false,
                            },
                            axisLine: {
                                show: false,
                            },
                            axisTick: {
                                show: true,
                                distance: 2,
                                length: 8,
                                lineStyle: {
                                    color: '#f4f4f1',
                                    width: 1,
                                },
                            },
                            splitLine: {
                                show: false,
                            },
                            pointer: {
                                show: false,
                            },
                            axisLabel: {
                                show: false,
                            },
                            title: {
                                show: false,
                            },
                            detail: {
                                show: false,

                            },

                        },

                        // gauge layer3 : 게이지그래프 0, 100 수치
                        {
                            type: 'gauge',
                            z: 20,

                            startAngle: 0,
                            endAngle: 0,
                            min: 0,
                            max: 0,
                            progress: {
                                show: false,
                            },
                            axisLine: {
                                show: false,
                            },
                            axisTick: {
                                show: false,
                            },
                            splitLine: {
                                show: false,
                            },
                            pointer: {
                                show: false,
                            },
                            axisLabel: {
                                show: false,
                            },
                            title: {
                                show: false,
                            },
                            detail: {
                                show: true,
                                fontFamily: 'KiaSignature',
                                fontSize: 12,
                                fontWeight: 'lighter',
                                color: '#939598',
                            },
                            data: [
                                {
                                    value: 0,
                                    detail: {
                                        offsetCenter: ['-' + fnSetDataOffsetCenter() + '%', '18%']
                                    },
                                },
                                {
                                    value: 100,
                                    detail: {
                                        offsetCenter: [fnSetDataOffsetCenter() + '%', '18%']
                                    },
                                }
                            ]
                        },

                    ],
                }

                $(document).ready(function () {
                    _echartsDrivingDataSafety.setOption(_echartsDrivingDataSafety_option);
                    $('#echartsName').fadeIn();
                });

                $(window).on('resize', function () {
                    _echartsDrivingDataSafety.resize();
                });
            }
            return;
        };
        var _$slider = $('.slider-main-visual .swiper-slide');
        if(_$slider.length>1){//슬라이더 1개 이상 일때만 스와이퍼 적용.
            loginHome._sliderVisual = new Swiper('.slider-main-visual', {
                slidesPerView: 1,
                loop: false,
                speed: 300,
                //grabCursor:true,
                touchRatio: $('.content-home .slider-main-visual .swiper-slide').length > 1 ? true : false, // 슬라이드 영역 1개일경우 드래그 금지,
                pagination: {
                    el: '.main-visual-cont .swiper-pagination',
                    clickable: true,
                },
            });
        }
        // ------------------------------
        // 	Scroll START
        // ------------------------------
        var nScrollPos = [];
        var nScrollPosNum = 0;
        $('[class^="section-"]').not(".none").each(function (idx, item) {
        // $('[class^="section-"]').each(function (idx, item) {
            nScrollPos[nScrollPosNum] = $(this).offset().top - 450;
            nScrollPosNum++;
        });
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        // 한번만 실행
        var activeScrollFlag1 = true;
        $(window).off("scroll").on("scroll",function (e) {
            var $nowTop = $(this).scrollTop();
            fnSetHomeHeaderBgActive(); // 메인홈 header활성화
            for (var i = 0; i < nScrollPos.length; i++) {
                if ($nowTop > nScrollPos[i]) {
                    $('[class^="section-"]').not(".none").eq(i).addClass('active--scroll');

                    if (!$('.section-02').hasClass('none')
                        && $('.section-02').hasClass('active--scroll')
                        && activeScrollFlag1) {
                        fnSetEchartsDrivingDataSafety();
                        activeScrollFlag1 = false;
                    }

                }
            }
        });
        // ------------------------------
        // 	Scroll END
        // ------------------------------
    };
    /***
     * common_home 에 homePgvObj>popUp 부분 참조.
     * 주의 : 홈의 팝업은 체인닝 되어 있음.
     * @returns {Promise}
     * @private
     */
    this.verifySelectCarAndSetVariables = function(ownCarListInfo) {
        /**
         * 차량리스트중에서 디폴트로 선택될 차량을 선정하고 값을 리턴한다.
         * @param carList
         * @returns {defaultCar}
         */
        function verifySelectCar(carList,contractCarList) {
            var preSelectCar=null;
            if (!isEmpty(intro_selectCar)) {
                if(!isEmpty(intro_selectCar.vin)){
                    preSelectCar = carList.find(function (value) {
                        return value.vin == intro_selectCar.vin;
                    });//선택차량
                }else if(intro_selectCar.isContract){
                    preSelectCar = contractCarList.find(function (value) {
                        return value.contNo == intro_selectCar.contNo;
                    });//선택차량
                }
            }
            //preSelectCar and repCar
            var repCar;
            if(!isEmpty(carList)){
                repCar = carList.find(function (value) {
                    return value.dispNo == "1";
                });//선택-대표차량
                if(isEmpty(repCar)){
                    repCar =  carList[0];
                }
            }

            if(isEmpty(repCar)&&!isEmpty(contractCarList)){
                repCar =  contractCarList[0];
            }
            loginHome.gVals.representCar = repCar;


            if(isEmpty(loginHome.gVals.car.selectCar)){
                loginHome.gVals.representCar = repCar;
            }
            var defaultSelectedCar = !isEmpty(preSelectCar)?preSelectCar:repCar;
            loginHome.gVals.car.selectCar = defaultSelectedCar;
            COMMON_FUNCTION.TOOL.DEBUG.showTalk("defaultSelectedCar : ",defaultSelectedCar);
            return defaultSelectedCar;
        }

        var undeliveryCarList = ownCarListInfo.unDeliveryCarInfoListResDto;
        var myCarList = sortJsonArrayList(ownCarListInfo.myCarInfoListResDto, "dispNo");
        var defaultCar = null;
        var display = {};
        var isSelectedCarEv = false;

        /* 선택차량 선정. */
        defaultCar = verifySelectCar(myCarList, undeliveryCarList);
        isSelectedCarEv = defaultCar.memEvYn != "N";
        loginHome.gVals.car.isEv = isSelectedCarEv;
        if (defaultCar.isContract) {//선택차량이 계약차임
            display = CMM_HOME.dict.disp = "CONSTRUCT_CAR";
        } else {//선택차량이 보유차임
            if (isEmpty(defaultCar.carId)) {
                display = CMM_HOME.dict.disp.HAS_CAR_CCS_ENABLE;//ccs isMaster를 조회하라.
            } else {
                display = CMM_HOME.dict.disp.HAS_CAR_CCS;//동의조회하기
            }
            if (!isEmpty(undeliveryCarList)) {
                //계약차도 있음.
                loginHome.gVals.popUp.constructCarPop = true;
            }
        }
        /*페이지변수 셋*/
        loginHome.gVals.car.selectCar = defaultCar;
        loginHome.gVals.car.unDeliveryCarInfoListResDto = undeliveryCarList || {};
        loginHome.gVals.car.myCarInfoListResDto = myCarList;
        loginHome.gVals.display = display;
        return display;
    }
    /** 실운행등록시에 차량정보 다시 셋팅하기
     * */
    this.setNewCarInfos = function() {
        CMM_HOME.collectCarListInfo()
            .then(
                function (ownCarListInfo) {
                    /** 차량데이터 검증결과, 차량보유 홈이 아니라 다른 페이지인지 재검증 */
                    if(!isEmpty(loginHome))loginHome.gVals.display = CMM_HOME.dict.disp["HAS_CAR_ONLY"];//임시상태임.
                    CMM_HOME.reloadLoginHome(ownCarListInfo, intro_selectCar);
                    return ownCarListInfo;
                }
            )
            .then(CMM_HOME.verifySelectCarAndSetVariables)
            .then(
                function () {
                    var passData = toAddPassData(loginHome.gVals);
                    MData.global("passData", passData);
                    PGV.passData = passData;
                }
            );
    }
    /** 메인홈 날씨 슬라이더 html 반환 */
    this.htmlWeatherMainVisualBox = function(weatherInfo) {

        var gpsKor = (loginHome.gVals.location.state||"") + " " + (loginHome.gVals.location.city||"");
        var html='';
        //(S) 슬라이더시작
        //div.swiper-slide
        //└────div.main-visual-box
        //│     └────div.group-01 : 날씨
        //│     └────div.group-02 : 미세먼지
        //└────button : 차량복구/내차위치 등 링크버튼 위치
        var msgHtml = '                          <b>반갑습니다.<br>MyKia입니다.</b>';//계약차 미보유차 메세지 고정.
        if (PGV.currentPage == PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml) {
            var homeInsight = loginHome.gVals.main.homeInsight;
            if (isEmpty(homeInsight.genInstMsg1) || isEmpty(homeInsight.genInstMsg2)) {
                msgHtml = '          <b>' + PGV.loginInfo.mbrNm + '님' + '<br>오늘도 안전 운행 하세요.</b>';
            } else {
                msgHtml = '           <b>' + homeInsight.genInstMsg1 + '<br>' + homeInsight.genInstMsg2 + '</b>';
            }
        }
        if (!isEmpty(weatherInfo) && !isEmpty(weatherInfo.case) && isEmpty(weatherInfo.fcstREsDto)) {
            var weatherFcstResDto = weatherInfo.fcstResDto;
            var weatherCase = weatherInfo.case;
            /***
             * 날씨정보 오류시 처리 4case[날씨,미세먼지](11,10,01,00) 퍼블->KIA_RNW_110_0000.html 확인
             * */


            if (!isEmpty(weatherCase)) {
                var temperature = isEmpty(weatherFcstResDto) ? "x" : weatherFcstResDto.t1h;
                var temperatereEl = "";
                if (temperature.toLowerCase() !== "x") {
                    temperatereEl = '                          <span class="degree">' + temperature + '</span>';
                }
                var dust1 = weatherInfo.dust.pm10Grd;//미세
                var dust1El = "";
                if (dust1.cd.toLowerCase() !== "x") {
                    dust1El = '                        <span>미세 <em class="' + dust1.font_class + '">' + dust1.text + '</em></span>';
                }
                var dust2 = weatherInfo.dust.pm25Grd;//초미세
                var dust2El = "";
                if (dust2.cd.toLowerCase() !== "x") {
                    dust2El = '                        <span>초미세 <em class="' + dust2.font_class + '">' + dust2.text + '</em></span>';
                }

                //(S)--div.main-visual-box
                html += '    <div class="main-visual-box">';
                //(S)--group-01
                var group1Html = "";
                group1Html += '      <div class="group-01">';
                group1Html += '        <div class="row text-align-right">';
                group1Html += '          <button type="button" class="btn-gps">';
                group1Html += '            <i class="ico-gps"></i><em>' + gpsKor + '</em>';
                group1Html += '          </button>';
                group1Html += '        </div>';
                group1Html += '        <div class="row">';
                group1Html += '          <h2 class="text-scale-02">';
                group1Html += msgHtml;
                group1Html += '          </h2>';
                group1Html += '        </div>';
                group1Html += '      </div>';// !E group-01
                //(S)--group-02
                var allInfoExist = !isEmpty(dust1El) && !isEmpty(dust2El) && (weatherFcstResDto.pty.toLowerCase() !== "x" || weatherFcstResDto.rn1.toLowerCase() !== "x" || weatherFcstResDto.sky.toLowerCase() !== "x");
                var allInfoNotExist = isEmpty(dust1El) && isEmpty(dust2El) && (weatherFcstResDto.pty.toLowerCase() == "x" || weatherFcstResDto.rn1.toLowerCase() == "x" || weatherFcstResDto.sky.toLowerCase() == "x");
                var group2Html = "";
                if (!allInfoNotExist) {

                    group2Html += '<div class="group-02">';
                    // 미세먼지 정보 존재 여부에 따라.
                    var row1 = '';//온도,날씨
                    var row2 = '';//미세먼지
                    //===========상위태그 분기처리
                    if (allInfoExist) {
                        row1 += '    <div class="row-01 js-tooltip-ctrl">';
                        row2 += '    <div class="row-02 js-tooltip-ctrl">';
                    } else {
                        if (!isEmpty(dust1El) && !isEmpty(dust2El)) {
                            row1 += '    <div class="row-01">';
                            row2 += '    <div class="row-02 js-tooltip-ctrl" style="border-top:none;">';
                        }
                        if (weatherFcstResDto.pty.toLowerCase() !== "x" || weatherFcstResDto.rn1.toLowerCase() !== "x" || weatherFcstResDto.sky.toLowerCase() !== "x") {
                            row1 += '    <div class="row-01 js-tooltip-ctrl">';
                            row2 += '    <div class="row-02 style="display:none;">';
                        }
                    }

                    //날씨정보 존재시에 (S)row-01's contents
                    if (weatherFcstResDto.pty.toLowerCase() !== "x" || weatherFcstResDto.rn1.toLowerCase() !== "x" || weatherFcstResDto.sky.toLowerCase() !== "x") {
                        row1 += '        <div class="info-text js-tooltip-ctrl">';
                        row1 += temperatereEl;//'<span class="degree">35</span>';
                        row1 += '            <span>' + weatherCase.title + '</span>';//'<span>맑음</span>';
                        row1 += '            <button type="button" class="btn-info-regular js-tooltip-btn"><i class="ico-info-regular"></i></button>';
                        row1 += '            <div class="tooltip-box js-tooltip-box">';
                        row1 += '                <h8 class="text-scale-08"><b>기상청 단기예보 API</b></h8>';
                        row1 += '                <div class="inner-info">';
                        row1 += '                    <p>';
                        row1 += '                        본 저작물은 기상청에서 제공하는 동네예보 조회 서비스를 이용하였습니다.<br>';
                        row1 += '                        해당 자료는 공공데이터포털<br>';
                        row1 += '                        www.data.go.kr에서 무료로 확인하실 수 있습니다.';
                        row1 += '                    </p>';
                        row1 += '                </div>';
                        row1 += '                <div class="img-cont">';
                        row1 += '                    <img src="../../img/rnw/main/home/img_opentype01.jpg" alt="">';
                        row1 += '                </div>';
                        row1 += '            </div>';
                        row1 += '        </div>';
                        row1 += '        <div class="info-ico">';
                        row1 += '            <i class="ico-weather ' + weatherCase.ico_class + '"></i>';//'            <i class="ico-weather sunny"></i>';
                        row1 += '        </div>';
                    }
                    row1 += '    </div>';//(E)row-01

                    //미세먼지 정보 존재시에  (S)row-02's contents
                    //미세먼지정보 존재시
                    if (!isEmpty(dust1El) && !isEmpty(dust2El)) {
                        row2 += '        <div class="info-detail">';
                        row2 += dust1El + dust2El;//<span>미세 <em class="dust-status-bad">나쁨</em></span><span>초미세 <em class="dust-status-good">좋음</em></span>
                        row2 += '        </div>';
                        row2 += '        <button type="button" class="btn-info-regular js-tooltip-btn"><i class="ico-info-regular"></i></button>';
                        row2 += '        <div class="tooltip-box js-tooltip-box">';
                        row2 += '            <h8 class="text-scale-08"><b>데이터 오류 가능성</b></h8>';
                        row2 += '            <div class="inner-info">';
                        row2 += '                <p>';
                        row2 += '                    데이터는 실시간 관측된 자료이며 측정소 현지 사정이나 데이터의 수신상태에 따라 미수신 될 수 있음';
                        row2 += '                </p>';
                        row2 += '                <p>';
                        row2 += '                    출처 : Airkorea';
                        row2 += '                </p>';
                        row2 += '            </div>';
                        row2 += '        </div>';
                    }
                    row2 += '    </div>';//(E)row-02
                    group2Html += row1 + row2 + '    </div>';//group-02

                }
                html += group1Html + group2Html;// 그룹1,2 html
                html += '</div>';//main-visual-box
            }
        }
        else {//날씨정보 조회 오류로 디폴트 날씨(맑음)이미지 표출
            if (isEmpty(gpsKor.trim())) gpsKor = "";
            html += '  <div class="main-visual-box">';
            html += '    <div class="group-01">';
            html += '      <div class="row text-align-right">';
            html += '        <button type="button" class="btn-gps">';
            html += isEmpty(gpsKor.trim()) ? "" : '          <i class="ico-gps"></i><em>' + gpsKor + '</em>';
            html += '        </button>';
            html += '      </div>';
            html += '      <div class="row">';
            html += '        <h2 class="text-scale-02">';
            html += msgHtml;
            html += '        </h2>';
            html += '      </div>';
            html += '      <div class="row d-flex justify-content-between align-items-end">';
            html += '      </div>';
            html += '    </div>';
            html += '  </div>';
        }
        return html;
    }
    this.popupManage = function () {
        /* 실운행자등록 팝업 */
        function popRealDriver() {
            eventLog("carAgreeStandBy", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
            return CMM_NET_SVR.getCarAgreeStandBy()
                .then(
                    function (response){
                        // 4test: 실운행자 데이터 동적세팅 오래걸림. 개발동안.
                        // response.carAgreeStandByListRnwResDto = [
                        //     {
                        //         "vin": "KNAGS411BJA233710",
                        //         "rdmStateCcd": null,
                        //         "ownerCsmrMgmtNo": "A202203220000003",
                        //         "mbrId": "munju.kim@ksmartech.com",
                        //         "mbrNm": "김문주",
                        //         "carRgstNo": "12가3333",
                        //         "mdlNm": "K5",
                        //         "rdmRelCcd": "36"
                        //     },
                        //     {
                        //         "vin": "KNAB1212BHT001122",
                        //         "rdmStateCcd": null,
                        //         "ownerCsmrMgmtNo": "A201706290000753",
                        //         "mbrId": "mtest@test.com",
                        //         "mbrNm": "강민영",
                        //         "carRgstNo": "12가1234",
                        //         "mdlNm": "EV6",
                        //         "rdmRelCcd": "99"
                        //     }
                        // ];
                        if (response.resultCode === "200"&&!isEmpty(response.carAgreeStandByListRnwResDto)) {
                            loginHome.gVals.popUp.realDriverRegisterPop.active=true;
                            loginHome.gVals.popUp.realDriverRegisterPop.data= response.carAgreeStandByListRnwResDto;
                            loginHome.gVals.popUp.realDriverRegisterPop.popFunc = function(){
                                function htmlRdmReqContents(ownerName) {
                                    var html='';
                                    html += '<p>';
                                    html += ownerName + '님이 ' + PGV.loginInfo.mbrNm + '님에게<br>';
                                    html += '실운행자 등록을 요청하셨습니다.<br>';
                                    html += '실운행자 등록에 동의하시겠습니까?';
                                    html += '</p>';
                                    return html;
                                }

                                var pagefunction = function(item){
                                    var driverInfos = loginHome.gVals.popUp.realDriverRegisterPop.data;
                                    MData.param("driverList",driverInfos);
                                    MData.param("toReloadCarInfo",false);
                                    if($("#popup_0B0_0000").length < 1){
                                        var driverInfo = driverInfos[0];
                                        var screenHtml = $("<div></div>");
                                        screenHtml.append(item);
                                        $('body').append(screenHtml.find('#popup_0B0_0000'));
                                        var _$target = $("#popup_0B0_0000_contents");
                                        var _$content = $(htmlRdmReqContents(driverInfo.mbrNm));
                                        _$target.append(_$content);
                                        _$target.data("registInfo",driverInfo);
                                        exWNHideIndicator();
                                        //dim 클릭시.
                                        $("#popup_0B0_0000").find("div.dim").off("click").on("click",function(e){
                                            e.preventDefault();
                                            var lastList = MData.param("driverList");
                                            if(typeof lastList == 'string' || loginHome.gVals.popUp.realDriverRegisterPop.data.length!=lastList.length){
                                                var newHomes  = [PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml,
                                                    PATH_MANAGER.KIA_RNW_120_0000_2.nameWithHtml]
                                                if(PGV.currentPage!=PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml){
                                                    MPage.html({
                                                        url : PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml
                                                    });
                                                }else{
                                                    loginHome.intro_selectCar=loginHome.gVals.car.selectCar;
                                                    CMM_HOME.setNewCarInfos();//실운행자등록으로 내 차량 정보가 변경되어져야함.
                                                    $("#popup_0B0_0000").fadeOut('fast');
                                                    $('body').removeClass('js-overflow-hidden');
                                                    $(".wrapper").removeClass("donemove");
                                                    customPopup.remove($("#popup_0B0_0000"));
                                                    loginHome.gVals.popUp.realDriverRegisterPop.status = "close";
                                                    MData.removeParam("driverList");//마지막에 삭제
                                                    exWNHideIndicator();
                                                }
                                            }else{
                                                loginHome.gVals.popUp.realDriverRegisterPop.status = "close";
                                            }
                                        });
                                        /** (S)확인버튼 클릭시 */
                                        $("#popup_0B0_0000").find("[data-regist-agree-yn]").off("click").on("click", function () {
                                            MData.param("toReloadCarInfo", true);
                                            var agreeYn = $(this).data("registAgreeYn");
                                            var registInfo = $("#popup_0B0_0000").find("div.popup-body div.group-01").data("registInfo");
                                            var sendData = {
                                                mbrId: PGV.loginInfo.mbrId,
                                                chmbCrorAgrYn: agreeYn, //실행운행자동의여부
                                                vin: registInfo.vin, //차대번호
                                                rdmRelCd: registInfo.rdmRelCcd, //관계코드
                                                ownCsmrMgmtNo: registInfo.ownerCsmrMgmtNo, //차주고객관리번호
                                                ownMbrId: registInfo.mbrId, //차주아이디
                                            };
                                            eventLog("realDriverAgreeYn", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
                                            //4test: 빠른 화면콘트롤 확인: 아래 then function안에 코드만 실행토록 함.
                                            CMM_NET_SVR.postRealDriverAgreeYn(sendData)//1. 실운행자등록
                                                .then(function (response) {
                                                    exWNHideIndicator();
                                                    // 성공여부상관없이 , 다음 실행운전 팝업내용으로 교체한다.
                                                    // if (response.resultCode === "200" && !isEmpty(response.registYn) && response.registYn=="Y") {}else{}
                                                    var resultMessage = registInfo.mdlNm + "(" + registInfo.carRgstNo + ")";
                                                    if (response.resultCode === "200" && !isEmpty(response.registYn)&&response.registYn == "Y") {
                                                        if (agreeYn == "Y") {
                                                            resultMessage += " 차량에 대한 실운행자로 등록되었습니다.";
                                                        } else {
                                                            resultMessage ="";//등록거절됨.
                                                        }
                                                    } else {
                                                        resultMessage += " 차량에 대한 실운행자 등록에 실패하였습니다.";
                                                    }
                                                    if(!isEmpty(resultMessage))MPopup.instance(resultMessage);

                                                    $("#popup_0B0_0000").find("div.popup-body div.group-01").html("");
                                                    var driverInfos = MData.param("driverList");
                                                    var newList = !isEmpty(driverInfos) ? driverInfos.splice(1, driverInfos.length) : [];
                                                    MData.param("driverList", newList);
                                                    if (isEmpty(newList)) {
                                                        var newHomes  = [PATH_MANAGER.KIA_RNW_120_0000.nameWithHtml,
                                                            PATH_MANAGER.KIA_RNW_120_0000_2.nameWithHtml]
                                                        if(PGV.currentPage!=PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml){
                                                            MPage.html({
                                                                url : PATH_MANAGER.KIA_RNW_120_0000_3.nameWithHtml
                                                            });
                                                        }else{
                                                            loginHome.intro_selectCar=loginHome.gVals.car.selectCar;
                                                            CMM_HOME.setNewCarInfos();//실운행자등록으로 내 차량 정보가 변경되어져야함.
                                                            $("#popup_0B0_0000").fadeOut('fast');
                                                            $('body').removeClass('js-overflow-hidden');
                                                            $(".wrapper").removeClass("donemove");
                                                            customPopup.remove($("#popup_0B0_0000"));
                                                            loginHome.gVals.popUp.realDriverRegisterPop.status = "close";
                                                            MData.removeParam("driverList");//마지막에 삭제

                                                        }

                                                    } else {

                                                        $("#popup_0B0_0000").find("div.popup-body div.group-01").html(htmlRdmReqContents(newList[0].mbrNm));
                                                        $("#popup_0B0_0000").find("div.popup-body div.group-01").data("registInfo", newList[0]);

                                                    }
                                                    eventLog("realDriverAgreeYn", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                                                });
                                        //4test: 빠른 화면콘트롤 확인:
                                        });
                                        /** !!(E)확인버튼 클릭시 */
                                    };
                                    RNW_UI.popupLayer({selId : '#popup_0B0_0000'});
                                };
                                customPopup.get(PATH_MANAGER.KIA_RNW_0B0_0000.path, $("#popup_0B0_0000"), pagefunction);
                                loginHome.gVals.popUp.realDriverRegisterPop.status ="open";
                            };
                        }
                        else{
                            if(!loginHome.gVals.popUp.realDriverRegisterPop.active) loginHome.gVals.popUp.realDriverRegisterPop.status="ignore";
                        }
                        eventLog("carAgreeStandBy", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                        return;
                    }
                );
        }
        /* 주유내역등록 팝업 */
        function popOilTopUp() {
            return new Promise(function (resolve){
                var isSmsEnabled = M.data.storage("enable_receive_payment_info");
                // 4test
                // if(true){
                if(exWNcheckNotificationPermission()&&isSmsEnabled){
                    eventLog("propSearch", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
                    return CMM_NET_SVR.getPropSearch()
                        .then(//sever 결과 확인후 , 키워드 저장
                            function (response) {
                                eventLog("propSearch", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                                if (response.resultCode === "200") {
                                    M.data.storage("payment_push_keyword", (response.value || ""));
                                    return !isEmpty(response.value);
                                } else {
                                    return false;
                                }
                            }
                        )
                        .then(//새로저장(rule: 3일전 데이터 삭제, 최대 10개만 저장)
                            function (hasKeywords) {
                                if(hasKeywords){
                                    var smsList = M.data.storage("payment_info_list");
                                    //4test
                                    // smsList=[
                                    //     {date:"2022052311",price:"10000"},{date:"2022052312",price:"7000"},{date:"2022052411",price:"9000"},
                                    //     {date:"2022052311",price:"10000"},{date:"2022052312",price:"7000"},{date:"2022052411",price:"9000"},
                                    //     {date:"2022052311",price:"10000"},{date:"2022052312",price:"7000"},{date:"2022052411",price:"9000"},
                                    //     {date:"2022052311",price:"10000"}/*,{date:"2022052312",price:"7000"},{date:"2022052411",price:"9000"}*/]
                                    var lastSmsList;
                                    if(!isEmpty(smsList)){
                                        var day3BeforeNow = moment().add(-3, 'day').format('YYYYMMDD');
                                        var filteredList = smsList.filter(function (item) {
                                            var itemDate = (item.date).substr(0,8);
                                            return itemDate>=day3BeforeNow;
                                        });//대표차량

                                        var lastSmsList = filteredList.splice(0, 10);
                                        M.data.storage("payment_info_list",lastSmsList);
                                        loginHome.gVals.popUp.oilTopUpRegisterPop.active=!isEmpty(lastSmsList)?true:false;
                                        if(!loginHome.gVals.popUp.oilTopUpRegisterPop.active) loginHome.gVals.popUp.oilTopUpRegisterPop.status="ignore";
                                        loginHome.gVals.popUp.oilTopUpRegisterPop.data= lastSmsList;
                                        loginHome.gVals.popUp.oilTopUpRegisterPop.popFunc = function(){
                                            MData.param("smsList",loginHome.gVals.popUp.oilTopUpRegisterPop.data);
                                            var pagefunction = function(item){
                                                var smsInfos = MData.param("smsList");
                                                MData.removeParam("smsList");
                                                if($("#popup_128_0000").length < 1){
                                                    var screenHtml = $("<div></div>");
                                                    screenHtml.append(item);
                                                    $('body').append(screenHtml.find('#popup_128_0000'));
                                                    var _$target = $("#popup_128_0000 div.popup-body div.group-01 p b")
                                                    _$target.text(smsInfos.length+"건");

                                                    exWNHideIndicator();
                                                    $("#popup_128_0000 #popDetailBtn").off("click").on("click",function(){
                                                        MPage.html({url : PATH_MANAGER.KIA_RNW_224_3700.path});
                                                        customPopup.remove($("#popup_128_0000"));
                                                        loginHome.gVals.popUp.oilTopUpRegisterPop.status ="close";
                                                    });
                                                    $("#popup_128_0000").find("div.dim").off("click").on("click",function(e){
                                                        e.preventDefault();
                                                        $("#popup_128_0000").fadeOut('fast');
                                                        $('body').removeClass('js-overflow-hidden');
                                                        $(".wrapper").removeClass("donemove");
                                                        loginHome.gVals.popUp.oilTopUpRegisterPop.status ="close";
                                                    });
                                                    $("#popup_128_0000 button.js-popup-close-btn").off("click").on("click",function(){
                                                        M.data.storage("payment_info_list",null);// 삭제
                                                        customPopup.remove($("#popup_128_0000"));
                                                        loginHome.gVals.popUp.oilTopUpRegisterPop.status ="close";
                                                    });

                                                }
                                                RNW_UI.popupLayer({selId : '#popup_128_0000'});
                                            };
                                            customPopup.get(PATH_MANAGER.KIA_RNW_128_0000.path, $("#popup_128_0000"), pagefunction);
                                            loginHome.gVals.popUp.oilTopUpRegisterPop.status ="open";
                                        };
                                        resolve();
                                    }
                                    else{
                                        if(!loginHome.gVals.popUp.oilTopUpRegisterPop.active) loginHome.gVals.popUp.oilTopUpRegisterPop.status="ignore";
                                        resolve();
                                    }

                                }
                                else{
                                    if(!loginHome.gVals.popUp.oilTopUpRegisterPop.active) loginHome.gVals.popUp.oilTopUpRegisterPop.status="ignore";
                                    resolve();
                                }

                            }
                        )
                }
                else{
                    resolve();
                }
            });

        }
        /* 마케팅 팝업 */
        function popMarketing() {
            var sendData;
            if(!isEmpty(PGV.loginInfo)){
                sendData={
                    mbrId : PGV.loginInfo.mbrId,
                    lgnCd : "LI"
                };
            }else{
                sendData={
                    lgnCd : "LO"
                };
            }
            eventLog("marketingPopup", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
            return CMM_NET_SVR.getMarketingPopup(sendData)
                .then(
                    function (response){
                        //4test only
                        // response.mktPopRnwResDto=[];
                        // response.mktPopRnwResDto[0] = {
                        //     "popNm": "테스트",
                        //     "dispNo": "3",
                        //     "strtDtm": "20220512000000",
                        //     "endDtm": "20220531000000",
                        //     "imgUrl": "http://10.10.33.168:8090/uploadFiles/tempImage/marketing/20220512165652681.png",
                        //     "lnkCd": "O",
                        //     "lnkUrl": "http://www.kia.com",
                        //     "dtlCont": null
                        // };
                        // response.mktPopRnwResDto[1] = {
                        //     "popNm": "마케팅 팝업",
                        //     "dispNo": "2",
                        //     "strtDtm": "20220512000000",
                        //     "endDtm": "20220531000000",
                        //     "imgUrl": "http://10.10.33.168:8090/uploadFiles/tempImage/marketing/20220512165652681.png",
                        //     "lnkCd": "O",
                        //     "lnkUrl": "http://www.kia.com",
                        //     "dtlCont": "상세내용-2번째 슬라이드",
                        // };
                        if (response.resultCode === "200"&&!isEmpty(response.mktPopRnwResDto)) {
                            var popList = sortJsonArrayList(response.mktPopRnwResDto,"dispNo");
                            loginHome.gVals.popUp.marketingPop.active=true;
                            loginHome.gVals.popUp.marketingPop.data= response.mktPopRnwResDto;
                            loginHome.gVals.popUp.marketingPop.popFunc = function(){
                                var convertProxyToArray = JSON.parse(JSON.stringify(loginHome.gVals.popUp.marketingPop.data));//proxy 객체라서 오류나기 때문에.
                                var popList = sortJsonArrayList(convertProxyToArray,"dispNo");
                                MData.param("mktPopList",popList);
                                var pagefunction = function(item){
                                    var popInfos = MData.param("mktPopList");
                                    MData.removeParam("mktPopList");
                                    if($("#popup_129_0000").length < 1){
                                        var screenHtml = $("<div></div>");
                                        screenHtml.append(item);
                                        $('body').append(screenHtml.find('#popup_129_0000'));
                                        var html ="";
                                        var _$target = $("#popSliderTarget");
                                        $.each(popInfos, function (i, mktPopInfo) {
                                            var imgUrl = mktPopInfo.imgUrl;
                                            var lnkCd = mktPopInfo.lnkCd;
                                            var dataLinkStr =''
                                            if(lnkCd.toLowerCase()==="o"){
                                                var param = {};
                                                var carNlifeChek = mktPopInfo.lnkUrl.split("@");
                                                if(!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "carnLife"){     // 카앤라이프일경우 이벤트 등록 형식 carnLife@/a/M070100@621
                                                    param = {
                                                        rUrl : CONSTANT.AUTON_URL_PREFIX + carNlifeChek[1],
                                                        evtCd : isEmpty(carNlifeChek[2]) ? "" : carNlifeChek[2],
                                                        evtYN : "N"
                                                    }
                                                    dataLinkStr = " data-screenid-with-ref='KIA_RNW_810_0000' ";
                                                    param = JSON.stringify(param);
                                                    dataLinkStr += " data-param-info='" + param + "' ";
                                                }else {
                                                    dataLinkStr = " data-webview-link-direct='" + mktPopInfo.lnkUrl + "' ";
                                                }
                                            }
                                            else if(lnkCd.toLowerCase()==="i"){
                                                var isLink = mktPopInfo.lnkUrl.indexOf("http://") !== -1 || mktPopInfo.lnkUrl.indexOf("https://") !== -1;
                                                if(isLink){
                                                    dataLinkStr=" data-webview-link-direct='"+mktPopInfo.lnkUrl+"' ";
                                                }else{

                                                    var refNo = mktPopInfo.dtlCont;// 게시물 디테일(링크, 게시물번호)
                                                    if (!isEmpty(refNo)) {
                                                        var isLink2 = refNo.indexOf("http://") !== -1 || refNo.indexOf("https://") !== -1;
                                                        if(isLink2){
                                                            dataLinkStr=" data-webview-link-direct='"+refNo+"' ";
                                                        }else{
                                                            var param = {};

                                                            if (mktPopInfo.lnkUrl == "KIA_RNW_411_1000") {//event
                                                                param = {
                                                                    evtNo: refNo,		// 이벤트 번호
                                                                    eventType: "msg"	// 이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
                                                                }
                                                            } else if (mktPopInfo.lnkUrl == "KIA_RNW_421_0000") {//설문조사
                                                                param = {"srvyNo": refNo};
                                                            } else {
                                                                COMMON_FUNCTION.TOOL.DEBUG.showTalk("기획되지 않은 파라미터가 필요한 페이지 : " + mktPopInfo.lnkUrl);
                                                            }

                                                            dataLinkStr = " data-screenid-with-ref='" + mktPopInfo.lnkUrl + "' ";
                                                            if (!isEmpty(param)) {
                                                                param = JSON.stringify(param);
                                                                dataLinkStr += " data-param-info='" + param + "' ";
                                                            }
                                                        }

                                                    }
                                                    else{
                                                        var homeTabMenus = ["KIA_RNW_600_0000"
                                                            , "KIA_RNW_500_0000"
                                                            , "KIA_RNW_400_0000"
                                                            , "KIA_RNW_300_0000"
                                                            , "KIA_RNW_200_0000"];//홈탭이동
                                                        if(homeTabMenus.includes(mktPopInfo.lnkUrl)){//홈탭이동하기
                                                            dataLinkStr = " data-home-tab-menu='"+mktPopInfo.lnkUrl+"' ";
                                                        }else{
                                                            dataLinkStr=" data-screenid='"+mktPopInfo.lnkUrl+"' ";
                                                        }

                                                    }
                                                }
                                            }
                                            //console.log(mktPopInfo);
                                            html += "<div class='swiper-slide'"+dataLinkStr +">";
                                            html +=     "<div class='img-box'>";
                                            html +=         "<img src='"+ imgUrl+"' alt=''>";
                                            html +=     "</div>";
                                            html += "</div>";
                                        });
                                        _$target.append($(html));
                                        exWNHideIndicator();
                                        //오늘하루보지않기 체크박스
                                        $("#popup_129_0000").find("#chkOption-day").parent('div.chk-cont').off("click").on("click",function(){
                                            var that = this;
                                            $(that).find("input[type=checkbox]").prop("checked",function(){
                                                return !$(this).prop('checked');
                                            });
                                        });
                                        //확인버튼 클릭시
                                        $("#popup_129_0000").find("#popDetailBtn").off("click").on("click",function(e){
                                            e.preventDefault();
                                            var isChecked = $("#popup_129_0000").find("#chkOption-day").prop("checked");
                                            if(isChecked){
                                                var dayAfter = moment().add(1, 'day').format('YYYYMMDD');
                                                CMM_POP_MNG.modifyShowable("129_0000", true, dayAfter);
                                            }
                                            $("#popup_129_0000").fadeOut('fast');
                                            $('body').removeClass('js-overflow-hidden');
                                            $(".wrapper").removeClass("donemove");
                                            customPopup.remove($("#popup_129_0000"));
                                            loginHome.gVals.popUp.marketingPop.status ="close";
                                        });
                                        $("#popup_129_0000").find("div.dim").off("click").on("click",function(e){
                                            e.preventDefault();
                                            $("#popup_129_0000").fadeOut('fast');
                                            $('body').removeClass('js-overflow-hidden');
                                            $(".wrapper").removeClass("donemove");
                                            loginHome.gVals.popUp.marketingPop.status ="close";
                                        });
                                        COMMON_FUNCTION.TOOL.UI.enableWebviewLinkDirectListeners();
                                        COMMON_FUNCTION.TOOL.UI.enableHomeTabOpenListeners();
                                        COMMON_FUNCTION.TOOL.UI.enableScreenIdWithRefNoListeners();
                                        COMMON_FUNCTION.TOOL.UI.enableScreenIdListeners();
                                    }
                                    RNW_UI.popupLayer({selId : '#popup_129_0000'});
                                    var _sliderVisual = new Swiper('.slider-pop-visual', {
                                        slidesPerView: 1,
                                        loop: false,
                                        speed: 300,
                                        touchRatio: $('.slider-pop-visual .swiper-slide').length > 1 ? true : false, // 슬라이드 영역 1개일경우 드래그 금지
                                        pagination: {
                                            el: '.pop-visual-cont .swiper-pagination',
                                            clickable: true,
                                        },
                                    });
                                };

                                customPopup.get(PATH_MANAGER.KIA_RNW_129_0000.path, $("#popup_129_0000"), pagefunction);
                                loginHome.gVals.popUp.marketingPop.status ="open";
                            };
                        }
                        else{
                            if(!loginHome.gVals.popUp.marketingPop.active) loginHome.gVals.popUp.marketingPop.status="ignore";
                        }
                        eventLog("marketingPopup", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                        return;
                    }
                );

        }

        /* 2024.07.04 봉고3 LPDI 차량 무상 수리 팝업 임시 추가 */
        function recall_bongo() {
            return new Promise(function (resolve) {
                loginHome.gVals.popUp.marketingPop_bongo.active=true;
                loginHome.gVals.popUp.marketingPop_bongo.data = {};
                loginHome.gVals.popUp.marketingPop_bongo.popFunc = function(){
                    var pagefunction_bongo = function(item){
                        var osName = M.info.device().os.name;
                        var imgUrl = "../../img/rnw/main/home/pop_20240704.png";
                        var pdf = "https://vik.kia.com/uploadFiles/tempImage/popup/recall_bongo3.pdf";

                        var screenHtml = $("<div></div>");
                        screenHtml.append(item);
                        $('body').append(screenHtml.find('#popup_129_0000'));
                        var html ="";
                        var _$target = $("#popSliderTarget");
                        _$target.empty();

                        html += "<div class='swiper-slide' style=''>";
                        html +=     "<div class='img-box'>";
                        html +=         "<img src='"+ imgUrl+"' alt='리콜 안내 - 봉고 3 LPDI(PU LPDI) 차량은 무상수리(리콜) 대상 차량으로, 정비 가능한 오토큐 리스트를 확인 하신 후 예약 및 방문 부탁 드립니다.'>";
                        if (osName.toLowerCase() === "android") {
                            html +=         "<a id='pdf_download' href='"+pdf+"' download >";
                        }
                        html +=     "</div>";
                        html += "</div>";

                        _$target.append($(html));

                        // 닫기( X ) 버튼 추가
                        var _$targetBody = $("#popup_129_0000").find(".popup-body")[0];
                        if (isEmpty($("#popupCloseBtn"))) {
                            var htmlText = "<button type='button' class='btn-popup-close' id='popupCloseBtn'><i class='ico-close'>팝업 닫기</i></button>";
                            _$targetBody.insertAdjacentHTML('beforebegin', htmlText);
                        }

                        // 확인 버튼 명 변경
                        var _$targetBtn = $("#popup_129_0000").find("#popDetailBtn");
                        _$targetBtn.find("em")[0].innerHTML = "차량 정비 가능 센터 &amp; 오토큐 리스트 다운로드";

                        //오늘하루보지않기 체크박스
                        $("#popup_129_0000").find("#chkOption-day").parent('div.chk-cont').off("click").on("click",function(){
                            var that = this;
                            $(that).find("input[type=checkbox]").prop("checked",function(){
                                return !$(this).prop('checked');
                            });
                        });

                        //확인버튼 클릭시
                        _$targetBtn.off("click").on("click",function(e){
                            if (osName.toLowerCase() == "android") { // android
                                $("#pdf_download")[0].click(); // a태그 이벤트는 정상작동을 해야 하기 때문에 e.preventDefault() 전에 배치함
                            } else { // IOS
                                M.net.http.download({
                                    url: pdf,
                                    method: CONSTANT.NET_MTHD.POST,
                                    indicator: false,
                                    finish: function (status, header, fileinfo, setting) {
                                        if (status == 200) {
                                            // NOTICE : download 받은 pdf 파일을 viewer로 연다.
                                            var localpath = fileinfo.fullpath;
                                            console.log("localpath", localpath);
                                            exWNHideIndicator();
                                            var result = M.plugin('viewer.doc').open(localpath);
                                            if (result.status != 'SUCCESS') {
                                                MPopup.alert('파일을 찾을수 없습니다.');
                                            }
                                        } else if (status == -1) {
                                            MPopup.alert('네트워크 연결 시 문제가 발생하였습니다. 잠시 후 다시 시도해 주십시오.');
                                            exWNHideIndicator();
                                            return false;
                                        } else {
                                            exWNHideIndicator();
                                        }
                                    }
                                });
                            }
                        });
                        $("#popupCloseBtn").off("click").on("click",function(e){
                            e.preventDefault();
                            var isChecked = $("#popup_129_0000").find("#chkOption-day").prop("checked");
                            if(isChecked){
                                var dayAfter = moment().add(1, 'day').format('YYYYMMDD');
                                CMM_POP_MNG.modifyShowable("129_0000_1", true, dayAfter);
                            }
                            $("#popup_129_0000").fadeOut('fast');
                            $('body').removeClass('js-overflow-hidden');
                            $(".wrapper").removeClass("donemove");
                            customPopup.remove($("#popup_129_0000"));
                            loginHome.gVals.popUp.marketingPop.status ="close";

                        });
                        $("#popup_129_0000").find("div.dim").off("click").on("click",function(e){
                            e.preventDefault();
                            $("#popup_129_0000").fadeOut('fast');
                            $('body').removeClass('js-overflow-hidden');
                            $(".wrapper").removeClass("donemove");
                            loginHome.gVals.popUp.marketingPop_bongo.status ="close";
                        });

                        RNW_UI.popupLayer({selId : '#popup_129_0000'});
                    };

                    customPopup.get(PATH_MANAGER.KIA_RNW_129_0000.path, $("#popup_129_0000"), pagefunction_bongo);
                    loginHome.gVals.popUp.marketingPop_bongo.status ="open";
                }
                resolve();
            })
        }

        /**
         *  오픈유효한 팝업리스트를 리턴합니다.
         *  1. pop.active&&pop.status=="wait"
         *  2. 팝업이 2개이상 동시에 열리지 않습니다.
         *  */
        function verifyActivePops(popsObject) {
            var popUpKeys = Object.keys(popsObject);
            var popList = [];
            $.each(popUpKeys, function (i, popName) {
                popList.push(popsObject[popName]);
            });
            var openedPops = popList.filter(function (pop,i){
                return pop.status=='open';
            });
            var waitPops = popList.filter(function (pop, i) {
                return pop.active&&pop.status=="wait";
            });
            var activePops=[];
            if(openedPops.length<2){
                activePops=waitPops;
            }else if (openedPops.length==2){
                activePops.push(openedPops[openedPops.length-1])
                activePops.concat(waitPops);
            }
            var callPops = sortJsonArrayList(activePops, "dispNo");
            return callPops;
        }

        return new Promise(
            function (resolve) {

                var jobs = [];
                if(CMM_POP_MNG.isShowable("129_0000")) {
                    jobs.push(popMarketing());
                }//오늘하루보지않기 점검
                if(!isEmpty(PGV.loginInfo)) jobs.push(popRealDriver());
                if (!isEmpty(PGV.loginInfo)&&!isEmpty(loginHome.gVals.car.myCarInfoListResDto)) {
                    var oilCars = (loginHome.gVals.car.myCarInfoListResDto).find(function (car) {
                        return car.memEvYn == "N"&&car.rdmYn!="Y";
                    });
                    if (!isEmpty(oilCars)) {
                        jobs.push(popOilTopUp());
                    }
                }

                /* 2024.07.04 봉고3 LPDI 차량 무상 수리 팝업 임시 추가 */
                if (!isEmpty(PGV.loginInfo)&&!isEmpty(loginHome.gVals.car.myCarInfoListResDto)) {
                    var myCarList = loginHome.gVals.car.myCarInfoListResDto;
                    var recallPopYn = "N";
                    myCarList.forEach(function(carInfo){
                        // 보유 차량 중 B1, B2 체크 && recallTarYn === Y 체크
                        if (["B1", "B2"].includes(carInfo.vehlRepnCd)
                            && carInfo.recallTarYn === "Y") {
                            recallPopYn = "Y";
                        }
                    })
                    if (recallPopYn === "Y") {
                        if(CMM_POP_MNG.isShowable("129_0000_1")) {
                            jobs.push(recall_bongo());
                        }//오늘하루보지않기 점검
                    }
                }

                Promise.allSettled(jobs)
                    .then(
                        function (values) {
                            exWNShowIndicator();
                            if(values.length>1){
                                var popHandler ={
                                    set : function (target, property, value, receiver ) {
                                        if (target.hasOwnProperty(property)
                                            && property=='status'
                                            && (value != target[property])
                                            && value == 'close'
                                            && target[property] !== 'close'
                                        ) {
                                            COMMON_FUNCTION.TOOL.DEBUG.showTalk("set:" + target.cd+", property ==> now: "+target[property]+" to:"+value);
                                            console.dir(target);
                                            // debugger;

                                            var callPops = verifyActivePops(loginHome.gVals.popUp);
                                            var newList = callPops.filter(function (pop,i){
                                                return pop.cd!=target.cd;
                                            });
                                            if (!isEmpty(newList)) {
                                                newList[0].popFunc();
                                                target[property] = value;
                                                return true;
                                            }
                                        }else{
                                            target[property] = value;
                                            return true;
                                        }
                                    }
                                };
                                //팝업객체감시코드.
                                CMM_HOME.makeAuditObject(loginHome.gVals.popUp,popHandler);
                            }
                            // debugger;
                            exWNShowIndicator();
                            var callPops = verifyActivePops(loginHome.gVals.popUp);
                            if (!isEmpty(callPops)) {

                                callPops[0].popFunc();
                            }
                            exWNHideIndicator();
                        }
                    )
                    .then(resolve);
            }
        );
    }

    /**
     * as-is 기능 그대로임.
     * @param unDeliveryCarInfoList : 계약차량 목록임.
     */
    this.alertUnDeliveryCarNews = function (unDeliveryCarInfoList){
        /**
         * [KIAVIK-105] json compare
         */
        var jsoncompare = function(a, b){
            var i = 0, j;
            var result = -1;
            if(typeof a == "object" && a){
                if(Array.isArray(a)) {
                    //console.log("compare a.length=" + a.length + ", b.length=" + b.length);
                    for(j = a.length ; i < j ; i++){
                        if (JSON.stringify(a[i]) !== JSON.stringify(b[i])) return i;
                    }
                    return result;
                }
            }
            return result;
        };
        if(!isEmpty(unDeliveryCarInfoList)&&!isEmpty(unDeliveryCarInfoList[0])){
            var oldDeliveryCarInfo = M.data.storage("DeliceryCarInfo");
            // 최초 or 계약 이후 차량등록 완료시

            var index = jsoncompare(unDeliveryCarInfoList, oldDeliveryCarInfo);
            var isFirst = isEmpty(oldDeliveryCarInfo);
            if (isFirst || index != -1) {
                //GA Event 기록
                // ga('set', 'checkProtocolTask', null); // Disable file protocol checking.
                // ga('send', 'event', "contract_delivery", 'noti', isFirst?"contract":"delivery");
                eventLog("contract_delivery", 'noti', isFirst?"contract":"delivery");
                MPopup.confirm({
                    message : isFirst ? "신규 차량 계약 정보가 있습니다.\n확인 하시겠습니까?" : "신규 차량 출고 정보가 변경되었습니다.\n확인 하시겠습니까?",
                    callback : function(idx){
                        if(idx == 1){
                            MPage.html({
                                path: PATH_MANAGER.KIA_RNW_127_0000.path,
                                param: {
                                    passCar: unDeliveryCarInfoList[index]
                                }
                            })
                        }
                    }
                });
            }
            M.data.storage("DeliceryCarInfo", unDeliveryCarInfoList);
        }
        else{
            M.data.removeStorage("DeliceryCarInfo");
        }

        return;
    }
    this.initBottomTab = function () {
        var parentThis = this;
        var tab = MyKiaBottomTab;
        return MyKiaBottomTab.activate({
            beforeOpeningTheTab: function(tabName){
                return new Promise(function(resolve){
                    if(tabName === "EV"){
                        //카드 조회 시, 로딩 지연으로 중복클릭 방지위함(2022-06-28)
                        exWNShowIndicator();
                        eventLog("evAuthCheck", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_start");
                        CMM_HOME.evAuthCheck()
                            .then(function(receivedData){
                                eventLog("evAuthCheck", PATH_MANAGER[PGV.currentPage.split(".")[0]].desc, "api_end");
                                MData.global("evAuthCheck", receivedData);
                                resolve(true);
                            })
                    }else{
                        resolve(true);
                    }
                })
            },
            afterInit: function () {
                exWNHideIndicator();

                COMMON_FUNCTION.TOOL.UI.enableWebviewLinkListeners();
                COMMON_FUNCTION.TOOL.UI.enableScreenIdListeners();
                COMMON_FUNCTION.TOOL.UI.enableScreenIdWithRefNoListeners();
                COMMON_FUNCTION.TOOL.GNB.setEventListeners();
                COMMON_FUNCTION.TOOL.UI.ringTheBells();
                // CMM_HOME.uiBottomMenu();
                loginHome.setEventListner();
            },
            afterOpenedTheTab: function () {

                try{
                    if(MyKiaBottomTab.currentPage==="home"){
                        var openNewPage = MData.param("hasToHomeReload")=="true";
                        // MData.removeParam("openNewPage");
                        var changeSelectCar = MData.param("changeSelectCar") || null;
                        if(openNewPage&&!isEmpty(changeSelectCar)){

                            var _path = PATH_MANAGER.KIA_RNW_120_0000_3.path;
                            if (changeSelectCar.isContract && isEmpty(loginHome.gVals.car.myCarInfoListResDto)) {
                                _path= PATH_MANAGER.KIA_RNW_120_0000_2.path;
                            }else if(isEmpty(loginHome.gVals.car.myCarInfoListResDto)&&isEmpty(loginHome.gVals.car.unDeliveryCarInfoListResDto)){
                                _path= PATH_MANAGER.KIA_RNW_120_0000.path;
                            }
                            var options = {path: _path};
                            if(!isEmpty(changeSelectCar)){
                                options.param={};
                                options.param.intro_selectCar = changeSelectCar;
                            }
                            MPage.html(options);
                        }
                    }
                }
                catch(e){
                    COMMON_FUNCTION.TOOL.DEBUG.showTalk("error @home-afterOpenedTheTab : " + e);
                }
                finally {
                    exWNHideIndicator();
                    $(window).off("scroll");
                    $('body').removeClass('js-filter-list-fixed');
                    $(".wrapper").removeClass("donemove");
                    customPopup.remove($("div.popup-layer"));
                    console.log("heyyy afterInit");
                    exWNSetLightBarStyle("false");
                    COMMON_FUNCTION.TOOL.UI.enableWebviewLinkListeners();
                    COMMON_FUNCTION.TOOL.UI.enableScreenIdListeners();
                    COMMON_FUNCTION.TOOL.UI.enableScreenIdWithRefNoListeners();
                    COMMON_FUNCTION.TOOL.UI.ringTheBells();
                    COMMON_FUNCTION.TOOL.GNB.setEventListeners();
                    // CMM_HOME.uiBottomMenu();
                    loginHome.setEventListner();
                }

                fnIsFooterNav(); //footer 네비게이션 메뉴영역이 있는경우, 없는경우 제어
            }
        });
    }
// ------------------------------
// 	!--home  공통 함수 (E)
// 	EV 관련 함수 (S)
// ------------------------------
    /**
     * EV 멤버쉼 회원여부/카드 조회
     * @returns {Promise}
     */
    this.getEvMemberCheck = function(){
        return new Promise(function (resolve) {
            var sendData = {
                apiId: 'RNW-CRD-1001',
                mbrId: PGV.loginInfo.mbrId
            }

            MNet.httpSendAsync({
                path: _API.SVR.CMM.crd.holdCardReq,
                indicatorYn : "N",
                sendData: sendData,
                isMock: false
            }).then(function (response) {
                console.log(JSON.stringify(response))

                resolve(response);
            })
        })
    };

    /**
     * Straffic 회원여부/카드 조회
     * @returns {Promise}
     */
    this.getSscMemberCheck = function(){
        return new Promise(function (resolve) {
            var sendData = {
                apiId: 'RNW-EVC-4001',
                mbrId: PGV.loginInfo.mbrId
            }

            MNet.httpSendAsync({
                path: _API.SVR.EV.evmng.sscMemCardInfoReq,
                indicatorYn: "N",
                sendData: sendData,
                isMock: false
            }).then(function (receivedData) {

//                if(receivedData.resultCode == "200"){

                    resolve(receivedData);
//                }
            })
        })
    };

    /**
     * EV탭 진입 조건 check
     * @returns {Promise}
     */
    this.evAuthCheck = function(){
        return new Promise(function (resolve) {
            //1.EV멤버쉽 회원 여부 조회
            CMM_HOME.getEvMemberCheck()
            .then(function(response){
                //카드 조회 시, 로딩 지연으로 중복클릭 방지위함(2022-06-28)
                exWNHideIndicator();

                /* 리스트가 존재하면 회원으로 간주.. null로 오는 경우가 있음..? */
                if(response.resultCode == "200" && !isNull(response.cardMemberRnwResDto) && response.cardMemberRnwResDto.length > 0){

                    //2.EV멤버쉽 카드 여부 조회
                    var evIsOk = response.cardMemberRnwResDto.some(function(el){if((el.crdTypeCd == "EV") || (el.crdTypeCd == "EVT") || (el.crdTypeCd == "EV9")){return true;}})

                    if(evIsOk){
                        //3.SK일렉링크 회원 여부
                        CMM_HOME.getSscMemberCheck()
                        .then(function (receivedData) {
                                resolve(receivedData);
                        })
                    }else{
                        MPopup.confirm({
                            message: "EV멤버십 카드 발급이 가능합니다.\nEV멤버십 카드로 교체발급하시겠습니까?",
                            buttons: ["확인", "취소"],
                            callback: function (idx){
                                if(idx == 0){
                                    MNet.httpSendAsIs({
                                        path : checkVerifyUrl(inf.card.pssblExchngList.url),
                                        sendData : {
                                            csetIfTypeCd : "04",
                                            csetIfValue : PGV.loginInfo.csmrMgmtNo
                                        },
                                        callback : function(receivedData){
                                            exWNHideIndicator();

                                            var code = receivedData.resultCode;
                                            var msg = receivedData.resultMsg;
                                            var cardList = receivedData.cardExchngListResDto || [];
                                            var chngCardList = receivedData.cardPrmnCarListResDto || [];

                                            if(code == "200" && cardList.length > 0 && chngCardList.length > 0){
                                                MPage.html({
                                                    url : PATH_MANAGER.KIA_RNW_0D3_2220.path,
                                                    param : {
                                                        cardList : cardList,
                                                        chngCardList : chngCardList
                                                    }
                                                });
                                            }else{
                                                MPopup.alert("교체 신청이 가능한 카드가 없습니다.\n기아멤버스 카드를 보유하였으나, 교체발급 신청이 되지 않는 경우, 고객센터 080-200-2000으로 연락해 주세요.");
                                            }
                                        }
                                    });
                                }
                            }
                        });
                    }
                }else{
                    MPopup.confirm({
                        message: "EV멤버십 회원이 아닙니다.\nEV멤버십에 가입하시겠습니까?",
                        buttons: ["확인", "취소"],
                        callback: function (idx){
                            if(idx == 0){
                                var _url = CONSTANT.LINK_URL.KIA_RNW_0D2_3000.URL;

                                MPage.activity({
                                    className : "WebviewActivity",
                                    param: COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam("POST", _url, {
                                        mbrId: PGV.loginInfo.mbrId
                                    })
                                })
                            }
                        }
                    });
                }
            })
        })
    };
// ------------------------------
// 	!!-- EV 관련 함수 (E)
// ------------------------------

    this.checkRedMemberJoin = function () {
        MNet.httpSendAsIs({
            path: checkVerifyUrl(inf.card.cardList.url),
            sendData: {
                csetIfTypeCd: "04",						// 승인 IF 구분코드 (01:카드번호, 02:CI, 03:회원고유번호, 04:고객관리번호) 04로 고정!! 08/22 -lhs
                csetIfValue: PGV.loginInfo.csmrMgmtNo			// 02:ci
            },
            callback: this.checkRedMemberJoinCallback
        });
    };

    /**
     * 기아멤버스 오프라인 회원 여부 체크 콜백
     */
    this.checkRedMemberJoinCallback = function (receivedData) {
        /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
        COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(receivedData);
    };

    this.dynamicLink = function(receivedData , accessToken , ccspId , carId){

        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
        var getAgreementsWeb = String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service?token={0}&userId={1}&carId={2}',
            accessToken , ccspId, carId);
//

        MPage.activity({
            className : "WebviewActivity",
            param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(
                "GET",
                getAgreementsWeb ,
                null,
                "disable"
            )
        });
    };
}
