var CMM_NET = {};

/**  app server api */
CMM_NET.SVR = function () {
    this.getApiTest = function () {
        var options = {
            
            path: inf.terms.setTermsYn,
            sendData: {
                agrYn: "N",
                mbrId: PGV.loginInfo.mbrId,
                termsItmCd: "109",
                termsKndCcd: "105"
            },
        };

        return MNet.httpSendAsync(options)
            .then(function (resp) {
                console.log(resp)
                //debugger;
            })
    }
    /** Home-Insight */
    this.getHomeInsight = function (insightRequest) {
        var options = {
            isMock: false,
            path: _API.SVR.HOME.hom.homIns, 
            sendData: insightRequest,
        };

        return MNet.httpSendAsync(options);

    }
    /** 알림뱃지 */
    this.getNotiNotReadCnt = function () {
        var options = {
            isMock: false, path: _API.SVR.CMM.main.notiNotReadCnt, sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    }
    /** 차량정보동기화하기 */
    this.getSynchronizeUserCarInfo = function () {
        var options = {
            isMock: false, path: _API.SVR.CMM.owncar.updateOwncarList, sendData: {mbrId: PGV.loginInfo.mbrId},
        };

        return MNet.httpSendAsync(options);

    };
    /** 차량 보유/계약 리스트 */
    this.getOwnCarListInfo = function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.mykia.mycar.mainCarList,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    };
    /** CCS 가입차량 등록 */
    this.postRegCarId = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.CMM.mykia.mycar.regCarId, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    /** 날씨 등 조회 */
    this.getWethRsetDustyInfo = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.CMM.wtrsd.wethRsetDustyInfo, sendData: sendData,
        };
        return MNet.httpSendAsync(options).finally(function (response) {
            //console.dir(response);
            return response;
        });
    };

    /** 누적주행거리 조회 (차계부) */
    this.getDistInfo = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.car.distInfo, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    }

    /**
     * DKC 서비스가입 대상자 확인여부
     * "sendCode" : "W11055", "customerNo" : "고객관리번호", "name" : "mbrNm", "cellNo" : "hpno", "ci" : "ci"
     * "data" : "ADm2c+FFwLd3+II8r85zVriVwKXKHRVJ074T7F0gHbu2ckDNniH4hBbwMAh5sbPP1IsOFCqSW3DoYbo9EPwgMF7DkEJz9F1Q7f0/V+d3o6M20p9iq/irv8J7TdrHSXI+rxbhydyZODM7tttYkCSf94SOa55nEdWn80aHdm9yrL1rN/3O3Ldiamk0nX0MTuLK+2ayPka8qiEKqnNJ940RRIZspMiD+cOxYryXeglCLvRoHaCdpFef0e1MvlYhwpGo"
     * 검증계 가입 계정 정보
     * 유지은
     * 01059694539
     * 5l34ZLnmB/H7kciiZjYP8sKu+R9gVFhZDtPRTRlvdVQUBVLRJlpvRXQh6WpdhY+Rg+RYC6Ku288ZDB5TCRrW3w==
     * 운영계 가입 계정 정보
     * 유지은
     * 01077124539
     * 5l34ZLnmB/H7kciiZjYP8sKu+R9gVFhZDtPRTRlvdVQUBVLRJlpvRXQh6WpdhY+Rg+RYC6Ku288ZDB5TCRrW3w==
     */
    /** 디지털키 서비스 가입 대상자 확인 요청 */
    this.getResCheckService = function () {
        var sendData = {
            sendCode: "W11055",
            customerNo: PGV.loginInfo.csmrMgmtNo,      // "A202001141547399"
            name: PGV.loginInfo.mbrNm,    // "유지은"
            cellNo: PGV.loginInfo.hpno,      // "01059694539"
            ci: PGV.loginInfo.ci       // "5l34ZLnmB/H7kciiZjYP8sKu+R9gVFhZDtPRTRlvdVQUBVLRJlpvRXQh6WpdhY+Rg+RYC6Ku288ZDB5TCRrW3w=="
        };
        sendData = exWNEncryptString(JSON.stringify(sendData), CONSTANT.DKC_CRTEC_KEY, CONSTANT.DKC_IV_KEY);
        var options = {
            method: CONSTANT.NET_MTHD.POST,
            path: inf.dkc.getResCheckService,
            sendData: {"data": sendData},
        };
        return MNet.httpSendAsyncAsIs(options);
    }
    /** 실운행자 동의 대기 목록*/
    this.getCarAgreeStandBy = function () {
        var options = {
            
            path: _API.SVR.CMM.main.carAgreeStandBy,
            sendData: {mbrId: PGV.loginInfo.mbrId}
        };
        return MNet.httpSendAsync(options);
    }
    /** 실운행자 동의 하기*/
    this.postRealDriverAgreeYn = function (sendData) {
        var options = {
            indicatorYn: "Y",
            path: _API.SVR.CMM.car.driverAgreeYn,
            sendData: sendData
        };
        return MNet.httpSendAsync(options);
    }
    /**
     * 마케팅팝업정보리스트
     * @param sendData
     * @returns {*}
     */
    this.getMarketingPopup = function (sendData){
        var options ={
            
            path: _API.SVR.CMM.main.mktPop,
            sendData: sendData
        };
        return MNet.httpSendAsync(options);
    }
    /**
     * 스미싱 프로퍼티 조회
     * @returns {*}
     */
    this.getPropSearch = function (){
        var options = {
            
            path: _API.SVR.CMM.property.propSearch,
            sendData: {mbrId: PGV.loginInfo.mbrId,key:"SMIKW"}
        };
        return MNet.httpSendAsync(options);
    }
    /** 소모품현황 */
    this.getInsightExpMgmt = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.mci.expMgmt, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    /** 소모품 목록 조회
     * 회원ID    mbrId    string        Y
     * 차대번호    vin    string        Y
     * 누적주행거리    trvgDist    string        N */
    this.getCarExchCycle = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.ckb.exchCycle, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    this.getWarrantInfoList = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.HOME.carinfo.warrantInfoList, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    this.getFreeCareList = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.recall.freeCareList, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    /** 소모품 교체 내역 조회
     * 회원ID    mbrId    string        Y
     * 차대번호    vin    string        Y
     * 조회시작일자    viewStrtDt    string        N
     * 조회종료일자    viewEndDt    string        N
     * 소모품코드    exchCd    string        N*/
    this.getCarExchCycleDtl = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.ckb.exchCycleDtl, sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    /** 정비인사이트 */
    this.getRprInsight = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.insight.insight,
            sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    /** 차계부*/
    this.getExpForDay = function (sendData) {
        var options = {
            isMock: false, path: _API.SVR.MYCAR.ckb.expForDay,
            sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };


    /** 실운행자 동의등록 */
    this.postRealDriverAgreeYn_old = function (sendData) {
        if (isEmpty(sendData)) {
            sendData = {
                chmbCrorAgrYn: PGV.agree,
                csetIfTypeCd: "04",
                mbrId: PGV.passData.car.selectCar.mbrId, // 차주의 아이디
                csetIfValue: PGV.passData.car.selectCar.ownerCsmrMgmtNo, // 차주의 고객 번호
                rdmId: PGV.loginInfo.mbrId,  // 실운행자의 아이디
                rdmCsmrMgmtNo: PGV.loginInfo.csmrMgmtNo, //실운행자 고객 번호
                rdmRelCd: PGV.passData.car.selectCar.rdmRelCcd, //관계코드
                vin: PGV.passData.car.selectCar.vin
            }
        }

        var options = {
            method: CONSTANT.NET_MTHD.POST, path: inf.car.driverAgreeYn,
            sendData: {"data": sendData},
        };
        return MNet.httpSendAsync(options);
    };
    this.getMembershipOilCardsList = function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.holdCardReq,
        };
        return MNet.httpSendAsync(options);
    };
    this.getGsCaltexJoinReq = function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.gsCaltexJoinReq,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    };
    this.postGsCaltexJoin = function (_addParam) {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.gsCaltexJoin,
            sendData: {mbrId: PGV.loginInfo.mbrId, cardNo: _addParam},
        };
        return MNet.httpSendAsync(options);
    };
    this.getNewCarAdList = function () {
        var options = {
            isMock: false,
            path: _API.SVR.CMM.main.newCarList,
            sendData: {mbrId: PGV.loginInfo.mbrId},
        };
        return MNet.httpSendAsync(options);
    };
    this.postRepresentCarUpdate = function (sendData) {
        var options = {
            isMock: false,
            path: _API.SVR.HOME.mykia.mycar.representCarUpdate,
            sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    this.getRealDriverList = function (sendData) {
        var options = {
            isMock: false,
            path: _API.SVR.HOME.car.selectRealDriverList,
            sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
    this.postDelRealDriver = function (sendData) {
        var options = {
            isMock: false,
            path: _API.SVR.HOME.car.delRealDriver,
            sendData: sendData,
        };
        return MNet.httpSendAsync(options);
    };
};

/**  kia developers api */
CMM_NET.HUB = function () {
    /** ccs car id 조회 */
    this.getCarIdInfo = function (ccspId) {
        var options = {
            isMock: true,
            path: _API.HUB.vehicle.verifyUrl(ccspId).path,
            method: CONSTANT.NET_MTHD.GET,
            backup: {
                ccspId: PGV.loginInfo.ccspId,
            },
        }
        return MNet_Hub.httpSendAsync(options);
    }
    /** ccs 차주여부 조회 */
    this.getCarMasterInfo = function (_vin) {
        var options = {
            isMock: true,
            path: _API.HUB.carMaster.verifyUrl(PGV.loginInfo.ccspId, _vin).path,
            method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** ccs 연동 차량 등록 */
    this.postRegisterVehicle = function (_cars) {
        var options = {
            isMock: true, path: _API.HUB.registerVehicle.verifyUrl(PGV.loginInfo.ccspId).path,
            method: CONSTANT.NET_MTHD.POST,
            sendData: {
                cars: _cars
            },
        };
        return MNet_Hub.httpSendAsync(options);
    }

    /** data-hub 연동동의 조회 */
    this.getAgreements = function (userId, carId, token) {
        var options = {
            isMock: true,
            path: _API.HUB.agreements.verifyUrl(userId, carId, token).path,
            method: CONSTANT.NET_MTHD.GET,
        };

        return MNet_Hub.httpSendAsync(options);
    }

    /** data-hub  고장코드 조회 */
    this.getDtc = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.dtc.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** data-hub 전기차 상태 조회 */
    this.getEvStatus = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.evStatus.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** 전기차 차량의 충전 중 정보를 조회 */
    this.getEvCharging = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.evCharging.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** 전기차 차량의 배터리 잔량 정보를 조회 */
    this.getEvBattery = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.evBattery.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** 전기차 차량의 주행 가능 거리를 조회 */
    this.getEvDte = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.evDte.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }

    /**  data-hub 전기차 외 연료 조회 */
    this.getFuelLevel = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.fuelLevel.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }

    /** data-hub 누적 운행 거리 조회 */
    this.getOdometer = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.odometer.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }

    /** data-hub 전기차 외 주행 가능 거리*/
    this.getDte = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.dte.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }

    /** data-hub 전기차 외 주행 가능 거리*/
    this.getUbi = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.ubi.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** data-hub 전기차 외 주행 가능 거리*/
    this.getUbiDetail = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.ubiDetail.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** data-hub 전기차 외 주행 가능 거리*/
    this.getUbiTarget = function (param) {
        var options = {
            isMock: true,  path: _API.HUB.ubiTarget.verifyUrl(param).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
    /** data-hub 전기차 외 주행 가능 거리*/
    this.getRecentDrivingInfo = function (param) {
        //todo api 개발 대기
        var options = {
            isMock: true,  path: null, method: CONSTANT.NET_MTHD.GET,
        };
        //return MNet_Hub.httpSendAsync(options);

        return;
    }

    this.getDKCReserveData = function (userId, vin, startDate, endDate) {
        var options = {
            isMock: true,
            
            path: _API.HUB.reserveData.verifyUrl(userId, vin, startDate, endDate).path,
            method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    }
};

CMM_NET_SVR = new CMM_NET.SVR();
CMM_NET_HUB = new CMM_NET.HUB();




