/**

@파일명 : KIA_RNW_210_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 내 차 관리 탭
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/
var MyCarMngMain;
var KIA_RNW_210_0000 = {
    isContractCar : false,
    hasNoCar: false,

    init: function() {
        MyCarMngMain = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        /* !!! 선행개발팀 추헌남 - 마이기아 헤더가 스크롤링하면 사라지는 문제 임시 해결하였습니다 */
        $(window).off("scroll");

        /* 아래 activateMyCarTabularNavBar 함수에서 로드 완료 후 exWNHideIndicator 호출 */
        exWNShowIndicator();
        MyCarMngMain.activateMyCarTabularNavBar();

        COMMON_FUNCTION.TOOL.DATA.setCurrentScopeSelectCar(KIA_RNW_210_0000); // !!! 케이스마텍 추헌남 - 초기 해당 Scope 내에서 선택된 차량 설정
    },
    setEventListener: function() {

    },

    /* 정비 페이지에서 선택된 차량, 없으면 COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000)를 사용 */
    currentScopeSelectCar: null,

    /* 해당 페이지의 tabularNavigator 저장 */
    tabularNavigator: null,

    /* 함수들 정의 */
    activateMyCarTabularNavBar: function(){
        var parentThis =this;
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        var tabsMeta = [
            {
                page: {
                    pathManager: PATH_MANAGER.KIA_RNW_210_0000_2,
                    loadScript: true,
                    isMain: true
                }
            },
            {
                page: {
                    pathManager: PATH_MANAGER.KIA_RNW_220_0000,
                    loadScript: true,
                    isMain: false
                }
            },
            {
                page: {
                    pathManager: PATH_MANAGER.KIA_RNW_230_0000,
                    loadScript: true,
                    isMain: false
                }
            },
            {
                page: {
                    pathManager: PATH_MANAGER.KIA_RNW_240_0000,
                    loadScript: true,
                    isMain: false
                }
            }
        ];
        
        /* 계약 차량일 경우 설정 */
        if(PGV.passData && PGV.passData.car && PGV.passData.car.unDeliveryCarInfoListResDto){
            if(_.find(PGV.passData.car.unDeliveryCarInfoListResDto, function(element){
                return element.vin === currentScopeSelectCar.vin
            })){
                this.isContractCar = true;
            }
        }

        /* 보유 차량이 없을 경우 설정 */
        if (PGV.passData.car){
            if(!PGV.passData.car.myCarInfoListResDto || !PGV.passData.car.myCarInfoListResDto || !(PGV.passData.car.myCarInfoListResDto.length > 0)){
                this.hasNoCar = true;
            }
        }
        else{
            this.hasNoCar = true;
        }

        /* 계약 차량과 보유 차량일 때 차량 없음 페이지를 출력하도록 설정 */
        if(this.isContractCar || this.hasNoCar){
            tabsMeta = _.map(tabsMeta, function(element){
                element.page.pathManager = PATH_MANAGER.KIA_RNW_210_0000_4;
                element.page.loadScript = true;
                element.page.isMain = false;
                return element;
            })
            tabsMeta[0].page.isMain = true;
        }

        var option = {
            tabWrapperQueryString: "#mykia-section-container",
            tabs: $('.tabs#mykia-mycar-tabs').children(),
            tabsMeta: tabsMeta,
            lifeCycles: {
                afterInit: function(){
                    if(parentThis.hasNoCar || parentThis.isContractCar){
                        exWNHideIndicator();
                    }
                },
                beforeOpeningTheTab: function(attemptingIndex, initMode, eventListenerClickedMode, globalAccessMode){
                    if(!initMode && eventListenerClickedMode && !globalAccessMode && (parentThis.hasNoCar || parentThis.isContractCar)){
                        if(attemptingIndex !== 0){
                            COMMON_FUNCTION.TOOL.UI.showNoCarPopup();
                            return false;
                        }
                    }
                    if(!initMode && eventListenerClickedMode && !globalAccessMode && attemptingIndex === 2){
                        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
                        if(currentScopeSelectCar.memEvYn !== "N"){
                            MPopup.alert("내연 차량 전용 서비스입니다.");
                            return false;
                        }
                    }
                    return true;
                },
                afterOpenedTheTab: function(){
                    if(!isNaN(this.currentTabIndex) && this.currentTabIndex === 0){
                        // !!! 케이스마텍 추헌남 - CSS 오류깨짐 현상으로 임시 추가
                        $('div.content.content-mycar').removeClass('maintain');
                    }
                    if(parentThis.hasNoCar || parentThis.isContractCar){
                        $("#mykia-insight-restore-data").off("click").on("click", function(){
                            MPage.html({
                                path: PATH_MANAGER.KIA_RNW_127_3000.path
                            })
                        })
                        exWNHideIndicator();
                    }

                    fnIsFooterNav(); //footer 네비게이션 메뉴영역이 있는경우, 없는경우 제어
                }
            },
            viewerArea:$('#inner-cont-mycar-insight'),
            addEventListeners: true,
        };
        COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.init(option).then(function(navigator){
            parentThis.tabularNavigator = navigator;
        });
    }
}

KIA_RNW_210_0000.init();

// /** 
//  * 모피어스 화면 상태 이벤트 함수 
//  */
// var MStatus = {
//     onReady: function (event) {
//         console.log("onReady page : " + PGV.currentPage);
//         KIA_RNW_210_0000.init();
//     },
//     onHide: function (event) { },
//     onRestore: function (event) { },
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
//     // onBack : function(){}, 
//     onDestroy: function (event) { },
//     onPause: function (event) { },
//     onResume: function (event) { }
// }; 

    // /* 함수들 정의 */
    // activateMyCarTabularNavBar: function(){
    //     COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.init({
    //         tabWrapperQueryString: "section",
    //         tabs: $('.tabs').children(),
    //         tabsMeta: [
    //             {
    //                 page: {
    //                     pathManager: PATH_MANAGER.KIA_RNW_210_0000_2,
    //                     loadScript: false,
    //                     isMain: false
    //                 }
    //             },
    //             {
    //                 page: {
    //                     pathManager: PATH_MANAGER.KIA_RNW_210_0000_3,
    //                     loadScript: false,
    //                     isMain: false
    //                 }
    //             }
    //         ],
    //         viewerArea:$('#inner-cont-mycar-insight'),
    //         addEventListeners: {
    //             conditionalFunction: function(index){
    //                 if(index === 1){
    //                     return true;
    //                 }
    //                 else{
    //                     return false;
    //                 }
    //             }
    //         },
    //     });
    // }