/**
@파일명 : KIA_RNW_210_0000_2.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 내 차 관리 탭 > 인사이트 탭 
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/
var KIA_RNW_210_0000_2 = {
    showNoSpentInfo: false,
    showNoCarInstallmentInfo: false,
    showNoInsuranceInfo: false,
    stopLoadingIndicator: false,

    init: function () {
        console.log("page : " + PGV.currentPage + "initiolizing START");
        exWNShowIndicator();
    
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(currentScopeSelectCar, "#mykia-mycar-car-select-box");

        var parentThis = this;
        /* 이 함수에서 출력 해당하는 섹션에 .will-be-displayed 클래스가 붙습니다. loadingIndicator 컨트롤도 여기서 합니다 */
        this.setEachBoxByLoadedOrder()
        .then(function () {
            Promise.all([
                /* section.section-02#itemManageHistory (소모품 관리 내역) */
                parentThis.setManagePartInsightBox(),

                /* section.section-03#monthlySpentAverage (월 평균 지출 금액) */
                parentThis.setMonthlyExpenditureBox(),
                
                /* section.section-04#averageSpentPerItem (항목별 평균 지출 금액) */
                /* !!! 케이스마텍 추헌남 - 서버 요청 시 과도한 서버 부담으로 임시 주석처리되었습니다. */
                //parentThis.setMonthlyItemExpenditureBox(),
                
                /* section.section-05#carInstallmentInfo (자동차 할부 정보) */
                parentThis.setRemainingCarInstallmentPlanBox(),
                
                /* section.section-06#carInsuranceInfo (자동차 보험 정보) */
                parentThis.setInsuranceFeeBox(),
                
                /* 기획에서 확인 후 곧 DEPRECATED */
                // parentThis.checkForSpentInfoEmpty()
            ])
            .then(function(response){
                console.log("from insight : " , response);
                var errorCodes = _.filter(response, function(element){return element && (element.errorCode || element.resultCode !== "200")});
                var emptyResponses = _.filter(response, function(element){return isNull(element)});
                if( (errorCodes && errorCodes.length > 0) || (emptyResponses && emptyResponses.length > 0) ) {
                    parentThis.stopLoadingIndicator = true;
                    parentThis.setEventListener();
                    parentThis.setPublisherEventListener();
                    MPopup.confirm({
                        title : "알림",
                        message : "네트워크 연결 시 문제가 발생하였습니다. 잠시 후 다시 시도해 주십시오.",
                        buttons : ["확인"],
                        callback: function(){
                            exWNHideIndicator();
                        }
                    })
                    return;
                }

                /* 이 함수에서 .will-be-displayed 클래스가 있는 섹션을 display 하고 동시에 해당 클래스가 삭제됩니다. */
                parentThis.hideNonInformationBoxes();

                parentThis.hideItemManageHistoryWhenEV();
                parentThis.setEventListener();
                parentThis.setPublisherEventListener();
                exWNHideIndicator();
                exWNHideIndicator();
                exWNHideIndicator();
            })
            .catch(function(e){
                console.log(e);
                COMMON_FUNCTION.TOOL.DEBUG.showAdvice("인사이트 로딩 중 오류 발생");
                COMMON_FUNCTION.TOOL.DEBUG.showAdvice(e);
                parentThis.stopLoadingIndicator = true;
                MPopup.confirm({
                    title : "알림",
                    message : "네트워크 연결 시 문제가 발생하였습니다. 잠시 후 다시 시도해 주십시오.",
                    buttons : ["확인"],
                    callback: function(){
                        exWNHideIndicator();
                    }
                })
            })
        })
    },
    setEventListener: function () {
        var parentThis = this;
        $(".mykia-mycar-insight-go-to-ckb").on("click", function(){
            KIA_RNW_210_0000.tabularNavigator.open(1, true);
        })
        $('#mykia-mycar-car-select-box').on("click", function(){
            COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(KIA_RNW_210_0000);
        })
        $("#mykia-mycar-insight-go-to-write-installment").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_224_2600.path}); 
        })
        $("#mykia-mycar-insight-go-to-write-insurance").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_224_2500.path}); 
        })
        $('#mykia-edit-insight').on("click", function () {
            MPage.html({
                url: PATH_MANAGER.KIA_RNW_211_0000.path,
                param: {
                    "currentPermission": COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission(KIA_RNW_210_0000)
                }
            });
        })
    },
    
    /* 최초 로딩 여부 확인 */
    firstLoaded: true,

    /* 파이 차트 보관용 */
    echart: null,
    echartOptions: null,

    /* 할부 일련번호, 보험 일련번호 */
    installmentPaymentNo: null,
    insuranceSeqNo: null,

    /* 각 영역 출력 순서 설정에 따른 순서 조정 */
    setEachBoxByLoadedOrder: function () {
        var parentThis = this;
        return new Promise(function (resolve) {
            var carListSelectBox = $('#carListSelectBox');
            var insightBoxes = $('section.insight-box');
            insightBoxes.addClass('none');
            /* 보유한 차량이 있을 때 */
            carListSelectBox.removeClass('none');
            var tempStorage = M.data.storage('mykiaRenewal');
            var loadedInsightOrderArray = tempStorage && tempStorage.insight && tempStorage.insight.insightOrderArray || COMMON_FUNCTION.TOOL.DATA.getDefaultValue("insightOrderArray");
            var tempEditInsightSection = $('#editInsight');
            if (!isEmpty(loadedInsightOrderArray)) {
                var reversedLoadedInsightOrderArray = loadedInsightOrderArray.reverse();
                for (var i = 0; i < reversedLoadedInsightOrderArray.length; i++) {
                    var curNode = reversedLoadedInsightOrderArray[i];
                    var tempDOMNode = $('#' + curNode.id);
                    var nonDataTempDOMNode = $('#' + curNode.nonDataId);
                    //tempDOMNode.addClass('none');
                    if (curNode.checked) {
                        $('#carListSelectBox').after(tempDOMNode);
                        $("#carListSelectBox").after(nonDataTempDOMNode);
                        if (!curNode.isSkipped) tempDOMNode.addClass('will-be-displayed');
                        nonDataTempDOMNode.addClass("will-be-displayed");
                    }
                }
            }
            tempEditInsightSection.removeClass('none');
            $('html, body').scrollTop(0);
            
            var loadingIndicatorCounter = 0;
            var loadingIndicatorRunner = setInterval(function(){
                //loadingIndicatorCounter++;
                if(parentThis.stopLoadingIndicator){ //loadingIndicatorCounter > 200
                    clearInterval(loadingIndicatorRunner);
                    exWNHideIndicator();
                }
                if($(".will-be-displayed").length > 0){
                    exWNShowIndicator();
                }
                else{
                    clearInterval(loadingIndicatorRunner);
                    exWNHideIndicator();
                }
            }, 100);


            parentThis.firstLoaded = false;

            resolve(loadedInsightOrderArray);
        })
    },

    /* section.section-02#itemManageHistory (소모품 관리 내역) */
    setManagePartInsightBox: function () {
        var parentThis = this;
        return new Promise(function (resolve, reject) {
            //trvgDst: PGV.car && PGV.car.distInfo && PGV.car.distInfo.trvgDist || 0
            var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
            if(currentScopeSelectCar && currentScopeSelectCar.memEvYn !== "N") {
                resolve({resultCode: "200", isThisEVCar: true});
            }else{
                MNet.httpSendAsync({
                    path: _API.SVR.MYCAR.mci.expMgmt,
                    sendData: {
                        mbrId: PGV.loginInfo.mbrId,
                        vin: currentScopeSelectCar.vin
                    },
                    indicatorYn: "N",
                    isMock: false
                })
                .then(function (response) {
                    if(response.resultCode === "200"){
                        var containerElement = $('#itemManageHistory');
                        // 4a
                        var replaceNeededCount = parseInt(response.rplcRcmdCnt);
                        var replaceRecommendedCount = parseInt(response.rplcRqrmCnt);
                        var goodCount = parseInt(response.goodCnt);
                        var currentInsightText = "소모품 관리가 잘 되고 있어요";
                        if (((replaceNeededCount + replaceRecommendedCount) > goodCount / 2) || (replaceNeededCount >= 3)) {
                            currentInsightText = "소모품 관리가 필요해요";
                        }
                        $(containerElement.find('#mykia-imh-insight-text')).text(currentInsightText);
        
                        $(containerElement.find('#mykia-replace-needed')).text(replaceNeededCount);
                        $(containerElement.find('#mykia-replace-recommended')).text(replaceRecommendedCount);
                        $(containerElement.find('#mykia-good')).text(goodCount);
        
                        // 4b
                        $('#mykia-manage-part-more').on("click", function () {
                            KIA_RNW_210_0000.tabularNavigator.open(2, true);
                        })
        
                        // 4c
                        // EV 차량인지 아닌지 판별하여 소모품 상태값 (카운팅) 영역 미노출
                        if(_.contains(["rider-ev", "owner-ev"], COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission(KIA_RNW_210_0000))){
                            $(containerElement.find('#itemManageHistory')).addClass('none');
                        }
                        else{
                            $(containerElement.find('#itemManageHistory')).removeClass('none');
                        }
                    }
                    else{
                        MPopup.alert("소모품 관리 내역을 불러오는데에 문제가 발생했습니다.");
                    }
    
                    resolve(response);
                })
                .catch(function(){
                    reject("at setManagePartInsightBox");
                })
            }
        })
    },

    /* section.section-03#monthlySpentAverage (월 평균 지출 금액) */
    setMonthlyExpenditureBox: function () {
        var parentThis = this;
        return new Promise(function (resolve, reject) {
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.mci.aveMonSpd,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
                },
                indicatorYn: "N",
                isMock: false
            })
            .then(function (response) {
                console.log(response);
                if(response.resultCode === "200"){
                    // 5a
                    var monthlyExpenditureValue = response.avrMnthExp;
                    var monthlyExpenditureList = response.ckbExpMnthList;
    
                    monthlyExpenditureValue && $('#mykia-average-value').text(parseInt(monthlyExpenditureValue).toLocaleString() + "원");
                    
                    var isAllExpenditureIsNotZero = _.filter(monthlyExpenditureList, function(element){return element.mnthExp !== "0"});

                    if(monthlyExpenditureList && monthlyExpenditureList.length > 0 && isAllExpenditureIsNotZero && isAllExpenditureIsNotZero.length > 0){
                        var descSortedMonthlyExpenditureList = _.sortBy(monthlyExpenditureList, function(item){return -item.mnthExp});
                        var highestExpenditureSpenditure = descSortedMonthlyExpenditureList[0].mnthExp || 0;
                        
                        for (var i = 0; i < monthlyExpenditureList.length; i++){
                            var curNode = monthlyExpenditureList[i];
                            curNode.yyyymm && $('#monthExpendProgressMonthText' + i).text((moment(curNode.yyyymm,"YYYY.MM").month() + 1) + "월");
                        }
        
                        //$('#monthlySpentAverage #mykia-average-value').text(Math.round(averageMonthlyExpenditure / 10000) + '만원');
        
        
                        /* 퍼블리셔 스크립트 */
                        // --------------------------------
                        // 	Button 
                        // --------------------------------		
                        // 월 지출 금액 인사이트 영역 (수정됨)
                        var $progressItem = $('.js-progress-item');
                        var $proresesBtn = $('.js-progress-btn');
                        var $tooltipCont = $('.tooltip-cont');
        
                        $($proresesBtn).on('click', function(e) {
                            e.preventDefault();
        
                            var $getProgressBarHeight = $(this).find('.progress-bar').outerHeight();
                            $(this).closest($progressItem).addClass('active--click').siblings($progressItem).removeClass('active--click');
        
                        });
        
                        // 5c
                        // 그래프 영역 적용
                        function fnSetMonthExpendProgress() {
                            var $progressItem = $('.js-progress-item');
        
        
                            var monthExpenditureObject = $('#monthlySpentAverage .month-expend').find($progressItem);
                            monthExpenditureObject.each(function(idx, item) {
                                var setProgressData =  _.map(monthlyExpenditureList, function(item){return parseInt(item.mnthExp) / highestExpenditureSpenditure});
                                var priceData = _.map(monthlyExpenditureList, function(item){return parseInt(item.mnthExp) || 0});
                                var progressItemLength = monthExpenditureObject.length;
        
        
                                $(item).find('#monthExpendProgressBar'+idx).css('height', Math.round(setProgressData[idx] * 100)+'%');
                                $(item).find('.tooltip-value').text(priceData[idx] && priceData[idx].toLocaleString() || 0);
                    
                                // 마지막index
                                if (idx === (progressItemLength - 1)) {
                                    $(item).addClass('active--highlight');
                                    $(item).addClass('active--click');
                                }
                                
                            });
                        }
                        fnSetMonthExpendProgress();
                    }
                    /* !!! 케이스마텍 추헌남 - 원래 showNoSpentInfo는 항목별 평균 지출내역 불러오면서 체크하였으나 현재 서버 문제로 임시로 아래에서 설정합니다. 문제가 해결되면 아래 else를 주석처리해야 합니다. */
                    else{
                        parentThis.showNoSpentInfo = true;
                    }
                    var noDataMonthExpenditureObject = $('#mykia-month-expend-no-data .js-progress-item');
                    noDataMonthExpenditureObject.each(function(idx, item) {
                        var setProgressData =  [50, 40, 80, 40, 20, 60];
                        var progressItemLength = noDataMonthExpenditureObject.length;
    
    
                        $(item).find('#monthExpendProgressBar'+idx).css('height', setProgressData[idx]+'%');
            
                        // 마지막index
                        if (idx === (progressItemLength - 1)) {
                            $(item).addClass('active--highlight');
                            $(item).addClass('active--click');
                        }
                    });
                }
                else{
                    MPopup.alert("월 평균 지출 금액을 불러오는데에 문제가 발생했습니다.");
                }
                resolve(response);
            })
            .catch(function(){
                reject("at setMonthlyExpenditureBox");
            })
        })
    },

    /* section.section-04#averageSpentPerItem (항목별 평균 지출 금액) */
    setMonthlyItemExpenditureBox: function () {
        var parentThis = this;
        return new Promise(function (resolve, reject) {
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.mci.aveExpByItm,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
                },
                indicatorYn: "N",
                isMock: false
            })
            .then(function (response) {
                if(response.resultCode === "200"){
                    // 6c
                    $('#mykia-average-spent-per-item-more').on("click", function(){
                        KIA_RNW_210_0000.tabularNavigator.open(1, true);
                    });
                    if (response.ckbExpinfo03 || response.ckbExpinfo06 || response.ckbExpinfo12){
                        $('#noSpentInfo').addClass('none');
                        $("#noSpentPieChartInfo").addClass("none");

                        // 6e
                        var responseData = {
                            period03: response.ckbExpinfo03,
                            period06: response.ckbExpinfo06,
                            period12: response.ckbExpinfo12
                        }
                        var monthData = {
                            period03: { text: "3개월" },
                            period06: { text: "6개월" },
                            period12: { text: "12개월" }
                        }
                        var monthDataKeys = Object.keys(monthData);
                        for (var i = 0; i < monthDataKeys.length; i++) {
                            var key = monthDataKeys[i];
                            var currentNode = monthData[key];
                            if(responseData[key]){
                                currentNode["averageExpenditure"] = parseInt(responseData[key].avrExp);
                                currentNode["oilChargeCost"] = parseInt(responseData[key].oilExp);
                                currentNode["oilChargeRate"] = parseInt(responseData[key].oilRate);
                                currentNode["maintenanceCost"] = parseInt(responseData[key].reprExp);
                                currentNode["maintenanceRate"] = parseInt(responseData[key].reprRate);
                                currentNode["etcCost"] = parseInt(responseData[key].etcExp);
                                currentNode["etcRate"] = parseInt(responseData[key].etcRate);
                            }
                        }
                        
                        var averageExpenditureString = monthData.period03.averageExpenditure;
                        $('#averageSpentPerItem #mykia-monthly-view-period').text(monthData.period03.text);
                        $('#averageSpentPerItem #mykia-average-expenditure').text(averageExpenditureString && averageExpenditureString.toLocaleString() + "원");
    
                        /* 퍼블리셔 스크립트 */
                        parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox = { monthData: monthData };
                    }
    
                    else{
                        parentThis.showNoSpentInfo = true;
                    }
                }
                else{
                    MPopup.alert("항목별 평균 지출 금액을 가져오는데에 문제가 발생했습니다.");
                }

                resolve(response);
            })
            .catch(function(){
                reject("at setMonthlyItemExpenditureBox");
            })
        })
    },

    /* section.section-05#carInstallmentInfo (자동차 할부 정보) */
    setRemainingCarInstallmentPlanBox: function () {
        var parentThis = this;
        return new Promise(function (resolve, reject) {
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.mci.remCarIns,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
                },
                indicatorYn: "N",
                isMock: false
            })
            .then(function (response) {
                if(response.resultCode === "200"){
                    var installmentPaymentNo = parseInt(response.instPymnSeqNo);
                    var currentInstallmentCount = parseInt(response.pymnCnt) || 0;
                    var remainingInstallmentCount = parseInt(response.remnCnt) || 0;
                    var totalInstallmentCount = currentInstallmentCount + remainingInstallmentCount;
                    var curMonthAmount = parseInt(response.mnthPymnAmt) || 0;
                    var accumulativeAmount = parseInt(response.acmlPymnAmt) || 0;
                    var remainingAmount = parseInt(response.remnInstAmt) || 0;
    
                    if(!installmentPaymentNo || installmentPaymentNo === null || installmentPaymentNo === "0" || installmentPaymentNo === 0){
                        $('#carInstallmentInfo').addClass('none');
                        parentThis.showNoCarInstallmentInfo = true;
                        resolve(response);
                    }
                    else{
                        $('#noCarInstallmentInfo').addClass('none');
                    }
    
                    parentThis.installmentPaymentNo = installmentPaymentNo;
                    $('#carInstallmentInfo #mykia-remaining-installment-count').text(remainingInstallmentCount + '회');
                    $('#carInstallmentInfo .date-start').text("0회");
                    $('#carInstallmentInfo .date-end').text((totalInstallmentCount) + "회");
                    $('#carInstallmentInfo #mykia-cur-month-amount').text(curMonthAmount.toLocaleString() + "원");
                    $('#carInstallmentInfo #mykia-accumulative-amount').text(accumulativeAmount.toLocaleString() + "원");
                    $('#carInstallmentInfo #mykia-remaining-amount').text(remainingAmount.toLocaleString() + "원");
    
                    $('#carInstallmentInfo #mykia-trash-button').on("click", function(){
                        parentThis.onClickShowPopup('deleteCarInstallmentHistory');
                    });
                    
    
                    /* 퍼블리셔 스크립트 */
                    parentThis.isPromiseDataLoaded.setRemainingCarInstallmentPlanBox = {currentInstallmentCount: currentInstallmentCount, totalInstallmentCount: totalInstallmentCount};
                }
                else{
                    MPopup.alert("자동차 할부 정보를 가져오는데에 문제가 발생했습니다.");
                }
                resolve(response);
            })
            .catch(function(){
                reject("at setRemainingCarInstallmentPlanBox");
            })
        })
    },

    /* section.section-06#carInsuranceInfo (자동차 보험 정보) */
    setInsuranceFeeBox: function () {
        var parentThis = this;
        return new Promise(function (resolve, reject) {
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.mci.insPreInq,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
                },
                indicatorYn: "N",
                isMock: false
            })
            .then(function (response) {
                if(response.resultCode === "200"){
                    var insuranceSeqNo = response.insuSeqNo;
                    parentThis.insuranceSeqNo = insuranceSeqNo;
                    
                    if(!insuranceSeqNo || insuranceSeqNo === null || insuranceSeqNo === "0" || insuranceSeqNo === 0){
                        parentThis.showNoInsuranceInfo = true;
                        resolve(response);
                    }
                    else{
                        $('#noInsuranceInfo').addClass('none');
                    }
    
                    // 8a
                    var insuranceStartDate = response.insuStrtDt && new moment(response.insuStrtDt) || null;
                    var insuranceEndDate = response.insuEndDt && new moment(response.insuEndDt) || null;
    
                    $('#carInsuranceInfo #mykia-insurance-start-date').text(insuranceStartDate && insuranceStartDate.format('YYYY.MM.DD') || "날짜 정보 오류");
                    $('#carInsuranceInfo #mykia-insurance-end-date').text(insuranceEndDate && insuranceEndDate.format('YYYY.MM.DD') || "날짜 정보 오류");
    
                    var curMonthAmount = parseInt(response.payMnth) === 0 ? (parseInt(response.payAmt) || 0) : (parseInt(response.payAmt) * parseInt(response.payMnth) || 0);
                    if (insuranceEndDate) {
                        var remainingDays = parseInt((insuranceEndDate).diff(new moment(), 'days'));
                        if (remainingDays > 365) {
                            $('#carInsuranceInfo .div-title').text("보험이 종료되었습니다. 갱신한 보험 정보를 입력해주세요!");
                        }
                        else {
                            $('#carInsuranceInfo #mykia-cur-month-amount').text((curMonthAmount && curMonthAmount.toLocaleString() || 0) + "원");
                            $('#carInsuranceInfo #mykia-remaining-days').text("D-" + (remainingDays || 0));
                        }
                    }
    
                    $('#carInsuranceInfo #mykia-trash-button-insurance').on("click", function(){
                        parentThis.onClickShowPopup('deleteInsuranceHistory');
                    })
                }
                else{
                    MPopup.alert("자동차 보험 정보를 불러오는데에 문제가 발생했습니다.");
                }
                resolve(response);
            })
            .catch(function(){
                reject("at setInsuranceFeeBox");
            })
        })
    },

    hideNonInformationBoxes: function(){
        $('.will-be-displayed:not(.never-show)').removeClass("none").removeClass("will-be-displayed");

        if(this.showNoSpentInfo){
            $('#averageSpentPerItem').addClass('none');
            $('#monthlySpentAverage').addClass('none');
        } else {
            $('#noSpentInfo').addClass('none');
            $("#noSpentPieChartInfo").addClass("none");
        }
        if(this.showNoCarInstallmentInfo){
            $('#carInstallmentInfo').addClass('none');
        } else {
            $('#noCarInstallmentInfo').addClass('none');
        }
        if(this.showNoInsuranceInfo){
            $('#carInsuranceInfo').addClass('none');
        } else {
            $('#noInsuranceInfo').addClass('none');
        }

        $(".will-be-displayed.never-show").addClass("none").removeClass("will-be-displayed");
    },
    
    onClickShowPopup: function (targetPage) {
        var parentThis = this;
        switch (targetPage) {
            case "deleteCarInstallmentHistory":
                M.pop.alert({
                    title: '할부 내역 삭제',
                    message: '자동차 할부 정보가 삭제됩니다.\n\n차계부에 등록된 자동차 할부 내역도 함께 삭제됩니다.\n정말 삭제하시겠습니까?',
                    buttons: ['삭제', '취소'],
                    callback: function (index) {
                        switch (index) {
                            case 0:
                                MNet.httpSendAsync({
                                    path: _API.SVR.MYCAR.mci.remCarInsDel,
                                    sendData: {
                                        mbrId: PGV.loginInfo.mbrId,
                                        vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin,
                                        instPymnSeqNo: parentThis.installmentPaymentNo,
                                    },
                                    indicatorYn: "N",
                                    isMock: false
                                }).then(function(response){
                                    if(response.resultCode === "200"){
                                        if(response.delYn && response.delYn === "Y"){
                                            $('.insight-box #carInstallmentInfo').addClass('none');
                                            $('.insight-box #noCarInstallmentInfo').removeClass('none');
                                            M.pop.instance('삭제가 완료되었습니다.');
                                            KIA_RNW_210_0000 && KIA_RNW_210_0000.tabularNavigator.open(0, true);
                                        } else{
                                            M.pop.instance('삭제에 실패하였습니다.');
                                        }
                                    }
                                    else{
                                        M.pop.instance('삭제에 실패하였습니다.');
                                    }
                                })
                                break;
                        }
                    }
                });
                break;
            case "deleteInsuranceHistory":
                M.pop.alert({
                    title: '보험 내역 삭제',
                    message: '자동차 보험 정보가 삭제됩니다.\n\n차계부에 등록된 자동차 보험 내역도 함께 삭제됩니다.\n정말 삭제하시겠습니까?',
                    buttons: ['삭제', '취소'],
                    callback: function (index) {
                        switch (index) {
                            case 0:
                                MNet.httpSendAsync({
                                    path: _API.SVR.MYCAR.mci.InsPreDel,
                                    sendData: {
                                        mbrId: PGV.loginInfo.mbrId,
                                        vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin,
                                        insuSeqNo: parentThis.insuranceSeqNo,
                                    },
                                    indicatorYn: "N",
                                    isMock: false
                                }).then(function(response){
                                    if(response.delYn && response.delYn === "Y"){
                                        $('.insight-box #carInsuranceInfo').addClass('none');
                                        $('.insight-box #noInsuranceInfo').removeClass('none');
                                        M.pop.instance('삭제가 완료되었습니다.');
                                        KIA_RNW_210_0000 && KIA_RNW_210_0000.tabularNavigator.open(0, true);
                                    } else{
                                        M.pop.instance('삭제에 실패하였습니다.');
                                    }
                                })
                                break;
                        }
                    }
                });
                break;
        }
    },

    /* 스크롤 이벤트 함수 중 데이터 로드가 다 되었을 때 실행용 확인 변수 */
    isPromiseDataLoaded: {
        setMonthlyItemExpenditureBox: false,
        setRemainingCarInstallmentPlanBox: false
    },

    /* 퍼블리셔 함수들 정의 */
    setPublisherEventListener: function(){
		// ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		// 한번만 실행
        var runOnceFor = {
            "monthlyItemExpenditureGraph": true,
            "monthlyItemExpenditureGraphNoData": true,
            "carInstallmentGraph": true
        }

		//console.log('$headerHeight', $headerHeight)

		$('[class^="section-"]').each(function(idx, item) {
			nScrollPos[nScrollPosNum] = $(this).offset().top - 450;
			nScrollPosNum++;
		});

        var parentThis = this;

        /* 만약에 스크롤 발생하지 않았는데도 Viewer Area에서 노출되고 있는 경우를 위해 일단 한 번 실행 */
        (function(){
            var $nowTop = $(this).scrollTop();

            for (var i = 0; i< nScrollPos.length; i++) {
                if ($nowTop > nScrollPos[i]) {
                    $('[class^="section-"]').eq(i).addClass('active--scroll');
                    if ($('.section-04').hasClass('active--scroll') && runOnceFor.monthlyItemExpenditureGraph && parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox) {
                        if(parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox){
                            parentThis.drawMonthlyItemExpenditureGraph(parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox.monthData);
                        }
                        runOnceFor.monthlyItemExpenditureGraph = false;
                    }
                    if ($('.section-08').hasClass('active--scroll') && runOnceFor.monthlyItemExpenditureGraphNoData) {
                        parentThis.drawMonthlyItemExpenditureGraph();
                        runOnceFor.monthlyItemExpenditureGraphNoData = false;
                    }
                    if ($('.section-05').hasClass('active--scroll') && runOnceFor.carInstallmentGraph && parentThis.isPromiseDataLoaded.setRemainingCarInstallmentPlanBox) {
                        parentThis.drawCarInstallmentGraph();
                        runOnceFor.carInstallmentGraph = false;
                    }

                }
            }
        
            // 탭버튼영역 스크롤시 상단 고정
            if ($nowTop > $headerHeight) {
                $('body').addClass('js-mycar-tabs-fixed');
            }
            else {
                $('body').removeClass('js-mycar-tabs-fixed');
            }
            
            
            $winTop = $nowTop;
        })();

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();

			for (var i = 0; i< nScrollPos.length; i++) {
				if ($nowTop > nScrollPos[i]) {
					$('[class^="section-"]').eq(i).addClass('active--scroll');
					if ($('.section-04').hasClass('active--scroll') && runOnceFor.monthlyItemExpenditureGraph && parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox) {
                        if(parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox){
                            parentThis.drawMonthlyItemExpenditureGraph(parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox.monthData);
                        }
						runOnceFor.monthlyItemExpenditureGraph = false;
					}
                    if ($('.section-08').hasClass('active--scroll') && runOnceFor.monthlyItemExpenditureGraphNoData) {
                        parentThis.drawMonthlyItemExpenditureGraph();
						runOnceFor.monthlyItemExpenditureGraphNoData = false;
					}
					if ($('.section-05').hasClass('active--scroll') && runOnceFor.carInstallmentGraph && parentThis.isPromiseDataLoaded.setRemainingCarInstallmentPlanBox) {
						parentThis.drawCarInstallmentGraph();
						runOnceFor.carInstallmentGraph = false;
					}

				}
			}
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			
			$winTop = $nowTop;
		});
    },
    
    /* 구 - fnSetEchartsCaseExpend - 항목별 평균 지출 금액에서 사용하는 그래프 */
    drawMonthlyItemExpenditureGraph: function(passedData) {
        /* 공통 사용 함수 및 변수 정의 */
        var _echartsDataGenerator = function(passedData){
            var tempData = [];
            if(passedData){
                if(parseFloat(passedData.oilChargeRate) > 0){
                    tempData.push({
                        name: '주유',
                        value: passedData.oilChargeRate || "0",
                        unit: (passedData.oilChargeCost || 0) + '원'
                    })
                }
                if(parseFloat(passedData.maintenanceRate) > 0){
                    tempData.push({
                        name: '정비',
                        value: passedData.maintenanceRate || "0",
                        unit: (passedData.maintenanceCost || 0) + '원'
                    })
                }
                if(parseFloat(passedData.etcRate) > 0){
                    tempData.push({
                        name: '기타',
                        value: passedData.etcRate || "0",
                        unit: (passedData.etcCost || 0) + '원'
                    })
                }
            }
            return tempData;
        }
        
        function fnGetRich() {
            var result = {}
            _echartsCaseExpend_colors.forEach(function(v, i) {
                result["name" + i] = {
                    color: _echartsCaseExpend_colors[i],
                    fontSize:14,
                    lineHeight:20,
                    fontFamily:'KiaSignature',
                    padding: [20, 3, 20, -10]
                }
                result["value" + i] = {
                    color: _echartsCaseExpend_colors[i],
                    fontSize:14,
                    lineHeight:20,
                    fontFamily:'KiaSignature',
                    padding: [20, -10, 20, 0]
                }
                result["unit" + i] = {
                    color: '#05141f',
                    fontSize:14,
                    lineHeight:20,
                    fontFamily:'KiaSignature',
                }
            })
            
            //console.log('result', result)
            return result;
        }
        
        var _echartsOptionsGenerator = function (_echartsData) {
            return  {
                grid: {
                    left:'20%',
                    right:'20%',
                    top:'0%',
                    bottom:'0%',
                    containLabel: true
                },
                tooltip: {
                    show:false,
                    //trigger: 'item',
    
                },
                legend: {
                    show:false,
                },
    
                series: [{
                    type: 'pie',
                    radius: ['20%', '55%'],
                    avoidLabelOverlap: true,
    
                    /* 20220425//(Ina)수정(s) */
					label: {
						normal: {
							alignTo: 'none', //'none',  'labelLine',  'edge'
							margin: 0,
							distanceToLabelLine: 0,
							left: 'left',
							formatter: function(params) {

								//console.log('params', params)

								var _dataIndex = params.dataIndex;
								var _dataName = params.data.name;
								var _dataValue = params.data.value + '%';
								var _dataUnit = fnAddComma(params.data.unit);

								// return ["{name" + _dataIndex + "|" + _dataName + "}{value" + _dataIndex + "|" + _dataValue + "}", "{unit" + _dataIndex + "|" + _dataUnit + "}"].join('\n')
                                return parseInt(params.data.value) && ["{name" + _dataIndex + "|" + _dataName + "}{value" + _dataIndex + "|" + _dataValue + "}"].join('\n') || ""
							},
							opacity: 1,
							rich: fnGetRich()
						},
					},
					/* 20220425//(Ina)수정(e) */
    
    
                    labelLine: {
                        //show:true,
                        show:false
                    },
                    
                    data: _echartsData,
                    color: _echartsCaseExpend_colors,
                }],
            }
            
        }
        
        function fnAddComma(num) {
            var regexp = /\B(?=(\d{3})+(?!\d))/g;
            return num.toString().replace(regexp, ',')
        }

        var _echartsCaseExpend_colors = ['#5d7d2b', '#ea0029', '#f3c300'];        

        /* 항목별 지출 내역이 없을 때 */
        var _defaultData = [{
            name: '주유',
            value: '30',
            unit: 100000+'원',
            }, {
            name: '정비',
            value: '37',
            unit: 300000+'원',
            }, {
            name: '기타',
            value: '33',
            unit: 20000+'원',
        }];
        var _echartsCaseExpendNoData = echarts.init(document.getElementById('echartsCaseExpend-no-data'));
        _echartsCaseExpend_NoDataOption = _echartsOptionsGenerator(_defaultData);
        _echartsCaseExpendNoData.setOption(_echartsCaseExpend_NoDataOption);

        /* 항목별 지출 내역이 있을 때 */
        if(passedData && (passedData.period03 || passedData.period06 || passedData.period12)){
            var _echartsCaseExpend = echarts.init(document.getElementById('echartsCaseExpendDataView'));
            
            var _echartsDataPeriod03 = _echartsDataGenerator(passedData.period03);
            var _echartsDataPeriod06 = _echartsDataGenerator(passedData.period06);
            var _echartsDataPeriod12 = _echartsDataGenerator(passedData.period12);
    
            _echartsCaseExpend.setOption(_echartsOptionsGenerator(_echartsDataPeriod03));
    
            var parentThis = this;
    
            parentThis.echart = _echartsCaseExpend;
            parentThis.echartOptions = {
                period03: _echartsOptionsGenerator(_echartsDataPeriod03),
                period06: _echartsOptionsGenerator(_echartsDataPeriod06),
                period12: _echartsOptionsGenerator(_echartsDataPeriod12)
            }

            $('#averageSpentPerItem .filter-list button').on("click", function(){
                if (parentThis.isPromiseDataLoaded.setMonthlyItemExpenditureBox){
                    $(this).addClass('active');
                    $(this).siblings().removeClass('active');
                    var currentPeriod = $(this).data('period');
    
                    
                    var averageExpenditureString = (passedData[currentPeriod].averageExpenditure && passedData[currentPeriod].averageExpenditure.toLocaleString() || 0);
                    $('#averageSpentPerItem #mykia-monthly-view-period').text(passedData[currentPeriod].text);
                    $('#averageSpentPerItem #mykia-average-expenditure').text(averageExpenditureString.toLocaleString() + "원");
                    var passedDataKeys = Object.keys(passedData);
                    for(var i = 0; i < passedDataKeys.length; i++){
                        if(passedDataKeys[i] === currentPeriod){
                            if(parentThis.echart && parentThis.echartOptions){
                                parentThis.echart.setOption(parentThis.echartOptions[currentPeriod]);
                            }
                        }
                    }
                }
            })
        }

        $(window).on('resize', function() {
            //_echartsMonthExpend.resize();
            (typeof _echartsCaseExpend ==="object") && _echartsCaseExpend.resize();
            _echartsCaseExpendNoData.resize();
        });

    },

    /* 구 - fnSetCarExpendProgress - 자동차 할부 정보에서 사용하는 그래프 */
    drawCarInstallmentGraph: function() {
        var $progressItem = $('.js-progress-item');
        var $proresesBtn = $('.js-progress-btn');

        var parentThis = this;

        var currentPromiseData = parentThis.isPromiseDataLoaded && parentThis.isPromiseDataLoaded.setRemainingCarInstallmentPlanBox;
        var currentInstallmentCount =  currentPromiseData && currentPromiseData.currentInstallmentCount || 0;
        var totalInstallmentCount = currentPromiseData && currentPromiseData.totalInstallmentCount || 1;

        $("#carInstallmentInfo #carExpendProgressBar0").css("width", (parseInt(Math.round((currentInstallmentCount / totalInstallmentCount) * 100)) || 0) +'%');

        $('#mykia-car-expend-no-data').find($progressItem).each(function(idx, item) {
            var setProgressData =  [60];

            $(item).find('#carExpendProgressBarNoData').css('width', setProgressData[idx]+'%');

        });
    },

    /* EV일 경우 소모품 관리 항목 숨기기 */
    hideItemManageHistoryWhenEV: function(){
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        if(currentScopeSelectCar && currentScopeSelectCar.memEvYn !== "N"){
            $("#itemManageHistory").addClass("none");
        }
    },
}

KIA_RNW_210_0000_2.init();


COMMON_FUNCTION.TOOL.MStatusControl.addMStatusFunction("onRestore", "KIA_RNW_210_0000_2", function(){
    if($("[data-tab-name=mykia-tab-mycar]:visible").length > 0){
        if(KIA_RNW_210_0000 && KIA_RNW_210_0000.tabularNavigator){
            var pageIndex = KIA_RNW_210_0000.tabularNavigator.currentTabIndex;
            if (pageIndex === 0) {
                KIA_RNW_210_0000.tabularNavigator.open(0, true);
                // KIA_RNW_210_0000_2 && KIA_RNW_210_0000_2.setEachBoxByLoadedOrder();
                // KIA_RNW_210_0000_2 && KIA_RNW_210_0000_2.hideNonInformationBoxes();
            }
        }
    }
})

// /**
//  * 모피어스 화면 상태 이벤트 함수
//  */
// var MStatus = {
//     onReady: function (event) {
//         console.log("onReady page : " + PGV.currentPage);
//         KIA_RNW_210_0000.init();
//     },
//     onHide: function (event) { },
//     onRestore: function (event) { },
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//     // onBack : function(){},
//     onDestroy: function (event) { },
//     onPause: function (event) { },
//     onResume: function (event) { }
// }; 
