/**

@파일명 : KIA_RNW_211_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 :  
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/
var KIA_RNW_211_0000 = {
    /* 현재 페이지의 권한을 부모 페이지로부터 받아온다. */
    currentPermission: MData.param("currentPermission"),

    init: function () {
        var parentThis = this;
        this.loadSavedOrder()
        .then(function (savedOrderList) {
            
            /* 현재 선택된 차량이 EV 모드일 경우 소모품 관리 항목은 넘어가기 */
            var currentPermission = typeof parentThis.currentPermission === "string" && parentThis.currentPermission.length > 0 && parentThis.currentPermission || null;
            var isEVMode = _.contains(["owner-ev", "rider-ev"], currentPermission);
            if(isEVMode) savedOrderList = _.map(savedOrderList, function(element){
                if(element.id === "itemManageHistory") element.isSkipped = true;
                return element;
            })

            parentThis.setSavedOrder(savedOrderList)
            .then(function () {
                parentThis.setSortableList();
                parentThis.setEventListner(savedOrderList);
            })
            .catch(function (e) {
                COMMON_FUNCTION.TOOL.DEBUG.showAdvice(e);
            });
        });
        //$('input#chkOption3').parents('li')
    },
    setEventListner: function (savedOrderList) {
        var parentThis = this;
        $('#mykia-edit-insight-order-save').on("click", function () {
            var screenInsightOrder = parentThis.getCurrentInsightOrder(savedOrderList);
            parentThis.saveInsightOrder(screenInsightOrder);
        })
    },
    loadSavedOrder: function () {
        return new Promise(function (resolve) {
            var tempStorage = M.data.storage('mykiaRenewal');
            var currentSavedOrderList = tempStorage && tempStorage.insight && tempStorage.insight.insightOrderArray || [];
            if (currentSavedOrderList.length === 0){
                currentSavedOrderList = COMMON_FUNCTION.TOOL.DATA.getDefaultValue('insightOrderArray');
            }
            resolve(currentSavedOrderList);
        })
    },
    setSavedOrder: function (savedOrderList) {
        var currentPermission = typeof this.currentPermission === "string" && this.currentPermission.length > 0 && this.currentPermission || null;
        return new Promise(function (resolve) {
            var entryTemplate = function (entryId, entryTitle, entryChecked) {
                var templateString =
                    '<li class="">' +
                        '<div class="form-field">' +
                            '<div class="chk-cont chk-size-m">' +
                                '<input type="checkbox" name="' + entryId + '" id="' + entryId +'" ' + '>' +
                                    '<label for="' + entryId + '">' +
                                        '<span>' + entryTitle +'</span>' +
                                    '</label>' +
                            '</div>' +
                        '</div>' +
                        '<button type="button" class="btn-swap">' +
                            '<i class="ico-swap"></i>' +
                        '</button>' +
                    '</li>';
                
                var templateObject = $(templateString);
                if(entryChecked) templateObject.find('input').prop('checked', true);
                return templateObject;
            }

            var uiCheckBoxesContainer = $('ul#sortable');
            
            for(var i = 0; i < savedOrderList.length; i++){
                var curNode = savedOrderList[i];

                if(curNode.isSkipped) continue;
                
                uiCheckBoxesContainer.append(entryTemplate(curNode.id, curNode.title, curNode.checked));
            }
            resolve();
        })
    },
    setSortableList: function () {
        $('#sortable').sortable({
            cancel:'',
            handle : '.btn-swap',
            containment:'#sortable', // 20220530//(Ina) containment옵션추가, #sortable 안에서만 움직이도록 설정
        }).disableSelection();
    },
    onClickCheckbox: function(){
        $('ul.sortable-list li input').on("click", function(){

        })
    },
    getCurrentInsightOrder: function (savedOrderList) {
        /* 앱 화면 속 Insight Order 가져오기 */
        var insightOrderArray = [];
        var uiCheckBoxes = $('ul#sortable input');
        for (var i = 0; i < uiCheckBoxes.length; i++) {
            var currentInput = $(uiCheckBoxes[i]);
            var currentSearchedNode = _.find(savedOrderList, function(element){return element.id === currentInput.attr('id')});
            currentSearchedNode.checked = currentInput.prop("checked");
            insightOrderArray.push(currentSearchedNode);
        }

        return insightOrderArray;
    },
    saveInsightOrder: function(currentInsightOrderArray){
        /* Insight Order storage에 저장하기 */
        var tempStorage = M.data.storage('mykiaRenewal');
        if (!tempStorage) tempStorage = {};
        if (!tempStorage.insight) tempStorage["insight"] = {};
        if (!tempStorage.insight.insightOrderArray)  tempStorage.insight["insightOrderArray"] = COMMON_FUNCTION.TOOL.DATA.getDefaultValue('insightOrderArray');
        
        var defaultInsightOrderArray = COMMON_FUNCTION.TOOL.DATA.getDefaultValue('insightOrderArray');

        var showSuccessToastMessage = !_.isEqual(defaultInsightOrderArray, currentInsightOrderArray);

        for(var i = 0; i < defaultInsightOrderArray.length; i++){
            var curNode = defaultInsightOrderArray[i];
            if (_.find(currentInsightOrderArray, function(element){return element.id === curNode.id})){
                continue;
            }
            currentInsightOrderArray.push(curNode);
        }

        tempStorage.insight.insightOrderArray = currentInsightOrderArray;

        M.data.storage('mykiaRenewal', tempStorage);

        if(showSuccessToastMessage){
            M.pop.instance('저장이 완료되었습니다.');
            MPage.back();
        }
        else{
            M.pop.instance('변경된 내용이 없습니다.');   
        }
    }
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_211_0000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) { },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
