/**

@파일명 : KIA_RNW_220_0000.js
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03
@메뉴명 :
@DESC : 전체메뉴노출[O]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O]
*/
var CurrPage;
var KIA_RNW_220_0000 = {
    init: function () {
        CurrPage = this;
        exWNShowIndicator();
        //페이지 및 화면별 권한여부
        CurrPage.chkAuthPage();

        //차량 선택 팝업 set
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(currentScopeSelectCar, "#mykia-mycar-car-select-box");
        //주유사 제휴 정보
        CurrPage.getCardList();
        //scroll event
        CurrPage.setScrollEvt();
        //event
        CurrPage.setEventListner();


        //CCS연동 여부에 따라 누적주행거리 수정여부판단 (CCS대상 : 수정불가 + datahub 누적주행거리 조회 / 비대상 : 수정가능)
        COMMON_FUNCTION.TOOL.DATA.getTrvgDist(currentScopeSelectCar)
        .then(function(response){
            // 2024.04.17 ccsYn 컬럼 사용 중단
            // if(currentScopeSelectCar.ccsYn == "Y" && (currentScopeSelectCar.carId != undefined && currentScopeSelectCar.carId != "X")){
            if(currentScopeSelectCar.carId != undefined && currentScopeSelectCar.carId != "X"){
                //차계부 하위의 모든 페이지에서 누적주행거리 디폴트로 가지기 위함.
                MData.global('myCarMngInfo', response);
                $("#distInfoBtn").remove();
            }else{
                MData.removeGlobal('myCarMngInfo');
            }
            var trvgDist = parseInt(response.trvgDist);
            $("#distInfo").find('span').text(trvgDist && trvgDist.toLocaleString() || response.trvgDist);

            //월별 지출 요약 조회 && 월별 지출 비교 조회
            CurrPage.expForMonth()
            .then(function(obj){
                return Promise.all([
                    CurrPage.expSumyArea(obj.ckbExpSumy),
                    CurrPage.expCompArea(obj.ckbExpComp)
                ])
            })
            .then(function(obj){
                exWNHideIndicator();
            });
        });
    },
    setEventListner: function () {

        //퀵 버튼 클릭 evt
        $('.js-mycar-quick-btn').on('click', function(e) {
            e.preventDefault();
            $('body').toggleClass('js-mycar-quick--active');
        });

        //차량 선택
        $("#mykia-mycar-car-select-box").off("click").on("click", function(){
            if($("body.js-mycar-quick--active").length > 0){
                $('body').removeClass('js-mycar-quick--active');
            }
            COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(KIA_RNW_210_0000);
        });

        //월별 지출 요약 현재 날짜 기준 연,월 (moment.js)
        $("#selDate").data("srchDt", moment().format("YYYYMM"));
        $("#selDate > b").text(moment().format("YYYY년 MM월"));

        //검색 연월 팝업
        $("#selDatePop").on("click", function(){
            var minDt = moment('2015-01-01').format('YYYYMM');
            //var minDt = moment().add('-12','M').format('YYYYMM');
            var maxDt = moment().format("YYYYMM");
            var options = {
                type: "YM",
                initDate: $("#selDate").data("srchDt"),
                startDate: minDt,
                endDate: maxDt,
                minDate: minDt,
                maxDate: maxDt
            };
            MPopup.date(options, CurrPage.selDatePop);
        });


        //누적 주행거리 customPopup
        $("#distInfoBtn").on("click", function(){
            CurrPage.distPopEvt();
        })

        //월별 지출 요약 > 상세내역
        $("#mnthExpDtl").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_223_0000.path});

            if($("body.js-mycar-quick--active").length > 0){
                $('body').removeClass('js-mycar-quick--active');
            }
        });

        //제휴사 정보 받기 설정 버튼
        $("#popDetailBtn").on("click",function(){
            //제휴사 연동 안내 팝업
            var pop = PATH_MANAGER.KIA_RNW_0D2_2100;
            if(PGV.currentPage != pop.nameWithHtml){
                MPage.html({
                    url : pop.path,
                    animate : "MODAL_DOWN",
                });
            }
        });

        //핸드폰 기종에 따라 노출여부
        if(!M.navigator.device("ios")){
            CurrPage.notiChkEvt();
            $("#smsNotIos").show();
            $("#smsNotIosText").show();
        }

        //알림접근허용 evt
        $("#smsNotIos").find("input[type=checkbox]").on("click", function(){
            //허용 on
            if($(this).prop('checked')){
                var isNoti = exWNcheckNotificationPermission();

                if(isNoti == "true"){
                    M.data.storage('enable_receive_payment_info', true);
                }else{
                    exWNshowNotificationPermission();
                }
            }else{
                //허용 off
                M.data.storage('enable_receive_payment_info', false);
            }

            CurrPage.notiChkEvt();
        });

        //ev차량일 경우, sms 영역 미노출 + 퀵버튼 주유 클래스명 변경
        if(COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).memEvYn != "N"){
            $("#smsNotIos").remove();
            $("#smsNotIosText").remove();
            $(".mycar-quick-list .btn-quick-gas > i").prop('class', 'ico-quick-charge');
            $(".mycar-quick-list .btn-quick-gas").prop('class', 'btn-quick-charge');
        }

        //퀵버튼 클릭evt
        $(".mycar-quick-list button").on("click", function(){
            var classNm = $(this).attr('class');

            if(classNm.indexOf('gas') > -1){
                MPage.html({url: PATH_MANAGER.KIA_RNW_224_2100.path});
            }else if(classNm.indexOf('charge') > -1){
                MPage.html({url: PATH_MANAGER.KIA_RNW_224_2200.path});
            }else if(classNm.indexOf('repair') > -1){
                MPage.html({url: PATH_MANAGER.KIA_RNW_224_2300.path});
            }else if(classNm.indexOf('etc') > -1){
                MPage.html({url: PATH_MANAGER.KIA_RNW_224_1000.path});
            }

            if($("body.js-mycar-quick--active").length > 0){
                $('body').removeClass('js-mycar-quick--active');
            }
        })
    },

    
    chkAuthPage: function(){
        //등록된 차량이 없을 때, 팝업노출
        var passData = MData.global("passData");
        if(!passData.car.myCarInfoListResDto){
            COMMON_FUNCTION.TOOL.UI.showNoCarPopup(function(){
                MyKiaBottomTab.open('home');
            });
        }
    },
    
    connectCcs: function(){
        var options = {
            isMock: false, indicatorYn: "N", path: _API.HUB.carMaster.verifyUrl(PGV.loginInfo.ccspId, COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    },
    odometer: function(){
        var options = {
            isMock: false, indicatorYn: "N", path: _API.HUB.odometer.verifyUrl(COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).carId).path, method: CONSTANT.NET_MTHD.GET,
        };
        return MNet_Hub.httpSendAsync(options);
    },

    distPopEvt: function(){
        customPopup.get(PATH_MANAGER.KIA_RNW_221_0000.path, $("#popup_221_0000"), function(item){
            //누적 주행거리 입력 팝업 생성
            if($("#popup_221_0000").length < 1){
                var screenHtml = $("<div></div>");
                screenHtml.append(item);
                $('body').append(screenHtml.find('#popup_221_0000'));

                $("#saveBtn").on("click", function(){
                    if(parseInt($("#trvgDist").val())){
                        //누적 주행거리 입력 팝업 저장
                        CurrPage.insertDist()
                        .then(function(){
                            exWNHideIndicator();
                        });
                    }else{
                        MPopup.instance("유효하지 않은 숫자입니다.");
                    }
                })
                COMMON_FUNCTION.TOOL.UI.handleNumberOnlyInput();
            }

            //누적 주행거리 값
            $("#trvgDist").val(comma.add($("#distInfo").find('span').text()));

            RNW_UI.popupLayer({selId : '#popup_221_0000'});
        });
    },
    notiChkEvt: function(){
        //알림 동의 여부
        var isNoti = exWNcheckNotificationPermission();

        if(isNoti == "true"){
            var isPayInfo = M.data.storage('enable_receive_payment_info');

            if(isPayInfo == "true"){
                $("#smsNotIos").find("input[type=checkbox]").prop('checked', true);
            }else{
                $("#smsNotIos").find("input[type=checkbox]").prop('checked', false);
            }
        }else{
            $("#smsNotIos").find("input[type=checkbox]").prop('checked', false);
        }
    },
    distInfo: function () {
        //누적주행거리 조회
        var sendData = {
            apiId: 'RNW-CKB-1001',
            mbrId: PGV.loginInfo.mbrId,
            vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.car.distInfo,
            sendData: sendData,
            indicatorYn: "N",
            isMock: false
        }).then(function (response) {
            console.log(JSON.stringify(response))

            if(response.resultCode == '200'){
                var data = response.carTrvgDistRnwResDto;
                loginHome.gVals.car.distInfo.trvgDist = data.trvgDist;
                var trvgDist = "-";

                if(!isNull(data.trvgDist)){
                    if(data.trvgDist != "0"){
                        trvgDist = comma.add(data.trvgDist);
                    }
                }

                $("#distInfo").find('span').text(trvgDist);
            }
        })
    },
    expForMonth: function () {
        return new Promise(function (resolve) {
            //월별 지출요약_지출비교
            var sendData = {
                apiId: 'RNW-CKB-2001',
                mbrId: PGV.loginInfo.mbrId,
                vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin,
                viewMnth: $("#selDate").data("srchDt")
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.ckb.expForMonth,
                sendData: sendData,
                isMock: false
            }).then(function (response) {
                console.log(JSON.stringify(response))
                if(response.resultCode == '200'){
                    //주 데이터 조회 시, progress 애니메이션 주기 위함
                    CurrPage.activeScrollFlag2 = true;

                    var obj = response.ckbExpForMonthRnwResDto;
                    //월 지출내역 합계 (천단위 콤마)
                    var viewMnthExp = parseInt(obj.ckbExpSumy.viewMnthExp).toLocaleString();
                    $("#viewMnthExp").find('span').text(viewMnthExp);

                    resolve(obj);
                }
            })
        })
    },
    expSumyArea: function (obj) {
        return new Promise(function (resolve) {
            //월별 지출 요약 영역
            // 항목별 평균 지출 내역 영역
            var avgList = obj.viewMnthList;

            //데이터 없을 시, 예외처리 추가(2022-04-29)
            var dataIsOk = avgList.some(function(el){return el.svcExp > 0});
            if(dataIsOk){

                $("#chartContainer").show();
                $(".nodata-area").hide();

                var avgChart = echarts.init(document.getElementById('echartsCaseExpend'));
                //애니메이션 효과를 주기 위해 초기화
                avgChart.clear();
                var colors = ['#5d7d2b', '#ea0029', '#f3c300'];
                var option;
                var data = [];

                //avgList가 존재하지 않을 때에도 0으로 노출하기 위함 (2022-03-14)
                if(avgList.length < 1)
                {
                    var memEvYn = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).memEvYn;
                    var svcNm = memEvYn != "N" ? "충전" : "주유";
                    avgList = [
                       {"svcCd":"02","svcNm":svcNm,"svcRate":"0", "svcExp":"0"}
                      ,{"svcCd":"05","svcNm":"정비","svcRate":"0", "svcExp":"0"}
                      ,{"svcCd":"03","svcNm":"용품/기타","svcRate":"0", "svcExp":"0"}
                    ];
                };

                //data 가공 및 라벨 함수 (obj.viewMnthList.length = 3으로 가정, 그 이상일 때 colors만 추가하면 됨.)
                function fnGetRich() {
                    //차트 라벨 rich
                    var labelRich = {};
                    //항목별 지출 내역 html
                    var histList = "";

                    //주유(충전),정비,기타 순 정렬
                    avgList.sort(function(a,b){
                        if(a.svcCd == "03"){
                            return 1;
                        }else if(b.svcCd == "03"){
                            return -1;
                        }else{
                            return a.svcCd-b.svcCd;
                        }
                    })

                    avgList.forEach(function(v, i) {
                        //천단위 콤마 정규식
                        var tmpSvcExp = parseInt(avgList[i].svcExp).toLocaleString();
                        var memEvYn = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).memEvYn;
                        if(avgList[i].svcCd == "02"){
                            avgList[i].svcNm = memEvYn != "N" ? "충전" : "주유";
                        }

                        labelRich["name" + i] = {
                            color: colors[i],
                            fontSize:14,
                            lineHeight:20,
                            fontFamily:'KiaSignature',
                            padding: [20, 3, 20, -10]
                        }
                        labelRich["value" + i] = {
                            color: colors[i],
                            fontSize:14,
                            lineHeight:20,
                            fontFamily:'KiaSignature',
                            padding: [20, -10, 20, 0]
                        }
                        labelRich["unit" + i] = {
                            color: '#05141f',
                            fontSize:14,
                            lineHeight:20,
                            fontFamily:'KiaSignature',
                        }

                        data.push({
                              name : avgList[i].svcNm
                            , value : avgList[i].svcRate
                            , unit : avgList[i].svcExp + "원"
                        });

                        histList += "<dl><dt>"+avgList[i].svcNm+"</dt><dd><b>"+tmpSvcExp+"원</b></dd></dl>"
                    })

                    $("#histList").html(histList);
                    return labelRich;
                }

                //차트 옵션
                option = {
                     grid: {
                        left:'20%',
                        right:'20%',
                        top:'0%',
                        bottom:'0%',
                        containLabel: true
                     },
                     tooltip: {
                         show:false,
                     },
                     legend: {
                         show:false,
                     },
                     series: [{
                        type: 'pie',
                        radius: ['20%', '55%'],
                        avoidLabelOverlap: true,
                        label: {
                            normal: {
                                alignTo: 'none', //'none',  'labelLine',  'edge'
                                margin: 0,
                                distanceToLabelLine: 0,
                                left: 'left',
                                formatter: function(params) {

                                    //console.log('params', params)

                                    var _dataIndex = params.dataIndex;
                                    var _dataName = params.data.name;
                                    var _dataValue = params.data.value + '%';
                                    var _dataUnit = comma.add(params.data.unit);

                                    return parseInt(params.data.value) && ["{name" + _dataIndex + "|" + _dataName + "}{value" + _dataIndex + "|" + _dataValue + "}"].join('\n') || ""
                                },
                                opacity: 1,
                                rich: fnGetRich()
                            }
                         },
                         labelLine: {
                             show:false
                         },
                         data: data,
                         color: colors,
                     }],
                };

                //차트 set
                avgChart.setOption(option);
            }else{
                $("#chartContainer").hide();
                $(".nodata-area").show();
            }

            resolve();
        })
    },
    expCompArea: function (obj) {
        return new Promise(function (resolve) {
            //월별 지출 비교 영역
            //조회월 (현재 달 기준 - 1)
            var viewMnth = obj.viewMnth.substr(4,2);
            //전월 (현재 달 기준 - 2)
            var prevMnth = obj.prevMnth.substr(4,2);
            //월별 지출 비교 리스트
            var viewMnthList = obj.viewMnthList;
            //급증가 카테고리
            var arrIncrCtrg = [];
            //리스트 초기화
            $("#compListContainer").html('');
            //리스트 영역 복사
            var compListHtml = $("#dummyDlCon").clone();

            //viewMnthList 존재하지 않을 때에도 0으로 노출하기 위함 (2022-03-14)
            if(viewMnthList.length < 1)
            {
                var memEvYn = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).memEvYn;
                var svcNm = memEvYn != "N" ? "충전" : "주유";
                viewMnthList = [
                    {"svcCd":"02","svcNm":svcNm,"svcExp":"0","svcPrevExp":"0","incrExp":"0"}
                   ,{"svcCd":"05","svcNm":"정비","svcExp":"0","svcPrevExp":"0","incrExp":"0"}
                   ,{"svcCd":"03","svcNm":"용품/기타","svcExp":"0","svcPrevExp":"0","incrExp":"0"}
                ]
            };

            //주유(충전),정비,기타 순 정렬
            viewMnthList.sort(function(a,b){
                if(a.svccd == "03"){
                    return 1;
                }else if(b.svcCd == "03"){
                    return -1;
                }else{
                    return a.svcCd-b.svcCd;
                }
            })

            viewMnthList.forEach(function(v, i) {
                //월별 지출 비교 html
                var tmpIncrTxt = "";
                var tmpListHtml = $(compListHtml).clone();
                var differExp = viewMnthList[i].svcExp - viewMnthList[i].svcPrevExp;
                var memEvYn = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).memEvYn;
                if(viewMnthList[i].svcCd == "02"){
                    viewMnthList[i].svcNm = memEvYn != "N" ? "충전" : "주유";
                }

                //급 증가 영역 2개 이상인지 판단하기 위함
                if(viewMnthList[i].incrExp >= 20){
                    arrIncrCtrg.push({svcNm: viewMnthList[i].svcNm});
                }

                //월별 지출 차
                if(differExp > 0){
                    var tmpExpRate = (viewMnthList[i].svcPrevExp / viewMnthList[i].svcExp) * 100;
                    tmpIncrTxt = differExp.toLocaleString() + "원 증가하였습니다.";
                    $(tmpListHtml).find('dd:first .progress-bar').data('width', '100');
                    $(tmpListHtml).find('dd:last .progress-bar').data('width', tmpExpRate);
                }else if(differExp < 0){
                    var tmpExpRate = (viewMnthList[i].svcExp / viewMnthList[i].svcPrevExp) * 100;
                    tmpIncrTxt = Math.abs(differExp).toLocaleString() + "원 감소하였습니다.";
                    $(tmpListHtml).find('dd:first .progress-bar').data('width', tmpExpRate);
                    $(tmpListHtml).find('dd:last .progress-bar').data('width', '100');
                }else{
                    //differExp = 0 이지만, svcPrevExp or svcExp가 0인지 아닌지 판단하기 위함
                    var tmpExpRate = (viewMnthList[i].svcExp / viewMnthList[i].svcPrevExp) * 100;

                    if(isNaN(tmpExpRate)){
                        tmpExpRate = 0;
                    }
                    $(tmpListHtml).find('dd:first, dd:last').find('.progress-bar').data('width', tmpExpRate);
                }

                $(tmpListHtml).find('dt > em').text(tmpIncrTxt);
                $(tmpListHtml).find('dt .text-scale-05 > b').text(viewMnthList[i].svcNm);
                $(tmpListHtml).find('dd:first .progress-text').text(parseInt(viewMnthList[i].svcExp).toLocaleString() + " 원");
                $(tmpListHtml).find('dd:last .progress-text').text(parseInt(viewMnthList[i].svcPrevExp).toLocaleString() + " 원");
                $(tmpListHtml).show();

                $("#compListContainer").append(tmpListHtml);
            })


            //급 증가 영역 개수에 따른 문구
            if(arrIncrCtrg.length >= 2){
                rapidTxt = "지난 달 대비 전체적인 유지 비용이 큰 폭으로 증가했어요!";
                //현재 조회의 이전 조회가 증가가 아닐 경우 대비하기 위함
                $("#rapidTxt").closest('.info-cont.c-bg-gray').show();
            }else if(arrIncrCtrg.length == 1){
                rapidTxt = prevMnth + "월 대비 "+ arrIncrCtrg[0].svcNm +"금액이 <b class='c-font-brand-point'>20%</b>이상 증가했어요!";
                //현재 조회의 이전 조회가 증가가 아닐 경우 대비하기 위함
                $("#rapidTxt").closest('.info-cont.c-bg-gray').show();
            }else{
                //증가가 아닐 경우? 영역숨김
                $("#rapidTxt").closest('.info-cont.c-bg-gray').hide();
            }

            $("#viewMnth").text(viewMnth+"월");
            $("#prevMnth").text(prevMnth+"월");
            $("#rapidTxt").html(rapidTxt);

            resolve();
        })
    },
    insertDist: function () {
        return new Promise(function (resolve) {
            var sendData = {
                apiId: 'RNW-CKB-1002',
                mbrId: PGV.loginInfo.mbrId,
                vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin,
                trvgDist: comma.remove($("#trvgDist").val()) || 0
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.car.insertDist,
                sendData : sendData,
                isMock: false
            }).then(function (response) {
                if(response.resultCode == '200')
                {
                    if(response.carAddTrvgDistRnwResDto.rgstYn == 'Y')
                    {
                        MPopup.alert({
                            message : "등록 성공하였습니다."
                            , callback : function(index){
                                customPopup.remove($("#popup_221_0000"));
                                CurrPage.distInfo();
                            }
                        })
                    }else{
                        MPopup.alert("등록 실패하였습니다.");
                    }
                }

                resolve();
            })
        })
    },
    setScrollEvt: function(){
        // ------------------------------
        // 	Scroll
        // ------------------------------

        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();

        // 한번만 실행
        CurrPage.activeScrollFlag1 = true;
        CurrPage.activeScrollFlag2 = true;

        $('[class^="section-"]').each(function(idx, item) {
            nScrollPos[nScrollPosNum] = $(this).offset().top - 450;
            nScrollPosNum++;
        });

        $(window).scroll(function(e) {
            var $nowTop = $(this).scrollTop();

            for (var i = 0; i< nScrollPos.length; i++) {
                if ($nowTop > nScrollPos[i]) {
                    $('[class^="section-"]').eq(i).addClass('active--scroll');

                    /*if ($('.section-03').hasClass('active--scroll') && activeScrollFlag1) {
                        notiMng.expSumyArea(notiMng.ckbExpSumy);
                        notiMng.expCompArea(notiMng.ckbExpComp);
                        activeScrollFlag1 = false;
                    }*/

                    if ($('.section-04').hasClass('active--scroll') && CurrPage.activeScrollFlag2) {
                        var $progressItem = $('.js-progress-item');
                        //progress-bar 애니메이션

                        $('.case-expend').find($progressItem).each(function(idx, item) {
                            var progBar = $(item).find('.progress-bar');
                            progBar.css('width', progBar.data('width')+'%');
                        });

                        CurrPage.activeScrollFlag2 = false;
                    }
                }
            }

            // 탭버튼영역 스크롤시 상단 고정
            if ($nowTop > $headerHeight) {
                $('body').addClass('js-mycar-tabs-fixed');
            }
            else {
                $('body').removeClass('js-mycar-tabs-fixed');
            }

            $winTop = $nowTop;

        });
    },
    getCardList: function () {
        return CurrPage.getMembershipOilCardsList()
            .then(
                function(response){
                    var cards=null;
                    var totalCnt =0;

                    /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
                    COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(response);

                    if(response.resultCode==="200"){
                        var cardMemberRnwResDto = response.cardMemberRnwResDto;
                        var cardOilListRnwResDto = response.cardOilListRnwResDto;
                        totalCnt = (isEmpty(cardMemberRnwResDto)?0:cardMemberRnwResDto.length) +(isEmpty(cardOilListRnwResDto)?0:cardOilListRnwResDto.length);
                        if(totalCnt==0) response={};
                        cards = response;
                    }else{
                        cards = {};
                    }
                    cards.totalCnt = totalCnt;
                    PGV.passData.gnb.barcode.cardList = cards;
                    M.data.global("cardOilList",PGV.passData.gnb.barcode.cardList.cardOilListRnwResDto);
                }
            );
    },
    getMembershipOilCardsList : function(){
        var options = {
            isMock: false,
            path: _API.SVR.CMM.crd.holdCardReq,
            sendData: {
                mbrId: PGV.loginInfo.mbrId
            }
        };
        return MNet.httpSendAsync(options);
    },
    selDatePop: function(result, setting){

        //"{"yyyy":"2021","MM":"03","status":"SUCCESS"}"
        if(result.status == 'SUCCESS')
        {
            //조회월 변경 시, 문구 변경 및 조회월 데이터 조회
            $("#selDate").data("srchDt", result.yyyy+result.MM);
            $("#selDate > b").text(result.yyyy + "년 "+result.MM+"월");


            CurrPage.expForMonth()
            .then(function(obj){
                return Promise.all([
                    CurrPage.expSumyArea(obj.ckbExpSumy),
                    CurrPage.expCompArea(obj.ckbExpComp)
                ])
            })
            .then(function(obj){
                exWNHideIndicator();
            });
        }
    }
}

KIA_RNW_220_0000.init();

COMMON_FUNCTION.TOOL.MStatusControl.addMStatusFunction("onRestore", "KIA_RNW_220_0000", function(){
    if($("[data-tab-name=mykia-tab-mycar]:visible").length > 0){
        if(KIA_RNW_210_0000 && KIA_RNW_210_0000.tabularNavigator.currentTabIndex === 1){
            if(MData.param('isRefresh') == 'Y'){

                MData.removeParam('isRefresh');
                KIA_RNW_210_0000.tabularNavigator.open(1, true);
            }else{
                //알림 동의 여부
                CurrPage.notiChkEvt();
            }
        }
    }
})
/**
 * 모피어스 화면 상태 이벤트 함수
 */
/*var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_220_0000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) { },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
*/