/**

@파일명 : KIA_RNW_223_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.02.25 
@메뉴명 :  지출 상세 내역
@DESC : 권한 확인 중
*/
var CurrPage;
var KIA_RNW_223_0000 = {
    init: function() {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        //evt
        CurrPage.setEventListner();
        //지출 상세 내역 조회
        CurrPage.expendList()
        .then(function(){
            exWNHideIndicator();
        });
    },
    setEventListner: function () {

        //선택했던 차량의 EV 여부
        var memEvYn = MData.global('passData').car.currentScopeSelectCar.memEvYn;
        memEvYn != "N" && $("#tabBtn button").eq(1).text("충전");

        //지출 상세 내역 현재 날짜 기준 연,월 (moment.js)
        $("#selDate").data("srchDt", moment().format("YYYYMM"));
        $("#selDate > b").text(moment().format("YYYY년 MM월"));

        //검색 연월 팝업
        $("#selDatePop").on("click", function(){
            var minDt = moment('2015-01-01').format('YYYYMM');
            //var minDt = moment().add('-12','M').format('YYYYMM');
            var maxDt = moment().format("YYYYMM");
            var options = {
                type: "YM",
                initDate: $("#selDate").data("srchDt"),
                startDate: minDt,
                endDate: maxDt,
                minDate: minDt,
                maxDate: maxDt
            };
            MPopup.date(options, CurrPage.selDatePop);
        });

        //탭에 따른 리스트 조회
        $("#tabBtn button").on("click", function(){
            CurrPage.expendList()
            .then(function(){
                exWNHideIndicator();
            });
        });

        //지출내역 상세 클릭 이벤트
        $("#dummyDivCon li").on("click", function(){
            //차계부고유번호
            var ckbUnqNo = $(this).data('seq');
            //서비스코드
            var svcCd = $(this).data('svcCd');
            //정유사 Y/N
            var chnlYn = $(this).data('chnlYn');
            //스미싱 판단 코드
            var chnlCd = $(this).data('chnlCd');
            //충전 Y/N
            var evYn = $(this).data('evYn');
            var rtnUrl;

            //정유사(chnlYn == 'Y') 및 서비스코드에 따라 상세 페이지 분기
            if(svcCd == '02'){
                //주유 or 충전 여부(?)
                if(evYn == 'Y'){
                    rtnUrl = (chnlYn == 'Y') ? PATH_MANAGER.KIA_RNW_223_3200.path : PATH_MANAGER.KIA_RNW_223_1200.path;
                }else{
                    //스미싱 여부 판단
                    if(chnlCd == 'CSSM'){
                        rtnUrl = PATH_MANAGER.KIA_RNW_223_3400.path;
                    }else{
                        rtnUrl = (chnlYn == 'Y') ? PATH_MANAGER.KIA_RNW_223_3100.path : PATH_MANAGER.KIA_RNW_223_1100.path;
                    }
                }
            }else if(svcCd == '03'){
                //기타는 일반/보험/할부로 나눠야 할(?)
                var svcSmlCd = $(this).data('svcSmlCd');

                if(svcSmlCd == 'A1'){
                    //보험
                    rtnUrl = PATH_MANAGER.KIA_RNW_223_1500.path;
                }else if(svcSmlCd == 'A2'){
                    //할부
                    rtnUrl = PATH_MANAGER.KIA_RNW_223_1600.path;
                }else{
                    //일반
                    rtnUrl = PATH_MANAGER.KIA_RNW_223_1400.path;
                }

            }else if(svcCd == '05'){
                rtnUrl = (chnlYn == 'Y') ? PATH_MANAGER.KIA_RNW_223_3300.path : PATH_MANAGER.KIA_RNW_223_1300.path;
            }

            var options = {
                url: rtnUrl,
                param: {
                    viewMnth : $("#selDate").data('srchDt'),
                    ckbUnqNo : ckbUnqNo
                }
            }

            MPage.html(options)
        });

        //엑셀 다운로드 customPopup
        $("#excelPop").on("click", function(){
            CurrPage.excelPopEvt();
        });


    },
    excelPopEvt: function(){

        //엑셀 팝업 이벤트
        customPopup.get(PATH_MANAGER.KIA_RNW_223_2000.path, $("#popup_223_2000"), function(item){

            //누적 주행거리 입력 팝업 생성
            if($("#popup_223_2000").length < 1){
                var screenHtml = $("<div></div>");
                screenHtml.append(item);


                //android, ios 분기처리
                 if(MInfo.device().os.name.toLowerCase() == 'ios'){
                    screenHtml.find("#excelDown").closest(".col-2").remove();
                    screenHtml.find("#excelShare").removeClass("btn-default").addClass("btn-primary").closest(".col-2").css('width','100%');
                 }

                $('body').append(screenHtml.find('#popup_223_2000'));

                //엑셀 다운로드
                $("#excelDown").on("click", function(){
                    var strtDt = $("#datepicker1").val();
                    var endDt = $("#datepicker2").val();

                    if(strtDt > endDt){
                        MPopup.instance("날짜를 확인해 주세요.");
                    }else{
                        CurrPage.excelDown()
                        .then(function(downFileUrl){
                            exWNHideIndicator();
                        })
                        .catch(function(){
                            exWNHideIndicator();
                        })
                    }
                });

                //엑셀 공유하기
                $("#excelShare").on("click", function(){
                    var strtDt = $("#datepicker1").val();
                    var endDt = $("#datepicker2").val();

                    if(strtDt > endDt){
                        MPopup.instance("날짜를 확인해 주세요.");
                    }else{
                        CurrPage.excelDownAndShare()
                        .then(function(fileInfo){
                            exWNShareFile(fileInfo.fullpath);
                            exWNHideIndicator();
                        })
                        .catch(function(){
                            exWNHideIndicator();
                        })
                    }
                });
            }

            RNW_UI.popupLayer({selId : '#popup_223_2000'});

            //현재 날짜로
            $("#datepicker1, #datepicker2").val(moment().format("YYYY.MM.DD"));

        });

    },
    excelDown: function(){
            return new Promise(function (resolve, reject) {

                // 2024.04.16 다운로드 기간 365일 문구 추가
                var strtDt = $('#datepicker1').val();
                var endDt = $('#datepicker2').val();

                if (dDayDiff(strtDt, endDt) > 365) {
                    MPopup.instance("다운로드 기간은 365일을 초과 할 수 없습니다.");
                    return reject();
                }

                var sendData = {
                    apiId: 'RNW-CKB-2005',
                    mbrId: PGV.loginInfo.mbrId,
                    vin: MData.global('passData').car.currentScopeSelectCar.vin,
                    strtDt: $('#datepicker1').val().replace(/\./g, ""),
                    endDt: $('#datepicker2').val().replace(/\./g, ""),
                    evYn: MData.global('passData').car.currentScopeSelectCar.memEvYn
                }

                MNet.httpSendAsync({
                    path: _API.SVR.MYCAR.ckb.downloadExpend,
                    sendData : sendData,
                    isMock: false
                }).then(function (response) {
    console.log(JSON.stringify(response))
                    if(response.resultCode == "200"){
                        var downFileUrl = response.ckbDownFileRnwResDto.downFileUrl;

                        if(downFileUrl != null){
                            var headers = {"mbrId": PGV.loginInfo.mbrId, "p_key" : PGV.loginInfo.pKey};
                            M.net.http.download({
                                url: downFileUrl,
                                header: headers,
                                //directory : "doc://", //ext:외부저장소 doc:내부 app:앱 media:미디어
                                path: "/storage/emulated/0/Download",   // 안드로이드 외부 저장소 저장 설정, 모피어스 API 업데이트 되면 주석 해제 필요
                                finish: function( statusCode, header, fileInfo, status, error ) {
                                    console.log(JSON.stringify(fileInfo));
                                    console.log( status);

                                    if (status == "SUCCESS") {
                                        MPopup.instance("다운로드가 완료되었습니다.");
                                        resolve(fileInfo);
                                    }
                                    else {
                                        MPopup.instance("다운로드에 실패했습니다.");
                                        reject();
                                    }
                                },
                                progress : function(total, current, remaining, percentage) {
                                    console.log(total, current, remaining, percentage);
                                }
                            });

                        }else {
                            MPopup.instance("지출 내역이 없습니다.");
                            reject();
                        }
                    }
                });
            });
        },
    excelDownAndShare: function(){
        return new Promise(function (resolve, reject) {

            // 2024.04.16 다운로드 기간 365일 문구 추가
            var strtDt = $('#datepicker1').val();
            var endDt = $('#datepicker2').val();

            if (dDayDiff(strtDt, endDt) > 365) {
                MPopup.instance("다운로드 기간은 365일을 초과 할 수 없습니다.");
                return reject();
            }

            var sendData = {
                apiId: 'RNW-CKB-2005',
                mbrId: PGV.loginInfo.mbrId,
                vin: MData.global("passData").car.currentScopeSelectCar.vin,
                strtDt: $('#datepicker1').val().replace(/\./g, ""),
                endDt: $('#datepicker2').val().replace(/\./g, ""),
                evYn: MData.global("passData").car.currentScopeSelectCar.memEvYn
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.ckb.downloadExpend,
                sendData : sendData,
                isMock: false
            }).then(function (response) {
console.log(JSON.stringify(response))
                if(response.resultCode == "200"){
                    var downFileUrl = response.ckbDownFileRnwResDto.downFileUrl;

                    if(downFileUrl != null){
                        // 다운로드 방식 변경, POST --> GET + header 추가
                        // 서버에 사용자 검증 프로세스 추가로 header 추가됨.
                        var headers = {"mbrId": PGV.loginInfo.mbrId, "p_key" : PGV.loginInfo.pKey};
                        M.net.http.download({
                            url: downFileUrl,
                            header: headers,
                            //directory : "doc://", //ext:외부저장소 doc:내부 app:앱 media:미디어
                            finish: function( statusCode, header, fileInfo, status, error ) {
                                console.log(JSON.stringify(fileInfo));
                                console.log( status);

                                if (status == "SUCCESS") {
                                    MPopup.instance("다운로드가 완료되었습니다.");
                                    resolve(fileInfo);
                                }
                                else {
                                    MPopup.instance("다운로드에 실패했습니다.");
                                    reject();
                                }
                            },
                            progress : function(total, current, remaining, percentage) {
                                console.log(total, current, remaining, percentage);
                            }
                        });
                    }else {
                        MPopup.instance("지출 내역이 없습니다.");
                        reject();
                    }
                }
            });
        });
    },
    selDatePop: function(result, setting){

        //"{"yyyy":"2021","MM":"03","status":"SUCCESS"}"
        if(result.status == 'SUCCESS')
        {
            //조회월 변경 시, 문구 변경 및 조회월 데이터 조회
            $("#selDate").data("srchDt", result.yyyy+result.MM);
            $("#selDate > b").text(result.yyyy + "년 "+result.MM+"월");

            CurrPage.expendList()
            .then(function(){
                exWNHideIndicator();
            });
        }
    },
    expendList: function(){
        return new Promise(function (resolve) {
            //차계부서비스제공코드 / ALL:전체, 02:주유, 03:정비, 05:기타
            var sendData = {
                apiId: 'RNW-CKB-2002',
                mbrId: PGV.loginInfo.mbrId,
                vin: MData.global('passData').car.currentScopeSelectCar.vin,
                viewMnth: $("#selDate").data('srchDt'),
                svcCd: $("#tabBtn").find('.active').data('svcCd'),
                currentPageNo: 1,
                pageSize: 500
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.ckb.expendList,
                sendData : sendData,
                isMock: false
            }).then(function (response) {
    console.log(JSON.stringify(response))
                //최상단으로
                window.scrollTo(0,0);

                if(response.resultCode == "200")
                {
                    //초기화
                    $("#expendList").html('');

                    if(response.ckbExpendListRnwResDto.length > 0)
                    {
                        //response data를 날짜별 정렬 및 Grouping 후 List set 하기 위함
                        var ckbExpData = response.ckbExpendListRnwResDto;
                        var divCon = $("#dummyDivCon .div-item-cont").clone(true);
                        var data = ckbExpData.sort(function(a,b){
                            return a.rgstDt - b.rgstDt;
                        })
                        .reduce(function(v, x) {
                            //yyymmddhh 로 받아오기 때문에 형식 변경(20220415)
                            x['rgstDt'] = x['rgstDt'].substring(0,8);
                            (v[x['rgstDt']] = v[x['rgstDt']] || []).push(x);
                            return v;
                        }, {});

                       //i = 날짜별
                        for (i in data){
                            var tmpDivCon = divCon.clone(true);
                            var txtDt = moment(i).format("YYYY.MM.DD");
                            var txtDay = changeDate(i.replace(/\-/g, ""));

                            //리스트 초기화
                            $(tmpDivCon).find('li').remove();
                            //날짜,요일 설정
                            $(tmpDivCon).find('.date').text(txtDt + txtDay);

                            //날짜에 해당되는 리스트
                            data[i].forEach(function(item){
                                var tmpLiCon = $(divCon).find('li').clone(true);

                                if(i == item.rgstDt){

                                    $(tmpLiCon).data('seq', item.ckbUnqNo);
                                    $(tmpLiCon).data('svcCd', item.svcCd);
                                    $(tmpLiCon).data('evYn', item.evYn);
                                    $(tmpLiCon).data('svcSmlCd', item.svcSmlCd);
                                    //$(tmpLiCon).find("#svcNm").text(item.svcNm);
                                    $(tmpLiCon).find("#expAmt").text(item.expAmt+"원");

                                    //가맹점명 없을 시, 예외처리
                                    if(isNull(item.firmNm) || item.firmNm == "-"){
                                        $(tmpLiCon).find("#firmNm").closest(".row").remove();
                                    }else{
                                        $(tmpLiCon).find("#firmNm").text(item.firmNm);
                                    }

                                    //서비스코드에 따라 노출 상이
                                    if(item.svcCd == '02'){
                                        if(item.evYn == "Y"){
                                            Number(item.oilnQty) && $(tmpLiCon).find("#oilnQty").text(item.oilnQty+"kWh");
                                            $(tmpLiCon).find("#svcNm").attr('class', 'ico-label-charge');
                                        }else{
                                            Number(item.oilnQty) && $(tmpLiCon).find("#oilnQty").text(item.oilnQty+"L");
                                            $(tmpLiCon).find("#svcNm").attr('class', 'ico-label-refuel');
                                        }
                                    }
                                    else if(item.svcCd == '03'){
                                        $(tmpLiCon).find("#oilnQty").text(item.svcSmlNm);
                                        $(tmpLiCon).find("#svcNm").attr('class', 'ico-label-etc');
                                    }
                                    else if(item.svcCd == '05'){
                                        $(tmpLiCon).find("#oilnQty").text(item.svcSmlNm);
                                        $(tmpLiCon).find("#svcNm").attr('class', 'ico-label-service');
                                    }
                                    else{
                                        $(tmpLiCon).find("#oilnQty").text('');
                                    }

                                    //등록채널코드에 따라 아이콘 상이 && 정유사는 별도페이지
                                    if(item.rgstChnlCd == 'CSMR'){
                                        //고객직접등록
                                        $(tmpLiCon).data('chnlYn', 'N');
                                    }
                                    else if(item.rgstChnlCd == 'CSSM'){
                                        //스미싱등록
                                        $(tmpLiCon).data('chnlCd', 'CSSM');
                                        $(tmpLiCon).find('#icoSms').show();
                                    }
                                    else if(item.rgstChnlCd == 'HDOL' || item.rgstChnlCd == 'SSOL'
                                    || item.rgstChnlCd == 'GSOL' || item.rgstChnlCd == 'STCC' || item.rgstChnlCd == 'FC'){
                                        //정유사 data일 때,
                                        (item.rgstChnlCd == 'HDOL') && $(tmpLiCon).find("#rqstChnl").prop('class', 'ico-hyundaioilbank');
                                        (item.rgstChnlCd == 'SSOL') && $(tmpLiCon).find("#rqstChnl").prop('class', 'ico-soil');
                                        (item.rgstChnlCd == 'GSOL') && $(tmpLiCon).find("#rqstChnl").prop('class', 'ico-gs');
                                        (item.rgstChnlCd == 'STCC') && $(tmpLiCon).find("#rqstChnl").prop('class', 'ico-straffic');
                                        //정비 - AutoQ
                                        (item.rgstChnlCd == 'FC') && $(tmpLiCon).find("#rqstChnl").prop('class', 'ico-autoq');

                                        $(tmpLiCon).find("#rqstChnl").show();
                                        //chnlYn 상세페이지 분기처리하기 위함
                                        $(tmpLiCon).data('chnlYn', 'Y');

                                    }

                                    $(tmpDivCon).find('#liTagList').prepend(tmpLiCon);
                                }
                            })

                            $(tmpDivCon).show();
                            $("#expendList").prepend(tmpDivCon);
                        }
                    }else{
                        var noData =    "<div class='nodata-area'>"
                                    +       "<div class='ico-cont'>"
                                    +           "<i class='ico-nodata-caseExpend'></i>"
                                    +       "</div>"
                                    +       "<p>등록된 지출 내역이 없습니다.</p>"
                                    +   "</div>";

                        $("#expendList").html(noData);
                    }

                    resolve();
                }
            })
        })
    }
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_223_0000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {

        if(MData.param('isRefresh') == 'Y'){
            MData.removeParam('isRefresh');
            //지출 상세 내역 조회
            CurrPage.expendList()
            .then(function(){
                exWNHideIndicator();
            });
        }
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 