/**

@파일명 : KIA_RNW_223_1500.js
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 지출 금액 수정_기타(보험)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_223_1500 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        //event
        CurrPage.setEventListner();

        CurrPage.ckbUnqNo = MData.param('ckbUnqNo');
        //보험 계약정보 조회
        CurrPage.insuList()
        .then(function(){
            exWNHideIndicator();
        });
    }, 
    setEventListner: function(){

        //1. 필수 입력 값에 따른 저장버튼 활성화 여부
        /*$(".required").find('input').on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $("#saveExpBtn").removeClass('disabled');
            }else{
                $("#saveExpBtn").addClass('disabled');
            }
        });*/

        //2. 필수 입력 값에 따른 저장버튼 활성화 여부
        /*$(".required").find('.js-input-clear-btn').on('click', function(e) {
           $("#saveExpBtn").addClass('disabled');
        });*/

        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //삭제
        $("#delExpBtn").on("click", function(){
            CurrPage.showDeleteExpenseEntryDetailPopup();
        });

        //저장
        /*$("#saveExpBtn").on("click", function(){
            CurrPage.saveExpenseEntryDetail();
        });*/

        //메모 keyup
        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    insuList: function(){
        return new Promise(function (resolve) {
            //차계부서비스제공코드 / ALL:전체, 02:주유, 03:정비, 05:기타
            var sendData = {
                apiId: 'RNW-CKB-4004',
                mbrId: PGV.loginInfo.mbrId,
                vin: MData.global('passData').car.currentScopeSelectCar.vin
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.ckb.insuContInfoInq,
                sendData : sendData,
                isMock: false
            }).then(function (response) {

                console.log(JSON.stringify(response))
                if(response.resultCode == "200"){

                    //지출일자
                    var rgstDtTxt = moment(response.insuStrtDt).format("YYYY년 MM월 DD일");

                    $("#rgstDt").val(rgstDtTxt);
                    $("#rgstDt").data('date', response.insuStrtDt);
                    $("#cmpyNm").val(response.cmpyNm);
                    $("#payAmt").val(response.payAmt);
                    $("#payMnth").val(response.payMnth);
                    $("#memo").val(response.memo);
                    $("#txtLength").text(response.memo && response.memo.length || 0);

                    resolve();
                }
            })
        })
    },
    saveExpenseEntryDetail: function(){
        var sendData = {
            apiId: 'RNW-CKB-4005',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            ckbUnqNo: CurrPage.ckbUnqNo,
            rgstDt: $("#rgstDt").data('date'),
            expAmt: comma.remove($("#payAmt").val()),
            memo: $("#memo").val()
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.corrOfMontPrem,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            if(response.resultCode == "200"){
                if(response.updYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            MPage.back({
                                param: {"isRefresh": "Y"}
                            });
                        }
                    });

                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    },
    showDeleteExpenseEntryDetailPopup: function(){

        MPopup.confirm({
            title: "차계부 내역 삭제",
            message: "차계부 내역이 삭제됩니다.\n정말 삭제하시겠습니까?",
            buttons: ["삭제", "취소"],
            callback: function (idx){
                if(idx == 0){
                    //삭제
                    CurrPage.deleteExpenseEntryDetail();
                }
            }
        });
    },
    deleteExpenseEntryDetail: function(obj){

        var sendData = {
            apiId: 'RNW-CKB-2003',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            ckbUnqNo: CurrPage.ckbUnqNo
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.deleteExpend,
            sendData: sendData,
            isMock: false
        }).then(function (response) {

            if(response.resultCode == "200"){
                if(response.ckbDelExpRnwResDto.delYn == 'Y'){
                    MPopup.instance("삭제가 완료되었습니다.");

                    MPage.back({
                        param: {"isRefresh": "Y"}
                    });

                }else{
                    MPopup.instance("삭제 실패 했습니다.");
                }
            }
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_223_1500.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 


