/**

@파일명 : KIA_RNW_223_3300.js
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 지출 금액 자동 입력 수정_정비
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_223_3300 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //특수문자 입력하지 못하게 하기 위함.
        COMMON_FUNCTION.TOOL.UI.handleNumberOnlyInput();

        //event
        CurrPage.setEventListner();

        CurrPage.ckbUnqNo = MData.param('ckbUnqNo');
        //차계부내역 조회
        CurrPage.expendList()
        .then(function(){
            exWNHideIndicator();
        });
    }, 
    setEventListner: function(){

        $("#delExpBtn").on("click", function(){
            CurrPage.showDeleteExpenseEntryDetailPopup();
        });

        $("#saveExpBtn").on("click", function(){
            CurrPage.saveExpenseEntryDetail();
        });

        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    expendList: function(){
        return new Promise(function (resolve) {
            //차계부서비스제공코드 / ALL:전체, 02:주유, 03:정비, 05:기타
            var sendData = {
                apiId: 'RNW-CKB-2002',
                mbrId: PGV.loginInfo.mbrId,
                vin: MData.global('passData').car.currentScopeSelectCar.vin,
                svcCd: 'ALL',
                viewMnth: MData.param('viewMnth'),
                currentPageNo: 1,
                pageSize: 10,
                ckbUnqNo: CurrPage.ckbUnqNo
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.ckb.expendList,
                sendData : sendData,
                isMock: false
            }).then(function (response) {
                console.log(JSON.stringify(response))
                if(response.resultCode == "200"){
                    if(response.ckbExpendListRnwResDto.length > 0){
                        //월별 지출 상세내역 단건
                        var ckbData = response.ckbExpendListRnwResDto[0];

                        //오토큐 상단 타이틀 우측 아이콘
                        (ckbData.rgstChnlCd == 'FC') && $("#oilIcon").prop('class', 'ico-autoq');

                        //지출일자
                        var rgstDtTxt = moment(ckbData.rgstDt).format("YYYY년 MM월 DD일");

                        //화면에 그릴
                        $("#rgstDt").text(rgstDtTxt);
                        $("#rgstDt").data('date', ckbData.rgstDt);
                        $("#firmNm").text(ckbData.firmNm);
                        $("#trvgDist").val(ckbData.trvgDist);
                        $("#svcMidNm").text(ckbData.svcMidNm);
                        $("#svcSmlNm").text(ckbData.svcSmlNm);
                        $("#expAmt").text(ckbData.expAmt+"원");
                        $("#memo").val(ckbData.memo);
                        $("#txtLength").text(ckbData.memo && ckbData.memo.length || 0);

                        //save action data
                        $("#svcMidNm").data('midCd', ckbData.svcMidCd);
                        $("#svcSmlNm").data('smlCd', ckbData.svcSmlCd);
                        $("#expAmt").data('expAmt', ckbData.expAmt);
                    }

                    resolve();
                }
            })
        })
    },
    saveExpenseEntryDetail: function(){
        var sendData = {
            apiId: 'RNW-CKB-4002',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            ckbUnqNo: CurrPage.ckbUnqNo,
            rgstDt: $("#rgstDt").data('date'),
            firmNm: $("#firmNm").text(),
            trvgDist: $("#trvgDist").val(),
            memo: $("#memo").val(),
            svcMidCd: $("#svcMidNm").data('midCd'),
            svcSmlCd: $("#svcSmlNm").data('smlCd'),
            expAmt: $("#expAmt").data('expAmt')
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.mainBookUpdate,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            if(response.resultCode == "200"){
                if(response.updYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            MPage.back({
                                param: {"isRefresh": "Y"}
                            });
                        }
                    });

                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    },
    showDeleteExpenseEntryDetailPopup: function(){

        MPopup.confirm({
            title: "차계부 내역 삭제",
            message: "차계부 내역이 삭제됩니다.\n정말 삭제하시겠습니까?",
            buttons: ["삭제", "취소"],
            callback: function (idx){
                if(idx == 0){
                    //삭제
                    CurrPage.deleteExpenseEntryDetail();
                }
            }
        });
    },
    deleteExpenseEntryDetail: function(obj){

        var sendData = {
            apiId: 'RNW-CKB-2003',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            ckbUnqNo: CurrPage.ckbUnqNo
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.deleteExpend,
            sendData: sendData,
            isMock: false
        }).then(function (response) {

            if(response.resultCode == "200"){
                if(response.ckbDelExpRnwResDto.delYn == 'Y'){
                    MPopup.instance("삭제가 완료되었습니다.");

                    MPage.back({
                        param: {"isRefresh": "Y"}
                    });

                }else{
                    MPopup.instance("삭제 실패 했습니다.");
                }
            }
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_223_3300.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 


