/**

@파일명 : KIA_RNW_223_3400.js
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 지출 금액 자동 입력 수정_주유(스미싱)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_223_3400 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //특수문자 입력하지 못하게 하기 위함.
        COMMON_FUNCTION.TOOL.UI.handleNumberOnlyInput();


        //지출 대상 차량 정보(노출 여부 및 event 적용)
        CurrPage.expTargetCarList();

        //event
        CurrPage.setEventListner();

        CurrPage.ckbUnqNo = MData.param('ckbUnqNo');
        //차계부내역 조회
        CurrPage.expendList()
        .then(function(){
            exWNHideIndicator();
        });
    }, 
    setEventListner: function(){

        //1. 필수 입력 값에 따른 저장버튼 활성화 여부
        /*$(".required").find('input').on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $("#saveExpBtn").removeClass('disabled');
            }else{
                $("#saveExpBtn").addClass('disabled');
            }
        });*/

        //2. 필수 입력 값에 따른 저장버튼 활성화 여부
        /*$(".required").find('.js-input-clear-btn').on('click', function(e) {
           $("#saveExpBtn").addClass('disabled');
        });*/


        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //주유량+충전량 정수형 자리수는 8자리 제한, 소수점은 2자리까지
        $("#oilnQty").on("propertychange change keyup paste input", function(){

            var oilnQty = $(this).val().replace(",","");
            var arrData = oilnQty.split(".");

            if(arrData[0] && arrData[0].length > 5){
                $("#oilnQty").val(CurrPage.oilnQty);
                return;
            }
            if(arrData[1] && arrData[1].length > 2){
                $("#oilnQty").val(CurrPage.oilnQty);
                return;
            }

            CurrPage.oilnQty = oilnQty;
        });

        $("#delExpBtn").on("click", function(){
            CurrPage.showDeleteExpenseEntryDetailPopup();
        });

        $("#saveExpBtn").on("click", function(){
            CurrPage.saveExpenseEntryDetail();
        });

        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    expTargetCarList: function(){

        //내연기관 차량 2대이상일 때,
        var carListHtml = "";
        var passData = MData.global("passData");
        var carList = passData.car.myCarInfoListResDto;

        //메인에서 선택된 차량 디폴트
        //var curCarNickname = passData.car.selectCar.carAlias || "";
        /*var curCarModelName = passData.car.selectCar.mdlNm || "";
        var curCarNumber = passData.car.selectCar.carRgstNo;
        $("#carRgstNo").val(curCarModelName + " " + curCarNumber);*/
        $("#carRgstNo").data('vin', passData.car.currentScopeSelectCar.vin);

        //내연 보유 차량 카운트
        var targetCnt = 0;

        carList.forEach(function(item){
            if(item.memEvYn == 'N' && item.vin){

                ++targetCnt;
                //var curCarNickname = item.carAlias || "";
                var curCarModelName = item.mdlNm || "";
                var curCarNumber = item.carRgstNo;

                carListHtml += "<li><button type='button' class='btn-link' data-vin='" + item.vin + "'>";
                carListHtml += curCarModelName + " " + curCarNumber;
                carListHtml += "</button></li>";
            }
        });

        if(targetCnt > 1){
            //내연기관 차량data 담을 팝업
            $("#popup_0E0_0000 .select-list").html(carListHtml);

            //팝업 선택 evt
            $("#popup_0E0_0000 .select-list li").on("click", function(){

                var carRgstNo = $(this).find('button').text();
                var vin = $(this).find('button').data('vin');

                $("#carRgstNo").val(carRgstNo);
                $("#carRgstNo").data('vin', vin);

                //팝업닫기
                $("#popup_0E0_0000").fadeOut('fast');
                $("#popup_0E0_0000").find('.popup-wrap').removeClass('is-ani');
                $('body').removeClass('js-overflow-hidden');
            });

            $("#expTargetCar").show();
        }
    },
    expendList: function(){
        return new Promise(function (resolve) {
            //차계부서비스제공코드 / ALL:전체, 02:주유, 03:정비, 05:기타
            var sendData = {
                apiId: 'RNW-CKB-2002',
                mbrId: PGV.loginInfo.mbrId,
                vin: $("#carRgstNo").data('vin'),
                svcCd: 'ALL',
                viewMnth: MData.param('viewMnth'),
                currentPageNo: 1,
                pageSize: 10,
                ckbUnqNo: CurrPage.ckbUnqNo
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.ckb.expendList,
                sendData : sendData,
                isMock: false
            }).then(function (response) {
                if(response.resultCode == "200"){
                    if(response.ckbExpendListRnwResDto.length > 0){

                        //월별 지출 상세내역 단건
                        var ckbData = response.ckbExpendListRnwResDto[0];

                        //지출일자
                        var rgstDtTxt = moment(ckbData.rgstDt).format("YYYY년 MM월 DD일");

                        //화면에 그릴
                        $("#rgstDt").text(rgstDtTxt);
                        $("#firmNm").val(ckbData.firmNm);
                        $("#expAmt").text(ckbData.expAmt);
                        $("#litrAmt").val(ckbData.litrAmt);
                        $("#oilnQty").val(ckbData.oilnQty);
                        $("#trvgDist").val(comma.add(ckbData.trvgDist));
                        $("#memo").val(ckbData.memo);
                        $("#txtLength").text(ckbData.memo && ckbData.memo.length || 0);

                        var carModelName = MData.global('passData').car.myCarInfoListResDto.filter(function(el){return (el.vin == ckbData.vin)})[0].mdlNm;
                        var rgstCarNo = MData.global('passData').car.myCarInfoListResDto.filter(function(el){return (el.vin == ckbData.vin)})[0].carRgstNo;
                        $("#carRgstNo").val(carModelName + " " + rgstCarNo);

                        //save action data
                        $("#rgstDt").data('date', ckbData.rgstDt);
                        $("#expAmt").data('expAmt', ckbData.expAmt);
                        $("#carRgstNo").data('vin', ckbData.vin);
                    }

                    resolve();
                }
            })
        })
    },
    saveExpenseEntryDetail: function(){

        var sendData = {
            apiId: 'RNW-CKB-2004',
            mbrId: PGV.loginInfo.mbrId,
            vin: $("#carRgstNo").data('vin'),
            ckbUnqNo: CurrPage.ckbUnqNo,
            rgstDt: $("#rgstDt").data('date'),
            expAmt: $("#expAmt").data('expAmt'),
            trvgDist: comma.remove($("#trvgDist").val()),
            oilnQty: $("#oilnQty").val(),
            litrAmt: comma.remove($("#litrAmt").val()),
            firmNm: $("#firmNm").val(),
            memo: $("#memo").val()
        };

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.updateExpend,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            if(response.resultCode == "200"){
                if(response.ckbUpdExpRnwResDto.updYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            MPage.back({
                                param: {"isRefresh": "Y"}
                            });
                        }
                    });

                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    },
    showDeleteExpenseEntryDetailPopup: function(){

        MPopup.confirm({
            title: "차계부 내역 삭제",
            message: "차계부 내역이 삭제됩니다.\n정말 삭제하시겠습니까?",
            buttons: ["삭제", "취소"],
            callback: function (idx){
                if(idx == 0){
                    //삭제
                    CurrPage.deleteExpenseEntryDetail();
                }
            }
        });
    },
    deleteExpenseEntryDetail: function(obj){

        var sendData = {
            apiId: 'RNW-CKB-2003',
            mbrId: PGV.loginInfo.mbrId,
            vin: $("#carRgstNo").data('vin'),
            ckbUnqNo: CurrPage.ckbUnqNo
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.deleteExpend,
            sendData: sendData,
            isMock: false
        }).then(function (response) {

            if(response.resultCode == "200"){
                if(response.ckbDelExpRnwResDto.delYn == 'Y'){
                    MPopup.instance("삭제가 완료되었습니다.");

                    MPage.back({
                        param: {"isRefresh": "Y"}
                    });

                }else{
                    MPopup.instance("삭제 실패 했습니다.");
                }
            }
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_223_3400.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 


