/**

@파일명 : KIA_RNW_224_2300.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 지출 금액 입력(정비)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_224_2300 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        //키패드 함수
        CurrPage.fnSetKeypad();
        CurrPage.setEventListner();
    }, 
    setEventListner: function(){

        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //체크박스 클릭 evt
        var $chkFormItem = $('.js-chk-form-item');
        $chkFormItem.each(function(idx, item) {
            $(item).find('input[type="checkbox"]').on('click', function(e) {
                //체크된 개수
                var chkboxCnt = $('.repair-list-cont').find('input[type="checkbox"]:checked').length;

                if ($(this).is(':checked')) {
                    $(this).closest('dt').next('dd').show();
                }
                else {
                    $(this).closest('dt').next('dd').hide();
                }
                //다음버튼 활성화 여부 판단
                CurrPage.nextBtnChk();

                //중분류코드 카운트
                CurrPage.expChkListCnt();
            });
        });

        //금액 입력 이벤트
        $(".chk-form-cont").find('input[type=text]').on("propertychange change keyup paste input", function(){
            //다음버튼 활성화 여부 판단
            CurrPage.nextBtnChk();
        });

        //금액 입력 삭제버튼
        $(".chk-form-cont").find('.js-input-clear-btn').on('click', function(e) {
           //다음버튼 활성화 여부 판단
           CurrPage.nextBtnChk();
        });


        //다음 버튼 이벤트
        $("#nextBtn").on("click",function(){
            //다음 페이지로 넘어가기 위한 data 준비
            CurrPage.nextDataInit();
        });
    },
    fnSetKeypad: function() {
        //$('.keypad-cont').hide();

        $(document).click(function(e){
            if (!$(e.target).is('.js-keypadInput, .inlineKeypad button, .keypad-cont button, .btn-input-clear')) {
                $('.keypad-cont').hide();
                $('.chk-form-cont').removeClass('open-keypad');
            }else{
                $('.keypad-cont').show();
                $('.chk-form-cont').addClass('open-keypad');
            }
        });

        var thisInput;
        $('.js-chk-form-item').each(function(idx, item) {

            $(item).focusin(function() {
                thisInput = $(this).find('.js-keypadInput');
                var thisIdx = idx;
                var thisInputDataNum = $(this).find('.js-keypadInput').attr('data-num');
                thisInputDataNum = parseInt(thisInputDataNum, 10);

                console.log('thisIdx', thisIdx)
                console.log('thisInputDataNum', thisInputDataNum)

                $(this).addClass('active');

                if ($(this).hasClass('active')) {
                    $('html, body').stop().animate({scrollTop:$(this).offset().top - 100}, 300, 'swing');
                }

                if (thisIdx === thisInputDataNum) {
                    $('.inlineKeypad-area').html('');
                    $('.inlineKeypad-area').html('<div id="inlineKeypad'+thisIdx+'" class="inlineKeypad"></div>');

                    $('.inlineKeypad').keypad({
                        target: $(this).find('.js-keypadInput'),
                        keypadOnly:true,
                        layout: [
                            '1|2|3',
                            '4|5|6',
                            '7|8|9',
                            '000|0|'+ $.keypad.BACK
                        ],
                        onKeypress: fnChooseState, separator:'|',
                        beforeShow: function(div, inst) {
                            $('.keypad-back').click(function() {
                                console.log($(thisInput).val());

                                if ($(thisInput).val()) {
                                    $(thisInput).closest('.input-cont').removeClass('js-input-focus--active');
                                    $(thisInput).closest('.input-cont').removeClass('js-input-clear--active');

                                    CurrPage.nextBtnChk();
                                }
                                else {
                                    $("#nextBtn").addClass('disabled');
                                    $(thisInput).closest('.input-cont').addClass('js-input-focus--active');
                                    $(thisInput).val() && $(thisInput).closest('.input-cont').addClass('js-input-clear--active');
                                }
                            })
                        }
                    });
                }

            }).focusout(function() {
                $(this).removeClass('active');
            });

            function fnChooseState(key){

                //천단위 콤마 찍기 위함
                $(this).val(comma.add($(this).val()));

                if (!key) {
                    $("#nextBtn").addClass('disabled');
                    $(this).closest('.input-cont').removeClass('js-input-focus--active');
                    $(this).closest('.input-cont').removeClass('js-input-clear--active');
                }
                else {

                    $(this).val() && $(this).closest('.input-cont').addClass('js-input-focus--active');
                    $(this).val() && $(this).closest('.input-cont').addClass('js-input-clear--active');

                    CurrPage.nextBtnChk();
                }
            }
        });

        //키패드 상단의 퀵버튼 이벤트
        $("#quickBtn button").on("click", function(){

            var sumAmt = 0;
            var plusAmt = $(this).data('amt');
            var expAmt = Number(comma.remove($(thisInput).val()));

            //초기화 여부
            if(plusAmt == 0){
                sumAmt = '';
                $("#nextBtn").addClass('disabled');
            }else{
                //현재값 여부
                if(expAmt){

                    sumAmt = expAmt + plusAmt;

                    //최대자리수 넘길 시, 토스트팝업 노출하기 위함(2022-05-16)
                    var sumAmtLength = comma.add(sumAmt).length;
                    var amtMaxLength = Number($(thisInput).attr('maxLength'));

                    if(sumAmtLength > amtMaxLength){
                        MPopup.instance("금액이 너무 많습니다.");

                        return false;
                    }
                }else{
                    sumAmt = plusAmt;
                }
                $("#nextBtn").removeClass('disabled');
            }

            $(thisInput).val(comma.add(sumAmt));
        })
    },
    expChkListCnt: function(){
        //일반정비
        var repairCnt = $("#repairCon").find('input[type="checkbox"]:checked').length;
        //소모품
        var expCnt = $("#expCon").find('input[type="checkbox"]:checked').length;

        if(repairCnt > 0){
            $("#repairCon").find('.num').html("<b class='c-font-brand-point'>"+ repairCnt +"</b>");
        }else{
            $("#repairCon").find('.num').html("<b>0</b>");
        }

        if(expCnt > 0){
            $("#expCon").find('.num').html("<b class='c-font-brand-point'>"+ expCnt +"</b>");
        }else{
            $("#expCon").find('.num').html("<b>0</b>");
        }
    },
    nextBtnChk: function(){
        //다음버튼 활성화 여부
        //체크된 박스 개수
        var chkCnt = $(".chk-form-cont").find('input[type="checkbox"]:checked').length;
        var chkTxtCnt = 0;

        $(".chk-form-cont").find('input[type="checkbox"]:checked').each(function() {
            if($(this).closest('dl').find('dd').find('input[type=text]').val()){
                chkTxtCnt += 1;
            }
        })

        //체크된 박스 개수와 하위 금액을 입력한 개수 비교
        if(chkCnt && chkCnt == chkTxtCnt){
            $("#nextBtn").removeClass('disabled');
        }else{
            $("#nextBtn").addClass('disabled');
        }
    },
    nextDataInit: function(){

        //일반정비
        var arrRepair = [];
        //소모품
        var arrExp = [];
        //사용자지정소모품
        var arrCustomExp = [];
        //총 개수
        var chkboxCnt = $('.chk-form-cont').find('input[type="checkbox"]:checked').length;

        //일반정비 (코드명 + 금액)
        $("#repairCon").find('input[type="checkbox"]:checked').each(function(idx, item) {
            var svcSmlCd = $(this).val();
            var svcSmlNm = $(this).closest('dl').find('dt').find('span').text();
            var expAmt = $(this).closest('dl').find('dd').find('input[type=text]').val();

            arrRepair.push({svcMidCd: '00', svcSmlCd: svcSmlCd, svcSmlNm: svcSmlNm, expAmt: expAmt});
        });

        //소모품 (코드명 + 금액)
        $("#expCon").find('input[type="checkbox"]:checked').each(function(idx, item) {
            var svcSmlCd = $(this).val();
            var svcSmlNm = $(this).closest('dl').find('dt').find('span').text();
            var expAmt = $(this).closest('dl').find('dd').find('input[type=text]').val();

            arrExp.push({svcMidCd: '01', svcSmlCd: svcSmlCd, svcSmlNm: svcSmlNm, expAmt: expAmt});
        });

        //사용자지정소모품 (코드명 + 금액)
        $("#customExpCon").find('input[type="checkbox"]:checked').each(function(idx, item) {
            var svcSmlCd = $(this).val();
            var svcSmlNm = $(this).closest('dl').find('dt').find('span').text();
            var expAmt = $(this).closest('dl').find('dd').find('input[type=text]').val();

            arrCustomExp.push({svcMidCd: '07', svcSmlCd: svcSmlCd, svcSmlNm: svcSmlNm, expAmt: expAmt});
        });

        //버튼 활성화 및 입력값 여부 판단 후, 다음 페이지 진입
        if(!$(this).hasClass('disabled') && chkboxCnt > 0){
            var options = {
                url: PATH_MANAGER.KIA_RNW_224_3300.path,
                param: {
                    arrRepair : arrRepair,
                    arrExp : arrExp,
                    arrCustomExp : arrCustomExp,
                }
            };

            MPage.html(options);
        }
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_224_2300.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
