/**

@파일명 : KIA_RNW_224_2400.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 지출 금액 입력_기타(일반)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_224_2400 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        //키패드 함수
        CurrPage.fnSetKeypad();
        CurrPage.setEventListner();
    }, 
    setEventListner: function(){

        //입력창or키패드 버튼 외 클릭 시 키패드 숨김(2022-04-19)
        $(document).click(function(e){
            if (!$(e.target).is('.js-keypadInput-01, .keypad-cont button, .btn-input-clear')) {
                $('.keypad-cont').hide();
            }else{
                $('.keypad-cont').show();
            }
        });

        //서브타이틀명
        $("#svcSmlNm").text(MData.param('svcSmlNm'));

        //키패드 상단의 퀵버튼 이벤트
        $("#quickBtn button").on("click", function(){

            var sumAmt = 0;
            var plusAmt = $(this).data('amt');
            var expAmt = Number(comma.remove($("#expAmt").val()));

            //초기화 여부
            if(plusAmt == 0){
                sumAmt = '';
                $("#nextBtn").addClass('disabled');
            }else{
                //현재값 여부
                if(expAmt){
                    sumAmt = expAmt + plusAmt;

                    //최대자리수 넘길 시, 토스트팝업 노출하기 위함(2022-05-16)
                    var sumAmtLength = comma.add(sumAmt).length;
                    var amtMaxLength = Number($("#expAmt").attr('maxLength'));

                    if(sumAmtLength > amtMaxLength){
                        MPopup.instance("금액이 너무 많습니다.");

                        return false;
                    }

                }else{
                    sumAmt = plusAmt;
                }
                $("#nextBtn").removeClass('disabled');
            }
            $("#expAmt").val(comma.add(sumAmt));
        })



        //다음 버튼 이벤트
        $("#nextBtn").on("click",function(){
            //금액 입력 여부 판단하기 위함
            var expAmt = $('#expAmt').val();

            //버튼 활성화 및 입력값 여부 판단 후, 다음 페이지 진입
            if(!$(this).hasClass('disabled') && expAmt){
                var options = {
                    url: PATH_MANAGER.KIA_RNW_224_3400.path,
                    param: {
                        expAmt : expAmt,
                        svcSmlNm : MData.param('svcSmlNm'),
                        svcSmlCd : MData.param('svcSmlCd')
                    }
                };
                MPage.html(options);
            }
        })

        //클리어버튼 evt
        $('.js-input-clear-btn').on('click', function(e) {
           $("#nextBtn").addClass('disabled');
        });
    },
    fnSetKeypad: function() {
        $('#inlineKeypad01').keypad({
            target: $('#expAmt'),
            keypadOnly:true,
            layout: [
                '1|2|3',
                '4|5|6',
                '7|8|9',
                '000|0|'+ $.keypad.BACK
            ],
            onKeypress: CurrPage.fnChooseState, separator:'|',
            beforeShow: function(div, inst) {
                $('.keypad-back').click(function() {

                    if ($('#expAmt').val()) {
                        $("#nextBtn").removeClass('disabled');
                        $('.js-keypadInput-01').closest('.input-cont').removeClass('js-input-focus--active');
                        $('.js-keypadInput-01').closest('.input-cont').removeClass('js-input-clear--active');
                    }
                    else {
                        $("#nextBtn").addClass('disabled');
                        $('.js-keypadInput-01').closest('.input-cont').addClass('js-input-focus--active');
                        $('#expAmt').val() && $('.js-keypadInput-01').closest('.input-cont').addClass('js-input-clear--active');
                    }
                })
            }
        });
    },
    fnChooseState: function(key) {

        //천단위 콤마 찍기 위함
        $("#expAmt").val(comma.add($("#expAmt").val()));

        if (!key) {
            $("#nextBtn").addClass('disabled');
            $(this).closest('.input-cont').removeClass('js-input-focus--active');
            $(this).closest('.input-cont').removeClass('js-input-clear--active');
        }
        else {
            $("#expAmt").val() && $("#nextBtn").removeClass('disabled');
            $("#expAmt").val() && $(this).closest('.input-cont').addClass('js-input-focus--active');
            $("#expAmt").val() && $(this).closest('.input-cont').addClass('js-input-clear--active');
        }
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_224_2400.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
