/**

@파일명 : KIA_RNW_224_2600.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 지출 금액 입력_기타(할부)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_224_2600 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        //키패드 함수
        CurrPage.fnSetKeypad();
        CurrPage.setEventListner();
    }, 
    setEventListner: function(){

        //입력창or키패드 버튼 외 클릭 시 키패드 숨김(2022-04-19)
        $(document).click(function(e){
            if (!$(e.target).is('.js-keypadInput-01, .js-keypadInput-02, .keypad-cont button, .btn-input-clear')) {
                $('#keypadCont01').hide();
                $('#keypadCont02').hide();
            }
        });

        // 키패드 변경
        $('.js-keypadInput-01').mouseenter(function(e) {
            $('#keypadCont02').hide();
            $('#keypadCont01').show();
        });
        $('.js-keypadInput-02').mouseenter(function(e) {
            $('#keypadCont01').hide();
            $('#keypadCont02').show();
        });


        //키패드 상단의 퀵버튼 이벤트(보험료)
        $("#quickBtn button").on("click", function(){

            var sumAmt = 0;
            var plusAmt = $(this).data('amt');
            var istmMnthAmt = Number(comma.remove($("#istmMnthAmt").val()));

            //초기화 여부
            if(plusAmt == 0){
                sumAmt = '';
                $("#nextBtn").addClass('disabled');
            }else{
                //현재 보험료 여부
                if(istmMnthAmt){
                    sumAmt = istmMnthAmt + plusAmt;

                    //최대자리수 넘길 시, 토스트팝업 노출하기 위함(2022-05-16)
                    var sumAmtLength = comma.add(sumAmt).length;
                    var amtMaxLength = Number($("#istmMnthAmt").attr('maxLength'));

                    if(sumAmtLength > amtMaxLength){
                        MPopup.instance("금액이 너무 많습니다.");

                        return false;
                    }
                }else{
                    sumAmt = plusAmt;
                }
                $("#nextBtn").removeClass('disabled');
            }
            $("#istmMnthAmt").val(comma.add(sumAmt));
        });

        //키패드 상단의 퀵버튼 이벤트(할부개월)
        $("#quickBtnMnth button").on("click", function(){

            var sumMnth = 0;
            var plusMnth = $(this).data('mnth');
            var istmMnthCnt = parseInt($("#istmMnthCnt").val());

            //초기화 여부
            if(plusMnth == 0){
                sumMnth = '';
                $("#nextBtn").addClass('disabled');
            }else{
                //현재값 여부
                if(istmMnthCnt){
                    sumMnth = istmMnthCnt + plusMnth;

                    //최대자리수 넘길 시, 토스트팝업 노출하기 위함(2022-05-16)
                    var sumMnthLength = sumMnth.toString().length;
                    var mnthMaxLength = Number($("#istmMnthCnt").attr('maxLength'));

                    if(sumMnthLength > mnthMaxLength){
                        MPopup.instance("할부 개월 수가 너무 많습니다.");

                        return false;
                    }
                }else{
                    sumMnth = plusMnth;
                }

                if($("#istmMnthAmt").val() != ""){
                    $("#nextBtn").removeClass('disabled');
                }
            }
            $("#istmMnthCnt").val(sumMnth);
        })

        //다음 버튼 이벤트
        $("#nextBtn").on("click",function(){
            //금액 입력 여부 판단하기 위함
            var istmMnthAmt = $("#istmMnthAmt").val();
            var istmMnthCnt = $("#istmMnthCnt").val();


            //버튼 활성화 및 입력값 여부 판단 후, 다음 페이지 진입
            if(!$(this).hasClass('disabled') && istmMnthAmt != "" && istmMnthCnt != ""){
                var options = {
                    url: PATH_MANAGER.KIA_RNW_224_3600.path,
                    param: {
                        istmMnthAmt : istmMnthAmt,
                        istmMnthCnt : istmMnthCnt
                    }
                };
                MPage.html(options);
            }
        })

        //클리어버튼 evt
        $('.js-input-clear-btn').on('click', function(e) {
           $("#nextBtn").addClass('disabled');
           $(this).prev('input').mouseenter();
        });
    },
    fnSetKeypad: function() {

        $('#inlineKeypad01').keypad({
            target: $('#istmMnthAmt'),
            keypadOnly:true,
            layout: [
                '1|2|3',
                '4|5|6',
                '7|8|9',
                '000|0|'+ $.keypad.BACK
            ],
            onKeypress: CurrPage.fnChooseStateOne, separator:'|',
            beforeShow: function(div, inst) {
                $('#inlineKeypad01 .keypad-back').click(function() {

                    if ($('#istmMnthAmt').val()) {
                        $("#nextBtn").removeClass('disabled');
                        $('.js-keypadInput-01').closest('.input-cont').removeClass('js-input-focus--active');
                        $('.js-keypadInput-01').closest('.input-cont').removeClass('js-input-clear--active');
                    }
                    else {
                        $("#nextBtn").addClass('disabled');
                        $('.js-keypadInput-01').closest('.input-cont').addClass('js-input-focus--active');
                        $('#istmMnthAmt').val() && $('.js-keypadInput-01').closest('.input-cont').addClass('js-input-clear--active');
                    }
                })
            }
        });

        $('#inlineKeypad02').keypad({
            target: $('#istmMnthCnt'),
            keypadOnly:true,
            layout: [
                '1|2|3',
                '4|5|6',
                '7|8|9',
                '000|0|'+ $.keypad.BACK
            ],
            onKeypress: CurrPage.fnChooseStateTwo, separator:'|',
            beforeShow: function(div, inst) {
                $('#inlineKeypad02 .keypad-back').click(function() {

                    if ($('#istmMnthAmt').val() != "" && $('#istmMnthCnt').val() != "") {
                        $("#nextBtn").removeClass('disabled');
                        $('.js-keypadInput-02').closest('.input-cont').removeClass('js-input-focus--active');
                        $('.js-keypadInput-02').closest('.input-cont').removeClass('js-input-clear--active');
                    }
                    else {
                        $("#nextBtn").addClass('disabled');
                        $('.js-keypadInput-02').closest('.input-cont').addClass('js-input-focus--active');
                        $('#istmMnthCnt').val() && $('.js-keypadInput-02').closest('.input-cont').addClass('js-input-clear--active');
                    }
                })
            }
        });
    },
    fnChooseStateOne: function(key) {

        //천단위 콤마 찍기 위함
        $("#istmMnthAmt").val(comma.add($("#istmMnthAmt").val()));

        if (!key) {
            $("#nextBtn").addClass('disabled');
            $(this).closest('.input-cont').removeClass('js-input-focus--active');
            $(this).closest('.input-cont').removeClass('js-input-clear--active');
        }
        else {
            $('#istmMnthAmt').val() && $(this).closest('.input-cont').addClass('js-input-focus--active');
            $('#istmMnthAmt').val() && $(this).closest('.input-cont').addClass('js-input-clear--active');

            CurrPage.nextBtnChk();
        }
    },
    fnChooseStateTwo: function(key) {

        $("#istmMnthCnt").val(comma.add($("#istmMnthCnt").val()));

        if (!key) {
            $("#nextBtn").addClass('disabled');
            $(this).closest('.input-cont').removeClass('js-input-focus--active');
            $(this).closest('.input-cont').removeClass('js-input-clear--active');
        }
        else {
            $('#istmMnthCnt').val() && $(this).closest('.input-cont').addClass('js-input-focus--active');
            $('#istmMnthCnt').val() && $(this).closest('.input-cont').addClass('js-input-clear--active');

            CurrPage.nextBtnChk();
        }
    },
    nextBtnChk: function(){
        //다음버튼 활성화 여부 판단
        var istmMnthAmt = $("#istmMnthAmt").val();
        var istmMnthCnt = $("#istmMnthCnt").val();

        if(istmMnthAmt != "" && istmMnthCnt != ""){
            $("#nextBtn").removeClass('disabled');
        }else{
            $("#nextBtn").addClass('disabled');
        }
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_224_2600.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
