/**

@파일명 : KIA_RNW_224_3100.js
@작성자 :
@생성일 : 2022.01.26
@메뉴명 : 지출 금액 입력 상세(주유)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O]
*/
var CurrPage;
var KIA_RNW_224_3100 ={
    init: function(){
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //특수문자 입력하지 못하게 하기 위함.
        COMMON_FUNCTION.TOOL.UI.handleNumberOnlyInput();

        //event
        CurrPage.setEventListner();

        //누적주행거리 조회 추가(2022-05-03)
        //CCS연동 차량은 datahub 누적주행거리 노출하기 위함.(2022-05-26)
        var myCarMngInfo = MData.global('myCarMngInfo');
        if(myCarMngInfo && (myCarMngInfo.isMaster == "Y")){
            $("#trvgDist").val(comma.add(myCarMngInfo.trvgDist));
        }else{
            CurrPage.distInfo()
            .then(function(){
                exWNHideIndicator();
            });
        }
    },
    setEventListner: function(){

        //1. 필수 입력 값에 따른 저장버튼 활성화 여부
        $(".required").find('input').on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $("#saveExpBtn").removeClass('disabled');
            }else{
                $("#saveExpBtn").addClass('disabled');
            }
        });

        //2. 필수 입력 값에 따른 저장버튼 활성화 여부
        $(".required").find('.js-input-clear-btn').on('click', function(e) {
           $("#saveExpBtn").addClass('disabled');
        });

        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //주유량+충전량 정수형 자리수는 8자리 제한, 소수점은 2자리까지
        $("#oilnQty").on("propertychange change keyup paste input", function(){

            var oilnQty = $(this).val().replace(",","");
            var arrData = oilnQty.split(".");

            if(arrData[0] && arrData[0].length > 5){
                $("#oilnQty").val(CurrPage.oilnQty);
                return;
            }
            if(arrData[1] && arrData[1].length > 2){
                $("#oilnQty").val(CurrPage.oilnQty);
                return;
            }

            CurrPage.oilnQty = oilnQty;
        });

        //날짜 default: 오늘
        var nowTime = moment();
        $("#rgstDt").data('date', nowTime.format('YYYYMMDDHH'));
        $("#rgstDt").val(nowTime.format("YYYY년 MM월 DD일"));

        //지출금액(이전 페이지 입력 금액 표시)
        $("#expAmt").val(M.data.param('expAmt'));

        //주유량 자동 계산 (지출금액/주유단가)
        $("#litrAmt, #expAmt").on("keyup", function(){
            var expAmt = comma.remove($("#expAmt").val());
            var litrAmt = comma.remove($("#litrAmt").val());
            var oilnQty = (expAmt && litrAmt) && (expAmt / litrAmt).toFixed(1) || 0;

            $("#oilnQty").val(oilnQty);
        });

        //취소
        $("#cancleBtn").on("click", function(){
            //20220415 차계부 홈으로 돌아가서 새로고침하기 위함
            garbageAll();
            MPage.back({param: {"isRefresh": "Y"}});
        });

        //저장
        $("#saveExpBtn").on("click", function(){
            CurrPage.saveExpenseEntryDetail();
        });

        //메모 keyup
        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    distInfo: function () {
        return new Promise(function (resolve) {
            //누적주행거리 조회
            var sendData = {
                apiId: 'RNW-CKB-1001',
                mbrId: PGV.loginInfo.mbrId,
                vin: MData.global('passData').car.currentScopeSelectCar.vin
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.car.distInfo,
                sendData: sendData,
                isMock: false
            }).then(function (response) {

                $("#trvgDist").val(comma.add(response.carTrvgDistRnwResDto.trvgDist));

                resolve();
            })
        })
    },
    saveExpenseEntryDetail: function(){
        var sendData = {
            apiId: 'RNW-CKB-3001',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            rgstCd: 'C',
            rgstDt: $("#rgstDt").data('date'),
            expAmt: comma.remove($("#expAmt").val()),
            trvgDist: comma.remove($("#trvgDist").val()),
            oilnQty: $("#oilnQty").val(),
            litrAmt: comma.remove($("#litrAmt").val()),
            firmNm: $("#firmNm").val(),
            memo: $("#memo").val(),
            washAmt: comma.remove($("#washAmt").val())
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.regExpInfoOil,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
        console.log(JSON.stringify(response))

            if(response.resultCode == '200'){
                if(response.ckbAddOilExpRnwResDto.rgstYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            //20220415 차계부 홈으로 돌아가서 새로고침하기 위함
                            garbageAll();
                            MPage.back({param: {"isRefresh": "Y"}});
                        }
                    });

                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_224_3100.init();
    },
    onHide : function(event){},
    onRestore : function(event){},
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy : function(event){},
    onPause : function(event){},
    onResume : function(event){}
};



