/**

@파일명 : KIA_RNW_224_3300.js
@작성자 :
@생성일 : 2022.01.26
@메뉴명 : 지출 금액 입력 상세(정비)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O]
*/
var CurrPage;
var KIA_RNW_224_3300 ={
    init: function(){
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //특수문자 입력하지 못하게 하기 위함.
        COMMON_FUNCTION.TOOL.UI.handleNumberOnlyInput();

        //event
        CurrPage.setEventListner();

        //이전페이지 정비데이터 리스트
        CurrPage.repairListData();

        //CCS연동 차량은 datahub 누적주행거리 노출하기 위함.(2022-05-26)
        var myCarMngInfo = MData.global('myCarMngInfo');
        if(myCarMngInfo && (myCarMngInfo.isMaster == "Y")){
            $("#trvgDist").val(comma.add(myCarMngInfo.trvgDist));
        }else{
            CurrPage.distInfo()
            .then(function(){
                exWNHideIndicator();
            });
        }
    },
    setEventListner: function(){
        //1. 필수 입력 값에 따른 저장버튼 활성화 여부
        $(".required").find('input').on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $("#saveExpBtn").removeClass('disabled');
            }else{
                $("#saveExpBtn").addClass('disabled');
            }
        });

        //2. 필수 입력 값에 따른 저장버튼 활성화 여부
        $(".required").find('.js-input-clear-btn').on('click', function(e) {
           $("#saveExpBtn").addClass('disabled');
        });

        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //날짜 default: 오늘
        var nowTime = moment();
        $("#rgstDt").data('date', nowTime.format('YYYYMMDDHH'));
        $("#rgstDt").val(nowTime.format("YYYY년 MM월 DD일"));

        //취소
        $("#cancleBtn").on("click", function(){
            //20220415 차계부 홈으로 돌아가서 새로고침하기 위함
            garbageAll();
            MPage.back({param: {"isRefresh": "Y"}});
        });

        //저장
        $("#saveExpBtn").on("click", function(){
            //소모품 반영 여부 추가 (2020-05-03)
            var memEvYn = MData.global('passData').car.currentScopeSelectCar.memEvYn;
            var exchRegYn = "N";
            if(MData.param('arrExp').length > 0 && memEvYn == "N"){
                MPopup.confirm({
                    message: "입력하신 소모품의 교체 등록을 함께 하시겠습니까?\n\n* 소모품 교체가 등록되면 수정 및 삭제가 불가능합니다.\n* 교체된 소모품의 정보는 \"내 차 관리 > 소모품 탭\"에서 확인 가능합니다.",
                    buttons: ["예", "아니오"],
                    callback: function (idx){
                        if(idx == 0){
                            exchRegYn = "Y";
                            CurrPage.saveExpenseEntryDetail(exchRegYn);
                        }else{
                            CurrPage.saveExpenseEntryDetail(exchRegYn);
                        }
                    }
                })
            }else{
                CurrPage.saveExpenseEntryDetail(exchRegYn);
            }
        });

        //메모 keyup
        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    distInfo: function () {
        return new Promise(function (resolve) {
            //누적주행거리 조회
            var sendData = {
                apiId: 'RNW-CKB-1001',
                mbrId: PGV.loginInfo.mbrId,
                vin: MData.global('passData').car.currentScopeSelectCar.vin
            }

            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.car.distInfo,
                sendData: sendData,
                isMock: false
            }).then(function (response) {

                $("#trvgDist").val(comma.add(response.carTrvgDistRnwResDto.trvgDist));

                resolve();
            })
        })
    },
    saveExpenseEntryDetail: function(exchRegYn){

        //일반정비
        var arrRepair = MData.param('arrRepair');
        //소모품
        var arrExp = MData.param('arrExp');
        //사용자지정소모품
        var arrCustomExp = MData.param('arrCustomExp');

        //저장할 데이터 중에서 svcSmlNm 제거 필요(20220415)
        var rprList = arrRepair.concat(arrExp, arrCustomExp);
        rprList.forEach(function(item){
            delete item.svcSmlNm;
        });

        var sendData = {
            apiId: 'RNW-CKB-3002',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            rgstDt: $("#rgstDt").data('date'),
            firmNm: $("#firmNm").val(),
            trvgDist: comma.remove($("#trvgDist").val()),
            memo: $("#memo").val(),
            exchRegYn: exchRegYn,
            rprList: rprList
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.regExpInfoRpr,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            if(response.resultCode == '200'){
                if(response.ckbAddRprExpRnwResDto.rgstYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            //20220415 차계부 홈으로 돌아가서 새로고침하기 위함
                            garbageAll();
                            MPage.back({param: {"isRefresh": "Y"}});
                        }
                    });

                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    },
    repairListData: function(){

        //정비리스트
        var arrRepair = MData.param('arrRepair');
        var arrExp = MData.param('arrExp');
        var arrCustomExp = MData.param('arrCustomExp');
        //총합 금액
        var totAmt = 0;

        //초기화 및 tag clone
        $("#repairList").html('');
        var dlCon = $("#dummyDlCon").clone();

        //일반정비
        if(arrRepair.length > 0){
            var tmpDlCon = $(dlCon).clone();
            $(tmpDlCon).find('dd').remove();
            $(tmpDlCon).find('dt #midTit').text('일반정비');
            $(tmpDlCon).find('dt #midCnt').text(arrRepair.length);

            arrRepair.forEach(function(item){
                var ddCon = $(dlCon).find('dd').clone();
                $(ddCon).find('#smTit').text(item.svcSmlNm);
                $(ddCon).find('#smAmt').text(item.expAmt+"원");

                $(tmpDlCon).append(ddCon);
                totAmt += Number(comma.remove(item.expAmt));

            });

            $(tmpDlCon).show();
            $("#repairList").append(tmpDlCon);
        }

        //소모품
        if(arrExp.length > 0){
            var tmpDlCon = $(dlCon).clone();
            $(tmpDlCon).find('dd').remove();
            $(tmpDlCon).find('dt #midTit').text('소모품');
            $(tmpDlCon).find('dt #midCnt').text(arrExp.length);

            arrExp.forEach(function(item){
                var ddCon = $(dlCon).find('dd').clone();
                $(ddCon).find('#smTit').text(item.svcSmlNm);
                $(ddCon).find('#smAmt').text(item.expAmt+"원");

                $(tmpDlCon).append(ddCon);
                totAmt += Number(comma.remove(item.expAmt));
            });

            $(tmpDlCon).show();
            $("#repairList").append(tmpDlCon);
        }

        //사용자지정소모품
        if(arrCustomExp.length > 0){
            var tmpDlCon = $(dlCon).clone();
            $(tmpDlCon).find('dd').remove();
            $(tmpDlCon).find('dt #midTit').text('사용자 지정 소모품');
            $(tmpDlCon).find('dt #midCnt').text(arrCustomExp.length);

            arrCustomExp.forEach(function(item){
                var ddCon = $(dlCon).find('dd').clone();
                $(ddCon).find('#smTit').text(item.svcSmlNm);
                $(ddCon).find('#smAmt').text(item.expAmt+"원");

                $(tmpDlCon).append(ddCon);
                totAmt += Number(comma.remove(item.expAmt));
            });

            $(tmpDlCon).show();
            $("#repairList").append(tmpDlCon);
        }

        $("#totExpAmt").text(comma.add(totAmt)+" 원");
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_224_3300.init();
    },
    onHide : function(event){},
    onRestore : function(event){},
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy : function(event){},
    onPause : function(event){},
    onResume : function(event){}
};



