/**

@파일명 : KIA_RNW_224_3400.js
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 지출 금액 입력 상세_기타(일반)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_224_3400 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        //event
        CurrPage.setEventListner();

    }, 
    setEventListner: function(){

        //1. 필수 입력 값에 따른 저장버튼 활성화 여부
        $(".required").find('input').on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $("#saveExpBtn").removeClass('disabled');
            }else{
                $("#saveExpBtn").addClass('disabled');
            }
        });

        //2. 필수 입력 값에 따른 저장버튼 활성화 여부
        $(".required").find('.js-input-clear-btn').on('click', function(e) {
           $("#saveExpBtn").addClass('disabled');
        });

        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //날짜 default: 오늘
        var nowTime = moment();
        $("#rgstDt").data('date', nowTime.format('YYYYMMDDHH'));
        $("#rgstDt").val(nowTime.format("YYYY년 MM월 DD일"));

        //지출금액(이전 페이지 입력 금액 표시)
        $("#expAmt").val(M.data.param('expAmt'));
        //서브타이틀명
        $("#svcSmlNm").text(MData.param('svcSmlNm'));

        //취소
        $("#cancleBtn").on("click", function(){
            //20220415 차계부 홈으로 돌아가서 새로고침하기 위함
            garbageAll();
            MPage.back({param: {"isRefresh": "Y"}});
        });

        //저장
        $("#saveExpBtn").on("click", function(){
            CurrPage.saveExpenseEntryDetail();
        });

        //메모
        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    saveExpenseEntryDetail: function(){
        var sendData = {
            apiId: 'RNW-CKB-3003',
            mbrId: PGV.loginInfo.mbrId,
            vin: MData.global('passData').car.currentScopeSelectCar.vin,
            rgstDt: $("#rgstDt").data('date'),
            firmNm: $("#firmNm").val(),
            svcSmlCd: MData.param('svcSmlCd'),
            expAmt: comma.remove($("#expAmt").val()),
            memo: $("#memo").val()
        }

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.regExpInfoEtc,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            if(response.resultCode == "200"){
                if(response.ckbAddEtcExpRnwResDto.rgstYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            //20220415 차계부 홈으로 돌아가서 새로고침하기 위함
                            garbageAll();
                            MPage.back({param: {"isRefresh": "Y"}});
                        }
                    });

                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_224_3400.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 


