/**

@파일명 : KIA_RNW_223_3700.js
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 : 지출 금액 입력 상세_주유(스미싱)
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_223_3700 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");

        exWNShowIndicator();

        //특수문자 입력하지 못하게 하기 위함.
        COMMON_FUNCTION.TOOL.UI.handleNumberOnlyInput();

        //지출 대상 차량 정보(노출 여부 및 event 적용)
        CurrPage.expTargetCarList();

        //event
        CurrPage.setEventListner();

        //스미싱 차계부내역 set
        CurrPage.setSmsExpend()
        .then(function(){
            exWNHideIndicator();
        });
    }, 
    setEventListner: function(){

        //1. 필수 입력 값에 따른 저장버튼 활성화 여부
        /*$(".required").find('input').on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $("#saveExpBtn").removeClass('disabled');
            }else{
                $("#saveExpBtn").addClass('disabled');
            }
        });*/

        //2. 필수 입력 값에 따른 저장버튼 활성화 여부
        /*$(".required").find('.js-input-clear-btn').on('click', function(e) {
           $("#saveExpBtn").addClass('disabled');
        });*/

        //input[type=text] && inputmode='numeric' 일 때, 천단위 콤마 정규식 인용
        $("input[type=text][inputmode=numeric]").on("propertychange change keyup paste input", function(){
            if($(this).val()){
                 $(this).val(comma.add($(this).val()));
            }
        });

        //주유량+충전량 정수형 자리수는 8자리 제한, 소수점은 2자리까지
        $("#oilnQty").on("propertychange change keyup paste input", function(){

            var oilnQty = $(this).val().replace(",","");
            var arrData = oilnQty.split(".");

            if(arrData[0] && arrData[0].length > 5){
                $("#oilnQty").val(CurrPage.oilnQty);
                return;
            }
            if(arrData[1] && arrData[1].length > 2){
                $("#oilnQty").val(CurrPage.oilnQty);
                return;
            }

            CurrPage.oilnQty = oilnQty;
        });

         //주유량 자동 계산 (지출금액/주유단가)
        $("#litrAmt").on("keyup", function(){
            var expAmt = comma.remove($("#expAmt").data('expAmt'));
            var litrAmt = comma.remove($("#litrAmt").val());
            var oilnQty = (expAmt && litrAmt) && (expAmt / litrAmt).toFixed(1) || 0;

            $("#oilnQty").val(oilnQty);
        });

        $("#cancleBtn").on("click", function(){
            /*  다음 등록 데이터 존재 시, 추가 등록 필요!   */
            CurrPage.smsList.splice(0, 1);

            if(CurrPage.smsList.length > 0){
                M.data.storage("payment_info_list", CurrPage.smsList);

                MPage.html({
                    url: PATH_MANAGER.KIA_RNW_224_3700.path,
                    animate : "SLIDE_LEFT"
                });
            }else{
                M.data.removeStorage("payment_info_list");
                garbageAll();
                MPage.back({animate : "SLIDE_RIGHT"});
            }
        });

        $("#saveExpBtn").on("click", function(){
            CurrPage.saveExpenseEntryDetail();
        });

        $("#memo").on("keyup", function(){
            var txtLength = $("#memo").val().length;

            console.log(txtLength)
            if(txtLength > 100){
                $(this).val($(this).val().substring(0, 100));
            }else{
                $("#txtLength").text(txtLength);
            }
        });
    },
    smsList: M.data.storage("payment_info_list"),
    expTargetCarList: function(){

        //내연기관 차량 2대이상일 때,
        var carListHtml = "";
        var passData = MData.global("passData");
        var carList = passData.car.myCarInfoListResDto;

        //메인에서 선택된 차량 디폴트
        //var curCarNickname = passData.car.selectCar.carAlias || "";
        var curCarModelName = passData.car.selectCar.mdlNm || "";
        var curCarNumber = passData.car.selectCar.carRgstNo;

        $("#carRgstNo").data('vin', passData.car.selectCar.vin);
        $("#carRgstNo").val(curCarModelName + " " + curCarNumber);

        //내연 보유 차량 카운트
        var targetCnt = 0;

        carList.forEach(function(item){
            if(item.memEvYn == 'N' && item.vin){

                ++targetCnt;
                //var curCarNickname = item.carAlias || "";
                var curCarModelName = item.mdlNm || "";
                var curCarNumber = item.carRgstNo;

                carListHtml += "<li><button type='button' class='btn-link' data-vin='" + item.vin + "'>";
                carListHtml += curCarModelName + " " + curCarNumber;
                carListHtml += "</button></li>";
            }
        });

        if(targetCnt > 1){
            //내연기관 차량data 담을 팝업
            $("#popup_0E0_0000 .select-list").html(carListHtml);

            //팝업 선택 evt
            $("#popup_0E0_0000 .select-list li").on("click", function(){

                var carRgstNo = $(this).find('button').text();
                var vin = $(this).find('button').data('vin');

                $("#carRgstNo").val(carRgstNo);
                $("#carRgstNo").data('vin', vin);

                //팝업닫기
                $("#popup_0E0_0000").fadeOut('fast');
                $("#popup_0E0_0000").find('.popup-wrap').removeClass('is-ani');
                $('body').removeClass('js-overflow-hidden');
            });

            $("#expTargetCar").show();
        }
    },
    setSmsExpend: function(){
        return new Promise(function (resolve) {
            //스미싱 첫 데이터만 노출
            var curSmsList= CurrPage.smsList[0];

            if(curSmsList){
                //지출일자
                var rgstDtTxt = moment(curSmsList.date).format("YYYY년 MM월 DD일");

                //화면에 그릴
                $("#rgstDt").text(rgstDtTxt);
                $("#expAmt").text(comma.add(curSmsList.price) + "원");

                //save action data
                $("#rgstDt").data('date', curSmsList.date);
                $("#expAmt").data('expAmt', comma.remove(curSmsList.price));

                //CCS연동 차량은 datahub 누적주행거리 노출하기 위함.(2022-05-26)
                var passData = MData.global('passData');
                var trvgDist = "";
                if(passData.ccs && (passData.ccs.isMaster == "Y")){
                    trvgDist = passData.ccs.odometer[0].value;
                }else{
                    trvgDist = passData.car.distInfo.trvgDist;
                }
                $("#trvgDist").val(comma.add(trvgDist));

                resolve();
            }else{
                MPopup.alert({
                    message: CONSTANT.NETWORK_ERR_MSG,
                    callback : function(){
                        garbageAll();
                        MPage.back({animate : "SLIDE_RIGHT"});
                    }
                });
            }
        })
    },
    saveExpenseEntryDetail: function(){

        var sendData = {
            apiId: 'RNW-CKB-3001',
            mbrId: PGV.loginInfo.mbrId,
            vin: $("#carRgstNo").data('vin'),
            rgstCd: 'S',
            rgstDt: $("#rgstDt").data('date'),
            expAmt: $("#expAmt").data('expAmt'),
            trvgDist: comma.remove($("#trvgDist").val()),
            oilnQty: $("#oilnQty").val(),
            litrAmt: comma.remove($("#litrAmt").val()),
            firmNm: $("#firmNm").val(),
            memo: $("#memo").val()
        };

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.regExpInfoOil,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            console.log(JSON.stringify(response))
            if(response.resultCode == "200"){
                if(response.ckbAddOilExpRnwResDto.rgstYn == 'Y'){
                    MPopup.alert({
                        message: "저장 되었습니다.",
                        callback : function(){
                            //스미싱 첫 데이터만 삭제
                            CurrPage.smsList.splice(0, 1);

                            /*  다음 등록 데이터 존재 시, 추가 등록 필요!   */
                            if(CurrPage.smsList.length > 0){
                                M.data.storage("payment_info_list", CurrPage.smsList);

                                MPage.html({
                                    url: PATH_MANAGER.KIA_RNW_224_3700.path,
                                    animate : "SLIDE_LEFT"
                                });
                            }else{
                                M.data.removeStorage("payment_info_list");
                                garbageAll();
                                MPage.back({animate : "SLIDE_RIGHT"});
                            }
                        }
                    });
                }else{
                    MPopup.alert("저장 실패 했습니다.");
                    exWNHideIndicator();
                }
            }
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_223_3700.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    onBack : function(){
        garbageAll();
        MPage.back({animate : "SLIDE_RIGHT"});
    },
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 


