/**

@파일명 : KIA_RNW_230_0000.js 
@작성자 : 정목단 - 박민기
@생성일 : 2022.03.14
@메뉴명 : 소모품 탭 
@DESC : 전체메뉴노출[O]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/
var ExchMng;

var KIA_RNW_230_0000 ={
    itemList:[],
    cycleList:[],
    odometers:null,
    trvgDist:0,
    isDOMReady:false,
    init: function(){
        // todo : exchDist, exchStatus, itcgCyclScnCd, percent는 optional이므로 처리 필요
        
        ExchMng = this;

        var passData = !isEmpty(PGV.passData)?PGV.passData:MData.param("passData");
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("page : " + PGV.currentPage + "initiolizing START");

        $('.content.content-mycar').removeClass('maintain');
        $('.content.content-mycar').addClass('supply'); // html 불러오면서 supply 클래스가 추가되지 않아 수동추가 (당장은)

        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(currentScopeSelectCar, "#mykia-mycar-car-select-box");

        ExchMng.getInfo();
        var delay = 0;
        setTimeout(function getDOMReady() {
            exWNShowIndicator();
            if (ExchMng.isDOMReady) {
                exWNHideIndicator();
                COMMON_FUNCTION.TOOL.DEBUG.showTalk("domReady");
                ExchMng.setEventListner();
                clearTimeout(getDOMReady);
            } else {
                delay += 500;
                setTimeout(getDOMReady, delay);
            }
        }, delay);
    },
    needUpdateExchDist:function(datas)
    {
        if( $(datas).length > 0 ) 
        {
            var sum = 0;
            $(datas).each(function (idx,data){
                if( !isEmpty(data.exchDist) ) sum += Number(data.exchDist);
            });
            
            // 교체기준거리가 모두 0인 경우는 최초 기본값도 설정되어있지 않은 케이스
            // 최초 1회 서버에 기본값으로 설정 필요
            if( sum == 0 ) 
            {
                return true;
            }
        }

        return false;
    },
    getDefault:function(exchCd)
    {
        var exchDist = 0;
        switch(exchCd){
            case "0001":
            exchDist = 10000;
            break;
            case "0002":
            exchDist = 40000;
            break;
            case "0003":
            exchDist = 15000;
            break;
            case "0004":
            exchDist = 100000;
            break;
            case "0005":
            exchDist = 100000;
            break;
            case "0006":
            exchDist = 40000;
            break;
            case "0007":
            exchDist = 40000;
            break;
            case "0008":
            exchDist = 40000;
            break;
            case "0009":
            exchDist = 40000;
            break;
            case "0010":
            exchDist = 40000;
            break;
            case "0011":
            exchDist = 60000;
            break;
            case "0012":
            exchDist = 10000;
            break;
            case "0013":
            exchDist = 80000;
            break;
            case "0014":
            exchDist = 70000;
            break;
            default:
            break;
        }
        return exchDist;
    },
    setExchDist:function(list)
    {
        var passData = !isEmpty(PGV.passData)?PGV.passData:MData.param("passData");

        var sendData = {
            mbrId: PGV.loginInfo.mbrId,
            vin: passData.car.selectCar.vin,
            exchCycleList : []
        };

        list.map(function(item){

            sendData.exchCycleList.push({
                exchCd : item.exchCd,
                exchDist : ExchMng.getDefault(item.exchCd), //item.exchDist,
                partTrtmYn : isEmpty(item.exchangeYn)?"N":item.exchangeYn,
                itcgCyclScnCd : isEmpty(item.itcgCyclScnCd)?"1":item.itcgCyclScnCd
            });

            return item;
        });

        COMMON_FUNCTION.TOOL.DEBUG.showTalk("sendData(insertCycle) : " + JSON.stringify(sendData));
        
        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.insertCycle,
            sendData : sendData,
            indicatorYn:"Y",
            isMock: false
        }).then(
            function(response){
                exWNHideIndicator();
                COMMON_FUNCTION.TOOL.DEBUG.showTalk(JSON.stringify(response));
                if(response.resultCode==="200")
                {
                    // M.pop.instance('설정이 완료되었습니다.');
                    // MPage.back({param: {"isRefresh": "Y"}});
                }
                else
                {
                    MPopup.instance("오류가 발생하였습니다.");
                }
            }
        ).catch(function(){
            exWNHideIndicator();
            MPopup.instance("오류가 발생하였습니다.");
        }).finally(function(){
            ExchMng.getExchCycle(ExchMng.trvgDist, false);
        });
    },
    getExchCycle: function(trvgDist, first)
    {
        var car = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
                    
        var sendData = {
            mbrId: PGV.loginInfo.mbrId,
            vin: car.vin,
            // trvgDist: trvgDist
        };

        if( trvgDist != 0 ) sendData["trvgDist"] = trvgDist; //car.distInfo.trvgDist;
        // if(car && car.distInfo && car.distInfo.trvgDist) sendData["trvgDist"] =  car.distInfo.trvgDist;

        COMMON_FUNCTION.TOOL.DEBUG.showTalk( "exchCycle : " + JSON.stringify(sendData) );

        var needUpdate = false;
        var itemList = [];
        
        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.ckb.exchCycle,
            sendData : sendData,
            indicatorYn:"Y",
            isMock: false
        }).then(
            function(response){
                exWNHideIndicator();
                COMMON_FUNCTION.TOOL.DEBUG.showTalk( JSON.stringify(response) );
                if(response.resultCode==="200"
                    && !isEmpty(response.ckbExchCycleListRnwResDto)){
                    // $("#exchBtnGroup").show();
                    // var btnDivHtml='';
                    // btnDivHtml += '<div class="btn-block d-flex justify-content-between">';
                    // btnDivHtml += '    <div class="col-2">';
                    // btnDivHtml += '        <button type="button" class="btn-default" id="btnCycle">';
                    // btnDivHtml += '            <em>교환 주기 설정</em>';
                    // btnDivHtml += '        </button>';
                    // btnDivHtml += '    </div>';
                    // btnDivHtml += '    <div class="col-2">';
                    // btnDivHtml += '        <button type="button" class="btn-default"  id="btnReg">';
                    // btnDivHtml += '            <em>교체 이력 등록</em>';
                    // btnDivHtml += '        </button>';
                    // btnDivHtml += '    </div>';
                    // btnDivHtml += '</div>';
                    // $("section.section-02 div.inner-cont").append($(btnDivHtml));
                    // 교체기준거리가 모두 0이거나 비어있는 경우, 초기값을 세팅하고 시작한다.
                    if( ExchMng.needUpdateExchDist(response.ckbExchCycleListRnwResDto) && first )
                    {
                        itemList = JSON.parse(JSON.stringify(response.ckbExchCycleListRnwResDto));
                        needUpdate = true;
                    }
                    else
                    {
                        ExchMng.uiExchCycle(response.ckbExchCycleListRnwResDto);
                        ExchMng.setDetailClick();
                    }
                }
                else{
                    ExchMng.uiExchCycle(null);
                    M.pop.instance( !isEmpty(response.resultMsg)? response.resultMsg:response.errorMessage );
                }
            }
        ).catch(function(){
            exWNHideIndicator();
        }).finally(function(){
            ExchMng.isDOMReady = true;
            COMMON_FUNCTION.TOOL.DEBUG.showTalk(ExchMng.isDOMReady);
            if( needUpdate )
            {
                ExchMng.setExchDist(itemList);

            }
        });
    },
    getInfo: function()
    {
        var car = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);

        COMMON_FUNCTION.TOOL.DATA.getTrvgDist(car).then(
            function (response) {
                var odometer = response.trvgDist;
                exWNHideIndicator();
                if( typeof odometer == "string" )
                {
                    ExchMng.trvgDist = isNaN(Number(odometer))?0:Number(odometer);
                }
                else if( typeof odometer == "number" )
                {
                    ExchMng.trvgDist = isNaN(odometer)?0:odometer;
                }
                else
                {
                    ExchMng.trvgDist = 0;
                }

                console.log("ExchMng.trvgDist?? == >> "+ExchMng.trvgDist);
            }
        ).finally(function(){
            exWNHideIndicator();
            
            ExchMng.getExchCycle(ExchMng.trvgDist, true);
        });

        // 데이터 허브에 거리 정보가 있는 경우에만 파라메터로 설정
        // if (!isEmpty(car.carId))
        // {
        //     MNet_Hub.httpSendAsync({
        //         indicatorYn : "Y",
        //         path : _API.HUB.odometer.verifyUrl(car.carId),
        //         errorPopupEnabled : false,
        //         method : "GET"
        //     })
        //     // new Promise(function(resolve, rejust){
        //     //     resolve( {
        //     //         "odometers": [
        //     //             {
        //     //                 "date": "20200115",
        //     //                 "timestamp": "20200114152139",
        //     //                 "value": 12320.2,
        //     //                 "unit": 1
        //     //             }
        //     //         ],
        //     //         "msgId": "655f3b1c-d19e-4e59-9706-4a7d82df3502"
        //     //     });
        //     // })
        //     .then(
        //         function (response) {
        //             exWNHideIndicator();
        //             if (!isEmpty(response.errorCode)) {//통신응답오류
        //                 // return {from: wherTo, data: null};
        //             }
        //             else{
        //                 if (isEmpty(response.errCode)) {//datahub errorcode
        //                     ExchMng.odometers = response.odometers;
        //                     // return {from: wherTo, data: response.odometers};
        //                 } else {
        //                     // return {from: wherTo, data: null};
        //                 }
        //             }
        //         }
        //     ).finally(function(){
        //         exWNHideIndicator();
        //         var trvgDist = 0;
        //         if( !isEmpty( ExchMng.odometers ) )
        //         {
        //             try{
        //                 var odometer = ExchMng.odometers[0].value;
        //                 var unit = ExchMng.odometers[0].unit;
        //                 trvgDist = convertDistanceToKm(unit, odometer) || 0;
        //             }
        //             catch(e){
        //                 trvgDist = 0;
        //             }
        //             ExchMng.trvgDist = trvgDist;
        //         }
        //         ExchMng.getExchCycle(trvgDist, true);
        //     });
        // }
        // else
        // {
        //     ExchMng.getExchCycle(0, true);
        // }

        //누적주행거리 조회
        // var sendData = {
        //     apiId: 'RNW-CKB-1001',
        //     mbrId: PGV.loginInfo.mbrId,
        //     vin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
        // }

        // MNet.httpSendAsync({
        //     path: _API.SVR.MYCAR.car.distInfo,
        //     sendData: sendData,
        //     isMock: false
        // }).then(function (response) {
        //     exWNHideIndicator();

        //     COMMON_FUNCTION.TOOL.DEBUG.showTalk(JSON.stringify(response));

        //     var trvgDist = 0;

        //     if(response.resultCode == '200'){
        //         var data = response.carTrvgDistRnwResDto;

        //         trvgDist = data && data.trvgDist || 0;
        //     }


        // }).catch(function(){
        //     exWNHideIndicator();
        // });
    },
    uiExchCycle: function (datas) {
        var _target = $("#exchHistory");
        $("#exchHistory").html('');
        ExchMng.itemList = [{exchCd:0, exchNm: "전체 항목"}];
        $(datas).each(function (idx,data){
            ExchMng.itemList.push( {exchCd:data.exchCd, exchNm: data.exchNm} );
            var _$itemDiv = ExchMng._$getExchItemDiv(data);
            _target.append(_$itemDiv);
        });

        if( !isEmpty(datas) )
        {
            ExchMng.cycleList = JSON.parse(JSON.stringify(datas));
            ExchMng.cycleList.map(function(item){
                // delete item.exchNm;
                delete item.exchStatus;
                delete item.percent;
                item.itcgCyclScnCd = isEmpty(item.itcgCyclScnCd)?"1":item.itcgCyclScnCd;
                item["partTrtmYn"] = item.exchangeYn;
                delete item.exchangeYn;

                return {
                    exchCd : item.exchCd,
                    exchNm : item.exchNm,
                    exchDist : item.exchDist,
                    // exchangeYn => partTrtmYn
                    partTrtmYn : item.exchangeYn,
                    itcgCyclScnCd : isEmpty(item.itcgCyclScnCd)?"1":item.itcgCyclScnCd
                };
            });

            // COMMON_FUNCTION.TOOL.DEBUG.showTalk(JSON.stringify(ExchMng.cycleList));
            
        }
        else
        {
            ExchMng.cycleList = null;
        }
    },
    comma: function(str) {
        str = String(str);
        return str.replace(/(\d)(?=(?:\d{3})+(?!\d))/g, '$1,');
    },
    uncomma: function(str) {
        str = String(str);
        str = str.replace(/[^\d]+/g, '');
        if( !str.trim() ) str = str.trim(); // 빈값은 그대로 둠
        else str = Number(str).toString(); // leading zero 제거
        return str;
    },
    _$getExchItemDiv: function (data) {
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("_230_0000_Func> _$getExchItemDiv : "+data);
        var percent= parseInt(data.percent||0);
        var DICT_EXCH_STATUS = {"0": "양호", "4": "양호", "1": "교체권장", "2": "교체필요",};
        var DICT_BAR_CLASS={"RED":"c-bg-brand-point",
            "YELLOW":"c-bg-brand-secondary-01",
            "GREEN":"c-bg-brand-secondary-02"};
        var exch_percent_bar_class = "";
        if(percent>=100){
            exch_percent_bar_class = DICT_BAR_CLASS["RED"];
        }else if(percent>=95){
            exch_percent_bar_class = DICT_BAR_CLASS["YELLOW"];
        }else
        //if(percent>=0)
        {
            exch_percent_bar_class = DICT_BAR_CLASS["GREEN"];
        }
        // else{
        //     return new Error("소모품 잔여기간 퍼센트 범위 외값");
        // }

        var html =
           '     <div class="div-table">' +
           '         <div class="div-table-cell cell-01">' +
           '             <i class="ico-period">' +
           '                 <b>' + percent+ '%</b>' +
           '             </i>' +
           '         </div>' +
           '         <div class="div-table-cell cell-02">' +
           '             <div class="text-title">' +
           '                 <h5 class="text-scale-05"><b>'+data.exchNm+'</b></h5>' +
           '                 <em>'+ ExchMng.comma(ExchMng.uncomma(data.exchDist)) +'km 주기 교체 권장</em>' +
           '             </div>' +
           '         </div>' +
           '         <div class="div-table-cell cell-03">' +
           '             <button type="button" class="btn-arrow-right">' +
            '<input type="hidden" name="exchCd" value="'+data.exchCd+'"/>'+
           '                 <i class="ico-arrow-right"><em class="blind">자세히보기</em></i>' +
           '             </button>' +
           '         </div>' +
           '     </div>' +
           '     <div class="progress-cont">' +
           '         <div class="js-progress-item">' +
           '             <div class="progress">' +
           '                 <div class="progress-bar '+exch_percent_bar_class+' js-progress-btn" style="width:'+percent+'%;"></div>' +
           '             </div>' +
           '         </div>' +
           '     </div>';

        return $('<div class="div-item"></div>').html(html);
    },
    uiExchCycleDtl: function (exchCycleDtl) {

    },
    setDetailClick: function(){
    /** 교체내역상세클릭 */
        $("#btnExchDtlCycle ,#exchHistory>div>div>div>button.btn-arrow-right")
            .on("click",
                function(e) {
                    var exchCd = $(e.target).children('input[name="exchCd"]')[0].value;
                    // M.data.param("selectedChCd",exchCd);

                    var param = {
                        selectedChCd : exchCd,
                        itemList: ExchMng.itemList,
                        currentSelectCarVin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
                    };
            
                    MPage.html({
                        url : PATH_MANAGER.KIA_RNW_231_0000.path,
                        animate : 'MODAL_UP',
                        param : param
                    });

                    // customPopup.get(
                    // PATH_MANAGER.KIA_RNW_231_0000.path,
                    // $("#popup_231_0000"),
                    // function(item){//item==POP._231_0000.url's html
                    //     var selectedChCd = M.data.param("selectedChCd");
                    //     COMMON_FUNCTION.TOOL.DEBUG.showTalk("_231_0000_Func> selectedChCd : "+selectedChCd);
                    //     if($("#popup_231_0000").length < 1){
                    //         var screenHtml = $("<div></div>");
                    //         screenHtml.append(item);
                    //         $('body').append(screenHtml.find('#popup_231_0000'));
                    //     }
                    //     RNW_UI.popupLayer({selId : '#popup_231_0000'});
                    //     var nowYyyyMmDdEach = DateUtil.getNowYyyyMmDdEach();
                    //     $("#datepicker1").val((Number(nowYyyyMmDdEach.yyyy)-1)+"."+nowYyyyMmDdEach.mm+"."+(Number(nowYyyyMmDdEach.dd)+1));
                    //     $("#datepicker2").val(nowYyyyMmDdEach.yyyy+"."+nowYyyyMmDdEach.mm+"."+nowYyyyMmDdEach.dd);


                    //     $(".js-popup-close-btn").click(function(){
                    //         M.data.removeParam("selectedChCd");
                    //     });
                    // });
            }
        );
    },
    setEventListner: function(){
        // $('#mykia-mycar-car-select-box').on("click", function(){
        //     COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(ExchMng);
        // })
        $('#mykia-mycar-car-select-box').on("click", function(){
            COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(KIA_RNW_210_0000);
        })
        

        $("#btnAllExchHist").on("click", function(){
            COMMON_FUNCTION.TOOL.DEBUG.showTalk("btnAllExchHist click");
            var param = {
                selectedChCd : "0",
                itemList: ExchMng.itemList,
                currentSelectCarVin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
            };
    
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_231_0000.path,
                animate : 'MODAL_UP',
                param : param
            });

        });


        $("#btnCycle").on("click", function(e) {
            var param = {
                cycleList: ExchMng.cycleList,
                currentSelectCarVin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
            };
    
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_233_0000.path,
                animate : 'MODAL_UP',
                param : param
            });
        });

        $("#btnReg").on("click", function(e) {
            console.log("ExchMng.trvgDist == >> "+ExchMng.trvgDist);
            var param = {
                cycleList: ExchMng.cycleList,
                trvgDist: ExchMng.trvgDist,
                currentSelectCarVin: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000).vin
            };
    
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_232_0000.path,
                animate : 'SLIDE_LEFT',
                param : param
            });
        });


        // $("#btnExchDtlCycle").on("click", function(e) {
        //     customPopup.get(
        //         PATH_MANAGER.KIA_RNW_232_1000.path,
        //         $("#popup_232_1000"),
        //         function(item){});
        // });
        // $("#btnExchDtlCycle").on("click", function(e) {
        //     customPopup.get(
        //         PATH_MANAGER.KIA_RNW_233_0000.path,
        //         $("#popup_233_0000"),
        //         function(item){});
        // });

        // todo 교체내역 클릭시 팝업 퍼블대기하기
        // var exchCycleDtlPromise = CMM_NET_SVR
        //     .getCarExchCycleDtl({
        //         mbrId: PGV.loginInfo.mbrId,
        //         vin: data.car.selectCar.vin,
        //     })
        //     .then(
        //         function(response){
        //             if(response.resultCode==="200"
        //                 && !isEmpty(response.ckbExchCycleDtlListRnwResDto)){
        //                 ExchMng.uiExchCycleDtl(response.ckbExchCycleDtlListRnwResDto);
        //             }
        //             else{
        //                 ExchMng.uiExchCycleDtl(null);
        //             }
        //         }
        //     );
    }

}

KIA_RNW_230_0000.init();

COMMON_FUNCTION.TOOL.MStatusControl.addMStatusFunction("onRestore", "KIA_RNW_230_0000", function(){
    if($("[data-tab-name=mykia-tab-mycar]:visible").length > 0){
        if(KIA_RNW_210_0000 && KIA_RNW_210_0000.tabularNavigator){
            var pageIndex = KIA_RNW_210_0000.tabularNavigator.currentTabIndex;
            if (pageIndex === 2) {
                var isRefresh = MData.param('isRefresh');
                MData.removeParam('isRefresh');
                if( !isEmpty(isRefresh) && isRefresh == 'Y')
                {
                    KIA_RNW_210_0000.tabularNavigator.open(2,true);
                }
            }
        }
    }
})

 /**
  * 모피어스 화면 상태 이벤트 함수
  */
// var MStatus = {
//      onReady : function(event){
//          COMMON_FUNCTION.TOOL.DEBUG.showTalk("onReady page : "+PGV.currentPage);
//          KIA_RNW_230_0000.init();
//      },
//      onHide : function(event){},
//      onRestore : function(event){},
//      // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//      // onBack : function(){},
//      onDestroy : function(event){},
//      onPause : function(event){},
//      onResume : function(event){}
//  };
