/**

@파일명 : KIA_RNW_240_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.01.26 
@메뉴명 : 정비 탭 
@DESC : 전체메뉴노출[O]	미로그인[X]	차량미보유[X]	계약차량보유[O]	내연보유[O]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_240_0000 ={ 
    eventListContainer: [],
    /* updateMyAutoQ에서 할당합니다. */
    myAutoQStationInfo: null,
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        $('.content.content-mycar').addClass('maintain'); // !!! 케이스마텍 추헌남 - html 불러오면서 maintain 클래스가 추가되지 않아 수동추가 (당장은)

        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(currentScopeSelectCar, "#mykia-mycar-car-maintenance-select-box");

        var indicatorMaintainer = setInterval(function(){
            exWNShowIndicator();
        }, 500)

        var parentThis = this;
        this.getAndSetInsightInfo()
        .then(function(response){
            Promise.all([
                parentThis.setMyAutoQ(),
                parentThis.setServiceList("ING")
            ])
            .then(function(){
                parentThis.setPublisherEventListener();
                parentThis.setEventListner();
                clearInterval(indicatorMaintainer);
                exWNHideIndicator();
            })
        })
    }, 
    setEventListner: function(){
        var parentThis = this;
        COMMON_FUNCTION.TOOL.UI.enableScreenIdListeners();
        /* 2023.12.12 클릭 event 버그로 off 추가 */
        $('#mykia-mycar-set-myautoq, #mykia-mycar-find-station').off("click").on("click", function(){
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_242_0000.path,
                param: {
                    currentScopeSelectCar : KIA_RNW_210_0000.currentScopeSelectCar
                }
            });
        })
        $('#mykia-mycar-car-maintenance-select-box').off("click").on("click", function(){
            COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(KIA_RNW_210_0000);
        })
        $('#mykia-mycar-reserve').off("click").on("click", function(){
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_243_1000.path,
                param: {
                    carList: PGV.passData && PGV.passData.car,
                    defaultSelectCar: PGV.passData && PGV.passData.car && PGV.passData.car.selectCar,
                    currentScopeSelectCar: KIA_RNW_210_0000.currentScopeSelectCar,
                }
            })
        })
        // $("#mykia-mycar-change-myautoq").on("click", function(){
        //     MPage.html({
        //         path: PATH_MANAGER.KIA_RNW_242_0000.path,
        //         param: {
        //             currentScopeSelectCar : KIA_RNW_210_0000.currentScopeSelectCar
        //         }
        //     });
        // })
        /* !!! 케이스마텍 추헌남 - 정비 편의 서비스 swiper 클릭 이벤트 리스너 오작동으로 인한 이벤트 리스너 수정 후 여기로 이동 */
        $(".swiper-slide").off("click").on("click", function(){
            var currentIndex = parseInt($(this).find("img").data("event-index"));
            var linkUrl = parentThis.eventListContainer[currentIndex] && parentThis.eventListContainer[currentIndex].lingUrl || null;
            if(linkUrl){
                MPage.activity({
                    className : "WebviewActivity",
                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam("GET", linkUrl)
                });
            }
        })
    },
    setPublisherEventListener: function(){
        var tempSwiperSetting = {
            slidesPerView:'auto',
            autoHeight: true,
            pagination: {
                el: '.maintain-service .swiper-pagination',
                clickable: true,
            },
        };
        
        if($(".slider-maintain-service .swiper-slide").length > 1){
            tempSwiperSetting["speed"] = 300;
            tempSwiperSetting["loop"] = true;
            tempSwiperSetting["autoplay"] = {
            	delay:3000,
            	disableOnInteraction: false, // 사용자가 슬라이드 수동전환 하는경우 자동재생 멈추게 한다:true
            };
            tempSwiperSetting["touchRatio"] = true;
        }

        var _sliderMaintainService = new Swiper('.slider-maintain-service', tempSwiperSetting);		
        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			$winTop = $nowTop;
			
		});
    },
    getAndSetInsightInfo: function(){
        var currentCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
        var getTemplateString = function(onlyOneLine, line01, line02){
            var templateString = 
                '<div class="row-01">' +
                    '<h4 class="text-scale-04">' +
                        line01 +
                    '</h4>' +
                '</div>' +
                (!onlyOneLine ?
                    '<div class="row-02">' +
                        line02 +
                    '</div>' : "");
            return templateString;
        }

        var line01 = "";
        var line02 = "";
        var onlyOneLine = false;

        return new Promise(function(resolve){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.insight.insight,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: currentCar.vin,
                    carRgstNo: currentCar.carRgstNo,
                    hpNo: PGV.loginInfo.hpno
                },
                isMock: false,
            })
            .then(function(response){
                console.log("throwing from insight : ", {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: currentCar.vin,
                    carRgstNo: currentCar.carRgstNo,
                    hpNo: PGV.loginInfo.hpno
                })
                console.log("from insight : " , response);
                var targetResponseCode = response.instCd;
                if(targetResponseCode === "R001"){
                    //정비중차량
                    line01 = "지금은, 정비 진행 중입니다.";
                    //오토캠 있을 때 없을 때
                    if(!isEmpty(response.autoCamInfo)){
                        line02 = 
                            '<i class="ico-live"><em class="blind">LIVE</em></i>' +
                            '<span class="text-underline c-font-primary" id="mykia-mycar-go-autocam">오토캠 시청</span>' +
                            '<span class="text-underline c-font-primary" id="mykia-mycar-go-maintenance-status">정비 진행 현황</span>';
                    }
                    else{
                        line02 =
                            '<span class="text-underline c-font-primary" id="mykia-mycar-go-maintenance-status">정비 진행 현황</span>';
                    }
                }
                if(targetResponseCode === "R002"){
                    if(!isEmpty(response.rprPrctCar)){ // ??? 케이스마텍 추헌남 - 해당 부분의 항목이 없음
                        line01 = '<b>차량 정비 방문이 <b class="c-font-brand-point">' + response.rprPrctCar.rmnDt + '일</b> 남았습니다.</b>';
                        line02 = '<span class="text-underline c-font-primary" id="mykia-mycar-go-maintenance-reserve-status">정비 예약 현황/내역</span>';
                    }
                }
                if(targetResponseCode === "R003"){
                    //정기점검차량
                    var targetResponseBody = response.rprRcmnCar || response.rprRcmmCar;
                    if(!isEmpty(targetResponseBody)){
                        if(targetResponseBody.rcmdDt){
                            var momentObject = moment(targetResponseBody.rcmdDt, "YYYYMMDD");
                            var dateText = momentObject.format("YYYY년 MM월 DD일");
                            var remainingDays = targetResponseBody.rmnDt;
                            
                            line01 =
                                '<h4 class="text-scale-04">' +
                                    '<b>차량 정비 권장일은<br>' + dateText + ' 입니다.</b>' +
                                '</h4>' +
                                '<span class="label-cont">' +
                                    '<i class="ico-label-primary">' +
                                        '<em>' + remainingDays + '</em>' +
                                    '</i>' +
                                '</span>';
                            onlyOneLine = true;
                        }
                    }
                }
                if(targetResponseCode === "R004"){
                    //디폴트 메시지
                    line01 = "안전운전을 위해<br>주기적으로 정비서비스를 받아보세요.";
                    onlyOneLine = true;
                }
                
                var htmlString = getTemplateString(onlyOneLine, line01, line02);
                
                $('#mykia-mycar-car-insight-text').html(htmlString);
    
                $("#mykia-mycar-go-autocam").off("click").on("click", function(){
                    MPage.html({
                        path: PATH_MANAGER.KIA_RNW_247_1000.path,
                        param: {
                            autoCapmInfo: response.autoCamInfo
                        }
                    })
                })
                $("#mykia-mycar-go-maintenance-status").off("click").on("click", function(){
                    MPage.html({
                        path: PATH_MANAGER.KIA_RNW_247_0000.path,
                        param: {
                            autoCapmInfo: response.autoCamInfo,
                            
                        }
                    })
                })
                $("#mykia-mycar-go-maintenance-reserve-status").off("click").on("click", function(){
                    MPage.html({
                        path: PATH_MANAGER.KIA_RNW_244_1000.path
                    })
                })
                resolve(response);
            })
        })
    },
    setMyAutoQ: function(){
        // var currentPermission = COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission(KIA_RNW_210_0000);
        if(COMMON_FUNCTION.TOOL.DATA.hasAtLeastOneOwnedCar()){
            var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_210_0000);
            COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("insight", currentScopeSelectCar, this);
            $("#mykia-mycar-myautoq").removeClass("none");
        }
        else{
            $("#mykia-mycar-myautoq").addClass("none");
        }
    },
    setServiceList:function(serviceState) {
        var parentThis = this;
        return new Promise(function(resolve){
            COMMON_FUNCTION.TOOL.OPTIMIZE.memoize.httpSendAsync({
                path: _API.SVR.MYCAR.event.carCareServiceList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    stsCd: serviceState,
                    currentPageNo: 1,
                    pageSize: 10 // ??? 케이스마텍 추헌남 - 이거 pagination 정책이 어떻게 되지?
                },
                isMock: false
            })
            .then(function(response){
                if(response.resultCode === "200"){
                    var eventList = response.carCareServiceListRnwResDto;
                    parentThis.eventListContainer = eventList;
                    if (eventList && eventList.length > 0){
                        $("#mykia-mycar-service-list-nodata").addClass("none");
                        $("#mykia-mycar-service-list-container").removeClass("none");
                        var addingEventObjectsList = [];
                        for (var i = 0; i < eventList.length; i++){
                            var curNode = eventList[i];
                            var savedFileNm = curNode.savedFileNm;
                            var savedFilePath = curNode.savedFilePath;
                            
                            var htmlString =
                                '<div class="swiper-slide">' +
                                    '<img src="' + (CONSTANT.IMG_URL_PREFIX + savedFilePath + savedFileNm) + '" alt="" data-event-index="' + i + '">' +
                                '</div>'
                            var htmlObject = $(htmlString);
                            addingEventObjectsList.push(htmlObject);
                        }
                        $('#mykia-mycar-service-list').html('');
                        $('#mykia-mycar-service-list').append(addingEventObjectsList);
                    }
                    else{
                        $("#mykia-mycar-service-list-nodata").removeClass("none");
                        $("#mykia-mycar-service-list-container").addClass("none");
                    }
                    resolve();
                }
            })
        })
    },
} 

KIA_RNW_240_0000.init();

COMMON_FUNCTION.TOOL.MStatusControl.addMStatusFunction("onRestore", "KIA_RNW_240_0000", function(){
    if(KIA_RNW_210_0000.tabularNavigator.currentTabIndex === 3){
        KIA_RNW_210_0000.tabularNavigator.open(3, true);
    }
    //KIA_RNW_240_0000.setMyAutoQ();
});
COMMON_FUNCTION.TOOL.MStatusControl.addMStatusFunction("onResume", "KIA_RNW_240_0000", function(){
    if(KIA_RNW_210_0000.tabularNavigator.currentTabIndex === 3){
        KIA_RNW_210_0000.tabularNavigator.open(3, true);
    }
});

// /** 
//  * 모피어스 화면 상태 이벤트 함수 
//  */ 
// var MStatus = { 
//     onReady : function(event){ 
//         console.log("onReady page : "+PGV.currentPage); 
//         KIA_RNW_240_0000.init(); 
//     }, 
//     onHide : function(event){}, 
//     onRestore : function(event){}, 
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
//     // onBack : function(){}, 
//     onDestroy : function(event){}, 
//     onPause : function(event){}, 
//     onResume : function(event){} 
// }; 
