/**

@파일명 : KIA_RNW_242_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.02.25 
@메뉴명 : 정비서비스 거점 검색
@DESC : 권한 확인중
*/
var CurrPage;
var KIA_RNW_242_0000 = {
    mapsManager: COMMON_FUNCTION.ROUTO.mapsManager,
    /* this.checkMyAutoQStatus 에서 할당하였다가 이제는 이전 페이지에서 가져옴 */ 
    myAutoQStationInfo: null,
    // 2024.01.19 삼항연산자 안의 함수 값을 못받는 버그로 인해 변경
    // currentScopeSelectCar: _.contains(["", "undefined", "null"], MData.param('currentScopeSelectCar')) ? COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar() : MData.param('currentScopeSelectCar'),
    currentScopeSelectCar: function () {
        return _.contains(["", "undefined", "null"], MData.param('currentScopeSelectCar')) ? COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar() : MData.param('currentScopeSelectCar')
    },
    serviceGubunList: null, // this.setFilterButtons 에서 할당함

    currentCoords: null, // this.init 에서 할당함

    noGPSCoords: false, // setMapInterface -> COMMON_FUNCTION.TOOL.GPS.getGPSCoordsAsync 에서 설정, GPS 없어 기본값 혹은 오류 발생 시 true로 변경됨

    // !!! 케이스마텍 추헌남 - 스크롤 페이지 관련 메타
    pageMeta: { // this.setNearbyAutoQStationList에서 할당
        currentPageNo: 1,
        pageSize: 10,
        stopLoadingMore: false,
        currentSearchState: {
            currentCar: null,
            coords: null,
            serviceGubun: null,
            partName: null,
            myAutoQStationCode: null
        }
    },

    init: function () {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var keepShowingIndicator = setInterval(function(){
            exWNShowIndicator();
            var mapViewPortStyle = $(".ol-viewport:visible").attr("style");
            if ( mapViewPortStyle && mapViewPortStyle.indexOf("tile.routo.com") > 0){
                clearInterval(keepShowingIndicator);
                exWNHideIndicator();
            }
        }, 500);

        var parentThis = this;

        var indicatorMaintainer = setInterval(function(){
            exWNShowIndicator();
        }, 500)

        var onSearchCallback = function(currentMapCenterCoords){
            var curSearchState = parentThis.pageMeta.currentSearchState;
            var serviceGubun = curSearchState.serviceGubun;
            var partName = curSearchState.partName;
            var myAutoQStationCode = parentThis.myAutoQStationInfo && parentThis.myAutoQStationInfo.asnCd || null;
            parentThis.setNearbyAutoQStationList(parentThis.currentScopeSelectCar(), currentMapCenterCoords, serviceGubun, partName, myAutoQStationCode, 1, 10);
        }

        Promise.all([
            this.setFilterButtons(),
            COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.setMapInterface("mykia-mycar-find-autoq-station-map", KIA_RNW_242_0000, onSearchCallback),
            //this.currentScopeSelectCar && this.checkMyAutoQStatus(this.currentScopeSelectCar.carRgstNo, this.currentScopeSelectCar.vin) // !!! 케이스마텍 추헌남 - 기존 param으로 들어온 myAutoQ를 받되, 없으면 요청하기
        ])
        .then(function (responses) {
            PGV.loginInfo && COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", parentThis.currentScopeSelectCar(), KIA_RNW_242_0000);
            
            if (responses[1]) {
                parentThis.currentCoords = responses[1];
                if (parentThis.currentCoords) {
                    /* !!! 케이스마텍 추헌남 - 아래에서 검색 결과까지 다 나오면 exWNHideIndicator 해당 함수 내부에서 실행 */
                    parentThis.setNearbyAutoQStationList(
                        parentThis.currentScopeSelectCar(),
                        parentThis.currentCoords,
                        null,
                        null,
                        parentThis.myAutoQStationInfo && parentThis.myAutoQStationInfo.asnCd);
                }
            }
            parentThis.setEventListner();
            parentThis.handleOnListHitsBottom();
            clearInterval(keepShowingIndicator);/* 2023.12.12 지도 loading 실패 시 indicator 사라지지 않아 추가 */
            clearInterval(indicatorMaintainer);
            exWNHideIndicator();
        })
    },

    setEventListner: function () {
        var parentThis = this;
        $('#mykia-mycar-find-autoq-station-page button.btn-prev').off("click").on("click", function () {
            MPage.back();
        });
        $('#mykia-mycar-find-autoq-station-search-toggle').on("click", function () {
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_242_4000.path,
                animate: "NONE",
                param: {
                    myAutoQStationInfo: parentThis.myAutoQStationInfo,
                    currentScopeSelectCar: parentThis.currentScopeSelectCar(),
                    currentCoords : parentThis.currentCoords
                }
            })
        });
    },

    setNearbyAutoQStationList: function (currentCar, coords, serviceGubun, partName, myAutoQStationCode, nowPage, pageSize, loadMoreMode) {
        !loadMoreMode && $("#mykia-mycar-find-autoq-station-list").scrollTop(0);
        this.pageMeta.currentSearchState = {
            currentCar: currentCar,
            coords: coords,
            serviceGubun: serviceGubun,
            partName: partName,
            myAutoQStationCode: myAutoQStationCode
        }

        var tempSendData = COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
            mobAppPrctTim: "A",
            nowPage: loadMoreMode ? nowPage || 1 : 1,
            pageSize: pageSize || 10
        })

        if(currentCar){
            // if(currentCar.carRgstNo && currentCar.carRgstNo.trim().length > 0){
            //     tempSendData["carNo"] = currentCar.carRgstNo.trim();
            // }
            // tempSendData["vin"] = currentCar.vin;
            tempSendData["carNo"] = null;
            tempSendData["vin"] = null;
        }
        
        tempSendData["serviceGubun"] = serviceGubun;

        if(coords){
            tempSendData["lat"] = (coords && (coords.latitude || coords.lat)) || CONSTANT.DEFAULTS_LOCATION.LAT;
            tempSendData["lng"] = (coords && (coords.longtitude || coords.lng)) || CONSTANT.DEFAULTS_LOCATION.LNG;
        }

        console.log(tempSendData);

        var parentThis = this;
        // partLigCd: partName, 부품 코드 (필수 아님)
        // 01 직영서비스, 02 마스터 오토큐, 03 K9/스팅어, 04 친환경 전문, 08 판금, null 전체검색
        // A 전시간대, B 오전시간대, C 오후시간대 (설계서상 A로 고정)
        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.nearAutoqInfoList,
            isMock: false,
            sendData: tempSendData
        })
            .then(function (response) {
                return new Promise(function (resolve) {
                    if (response.resultCode === "200") {
                        var stationList = response.carSvcNearAutoqRnwResListDto;
                        var stationListContainerView = $('#mykia-mycar-find-autoq-station-list');
                        if (stationList && stationList.length > 0) {
                            console.log(stationList);
                            if (loadMoreMode) {
                                parentThis.pageMeta.currentPageNo = nowPage || 1;
                            }
                            else {
                                parentThis.pageMeta.currentPageNo = 1;
                                parentThis.pageMeta.stopLoadingMore = false;
                                $('#mykia-mycar-find-autoq-station-list .div-item').remove();
                                $('#mykia-mycar-find-autoq-station-list .inner-info').remove();
                            }
                            $('#mykia-mycar-find-autoq-station-list #no-data').addClass("none");
                            !loadMoreMode && COMMON_FUNCTION.ROUTO.mapsManager.drawStationListsResults(stationList, parentThis);
                            var stationListElementsContainer = [];
                            if(!loadMoreMode){
                                var stationListNoticeHeaderHtmlString = 
                                    '<div class="inner-info">' +
                                        '<ul>' +
                                            '<li>' +
                                                '<p class="bullet-reference">' +
                                                    '검색 시점의 지도 중앙을 기준으로 거리를 제공합니다.' +
                                                '</p>' +
                                            '</li>' +
                                        '</ul>' +
                                    '</div>';
                                stationListElementsContainer.push($(stationListNoticeHeaderHtmlString));
                            }

                            for (var i = 0; i < stationList.length; i++) {
                                var curNode = stationList[i];
                                var curJQueryObject = COMMON_FUNCTION.TOOL.UI.myKiaAutoQInterface.getAutoQBoxJQueryObject(
                                    curNode, 
                                    KIA_RNW_242_0000, 
                                    currentCar, 
                                    "normal",
                                    null,
                                    true
                                );
                                stationListElementsContainer.push(curJQueryObject);
                            }
                            stationListContainerView.append(stationListElementsContainer);
                            exWNHideIndicator();
                            resolve(stationList);
                        }
                        else {
                            if (loadMoreMode){
                                parentThis.pageMeta.stopLoadingMore = true;
                            }
                            else {
                                $('#mykia-mycar-find-autoq-station-list #no-data').removeClass("none");
                                M.pop.instance('검색결과가 없습니다.');
                                exWNHideIndicator();
                                resolve([]);
                            }
                        }

                        $("#mykia-mycar-find-autoq-station-list").removeClass("none");
                    }
                })
            })
    },

    checkMyAutoQStatus: function (carNumber, carVin, partName) {
        var parentThis = this;
        return new Promise(function (resolve, reject) {
            if (!parentThis.myAutoQStationInfo || parentThis.myAutoQStationInfo === "" || parentThis.myAutoQStationInfo === "undefined") {
                MNet.httpSendAsync({
                    path: _API.SVR.MYCAR.carService.myAutoqAsnInfo_view,
                    isMock: false,
                    sendData: COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
                        carRgstNo: carNumber,
                        vin: carVin
                    })
                })
                .then(function (response) {
                    if (response.resultCode === "200") {
                        var mainAutoQInfo = response;                    }
                    parentThis.myAutoQStationInfo = mainAutoQInfo;

                    resolve();
                })
                .catch(function () {
                    reject();
                })
            }
            else {
                resolve();
            }
        })
    },

    setFilterButtons: function () {
        var parentThis = this;
        return new Promise(function (resolve) {
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqServiceTypeList,
                sendData: COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
                    schFlag: "00"
                }),
                isMock: false,
            })
                .then(function (response) {
                    if (response.resultCode === "200") {
                        var serviceGubunList = response.carSvcAutoqTypeListRnwResDto;
                        parentThis.serviceGubunList = _.map(serviceGubunList, function (element) { return element }); // copy
                        var htmlString = "";
                        if (serviceGubunList) {
                            // !!! 케이스마텍 추헌남 - 전체 검색 옵션이 없을 경우 집어넣어야 함
                            if (!_.find(serviceGubunList, function (element) { return element.serviceCd === "all" })) {
                                serviceGubunList.unshift({
                                    "serviceNm": "전체",
                                    "serviceCd": "all",
                                })
                            }
                            for (var i = 0; i < serviceGubunList.length; i++) {
                                var curNode = serviceGubunList[i];
                                htmlString +=
                                    '<div class="swiper-slide ' + (i === 0 ? "active" : "") + '" data-slide-index="' + i + '">' +
                                        '<button type="button" class="btn-filter" data-filter-type="' + curNode.serviceCd + '">' + curNode.serviceNm + '</button>' +
                                    '</div>';
                            }
                        }
                        $('#mykia-mycar-find-autoq-station-filter').html(htmlString);

                        // ------------------------------
                        // 	Slider
                        // ------------------------------
                        var _sliderFilterList = new Swiper('#mykia-mycar-find-autoq-station-page .slider-filter-list', {
                            spaceBetween: 0,
                            slidesPerView: 'auto',
                            //centeredSlides:true,
                            loopedSlides: 1,
                            loop: false,
                            speed: 300,
                            grapCursor: true,
                            observer: true,
                            observParents: true,
                            resistanceRatio: 0 //드래그 저항비율 제어
                        });

                        // $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
                        //     e.preventDefault();			
                        //     var getSlideIdx = $(this).data('slide-index');
                        //     //console.log('getSlideIdx', getSlideIdx)
                        //     _sliderFilterList.slideTo(getSlideIdx, 300, false);	
                        //     $('.slider-filter-list').find('.active').removeClass('active');
                        //     $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
                        // });

                        $('#mykia-mycar-find-autoq-station-filter button').on("click", function () {
                            var filterType = $(this).data('filter-type');
                            $(this).parent().addClass('active');
                            $(this).parent().siblings().removeClass('active');

                            if (filterType === "all") {
                                parentThis.setNearbyAutoQStationList(
                                    parentThis.currentScopeSelectCar(),
                                    parentThis.pageMeta.currentSearchState.coords,
                                    null,
                                    null,
                                    parentThis.myAutoQStationInfo && parentThis.myAutoQStationInfo.asnCd);
                            }
                            else {
                                //serviceGubun에 넣기
                                parentThis.setNearbyAutoQStationList(
                                    parentThis.currentScopeSelectCar(),
                                    parentThis.pageMeta.currentSearchState.coords,
                                    filterType,
                                    null,
                                    parentThis.myAutoQStationInfo && parentThis.myAutoQStationInfo.asnCd);
                            }
                        });
                        resolve();
                    }
                })
        })
    },

    handleOnListHitsBottom: function () {
        var parentThis = this;
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        var $floatingLayerBody = null; // $('.js-floating-layer-body:visible');

        /* 20220408//(Ina)$floatingLayerBody영역 scrollend 스크립트 추가(s) */
        var scrollEventRunnerCount = 0;
        var scrollEventRunner = setInterval(function(){
            $floatingLayerBody = $('.js-floating-layer-body:visible');
            if(scrollEventRunnerCount > 150){
                clearInterval(scrollEventRunner);
                COMMON_FUNCTION.TOOL.DEBUG.showAdvice("handleOnListHitsBottom : .js-floating-layer-body 로딩 중 타임아웃");
            }
            if($('.js-floating-layer-body:visible').length > 0){
                clearInterval(scrollEventRunner);
                $floatingLayerBody.off("scroll").scroll(function (e) {
                    var $nowTop = $(this).scrollTop();
        
                    //CurrPage.fnMapAreaCtrl();
        
                    if (($floatingLayerBody[0].scrollHeight - Math.ceil($floatingLayerBody.scrollTop())) <= Math.floor($floatingLayerBody.outerHeight())) {
                        if (!parentThis.pageMeta.stopLoadingMore) {
                            var curSearchState = parentThis.pageMeta.currentSearchState;
                            var currentCar = curSearchState.currentCar;
                            var coords = curSearchState.coords;
                            var serviceGubun = curSearchState.serviceGubun;
                            var partName = curSearchState.partName;
                            var myAutoQStationCode = curSearchState.myAutoQStationCode;
                            var nowPage = parentThis.pageMeta.currentPageNo + 1;
                            var pageSize = parentThis.pageMeta.pageSize;
        
                            parentThis.setNearbyAutoQStationList(currentCar, coords, serviceGubun, partName, myAutoQStationCode, nowPage, pageSize, true);
                        }
                    }
        
                    $winTop = $nowTop;
                });
            }
        }, 100);
    },
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_242_0000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_242_0000);
        PGV.loginInfo && COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_242_0000);
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) {
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_242_0000);
        PGV.loginInfo && COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_242_0000);
    }
}; 
