/**

@파일명 : KIA_RNW_242_2000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.01.26 
@메뉴명 :  
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_242_2000 ={
    mapsManager: COMMON_FUNCTION.ROUTO.mapsManager,
    myAutoQStationInfo : MData.param("myAutoQStationInfo"), 
    targetStationInfo: MData.param('targetStationInfo'), // 먼저 stationCode를 받아오기 위해서 param으로 받고, this.setAutoQDetailView에서 다시 재할당
    stationCode: null, // this.init() 에서 할당
    currentGivenDistance: null, // 검색 결과의 거리값을 받아옴, this.init()에서 할당\
    currentScopeSelectCar : MData.param("currentScopeSelectCar"),

    targetStationCode: MData.param("targetStationCode"), //targetStationInfo를 받기 어려운 경우 코드로 넘긴다.

    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        var parentThis = this;

        if(this.targetStationInfo && this.targetStationInfo.hasOwnProperty("asnCd")){
            this.stationCode = this.targetStationInfo.asnCd;
            this.currentGivenDistance = this.targetStationInfo.distance;
        }
        if(this.targetStationInfo && this.targetStationInfo.hasOwnProperty("carSvcDetailAutoqRnwResDto")){
            this.stationCode = this.targetStationInfo.carSvcDetailAutoqRnwResDto.asnCd;
            this.currentGivenDistance = this.targetStationInfo.carSvcDetailAutoqRnwResDto.distance;
        }
        if(this.targetStationInfo && this.targetStationInfo.hasOwnProperty("carSvcMyAutoqRnwResDto")){
            this.stationCode = this.targetStationInfo.carSvcMyAutoqRnwResDto.asnCd;
            this.currentGivenDistance = this.targetStationInfo.carSvcMyAutoqRnwResDto.distance;
        }

        var targetStationCode = this.targetStationInfo.asnCd || this.targetStationCode;

        var myAutoQStationCode = this.myAutoQStationInfo && this.myAutoQStationInfo.asnCd || null;

        var runningFunctionsList = [
            COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.setMapInterface("mykia-mycar-autoq-detail-station-map", KIA_RNW_242_2000, null, true),
            this.setAutoQDetailView(targetStationCode, myAutoQStationCode)
        ]

        if(!this.myAutoQStationInfo || this.myAutoQStationInfo === ""){
            runningFunctionsList.push(
                COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("mapDetail", parentThis.currentScopeSelectCar, KIA_RNW_242_2000)
            );
        }


        Promise.all(runningFunctionsList)
        .then(function(){
            parentThis.mapsManager.drawStationListsResults([parentThis.targetStationInfo], parentThis);
            parentThis.mapsManager.setAdjustedCenter(
                {lat: Math.abs(parseFloat(parentThis.targetStationInfo.mapYcooNm)), lng: Math.abs(parseFloat(parentThis.targetStationInfo.mapXcooNm))}
            );
            $("#mykia-mycar-autoq-detail-view-container").removeClass("none");
            parentThis.setEventListner();
            exWNHideIndicator();
            //parentThis.setPublisherEventListener();
        })
    }, 

    setEventListner: function(){
        var parentThis = this;
        $('.btn-map-close').on("click", function(){
            MPage.back();
        });
        $('#mykia-mycar-autoq-detail-set-myautoq').on("click", function(){
            var curNode = parentThis.targetStationInfo && parentThis.targetStationInfo;
            if(curNode && curNode.asnCd){
                parentThis.onClickSetMyAutoQ(curNode.asnCd);
            }
        });
        $('#mykia-mycar-autoq-detail-station-phone').on("click", function () {
            M.sys.call(extractNumber($(this).text().trim()));
        });
        $('#mykia-mycar-autoq-detail-station-send-location').on("click", function(){
            var curNode = parentThis.targetStationInfo && (parentThis.targetStationInfo.asnCd && parentThis.targetStationInfo || parentThis.targetStationInfo.carSvcDetailAutoqRnwResDto.asnCd) || null;
            if(curNode){
                var stationName = curNode.asnNm;
                var stationCoord = { lat: parseFloat(curNode.mapYcooNm), lng: parseFloat(curNode.mapXcooNm) };
                parentThis.onClickSendLocation(stationName, stationCoord);
            }
        });
       $('#mykia-mycar-autoq-detail-station-copy-address').on("click", function () {
            COMMON_FUNCTION.TOOL.UI.copyToClipboard($('#mykia-mycar-autoq-detail-station-address'), true);
        });
    },

    setAutoQDetailView: function (stationCode, myAutoQStationCode) {
        var parentThis = this;
        return new Promise(function(resolve){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqDetailInfo,
                sendData: COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
                    asnCd: stationCode
                }),
                isMock: false
            })
            .then(function (response) {
                console.log(response);
                if (response.resultCode === "200") {
                    var curNode = response; //.carSvcDetailAutoqRnwResDto;
                    if (curNode.asnCd) {
                        parentThis.targetStationInfo = curNode;
                        var stationCode = curNode.asnCd;
                        var stationName = curNode.asnNm;
                        var stationServiceType = curNode.acps1Nm;
                        var stationCoordinate = { latitude: parseFloat(response.mapYcooNm), longtitude: parseFloat(response.mapXcooNm) };
                        var stationAddress = curNode.pbzAdr;
                        var stationPhoneNo = COMMON_FUNCTION.TOOL.DATA.getFormattedPhoneNo(curNode.repnTn || "");
                        var stationIsReserveAvailable = curNode.reSerVeYn; //"Y" "N"
                        var stationStartTime = moment(curNode.bizStrtCtm, "HHmm");
                        stationStartTime = stationStartTime.isValid() ? stationStartTime.format("HH:mm") : "";
                        var stationEndTime = moment(curNode.bizFnhCtm, "HHmm");
                        stationEndTime = stationEndTime.isValid() ? stationEndTime.format("HH:mm") : "";
                        var stationSpecificNote = curNode.specifics &&
                                                  typeof curNode.specifics === "string" &&
                                                  _.map(curNode.specifics.split("\n"), function(element){
                                                        return COMMON_FUNCTION.TOOL.SECURITY.cleanXSS(element);
                                                    }).join("<br>") || "";
                        var stationOuterImageSrc = curNode.ousdImgPathAdr;
                        var stationInnerImageSrc = curNode.insdImgPathAdr;
                        var stationImageSrc = curNode.oipf1Nm;
                        
                        if(COMMON_FUNCTION.TOOL.DATA.hasAtLeastOneOwnedCar()){
                            if(stationCode === myAutoQStationCode){
                                $('#mykia-mycar-autoq-detail-set-myautoq').addClass('none');
                                $('#mykia-mycar-autoq-detail-myautoq-badge').removeClass('none');
                            }
                            else{
                                $('#mykia-mycar-autoq-detail-set-myautoq').removeClass('none');
                                $('#mykia-mycar-autoq-detail-myautoq-badge').addClass('none');
                            }
                        }
                        else{
                            $('#mykia-mycar-autoq-detail-set-myautoq').addClass('none');
                            $('#mykia-mycar-autoq-detail-myautoq-badge').addClass('none');
                        }
    
                        if(parentThis.currentGivenDistance){
                            var targetDistance = parseInt(parentThis.currentGivenDistance) > 1000 ? 
                                                ((parseInt(parentThis.currentGivenDistance) / 1000).toFixed(1) + "km ") : 
                                                (parentThis.currentGivenDistance + "m ");
                            $('#mykia-mycar-autoq-detail-station-distance').text(targetDistance);
                        }
                        else{
                            $('#mykia-mycar-autoq-detail-station-distance').addClass("none");
                        }
                        $("#mykia-mycar-autoq-detail-station-service-type").text(stationServiceType);
                        $('#mykia-mycar-autoq-detail-station-name').text(stationName);
                        $('#mykia-mycar-autoq-detail-station-address').text(stationAddress || "주소 없음");
                        $('#mykia-mycar-autoq-detail-station-phone').text(stationPhoneNo);
                        if(stationStartTime && stationEndTime && stationStartTime.trim().length > 0 && stationEndTime.trim().length > 0){
                            $('#mykia-mycar-autoq-detail-station-time').text(stationStartTime + '~' + stationEndTime);
                        }
                        else{
                            $('#mykia-mycar-autoq-detail-station-time').addClass("none");
                        }
    
                        if(stationSpecificNote && stationSpecificNote.trim().length > 0){
                            $('#mykia-mycar-autoq-detail-station-note').html(stationSpecificNote);
                        }
                        else{
                            $('#mykia-mycar-autoq-detail-station-note').text("예약 특이사항이 없습니다.");
                        }
    
                        if(stationImageSrc && typeof stationImageSrc === "string" && stationImageSrc.length > 0 && stationServiceType === "직영서비스"){
                            $('#mykia-mycar-autoq-detail-station-img').attr('src', stationImageSrc);
                            $('#mykia-mycar-autoq-detail-station-img-container').removeClass('none');
                        }
                    }
                }
                resolve();
            })
        })
    },

    onClickSetMyAutoQ: function(targetStationCode){
        console.log("throwing onsetmyautoq", COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
            asnCd: targetStationCode
        }))
        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.updateMainAutoq,
            isMock: false,
            sendData: COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
                asnCd: targetStationCode
            })
        })
        .then(function(response){
            console.log(response)
            if(response.resultCode === "200"){
                if(response.updYn === "Y"){
                    $('#mykia-mycar-autoq-detail-set-myautoq').addClass('none');
                    $('#mykia-mycar-autoq-detail-myautoq-badge').removeClass('none');
                    M.pop.instance('전담 정비소로 설정되었습니다.')
                }
                else{
                    M.pop.instance('전담 정비소 설정에 실패하였습니다.')
                }
                exWNHideIndicator();
            }
        })
    },

    onClickSendLocation: function(stationName, stationCoord){
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_242_1000.path, function () {
            var parentThis = this;
            var closePopup = function (e, parentThis) {
                e.preventDefault();

                parentThis.fadeOut('fast');
                parentThis.find('.popup-wrap').removeClass('is-ani');

                $('body').removeClass('js-overflow-hidden');
            }
            this.find("ul li").off("click").on("click", function (e) {
                var targetApp = $(this).data('target-app');
                switch(targetApp){
                    case "kakaomap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('k', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "tmap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('t', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "kia-connect":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('kc', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                }
                closePopup(e, parentThis);
            })
            this.find('#mykia-close-popup').off("click").on("click", function (e) {
                closePopup(e, parentThis);
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_242_2000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
