/**

@파일명 : KIA_RNW_243_1000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 정비 예약 현황/내역정비 예약 탭 
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_243_1000 ={ 
    /*
        <<< defaultSelectCar, currentScopeSelectCar와 currentSelectedCar 차이점 >>>

        defaultSelectCar - 현재 홈에서 선택된 차
        currentScopeSelectCar - 현재 내 차 관리 섹션에서 선택된 차
        currentSelectedCar - 이 차량 선택 페이지에서 선택한 차 
        (이 항목이 <currentSelectedCar> 다음 페이지의 currentReservationInfo 객체 안에 저장된 채로 param으로 넘어갑니다)
     */
    carList:  MData.param('carList'),
    defaultSelectCar: MData.param('defaultSelectCar'),
    currentScopeSelectCar: MData.param('currentScopeSelectCar'),

    /* !!! 케이스마텍 추헌남 - 예약 정보 작성이 여기서부터 시작됩니다. param으로 다음 페이지에 계속 넘어갑니다. */
    currentReservationInfo: {
        myAutoQStationInfo : MData.global('passData').autoQ && MData.global('passData').autoQ.myAutoQStationInfo , // this.attemptGoingToNextPage 에서 할당
        availableDateTimes: null, // this.attemptGoingToNextPage 에서 할당 (myAutoQ 가 있을 경우 myAutoQ에 대한 가능한 시간대)
        currentSelectedCar: null, // this.attemptGoingToNextPage 에서 할당
        targetStationInfo: null,
        targetStationAvailableDateTimes: null, // KIA_RNW_243_3100의 this.setNextButton 함수에서 설정합니다.
        partNameList: null, // this.attemptGoingToNextPage 에서 할당, KIA_RNW_243_6000 에서 파트명들 출력용
        partLigCd: null, // this.attemptGoingToNextPage 에서 할당
        prctSbc: null, // this.attemptGoingToNextPage 에서 할당
        isDTDSupported: false, // this.checkConditions 에서 할당
        isRsvYnInfo: null, // this.checkBeforeGoingToNextPage 에서 할당, 예약 가능 및 가능한 프리케어 목록을 출력하는 객체입니다.
        freecareGrnYmd: null, // this.checkBeforeGoingToNextPage 에서 할당, 프리케어 만료일자 // 2024.04.25 freecareGrnYmd 변수 사용 중지, 사유 : 프리케어 항목별 만료일자 각각 체크
        freecareSelectYn: null, // this.checkBeforeGoingToNextPage 에서 할당, 프리케어 정비항목 선택여부
        freecareSelectList: null, // this.checkBeforeGoingToNextPage 에서 할당, 프리케어 정비항목 선택 List
        KDeliveryInfo: {
            serviceType: null,
            pickupAddress01: null,
            pickupAddress02: null,
            deliveryAddress01: null,
            deliveryAddress02: null,
            prctSbc: null
        },
        DTDTotalCount: 0, // K딜리버리 서비스 총 횟수
        DTDUsedCount: 0,  // K딜리버리 서비스 사용 횟수
        DTDGrnYmd: null,  // K딜리버리 서비스 만료일
        DTDRprYn: null,   // K딜리버리 서비스 만료 여부
        prctCdt: null,
        prctCtm: null,
        prctSbc: null
    },
    
    init: function(){ 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        exWNShowIndicator();
        // !!! 케이스마텍 추헌남 - carNumber 받아오기
        if(this.hasMoreThanTwoCars()){
            this.setCarList(this.carList);
            exWNHideIndicator();
        }
        else{
            this.attemptGoingToNextPage(this.carList.myCarInfoListResDto[0]);
        }

        this.setPublisherEventListeners();
        this.setEventListner();
    },

    setEventListner: function(){
        var parentThis = this;
        $('#mykia-mycar-reserve-next').on("click", function(){
            if(!$(this).hasClass('disabled')){
                var curVin = $('.mykia-mycar-reserve-car-item.active').data('vin');
                var currentSelectedCar = _.find(parentThis.carList.myCarInfoListResDto, function(element){return element.vin === curVin});
                parentThis.attemptGoingToNextPage(currentSelectedCar);
            }
        })
        $('.mykia-mycar-reserve-car-item').on("click", function(){
            if($('.mykia-mycar-reserve-car-item.active').length > 0){
                $('#mykia-mycar-reserve-next').removeClass('disabled');
            }
            else{
                $('#mykia-mycar-reserve-next').addClass('disabled');
            }
        })
    },
    
    setPublisherEventListeners: function(){
        $('.js-active-btn').on('click', function(e) {
            e.preventDefault();
            $(this).toggleClass('active').siblings().removeClass('active');
        });
        
        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			$winTop = $nowTop;
			
		});
    },

    hasMoreThanTwoCars: function(){
        if(typeof this.carList !== "string" && typeof this.carList !== "undefined"  && this.carList.myCarInfoListResDto){
            if(this.carList.myCarInfoListResDto.length === 1){
                return false; 
            }
            else{
                return true;
            }
        }
        COMMON_FUNCTION.TOOL.DEBUG.showAdvice("this.hasMoreThanTwoCars : carList를 불러오는 도중에 문제가 발생했습니다.");
    },

    setCarList: function(carList){
        $(".section-01").removeClass("none");
        $(".pos-bottom").removeClass("none");

        var htmlString = ""
        
        var availableCarList = carList.myCarInfoListResDto;
        var contractCarList = carList.unDeliveryCarInfoListResDto;

        var representativeCarNode = _.find(availableCarList, function(element){return element.dispNo === 1}) || availableCarList[0];

        for(var i = 0; i < availableCarList.length; i++){
            var curNode = availableCarList[i];
            var isDefaultSelectedCar = this.defaultSelectCar.vin === curNode.vin;
            
            htmlString += COMMON_FUNCTION.TOOL.UI.myKiaReserveInterface.getReserveCarEntryHTML(
                this.defaultSelectCar,
                this.currentScopeSelectCar,
                curNode,
                false,
                representativeCarNode,
                true
            );
            
            // if(isDefaultSelectedCar){
            //     $('#mykia-mycar-reserve-next').removeClass('disabled');
            // }
        }

        for (var i = 0; i < contractCarList.length; i++){
            var curNode = contractCarList[i];

            htmlString += COMMON_FUNCTION.TOOL.UI.myKiaReserveInterface.getReserveCarEntryHTML(
                this.defaultSelectCar, 
                this.currentScopeSelectCar, 
                curNode, 
                true,
                representativeCarNode,
                true
            );
        }

        $('#mykia-mycar-reserve-carlist').html(htmlString);
    },

    attemptGoingToNextPage: function(currentSelectedCar){
        var parentThis = this;
        this.checkBeforeGoingToNextPage(currentSelectedCar)
        .then(function(hasPassedCondition){
            if(hasPassedCondition){
                parentThis.currentReservationInfo["currentSelectedCar"] = currentSelectedCar;
                MPage.html({
                    path: PATH_MANAGER.KIA_RNW_243_2000.path,
                    param: {
                        currentReservationInfo: parentThis.currentReservationInfo
                    }
                })
            }
        })
    },

    checkBeforeGoingToNextPage: function(currentSelectedCar){
        var parentThis = this;
        return new Promise(function(resolve){
            exWNShowIndicator();
            /* 차량 번호 여부 확인 */
            var hasNoCarNumber = false;
            /* 차량 번호가 없을 경우 */
            if( currentSelectedCar && 
                (typeof currentSelectedCar.carRgstNo !== "string" ||
                !(currentSelectedCar.carRgstNo.trim().length > 0))){
                hasNoCarNumber = true;
                M.pop.alert({
                    title: '차량번호를 등록해 주세요.',
                    message: '정비를 진행할 차량의 차량번호를 등록 후\n정비 예약 서비스를 이용하실 수 있습니다.',
                    buttons: ['확인', '차량 번호 등록'],
                    callback: function (index) {
                        switch(index){
                            case 0:
                                if(!KIA_RNW_243_1000.hasMoreThanTwoCars()) MPage.back();
                                exWNHideIndicator();
                                break;
                            case 1:
                                // !!! 케이스마텍 추헌남 - 실운행자일 경우 차량 번호 등록 불가 처리
                                if(currentSelectedCar.rdmYn === "Y"){ // N : 차주, Y : 실운행자 dispNo === "0" 인 경우 소유주
                                    MPopup.instance("실소유자가 아닌 경우 변경할 수 없습니다.");
                                    exWNHideIndicator();
                                }
                                else{
                                    MPage.html({
                                        path: PATH_MANAGER.KIA_RNW_127_6000.path,
                                        param: {
                                            carInfo : currentSelectedCar
                                        }
                                    });
                                }
                                break;
                        }
                    }
                });
                resolve(false);
            }
            
            /* 정비 예약 중복 여부 확인 */
            if (!hasNoCarNumber){
                var targetSendData = {
                    mbrId: PGV.loginInfo.mbrId,
                    carRgstNo: currentSelectedCar.carRgstNo,
                    vin: currentSelectedCar.vin
                }
                COMMON_FUNCTION.TOOL.DATA.getTrvgDist(currentSelectedCar).then(function(response){
                    var trvgDist = response.trvgDist;
                    if(trvgDist) targetSendData["trvgDist"] = trvgDist;
                    console.log("request body for : ", targetSendData);
                    MNet.httpSendAsync({
                        path: _API.SVR.MYCAR.carService.isRsvYnInfo,
                        isMock: false,
                        sendData: targetSendData
                    })
                    .then(function(response){
                        console.log(response);
                        if(response.resultCode === "200"){
                            var result = response;
                            var isReservationAvailable = result.isRsvYn === "Y"; // !!! 케이스마텍 추헌남 - rsvYn Y로 설정하기
    
                            parentThis.currentReservationInfo["isRsvYnInfo"] = response;
    
                            if (!isReservationAvailable){
                                M.pop.alert({
                                    title: '이미 예약한 정비 내역이 있습니다.',
                                    message: '중복으로 예약이 불가합니다.\n다른 날짜로 정비 예약을 원하시는 경우\n정비 예약 내역에서 예약 취소 후 다시 진행해 주세요.',
                                    buttons: ['확인', '정비 예약 내역'],
                                    callback: function (index) {
                                        switch(index){
                                            case 0:
                                                if(!KIA_RNW_243_1000.hasMoreThanTwoCars()) MPage.back();
                                                exWNHideIndicator();
                                                break;
                                            case 1:
                                                MPage.html({
                                                    path: PATH_MANAGER.KIA_RNW_244_1000.path
                                                })
                                                break;
                                        }
                                    }
                                });
                                resolve(false);
                            }
                            resolve(true);
                        }
                    })

                })
                
            }
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_1000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
