/**

@파일명 : KIA_RNW_243_2000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.04.06 
@메뉴명 : 내 차 관리 탭 > 정비 탭 > 정비 예약 > 정비 예약 정비 항목
@DESC : 권한 확인 중
*/ 
var CurrPage; 
var KIA_RNW_243_2000 ={
    isReservationAvailable: false, // this.checkConditions 에서 할당
    currentSelectedCar: typeof MData.param("currentReservationInfo") === "object" && MData.param("currentReservationInfo").currentSelectedCar,
    currentReservationInfo: MData.param("currentReservationInfo"),

    myAutoQCheckResult: null,

    isTooManyPartsSelectedPopupOpened: false,
    
    init: function(){ 
        CurrPage = this;
        // !!! 케이스마텍 추헌남 - 필요 변수 - myAutoQStationCode
        var parentThis = this;

        var carNumber = this.currentSelectedCar && this.currentSelectedCar.carRgstNo;
        var carVin = this.currentSelectedCar && this.currentSelectedCar.vin;
        var vehlRepnCd = this.currentSelectedCar && this.currentSelectedCar.vehlRepnCd;
        this.checkConditions(carNumber, carVin)
        .then(function(response){
            var filteredReplaceRequiredPartsList = _.filter(response.replaceRequiredPartsList, function(element){return _.contains(["1", "2"], element.exchStatus)});
            if(filteredReplaceRequiredPartsList && filteredReplaceRequiredPartsList.length > 0){
                parentThis.showReplaceNeededPopup(filteredReplaceRequiredPartsList.length, filteredReplaceRequiredPartsList);
            }
            /* !!! 케이스마텍 추헌남 - 프리케어 필터 설정 후 이 안에서 parentThis.setPublisherEventListener(); 실행합니다. */
            parentThis.checkAndSetFreecareFilterAndSection(response);
            parentThis.setEventListner(vehlRepnCd);
            exWNHideIndicator();
        })
        
        COMMON_FUNCTION.TOOL.UI.myKiaReserveInterface.handleBackKey();
    }, 

    setEventListner: function(vehlRepnCd){
        var parentThis = this;

        $('ul.chk-form-list div.form-field').on("click", function(e){
            e.preventDefault();
            e.stopPropagation();

            /* 해당 체크 박스가 disabled 상태면 넘어가기 */
            if($(this).find("input").prop("disabled")) return;

            /* 체크 박스 개수가 12개를 넘으면 오류메시지 출력 */
            var checkedCount = $('ul.chk-form-list li input:checked').length + ($(this).find("input").prop("checked") === true ? -1 : 1); // 체크될 예정을 반영 (체크가 빠질 예정 / 체크가 될 예정)
            if(checkedCount > 12){
                var innerParentThis = this;
                if(!parentThis.isTooManyPartsSelectedPopupOpened){
                    parentThis.isTooManyPartsSelectedPopupOpened = true;
                    MPopup.confirm({
                        title : "정비 항목이 너무 많습니다.",
                        message : "정비 항목을 줄이거나 정비 요청사항에 입력해 주세요.",
                        buttons : ["확인"],
                        callback: function(){
                            parentThis.isTooManyPartsSelectedPopupOpened = false;
                            $(innerParentThis).find('input').prop('checked', false);
                            var checkedCount = $('ul.chk-form-list li input:checked').length;
                            $('#mykia-mycar-reserve-parts-selected-count').text(checkedCount);
                            var parentContainer = $(innerParentThis).parent().parent().parent().parent();
                            var localTotalCount = parentContainer.find("input:checked").length;
                            parentContainer.find("span.num b").text(localTotalCount);
                        }
                    })
                }

                return;
            }

            /* 체크박스 체크 처리 */
            var currentCheckBox = $(this).find("input");
            if(currentCheckBox.prop("checked") === true){
                currentCheckBox.prop("checked", false);
            }
            else{
                currentCheckBox.prop("checked", true);
            }

            /* 체크박스 체크 처리 후 화면에 체크된 개수 반영 */
            var parentContainer = $(this).parent().parent().parent().parent();
        	var localTotalCount = parentContainer.find("input:checked").length;
        	parentContainer.find("span.num b").text(localTotalCount);

            /* 1개 이상 체크되었을 경우 다음 버튼 활성화 */
            $('#mykia-mycar-reserve-parts-selected-count').text(checkedCount);
            if(checkedCount > 0){
                $("#mykia-mycar-reserve-parts-next").removeClass('disabled');
            }
            else{
                $("#mykia-mycar-reserve-parts-next").addClass('disabled');
            }
        })

        $('#mykia-mycar-reserve-parts-reset-selection').on("click", function(){
            $('.chk-form-cont .div-title span.num b').text(0);
            $('ul.chk-form-list li input:checked').prop('checked', false);
            $('#mykia-mycar-reserve-parts-selected-count').text("0");
            $("#mykia-mycar-reserve-parts-next").addClass("disabled");
        })

        $('#mykia-mycar-reserve-parts-next').on("click", function(){
            parentThis.attemptGoingToNextPage();
        })

        $('#mykia-mycar-reserve-parts-call-trc').on("click", function(){
            M.sys.call(extractNumber($(this).text().trim().split(" ")[1]));
        })

        $("#mykia-mycar-reserve-parts-go-find-autoq").on("click", function(){
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_242_0000.path,
                param: {
                    currentScopeSelectCar: parentThis.currentReservationInfo.currentSelectedCar
                }
            })
        })
        $("#mykia-mycar-reserve-parts-dtd-info-popup").on("click", function(){
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_252_1000.path
            })
        })
    },

    setPublisherEventListener: function(){
        /* 각 메뉴별 Scroll Position 목록을 만든다. */
        var nScrollPos = [];
        var nScrollPosNum = 0;
    
        $('section:visible .div-item:visible').each(function(idx, item) {
            nScrollPos[nScrollPosNum] = $(this).offset().top - ($('.slider-filter-cont').outerHeight() * 2);
            nScrollPosNum++;
        });
        // var $filterListContHeight = fnCheckDevice() == 'android' ? $('.slider-filter-cont').outerHeight() * 1.3 : $('.slider-filter-cont').outerHeight() * 2;
        // var $divItemWrap = $('.js-div-item-wrap');
        // var $divItemWrapTop = $('.js-div-item-wrap').offset().top - 200;
        
        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });
        
        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();			
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)
        
            if ($('.slider-filter-cont').hasClass('is-sticky')) {
                var $divItemTop;
                var $scrollEnd = $(document).height() - $(window).height();
        
                if (getSlideIdx == 0) {
                    _sliderFilterList.slideTo(0, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                    $('html, body').stop().animate({scrollTop:0}, 300, 'swing');
                }
                else{
                    //var currentIndex = $(this).index() - 1;
                    console.log("curindex:", getSlideIdx)
                    var currentPartScrollTop = nScrollPos[getSlideIdx - 1];
                    $('html, body').stop().animate({scrollTop:currentPartScrollTop}, 300, 'swing');
                }
            }
        
        });
        
        // ------------------------------
        // 	Scroll
        // ------------------------------
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
    
        
        $(window).scroll(function(e) {
            var $nowTop = $(this).scrollTop();
            // console.log($nowTop);
            
            /* 각 메뉴별 Scroll Position을 재계산한다. 상단 fixed 슬라이더 바가 position을 수시로 다르게 만든다. */
            var nScrollPosNum = 0;
            $('section:visible .div-item:visible').each(function(idx, item) {
                if($('body').is(".js-filter-list-fixed")){
                    nScrollPos[nScrollPosNum] = $(this).offset().top - $('.slider-filter-cont').outerHeight();
                    nScrollPosNum++;
                }
                else{
                    nScrollPos[nScrollPosNum] = $(this).offset().top - ($('.slider-filter-cont').outerHeight() * 2);
                    nScrollPosNum++;
                }
            });
    
    
            for (var i = 0; i< nScrollPos.length; i++) {
                /* 꼭대기일 경우 */
                if(i === 0 && $nowTop < nScrollPos[i]){
                    _sliderFilterList.slideTo(0, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                }
    
                var eachPartScrollTop = nScrollPos[i];
                var nextEachPartScrollTop = i === nScrollPos.length - 1 ? ($(document).height() - $(window).height()) : nScrollPos[i + 1];
                
                if (eachPartScrollTop - 10 < $nowTop && $nowTop < nextEachPartScrollTop) {
                    _sliderFilterList.slideTo(i, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index]:visible').eq(i + 1).addClass('active');
                }
                
                /* 바닥에 도달했을 경우 */
                if ($nowTop + 5 >= ($(document).height() - $(window).height())) {
                    _sliderFilterList.slideTo(nScrollPos.length, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=' + nScrollPos.length + ']').addClass('active');
                }
            }
        
            if ($nowTop > 100) {
                $('body').addClass('js-filter-list-fixed');
            }
            else {
                // scroll up
                if (Math.floor($nowTop) >= 0) {
                    $('body').removeClass('js-filter-list-fixed');
                    _sliderFilterList.slideTo(0, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                }
            }
        
            $winTop = $nowTop;
            
        });
    },

    checkMyAutoQStatus: function(carNumber, carVin, partName){
        return MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.myAutoqAsnInfo_view,
            isMock: false,
            sendData: {
                mbrId: PGV.loginInfo.mbrId,
                carRgstNo: carNumber,
                vin: carVin,
                partLigCd: partName
            }
        })
    },

    checkAutoQAvailableTime: function(stationCode, carNumber, carVin, partName){
        return MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.schAutoqYmdList,
            isMock: false,
            sendData: {
                mbrId: PGV.loginInfo.mbrId,
                asnCd: stationCode,
                partLigCd: partName,
                carRgstNo: carNumber,
                vin: carVin,
                mobPrctTim: "A"
            }
        })
    },

    checkConditions: function(carNumber, carVin){
        var parentThis = this;
        return new Promise(function(resolve){
            /* KIA_RNW_243_1000.checkBeforeGoingToNextPage에서 받은 예약 가능 여부 및 프리케어 정보를 여기서 받습니다. */
            var response = typeof parentThis.currentReservationInfo === "object" && parentThis.currentReservationInfo.isRsvYnInfo;
            if(response.resultCode === "200"){
                var result = response;
                var isReservationAvailable = response.isRsvYn;
                var freecareList = response.freecareList;
                var isFreecareAvailable = freecareList && freecareList.length > 0 // response.freecareYn;
                var replaceRequiredPartsCount = parseInt(result.exchCycleCnt);
                var replaceRequiredPartsList = result.exchCycleList;

                if (freecareList && freecareList.length > 0){ //isFreecareAvailable === "Y" && 
                    for(var i = 0; i < freecareList.length; i++){
                        var curNode = freecareList[i];
                        var designatedCount = parseInt(curNode.apimOft);
                        var useCount = parseInt(curNode.vinCnt);
                        var grnYmd = curNode.grnYmd;
                        var rprYn = curNode.rprYn;
                        var isDTDSupported = curNode.dtdYn;

                        if(isDTDSupported === "Y"){
                            parentThis.currentReservationInfo.isDTDSupported = true;
                            parentThis.currentReservationInfo.DTDTotalCount += designatedCount;
                            parentThis.currentReservationInfo.DTDUsedCount += useCount;
                            parentThis.currentReservationInfo.DTDGrnYmd = grnYmd;
                            parentThis.currentReservationInfo.DTDRprYn = rprYn;
                        }
                    }
                }

                parentThis.isReservationAvailable = isReservationAvailable === "Y" ? true : false;
                
                // ??? 케이스마텍 추헌남 - 정비 예약 마감 여부는 확인 불가
                // console.log(replaceRequiredPartsCount, replaceRequiredPartsList)

                resolve({
                    isFreecareAvailable: isFreecareAvailable,
                    freecareList: freecareList,
                    isDTDSupported: isDTDSupported,
                    DTDTotalCount: parentThis.currentReservationInfo.DTDTotalCount,
                    DTDUsedCount: parentThis.currentReservationInfo.DTDUsedCount,
                    DTDGrnYmd: parentThis.currentReservationInfo.DTDGrnYmd,
                    DTDRprYn: parentThis.currentReservationInfo.DTDRprYn,
                    replaceRequiredPartsCount: replaceRequiredPartsCount || 0,
                    replaceRequiredPartsList: replaceRequiredPartsList || []
                });
            }
        })
    },

    showReplaceNeededPopup: function(replaceRequiredPartsCount, replaceRequiredPartsList){
        var partsDict = {
            "엔진오일 및 필터": "엔진오일",
            "공조장치용 에어필터": "에어컨 필터",
            "타이어 위치교체": null,
            "에어클리너 필터": "에어컨 필터",
            "브레이크패드(Rr.디스크)": "브레이크 패드",
            "부동액": "부동액",
            "브레이크 패드(Frt)": "브레이크 패드",
            "구동벨트": null,
            "연료필터": "연료 필터"
        }
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_243_2200.path, function(){
            var convertedRequiredPartsList = _.uniq(_.map(
                _.filter(replaceRequiredPartsList, function(element){return partsDict[element.exchNm] && _.contains(["1", "2"], element.exchStatus)}),
                function(element){return partsDict[element.exchNm]}
            ))
            var descriptions = convertedRequiredPartsList.join(", ");
            this.find('#mykia-mycar-reserve-parts-replace-needed-count').text(convertedRequiredPartsList.length);
            this.find('#mykia-mycar-reserve-parts-replace-needed-descriptions').text(descriptions);
            this.find('#popDetailBtn').off().on("click", function(){
                for (var i = 0; i < convertedRequiredPartsList.length; i++){
                    var curNode = convertedRequiredPartsList[i];
                    curNode && $('label span:contains("' + curNode +'")').click(); //prop("checked", true)
                }
                $(".js-popup-close-btn").click();
            })
        });
    },

    checkAndSetFreecareFilterAndSection: function(response){
        if(response.isFreecareAvailable){
            $('#mykia-mycar-reserve-parts-freecare-section').removeClass('none');
            $('#mykia-mycar-reserve-parts-freecare-filter').removeClass('none');
        }
        else{
            $('#mykia-mycar-reserve-parts-freecare-section').addClass('none');
            $('#mykia-mycar-reserve-parts-freecare-filter').addClass('none');
        }
        
        /* 필터 버튼 설정 */
        $("[data-slide-index]:hidden").removeAttr("data-slide-index").remove();
        var filterList = $("[data-slide-index]:visible");
        for (var i = 0; i < filterList.length; i++){
            var curNode = $(filterList[i]);
            curNode.attr("data-slide-index", i);
        }

        $(".div-item:hidden").remove();
        var divList = $(".div-item");
        for (var i = 0; i < divList.length; i++){
            var curNode = $(divList[i]);
            curNode.attr("id", "divItem_" + i);
        }

        if(response.isFreecareAvailable){
            /* 프리케어 선택 섹션 설정 */
            var freecareList = response.freecareList;

            /* 2023.07.13 프리케어 만료일자 검증 관련 */
            // 2024.04.25 freecareGrnYmd 변수 사용 중지, 사유 : 프리케어 항목별 만료일자 각각 체크
            // if (freecareList.length > 0 && freecareList[0]){
            //     this.currentReservationInfo.freecareGrnYmd = freecareList[0].grnYmd; // 프리케어 만료일자 (정비항목과 무관하게 만료일자는 통일이므로 0번째 항목에서 가져옴)
            // }

            var htmlString = "";
            for(var i = 0; i < freecareList.length; i++){
                var curNode = freecareList[i];
                var usedCount = parseInt(curNode.vinCnt);
                usedCount = typeof usedCount === "number" && usedCount || 0;
                var designatedCount = parseInt(curNode.apimOft);
                designatedCount = typeof designatedCount === "number" && designatedCount || 0;
                var totalRemainingCount = designatedCount - usedCount;
                var currentDOMId = "chkOption1-" + i.toString();
                // var currentPartName = curNode.cdValNm;
                var currentPartName = curNode.pckgNm;
                var salePckgCd = curNode.salePckgCd;

                var isExhausted = totalRemainingCount === 0;
                var isUnavailable = typeof curNode.rprYn === "string" && curNode.rprYn.trim().length > 0;
                var isDisabled = (isExhausted || isUnavailable) ? "disabled" : "";
                var UnavailableType = isUnavailable && curNode.rprYn.substring(curNode.rprYn.indexOf("(")+1, curNode.rprYn.indexOf(")"));

                // if(currentPartName === "도어 투 도어") currentPartName = "K딜리버리";
                if(currentPartName === "도어 투 도어" || currentPartName.toUpperCase().indexOf("DOOR") > -1) currentPartName = "K딜리버리";
                if(currentPartName === "K딜리버리") continue;

                htmlString += 
                    '<li class="d-flex justify-content-between ' + isDisabled + '">' +
                        '<div class="form-field">' +
                            '<div class="chk-cont chk-size-m">' +
                                '<input type="checkbox" name="' + currentDOMId + '" id="' + currentDOMId + '" data-important-order="99" ' + ' data-sale-pckg-cd="'+ salePckgCd +'" ' + isDisabled + '>' +
                                '<label for="' + currentDOMId + '">' +
                                    '<span>' + currentPartName  + '</span>' +
                                '</label>' +
                            '</div>' +
                        '</div>' +
                        '<span class="unit">' +
                            (
                                isUnavailable ? UnavailableType + ' 만료' :
                                    (isExhausted ? "소진" : 
                                        totalRemainingCount + '/' + designatedCount 
                                    )
                            ) + 
                        '</span>' +
                    '</li>';
            }

            $("#mykia-mycar-reserve-parts-freecare-selection-list").html(htmlString);


            /* DTD (K딜리버리) 사용 가능 개수 설정 */
            console.log("isDTDSupported check:", response);
            if(response.DTDTotalCount > 0){ //if(response.isDTDSupported){
                var DTDAvailableCount = response.DTDTotalCount - response.DTDUsedCount;

                if (typeof response.DTDRprYn === "string" && response.DTDRprYn.trim().length > 0) {
                    var isUnavailable = typeof response.DTDRprYn === "string" && response.DTDRprYn.trim().length > 0;
                    var UnavailableType = isUnavailable && response.DTDRprYn.substring(response.DTDRprYn.indexOf("(")+1, response.DTDRprYn.indexOf(")"));

                    $("#mykia-mycar-reserve-parts-dtd-unavailable").text(UnavailableType + ' 만료');
                    $("#mykia-mycar-reserve-parts-dtd-unavailable").removeClass("none");
                    $("#mykia-mycar-reserve-parts-dtd-available").addClass("none");
                } else {
                    $("#mykia-mycar-reserve-parts-dtd-available-count").text(DTDAvailableCount);
                    $("#mykia-mycar-reserve-parts-dtd-total-count").text(response.DTDTotalCount);
                    $("#mykia-mycar-reserve-parts-dtd-available").removeClass("none");
                    $("#mykia-mycar-reserve-parts-dtd-unavailable").addClass("none");
                }
                $("#mykia-mycar-reserve-parts-dtd-container").removeClass("none");
            }
            else{
                $("#mykia-mycar-reserve-parts-dtd-container").addClass("none");
            }

        }

        this.setPublisherEventListener();
    },

    showBeforeClosePopup: function(){
        M.pop.alert({
            title: '정비 예약을 종료하시겠습니까?',
            message: '정비 예약을 종료하실 경우 작성한 내용이 모두 사라집니다.',
            buttons: ['네', '아니오'],
            callback: function (index) {
                switch(index){
                    case 0:
                        MPage.back();
                        break;
                    case 1:
                        break;
                }
            }
        });
    },

    attemptGoingToNextPage: function(){
        /* 선택 항목 수집 */
        var inputList = $('ul.chk-form-list li input:checked');
        var selectedAllPartsList = [];
        for(var i = 0; i < inputList.length; i++){
            var curJQueryNode = $(inputList[i]);
            selectedAllPartsList.push({
                partDescription: curJQueryNode.parent().find("label span").text().trim(),
                importantOrder: curJQueryNode.data("important-order"),
                currentJQueryNode : curJQueryNode
            });
        }

        console.log("# attemptGoingToNextPage start");

        /* 수집된 선택 항목으로 해당하는 partLigCd, prctSbc 생성 */
        if (selectedAllPartsList.length > 0){
            var selectedFreeCareList = _.filter(selectedAllPartsList, function(element){return element.currentJQueryNode.parent().parent().parent().parent().data("freecare-yn") === "Y"});
            var selectedNormalPartsList = _.filter(selectedAllPartsList, function(element){return element.currentJQueryNode.parent().parent().parent().parent().data("freecare-yn") !== "Y"});
            var requestText = "";

            /* 2023.07.13 프리케어 만료일자 검증 */
            this.currentReservationInfo.freecareSelectYn = null; // 프리케어 정비항목 선택여부 초기화

            if (selectedFreeCareList.length > 0){
                requestText += "[프리케어]";
                var freecarePartsDescriptionList = [];
                var freecareSelectList = [];
                for (var i = 0; i < selectedFreeCareList.length; i++){
                    var curNode = selectedFreeCareList[i];
                    freecarePartsDescriptionList.push(curNode.partDescription);

                    var salePckgCd = curNode.currentJQueryNode.data("sale-pckg-cd");
                    this.currentReservationInfo.isRsvYnInfo.freecareList.forEach(function(freecare) {
                        if(freecare.salePckgCd == salePckgCd) {
                            freecareSelectList.push(freecare);
                        }
                    });
                }
                requestText += freecarePartsDescriptionList.join("/");

                /* 2023.07.13 프리케어 만료일자 검증 */
                this.currentReservationInfo.freecareSelectYn = "Y"; // 프리케어 정비항목 선택여부 true
                this.currentReservationInfo.freecareSelectList = !isEmpty(freecareSelectList) ? freecareSelectList : null; // 프리케어 정비항목 선택 List 를 Global 변수에 담는다
            }

            if (selectedNormalPartsList.length > 0){
                requestText += "[정비내용]";
                var normalPartsDescriptionList = [];
                for (var i = 0; i < selectedNormalPartsList.length; i++){
                    var curNode = selectedNormalPartsList[i];
                    normalPartsDescriptionList.push(curNode.partDescription);
                }
                requestText += normalPartsDescriptionList.join("/");
            }

            var mostImportantPartElement = _.min(selectedAllPartsList, function(element){return parseInt(element.importantOrder)});
            var mostImportantPartCode = mostImportantPartElement.currentJQueryNode.parent().parent().parent().parent().data("deliver-code");
            var mostImportantOrder = mostImportantPartElement.importantOrder;

            this.currentReservationInfo.partNameList = _.map(selectedAllPartsList, function(element){return element.partDescription});
            this.currentReservationInfo.partLigCd = mostImportantPartCode;
            this.currentReservationInfo.prctSbc = requestText;
            this.currentReservationInfo.importantOrder = mostImportantOrder;

            /* 나의 오토큐 정보 검색 */
            var carNumber = this.currentSelectedCar.carRgstNo;
            var carVin = this.currentSelectedCar.vin;
            var parentThis = this;
            //this.checkMyAutoQStatus(carNumber, carVin, mostImportantPartCode)
            COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ(
                "onlyData",
                parentThis.currentReservationInfo.currentSelectedCar,
                this,
                mostImportantPartCode
            )
            .then(function(){
                /* 전담 오토큐 조회에 실패한 경우 */
                if(!parentThis.myAutoQCheckResult || !parentThis.myAutoQCheckResult.stationDetailResponse || parentThis.myAutoQCheckResult.stationDetailResponse.resultCode !== "200"){
                    exWNHideIndicator();
                    MPage.html({
                        path: PATH_MANAGER.KIA_RNW_243_3000.path,
                        param: {
                            currentReservationInfo: parentThis.currentReservationInfo
                        }
                    })
                }

                /* 전담 오토큐 조회에 성공한 경우 */
                if(parentThis.myAutoQCheckResult && parentThis.myAutoQCheckResult.stationDetailResponse && parentThis.myAutoQCheckResult.stationDetailResponse.resultCode === "200"){
                    exWNHideIndicator();
                    var myAutoQStationInfo = parentThis.myAutoQCheckResult.stationDetailResponse;
                    var isReservationAvailable = parentThis.myAutoQCheckResult.myAutoQViewResponse && parentThis.myAutoQCheckResult.myAutoQViewResponse.isRsvYn;
                    var stationCode = myAutoQStationInfo && myAutoQStationInfo.asnCd;
                    var stationName = myAutoQStationInfo && myAutoQStationInfo.asnNm;
                    //var stationCategory = myAutoQStationInfo.acps1Nm; //2 직영, C 종합, D 전문
    
                    parentThis.currentReservationInfo.myAutoQStationInfo = myAutoQStationInfo;
    
                    /* 나의 오토큐 정보가 있다면 */
                    if(!isEmpty(stationCode)){
                        parentThis.checkAutoQAvailableTime(stationCode, carNumber, carVin, mostImportantPartCode)
                        .then(function(timeResponse){
                            exWNHideIndicator();
                            if (timeResponse.resultCode === "200"){
                                var availableDateTimes = timeResponse.carSvcAutoqYmdRnwResListDto;

                                parentThis.currentReservationInfo.availableDateTimes = availableDateTimes;

                                var availableTimeCheckList = _.filter(availableDateTimes, function(element){return element.sumCnt!=="0"});
                                var isTimeAvailable = availableDateTimes && availableTimeCheckList && availableTimeCheckList.length > 0 || false;

                                /* 나의 오토큐에서 예약이 가능하다면 */
                                //if(todayDateTimesInfo && todayDateTimesInfo.timeList && todayDateTimesInfo.timeList.length > 0){
                                if(isTimeAvailable && isReservationAvailable === "Y"){ // 예약 상태 O && 가능 시간 O 일 경우
                                    // 진행 확인 팝업
                                    COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_243_2100.path, function(){
                                        var stationName = parentThis.currentReservationInfo.myAutoQStationInfo.asnNm;
                                        this.find('#mykia-reserve-parts-myautoq-station-name').text(stationName);
                                        this.find('#popDetailBtn').off().on("click", function(){
                                            MPage.html({
                                                path: PATH_MANAGER.KIA_RNW_243_4000.path,
                                                param: {
                                                    currentReservationInfo: parentThis.currentReservationInfo
                                                }
                                            })
                                        })
                                        this.find("#popCancelBtn").off().on("click", function(){
                                            MPage.html({
                                                path: PATH_MANAGER.KIA_RNW_243_3000.path,
                                                param: {
                                                    currentReservationInfo: parentThis.currentReservationInfo
                                                }
                                            })
                                        })
                                    });
                                }
                                /* 나의 오토큐에서 예약이 불가능하다면 */
                                // else{
                                    /* 나의 오토큐가 예약 불가하다면 */
                                    else if (isTimeAvailable && isReservationAvailable === "N"){ // (예약 상태 X && 가능 시간 O) 일 경우
                                        var stationName = parentThis.currentReservationInfo.myAutoQStationInfo.asnNm;
                                        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_243_2100_3.path, function(){
                                            this.find('#mykia-reserve-parts-myautoq-station-name').text(stationName);
                                            this.find('button.btn-primary').off().on("click", function(){
                                                MPage.html({
                                                    path: PATH_MANAGER.KIA_RNW_243_3000.path,
                                                    param: {
                                                        currentReservationInfo: parentThis.currentReservationInfo
                                                    }
                                                })
                                            })
                                        });
                                    }
                                    /* 나의 오토큐가 예약 마감이라면 */
                                    else{
                                        var stationName = parentThis.currentReservationInfo.myAutoQStationInfo.asnNm;
                                        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_243_2100_2.path, function(){
                                            this.find('#mykia-reserve-parts-myautoq-station-name').text(stationName);
                                            this.find('button.btn-primary').off().on("click", function(){
                                                MPage.html({
                                                    path: PATH_MANAGER.KIA_RNW_243_3000.path,
                                                    param: {
                                                        currentReservationInfo: parentThis.currentReservationInfo
                                                    }
                                                })
                                            })
                                        });
                                    }
                                // }
                            }
                        })
                    }
                    else{
                        // currentSelectedCar 유실 문제
                        // parentThis.currentReservationInfo["currentSelectedCar"] = MData.param("currentSelectedCar");
                        MPage.html({
                            path: PATH_MANAGER.KIA_RNW_243_3000.path,
                            param: {
                                currentReservationInfo: parentThis.currentReservationInfo
                            }
                        })
                    }
                }
            })
        }
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_2000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        exWNHideIndicator();
    }, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){
        exWNHideIndicator();
    } 
}; 