/**

@파일명 : KIA_RNW_243_3000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.04.05 
@메뉴명 : 정비서비스 거점 검색
@DESC : 권한 확인중
*/
var CurrPage;

var KIA_RNW_243_3000 = {
    mapsManager: COMMON_FUNCTION.ROUTO.mapsManager,
    myAutoQStationInfo: MData.param('currentReservationInfo').myAutoQStationInfo,

    currentReservationInfo: MData.param('currentReservationInfo'),

    serviceGubunList: null, // this.setFilterButtons 에서 할당함

    currentCoords: null,

    noGPSCoords: false, // setMapInterface -> COMMON_FUNCTION.TOOL.GPS.getGPSCoordsAsync 에서 설정, GPS 없어 기본값 혹은 오류 발생 시 true로 변경됨

    // !!! 케이스마텍 추헌남 - 스크롤 페이지 관련 메타
    pageMeta: { // this.setNearbyAutoQStationList에서 할당
        currentPageNo: 1,
        pageSize: 10,
        stopLoadingMore: false,
        currentSearchState: {
            currentScopeSelectCar: null,
            coords: null,
            serviceGubun: null,
            partName: null,
            myAutoQStationCode: null
        }
    },

    init: function () {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var keepShowingIndicator = setInterval(function(){
            exWNShowIndicator();
            var mapViewPortStyle = $(".ol-viewport:visible").attr("style");
            if ( mapViewPortStyle && mapViewPortStyle.indexOf("tile.routo.com") > 0){
                clearInterval(keepShowingIndicator);
                exWNHideIndicator();
            }
        }, 500);

        var parentThis = this;

        var indicatorMaintainer = setInterval(function(){
            exWNShowIndicator();
        }, 500)
        
        var onSearchCallback = function(currentMapCenterCoords){
            parentThis.setNearbyAutoQStationList(
                parentThis.currentReservationInfo.currentSelectedCar, 
                currentMapCenterCoords, 
                null, 
                parentThis.currentReservationInfo.partLigCd, 
                parentThis.currentReservationInfo.myAutoQStationInfo && parentThis.currentReservationInfo.myAutoQStationInfo.asnCd)
        }

        Promise.all([
            this.setFilterButtons(),
            COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.setMapInterface("mykia-mycar-reserve-find-autoq-station-map", KIA_RNW_243_3000, onSearchCallback)
        ])
        .then(function(responses){
            parentThis.currentCoords = responses[1];
            if(parentThis.currentReservationInfo.currentSelectedCar && parentThis.currentCoords){
                parentThis.setNearbyAutoQStationList(
                    parentThis.currentReservationInfo.currentSelectedCar,
                    parentThis.currentCoords,
                    null,
                    parentThis.currentReservationInfo.partLigCd,
                    parentThis.currentReservationInfo.myAutoQStationInfo && parentThis.currentReservationInfo.myAutoQStationInfo.asnCd);
            }
            parentThis.setEventListner();
            parentThis.handleOnListHitsBottom();
            clearInterval(keepShowingIndicator);/* 2023.12.12 지도 loading 실패 시 indicator 사라지지 않아 추가 */
            clearInterval(indicatorMaintainer);
            exWNHideIndicator();
        })
    },

    setEventListner: function () {
        var parentThis = this;
        $('#mykia-mycar-reserve-find-autoq-station-search').on("click", function () {
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_243_3200.path,
                animate: "NONE",
                param: {
                    currentReservationInfo: parentThis.currentReservationInfo,
                }
            })
        });
    },

    setNearbyAutoQStationList: function (currentScopeSelectCar, coords, serviceGubun, partName, myAutoQStationCode, nowPage, pageSize, loadMoreMode) {
        !loadMoreMode && $("#mykia-mycar-reserve-find-autoq-station-list").scrollTop(0);
        this.pageMeta.currentSearchState = {
            currentScopeSelectCar: currentScopeSelectCar,
            coords: coords,
            serviceGubun: serviceGubun,
            partName: partName,
            myAutoQStationCode: myAutoQStationCode
        }

        var tempSendData = {
            mbrId: PGV.loginInfo.mbrId,
            carNo: currentScopeSelectCar.carRgstNo,
            vin: currentScopeSelectCar.vin,
            serviceGubun: serviceGubun,
            partLigCd: partName,
            mobAppPrctTim: "A",
            nowPage: nowPage || 1,
            pageSize: pageSize || 10
        }

        if(coords){
            tempSendData["lat"] = (coords && (coords.latitude || coords.lat)) || CONSTANT.DEFAULTS_LOCATION.LAT;
            tempSendData["lng"] = (coords && (coords.longtitude || coords.lng)) || CONSTANT.DEFAULTS_LOCATION.LNG;
        }


        var parentThis = this;
        // partLigCd: partName, 부품 코드 (필수 아님)
        // 01 직영서비스, 02 마스터 오토큐, 03 K9/스팅어, 04 친환경 전문, 08 판금, null 전체검색
        // A 전시간대, B 오전시간대, C 오후시간대 (설계서상 A로 고정)

        console.log("검색 시 던지는 sendData : " , tempSendData);

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.nearAutoqInfoList,
            isMock: false,
            sendData: tempSendData
        })
        .then(function (response) {
            return new Promise(function (resolve) {
                if (response.resultCode === "200") {
                    var stationList = response.carSvcNearAutoqRnwResListDto;
                    var stationListContainerView = $('#mykia-mycar-reserve-find-autoq-station-list');
                    if (stationList && stationList.length > 0) {
                        if (loadMoreMode) {
                            parentThis.pageMeta.currentPageNo = nowPage || 1;
                        }
                        else {
                            parentThis.pageMeta.currentPageNo = 1;
                            parentThis.pageMeta.stopLoadingMore = false;
                            $('#mykia-mycar-reserve-find-autoq-station-list .div-item').remove();
                            $('#mykia-mycar-reserve-find-autoq-station-list .inner-info').remove();
                        }
                        $('#mykia-mycar-reserve-find-autoq-station-list #no-data').addClass("none");
                        !loadMoreMode && COMMON_FUNCTION.ROUTO.mapsManager.drawStationListsResults(stationList, parentThis);
                        var stationListElementsContainer = [];
                        if(!loadMoreMode){
                            var stationListNoticeHeaderHtmlString = 
                                '<div class="inner-info">' +
                                    '<ul>' +
                                        '<li>' +
                                            '<p class="bullet-reference">' +
                                                '검색 시점의 지도 중앙을 기준으로 거리를 제공합니다.' +
                                            '</p>' +
                                        '</li>' +
                                    '</ul>' +
                                '</div>';
                            stationListElementsContainer.push($(stationListNoticeHeaderHtmlString));
                        }
                        for (var i = 0; i < stationList.length; i++) {
                            var curNode = stationList[i];
                            var curJQueryObject = COMMON_FUNCTION.TOOL.UI.myKiaAutoQInterface.getAutoQBoxJQueryObject(
                                curNode,
                                KIA_RNW_243_3000,
                                currentScopeSelectCar,
                                "reserve",
                                parentThis.currentReservationInfo,
                                true
                            )
                            stationListElementsContainer.push(curJQueryObject);
                        }
                        stationListContainerView.append(stationListElementsContainer);
                        exWNHideIndicator();
                        resolve(stationList);
                    }
                    else {
                        if (loadMoreMode){
                            parentThis.pageMeta.stopLoadingMore = true;
                        }
                        else{
                            $('#mykia-mycar-reserve-find-autoq-station-list #no-data').removeClass("none");
                            M.pop.instance('검색결과가 없습니다.');
                            exWNHideIndicator();
                            resolve([]);
                        }
                    }
    
                    $("#mykia-mycar-reserve-find-autoq-station-list").removeClass("none");
                }
            })
        })
    },

    checkMyAutoQStatus: function(carNumber, carVin, partName){
        var parentThis = this;
        return new Promise(function(resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.myAutoqAsnInfo_view,
                isMock: false,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    carRgstNo: carNumber,
                    vin: carVin,
                    partLigCd: partName
                }
            })
            .then(function(response){
                if(response.resultCode === "200"){
                    var mainAutoQInfo = response;
                }
                parentThis.currentReservationInfo.myAutoQStationInfo = mainAutoQInfo;

                resolve(response);
            })
            .catch(function(){
                reject();
            })
        })
    },

    setFilterButtons: function(){
        var parentThis = this;
        return new Promise(function(resolve){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqServiceTypeList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    schFlag: "00"
                },
                isMock: false,
            })
            .then(function(response){
                if (response.resultCode === "200"){
                    var serviceGubunList = response.carSvcAutoqTypeListRnwResDto;
                    parentThis.serviceGubunList = _.map(serviceGubunList, function(element){return element}); // copy
                    var htmlString = "";
                    if(serviceGubunList){
                        // !!! 케이스마텍 추헌남 - 전체 검색 옵션이 없을 경우 집어넣어야 함
                        if(!_.find(serviceGubunList, function(element){return element.serviceCd === "all"})){
                            serviceGubunList.unshift({
                                "serviceNm": "전체",
                                "serviceCd": "all",
                            })
                        }
                        for (var i = 0; i < serviceGubunList.length; i++){
                            var curNode = serviceGubunList[i];
                            htmlString += 
                                '<div class="swiper-slide ' + (i === 0 ? "active" : "") + '" data-slide-index="' + i + '">' +
                                    '<button type="button" class="btn-filter" data-filter-type="' + curNode.serviceCd + '">' + curNode.serviceNm + '</button>' +
                                '</div>';
                        }
                    }
                    $('#mykia-mycar-reserve-find-autoq-station-filter').html(htmlString);
                    
                    // ------------------------------
                    // 	Slider
                    // ------------------------------
                    var _sliderFilterList = new Swiper('.slider-filter-list', {
                        spaceBetween:0,
                        slidesPerView:'auto',
                        //centeredSlides:true,
                        loopedSlides:1,
                        loop: false,
                        speed:300,
                        grapCursor:true,
                        observer:true,
                        observParents:true,
                        resistanceRatio:0 //드래그 저항비율 제어
                    });
        
                    // $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
                    //     e.preventDefault();			
                    //     var getSlideIdx = $(this).data('slide-index');
                    //     //console.log('getSlideIdx', getSlideIdx)
                    //     _sliderFilterList.slideTo(getSlideIdx, 300, false);	
                    //     $('.slider-filter-list').find('.active').removeClass('active');
                    //     $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
                    // });
    
                    $('#mykia-mycar-reserve-find-autoq-station-filter button').on("click", function () {
                        var filterType = $(this).data('filter-type');
                        $(this).parent().addClass('active');
                        $(this).parent().siblings().removeClass('active');
                        
                        if (filterType === "all") {
                            parentThis.setNearbyAutoQStationList(
                                parentThis.currentReservationInfo.currentSelectedCar, 
                                parentThis.pageMeta.currentSearchState.coords, 
                                null, 
                                parentThis.currentReservationInfo.partLigCd, 
                                parentThis.currentReservationInfo.myAutoQStationInfo && parentThis.currentReservationInfo.myAutoQStationInfo.asnCd);
                        }
                        else {
                            //serviceGubun에 넣기
                            parentThis.setNearbyAutoQStationList(
                                parentThis.currentReservationInfo.currentSelectedCar, 
                                parentThis.pageMeta.currentSearchState.coords, 
                                filterType, 
                                parentThis.currentReservationInfo.partLigCd, 
                                parentThis.currentReservationInfo.myAutoQStationInfo && parentThis.currentReservationInfo.myAutoQStationInfo.asnCd);
                        }
                    });
                    resolve();
                }
            })
        })
    },

    handleOnListHitsBottom: function () {
        var parentThis = this;
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        var $floatingLayerBody = null; // $('.js-floating-layer-body:visible');

        /* 20220408//(Ina)$floatingLayerBody영역 scrollend 스크립트 추가(s) */
        var scrollEventRunnerCount = 0;
        var scrollEventRunner = setInterval(function(){
            $floatingLayerBody = $('.js-floating-layer-body:visible');
            if(scrollEventRunnerCount > 150){
                clearInterval(scrollEventRunner);
                COMMON_FUNCTION.TOOL.DEBUG.showAdvice("handleOnListHitsBottom : .js-floating-layer-body 로딩 중 타임아웃");
            }
            if($('.js-floating-layer-body:visible').length > 0){
                clearInterval(scrollEventRunner);
                $floatingLayerBody.off("scroll").scroll(function (e) {
                    var $nowTop = $(this).scrollTop();
        
                    //CurrPage.fnMapAreaCtrl();
        
                    if (($floatingLayerBody[0].scrollHeight - Math.ceil($floatingLayerBody.scrollTop())) <= Math.floor($floatingLayerBody.outerHeight())) {
                        if (!parentThis.pageMeta.stopLoadingMore) {
                            var curSearchState = parentThis.pageMeta.currentSearchState;
                            var currentScopeSelectCar = curSearchState.currentScopeSelectCar;
                            var coords = curSearchState.coords;
                            var serviceGubun = curSearchState.serviceGubun;
                            var partName = curSearchState.partName;
                            var myAutoQStationCode = curSearchState.myAutoQStationCode;
                            var nowPage = parentThis.pageMeta.currentPageNo + 1;
                            var pageSize = parentThis.pageMeta.pageSize;
        
                            parentThis.setNearbyAutoQStationList(currentScopeSelectCar, coords, serviceGubun, partName, myAutoQStationCode, nowPage, pageSize, true);
                        }
                    }
        
                    $winTop = $nowTop;
                });
            }
        }, 100);
    },
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_243_3000.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_243_3000);
        COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_243_3000.currentReservationInfo);
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) {
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_243_3000);
        COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_243_3000.currentReservationInfo);
    }
}; 
