/**

@파일명 : KIA_RNW_243_3100.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.04.05 
@메뉴명 : 내 차 관리 탭_정비 탭_정비서비스 거점검색_정비서비스 거점 검색_정비 예약_정비소 상세 팝업
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage;
var RESERVATION_LIG_NM = {
    "1" : "중요정비",
    "2" : "기본/경정비",
    "3" : "소모품",
    "99" : "프리케어",
}
var KIA_RNW_243_3100 ={
    mapsManager: COMMON_FUNCTION.ROUTO.mapsManager,

    currentReservationInfo: MData.param('currentReservationInfo'),
    targetStationInfo: MData.param('currentReservationInfo').targetStationInfo,

    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        
        var parentThis = this;
        var myAutoQStationCode = this.currentReservationInfo.myAutoQStationInfo && this.currentReservationInfo.myAutoQStationInfo && this.currentReservationInfo.myAutoQStationInfo.asnCd;
        var currentSelectedCar = this.currentReservationInfo.currentSelectedCar;
        
        /* !!! 케이스마텍 추헌남 - 아래 확인 버튼이 뜨지 않던 버그 임시 수정 */
        $(".pos-bottom").css("z-index", 400);

        COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.setMapInterface("mykia-mycar-reserve-autoq-detail-station-map", KIA_RNW_243_3100, null, true)
        .then(function(){
            parentThis.mapsManager.drawStationListsResults([parentThis.currentReservationInfo.targetStationInfo], parentThis);
            parentThis.mapsManager.setAdjustedCenter(
                {lat: Math.abs(parseFloat(parentThis.currentReservationInfo.targetStationInfo.mapYcooNm)), lng: Math.abs(parseFloat(parentThis.currentReservationInfo.targetStationInfo.mapXcooNm))}
            );
            parentThis.setNextButton(parentThis.currentReservationInfo.targetStationInfo.asnCd, currentSelectedCar.carRgstNo, currentSelectedCar.vin, parentThis.currentReservationInfo.partLigCd);
            parentThis.setAutoQDetailView(parentThis.currentReservationInfo.targetStationInfo.asnCd, myAutoQStationCode)
            .then(function(){
                $("#mykia-mycar-reserve-autoq-detail-view-container").removeClass("none")
                parentThis.setEventListner();
                parentThis.setPublisherEventListener();
                exWNHideIndicator();
            })
        })
    }, 

    setEventListner: function(){
        var parentThis = this;
        $('.btn-map-close').on("click", function(){
            MPage.back();
        });
        $('#mykia-mycar-reserve-autoq-detail-set-myautoq').on("click", function(){
            var curNode = parentThis.currentReservationInfo.targetStationInfo;
            if(curNode && curNode.asnCd){
                parentThis.onClickSetMyAutoQ(curNode.asnCd);
            }
        });
        $('#mykia-mycar-reserve-autoq-detail-station-phone').on("click", function () {
            MSys.call($(this).text());
        });
        $('#mykia-mycar-reserve-autoq-detail-station-send-location').on("click", function(){
            var curNode = parentThis.currentReservationInfo.targetStationInfo;
            if(curNode && curNode.asnCd){
                var stationName = curNode.asnNm;
                var stationCoord = { lat: parseFloat(curNode.mapYcooNm), lng: parseFloat(curNode.mapXcooNm) };
                parentThis.onClickSendLocation(stationName, stationCoord);
            }
        });
       $('#mykia-mycar-reserve-autoq-detail-station-copy-address').on("click", function () {
            COMMON_FUNCTION.TOOL.UI.copyToClipboard($('#mykia-mycar-reserve-autoq-detail-station-address'), true);
        });
    },

    setPublisherEventListener: function(){
        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			$winTop = $nowTop;
			
		});
    },

    setAutoQDetailView: function (stationCode, myAutoQStationCode) {
        var parentThis = this;
        console.log({
            mbrId: PGV.loginInfo.mbrId,
            asnCd: stationCode
        });
        return new Promise(function(resolve){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqDetailInfo,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    asnCd: stationCode
                },
                isMock: false
            })
            .then(function (response) {
                console.log(response);
                if (response.resultCode === "200") {
                    var curNode = response;
                    if (curNode.asnCd) {
                        parentThis.currentReservationInfo.targetStationInfo = response;
                        var stationCode = curNode.asnCd;
                        var stationName = curNode.asnNm;
                        var stationServiceType = curNode.acps1Nm;
                        var stationCoordinate = { lat: parseFloat(response.mapYcooNm), lng: parseFloat(response.mapXcooNm) };
                        //var stationDistance = parentThis.currentReservationInfo.targetStationInfo.carSvcDetailAutoqRnwResDto.distance;
                        var stationAddress = curNode.pbzAdr;
                        var stationPhoneNo = COMMON_FUNCTION.TOOL.DATA.getFormattedPhoneNo(curNode.repnTn || "");
                        var stationIsReserveAvailable = curNode.reSerVeYn; //"Y" "N"
                        var stationStartTime = moment(curNode.bizStrtCtm, "HHmm");
                        stationStartTime = stationStartTime.isValid() ? stationStartTime.format("HH:mm") : "";
                        var stationEndTime = moment(curNode.bizFnhCtm, "HHmm");
                        stationEndTime = stationEndTime.isValid() ? stationEndTime.format("HH:mm") : "";
                        var stationSpecificNote = curNode.specifics &&
                                                  typeof curNode.specifics === "string" &&
                                                  _.map(curNode.specifics.split("\n"), function(element){
                                                        return COMMON_FUNCTION.TOOL.SECURITY.cleanXSS(element);
                                                    }).join("<br>") || "";
                        var stationImageSrc = curNode.oipf1Nm;

                        // stationDistance = parseInt(stationDistance) > 1000 ? 
                        //                 ((parseInt(stationDistance) / 1000).toFixed(1) + "km ") : 
                        //                 (stationDistance + "m ");

                        /* 실운행자의 경우 전담오토큐 설정 불가 */
                        if(COMMON_FUNCTION.TOOL.DATA.hasAtLeastOneOwnedCar()){
                            if(stationCode === myAutoQStationCode){
                                $('#mykia-mycar-reserve-autoq-detail-set-myautoq').addClass('none');
                                $('#mykia-mycar-reserve-autoq-detail-myautoq-badge').removeClass('none');
                            }
                            else{
                                $('#mykia-mycar-reserve-autoq-detail-set-myautoq').removeClass('none');
                                $('#mykia-mycar-reserve-autoq-detail-myautoq-badge').addClass('none');
                            }
                        }
                        else{
                            $('#mykia-mycar-reserve-autoq-detail-myautoq-badge').addClass('none');
                            $('#mykia-mycar-reserve-autoq-detail-set-myautoq').addClass('none');
                        }

    
                        //$('#mykia-mycar-reserve-autoq-detail-distance').text(stationDistance);
                        $("#mykia-mycar-reserve-autoq-detail-station-service-type").text(stationServiceType);
                        $('#mykia-mycar-reserve-autoq-detail-station-name').text(stationName);
                        $('#mykia-mycar-reserve-autoq-detail-station-address').text(stationAddress || "주소 없음");
                        $('#mykia-mycar-reserve-autoq-detail-station-phone').text(stationPhoneNo);
                        $('#mykia-mycar-reserve-autoq-detail-station-time').text(stationStartTime + '~' + stationEndTime);
    
                        if(stationSpecificNote && stationSpecificNote.trim().length > 0){
                            $('#mykia-mycar-reserve-autoq-detail-station-note').html(stationSpecificNote);
                        }
                        else{
                            $('#mykia-mycar-reserve-autoq-detail-station-note').text("예약 특이사항이 없습니다.");
                        }
    
                        if(stationImageSrc && typeof stationImageSrc === "string" && stationImageSrc.length > 0 && stationServiceType === "직영서비스"){
                            $('#mykia-mycar-reserve-autoq-detail-station-img').attr('src', stationImageSrc);
                            $('#mykia-mycar-reserve-autoq-detail-station-img-container').removeClass('none');
                        }
                    }
                }
                resolve();
            })
        })
    },

    setNextButton: function(stationCode, carNumber, carVin, mostImportantPartCode){
        var parentThis = this;
        this.checkAutoQAvailableTime(stationCode, carNumber, carVin, mostImportantPartCode)
        .then(function(response){
            console.log("availTime : ", response);
            if (response.resultCode === "200"){
                var availableDateTimes = response.carSvcAutoqYmdRnwResListDto;
                var availableTimeCheckList = _.filter(availableDateTimes, function(element){return element.sumCnt!=="0"});
                var isTimeAvailable = availableDateTimes && availableTimeCheckList && availableTimeCheckList.length > 0 || false;

                /* 나의 오토큐에서 예약이 가능하다면 */                
                if(isTimeAvailable){
                    $('#mykia-mycar-reserve-autoq-detail-select').removeClass('none');
                    $('#mykia-mycar-reserve-autoq-detail-select-disable-timefull').addClass('none');
                    $('#mykia-mycar-reserve-autoq-detail-select-disable-notavail').addClass('none');
                    $('#mykia-mycar-reserve-autoq-detail-select').off().on("click", function(){
                        parentThis.currentReservationInfo["targetStationAvailableDateTimes"] = availableDateTimes;
                        MPage.html({
                            path: PATH_MANAGER.KIA_RNW_243_4000.path,
                            param: {
                                currentReservationInfo: parentThis.currentReservationInfo
                            }
                        })
                    })
                }
                /* 해당 오토큐에서 예약이 불가능하다면 */
                else{
                    var pReservationInfo = parentThis.currentReservationInfo;
                    var isReservationAvailable = pReservationInfo.targetStationInfo.reSerVeYn;
                    var rsvText = "불가합니다.";
                    /* 해당 오토큐가 예약 불가하다면 */
                    if (isReservationAvailable === "N"){
                        $('#mykia-mycar-reserve-autoq-detail-select').addClass('none');
                        $('#mykia-mycar-reserve-autoq-detail-select-disable-timefull').addClass('none');
                        $('#mykia-mycar-reserve-autoq-detail-select-disable-notavail').removeClass('none');
                    }
                    /* 해당 오토큐가 예약 마감이라면 */
                    else{
                        $('#mykia-mycar-reserve-autoq-detail-select').addClass('none');
                        $('#mykia-mycar-reserve-autoq-detail-select-disable-timefull').removeClass('none');
                        $('#mykia-mycar-reserve-autoq-detail-select-disable-notavail').addClass('none');
                        rsvText = "마감되었습니다.";
                    }
                    /* 2024.03.07 예약 불가 및 마감 메세지 추가 */
                    var ligNm = RESERVATION_LIG_NM[pReservationInfo.importantOrder];
                    MPopup.alert({
                        message : String.format(`{0} 차량은 {1} 에서\n선택 하신 {2} 항목으로 예약이 {3}\n다른 지점을 이용해 주세요.`,
                            pReservationInfo.currentSelectedCar.mdlNm,
                            pReservationInfo.targetStationInfo.asnNm,
                            ligNm,
                            rsvText),
                        callback : function(){
                            MPage.back();
                        }
                    });
                }
            }
        })
    },

    onClickSetMyAutoQ: function(targetStationCode){
        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.updateMainAutoq,
            isMock: false,
            sendData: {
                mbrId: PGV.loginInfo.mbrId,
                asnCd: targetStationCode
            }
        })
        .then(function(response){
            if(response.resultCode === "200"){
                if(response.updYn === "Y"){
                    $('#mykia-mycar-reserve-autoq-detail-set-myautoq').addClass('none');
                    $('#mykia-mycar-reserve-autoq-detail-myautoq-badge').removeClass('none');
                    M.pop.instance('전담 정비소로 설정되었습니다.')
                }
                else{
                    M.pop.instance('전담 정비소 설정에 실패하였습니다.')
                }
                exWNHideIndicator();
            }
        })
    },

    onClickSendLocation: function(stationName, stationCoord){
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_242_1000.path, function () {
            /* !!! 케이스마텍 추헌남 - 해당 팝업이 선택 버튼에 가려지는 부분 임시 수정 */
            $("#popup_242_1000").css("z-index", 500);
            var parentThis = this;
            var closePopup = function (e, parentThis) {
                e.preventDefault();

                parentThis.fadeOut('fast');
                parentThis.find('.popup-wrap').removeClass('is-ani');

                $('body').removeClass('js-overflow-hidden');
            }
            this.find("ul li").off("click").on("click", function (e) {
                var targetApp = $(this).data('target-app');
                switch(targetApp){
                    case "kakaomap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('k', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "tmap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('t', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "kia-connect":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('kc', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                }
                closePopup(e, parentThis);
            })
            this.find('#mykia-close-popup').off("click").on("click", function (e) {
                closePopup(e, parentThis);
            })
        })
    },

    checkAutoQAvailableTime: function(stationCode, carNumber, carVin, partName){
        return MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.schAutoqYmdList,
            isMock: false,
            sendData: {
                mbrId: PGV.loginInfo.mbrId,
                asnCd: stationCode,
                partLigCd: partName,
                carRgstNo: carNumber,
                vin: carVin,
                mobPrctTim: "A"
            }
        })
    },
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_3100.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
