/**

@파일명 : KIA_RNW_243_4000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.04 
@메뉴명 : 내 차 관리 탭_정비 탭_정비서비스 거점검색_정비서비스 거점 검색_정비 예약_정비소 키워드 검색
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/
var MntnceSearchStation;
var KIA_RNW_243_3200 = {
    /* !!! 케이스마텍 추헌남 - KIA_RNW_243_3000 객체의 이벤트 리스너 항목에서 아래 내용을 채워줍니다. */
    myAutoQStationInfo: MData.param("currentReservationInfo").myAutoQStationInfo,
    myAutoQStationCode: MData.param("currentReservationInfo").myAutoQStationInfo && MData.param("currentReservationInfo").myAutoQStationInfo.asnCd,
    currentReservationInfo: MData.param("currentReservationInfo"),

    currentCoords : null,

    // !!! 케이스마텍 추헌남 - 스크롤 페이지 관련 메타
    pageMeta: { // this.setSearchAutoQStationResult에서 할당
        currentPageNo: 1,
        pageSize: 10,
        stopLoadingMore: false,
        currentSearchState: {
            currentScopeSelectCar: null,
            searchWord: null,
            myAutoQStationCode: null,
            serviceGubun: null,
            partName: null
        }
    },

    searchKeywordHistoryManager: COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.searchKeywordHistoryManager,

    init: function () {
        MntnceSearchStation = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");

        $('#mykia-mycar-reserve-find-autoq-station-search-inputbox:visible').focus();

        var parentThis = this;
        // !!! 케이스마텍 추헌남 - asnCd 가져오기
        KIA_RNW_243_3200.setFilterButtons()
        .then(function(){
            parentThis.setSearchHistoryBox(parentThis.searchKeywordHistoryManager.load());
            $(".content.content-mycar").removeClass("none");
            parentThis.setEventListner();
            parentThis.handleOnListHitsBottom();
            exWNHideIndicator();
        });
    },

    setEventListner: function () {
        var parentThis = this;
        $('#mykia-mycar-reserve-find-autoq-station-search-page button.btn-prev').off("click").on("click", function (e) {
            MPage.back();
        });
        $('#mykia-mycar-reserve-find-autoq-station-search-page button.btn-input-clear').on("click", function () {
            $('#mykia-mycar-reserve-find-autoq-station-search-inputbox').value('');
        });
        $('#mykia-mycar-reserve-find-autoq-station-search-page button.btn-search').on("click", function () {
            parentThis.onInputSearch();
        });
        $('#mykia-mycar-reserve-find-autoq-station-search-inputbox').on("keyup", function (e) {
            if (e.keyCode === 13) {
                parentThis.onInputSearch();
            }
        });
        $('#mykia-mycar-reserve-find-autoq-station-search-inputbox').on("focus", function () {
            parentThis.setSearchHistoryBox(parentThis.searchKeywordHistoryManager.load());
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container-nodata').addClass('none');
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container').addClass('none');
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-history-list').removeClass('none');
        });
    },

    setSearchHistoryBox: function (historyObject) {
        var parentThis = this;
        var historyBoxView = $('#mykia-mycar-reserve-find-autoq-station-search-history');
        historyBoxView.html('');
        var searchHistoryNodes = [];
        if (historyObject && historyObject.length > 0) {
            $('#mykia-mycar-reserve-find-autoq-station-search-history-nodata').addClass('none');
            historyBoxView.removeClass("none");
        }
        else {
            $('#mykia-mycar-reserve-find-autoq-station-search-history-nodata').removeClass('none');
            historyBoxView.addClass("none");
        }
        if (historyObject) {
            for (var i = 0; i < historyObject.length; i++) {
                var curNodeString = historyObject[i];
                var htmlString =
                    '<li>' +
                    '<span class="text-scale-05">' + curNodeString + '</span>' +
                    '<button type="button" class="btn-delete"><em class="blind">삭제</em></button>' +
                    '</li>';
                var htmlObject = $(htmlString);
                (function (index, searchKeyword) {
                    htmlObject.find('span').on("click", function () {
                        var searchKeyword = $(this).text().trim();
                        var changedHistoryObject = parentThis.searchKeywordHistoryManager.load();
                        changedHistoryObject = parentThis.searchKeywordHistoryManager.addHistory(changedHistoryObject, searchKeyword);
                        parentThis.searchKeywordHistoryManager.save(changedHistoryObject);
                        $('#mykia-mycar-reserve-find-autoq-station-search-inputbox').val(searchKeyword);
                        parentThis.setSearchAutoQStationResult(parentThis.currentReservationInfo.currentSelectedCar, searchKeyword, parentThis.myAutoQStationCode, null, parentThis.currentReservationInfo.partLigCd);
                    })
                    htmlObject.find('button.btn-delete').on("click", function () {
                        var changedHistoryObject = parentThis.searchKeywordHistoryManager.deleteHistory(historyObject, index);
                        parentThis.searchKeywordHistoryManager.save(changedHistoryObject);
                        parentThis.setSearchHistoryBox(changedHistoryObject);
                    })
                })(i, curNodeString);
                searchHistoryNodes.push(htmlObject);
            }
            historyBoxView.append(searchHistoryNodes);
        }
    },

    setSearchAutoQStationResult: function (currentSelectedCar, searchWord, myAutoQStationCode, serviceGubun, partName, nowPage, pageSize, loadMoreMode, onFilterClicked) {
        // this.currentSearchKeyword = searchWord;
        // this.pageMeta.currentSearchState = {
        //     currentScopeSelectCar : currentSelectedCar,
        //     searchWord : searchWord,
        //     myAutoQStationCode : myAutoQStationCode,
        //     serviceGubun: serviceGubun,
        //     partName: partName
        // }

        // !!! 케이스마텍 추헌남 - 필터 목록 미출력 및 스크롤 미동작 문제 우회 해결용 코드
        $("#mykia-mycar-reserve-find-autoq-station-search-section").css("overflow-y", "auto");
        $('#mykia-mycar-reserve-find-autoq-station-search-inputbox').blur();
        var parentThis = this;
        
        // A 전시간대, B 오전시간대, C 오후시간대 (설계서상 A로 고정)
        var tempSendData = {
            mbrId: PGV.loginInfo.mbrId,
            carNo: currentSelectedCar.carRgstNo,
            vin: currentSelectedCar.vin,
            searchWord: searchWord,
            //partLigCd: partName,
            mobAppPrctTim: "A",
            serviceGubun: serviceGubun || null,
            nowPage: nowPage || 1,
            pageSize: pageSize || 10
        }
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("키워드 검색 시 던지는 sendData : " , tempSendData);

        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.schAutoqList,
            isMock: false,
            sendData: tempSendData
        })
        .then(function (response) {
            console.log(response);
            if (response.resultCode === "200") {
                var stationList = response.carSvcKwdAutoqRnwResListDto;
                var stationListContainerView = $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-list');
                if (stationList && stationList.length > 0) {
                    $(".nodata-area#result-container").addClass("none");
                    if (loadMoreMode){
                        parentThis.pageMeta.currentPageNo = nowPage || 1;
                    }
                    else {
                        parentThis.pageMeta = {
                            currentPageNo: nowPage || 1,
                            pageSize: 10,
                            stopLoadingMore: false,
                            currentSearchState: {
                                currentScopeSelectCar : currentSelectedCar,
                                searchWord : searchWord,
                                myAutoQStationCode : myAutoQStationCode,
                                serviceGubun: serviceGubun,
                                partName: partName

                            }
                        }
                        $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container .div-item').remove();
                    }
                    $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container-nodata').addClass('none');
                    $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container').removeClass('none');
                    $('#mykia-mycar-reserve-find-autoq-station-search-keyword-history-list').addClass('none');
                    var stationListElementsContainer = [];
                    // ServiceGubun - 01 직영서비스, 02 마스터 오토큐, 03 K9/스팅어, 04 친환경 전문, 08 판금, null 전체검색
                    for (var i = 0; i < stationList.length; i++) {
                        var curNode = stationList[i];
                        var curJQueryObject = COMMON_FUNCTION.TOOL.UI.myKiaAutoQInterface.getAutoQBoxJQueryObject(
                                curNode,
                                KIA_RNW_243_3200,
                                currentSelectedCar,
                                "reserve",
                                parentThis.currentReservationInfo,
                                false
                            )
                        stationListElementsContainer.push(curJQueryObject);
                    }
                    stationListContainerView.append(stationListElementsContainer);
                }
                else {
                    if(loadMoreMode){
                        parentThis.pageMeta.stopLoadingMore = true;
                    }
                    else{
                        $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container .div-item').remove();
                        $('#mykia-mycar-reserve-find-autoq-station-search-keyword-history-list').addClass('none');
                        if(onFilterClicked){
                            $(".nodata-area#result-container").removeClass("none");
                        }
                        else{
                            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container').addClass('none');
                            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container-nodata').removeClass('none');
                            M.pop.instance('검색 결과가 없습니다.');
                        }
                    }
                }
                exWNHideIndicator();
            }
        })
    },

    onInputSearch: function () {
        var searchKeyword = $('#mykia-mycar-reserve-find-autoq-station-search-inputbox').val().trim();
        if (!searchKeyword && !(searchKeyword.length > 0)) {
            M.pop.instance('검색어를 입력해주세요.');
        }
        else {
            var historyObject = this.searchKeywordHistoryManager.load();
            historyObject = this.searchKeywordHistoryManager.addHistory(historyObject, searchKeyword);
            this.searchKeywordHistoryManager.save(historyObject);
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container .div-item').remove();
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container-nodata').addClass('none');
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-result-container').removeClass('none');
            $('#mykia-mycar-reserve-find-autoq-station-search-keyword-history-list').addClass('none');
            this.setSearchAutoQStationResult(this.currentReservationInfo.currentSelectedCar, searchKeyword, this.myAutoQStationCode, null, this.currentReservationInfo.partLigCd);
            // var currentScopeSelectCar = KIA_RNW_243_3200.currentReservationInfo.currentSelectedCar;
            // COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_243_3200.currentReservationInfo);
        }
    },

    setFilterButtons: function(){
        var parentThis = this;
        return new Promise(function(resolve){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqServiceTypeList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    schFlag: "00"
                },
                isMock: false,
            })
            .then(function(response){
                if (response.resultCode === "200"){
                    var serviceGubunList = response.carSvcAutoqTypeListRnwResDto;
                    if(serviceGubunList){
                        var htmlString = "";
                        // !!! 케이스마텍 추헌남 - 전체 검색 옵션도 집어넣어야 함
                        serviceGubunList.unshift({
                            "serviceNm": "전체",
                            "serviceCd": "all",
                        })
                        for (var i = 0; i < serviceGubunList.length; i++){
                            var curNode = serviceGubunList[i];
                            htmlString += 
                                '<div class="swiper-slide ' + (i === 0 ? "active" : "") + '" data-slide-index="' + i + '">' +
                                    '<button type="button" class="btn-filter" data-filter-type="' + curNode.serviceCd + '">' + curNode.serviceNm + '</button>' +
                                '</div>';
                        }
                    }
                    $('#mykia-mycar-reserve-find-autoq-filter-list').html(htmlString);
                    
                    // ------------------------------
                    // 	Slider
                    // ------------------------------
                    var _sliderFilterList = new Swiper('.slider-filter-list', {
                        spaceBetween:0,
                        slidesPerView:'auto',
                        //centeredSlides:true,
                        loopedSlides:1,
                        loop: false,
                        speed:300,
                        grapCursor:true,
                        observer:true,
                        observParents:true,
                        resistanceRatio:0 //드래그 저항비율 제어
                    });

                    // $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
                    //     e.preventDefault();			
                    //     var getSlideIdx = $(this).data('slide-index');
                    //     //console.log('getSlideIdx', getSlideIdx)
                    //     _sliderFilterList.slideTo(getSlideIdx, 300, false);	
                    //     $('.slider-filter-list').find('.active').removeClass('active');
                    //     $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
                    // });
                    $('.swiper-slide button.btn-filter').off("click").on("click", function () {
                        var filterType = $(this).data('filter-type');
                        $(this).parent().addClass("active");
                        $(this).parent().siblings().removeClass("active");
                        if (filterType === "all") { // 01 직영서비스, 02 마스터 오토큐, 03 K9/스팅어, 04 친환경 전문, 08 판금, null 전체검색
                            parentThis.setSearchAutoQStationResult(parentThis.currentReservationInfo.currentSelectedCar, parentThis.pageMeta.currentSearchState.searchWord, parentThis.myAutoQStationCode, null, parentThis.currentReservationInfo.partLigCd, null, null, null, true);
                        }
                        else {
                            //serviceGubun에 넣기
                            parentThis.setSearchAutoQStationResult(parentThis.currentReservationInfo.currentSelectedCar, parentThis.pageMeta.currentSearchState.searchWord, parentThis.myAutoQStationCode, filterType, parentThis.currentReservationInfo.partLigCd, null, null, null, true);
                        }
                    })
                    resolve();
                }
            })
        })
    },

    handleOnListHitsBottom: function () {
        var parentThis = this;
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        var $floatingLayerBody = $("#mykia-mycar-reserve-find-autoq-station-search-section");

        /* 20220408//(Ina)$floatingLayerBody영역 scrollend 스크립트 추가(s) */
        $floatingLayerBody.off("scroll").scroll(function (e) {
            var $nowTop = $(this).scrollTop();

            //CurrPage.fnMapAreaCtrl();
            if (($floatingLayerBody[0].scrollHeight - Math.ceil($floatingLayerBody.scrollTop())) <= Math.floor($floatingLayerBody.outerHeight())) {
                if (!parentThis.pageMeta.stopLoadingMore) {
                    var curSearchState = parentThis.pageMeta.currentSearchState;
                    var currentScopeSelectCar = curSearchState.currentScopeSelectCar;
                    var searchWord = curSearchState.searchWord;
                    var myAutoQStationCode = curSearchState.myAutoQStationCode;
                    var serviceGubun = curSearchState.serviceGubun;
                    var partName = curSearchState.partName;
                    var nowPage = parentThis.pageMeta.nowPage + 1;
                    var pageSize = parentThis.pageMeta.pageSize;

                    parentThis.setSearchAutoQStationResult(currentScopeSelectCar, searchWord, myAutoQStationCode, serviceGubun, partName, nowPage, pageSize, true);
                }
            }

            $winTop = $nowTop;
        });
    },
}


/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_243_3200.init();
    },
    onHide: function (event) { },
    onRestore: function (event) {
        var currentScopeSelectCar = KIA_RNW_243_3200.currentReservationInfo.currentSelectedCar;
        COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_243_3200);
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) {
        var currentScopeSelectCar = KIA_RNW_243_3200.currentReservationInfo.currentSelectedCar;
        COMMON_FUNCTION.TOOL.UI.myKiaMapInterface.updateMyAutoQ("map", currentScopeSelectCar, KIA_RNW_243_3200);
    }
}; 
