/**

@파일명 : KIA_RNW_243_4000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 정비 예약 일시 선택
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_243_4000 ={
    currentReservationInfo: MData.param('currentReservationInfo'),
    selectedDate: null,
    selectedTime: null,

    init: function(){ 
        this.setCalendarControl();
        this.setEventListner();
    }, 

    setEventListner: function(){
        var parentThis = this;
        $('#mykia-mycar-reserve-timeselect-list button').on("click", function(){ //#mykia-mycar-reserve-timeselect-list button, [data-handler=selectDay]
            parentThis.setNextButtonActivationState();
        })
        $('#mykia-mycar-reserve-calendar-select-time-next').on("click", function(){
            if(!$(this).hasClass('disabled')){
                parentThis.currentReservationInfo["prctCdt"] = moment(parentThis.selectedDate, "YYYYMMDD").format("YYYYMMDD");
                parentThis.currentReservationInfo["prctCtm"] = moment(parentThis.selectedTime, "HH:mm").format("HHmm");

                /* 2023.07.13 프리케어 만료일자 검증 */
                // 프리케어 정비항목을 사용자가 선택하고, 프리케어 만료일자가 존재할 경우 날짜 검증
                // 2024.04.25 freecareGrnYmd 변수 사용 중지, 사유 : 프리케어 항목별 만료일자 각각 체크
                // if ("Y" == parentThis.currentReservationInfo.freecareSelectYn && parentThis.currentReservationInfo.freecareGrnYmd) {
                if ("Y" == parentThis.currentReservationInfo.freecareSelectYn) {
                    var rejectList = []; // 만료일 이후의 날짜로 예약한 프리케어 목록
                    var freecareSelectList = parentThis.currentReservationInfo.freecareSelectList;
                    for (let i = 0; i < freecareSelectList.length; i++) {
                        var freecareSelect = freecareSelectList[i];
                        var freecareGrnYmd = moment(freecareSelect.grnYmd).format("YYYYMMDD");

                        // 선택한 예약일자보다 프리케어 만료일자가 빠를 경우 팝업 오픈하여 메시지 출력
                        if (freecareGrnYmd < parentThis.currentReservationInfo.prctCdt) {
                            rejectList.push(freecareSelect);
                        }

                    }
                    if (!isEmpty(rejectList)) {
                        var msg = "예약 날짜를 프리케어 만료일자보다 빠르게 지정해주세요.\n";
                        for (let i = 0; i < rejectList.length; i++) {
                            var rejectItem = rejectList[i];
                            var grnYmd = moment(rejectItem.grnYmd).format("YYYYMMDD");

                            if(i !== rejectList.length) msg += "\n";
                            if(i !== rejectList.length) msg += "\n";
                            msg += `${i+1}. ${rejectItem.pckgNm}\n`;
                            msg += `(프리케어 만료일자: ${grnYmd.substr(0,4)}년 ${grnYmd.substr(4,2)}월 ${grnYmd.substr(6,2)}일)`;
                        }

                        M.pop.alert({
                            title: '알림',
                            message: msg,
                            buttons : ['닫기'],
                        });

                        // M.pop.alert({
                        //     title: '알림',
                        //     message: '예약 날짜를 프리케어 만료일자보다 빠르게 지정해주세요.\n\n(프리케어 만료일자: '
                        //         + freecareGrnYmd.substr(0,4)+'년 '+freecareGrnYmd.substr(4,2)+'월 '+freecareGrnYmd.substr(6,2)+'일)',
                        //     buttons : ['닫기'],
                        // });
                        return;
                    }
                }

                // K딜리버리 서비스 지원하고, 만료일자 체크 [ 만료일이 예약일보다 크거나 같을 경우 ]
                if(parentThis.currentReservationInfo.isDTDSupported && !(parentThis.currentReservationInfo.DTDGrnYmd < parentThis.currentReservationInfo.prctCdt)){
                    // K딜리버리 서비스 지원 페이지 이동
                    COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_243_4100.path, function(){
                        var availableCount = parentThis.currentReservationInfo.DTDTotalCount - parentThis.currentReservationInfo.DTDUsedCount;
                        this.find('#mykia-mycar-reserve-dtd-coupon-avail-count').text(availableCount);
                        this.find('#mykia-mycar-reserve-dtd-coupon-total-count').text(parentThis.currentReservationInfo.DTDTotalCount);
                        this.find("#dtd-skip-and-continue").off().on("click", function(){
                            MPage.html({
                                path: PATH_MANAGER.KIA_RNW_243_6000.path,
                                param: {
                                    currentReservationInfo: parentThis.currentReservationInfo
                                }
                            })
                        })
                        this.find('#popDetailBtn').off().on("click", function(){
                            var currentSelectedTime = moment(parentThis.selectedTime, "HHmm");
                            if(currentSelectedTime.isBefore(moment("1000", "HHmm"))){
                                MPopup.instance("오전 10시 이전에 예약하신 경우 이용이 불가합니다.");
                                return;
                            }
                            else{
                                MPage.html({
                                    path: PATH_MANAGER.KIA_RNW_243_5000.path,
                                    param: {
                                        currentReservationInfo: parentThis.currentReservationInfo
                                    }
                                });
                            }
                        })
                    })
                }
                else{
                    // 예약 페이지 이동
                    MPage.html({
                        path: PATH_MANAGER.KIA_RNW_243_6000.path,
                        param: {
                            currentReservationInfo: parentThis.currentReservationInfo
                        }
                    })
                }
            }
        })
    },

    checkAutoQReserveAvailableDate: function(stationCode, partName, carNumber, carVin){
        // mobPrctTim A 전체 B 오전 C 오후
        MNet.httpSendAsync({
            path: _API.SVR.MYCAR.carService.schAutoqYmdList,
            sendData: {
                mbrId: PGV.loginInfo.mbrIdm,
                asnCd: stationCode,
                partLigCd: partName,
                carRgstNo: carNumber,
                vin: carVin,
                mobPrctTim: "A"
            }
        })
        .then(function(response){
            if (response.resultCode === "200"){
                var availableTimeList = response.carSvcAutoqYmdRnwResListDto;
                if (availableTimeList.length > 0){
                    for (var i = 0; i < availableTimeList.length; i++){
                        var curNode = availableTimeList[i];
                        var totalDaysCount = curNode.sumCnt;
                        var currentDate = curNode.ymd;
                        var currentAvailableTimeList = curNode.timeList;
                        if(currentAvailableTimeList.length > 0){
                            for (var j = 0; i< currentAvailableTimeList.length; j++){
                                var currentTimeInfo = currentAvailableTimeList[j];
                                var alreadyReservedTime = currentTimeInfo.goalPrctCt;
                                var availableReserveTime = currentTimeInfo.time;
                            }
                        }
                    }
                }
            }
        })
    },

    setNextButtonActivationState: function(){
        /* 데이터 상에 선택된 날과 날짜가 있고 UI 상에서도 시간 선택 박스가 선택된 상태에 있을 경우 */
        if(this.selectedDate && this.selectedTime && $("button.btn-time.js-active-btn.active:visible").length > 0){
            $('#mykia-mycar-reserve-calendar-select-time-next').removeClass('disabled');
        }
        else{
            $('#mykia-mycar-reserve-calendar-select-time-next').addClass('disabled');
        }
    },
    
    setCalendarControl: function(){
        var parentThis = this;
        // !!! 케이스마텍 추헌남 - 퍼블리셔 작성 코드를 일부 수정
        // ------------------------------
        // 	Datepicker
        // ------------------------------
        $.datepicker.setDefaults({
            setDate: new Date(),
            dateFormat: 'yymmdd',
            prevText: '이전 달',
            nextText: '다음 달',
            monthNames: ['01월', '02월', '03월', '04월', '05월', '06월', '07월', '08월', '09월', '10월', '11월', '12월'],
            monthNamesShort: ['01월', '02월', '03월', '04월', '05월', '06월', '07월', '08월', '09월', '10월', '11월', '12월'],
            dayNames: ['일', '월', '화', '수', '목', '금', '토'],
            dayNamesShort: ['일', '월', '화', '수', '목', '금', '토'],
            dayNamesMin: ['일', '월', '화', '수', '목', '금', '토'],
            showMonthAfterYear: true,
            yearSuffix: '년',
            minDate: "+0D",
            maxDate: "+60D",
            useCurrent: false,
            defaultDate: null,
            onSelect: function(dateText, inst) {
                parentThis.selectedDate = dateText;
                var availableDateTimes = parentThis.currentReservationInfo.targetStationAvailableDateTimes || parentThis.currentReservationInfo.availableDateTimes;
                parentThis.setTimeControl(_.find(availableDateTimes, function(element){return element.ymd === parentThis.selectedDate}));
                $('#mykia-mycar-reserve-calendar-non-select').addClass('none');
                $('#mykia-mycar-reserve-calendar-select-time').removeClass('none');
                parentThis.setNextButtonActivationState();
            },
            onUpdateDatepicker: function(){
                $('.ui-datepicker-today').removeClass('ui-datepicker-today');
            },
            beforeShowDay: function(date){
                /* !!! 케이스마텍 추헌남 - 주말인 경우 선택 제한이 있었으나 해제함 */
                // var noWeekend = jQuery.datepicker.noWeekends(date);
                // return noWeekend[0] ? [true] : noWeekend;

                /* 예약 가능한 날짜만 선택 가능하도록 제한 */
                var availableDateTimes = parentThis.currentReservationInfo.targetStationAvailableDateTimes || parentThis.currentReservationInfo.availableDateTimes;
                var isAvailable = _.find(availableDateTimes, function(element){return element.ymd === moment(date).format("YYYYMMDD")});
                isAvailable = isAvailable && isAvailable.timeList.length > 0;
                return isAvailable ? [true] : [false];

            }
        });

        //datepicker 생성
        $('.js-datepicker').datepicker();

        /* 처음 진입 today 선택됨 UI 비활성화 */
        $('.ui-datepicker-today').addClass('disabled');
        $('.ui-datepicker-today').removeClass('ui-datepicker-today');
        $('.ui-state-active').removeClass('ui-state-active');
        $(".ui-datepicker-current-day").removeClass("ui-datepicker-current-day")
    },

    setTimeControl: function(dateEntry){
        $('#mykia-mycar-reserve-timeselect-list').addClass('none');
        $('#mykia-mycar-reserve-timeselect-list-none').addClass('none');

        var parentThis = this;
        var htmlObjectList = [];
        $('#mykia-mycar-reserve-timeselect-list').html('');
        var timeList = dateEntry && dateEntry.hasOwnProperty("timeList") && dateEntry.timeList;
        if(typeof timeList === "object" && timeList.length > 0){
            for (var i = 0; i < timeList.length; i++){
                var curNode = timeList[i];
                var htmlObject = $('<button type="button" class="btn-time js-active-btn">' + moment(curNode.time, "HHmm").format("HH:mm") + '</button>');
                (function(currentTime){
                    htmlObject.off().on("click", function(){
                        parentThis.selectedTime = currentTime;
                        $(this).addClass("active");
                        $(this).siblings().removeClass("active");
                        if($(".btn-time.active").length > 0){
                            $("#mykia-mycar-reserve-calendar-select-time-next").removeClass("disabled");
                        }
                        else{
                            $("#mykia-mycar-reserve-calendar-select-time-next").addClass("disabled");
                        }
                    })
                })(curNode.time)
                htmlObjectList.push(htmlObject);
            }
        }
        if(htmlObjectList.length > 0){
            $('#mykia-mycar-reserve-timeselect-list').removeClass('none');
            $('#mykia-mycar-reserve-timeselect-list-none').addClass('none');
            $('#mykia-mycar-reserve-timeselect-list').html('');
            $('#mykia-mycar-reserve-timeselect-list').append(htmlObjectList);
        }
        else{
            $('#mykia-mycar-reserve-timeselect-list').addClass('none');
            $('#mykia-mycar-reserve-timeselect-list-none').removeClass('none');
        }
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_4000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
