/**

@파일명 : KIA_RNW_243_5000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.04.13 
@메뉴명 : 내 차 관리 탭_정비 탭_정비 예약_K딜리버리 예약
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_243_4000 ={
    currentReservationInfo: MData.param('currentReservationInfo'),
    
    serviceTypeDict: {
        "all" : "왕복 서비스 (픽업+딜리버리)",
        "pickup-only": "편도 서비스 (픽업)"
    },
    serviceType: "all",
    
    doesUseSameAddresses: false,

    init: function(){ 
        var reservedTime = moment(this.currentReservationInfo.prctCdt, "YYYYMMDD").format("YYYY년 MM월 DD일")
        $("#mykia-mycar-reserve-kdelivery-date").text(reservedTime);
        this.setEventListner();
    }, 

    checkRequiredField: function(){
        if($("#mykia-mycar-reserve-kdelivery-tabs button.active").data("tab") === "all"){
            if (this.doesUseSameAddresses){
                if ($("#mykia-mycar-reserve-kdelivery-form-pickup-addr01").val().length > 0){
                    $("#mykia-mycar-reserve-kdelivery-next").removeClass("disabled");
                }
                else{
                    $("#mykia-mycar-reserve-kdelivery-next").addClass("disabled");
                }
            }
            else{
                if ($("#mykia-mycar-reserve-kdelivery-form-pickup-addr01").val().length > 0 && $("#mykia-mycar-reserve-kdelivery-form-delivery-addr01").val().length > 0){
                    $("#mykia-mycar-reserve-kdelivery-next").removeClass("disabled");
                }
                else{
                    $("#mykia-mycar-reserve-kdelivery-next").addClass("disabled");
                }
            }
        }
        else {
            if($("#mykia-mycar-reserve-kdelivery-form-pickup-addr01").val().length > 0){
                $("#mykia-mycar-reserve-kdelivery-next").removeClass("disabled");
            }
            else{
                $("#mykia-mycar-reserve-kdelivery-next").addClass("disabled");
            }
        }
    },
    setEventListner: function(){
        var parentThis = this;
        $("#mykia-mycar-reserve-kdelivery-tabs button").on("click", function(){
            var currentTab = $(this).data("tab");
            parentThis.serviceType = currentTab;
            $(this).addClass("active");
            $(this).siblings().removeClass("active");
            switch(currentTab){
                case "all":
                    $("#mykia-mycar-reserve-kdelivery-form-pickup").removeClass("none");
                    $("#mykia-mycar-reserve-kdelivery-form-delivery").removeClass("none");
                    break;
                case "pickup-only":
                    $("#mykia-mycar-reserve-kdelivery-form-pickup").removeClass("none");
                    $("#mykia-mycar-reserve-kdelivery-form-delivery").addClass("none");
                    break;
            }
            parentThis.checkRequiredField();
        })
        $("#mykia-mycar-reserve-kdelivery-form-same-addr").on("click", function(){
            var curNode = $(this).find("input");
            var isChecked = curNode.prop("checked");
            console.log(isChecked);
            // var address01 = $("#mykia-mycar-reserve-kdelivery-form-delivery-addr01");
            // var address02 = $("#mykia-mycar-reserve-kdelivery-form-delivery-addr02");
            var deliveryInputArea = $("#deliveryInputArea");
            if(!isChecked){
                deliveryInputArea.addClass("none");
                parentThis.doesUseSameAddresses = true;
            }
            else{
                deliveryInputArea.removeClass("none");
                parentThis.doesUseSameAddresses = false;
            }
            parentThis.checkRequiredField();
            curNode.prop("checked", !isChecked);
        })

        $(document).on("click", "#mykia-mycar-reserve-kdelivery-form-pickup-addr01, #mykia-mycar-reserve-kdelivery-form-delivery-addr01", function(){
            var param = {
                searchType : $(this).attr("id")
            };
    
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_0D3_1310.path,
                animate : 'MODAL_UP',
                param : param
            });
        });
        $("#mykia-mycar-reserve-kdelivery-next").on("click", function(){
            if(!$(this).hasClass("disabled")){
                var pickupAddress01 = $("#mykia-mycar-reserve-kdelivery-form-pickup-addr01").val();
                var pickupAddress02 = $("#mykia-mycar-reserve-kdelivery-form-pickup-addr02").val();
                var deliveryAddress01 = $("#mykia-mycar-reserve-kdelivery-form-delivery-addr01").val();
                var deliveryAddress02 = $("#mykia-mycar-reserve-kdelivery-form-delivery-addr02").val();

                parentThis.currentReservationInfo.KDeliveryInfo = {
                    serviceType: parentThis.serviceTypeDict[parentThis.serviceType],
                    pickupAddress01: pickupAddress01,
                    pickupAddress02: pickupAddress02,
                    deliveryAddress01: parentThis.serviceType === "all" ? deliveryAddress01 : null,
                    deliveryAddress02: parentThis.serviceType === "all" ? deliveryAddress02 : null
                }
                if(parentThis.doesUseSameAddresses){
                    parentThis.currentReservationInfo.KDeliveryInfo["deliveryAddress01"] = pickupAddress01;
                    parentThis.currentReservationInfo.KDeliveryInfo["deliveryAddress02"] = pickupAddress02;
                }

                MPage.html({
                    path: PATH_MANAGER.KIA_RNW_243_6000.path,
                    param: {
                        currentReservationInfo: parentThis.currentReservationInfo
                    }
                })
            }
        })        
    },
    setPublisherEventListener: function(){
        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			$winTop = $nowTop;
			
		});
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_4000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        		var adressData = MData.param("zipInfo");
		if(isEmpty(adressData) || isEmpty(MData.param("searchType"))){
			return;
		}
		if(MData.param("searchType") == "mykia-mycar-reserve-kdelivery-form-pickup-addr01"){
			// PGV.myInfo.homeAdr = adressData.fullAddr;
			// PGV.myInfo.homeRdMgmtNo = adressData.buildingCode;
			// PGV.myInfo.homeRefrAdr = adressData.extraAddr;
			// PGV.myInfo.homeZip = adressData.zoneCode;
			var homeAdress = "";

			if(!isEmpty(adressData.extraAddr.split(',')[1])){
				homeAdress = adressData.fullAddr + '('+adressData.extraAddr.split(',')[1].trim()+')';
			}else{
				homeAdress = adressData.fullAddr;
			}

			$("#mykia-mycar-reserve-kdelivery-form-pickup-addr01").val(homeAdress || "");
			//setZipText("home", adressData.zoneCode);
		}else{
			// PGV.myInfo.wkplAdr = adressData.fullAddr;
			// PGV.myInfo.wkplRdMgmtNo = adressData.buildingCode;
			// PGV.myInfo.wkplRefrAdr = adressData.extraAddr;
			// PGV.myInfo.wkplZip = adressData.zoneCode;
			
			var wkAdress = "";

			if(!isEmpty(adressData.extraAddr.split(',')[1])){
				wkAdress = adressData.fullAddr + '('+adressData.extraAddr.split(',')[1].trim()+')';
			}else{
				wkAdress = adressData.fullAddr;
			}
			$("#mykia-mycar-reserve-kdelivery-form-delivery-addr01").val(wkAdress || "");
			//setZipText("wkpl", adressData.zoneCode);
		}
        KIA_RNW_243_4000.checkRequiredField();
    }, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){
        KIA_RNW_243_4000.checkRequiredField();
    } 
}; 
