/**

@파일명 : KIA_RNW_243_6000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 정비 예약 확인
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_243_6000 ={ 
    currentReservationInfo: MData.param('currentReservationInfo'),

    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        this.setCurrentReservationInfoViewBox(this.currentReservationInfo);
        this.setEventListner();
        this.setPublisherEventListener();
    }, 
    
    setEventListner: function(){
        var parentThis = this;
        $('.btn-tel').on("click", function(){
            M.sys.call(extractNumber($(this).text().trim()));
        })
        $('#mykia-mycar-reserve-review-target-station-view-detail').on("click", function(){
            var currentStationInfo = parentThis.currentReservationInfo.targetStationInfo || parentThis.currentReservationInfo.myAutoQStationInfo;
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_242_2000.path,
                param: {
                    targetStationInfo: currentStationInfo,
                    myAutoQStationInfo: parentThis.currentReservationInfo.myAutoQStationInfo
                }
            })
        })
        $('textarea').on("input", function(){
            var textAreaDOM = $(this);
            var textCount = textAreaDOM.val().length;
            var textCountDOM = textAreaDOM.parent().parent().siblings().find('em.c-font-primary');
            textCountDOM.text(textCount);
            if (textCount > 100){
                textAreaDOM.val(textAreaDOM.val().slice(0, 100));
                textCountDOM.text("100");
            }
        })
        $("#mykia-mycar-reserve-review-submit").on("click", function(){
            var reservationRequestText = $("#mykia-mycar-reserve-review-request-text").find('textarea').val();
            var kDeliveryRequestText = $("#mykia-mycar-reserve-review-kdelivery-request-text").find('textarea').val();

            console.log(reservationRequestText);

            if(reservationRequestText && reservationRequestText.trim().length > 0) parentThis.currentReservationInfo.prctSbc += "\n" + reservationRequestText;
            parentThis.currentReservationInfo.KDeliveryInfo.prctSbc = kDeliveryRequestText;
            
            parentThis.onClickReserveButton();
        })
    },

    setPublisherEventListener: function(){
        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();			
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)
            _sliderFilterList.slideTo(getSlideIdx, 300, false);	
            $('.slider-filter-list').find('.active').removeClass('active');
            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');				
        });

        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			$winTop = $nowTop;
			
		});

    },

    setCurrentReservationInfoViewBox: function(currentReservationInfo){
        var currentSelectedCar = currentReservationInfo.currentSelectedCar;
        var partNameList = currentReservationInfo.partNameList;
        var targetStationInfo = currentReservationInfo.targetStationInfo || 
                                (currentReservationInfo.targetStationInfo && currentReservationInfo.targetStationInfo.carSvcDetailAutoqRnwResDto);
        var myAutoQStationInfo = currentReservationInfo.myAutoQStationInfo;
        var currentReserveDate = currentReservationInfo.prctCdt;
        var currentReserveTime = currentReservationInfo.prctCtm;
        var KDeliveryInfo = currentReservationInfo.KDeliveryInfo;

        var currentStationType = (targetStationInfo && targetStationInfo.acps1Nm) || myAutoQStationInfo.acps1Nm;
        var currentStationName = (targetStationInfo && targetStationInfo.asnNm) || myAutoQStationInfo.asnNm;

        $('#mykia-mycar-reserve-review-car-nickname').text(currentSelectedCar.carAlias);
        $('#mykia-mycar-reserve-review-car-modelname').text(currentSelectedCar.mdlNm);
        $("#mykia-mycar-reserve-review-target-station-service-type").text(currentStationType);
        var stationNameDOM = $('#mykia-mycar-reserve-review-target-station-name');
        stationNameDOM.html(currentStationName + stationNameDOM.html());
        $('#mykia-mycar-reserve-review-car-number').text(currentSelectedCar.carRgstNo);
        $('#mykia-mycar-reserve-review-car-part-list').html(_.map(partNameList, function(element){return '<p>' + element + '</p>'}).join(""));
        $('#mykia-mycar-reserve-review-car-nickname').text(currentSelectedCar.carAlias);

        if(targetStationInfo && myAutoQStationInfo && targetStationInfo.asnCd === myAutoQStationInfo.asnCd){
            $('#mykia-mycar-reserve-review-is-myautoq').removeClass('none');
        }

        var dateText = moment(currentReserveDate, "YYYYMMDD");
        dateText = dateText.format('YYYY.MM.DD ') + ["일", "월", "화", "수", "목", "금", "토"][dateText.day()];
        var timeText = moment(currentReserveTime, "HHmm").format('HH:mm');
        $('#mykia-mycar-reserve-review-date').text(dateText + " " + timeText);

        var doesKDeliveryInfoExist = _.filter(Object.keys(KDeliveryInfo), function(element){return KDeliveryInfo[element]}).length > 0;
        if(doesKDeliveryInfoExist){
            var phoneNumber = PGV.loginInfo.hpno.slice(0,3) + "-" + PGV.loginInfo.hpno.slice(3, 7) + "-" + PGV.loginInfo.hpno.slice(7, 11);
            $('#mykia-mycar-reserve-review-kdelivery-container').removeClass('none');
            $('#mykia-mycar-reserve-review-kdelivery-name').text(PGV.loginInfo.mbrNm);
            $('#mykia-mycar-reserve-review-kdelivery-phone').text(phoneNumber);
            $('#mykia-mycar-reserve-review-kdelivery-service-type').text(KDeliveryInfo.serviceType);

            var pickupAddress = KDeliveryInfo.pickupAddress01 + " " + KDeliveryInfo.pickupAddress02 || "";
            var deliveryAddress = KDeliveryInfo.deliveryAddress01 + " " + KDeliveryInfo.deliveryAddress02 || "";
            $('#mykia-mycar-reserve-review-kdelivery-pickup-addr').text(pickupAddress);
            if(KDeliveryInfo.deliveryAddress01){
                $('#mykia-mycar-reserve-review-kdelivery-delivery-addr').text(deliveryAddress);
            }
            else{
                $("#mykia-mycar-reserve-review-kdelivery-delivery-addr-container").addClass("none");
            }
            
            $('#mykia-mycar-reserve-review-kdelivery-pickup-date').text(dateText);
        }
    },

    onClickReserveButton: function(){
        let parentThis = this;
        let reserveInfo = this.currentReservationInfo;
        let partName = reserveInfo.partLigCd;
        let carNumber = reserveInfo.currentSelectedCar.carRgstNo;
        let carVin = reserveInfo.currentSelectedCar.vin;
        let reserveDate = reserveInfo.prctCdt;
        let reserveTime = reserveInfo.prctCtm;
        let reserveRequestNote = reserveInfo.prctSbc;
        let stationCode = reserveInfo.targetStationInfo && reserveInfo.targetStationInfo.asnCd || reserveInfo.myAutoQStationInfo.asnCd;
        let stationNotes = reserveInfo.targetStationInfo?.specifics || reserveInfo.myAutoQStationInfo?.specifics || null;

        // 특이사항 XSS 공격 체크
        stationNotes = typeof stationNotes === "string" &&
            _.map(stationNotes.split("\n"), function(element){
                return COMMON_FUNCTION.TOOL.SECURITY.cleanXSS(element);
            }).join("<br>") || "특이사항 없습니다.";

        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_243_6100.path, function(){
            this.find("#mykia-mycar-reserve-popup-note-description").html(stationNotes);
            this.find("#mykia-mycar-reserve-popup-confirm").off("click").on("click", function(){
                parentThis.reserveAutoQ(
                    stationCode,
                    partName,
                    carNumber,
                    carVin,
                    reserveDate,
                    reserveTime,
                    reserveRequestNote
                )
                .then(function(response){
                    if (typeof response.reservationNumber === "string" && response.reservationNumber.length > 0){
                        var autoQReservationNumber = response.reservationNumber;
                        var KDeliveryInfo = parentThis.currentReservationInfo.KDeliveryInfo;
                        var doesKDeliveryInfoExist = _.filter(Object.keys(KDeliveryInfo), function(element){return KDeliveryInfo[element]}).length > 0;
                        if(doesKDeliveryInfoExist){
                            var kDeliveryReserveType = KDeliveryInfo.serviceType
                            var deliveryTypeDict = {
                                "왕복 서비스 (픽업+딜리버리)": "1",
                                "편도 서비스 (픽업)": "2",
                                "편도 서비스 (딜리버리)": "3",
                                "편도 서비스 (방문진단)": "4"
                            };
                            var kDeliveryReserveTypeParam = deliveryTypeDict[kDeliveryReserveType];
                            var reservePlace = KDeliveryInfo.pickupAddress01 + " " + KDeliveryInfo.pickupAddress02;
                            var deliveryPlace = "";
                            if(KDeliveryInfo.deliveryAddress01){
                                deliveryPlace = KDeliveryInfo.deliveryAddress01 + " " + KDeliveryInfo.deliveryAddress02;
                            }
                            var deliveryRequestNote = KDeliveryInfo.prctSbc;
                            parentThis.reserveDTD(
                                kDeliveryReserveTypeParam,
                                carNumber,
                                carVin,
                                reserveDate,
                                reservePlace,
                                deliveryPlace,
                                deliveryRequestNote,
                                autoQReservationNumber
                            )
                            .then(function(DTDResponse){
                                console.log(DTDResponse);
                                if(DTDResponse.resultCode === "200"){
                                    if(DTDResponse.isReserveSuccessful){
                                        MPage.html({
                                            path: PATH_MANAGER.KIA_RNW_243_7000.path,
                                            param: {
                                                currentReservationInfo: parentThis.currentReservationInfo
                                            }
                                        })    
                                    }
                                    else{
                                        MPopup.confirm({
                                            title: "알림",
                                            message: "죄송합니다.\nK딜리버리 예약이 되지 않았습니다.\n정비 예약만 정상 예약되었습니다.",
                                            buttons: ["확인"],
                                            callback: function (index) {
                                                parentThis.currentReservationInfo.KDeliveryInfo = {"thisIsEmptyData": null};
                                                MPage.html({
                                                    path: PATH_MANAGER.KIA_RNW_243_7000.path,
                                                    param: {
                                                        currentReservationInfo: parentThis.currentReservationInfo
                                                    }
                                                })
                                            }
                                        });
                                    }
                                }
                                else{
                                    MPopup.alert(DTDResponse.resultMessage);
                                }
                            });
                        }
                        else{
                            MPage.html({
                                path: PATH_MANAGER.KIA_RNW_243_7000.path,
                                param: {
                                    currentReservationInfo: parentThis.currentReservationInfo
                                }
                            })
                        }
                    }
                    else{
                        exWNHideIndicator();
                        MPopup.confirm({
                            title: "알림",
                            message: response.errorMessage, //"정비 예약에 실패하였습니다.",
                            buttons: ["확인"]
                        });
                    }
                })
            })
        })
    },

    reserveAutoQ: function(stationCode, partName, carNumber, carVin, reserveDate, reserveTime, reserveRequestNote){
        console.log("throwing in reserve autoq: ", {
            mbrId: PGV.loginInfo.mbrId,
            asnCd: stationCode,
            partLigCd: partName,
            carRgstNo: carNumber,
            vin: carVin,
            prctCdt: reserveDate, //YYYYMMDD
            prctCtm: reserveTime, // HHMI
            prctSbc: reserveRequestNote
        })
        return new Promise(function(resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqRsvReq,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    asnCd: stationCode,
                    partLigCd: partName,
                    carRgstNo: carNumber,
                    vin: carVin,
                    prctCdt: reserveDate, //YYYYMMDD
                    prctCtm: reserveTime, // HHMI
                    prctSbc: reserveRequestNote
                },
                isMock: false
            })
            .then(function(response){
                console.log(response);
                if(response.resultCode === "200"){
                    var isReserveSuccessful = response.regYn === "Y";
                    var reservationNumber = response.prctCdNo;
                    resolve({
                        isReserveSuccessful: isReserveSuccessful,
                        reservationNumber: reservationNumber,
                        errorMessage : response.errorMsg
                    });   
                }
            })
        })
    },

    reserveDTD: function(reserveType, carNumber, carVin, reserveDate, reservePlace, deliveryPlace, reserveRequestNote, autoQReservationNumber){
        return new Promise(function(resolve, reject){
            var tempSendData = {
                mbrId: PGV.loginInfo.mbrId,
                scnCd: reserveType,
                carRgstNo: carNumber,
                vin: carVin,
                acqRqYmd: reserveDate, 
                acqPlNm: reservePlace, 
                etcSbc: reserveRequestNote,
                prctCdNo: autoQReservationNumber
            };
            tempSendData["dlgPlNm"] = deliveryPlace || null;
            console.log("throwing in reserve dtd : ", tempSendData);
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.dtdRsvReg,
                sendData: tempSendData,
                isMock: false
            })
            .then(function(response){
                console.log("response from reserve dtd : " , response);
                var isReserveSuccessful = response.regYn === "Y";
                var resultCode = response.resultCode;
                var resultMessage = response.resultMsg
                resolve({
                    isReserveSuccessful: isReserveSuccessful,
                    resultCode : resultCode,
                    resultMessage: resultMessage
                });
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_6000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
