/**

@파일명 : KIA_RNW_243_7000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.01.26 
@메뉴명 : 정비 예약 확인
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_243_7000 ={ 
    currentReservationInfo: MData.param('currentReservationInfo'),

    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        this.setCurrentReservationInfoViewBox(this.currentReservationInfo);
        this.setEventListner();
        this.setPublisherEventListener();
        // 상세 정비 요청 사항을 기존 요청 정보 뒤에 갖다 붙힌다.
    }, 
    setEventListner: function(){
        var parentThis = this;
        $("#mykia-mycar-reserve-result-reserve-history").on("click", function(){
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_244_1000.path
            })
        })
        $('#mykia-mycar-reserve-result-target-station-view-detail').on("click", function(){
            var currentStationInfo = parentThis.currentReservationInfo.targetStationInfo || parentThis.currentReservationInfo.myAutoQStationInfo;
            MPage.html({
                path: PATH_MANAGER.KIA_RNW_242_2000.path,
                param: {
                    targetStationInfo: currentStationInfo,
                    myAutoQStationInfo: parentThis.currentReservationInfo.myAutoQStationInfo
                }
            })
        })
        $('#mykia-mycar-reserve-result-confirm, .btn-prev').on("click", function(){
            COMMON_FUNCTION.TOOL.UI.myKiaReserveInterface.backWithDeletingAllReservePageStacks();
        })
        $('#kDelivery').off("click").on("click", function(){
            MPage.activity({
                className: "WebviewActivity",
                param: {
                    method: CONSTANT.NET_MTHD.GET,
                    //requestURL: "https://m.members.kia.com/kr/view/web/knet/knet_door_to_door.do"
                    requestURL: CONSTANT.LINK_URL.KIA_MOB_410_1002.URL
                }
            });
        })
    },

    setPublisherEventListener: function(){
        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			$winTop = $nowTop;
			
		});

        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			$winTop = $nowTop;
			
		});
    },

    setCurrentReservationInfoViewBox: function(currentReservationInfo){
        var currentSelectedCar = currentReservationInfo.currentSelectedCar;
        var partNameList = currentReservationInfo.partNameList;
        var targetStationInfo = currentReservationInfo.targetStationInfo ||
                                (currentReservationInfo.targetStationInfo && currentReservationInfo.targetStationInfo.carSvcDetailAutoqRnwResDto);
        var myAutoQStationInfo = currentReservationInfo.myAutoQStationInfo;
        var currentReserveDate = currentReservationInfo.prctCdt;
        var currentReserveTime = currentReservationInfo.prctCtm;
        var currentReservationRequestText = currentReservationRequestText &&
                                            typeof currentReservationRequestText === "string" &&
                                            _.map(currentReservationInfo.prctSbc.split("\n").slice(1, currentReservationInfo.prctSbc.split("\n").length), function(element){
                                                return COMMON_FUNCTION.TOOL.SECURITY.cleanXSS(element);
                                            }).join("<br>") || "";
        if(!(currentReservationRequestText.trim().length > 0)){
            currentReservationRequestText = "없음";
        }
        
        var KDeliveryInfo = currentReservationInfo.KDeliveryInfo;
        
        var currentStationType = (targetStationInfo && targetStationInfo.acps1Nm) || myAutoQStationInfo.acps1Nm;
        var currentStationName = (targetStationInfo && targetStationInfo.asnNm) || myAutoQStationInfo.asnNm;

        $('#mykia-mycar-reserve-result-car-nickname').text(currentSelectedCar.carAlias);
        $('#mykia-mycar-reserve-result-car-modelname').text(currentSelectedCar.mdlNm);
        $("#mykia-mycar-reserve-result-target-station-service-type").text(currentStationType);
        var stationNameDOM = $('#mykia-mycar-reserve-result-target-station-name');
        stationNameDOM.html(currentStationName + stationNameDOM.html());
        $('#mykia-mycar-reserve-result-car-number').text(currentSelectedCar.carRgstNo);
        $('#mykia-mycar-reserve-result-car-part-list').html(_.map(partNameList, function(element){return '<p>' + element + '</p>'}).join(""));
        $('#mykia-mycar-reserve-result-car-nickname').text(currentSelectedCar.carAlias);
        $('#mykia-mycar-reserve-result-request-text').html(currentReservationRequestText)

        if(targetStationInfo && myAutoQStationInfo && targetStationInfo.asnCd === myAutoQStationInfo.asnCd){
            $('#mykia-mycar-reserve-result-is-myautoq').removeClass('none');
        }

        var dateText = moment(currentReserveDate, "YYYYMMDD");
        dateText = dateText.format('YYYY.MM.DD ') + ["일", "월", "화", "수", "목", "금", "토"][dateText.day()];
        var timeText = moment(currentReserveTime, "HHmm").format('HH:mm');
        $('#mykia-mycar-reserve-result-date').text(dateText + " " + timeText);

        var doesKDeliveryInfoExist = _.filter(Object.keys(KDeliveryInfo), function(element){return KDeliveryInfo[element]}).length > 0;
        if(doesKDeliveryInfoExist){
            var phoneNumber = PGV.loginInfo.hpno.slice(0,3) + "-" + PGV.loginInfo.hpno.slice(3, 7) + "-" + PGV.loginInfo.hpno.slice(7, 11);
            $('#mykia-mycar-reserve-result-kdelivery-container').removeClass('none');
            $('#mykia-mycar-reserve-result-kdelivery-name').text(PGV.loginInfo.mbrNm);
            $('#mykia-mycar-reserve-result-kdelivery-phone').text(phoneNumber);
            $('#mykia-mycar-reserve-result-kdelivery-service-type').text(KDeliveryInfo.serviceType);

            var pickupAddress = KDeliveryInfo.pickupAddress01 + " " + KDeliveryInfo.pickupAddress02 || "";
            var deliveryAddress = KDeliveryInfo.deliveryAddress01 + " " + KDeliveryInfo.deliveryAddress02 || "";
            $('#mykia-mycar-reserve-result-kdelivery-pickup-addr').text(pickupAddress);
            if(KDeliveryInfo.deliveryAddress01){
                $('#mykia-mycar-reserve-result-kdelivery-delivery-addr').text(deliveryAddress);
            }
            else{
                $("#mykia-mycar-reserve-result-kdelivery-delivery-addr-container").addClass("none");
            }
            $('#mykia-mycar-reserve-result-kdelivery-pickup-date').text(dateText);

            // var KDeliveryRequestText = KDeliveryInfo.prctSbc.split("\n").join("<br>");
            var KDeliveryRequestText = KDeliveryInfo.prctSbc &&
                                       typeof KDeliveryInfo.prctSbc === "string" &&
                                       _.map(KDeliveryInfo.prctSbc.split("\n"), function(element){
                                            return COMMON_FUNCTION.TOOL.SECURITY.cleanXSS(element);
                                        }).join("<br>") || "";
            if(!(KDeliveryRequestText.trim().length > 0)){
                KDeliveryRequestText = "없음";
            }
            $('#mykia-mycar-reserve-result-kdelivery-request-text').attr("style", "white-space: pre-line").text(KDeliveryRequestText);
        }

        var isRsvInfo = currentReservationInfo.isRsvYnInfo;
        if(isRsvInfo.freecareYn == "Y"){
            var useCnt = "";
            var dtdYn = "";
            var freeCareList = isRsvInfo.freecareList;
            for(var i=0;i < freeCareList.length; i++){
                if(freeCareList[i].dtdYn == "Y"){
                    useCnt = freeCareList[i].apimOft - freeCareList[i].vinCnt;
                    dtdYn = freeCareList[i].dtdYn;
                }
            }
            if(dtdYn == "Y") {
                if (useCnt == 0) {
                    $('.section-02').removeClass("none");
                }
            }else{
                $('.section-02').removeClass("none");
            }
        }else{
            $('.section-02').removeClass("none");
        }
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_243_7000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 