/**

@파일명 : KIA_RNW_244_1000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 :  
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_244_1000 ={ 
    tabularNavigator: null,
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        /* !!! 케이스마텍 추헌남 - 예약 페이지에서 해당 페이지로 넘어옵니다. 이 때 스택에 예약 관련 페이지를 모두 지워야 합니다. */
        COMMON_FUNCTION.TOOL.UI.myKiaReserveInterface.deleteAllReservePageStacks();
        
        !this.tabularNavigator && this.setTabularNavigator();
        this.setPublisherEventListener();
        this.setAutoQReserveHistory("ALL", 0, 10);
        this.setEventListner();
        // COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(this.handleLoadMore);
    },

    pageMeta: {
        prctScnCd: null,
        stopLoadingMore: false,
        nowPage: 1,
        pageSize: 10
    },

    setEventListner: function(){
        var parentThis = this;
        $("[data-filter-type]").off("click").on("click", function(){
            $(this).addClass("active");
            $(this).siblings().removeClass("active");
            parentThis.setAutoQReserveHistory($(this).data('filter-type'));
        })
    },

    setPublisherEventListener: function(){
        var parentThis = this;
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });
        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			$winTop = $nowTop;

		});

    },

    setTabularNavigator: function(){
        var parentThis = this;
        COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.init({
            tabWrapperQueryString: "section",
            tabs: $('.tabs#mykia-mycar-status-tabs').children(),
            tabsMeta: [
                {
                    page: {
                        useDOM: $('section'),
                        loadScript: false,
                        isMain: true
                    }
                },
                {
                    page: {
                        pathManager: PATH_MANAGER.KIA_RNW_244_2000,
                        loadScript: true,
                        isMain: false
                    }
                }
            ],
            lifeCycles:{
                afterInit: function(){
                },
                afterOpenedTheTab: function(){
                    if (this.currentTabIndex === 0){
                        KIA_RNW_244_1000.setAutoQReserveHistory("ALL");
                        KIA_RNW_244_1000.setPublisherEventListener();
                        KIA_RNW_244_1000.setEventListner();
                    }

                    fnIsFooterNav(); //footer 네비게이션 메뉴영역이 있는경우, 없는경우 제어
                }
            },
            viewerArea:$('#mykia-mycar-status-content'),
            addEventListeners: true,
        }).then(function(resultTabularNavigator){
            parentThis.tabularNavigator = resultTabularNavigator;
        });
    },

    setAutoQReserveHistory: function(type, nowPage, pageSize, loadMoreMode){ // ALL - 전체, U - 이용, D - 취소
        this.pageMeta.prctScnCd = type;
        var parentThis = this;
        console.log("throwing:", {
            mbrId: PGV.loginInfo.mbrId,
            prctScnCd: type,
            nowPage: nowPage || 1,
            pageSize: pageSize || 10
        })
        return new Promise(function(resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqRsvHistInfoList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    prctScnCd: type
                    // nowPage: nowPage || 1,
                    // pageSize: pageSize || 10
                },
                isMock: false
            }).then(function(response){
                var responseList = response.autoqRsvHistInfoListRnwResDto;
                var listContainer = $('.reserve-cont.status .inner-cont');
                var htmlObjectList = [];
                if(responseList && responseList.length > 0){
                    if (loadMoreMode){
                        parentThis.pageMeta.nowPage++;
                    }
                    else{
                        parentThis.pageMeta.nowPage = nowPage;
                        parentThis.pageMeta.stopLoadingMore = false;
                        listContainer.empty();
                    }
                    for (var i = 0; i< responseList.length; i++){
                        var daysInfo = {"0": "일", "1": "월", "2": "화", "3": "수", "4": "목", "5": "금", "6": "토"}
                        var currentNode = responseList[i];
                        var reserveNumber = currentNode.prctCdNo;
                        var stationName = currentNode.asnNm;
                        var reserveDate = currentNode.prctCdtm && moment(currentNode.prctCdtm, "YYYYMMDDHHmm") || null;
                        var reserveDateText =  reserveDate.format("YYYY.MM.DD") + " " + daysInfo[reserveDate.day()] + " " + reserveDate.format("HH:mm");
                        var currentVehicleModelName = currentNode.mdlNm;
                        var currentVehicleNo = currentNode.carRegNo;
                        var reserveState = currentNode.ceqPrctStNm;
                        //var currentClassName = reserveState === "이용" ? "c-font-brand-secondary-02": "c-font-brand-secondary-03";
                    
                        var curHtmlObject = (function(reserveNumber, stationName, reserveDate, currentVehicleModelName, currentVehicleNo, reserveState){
                            var templateString =
                                '<div class="div-item' + (reserveState === "취소" ? " disabled" : "") + '">' +
                                    '<dl>' +
                                        '<dt>' +
                                        '<span className="label-cont">'+
											'<em className="label-status"><b class="c-font-brand-secondary-02">'+ reserveState +'</b></em>' +
										'</span>'+
                                        '<h4 class="text-scale-04"><b>' + stationName + '</b></h4>' +
                                            '<button type="button" class="btn-arrow-right">' +
                                                '<i class="ico-arrow-right"><em class="blind">자세히보기</em></i>' +
                                            '</button>' +
                                        '</dt>' +
                                        '<dd>' +
                                            '<div class="div-table">' +
                                                '<div class="name div-table-cell">방문 일정</div>' +
                                                '<div class="value div-table-cell">' + reserveDateText + '</div>' +
                                            '</div>' +
                                            '<div class="div-table">' +
                                                '<div class="name div-table-cell">정비 차량</div>' +
                                                '<div class="value div-table-cell">' + currentVehicleModelName + ' ' + currentVehicleNo +'</div>' +
                                            '</div>' +
                                        '</dd>' +
                                    '</dl>' +
                                '</div>';
    
                            
                            var templateObject = $(templateString);

                            templateObject.off("click").on("click", function(){
                                console.log("reserve number : ", reserveNumber);
                                MPage.html({
                                    path: PATH_MANAGER.KIA_RNW_244_1100.path,
                                    param: {
                                        reserveNumber: reserveNumber,
                                        vehicleNo: currentVehicleNo
                                    }
                                })
                            })
                            return templateObject;
                        })(reserveNumber, stationName, reserveDate, currentVehicleModelName, currentVehicleNo, reserveState);
    
    
                        htmlObjectList.push(curHtmlObject);
                    }

                    var infoHtmlString =
                            '<div class="inner-info">' +
                                '<div class="info-title">' +
                                    '<h4 class="text-scale-06"><b>안내사항</b></h4>' +
                                '</div>' +
                                '<ul>' +
                                    '<li>' +
                                        '<p class="bullet-dot">' +
                                            '예약시간 30분전에 입고하셔서 작업배정을 받아 주시기 바라며, 지연 입고시 당일 입고 차량과 동일한 입고순서에 따라 정비 진행되오니 유의해 주시기 바랍니다.' +
                                        '</p>' +
                                    '</li>' +
                                    '<li>' +
                                        '<p class="bullet-dot">' +
                                            '예약을 하신 경우에도 예약 당일 사업장 사정, 부품 결품 등으로 작업시간이 지연될 수 있는 점 양해 바랍니다.' +
                                        '</p>' +
                                    '</li>' +
                                '</ul>' +
                            '</div>';
                    
                    htmlObjectList.push($(infoHtmlString));
    
                    listContainer.append(htmlObjectList);
                }
                else{
                    if (loadMoreMode){
                        parentThis.pageMeta.stopLoadingMore = true;
                    }
                    else {
                        var emptyMessageString =
                            '<div class="nodata-area">' +
                                '<div class="ico-cont">' +
                                    '<i class="ico-nodata-maintenance"></i>' +
                                '</div>' +
                                '<p>' +
                                    '정비 예약 내역이 없습니다.' +
                                '</p>' +
                            '</div>';
                        listContainer.html(emptyMessageString);
                    }
                }
                exWNHideIndicator();
                resolve();
            })
        })
    },

    handleLoadMore: function(){
        if(!this.pageMeta.stopLoadingMore){
            var prctScnCd = this.pageMeta.prctScnCd;
            var nowPage = this.pageMeta.nowPage;
            var pageSize = this.pageMeta.pageSize;
            this.setAutoQReserveHistory(prctScnCd, nowPage, pageSize, true);
        }
    }
} 

var hideLoadingIndicator = function(){
    var runnerCounter = 0;
    var runner = setInterval(function(){
        runnerCounter++;
        if(runnerCounter > 100){
            clearInterval(runner);
            COMMON_FUNCTION.TOOL.DEBUG.showAdvice("KIA_RNW_244_1000.js:hideLoadingIndicator : dim 페이지 대기 중 타임아웃");
        }
        if($(".loading-area .dim:visible").length > 0){
            clearInterval(runner);
            exWNHideIndicator();
        }
    }, 100);
}


/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_244_1000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        var currentTabIndex = KIA_RNW_244_1000.tabularNavigator.currentTabIndex;
        KIA_RNW_244_1000.tabularNavigator.open(currentTabIndex, true);
        // if(KIA_RNW_244_1000){
        //     switch(KIA_RNW_244_1000.tabularNavigator.currentTabIndex){
        //         case 0:
        //             KIA_RNW_244_1000.init();
        //             break;
        //         case 1:
        //             KIA_RNW_244_2000.init();
        //             break;
        //     }
        // }
    }, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){
        var currentTabIndex = KIA_RNW_244_1000.tabularNavigator.currentTabIndex;
        KIA_RNW_244_1000.tabularNavigator.open(currentTabIndex, true);
        // if(KIA_RNW_244_1000){
        //     switch(KIA_RNW_244_1000.tabularNavigator.currentTabIndex){
        //         case 0:
        //             KIA_RNW_244_1000.init();
        //             break;
        //         case 1:
        //             KIA_RNW_244_2000.init();
        //             break;
        //     }
        // }
    } 
}; 
