/**

@파일명 : KIA_RNW_244_1100.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 :  
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/
var CurrPage;
var KIA_RNW_244_2100 = {
    init: function () {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var reserveNumber = MData.param("reserveNumber");
        var vehicleNumber = MData.param("vehicleNo");
        this.setAutoQReserveHistoryDetail(reserveNumber);
        this.setPublisherEventListener();
    },

    setEventListner: function () {
        // do something.. 
    },

    setPublisherEventListener: function(){

        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();			
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)
            _sliderFilterList.slideTo(getSlideIdx, 300, false);	
            $('.slider-filter-list').find('.active').removeClass('active');
            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');				
        });
		

		// ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
	
			
			$winTop = $nowTop;
			
		});
    },

    setAutoQReserveHistoryDetail: function (reserveNumber) {
        var parentThis = this;
        return new Promise(function (resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.autoqRsvDetailInfo,
                isMock: false,
                sendData: {
                    mbrId : PGV.loginInfo.mbrId,
                    prctCdNo: reserveNumber
                },
            }).then(function (response) {
                console.log("historydetail: ", response);
                if (response.resultCode === "200"){
                    var daysInfo = {"0": "일", "1": "월", "2": "화", "3": "수", "4": "목", "5": "금", "6": "토"}
                    var currentState = response.ceqPrctStNm;
                    var vehicleNickname = response.carAlias; // ??? 케이스마텍 추헌남 ppt 110 페이지 차량 오른쪽 값이 뭐에 해당하는지 모르겠음
                    var vehicleModelName = response.mdlNm;
                    var vehicleNo = response.carRegNo;
                    var stationName = response.asnNm; // ??? ppt 110 페이지 전문서비스가 적혀있는데 그 전문서비스라는게 뭐에 해당하는지?
                    var stationCode = response.asnCd;
                    var reserveDate = moment(response.prctCdtm, "YYYYMMDDHHmm");
                    var reserveDateText =  reserveDate.format("YYYY.MM.DD") + " " + daysInfo[reserveDate.day()] + " " + reserveDate.format("HH:mm");
                    var maintenanceRequestNote = COMMON_FUNCTION.TOOL.SECURITY.cleanXSS(response.prctSbc);
                    var isCancelButtonActivated = false;


                    console.log("currentState == >> "+currentState);
                    var currentStateText = "";
                    if(currentState === "예약"){
                        currentStateText = "예약된 정비 내역이 있습니다.<br>방문 일정을 확인해 주세요.";
                    }
                    else if(currentState === "이용"){
                        currentStateText = "이용이 완료된 내역입니다.";
                    }
                    else if(currentState === "취소"){
                        currentStateText = "예약이 취소된 내역입니다.";
                    }
    
                    var templateString = 
                        '<div class="div-title">' +
                            '<h3 class="text-scale-03"><b>' + currentStateText + '</b></h3>' +
                        '</div>' +
    
                        '<div class="div-body">' +
                            '<div class="div-item">' +
                                '<dl>' +
                                    '<dt>' +
                                        '<h5 class="text-scale-05">정비 예약 정보</h5>' +
                                    '</dt>' +
                                    '<dd>' +
                                        '<div class="div-table">' +
                                            '<div class="name div-table-cell">차량</div>' +
                                            '<div class="value div-table-cell">' +
                                                (vehicleNickname && '<p>' + vehicleNickname + '</p>' || "") +
                                                '<p>' + vehicleModelName + (vehicleNo && ' | ' + vehicleNo || "") + '</p>' +
                                            '</div>' +
                                        '</div>' +
                                        '<div class="div-table">' +
                                            '<div class="name div-table-cell">정비소</div>' +
                                            '<div class="value div-table-cell" id="mykia-mycar-maint-detail-go-to-station-detail">' +
                                                '<p>전문서비스</p>' +
                                                '<p>' +
                                                    stationName +
                                                    '<button type="button" class="btn-arrow-right">' +
                                                        '<i class="ico-arrow-right"><em class="blind">자세히보기</em></i>' +
                                                    '</button>' +
                                                '</p>' +
                                            '</div>' +
                                        '</div>' +
                                        '<div class="div-table">' +
                                            '<div class="name div-table-cell">방문일정</div>' +
                                            '<div class="value div-table-cell">' +
                                                '<p>' + reserveDateText + '</p>' +
                                            '</div>' +
                                        '</div>' +
                                        '<div class="div-block">' +
                                            '<div class="name">정비 항목 및 정비 요청 사항</div>' +
                                            '<div class="value">' +
                                                '<div class="c-bg-gray">' +
                                                    '<p>' + maintenanceRequestNote + '</p>' +
                                                '</div>' +
                                            '</div>' +
                                        '</div>' +
                                    '</dd>' +
                                '</dl>' +
                            '</div>' +
                        '</div>';
                    
                    var cancelButton = 
                        '<div class="btn-block" id="mykia-mycar-maint-detail-cancel" data-reserve-number="' + reserveNumber + '" data-vehicle-number="' + vehicleNo + '">' +
                            '<button type="button" class="btn-primary">' +
                                '<em>예약 취소</em>' +
                            '</button>' +
                        '</div>';
                    
                    if(moment().isBefore(reserveDate) && currentState === "예약"){
                        templateString += cancelButton;
                        isCancelButtonActivated = true;
                    }
                    
                    $('.reserve-cont.detail .inner-cont').html(templateString);
    
                    if(isCancelButtonActivated){
                        $('#mykia-mycar-maint-detail-cancel').on("click", function(){
                            var curReserveNumber = $(this).data('reserve-number');
                            var curVehicleNo = $(this).data('vehicle-number');
                            parentThis.onClickCancelAutoQReserve(curVehicleNo, curReserveNumber);
                        })
                    }
                    
                    $("#mykia-mycar-maint-detail-go-to-station-detail").on("click", function(){
                        MPage.html({
                            path: PATH_MANAGER.KIA_RNW_242_2000.path,
                            param: {
                                targetStationCode: stationCode
                            }
                        })
                    })
                }
                exWNHideIndicator();
                resolve();
            })
        })
    },
    onClickCancelAutoQReserve: function (vehicleNumber, reserveNumber){        
        M.pop.alert({
            title: '정비 예약을 취소하시겠습니까?',
            message: '예약을 취소하실 경우, K딜리버리 서비스 신청 내역도 같이 취소됩니다.',
            buttons: ['네', '아니오'],
            callback: function (index) {
                if(index === 0){
                    MNet.httpSendAsync({
                        path: _API.SVR.MYCAR.carService.autoqRsvCancel,
                        sendData: {
                            mbrId: PGV.loginInfo.mbrId,
                            prctCdNo: reserveNumber,
                            carRegNo: vehicleNumber
                        },
                    })
                    .then(function(response){ 
                        if(response.resultCode === "200"){
                            M.pop.alert({
                                title: '정비 예약이 취소되었습니다.',
                                buttons: ["확인"],
                                callback: function(){
                                    MPage.back();
                                }
                            });
                        }
                    })
                }
            }
        });
    }
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_244_2100.init();
    },
    onHide: function (event) { },
    onRestore: function (event) { },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
