/**

@파일명 : KIA_RNW_244_2000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 :  
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_244_2000 ={ 
    tabularNavigator: null,
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        this.setDeliveryReserveHistory("ALL");
        this.setPublisherEventListener();
        this.setEventListner();
        // COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(this.handleLoadMore);
    }, 

    pageMeta: {
        prctScnCd: null,
        stopLoadingMore: false,
        nowPage: 1,
        pageSize: 10
    },

    setEventListner: function(){
        var parentThis = this;
        $("[data-filter-type]").off("click").on("click", function(){
            $(this).addClass("active");
            $(this).siblings().removeClass("active");
            var filterType = $(this).data('filter-type');
            if(filterType === "ALL"){
                $("[data-reserve-state]").removeClass("none");
            }
            else{
                $("[data-reserve-state]").addClass("none");
                $("[data-reserve-state=" + filterType +"]").removeClass("none");
            }
            if($("[data-reserve-state]:visible").length > 0){
                $("#mykia-mycar-dtd-history-nodata.nodata-area").addClass("none");
            }
            else{
                if($(".nodata-area:visible").length > 0){
                    $("#mykia-mycar-dtd-history-nodata.nodata-area").removeClass("none");
                }
                else{
                    if($("#mykia-mycar-dtd-history-nodata.nodata-area").length == 0) {
                        var emptyMessageString =
                            '<div class="nodata-area" id="mykia-mycar-dtd-history-nodata">' +
                            '<div class="ico-cont">' +
                            '<i class="ico-nodata-maintenance-k"></i>' +
                            '</div>' +
                            '<p>' +
                            'K딜리버리 예약 내역이 없습니다.' +
                            '</p>' +
                            '</div>';
                        $("#mykia-mycar-dtd-history-list-container").prepend($(emptyMessageString));
                    }else{
                        $("#mykia-mycar-dtd-history-nodata.nodata-area").removeClass("none");
                    }
                }
            }
        })
    },

    setPublisherEventListener: function(){
        var parentThis = this;
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        // $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
        //     e.preventDefault();			
        //     var getSlideIdx = $(this).data('slide-index');
        //     //console.log('getSlideIdx', getSlideIdx)
        //     _sliderFilterList.slideTo(getSlideIdx, 300, false);	
        //     $('.slider-filter-list').find('.active').removeClass('active');
        //     $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');				

        //     switch(getSlideIdx){
        //         case "0":
        //             parentThis.getDeliveryReserveHistory("ALL");
        //             break;
        //         case "1":
        //             parentThis.getDeliveryReserveHistory("U");
        //             break;
        //         case "2":
        //             parentThis.getDeliveryReserveHistory("D");
        //             break;
        //     }
        // });

        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			$winTop = $nowTop;
			
		});
    },

    setDeliveryReserveHistory: function(type, nowPage, pageSize, loadMoreMode){
        this.pageMeta.prctScnCd = type;
        var parentThis = this;
        console.log("throwing",{
            mbrId: PGV.loginInfo.mbrId,
            prctScnCd: type,
            // nowPage: nowPage || 1,
            // pageSize: pageSize || 10
        });
        return new Promise(function(resolve, reject) {
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.dtdRsvHistInfoList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    prctScnCd: type
                    // nowPage: nowPage || 1,
                    // pageSize: pageSize || 10
                },
                isMock: false
            }).then(function (response){
                var responseList = response.carSvcDtdRsvListRnwResListDto;
                var listContainer = $('.reserve-cont.status .inner-cont');
                var htmlObjectList = [];
                var deliveryTypeDict = {
                    "픽업 + 딜리버리": "왕복 서비스 (픽업+딜리버리)",
                    "픽업": "편도 서비스 (픽업)",
                    "딜리버리": "편도 서비스 (딜리버리)",
                    "방문진단": "편도 서비스 (방문진단)"
                };

                if(responseList && responseList.length > 0){
                    if (loadMoreMode){
                        parentThis.pageMeta.nowPage++;
                    }
                    else{
                        parentThis.pageMeta.nowPage = nowPage;
                        parentThis.pageMeta.stopLoadingMore = false;
                        listContainer.empty();
                    }
                    for(var i = 0; i < responseList.length; i++){
                        var daysInfo = {"0": "일", "1": "월", "2": "화", "3": "수", "4": "목", "5": "금", "6": "토"}
                        var currentNode = responseList[i];
                        var internetPickupNumber = currentNode.inetPkupPrctNo;
                        var deliveryType = deliveryTypeDict[currentNode.scnNm];
                        var reserveDate = currentNode.acqRqYmd  && moment(currentNode.acqRqYmd , "YYYYMMDD") || null;
                        var reserveDateText =  reserveDate.format("YYYY.MM.DD") + " " + daysInfo[reserveDate.day()];
                        var currentVehicleModelName = currentNode.mdlNm;
                        var currentVehicleNo = currentNode.carRgstNo;
                        var reserveState = currentNode.ceqPrctStNm;
                        var reserveCode = "U";
                        if(reserveState === "취소"){
                            reserveCode = "D";
                        }else if(reserveState === "예약") {
                            reserveCode = "R";
                        }

                        var curHtmlObject = (function(internetPickupNumber, deliveryType, reserveDate, currentVehicleModelName, currentVehicleNo, reserveState){
                            var templateString =
                                '<div class="div-item' + (reserveState === "취소" ? " disabled" : "") + '"  data-reserve-state="' + (reserveState === "취소" ? "D" : "U") + '">' +
                                    '<dl>' +
                                        '<dt>' +
                                        '<span className="label-cont">' +
											'<em className="label-status"><b className="c-font-brand-secondary-02">'+ reserveState +'</b></em>' +
										'</span>' +
                                        '<h4 class="text-scale-04"><b>' + deliveryType + '</b></h4>' +
                                            '<button type="button" class="btn-arrow-right">' +
                                                '<i class="ico-arrow-right"><em class="blind">자세히보기</em></i>' +
                                            '</button>' +
                                        '</dt>' +
                                        '<dd>' +
                                            '<div class="div-table">' +
                                                '<div class="name div-table-cell">방문 일정</div>' +
                                                '<div class="value div-table-cell">' + reserveDateText + '</div>' +
                                            '</div>' +
                                            '<div class="div-table">' +
                                                '<div class="name div-table-cell">정비 차량</div>' +
                                                '<div class="value div-table-cell">' + (currentVehicleModelName && currentVehicleModelName || "") + ' ' + currentVehicleNo +'</div>' +
                                            '</div>' +
                                        '</dd>' +
                                    '</dl>' +
                                '</div>';


                            var templateObject = $(templateString);
                            templateObject.off("click").on("click", function(){
                                // var curVehicleNo = $(this).data('vehicle-number');
                                // var curInternetPickupNumber = $(this).data('internetpickup-number');
                                // console.log(curInternetPickupNumber, curVehicleNo);
    
                                // if(curVehicleNo && curVehicleNo){
                                if(currentVehicleNo && internetPickupNumber){
                                    MPage.html({
                                        path: PATH_MANAGER.KIA_RNW_244_2100.path,
                                        param: {
                                            internetPickupNumber: internetPickupNumber,
                                            vehicleNo: currentVehicleNo
                                        }
                                    })
                                }
                            })
                            return templateObject;
                        })(internetPickupNumber, deliveryType, reserveDate, currentVehicleModelName, currentVehicleNo, reserveState);

                        htmlObjectList.push(curHtmlObject);
                    }
                        listContainer.append(htmlObjectList);

                }
                else{
                    if(loadMoreMode){
                        parentThis.pageMeta.stopLoadingMore = true;
                    }
                    else{
                        var emptyMessageString =
                            '<div class="nodata-area" id="mykia-mycar-dtd-history-nodata">' +
                                '<div class="ico-cont">' +
                                    '<i class="ico-nodata-maintenance-k"></i>' +
                                '</div>' +
                                '<p>' +
                                    'K딜리버리 예약 내역이 없습니다.' +
                                '</p>' +
                            '</div>';
                        listContainer.html(emptyMessageString);
                    }
                }
                exWNHideIndicator();
                resolve();
            })
        })
    },

    handleLoadMore: function(){
        if(!this.pageMeta.stopLoadingMore){
            var prctScnCd = this.pageMeta.prctScnCd;
            var nowPage = this.pageMeta.nowPage;
            var pageSize = this.pageMeta.pageSize;
            this.setDeliveryReserveHistory(prctScnCd, nowPage, pageSize, true);
        }
    }
} 

KIA_RNW_244_2000.init(); 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
// var MStatus = { 
//     onReady : function(event){ 
//         console.log("onReady page : "+PGV.currentPage); 
//         KIA_RNW_244_2000.init(); 
//     }, 
//     onHide : function(event){}, 
//     onRestore : function(event){}, 
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
//     // onBack : function(){}, 
//     onDestroy : function(event){}, 
//     onPause : function(event){}, 
//     onResume : function(event){} 
// }; 
