/**

@파일명 : KIA_RNW_244_2100.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.03 
@메뉴명 :  
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/
var CurrPage;
var KIA_RNW_244_2100 = {
    init: function () {
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var internetPickupNumber = MData.param("internetPickupNumber");
        var vehicleNo = MData.param("vehicleNo");
        console.log(internetPickupNumber, vehicleNo);
        this.setDeliveryHistoryDetail(internetPickupNumber, vehicleNo);
    },
    setEventListner: function () {
        // do something.. 
    },
    setDeliveryHistoryDetail: function (internetPickupNumber, vehicleNo) {
        var parentThis = this;
        return new Promise(function (resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.carService.dtdRsvHistInfo,
                isMock: false,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    inetPkupPrctNo: internetPickupNumber
                }
            }).then(function (response) {
                var deliveryTypeDict = {
                    "픽업 + 딜리버리": "왕복 서비스 (픽업+딜리버리)",
                    "픽업": "편도 서비스 (픽업)",
                    "딜리버리": "편도 서비스 (딜리버리)",
                    "방문진단": "편도 서비스 (방문진단)"
                };
                var dateInfo = {"0": "일", "1": "월", "2": "화", "3": "수", "4": "목", "5": "금", "6": "토"}

                var currentState = response.ceqPrctStNm; // ??? 케이스마텍 추헌남 - 아직까지 해당 value로 뭐가 오는지 모름
                var customerName = response.csmrNm;
                var customerPhoneNo = response.hpNo;
                var deliveryType = deliveryTypeDict[response.scnNm];
                var pickupAddress = response.acqPlNm;
                var deliveryAddress = response.dlgPlNm;
                var reserveDate = moment(response.acqRqYmd, "YYYYMMDDHH");
                var reserveDateText =  reserveDate.format("YYYY.MM.DD") + " " + dateInfo[reserveDate.day()];
                var requestNote = response.etcSbc || "없음";
                var isCancelButtonActivated = false;
                console.log("currentState == >> "+currentState);
                var currentStateText = "";
                if(currentState === "예약"){
                    currentStateText = "예약된 K딜리버리 내역이 있습니다.<br>방문 일정을 확인해 주세요.";
                }
                else if(currentState === "이용"){
                    currentStateText = "이용이 완료된 내역입니다.";
                }
                else if(currentState === "취소"){
                    currentStateText = "예약이 취소된 내역입니다.";
                }

                var templateString = 
                    '<div class="div-title">' +
                        '<h3 class="text-scale-03"><b>' + currentStateText + '</b></h3>' +
                    '</div>' +
                    '<div class="div-body">' +
                        '<div class="div-item">' +
                            '<dl>' +
                                '<dt>' +
                                    '<h5 class="text-scale-05">K딜리버리 예약 정보</h5>' +
                                '</dt>' +
                                '<dd>' +
                                    '<div class="div-table">' +
                                        '<div class="name div-table-cell">성함</div>' +
                                        '<div class="value div-table-cell">' +
                                            '<p>' + customerName + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="div-table">' +
                                        '<div class="name div-table-cell">전화번호</div>' +
                                        '<div class="value div-table-cell">' +
                                            '<p>' + customerPhoneNo + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="div-table">' +
                                        '<div class="name div-table-cell">서비스</div>' +
                                        '<div class="value div-table-cell">' +
                                            '<p>' + deliveryType + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="div-table">' +
                                        '<div class="name div-table-cell">픽업 주소</div>' +
                                        '<div class="value div-table-cell">' +
                                            '<p>' + pickupAddress + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="div-table">' +
                                        '<div class="name div-table-cell">딜리버리 주소</div>' +
                                        '<div class="value div-table-cell">' +
                                            '<p>' + deliveryAddress + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="div-table">' +
                                        '<div class="name div-table-cell">픽업일</div>' +
                                        '<div class="value div-table-cell">' +
                                            '<p>' + reserveDateText + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="div-block">' +
                                        '<div class="name">K딜리버리 요청 사항</div>' +
                                        '<div class="value">' +
                                            '<div class="c-bg-gray">' +
                                                '<p>' + requestNote + '</p>' +
                                            '</div>' +
                                        '</div>' +
                                    '</div>' +
                                '</dd>' +
                            '</dl>' +
                        '</div>' +
                    '</div>';

                var cancelButton = 
                    '<div class="btn-block" id="mykia-mycar-maint-dtd-detail-cancel" data-internetpickup-number="' + internetPickupNumber + '" data-vehicle-number="' + vehicleNo + '">' +
                        '<button type="button" class="btn-primary">' +
                            '<em>예약 취소</em>' +
                        '</button>' +
                    '</div>';
                
                if(moment().isBefore(reserveDate) && currentState === "예약"){
                    templateString += cancelButton;
                    isCancelButtonActivated = true;
                }
                
                $('.reserve-cont.detail .inner-cont').html(templateString);

                if(isCancelButtonActivated){
                    $('#mykia-mycar-maint-dtd-detail-cancel').on("click", function(){
                        var curInternetPickupNumber = $(this).data('internetpickup-number');
                        var curVehicleNo = $(this).data('vehicle-number');
                        parentThis.onClickCancelDTDReserve(curInternetPickupNumber);
                    })
                }

                exWNHideIndicator();
                resolve();
            })
        })
    },
    onClickCancelDTDReserve: function (curInternetPickupNumber){        
        M.pop.alert({
            title: 'K딜리버리 예약을 취소하시겠습니까?',
            message: '예약을 취소하실 경우, 정비 예약 신청 내역은 취소되지 않습니다.',
            buttons: ['네', '아니오'],
            callback: function (index) {
                if(index === 0){
                    MNet.httpSendAsync({
                        path: _API.SVR.MYCAR.carService.autoqRsvCancel,
                        sendData: {
                            mbrId: PGV.loginInfo.mbrId,
                            inetPkupPrctNo: curInternetPickupNumber
                        },
                    })
                    .then(function(response){ 
                        if(response.resultCode === "200" && response.cnlYn === "Y"){
                            M.pop.alert({
                                title: 'K딜리버리 예약이 취소되었습니다.',
                                buttons: ["확인"],
                                callback: function(){
                                    MPage.back();
                                }
                            });
                        }
                    })
                }
            }
        });
    }
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */
var MStatus = {
    onReady: function (event) {
        console.log("onReady page : " + PGV.currentPage);
        KIA_RNW_244_2100.init();
    },
    onHide: function (event) { },
    onRestore: function (event) { },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy: function (event) { },
    onPause: function (event) { },
    onResume: function (event) { }
}; 
