/**

@파일명 : KIA_RNW_245_1000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.28
@메뉴명 : 정비 이력 상세 팝업 
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_245_1000 ={
    currentScopeSelectCar: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(),
    tabularNavigator: null,
    init: function(){ 
        CurrPage = this; 
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(this.currentScopeSelectCar, ".div-carInfo");
        this.setMaintenanceHistoryList(1, 100);
        this.setEventListner();

        var parentThis = this;
        COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(this.handleLoadMore);
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        //COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(this);
        
    }, 

    pageMeta: {
        nowPage: 1,
        pageSize: 100,
        stopLoadingMore: false
    },

    setEventListner: function(){
        $('.div-carInfo').off("click").on("click", function(){
            COMMON_FUNCTION.TOOL.UI.showCarSelectionPopup(KIA_RNW_245_1000);
        })
    },

    setPublisherEventListener: function(){
		// ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();
		var $tabsContTop = $('.tabs-cont').offset().top;

		//console.log('$tabsContTop', $tabsContTop)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();

			// 스크롤시 탭영역 고정
			if ($nowTop >= ($tabsContTop - $headerHeight)) {
				$('.wrapper').addClass('is-top-fixed');
				$('.tabs-cont').addClass('top-fixed-area');
			}
			else {
				$('.wrapper').removeClass('is-top-fixed');
				$('.tabs-cont').removeClass('top-fixed-area');
			}		
			
			$winTop = $nowTop;
			
		});
    },

    setMaintenanceHistoryList: function(nowPage, pageSize, loadMoreMode){
        var parentThis = this;
        console.log("throwing: ", {
            mbrId: PGV.loginInfo.mbrId,
            vin: parentThis.currentScopeSelectCar.vin,
            nowPage: nowPage || 1,
            pageSize: pageSize || 100
        })
        return new Promise(function(resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.repair.repairHistList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: parentThis.currentScopeSelectCar.vin,
                    nowPage: nowPage || 1,
                    pageSize: pageSize || 100
                },
                isMock: false
            }).then(function(response){
                console.log(response);
                var maintenanceTypeDict = { // ??? 내차관리_정비.xlsx 에서 21.정비이력 목록 조회에서 RO 구분 의미를 잘 모르겠음
                    "W": "보증 수리",
                    "C": "보증 수리",
                    "3": "일반 수리",
                    "4": "일반 수리",
                    "F": "보증 수리 (프리케어)",
                    "7": "기본 점검"
                }
                if(response.resultCode === "200"){
                    var responseList = response.repairHistListRnwResDto;
                    var htmlObjectList = [];
                    var listContainer  = $("#mykia-mycar-maintenance-history-list");
                    if(responseList && responseList.length > 0){
                        $("#mykia-mycar-maintenance-status-history-page-01 .nodata-area").addClass('none');
                        $("#mykia-mycar-maintenance-history-list-container").removeClass('none');

                        if (loadMoreMode){
                            parentThis.pageMeta.nowPage++;
                        }
                        else{
                            //1페이지 2번 호출을 방지하기 위함.(2022-06-14)
                            (nowPage == 1) && nowPage++;
                            parentThis.pageMeta.nowPage = nowPage;
                            parentThis.pageMeta.stopLoadingMore = false;
                            listContainer.empty();
                        }
                        
                        // !!! - TODOS - 정비 방문자와 로그인 계정이 다른 경우도 생각하여 구현 (프론트인지 백인지 담당이 어딘질 모름)
                        for(var i = 0; i < responseList.length; i++){
                            var currentNode = responseList[i];
                            var maintenanceType = maintenanceTypeDict[currentNode.roNo && currentNode.roNo.split("-")[2] || "3"] || "일반 수리";
                            var stationName = currentNode.asnNm;
                            var driveDistance = currentNode.trvgDist;
                            var maintenanceDescription = currentNode.timpWkNm;
                            var workStartDate = currentNode.wkStrtCdt;
                            var workStartDateMomentObject = moment(workStartDate, "YYYYMMDD");
                            var repairHistDetailInfoList = currentNode.repairHistDetailInfoListRnwResDto;
                            var curHtmlObject = (function(maintenanceType, workStartDateMomentObject, stationName, driveDistance, maintenanceDescription){
                                var templateString =
                                    '<div class="div-item">' + 
                                        '<dl>' +
                                            '<dt class="d-flex justify-content-between">' +
                                                '<h4 class="text-scale-04"><b>' + maintenanceType + '</b></h4>' +
                                                '<em class="date">' + workStartDateMomentObject.format("YYYY.MM.DD") + '</em>' +
                                            '</dt>' +
                                            '<dd>' +
                                                '<div class="div-table">' +
                                                    '<div class="name div-table-cell">정비소명</div>' +
                                                    '<div class="value div-table-cell">' +
                                                        '<p>' + stationName + '</p>' +
                                                    '</div>' +
                                                '</div>' +
                                                '<div class="div-table">' +
                                                    '<div class="name div-table-cell">주행 거리</div>' +
                                                    '<div class="value div-table-cell">' +
                                                        '<p>' + parseInt(driveDistance).toLocaleString() + 'km</p>' +
                                                    '</div>' +
                                                '</div>' +
                                                '<div class="div-table">' +
                                                    '<div class="name div-table-cell">정비 항목</div>' +
                                                    '<div class="value div-table-cell">';


                                                        for(var j = 0; j < repairHistDetailInfoList.length; j++){
                                                            templateString = templateString +
                                                            '<p>' + repairHistDetailInfoList[j].wkNm + '</p>';
                                                        };

                                                    templateString = templateString +
                                                    '</div>' +
                                                '</div>' +
                                            '</dd>' +
                                        '</dl>' +
                                    '</div>';
                                return templateString;
                            })(maintenanceType, workStartDateMomentObject, stationName, driveDistance, maintenanceDescription);
                            
                            htmlObjectList.push(curHtmlObject);
                        }
                    }
                    else{
                        if (loadMoreMode){
                            parentThis.pageMeta.stopLoadingMore = true;
                        }
                        else {
                            $("#mykia-mycar-maintenance-status-history-page-01 .nodata-area").removeClass('none');
                            $("#mykia-mycar-maintenance-history-list-container").addClass('none');
                        }
                    }

                    listContainer.append(htmlObjectList);
                }
                COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(parentThis.handleLoadMore);
                exWNHideIndicator();
                resolve();
            })
        })
    },

    handleLoadMore: function(){
        if(!KIA_RNW_245_1000.pageMeta.stopLoadingMore){
            var nowPage = KIA_RNW_245_1000.pageMeta.nowPage;
            var pageSize = KIA_RNW_245_1000.pageMeta.pageSize;
            KIA_RNW_245_1000.setMaintenanceHistoryList(nowPage, pageSize, true);
        }
    }
}

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_245_1000.init(); 
        COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.init({
            tabWrapperQueryString: "div.inspect-cont",
            tabs: $('.tabs#mykia-mycar-maintenance-history-tabs').children(),
            tabsMeta: [
                {
                    page: {
                        useDOM: $('#mykia-mycar-maintenance-status-history-page-01'),
                        loadScript: false,
                        isMain: true
                    }
                },
                {
                    page: {
                        pathManager: PATH_MANAGER.KIA_RNW_245_2000,
                        loadScript: true,
                        isMain: false
                    }
                }
            ],
            lifeCycles:{
                afterInit: function(){
                },
                afterOpenedTheTab: function(){
                    if (KIA_RNW_245_1000.tabularNavigator && KIA_RNW_245_1000.tabularNavigator.currentTabIndex === 0){
                        //탭 이동 후, 페이지 초기화 하기 위함
                        KIA_RNW_245_1000.pageMeta = {
                            nowPage: 1,
                            pageSize: 100,
                            stopLoadingMore: false
                        }
                        KIA_RNW_245_1000.init();
                    }

                    fnIsFooterNav(); //footer 네비게이션 메뉴영역이 있는경우, 없는경우 제어
                }
            },
            viewerArea:$('#mykia-mycar-maitenance-history-viewer-area'),
            addEventListeners: true,
        }).then(function(resultTabularNavigator){
            KIA_RNW_245_1000.tabularNavigator = resultTabularNavigator;
        });
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        if(KIA_RNW_245_1000){
            switch(KIA_RNW_245_1000.tabularNavigator.currentTabIndex){
                case 0:
                    KIA_RNW_245_1000.init();
                    break;
                case 1:
                    KIA_RNW_245_2000.init();
                    break;
            }
        }
    }, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){
        if(KIA_RNW_245_1000){
            switch(KIA_RNW_245_1000.tabularNavigator.currentTabIndex){
                case 0:
                    KIA_RNW_245_1000.init();
                    break;
                case 1:
                    KIA_RNW_245_2000.init();
                    break;
            }
        }
    } 
}; 
