/**

@파일명 : KIA_RNW_245_1000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.28
@메뉴명 : 정기점검 상세 팝업 
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_245_2000 ={ 
    init: function(){ 
        CurrPage = this;
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(KIA_RNW_245_1000.currentScopeSelectCar, ".div-carInfo");
        this.setMaintenanceRegularCheck();
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        
    }, 
    setEventListner: function(){
        // do something.. 
    },
    setMaintenanceRegularCheck: function(){
        console.log("throwing: ", {
            mbrId: PGV.loginInfo.mbrId,
            vin: KIA_RNW_245_1000.currentScopeSelectCar.vin
        })
        return new Promise(function(resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.repair.periodicRepairList,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: KIA_RNW_245_1000.currentScopeSelectCar.vin
                },
                isMock: false
            }).then(function(response){
                /* 
                   서버 쪽에서 정비 방문자와 현재 계정 일치 여부를 확인해서 해당하는 것만 던져주므로 
                   여기서 확인할 필요 없이 빈 배열이 오면 그냥 동일 계정 제한 안내 메세지만 출력하기
                 */
                console.log(response);
                if(response.resultCode === "200"){
                    var prevPeriodList = response.periodicRepairListRedDto;

                    var nextDDay = response.dDay;
                    nextDDay = nextDDay === "0" ? "day" : nextDDay;

                    // 2023.09.07 서버에서 예정년차 출력되도록 수정
                    // var curYearCount = response.checkYearCnt;
                    // var nextYearCount = curYearCount + 1;
                    var nextYearCount = response.checkYearCnt;
                    var nextPeriodicDate = response.nextReleasedDt;

                    // 2023.09.07 기본점검 대상자인 경우 정기점검 안내 영역 노출
                    if (nextPeriodicDate && nextYearCount < 9) {
                        $("#mykia-mycar-maintenance-history-periodic-check-list-container").removeClass("none");

                        var nextPeriodicDateMomentObject = moment(nextPeriodicDate, "YYYYMMDD");

                        var infoHtmlString =
                            '<em>다음 ' + nextYearCount + '년차 기아 멤버스 기본점검 기간은</em>' +
                            '<h4 class="text-scale-04">' +
                            '<b>' + nextPeriodicDateMomentObject.format("YYYY") +'년 ' + nextPeriodicDateMomentObject.format("MM") + '월까지입니다.</b>' +
                            '<span class="label-cont">' +
                            '<i class="ico-label-primary c-bg-brand-primary"><em>D-' + nextDDay + '</em></i>' +
                            '</span>' +
                            '</h4>'

                        $("#mykia-mycar-maintenance-history-periodic-check-info").html(infoHtmlString);

                        var graphNodeList = $("#mykia-mycar-maintenance-history-periodic-check-info-graph").children();
                        for(var i = 0; i < graphNodeList.length; i++){
                            var curNode = $(graphNodeList[i]);
                            if (i < (parseInt(nextYearCount) - 1)){
                                curNode.removeClass("active");
                                curNode.addClass("disabled");
                            }
                            if (i === (parseInt(nextYearCount) - 1)){
                                curNode.addClass("active");
                                curNode.removeClass("disabled");
                            }
                            if (i > (parseInt(nextYearCount) - 1)){
                                curNode.removeClass("active");
                                curNode.removeClass("disabled");
                            }
                        }
                    } else {
                        $("#mykia-mycar-maintenance-history-periodic-check-list-container").addClass("none");
                    }

                    var htmlObjectList = [];
                    if (prevPeriodList && prevPeriodList.length > 0){
                        $("#mykia-mycar-maintenance-history-periodic-check-list-diff-account").addClass("none");
                        for(var i = 0; i < prevPeriodList.length; i++){
                            var currentNode = prevPeriodList[i];
                            var curPeriodicDateMomentObject = moment(currentNode.periodicDate, "YYYYMMDD");
                            var curPeriodicYearCount = currentNode.periodicYear;
                            var curHtmlObject = (function(index, curPeriodicDateMomentObject, curPeriodicYearCount){
                                var curPeriodicDateText = curPeriodicDateMomentObject.format("YYYY.MM.DD");
                                var templateString =
                                    '<div class="div-item">' +
                                        '<em>' + curPeriodicDateText + '</em>' +
                                        '<h5 class="text-scale-05">' +
                                            curPeriodicYearCount + '년차 차량 기아 멤버스 기본점검' +
                                            '<button type="button" class="btn-arrow-right">' +
                                                '<i class="ico-arrow-right"><em class="blind">자세히보기</em></i>' +
                                            '</button>' +
                                        '</h5>' +
                                    '</div>'
                                var templateObject = $(templateString);
                                templateObject.on("click", function(){
                                    console.log("clicked");
                                    MPage.html({
                                        path: PATH_MANAGER.KIA_RNW_245_2100.path,
                                        param: {
                                            targetYear : curPeriodicYearCount
                                        }
                                    })
                                })
                                
                                return templateObject;
                            })(i, curPeriodicDateMomentObject, curPeriodicYearCount);
    
    
                            htmlObjectList.push(curHtmlObject);
                        }
                    }
                    else{
                        $("#mykia-mycar-maintenance-history-periodic-check-list-diff-account").removeClass("none");
                    }
                    
                    $("#mykia-mycar-maintenance-history-periodic-check-list").html("");
                    $("#mykia-mycar-maintenance-history-periodic-check-list").append(htmlObjectList);
                }
                else{
                    $("#mykia-mycar-maintenance-history-periodic-check-list-diff-account").removeClass("none");
                    $("#mykia-mycar-maintenance-history-periodic-check-list-container").addClass("none");
                }
                exWNHideIndicator();
                resolve();
            })
        })
    }

} 

KIA_RNW_245_2000.init(); 

// /** 
//  * 모피어스 화면 상태 이벤트 함수 
//  */ 
// var MStatus = { 
//     onReady : function(event){ 
//         console.log("onReady page : "+PGV.currentPage); 
//         KIA_RNW_245_2000.init(); 
//     }, 
//     onHide : function(event){}, 
//     onRestore : function(event){
//     }, 
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
//     // onBack : function(){}, 
//     onDestroy : function(event){}, 
//     onPause : function(event){}, 
//     onResume : function(event){
//     } 
// }; 
