/**

@파일명 : KIA_RNW_245_1000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.28
@메뉴명 : 정비 이력 상세 팝업 
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_245_2100 ={ 
    currentScopeSelectedCar: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(),
    targetYear: MData.param('targetYear'),

    init: function(){ 
        this.setMaintenanceRegularCheckDetail();
    }, 
    setEventListner: function(){
        // do something.. 
    },
    setMaintenanceRegularCheckDetail: function(){
        /* 점검 항목 출력 함수 공통화 */
        var listEntryGenerator = function(listGroup, listDataTargetKey){
            var sortedRepairCategoryList = _.sortBy(listGroup, function(element){return parseInt(element.sortSeq)});
            var repairEncouragedCount = 0;
            var normalCount = 0;
            var goodCount = 0;

            var htmlString = _.map(sortedRepairCategoryList, function(element, index){
                var curScopeHtmlString = 
                    '<dl>' +
                        '<dt>' +
                            '<h5 class="text-scale-05"><b>' + element.alpCarDgnInsNm + '</b></h5>' +
                        '</dt>';
                
                curScopeHtmlString += _.map(element[listDataTargetKey], function(eachPartElement){
                    var statusText = "";
                    var statusTextClass = "";
                    if (eachPartElement.good === "Y"){
                        statusText = "양호";
                        statusTextClass = "";
                        goodCount++;
                    };
                    if (eachPartElement.rightRepair === "Y"){
                        statusText = "보통";
                        normalCount++;
                    }
                    if (eachPartElement.laterRepair === "Y"){
                        statusText = "수리권장";
                        statusTextClass = " c-font-brand-point";
                        repairEncouragedCount++;
                    }
                    return '<dd>' +
                                '<div class="name">' + eachPartElement.alpCarDgnSubNm + '</div>' +
                                '<div class="value' + statusTextClass + '">' + statusText + '</div>' +
                            '</dd>'
                }).join("");

                curScopeHtmlString += '</dl>'
                return curScopeHtmlString;
            }).join("");

            return {
                htmlString: htmlString,
                repairEncouragedCount: repairEncouragedCount,
                normalCount: normalCount,
                goodCount: goodCount
            };
        }

        var parentThis = this;

        console.log("throwing : ", {
            mbrId: PGV.loginInfo.mbrId,
            vin: parentThis.currentScopeSelectedCar.vin,
            pYearCnt: parentThis.targetYear
        })

        return new Promise(function(resolve, reject){
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.repair.periodicRepairHistInfo,
                sendData: {
                    mbrId: PGV.loginInfo.mbrId,
                    vin: parentThis.currentScopeSelectedCar.vin,
                    yearCnt: parentThis.targetYear
                },
                isMock: true
            }).then(function(response){
                console.log(response);
                if(response.resultCode === "200"){
                    var result = response;

                    /* 점검 요약 영역 작성하기 */
                    var yearCount = response.yearCnt;
                    var workedDate = moment(result.repairRoHistInfoDto.iCdt, "YYYYMMDD").format("YYYY.MM.DD");
                    var stationName = result.repairRoHistInfoDto.asnNm;
                    var carNumber = parentThis.currentScopeSelectedCar.carRgstNo == null ? "" : getCarRgstNoText(parentThis.currentScopeSelectedCar.carRgstNo);
                    var carModelName = parentThis.currentScopeSelectedCar.mdlNm == null ? "" : parentThis.currentScopeSelectedCar.mdlNm;

                    $("#mykia-mycar-maintenance-detail-year").text(yearCount);
                    $("#mykia-mycar-maintenance-detail-date").text(workedDate);
                    $("#mykia-mycar-maintenance-detail-autoq-station-name").text(stationName);
                    $("#mykia-mycar-maintenance-detail-car-number").text(carNumber);
                    $("#mykia-mycar-maintenance-detail-car-modelname").text(carModelName);


                    /* 검사 소견 작성하기 */
                    var encouragedRepairList = result.encourageRepairListDto;
                    var encouragedRepairCount = result.encourageRepairCnt;
                    if(parseInt(encouragedRepairCount) > 0){
                        $("#mykia-mycar-maintenance-detail-fix-encourage-list-container").removeClass("none");
                        $("#mykia-mycar-maintenance-detail-fix-encourage-count").text("수리권장 " + encouragedRepairCount + "건");
                        if(encouragedRepairList && encouragedRepairList.length > 0){
                            var htmlString = _.map(encouragedRepairList, function(element){
                                return '<li><p class="bullet-dot">' + element.alpCarDgnInsNm + '</p></li>';
                            }).join("");
                            $("#mykia-mycar-maintenance-detail-fix-encourage-list").html(htmlString);
                        }
                    }


                    /* 기본 점검 작성하기 */
                    var baseCheckRepairGroupInfoList = result.repairBaseCheckListGroupDto;
                        
                        /* 타이어 정보 가져온 후 기본 점검 결과 Object 에서 타이어 공기압 세부내용 제거하기 */
                        var tireInfo = _.find(baseCheckRepairGroupInfoList, function(element){return element.alpCarDgnInsNm === "타이어 공기압 세부내용"});
                        tireInfo = tireInfo && tireInfo["repairBaseCheckListDto"]
                        baseCheckRepairGroupInfoList = _.filter(baseCheckRepairGroupInfoList, function(element){return element.alpCarDgnInsNm !== "타이어 공기압 세부내용"});
                    
                    var baseCheckResultObject = listEntryGenerator(baseCheckRepairGroupInfoList, "repairBaseCheckListDto");
                    var baseCheckHtmlString = baseCheckResultObject.htmlString;
                    var baseCheckRepairEncouragedCount = baseCheckResultObject.repairEncouragedCount;
                    var baseCheckNormalCount = baseCheckResultObject.normalCount;
                    var baseCheckGoodCount = baseCheckResultObject.goodCount;

                    $("#mykia-mycar-maintenance-basic-inspect-list").prepend($(baseCheckHtmlString));
                    $("#mykia-mycar-maintenance-basic-inspect-status-repair-encouraged-count")
                    .text(baseCheckRepairEncouragedCount || "0");
                    $("#mykia-mycar-maintenance-basic-inspect-status-repair-normal-count")
                    .text(baseCheckNormalCount || "0");
                    $("#mykia-mycar-maintenance-basic-inspect-status-repair-good-count")
                    .text(baseCheckGoodCount || "0");


                    /* 타이어 항목 작성하기 */
                    var tirePressureValues = {
                        "top-left" : 0,
                        "top-right" : 0,
                        "bottom-left" : 0,
                        "bottom-right" : 0
                    }

                    if(tireInfo){
                        for(var i = 0; i < tireInfo.length; i++){
                            var curNode = tireInfo[i];
                            var curTirePsi = curNode.remSbc;
                            switch(curNode.alpCarDgnSubNm){
                                case "앞, 좌":
                                    tirePressureValues["top-left"] = curTirePsi;
                                    break;
                                case "앞, 우":
                                    tirePressureValues["top-right"] = curTirePsi;
                                    break;
                                case "뒤, 좌":
                                    tirePressureValues["bottom-left"] = curTirePsi;
                                    break;
                                case "뒤, 우":
                                    tirePressureValues["bottom-right"] = curTirePsi;
                                    break;
                            }
                        }
                    }

                    _.map(Object.keys(tirePressureValues), function(element){
                        $("#mykia-mycar-maintenance-detail-car-tire-psi-" + element).text(tirePressureValues[element] + " psi");
                    })


                    /* 중간 점검 작성하기 */
                    var midCheckResultObject = null;
                    var midCheckHtmlString = "";
                    var midCheckRepairGroupInfoList = null;

                        /* 4~6년차일 경우 (일반 중간 점검) */
                        if(result.repairFourSixCheckListGroupRnwDto){ // && result.repairFourSixCheckListRnwDto
                            midCheckRepairGroupInfoList = result.repairFourSixCheckListGroupRnwDto;
                            midCheckResultObject = listEntryGenerator(midCheckRepairGroupInfoList, "repairFourSixCheckListRnwDto");
                        }

                        /* 1~3년차, 7~8년차일 경우 (중점 점검) */
                        else{
                            midCheckRepairGroupInfoList = result.repairEmphasisCheckListGroupDto;
                            midCheckResultObject = listEntryGenerator(midCheckRepairGroupInfoList, "repairEmphasisCheckListDto");
                        }
                    
                    midCheckHtmlString = midCheckResultObject.htmlString;
                    var midCheckRepairEncouragedCount = midCheckResultObject.repairEncouragedCount;
                    var midCheckNormalCount = midCheckResultObject.normalCount;
                    var midCheckGoodCount = midCheckResultObject.goodCount;
                    
                    $("#mykia-mycar-maintenance-further-inspect-list").prepend($(midCheckHtmlString));
                    $("#mykia-mycar-maintenance-further-inspect-status-repair-encouraged-count")
                    .text(midCheckRepairEncouragedCount || "0");
                    $("#mykia-mycar-maintenance-further-inspect-status-repair-normal-count")
                    .text(midCheckNormalCount || "0");
                    $("#mykia-mycar-maintenance-further-inspect-status-repair-good-count")
                    .text(midCheckGoodCount || "0");
                    
                    exWNHideIndicator();
                    resolve();
                }
            })
        })
    }

} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_245_2100.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
    }, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){
    } 
}; 
