/**

@파일명 : KIA_RNW_246_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.28
@메뉴명 : 내 차 관리 > 정비 탭 > 정비 편의 서비스
@DESC : 전체메뉴노출	[X]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_246_0000 ={
    // !!! 케이스마텍 추헌남 - 스크롤 페이지 관련 메타
    pageMeta: {
        currentPageNo: 1,
        pageSize: 10,
        stopLoadingMore: false,
        currentServiceState: "ING"
    },

    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");
        // 진행 중 - ING, 종료됨 - EMD
        this.setServiceList("ING");
        this.setEventListner();
        this.setPublisherEventListener();
    }, 
    setEventListner: function(){
        var parentThis = this;
        $('.btn-filter').on("click", function(){
            var serviceState = $(this).parent().data('slide-index').toString();
            switch(serviceState){
                case "0":
                    parentThis.setServiceList("ING");
                    break;
                case "1":
                    parentThis.setServiceList("END");
                    break;
            }
        });
        COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(function(){
            parentThis.setServiceList(parentThis.pageMeta.currentServiceState, true);
        })
    },
    setPublisherEventListener: function(){
        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();			
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)
            _sliderFilterList.slideTo(getSlideIdx, 300, false);	
            $('.slider-filter-list').find('.active').removeClass('active');
            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');				
        });

        // ------------------------------
		// 	Scroll
		// ------------------------------
		var nScrollPos = [];
		var nScrollPosNum = 0;
		var $winTop = $(window).scrollTop();
		var $headerHeight = $('.header').outerHeight();

		//console.log('$headerHeight', $headerHeight)

		$(window).scroll(function(e) {
			var $nowTop = $(this).scrollTop();
		
			// 탭버튼영역 스크롤시 상단 고정
			if ($nowTop > $headerHeight) {
				$('body').addClass('js-mycar-tabs-fixed');
			}
			else {
				$('body').removeClass('js-mycar-tabs-fixed');
			}
			
			$winTop = $nowTop;
			
		});

    },
    setServiceList:function(serviceState, loadMoreMode) {
        this.pageMeta.currentServiceState = serviceState;
        var parentThis = this;
        if(!loadMoreMode) {
            this.pageMeta.stopLoadingMore = false;
            this.pageMeta.currentPageNo = 1;
        }
        if(!this.pageMeta.stopLoadingMore){
            // 진행 중 - ING, 종료됨 - EMD
            MNet.httpSendAsync({
                path: _API.SVR.MYCAR.event.carCareServiceList,
                sendData: COMMON_FUNCTION.TOOL.DATA.getLoginDependencySendData({
                    stsCd: serviceState,
                    currentPageNo: parentThis.pageMeta.currentPageNo || 1,
                    pageSize: parentThis.pageMeta.pageSize || 10
                }),
                isMock: false
            })
            .then(function(response){
                var htmlString = "";
                if(response.resultCode === "200"){
                    var eventList = response.carCareServiceListRnwResDto;
                    if (!loadMoreMode) $("#mykia-mycar-maintenance-service-list").empty();
                    if (eventList.length > 0){
                        $("#mykia-mycar-maintenance-service-list-no-data").addClass("none");
                        $("#mykia-mycar-maintenance-service-list-container").removeClass("none");
                        parentThis.pageMeta.currentPageNo++;
                        for (var i = 0; i < eventList.length; i++){
                            var curNode = eventList[i];
                            var serviceNumber = curNode.svcNo;
                            var serviceStartDate = curNode.svcStartDtm;
                            var serviceEndDate = curNode.svcEndDtm;
                            var serviceName = curNode.svcNm;
                            var linkUrl = curNode.lingUrl;
                            var originalFileName = curNode.orgnFileNm;
                            var savedFilePath = curNode.savedFilePath;
                            var savedFileNm = curNode.savedFileNm;
                            
                            htmlString += 
                                '<div class="div-item" data-external-webview-link="' + linkUrl + '">' +
                                    '<div class="img-cont">' +
                                        '<img src="' + (CONSTANT.IMG_URL_PREFIX + savedFilePath + savedFileNm) + '" alt="">' +
                                    '</div>' +
                                    '<h6 class="text-scale-05"><b>' + serviceName + '</b></h6>' +
                                    '<em class="date">' + serviceStartDate + ' ~ ' + serviceEndDate + '</em>' +
                                '</div>';
                        }
                        var previousHtml = $("#mykia-mycar-maintenance-service-list").html();
                        $("#mykia-mycar-maintenance-service-list").html(previousHtml + htmlString);
                        $('[data-external-webview-link]').off("click").on("click", function(){
                            var targetLink = $(this).data('external-webview-link');
                            if(targetLink){
                                parentThis.onClickServiceEntry(targetLink);
                            }
                        })
                    }
                    else {
                        if(parentThis.pageMeta.currentPageNo === 1){
                            $("#mykia-mycar-maintenance-service-list-no-data").removeClass("none");
                            $("#mykia-mycar-maintenance-service-list-container").addClass("none");
                        } 
                        if(loadMoreMode) parentThis.pageMeta.stopLoadingMore = true;
                    }
                }
                else{
                    if(parentThis.pageMeta.currentPageNo === 1){
                        $("#mykia-mycar-maintenance-service-list-no-data").removeClass("none");
                        $("#mykia-mycar-maintenance-service-list-container").addClass("none");
                    } 
                    if(loadMoreMode) parentThis.pageMeta.stopLoadingMore = true;
                }
                
                exWNHideIndicator();
            })
        }

    },
    onClickServiceEntry: function(url){
        MPage.activity({
            className : "WebviewActivity",
            param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, url)
        });
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_246_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
