/**

@파일명 : KIA_RNW_311_0000.js 
@작성자 : 박민기
@생성일 : 2022.01.26 
@메뉴명 : Kia 차량 모델 (전체, EV, 승용, RV, 상용/택시/버스)
@DESC : 전체메뉴노출	[O]
*/ 
var CurrPage; 
var KIA_RNW_311_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("page : " + PGV.currentPage + "initiolizing START");
        /**
         * 초기화
         */
        var backFlag = MData.param("backFlag");
        if(backFlag != "Y"){
            garbageCollector();
        }
        // 차량 목록 조회
        var cat = isEmpty(MData.param("category"))?"":MData.param("category");
        CurrPage.selectCarList(cat);

        /**
         * 화면 이벤트
         */
        CurrPage.setEventListner();
    }, 
    setEventListner: function(){
        // 상단 차량 카테고리 클릭 시
        $(document).on("click", "#carTab li button", function(){
            $("#carTab li").removeClass("on");
            $(this).parent().addClass("on");

            CurrPage.changeDisplay();
        });

        // 차량 클릭 시(웹뷰로 해당 페이지 연동)
        $(document).on("click", ".btn-caritem", function(){
            var _url = $(this).attr("data-model-link");
            screenViewGa(PATH_MANAGER.KIA_RNW_311_1000.desc);
            MPage.activity({
                className : "WebviewActivity",
                param : {
                    method : CONSTANT.NET_MTHD.GET,
                    requestURL : _url,
                }
            });
        });
    },
    selectCarList:function(cat){
        MNet.httpSendAsIs({
            path : inf.carmgmt.carAllModelV2.url, // 차량목록 조회
            sendData : {
                category : cat,      // [KIAVIK-618] category ALL(전체), EV(EV), CAR(승용), RV(RV), ETC(상용/택시/버스)
                evYn : "Y"      // category "" 이거나 ALL 일때만 evYn 적용, Y면 EV 노출, N이면 EV 노출안함
            },
            callback : CurrPage.makeCarList
        });
    },
    makeCarList:function(receivedData){
        exWNHideIndicator();

        COMMON_FUNCTION.TOOL.DEBUG.showTalk(JSON.stringify(receivedData));
        var code = receivedData.resultCode;
        var msg = receivedData.resultMsg;

        if(code == "200"){
            // 카테고리 설정
            var categoryList = receivedData.categoryListResDto;
            var cateBuff = '';
            for(var i=0; i<categoryList.length; i++){
                if(categoryList[i].category == "ALL_V2"){
                    cateBuff += '<li class="on"><button type="button" data-car-type="' + categoryList[i].category + '">' + categoryList[i].ccdNm + '</button></li>';
                }else{
                    cateBuff += '<li><button type="button" data-car-type="' + categoryList[i].category + '">' + categoryList[i].ccdNm + '</button></li>';
                }
            }
            $("#carTab").html(cateBuff);


            // 차량 리스트 설정
            var nowOS = getOSType().toLowerCase() == "android" ? "AOS" : "IOS";
            var carList = receivedData.carByCategoryResDto;
            var strBuff = '';
            for(var i=0; i<carList.length; i++){
                strBuff += '<ul id="list_' + carList[i].categoryCd + '" class="none">';
                var carDetailList = sortJsonArrayList(carList[i].carInfoResDtoV2, "dispNo");
                for(var j=0; j<carDetailList.length; j++){
                    var mdlCd = typeof carDetailList[j].mdlCd == "string" ? carDetailList[j].mdlCd.trim() : carDetailList[j].mdlCd;	// 모델 코드
                    var mdlYearCd = typeof carDetailList[j].mdlYearCd == "string" ? carDetailList[j].mdlYearCd.trim() : carDetailList[j].mdlYearCd;		// 모델 연식 코드
                    var linkUrl = carDetailList[j].linkUrl;	// 링크 URL
                    var mdlCd = carDetailList[j].mdlCd;	// 차종 코드
                    var mdlNm = carDetailList[j].mdlNm;	// 차종 명
                    var sptdAppOsCcd = carDetailList[j].sptdAppOsCcd;	// 지원 OS (ALL : 전체, AOS : 안드로이드만, IOS : iOS만)
                    var filePath = CONSTANT.IMG_URL_PREFIX + carDetailList[j].savedFilePath + carDetailList[j].savedFileNm;	// 파일 경로
                    var viewFlag = true;
                    if(sptdAppOsCcd != "ALL" && sptdAppOsCcd != nowOS){
                        viewFlag = false;
                    }
                    strBuff += '<li>';
                    strBuff += '		<button type="button" class="btn-caritem" data-model-link="' + linkUrl + '" data-model-code="' + mdlCd + '"><img src="' + filePath + '" alt="" /><span>' + mdlNm + '</span></button>';
//                    if(!isEmpty(mdlCd) && viewFlag == true){
//                        strBuff += '		<span class="txt-carmark">AR/VR</span>';
//                    }
                    strBuff += '</li>';
                }
                strBuff += "</ul>";
            }
            $("#carWrap").html(strBuff);
            CurrPage.changeDisplay();
        } else {
            MPopup.alert(msg);
        }
    },
    changeDisplay:function(){
        var selectType = $("#carTab li.on > button").attr("data-car-type");
        $("#carWrap > ul").addClass("none");
        $("#list_" + selectType).removeClass("none");
    }
} 

// KIA_RNW_311_0000.init(); 
// /** 
//  * 모피어스 화면 상태 이벤트 함수 
//  */ 
var MStatus = { 
    onReady : function(event){ 
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("onReady page : "+PGV.currentPage); 
        KIA_RNW_311_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
