/**

@파일명 : KIA_RNW_321_0000.js 
@작성자 : 박민기
@생성일 : 2022.01.26 
@메뉴명 : kia EV 모델 
@DESC : 전체메뉴노출	[O]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_321_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("page : " + PGV.currentPage + "initiolizing START"); 
        
        var backFlag = MData.param("backFlag");
        if(backFlag != "Y"){
            garbageCollector();
        }

        CurrPage.selectCarList();

        CurrPage.setEventListner();
    }, 

    setEventListner: function(){
        // do something.. 
         // 차량 클릭 시(웹뷰로 해당 페이지 연동)
         $(document).on("click", ".btn-caritem", function(){
            var _url = $(this).attr("data-model-link");
            MPage.activity({
                className : "WebviewActivity",
                param : {
                    method : CONSTANT.NET_MTHD.GET,
                    requestURL : _url,
                }
            });
        });
    },

    /**
     * 차량 목록 조회
     */
    selectCarList:function(){
        MNet.httpSendAsIs({
            path : inf.carmgmt.carAllModelV2.url, // 차량목록 조회
            sendData : {
                category : "EV",
                evYn : "Y"      // EV는 YN 아무거나 넣어도 EV 값 나옴
            },
            callback : CurrPage.makeCarList
        });
    },

    makeCarList: function(receivedData){
        exWNHideIndicator();
        var code = receivedData.resultCode;
        var msg = receivedData.resultMsg;
        
        if(code == "200"){
            // 차량 리스트 설정
            var nowOS = getOSType().toLowerCase() == "android" ? "AOS" : "IOS";
            var carList = receivedData.carByCategoryResDto;
            var strBuff = '';
            for(var i=0; i<carList.length; i++){
                strBuff += '<ul>';
                var carDetailList = sortJsonArrayList(carList[i].carInfoResDtoV2, "dispNo");
                for(var j=0; j<carDetailList.length; j++){
                    var mdlCd = typeof carDetailList[j].mdlCd == "string" ? carDetailList[j].mdlCd.trim() : carDetailList[j].mdlCd;	// 모델 코드
                    var mdlYearCd = typeof carDetailList[j].mdlYearCd == "string" ? carDetailList[j].mdlYearCd.trim() : carDetailList[j].mdlYearCd;		// 모델 연식 코드
                    var linkUrl = carDetailList[j].linkUrl;	// 링크 URL
                    var mdlCd = carDetailList[j].mdlCd;	// 차종 코드
                    var mdlNm = carDetailList[j].mdlNm;	// 차종 명
                    var sptdAppOsCcd = carDetailList[j].sptdAppOsCcd;	// 지원 OS (ALL : 전체, AOS : 안드로이드만, IOS : iOS만)
                    var filePath = CONSTANT.IMG_URL_PREFIX + carDetailList[j].savedFilePath + carDetailList[j].savedFileNm;	// 파일 경로
                    var viewFlag = true;
                    if(sptdAppOsCcd != "ALL" && sptdAppOsCcd != nowOS){
                        viewFlag = false;
                    }
                    strBuff += '<li>';
                    strBuff += '		<button type="button" class="btn-caritem" data-model-link="' + linkUrl + '" data-model-code="' + mdlCd + '"><img src="' + filePath + '" alt="" /><span>' + mdlNm + '</span></button>';
//                    if(!isEmpty(mdlCd) && viewFlag == true){
//                        strBuff += '		<span class="txt-carmark">AR/VR</span>';
//                    }
                    strBuff += '</li>';
                }
                strBuff += "</ul>";
            }
            $("#carWrap").html(strBuff);
        } else {
            MPopup.alert(msg);
        }
    }

} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("onReady page : "+PGV.currentPage); 
        KIA_RNW_321_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
