/**
 * @파일명 : KIA_MOB_320_1000.js / 리뉴얼 - KIA_RNW_411_0000.js
 * @작성자 : 이현석 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2018. 7. 30. 오전 11:37:05 / 리뉴얼 - 2022.04.01
 * @메뉴명 : 이벤트-진행중
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	// 전체 메뉴 스택정리
	var backFlag = MData.param("backFlag");
	var evtType = MData.param("evtType");
	if(backFlag != "Y"){
		garbageCollector();
	}
	PGV.eventFlag = 'ingEventBtn';
	PGV.eventText = '진행중인 이벤트가 없습니다.';
	PGV.evtCd = "JOIN";         //ALL':이벤트전체, 'JOIN':참여, 'PARTNER':제휴

	if (evtType != null && evtType != undefined && evtType != "undefined" && evtType != "") {
	    console.log("evtType : "+evtType);
	    PGV.evtCd = evtType;
	    if (evtType == "PARTNER") {
	        // 탭 변경
	        $('[data-tab-type="ty2"]').parent().addClass("on");
	        $('[data-tab-type="ty1"]').parent().removeClass("on");

	        // 컨텐츠 변경
	        $('[data-content-type="ty2"]').removeClass('none');
            $('[data-content-type="ty1"]').addClass('none');
	    }
	}

	nowServerTime(); // 서버 시간 20190612
	eventListInit();
	// screenViewGa(gaSendUrl["KIA_MOB_320_1000"].pageNm);//2020 공통으로 변경
	setEvent();
	/**
	 * 화면 이벤트
	 */
};

var eventListInit = function(){
	PGV.currentPageNo = 1;			// 현재 페이지 번호
	PGV.pageSize = 10;				// 받은 페이지의 총 개수
	PGV.totCnt = null;
	PGV.pageStart = null;
	PGV.pageEnd = null;

    // 리스트 초기화
    $('.evtlist').empty();
    $('.end-evtlist').empty();

    $("[data-tab-type]").each(function(e){
        var $li = $(this).parent();

        if($li.hasClass('on')){
            PGV.tabType = $(this).data("tabType");
//            PGV.tabType == 'ty1' ? selectEventList() : selectEndEventList();
            selectEventList();
            return;
        }
    });
};


var setScrollEvent = function(){
    //스크롤 반응 HEADER
    var lastScrollTop = 0,
    delta = 15;
    $('.scroll-loading').scroll(function (event) {
        var st = $(this).scrollTop();
        //console.log("--" + st);

        lastScrollTop = st;
    });
};

var setEvent = function() {
    // 진행종료탭 선택
    $(document).on("click", "[data-tab-type]", function(){
        if($(this).parent().hasClass('on')) return;
        // 탭 클래스 변경
        $(".function-tab li button").parent().removeClass("on");
        PGV.tabType = $(this).data('tabType');
        $('[data-tab-type="' + PGV.tabType + '"]').parent().addClass("on");

        //ty1 : ing, ty2 : end
    	if(PGV.tabType == "ty1"){
    	    $('[data-content-type="ty2"]').addClass('none');
    	    $('[data-content-type="ty1"]').removeClass('none');

            // 210618 정재익 수정
            // 동일 UI이므로 해당 화면에서 모두 처리
//            screenViewGa(gaSendUrl["KIA_MOB_320_1000"].pageNm); //진행

            PGV.evtCd = "JOIN";
    	}else{
    	    $('[data-content-type="ty1"]').addClass('none');
            $('[data-content-type="ty2"]').removeClass('none');

//            screenViewGa(gaSendUrl["KIA_MOB_320_1100"].pageNm); //종료

            PGV.evtCd = "PARTNER";
    	}

        eventListInit();
    });

    // 진행탭 - 참여제휴 분류
	$(document).on('click','input:radio[name="rdoEvtType"]', function(){
	    PGV.evtCd = $(this).attr('id');
	    eventListInit();
	});

	// 리스트 이벤트 클릭
	$(document).on("click", ".evtlist > li button, .end-evtlist > li button", function(){
		var that = $(this);
		var _evtNo = that.parent().data('evtNo');
        if(_evtNo == "web"){ // k7하드코딩
			var url = that.parent().attr("data-web-url");
			if(url == 'https://www.kseries-10th-anniversary.com/'){
				MApps.browser(url);
			}else if(url == PATH_MANAGER.KIA_RNW_440_0000.name){ 
				MPage.html({
					url : PATH_MANAGER.KIA_RNW_440_0000.path
				});
			}else if(url.indexOf("https://givecard.kakaomobility.com") > -1){     // 20211216 이벤트 임의 수정 (음주운전예방 browser실행)
                MApps.browser(url);
            }else{
				var carNlifeChek = that.parent().attr("data-web-url").split("@");
				if(!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "carnLife"){     // 카앤라이프일경우 이벤트 등록 형식 carnLife@/a/M070100@621
					MPage.html({
						url : PATH_MANAGER.KIA_RNW_810_0000.path,
						param : {
							rUrl : CONSTANT.AUTON_URL_PREFIX + carNlifeChek[1],
							evtCd : isEmpty(carNlifeChek[2]) ? "" : carNlifeChek[2],
							evtYN : "N"
						}
					});
				}else if(!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "notiNo"){
                    MPage.html({
                        url : PATH_MANAGER.KIA_RNW_620_0000.path,
                        param : {
                            notiNo : carNlifeChek[1]
                        }
                    });
                }else if(!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "surveyNo"){
                    // 20200617 이벤트목록 > 설문조사로 바로 넘어가는 영역 추가
                    if(!isNull(PGV.loginInfo)){ // 로그인시
	                    	MNet.httpSendAsIs({
	                    		path : inf.survey.selectSurveyCheck.url,
	                    		sendData : {
	                    			mbrId : PGV.loginInfo.mbrId,
	                    			srvyNo : carNlifeChek[1]
	                    		},
	                    		callback : function(receivedData){
	                    			exWNHideIndicator();
	                    			var code = receivedData.resultCode;
	                    			var msg = receivedData.resultMsg;
	                    			
	                    			if(code == "200"){
	                    				PGV.currentDate = moment().format("YYYYMMDD");
	                    				if(PGV.currentDate > parseDate(receivedData.srvyEndDtm)){
	                    					MPopup.alert("설문이 종료되어 참여할 수 없습니다.");
	                    				}else if(receivedData.ansCnt > 0){
	                    					MPopup.alert("설문은 한 번만 참여 가능합니다.");
	                    				}else{	                        					
	                    					MPage.html({
	                    						url : PATH_MANAGER.KIA_RNW_421_0000.path,
	                    						param : {
	                    							srvyNo : carNlifeChek[1],
	                    							evtType : "banner",
	                    							evtNo : _evtNo
	                    						}
	                    					});
	                    				}
	                    			}else{
	                    				MPopup.alert(msg);
	                    			}
	                    		}
	                    	});
                    }else{ //미 로그인시
                        var msg = "로그인 후 이용이 가능합니다.\n로그인 하시겠어요?"
                        var _returnUrl = PATH_MANAGER.KIA_RNW_120_0000.path;
                        var _params = {};
                        MPopup.confirm({
                            message : msg,
                            buttons : ["취소", "로그인"],
                            callback : function(idx){
                                if(idx == 1){ // 로그인 눌렀을때
                                    //ccsp로그인
                                    if(CONSTANT.IS_CCSP){
                                        var param = {
                                            returnLink : _returnUrl,
                                            returnParams : _params
                                        }
                                        ccspLogin(param);
                                    }else{
                                        MPage.html({
                                            /* !!! 케이스마텍 추헌남 - 로그인 AS-IS 페이지 CCSP 때문에 어차피 접근이 안되는거라 일단 남겨뒀습니다. */
                                            url : "../000/KIA_MOB_000_1300.html",
                                            param : {
                                                returnLink : _returnUrl,
                                                returnParams : _params
                                            }
                                        });
                                    }
                                    return false;
                                }else{
                                    return false;
                                }
                            }

                        });
                    }
				}else{
					MPage.activity({
						className : "WebviewActivity",
						param : {
							method : CONSTANT.NET_MTHD.GET,
							requestURL : url
						}
					});
				}
			}
			return false;
		}else{
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_411_1000.path,
                param : {
                    evtNo : _evtNo,		// 이벤트 번호
                    eventType : !that.hasClass("disabled") ? "ing" : "end",	// 이벤트 타입 (진행 : ing, 종료 : end)
					grade : "Aplus"
                }
            });
		}
	});

	// 필터 클릭 이벤트 - 참여 이벤트
    $(document).on('click','input:radio[name="join"]', function(){
        PGV.evtCd = $(this).attr('data-type');
        PGV.jState = $(this).attr('data-id');
        eventListInit();
    });

    // 필터 클릭 이벤트 - 제휴 이벤트
    $(document).on('click','input:radio[name="partner"]', function(){
        PGV.evtCd = $(this).attr('data-type');
        PGV.pState = $(this).attr('data-id');
        eventListInit();
    });

    //setScrollEvent();

};

/**
 * 진행중 이벤트 목록 조회
 */
var selectEventList = function(){
    if (PGV.evtCd == null || PGV.evtCd == undefined)
        PGV.evtCd = "JOIN";

    // JOIN 경우 jState, PARTNER인 경우 pState
    PGV.state = null;
    if  (PGV.evtCd == "JOIN")
        PGV.state = PGV.jState;
    else
        PGV.state = PGV.pState;

    if (PGV.state == null || PGV.state == undefined)
        PGV.state = "ALL";
	MNet.httpSendAsIs({
		path : inf.event.eventAllList.url,
		sendData : {
            currentPageNo : String(PGV.currentPageNo),
            pageSize : String(PGV.pageSize),
            evtCd : PGV.evtCd,
            state : PGV.state   // 전체 : ALL, 진행 : Y, 종료 : N
        },
		callback : eventListCallBack
	});
};

var eventListCallBack = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == '200'){
		PGV.totCnt  = receivedData.totCnt;
		PGV.pageStart = receivedData.pageStart;
		PGV.pageEnd = receivedData.pageEnd;

		if(receivedData.eventAllProInfoListResDto.length > 0){
			appendIngList(receivedData.eventAllProInfoListResDto);
		}else{ // 데이터 없을경우
            $("#noDataDiv").removeClass("none");
            $("#noDataDiv2").removeClass("none");
            $(".evtlist").addClass("none");

            if (PGV.state == "N")
                $(".txtgr6").text("종료된 이벤트가 없습니다.");
            else
                $(".txtgr6").text("진행 중인 이벤트가 없습니다.");
		}
	}else {
		MPopup.alert(msg);
	}
};

var appendIngList = function(list){
	var eventIngList = "";

	if(list.length > 0){
		for(var i=0; i< list.length; i++){
			var obj = list[i];
			var startTime = obj.evtStartDtm.split(" ")[0];
			var endTime = obj.evtEndDtm.split(" ")[0];
			var imgPath = CONSTANT.IMG_URL_PREFIX + obj.savedFilePath + obj.savedFileNm;
			var dday = dDayDiff(moment().format("YYYY-MM-DD"), moment(obj.evtEndDtm).format("YYYY-MM-DD"));
			if(obj.irsLinkYn == "Y"){ // 배너만으로 이동 이벤트 추가 20190729
				eventIngList += '<li data-evt-no="web" data-web-url= "'+obj.lingUrl+'">';
			}else{
				eventIngList +=	'<li data-evt-no="'+obj.evtNo+'">';	
			}
			eventIngList +=	'   <button type="button" class="event-wrap ' + (obj.state == "Y" ? '' : 'disabled') + '">';
			eventIngList += '       <div class="top-box">';
			if(!isEmpty(obj.savedFilePath)){
				eventIngList +=	'           <img src="'+imgPath+'" class="event-img" alt="'+obj.evtNm+'" />';
			}
			eventIngList += '           <span class="event-badge ' + (obj.evtClsCcd == 'JOIN' ? '' : 'partner') + '"></span>';
			eventIngList += '       </div>';
            eventIngList += '       <div class="btm-box">';
            eventIngList += '           <p class="main-txt">' + obj.evtNm + '</p>';
            eventIngList +=	'           <p class="sub-tit4"><em class="dday">' + (dday < 0 ? '(종료)' : ('D-'+(dday == 0 ? 'day' : dday))) + '</em>'+startTime+' ~ '+endTime+'</p>';
            eventIngList += '       </div>';
			eventIngList +=	'   </button>';
			eventIngList +=	'</li>';	
		}
	}
	
	$(".evtlist").append(eventIngList);
	
	$("#noDataDiv").addClass("none");
	$("#noDataDiv2").addClass("none");
    $(".evtlist").removeClass("none");

    if (PGV.state == "N")
        $(".txtgr6").text("종료된 이벤트가 없습니다.");
    else
        $(".txtgr6").text("진행 중인 이벤트가 없습니다.");
}
/**
 * 진행중 이벤트 목록 조회 종료 
 */

/**
 * 종료 이벤트 목록 조회
 */
var selectEndEventList = function(){
	MNet.httpSendAsIs({
		path : inf.event.endEventListV2.url,
        sendData : {
            currentPageNo : PGV.currentPageNo,
            pageSize : String(PGV.pageSize),
        },
		callback : selectEndEventListCallBack
	});
};

var selectEndEventListCallBack = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == '200'){
        PGV.totCnt  = receivedData.totCnt;
        PGV.pageStart = receivedData.pageStart;
        PGV.pageEnd = receivedData.pageEnd;

        if(receivedData.eventEndInfoListResDto.length > 0){
            appendFinishList(receivedData.eventEndInfoListResDto);
        }else{
            $("#noDataEndDiv").removeClass("none");
            $(".evtdone").addClass("none");
        }


	}else {
		MPopup.alert(msg);
	}
};

var appendFinishList = function(list){
	var strBuff = "";

	for(var i=0; i<list.length; i++){
        if(list[i].irsLinkYn == "Y"){ // 배너만으로 이동 이벤트 추가 20190729
            strBuff += '<li data-evt-no="web" data-web-url= "'+list[i].lingUrl+'">';
        }else{
            strBuff += '<li data-evt-no="' + list[i].evtNo + '">';
        }
        strBuff += '	<button type="button">';
        strBuff += '	    <p class="sub-tit8">' + list[i].evtNm + '</p>';
        strBuff += '	    <p class="sub-tit5">' + DateUtil.getYMD(list[i].evtStartDtm) + ' ~ ' +  DateUtil.getYMD(list[i].evtEndDtm) + '</p>';
        strBuff += '	</button>';
        strBuff += '</li>';
    }

	$(".end-evtlist").append(strBuff);

	$("#noDataEndDiv").addClass("none");
    $(".evtdone").removeClass("none");
};

/**
 * 종료이벤트 목록 조회 종료 
 */


/**
 * 하단 스크롤시 더보기 이벤트
 */
var selectMoreListData = function(){
	var totalPageCnt = Math.ceil(PGV.totCnt/PGV.pageSize);	// 전체 페이지 수
	
	if(totalPageCnt > PGV.currentPageNo){
		PGV.currentPageNo = PGV.pageEnd/PGV.pageSize + 1;
        $("[data-tab-type]").each(function(e){
            var $li = $(this).parent();
            var type = '';

            if($li.hasClass('on')){
                // 정비이력 리스트 초기화
                //$('input[name="autoqWrap"]').empty();

                var type = $(this).data("tabType");
//                type == 'ty1' ? selectEventList() : selectEndEventList();
                selectEventList();
                return;
            }
        });
	}
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){
		nowServerTime(); // 서버 시간 20190612
	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};