/**
 * @파일명 : KIA_MOB_340_1012.js / 리뉴얼 - KIA_RNW_411_1100.js
 * @작성자 : 최정동 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2018. 10. 10. 오후 4:38:01 / 리뉴얼 - 20220513
 * @메뉴명 : My Kia 기대평 이벤트 응모하기
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */	
	PGV.baseEvtNo = MData.param("baseEvtNo");
	MData.removeParam("baseEvtNo");
	/**
	 * 화면 이벤트
	 */
	setEvent();
};

var setEvent = function(){
	// 해시태그 버튼 클릭 시
	$(document).on("click", "#hashTagsWrap > button", function(){
		$("#hashTagsWrap > button").removeClass("black");
		$(this).addClass("black");
	});

	// 이미지 등록 버튼 클릭 시
	$(document).on("click", "#addImgBtn", function(){
		// TODO : 이미지 선택 팝업 호출
		if($("#imgListWrap > li").length >= 1) {
			MPopup.alert("사진은 최대 1장까지 등록 가능합니다.");
			return;
		}
		
		//getImage();
		alteredGetImage();
	});
	
	// 사진 삭제 버튼 클릭 시
	$(document).on("click", ".btn-ptdel", function(){
		$(this).parent().remove();
		$("#photoArea").removeClass("none");
		$(".review-photo").removeClass("none");
	});
	
	// 등록 버튼 클릭 시
	$(document).on("click", "#registBtn", function(){
		if($("#title").val().trim() == ""){		// 제목 미입력시
			MPopup.alert("닉네임을 입력해주세요.");
			return;
		}

		if($("#hashTagsWrap > button.black").length == 0){	// 해시태그 미선택시
			MPopup.alert("단말 OS를 선택해주세요.");
			return;
		}
		
		if($("#imgListWrap > li").length == 0) {
			MPopup.alert("이미지를 등록해주세요.");
			return;
		}
		
		var photoListEl = $("#imgListWrap > li");
		var photoListArr = [];
		for(var i=0; i<photoListEl.length; i++){
			photoListArr.push({
				name : $(photoListEl).eq(i).attr("data-file-nm"),
				content : $(photoListEl).eq(i).attr("data-img-src"),
				type : "FILE"
			});
		}
		uploadPhotoList(photoListArr);
	});

	// 응모완료 확인 
	$(document).on("click", "#chkReview", function(){
		MPage.back({
			param : {
				baseBallYn : "Y"
			}
		});
	});
};

/**
 * 사진 가져오기
 */
var getImage = function(){
	// 대표사진 선택 팝업
	customPopup.get(PATH_MANAGER.KIA_RNW_411_1110.path, $('#cameraPopUp'), function(item) {
		//screenViewGa(gaSendUrl["KIA_MOB_810_1023"].pageNm);
		var screenHtml = $('<div></div>');
		screenHtml.append(item);
		$('body').append(screenHtml.find('#cameraPopUp'));
		$('[data-btnpop-flag]').click(function() {	//버튼 이벤트
			var flag = $(this).data('btnpopFlag');
			switch(flag){
				case "cameraBtn" : 	//Camera
					customPopup.remove($('#cameraPopUp')); //팝업삭제
					MMedia.camera({
						callback : function(status, result){
							if(status == "SUCCESS"){
								exWNShowIndicator(); // 사진 로딩 표시
								var ratio = 1.0,
									info = M.media.get(result.fullpath);
								if(info.pixelWidth > 1024){
									ratio = info.pixelWidth / 1024;
								}
								//orientation
								M.media.optimize({
									source : result.fullpath,
									// destination: '/'+moment().format("YYYYMMDDHHmmss")+'.jpg', // 파일 이름 년월일시분초로 변경
									destination: '/'+PGV.loginInfo.mbrId+'.jpg', // 파일 이름 사용자 ID 변경
									overwrite: true,
									quality : 0.95, // Only JPG
									dimension : {width:parseInt(info.pixelWidth/ratio), height: parseInt(info.pixelHeight/ratio)},
									format : 'JPG',
									callback : function( result ) {
										setImage(result);
			                        }
			                    });
							}else if(status == "FAIL" && result.message.indexOf("Denied") > 0){
								exWNHideIndicator();

								if(M.page.info("device.os") == "iOS"){
									MPopup.alert('카메라에 대한 권한 설정은 아이폰 > 설정 > MyKia 혹은 아이폰 > 설정 > 개인정보의 설정을 확인 해 주세요.');
								}else{
									MPopup.alert('카메라에 대한 권한 설정은 단말기 환경설정 > MyKia > 권한을 확인 해 주세요.');
								}
							}else if(result.message != "canceled" && status != "CANCEL"){
								MPopup.alert('카메라를 가져오는데 실패하였습니다.');
							}
						}
					});
				break;
				case "pickerBtn" : 	//Picker
					customPopup.remove($('#cameraPopUp')); //팝업삭제
					MMedia.picker({
						callback : function(status, result){
							if(status == "SUCCESS"){
								var ratio = 1.0,
									info = M.media.get(result.fullpath);
								if(info.pixelWidth > 1024){
									ratio = info.pixelWidth / 1024;
								}
								M.media.optimize({
									source : result.fullpath,
									// destination: '/'+moment().format("YYYYMMDDHHmmss")+'.jpg', // 파일 이름 년월일시분초로 변경
									destination: '/'+PGV.loginInfo.mbrId+'.jpg', // 파일 이름 년월일시분초로 변경
									overwrite: true,
									quality : 0.95, // Only JPG
									dimension : {width: parseInt(info.pixelWidth/ratio), height: parseInt(info.pixelHeight/ratio)},
									format : 'JPG',
									callback : function( result ) {
										setImage(result);
			                        }
		                    	});
							}else if((status == "FAIL" || "ERROR") && result.message.indexOf("Denied") > 0){
								exWNHideIndicator();
								if(M.page.info("device.os") == "iOS"){
									MPopup.alert('앨범에 대한 권한 설정은 아이폰 > 설정 > MyKia 혹은 아이폰 > 설정 > 개인정보의 설정을 확인 해 주세요.');
								}else{
									MPopup.alert('앨범에 대한 권한 설정은 단말기 환경설정 > MyKia > 권한을 확인 해 주세요.');
								}
							}else if(result.message != "canceled" && status != "CANCEL"){
								MPopup.alert('앨범을 가져오는데 실패하였습니다.');
							}
						}
					});
				break;
			}
		});
		$("#closeBtn").click(function(e){
			customPopup.remove($('#cameraPopUp')); //팝업삭제
		});
	});
};

var alteredGetImage = function(){
    customPopup.remove($('#cameraPopUp')); //팝업삭제
	MMedia.picker({
		callback : function(status, result){
			if(status == "SUCCESS"){
				var ratio = 1.0,
					info = M.media.get(result.fullpath);
				if(info.pixelWidth > 1024){
					ratio = info.pixelWidth / 1024;
				}
				M.media.optimize({
					source : result.fullpath,
					// destination: '/'+moment().format("YYYYMMDDHHmmss")+'.jpg', // 파일 이름 년월일시분초로 변경
					destination: '/'+PGV.loginInfo.mbrId+'.jpg', // 파일 이름 년월일시분초로 변경
					overwrite: true,
					quality : 0.95, // Only JPG
					dimension : {width: parseInt(info.pixelWidth/ratio), height: parseInt(info.pixelHeight/ratio)},
					format : 'JPG',
					callback : function( result ) {
						setImage(result);
					}
				});
			}else if((status == "FAIL" || "ERROR") && result.message.indexOf("Denied") > 0){
				exWNHideIndicator();
				if(M.page.info("device.os") == "iOS"){
					MPopup.alert('앨범에 대한 권한 설정은 아이폰 > 설정 > MyKia 혹은 아이폰 > 설정 > 개인정보의 설정을 확인 해 주세요.');
				}else{
					MPopup.alert('앨범에 대한 권한 설정은 단말기 환경설정 > MyKia > 권한을 확인 해 주세요.');
				}
			}else if(result.message != "canceled" && status != "CANCEL"){
				MPopup.alert('앨범을 가져오는데 실패하였습니다.');
			}
		}
	});
}
/**
 * 이미지 세팅
 */
var setImage = function(result){
	var _imgSrc = wnIf.device == DT_IOS ? result.path : result.fullpath;
	var _index = _imgSrc.lastIndexOf("/") + 1;
	var _fileNm = _imgSrc.substring(_index);
	
	var strBuff = '';
	strBuff += '<li data-file-nm="' + _fileNm + '" data-img-src="' + _imgSrc + '">';
	strBuff += '		<img src="' + _imgSrc + '" alt="" />';
	strBuff += '		<button type="button" class="btn-ptdel">사진삭제</button>';
	strBuff += '</li>';
	$("#imgListWrap").append(strBuff);
	exWNHideIndicator();
	$(".review-photo").addClass("none");
	$("#photoArea").addClass("none");
};


/**
 * 이미지 파일 업로드
 */
var uploadPhotoList = function(uploadFileArr){
	MNet.upload({
		path : inf.file.upload.url,	
		sendData : {},
		files: uploadFileArr,
		callback : uploadPhotoListCallback
	});
};

/**
 * 이미지 파일 업로드 콜백
 */
var uploadPhotoListCallback = function(receivedData){
	var fileArrList = [];
	for(var i=0; i<receivedData.attFiles.length; i++){
		fileArrList.push({
			fileUploadPath : receivedData.uploadPath[i],
			orgnFileNm : receivedData.fileName[i],
			savedFileNm : receivedData.attFiles[i]
		});
	}
	var sendData = {
		cont : "",		// 없음
		csGbnCcd : "3",	// 리뷰이벤트 3번
		hashTags : $("#hashTagsWrap > button.black").text(),		// 해시태그
		hpno : PGV.loginInfo.hpno,		// 핸드폰번호
		mbrId : PGV.loginInfo.mbrId,		// 회원ID
		mbrNm : PGV.loginInfo.mbrNm,		// 회원이름
		title : $("#title").val(),		// 플레이스토어 닉네임
		fileArray : fileArrList,
		evtNo : PGV.baseEvtNo, //  참여 이벤트 번호
		rank : ""
	};

	registApply(sendData);
};

/**
 * 응모하기 전문
 */
var registApply = function(sendData){
	MNet.httpSendAsIs({
		path : inf.event.reviewApply.url,
		sendData : sendData,
		callback : registApplyCallback
	});
};

/**
 * 응모하기 콜백 전문
 */
var registApplyCallback = function(receivedData){
	
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){
		evtApply();
	}else{
		exWNHideIndicator();
		MPopup.alert(msg);
	}
};

/**
 * 이벤트 등록
 */
var evtApply = function(sendData){
	MNet.httpSendAsIs({
		path : inf.quiz.quizReg.url,
		sendData : {
			mbrId : PGV.loginInfo.mbrId,		
			evtNo : PGV.baseEvtNo,	// 이벤트번호
		},
		callback : evtApplyCallback
	});
};

/**
 * 이벤트 콜백 전문
 */
var evtApplyCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){
		$("#popWrap").removeClass("none");
		$("#popResult").removeClass("none");

	}else{
		MPopup.alert(msg);
	}
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(){
		pageInit();
	},

	onHide : function(){

	},

	onRestore : function(){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(){

	},

	onPause : function(){

	},

	onResume : function(){

	}
};