/**

@파일명 : KIA_MOB_360_1000.js => KIA_RNW_420_0000.js
@작성자 : 박민기
@생성일 : 2022.01.26 
@메뉴명 : 설문목록
@DESC : 전체메뉴노출	[O]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] )
*/
var CurrPage;
var KIA_RNW_420_0000 ={
    init: function(){
        CurrPage = this;
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("page : " + PGV.currentPage + "initiolizing START");

        var pageInit = function(){
        	/**
        	 * 초기화
        	 */
             PGV.evtFlag = "ALL";
             if(!isEmpty(MData.param("srvyType"))){
                 PGV.evtFlag = MData.param("srvyType");
             }

        	// 설문 목록 초기화 및 조회
        	srvyListInit();

        	/**
        	 * 화면 이벤트
        	 */
        	setEvent();
        };

        var setEvent = function() {
            $(document).on("click", ".btn-survey", function(){
                var $this = $(this);

        //		if($this.is(".end-survey") === true) {
        //		    return;
        //		}
                PGV.currentDate = moment().format("YYYYMMDD");
                if(PGV.currentDate > $this.data("endDtm")){
                        MPopup.alert("설문이 종료되어 참여할 수 없습니다.");
                }else if($this.data("ansCnt") > 0){
                    MPopup.alert("설문은 한 번만 참여 가능합니다.");
                }else{
                    MPage.html({
                        url : PATH_MANAGER.KIA_RNW_421_0000.path,
                        action : "NO_HISTORY",
                        param : {
                            srvyNo : $(this).parent().data("srvyNo")
                        }
                    });
                }
            });

            // 현재안씀
            $(".function-tab li button").on("click", function(){
                // 탭 클래스 변경
                $(".function-tab li button").parent().removeClass("on");
                var type = $(this).attr('data-tab-type');
                $('[data-tab-type="' + type + '"]').parent().addClass("on");

                PGV.survType = type;
                //하단 컨텐츠 변경
                $("[data-content-type]").addClass("none");
                $('[data-content-type="' + type + '"]').removeClass("none");
                srvyListInit();
            });

            // 필터 클릭 이벤트
            $(document).on('click','input:radio[name="progress"]', function(){
                PGV.evtFlag = $(this).attr('data-type');
                $('.hrs-list-surv').empty(); // 리스트 초기화
                srvyListInit(PGV.evtFlag);
            });

            // 회원정보 수정(업데이트)
            $(document).on('click', '#updateBtn', function(){
                MPage.html({
                    url : PATH_MANAGER.KIA_RNW_0D3_1100.path,//"../810/KIA_MOB_810_1030.html", // 0D3_1100
                    param : {
                        currentTitle : "추가정보 수정",
                        moveFlag : "KIA_RNW_0D3_1300" // 0D3_1300
                    }
                });
            });

            // 광고성 수신 동의
            $(document).on('click', '#agreeBtn', function(){
                MPage.html({
                    url : PATH_MANAGER.KIA_RNW_0D3_1000.path, //"../810/KIA_MOB_810_1000.html", // 0D3_1000
                    param : {}
                });
            });

        };

        /**
         * 설문 목록 초기화
         */
        var srvyListInit = function(){
            PGV.currentDate = moment().format("YYYYMMDD");
            PGV.currentPageNo = 1;			// 현재 페이지 번호
            PGV.pageSize = 10;				// 받은 페이지의 총 개수
            PGV.totCnt = null;
            PGV.pageStart = null;
            PGV.pageEnd = null;

            $(".hrs-list-surv").empty();
            
            selectSrvyList(PGV.evtFlag);
        };

        /**
         * 설문 목록 조회
         */
        var selectSrvyList = function(type){
        //    if (PGV.evtFlag == null || PGV.evtFlag == undefined){
        //        PGV.evtFlag = "ALL";
        //    }else{
        //        PGV.evtFlag = type;
        //    }
            if(PGV.evtFlag == "CUSTOMER"){
                $("#noDataDiv").addClass('none');
                $(".hrs-list-surv").addClass('none');
                //하단 컨텐츠 변경
                $("[data-content-type]").addClass("none");
                $('[data-content-type=ty2]').removeClass("none");
            }else{
                $("[data-content-type]").addClass("none");
                $('[data-content-type=ty1]').removeClass("none");
                // 탭 변경
                $('[data-type]').prop("checked",false);
                $('[data-content-type=ty1] [data-type="'+PGV.evtFlag+'"]').prop("checked",true);
                MNet.httpSendAsIs({
                    path : inf.survey.surveyList.url,
                    sendData : {
                        currentPageNo : PGV.currentPageNo,
                        pageSize : PGV.pageSize,
                        mbrId : PGV.loginInfo.mbrId,
                        evtFlag : type
                    },
                    callback : selectSrvyListCallback
                });
            }
        };

        /**
         * 설문 목록 조회 콜백 함수
         */
        var selectSrvyListCallback = function(receivedData){
            exWNHideIndicator();
            var code = receivedData.resultCode;
            var msg = receivedData.resultMsg;
            if(code == "200"){
        //	    if (PGV.survType == "survType") {
        //		    appendSrvyList(receivedData.surveyResListDto);
        //        } else {
        //		    appendEndSrvyList(receivedData.surveyResListDto);
        //        }

                appendSrvyList(receivedData.surveyResListDto);

                PGV.totCnt  = receivedData.totCnt;
                PGV.pageStart = receivedData.pageStart;
                PGV.pageEnd = receivedData.pageEnd;
            } else {
        //	    if (PGV.survType == "survType") {
        //            $("#noFeeInfo").removeClass('none');
        //            $("#survWrap").addClass('none');
        //		} else {
        //            $("#noEndFeeInfo").removeClass('none');
        //            $("#endSurvWrap").addClass('none');
        //		}

                $("#noDataDiv").removeClass('none');
                $(".hrs-list-surv").addClass('none');
                $("#customerDiv").addClass('none');

                MPopup.alert(msg);
            }
        };

        /**
        *   설문 목록 리스트 추가
        */
        var appendSrvyList = function(list){
            var today = PGV.currentDate;
            var strBuff = "";
            var nowDate = moment().format("YYYY-MM-DD");
            if(list.length > 0){
                $("#noDataDiv").addClass('none');
                $(".hrs-list-surv").removeClass('none');
            }else{
                $("#noDataDiv").removeClass('none');
                $(".hrs-list-surv").addClass('none');
                if (PGV.evtFlag == "END")
                    $(".txtgr6").text("종료된 설문이 없습니다.");
                else
                    $(".txtgr6").text("등록된 설문이 없습니다.");
                return;
            }
            for(var i=0; i<list.length; i++){
                var endDate = parseDate(list[i].srvyEndDtm);
                var dday = dDayDiff(nowDate, moment(list[i].srvyEndDtm).format("YYYY-MM-DD"));
                strBuff += '<li data-srvy-no="' + list[i].srvyNo + '">';
                strBuff += '    <button type="button" class="btn-survey ' + (list[i].ansCnt > 0 ? 'complete' : '') + '' + (today > endDate ? ' end-survey' : '')
                                    + '" data-ans-cnt="' + list[i].ansCnt + '" data-end-dtm="' + parseDate(list[i].srvyEndDtm) + '">';
                strBuff += '        <p class="survey-title">' + list[i].srvyNm + '</p>';
                strBuff += '        <p class="surv-date"><em class="point-txt">' + (dday < 0 ? '(종료)' : ('D-'+(dday == 0 ? 'day' : dday))) + '</em>'+parseDate2(list[i].srvyStartDtm) + ' ~ ' + parseDate2(list[i].srvyEndDtm)+'</p>';
                strBuff += '    </button>';
                strBuff += '</li>';

        //        strBuff += '<li data-srvy-no="' + list[i].srvyNo + '">';
        //        if(today > endDate){
        //            strBuff += '    <button type="button" class="btn-survey end-survey ' + (list[i].ansCnt > 0 ? 'complete' : '') + '" data-ans-cnt="' + list[i].ansCnt + '" data-end-dtm="' + parseDate(list[i].srvyEndDtm) + '">';
        //        }else{
        //            strBuff += '    <button type="button" class="btn-survey ' + (list[i].ansCnt > 0 ? 'complete' : '') + '" data-ans-cnt="' + list[i].ansCnt + '" data-end-dtm="' + parseDate(list[i].srvyEndDtm) + '">';
        //        }
        //        strBuff += '        <div class="surv-date">';
        //        strBuff += '            <p class="survey-title">' + list[i].srvyNm + '</p>';
        //        strBuff += '            <p class="surv-date"><em class="point-txt">' + (dday < 0 ? '(종료)' : ('D-'+(dday == 0 ? 'day' : dday))) + '</em>'+parseDate2(list[i].srvyStartDtm) + ' ~ ' + parseDate2(list[i].srvyEndDtm)+'</p>';
        //        strBuff += '        </div>';
        //        strBuff += '    </button>';
        //        strBuff += '</li>';

            }

            $(".hrs-list-surv").append(strBuff);
        };

        var appendEndSrvyList = function(list){
            var strBuff = "";

            if(list.length > 0){
                $("#noEndFeeInfo").addClass('none');
                $("#endSurvWrap").removeClass('none');
            }else{
                $("#noEndFeeInfo").removeClass('none');
                $("#endSurvWrap").addClass('none');
                return;
            }

            for(var i=0; i<list.length; i++){
                strBuff += '<li data-srvy-no="' + list[i].srvyNo + '">';
                strBuff += '    <button type="button" class="btn-survey end-survey disabled" >';
                strBuff += '        <p class="survey-title">' + list[i].srvyNm + '</p>';
                strBuff += '        <p class="surv-date">'+parseDate2(list[i].srvyStartDtm) + ' ~ ' + parseDate2(list[i].srvyEndDtm)+'</p>';
                strBuff += '    </button>';
                strBuff += '</li>';
            }

            $("#endSurvWrap").append(strBuff);
        };

        /**
         * 하단 스크롤시 더보기 이벤트
         */
        var selectMoreListData = function(){
            var totalPageCnt = Math.ceil(PGV.totCnt/PGV.pageSize);	// 전체 페이지 수

            if(totalPageCnt > PGV.currentPageNo){
                PGV.currentPageNo = PGV.pageEnd/PGV.pageSize + 1;
                selectSrvyList(PGV.evtFlag);
            }
        };

        pageInit();
    },
    setEventListner: function(){
        // do something..
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("onReady page : "+PGV.currentPage); 
        KIA_RNW_420_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
