/**

@파일명 : KIA_RNW_430_0000.js
@작성자 : 박민기 - 사용되지 않음, 진입점 없음, 현재 기아스토리 홈에서 보여짐
@생성일 : 2022.01.26 
@메뉴명 : 채널 기아
@DESC : 전체메뉴노출	[O]   계약차량보유	[O]   내연보유	[O]   EV보유	[O] ) 
*/ 
var CurrPage;
var KIA_RNW_430_0000 ={
    init: function(){
        CurrPage = this;
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("page : " + PGV.currentPage + "initiolizing START");

        var pageInit = function(){
        	/**
        	 * 초기화
        	 */

        	// 전체 메뉴 스택정리
        	var backFlag = MData.param("backFlag");
        	if(backFlag != "Y"){
        		garbageCollector();
        	}

        	selectKiaNews();

        	setEvent();
        	// screenViewGa(gaSendUrl["KIA_MOB_330_1000"].pageNm); //2020 공통으로 변경
        	/**
        	 * 화면 이벤트
        	 */
        };


        var setEvent = function() {
        	$(document).on("click", '[data-channel-url]', function(){	//전체 버튼
        		var _url = $(this).data('channelUrl');
        		MPage.activity({
        			className : "WebviewActivity",
        			param : {
        				method : CONSTANT.NET_MTHD.GET,
        				requestURL : _url
        			}
        		});
        	});

            // 상단 홍보 이미지 영역 클릭 시
        	$(document).on("click", "[data-promote-idx]", function(){
        		var $this = $(this);
        		var _url = $this.attr("data-brand-url");
        		switch ($this.attr("data-promote-idx")) {
        		case "Y":		// 외부
        			MPage.activity({
        				className : "WebviewActivity",
        				param : {
        					method : CONSTANT.NET_MTHD.GET,
        					requestURL : _url
        				}
        			});
        			break;
        		case "N":		// 내부
        			MPage.html({
        				url : PATH_MANAGER.KIA_RNW_411_1000.path,
        				param : {
        					evtNo : _url,		// 이벤트 번호
        					eventType : "ing"	// 이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
        				}
        			});
        			break;
        		default:
        			break;
        		}
        	});
        };

        var selectKiaNews = function(){
            // 20201221 kiaSelect api에서 mbrId 파라메터 조회 삭제
        	MNet.httpSendAsIs({
        		path : inf.kianews.kiaSelect.url,
        		sendData : {},
        		callback : callbackSelectKiaNews
        	});
        };

        var callbackSelectKiaNews = function(receivedData){

        	var code = receivedData.resultCode;
        	var msg = receivedData.resultMsg;

        	if(code == "200"){
        		var newsMainList = receivedData.newsMainDto;
        		var newsList = receivedData.newsListDto;

        		// 상단 이미지 영역
        		var brandAreaStr = "";
        		for(var i=0; i<newsMainList.length; i++){
        			var obj = newsMainList[i];
        			var _imgUrl = CONSTANT.IMG_URL_PREFIX + obj.savedFilePath + obj.savedFileNm;
        			brandAreaStr += '<div class="swiper-slide">';
        			brandAreaStr += '   <div class="swipebox">';
        			if(newsMainList[i].irsLinkYn == "N"){ // 이벤트 인경우
        				brandAreaStr += '    <div class="map-box" data-promote-idx="' + obj.irsLinkYn + '" data-brand-url="' + obj.evtNo + '">';
        			}else{
        				brandAreaStr += '    <div class="map-box" data-promote-idx="' + obj.irsLinkYn + '" data-brand-url="' + obj.linkUrl + '">';
        			}
        			brandAreaStr += '    		<img src="' + _imgUrl + '" alt="' + obj.popupDesc + '" />';
        			brandAreaStr += '    	</div>';
        			brandAreaStr += '       <p class="sub16">'+obj.title+'</p>';
        			brandAreaStr += '   </div>';
        			brandAreaStr += '</div>';
        		}

        		$("#brandAreaWrap").html(brandAreaStr);

        		// 브랜드 홍보 영역(상단) Swipe 적용
        		if(newsMainList.length > 1){
                    if(PGV.vikNewsAreaSwiper != null){
                        PGV.vikNewsAreaSwiper.destroy();
                    }
        			PGV.vikNewsAreaSwiper = new Swiper('.common-swipe .swiper-container', {
                        slidesPerView: 1,
                        centeredSlides: true,
                        spaceBetween: 0,
                        grabCursor: true,
                        loop: true,
                        autoplay: {
                            delay: 3000
                        },
                        pagination: {
                           el: '.common-swipe .swiper-pagination',
                        },
                    });
        		}

                var eventIngList = "";
                if(newsList.length > 0){
                    for(var i=0; i< newsList.length; i++){
                        var obj = newsList[i];
                        var imgPath = CONSTANT.IMG_URL_PREFIX + obj.savedFilePath + obj.savedFileNm;
                        var category = "";
                        var categoryIcon = "";
                        var url ="";
                        eventIngList += '<li>'
                        if(obj.irsLinkYn == "N"){ // 이벤트 인경우
                            eventIngList += '    <button class="news-wrap"  type="button" data-promote-idx="' + obj.irsLinkYn + '" data-brand-url="' + obj.evtNo + '" data-news="Y">';
                        }else{
                            eventIngList += '    <button class="news-wrap"  type="button" data-promote-idx="' + obj.irsLinkYn + '" data-brand-url="' + obj.linkUrl + '" data-news="Y">';
                        }

                        switch(obj.popupGbnCcd) {
                            case "YOUTUBE":
                                category = "캬TV by 기아";
                                categoryIcon = "../../img/common/thumb-news-youtubeic.png"
                                eventIngList += '<div class="top-box videonews">';
                                eventIngList += '<img class="news-img" src="' + imgPath + '">';
                                break;
                            case "PLAY":
                                category = "PLAY Kia";
                                categoryIcon = "../../img/common/thumb-news-playkiaic.png"
                                eventIngList += '<div class="top-box">';
                                eventIngList += '<img class="news-img" src="' + imgPath + '">';
                                eventIngList += '<span class="news-video"></span>';
                                break;
                            case "COPY":
                                category = "자동차에 대한 새로운 생각 카피엔스";
                                categoryIcon = "../../img/common/thumb-news-blogic.png"
                                eventIngList += '<div class="top-box">';
                                eventIngList += '<img class="news-img" src="' + imgPath + '">';
                                eventIngList += '<span class="news-video"></span>';
                                break;
                            case "KPLAZA":      // 20201221 KPLAZA 를 INSTA 용으로 대체하여 사용
                                category = "기아 인스타그램";
                                categoryIcon = "../../img/common/thumb_chkia_instagram.png"
                                eventIngList += '<div class="top-box insta">';
                                eventIngList += '<img class="news-img" src="' + imgPath + '">';
                                eventIngList += '<span class="news-video"></span>';
                                break;
                             default:
                                break;
                        }
                        eventIngList += '    </div>';
                        eventIngList += '        <div class="btm-box">';
                        eventIngList +=	'            <img class="news-thumb" src="' + categoryIcon + '" alt="" title="">';
                        eventIngList +=	'            <p class="main-txt">' + obj.title + '</p>';
                        eventIngList += '            <p class="sub-txt">' + category + '</p>';
                        eventIngList += '        </div>';
                        eventIngList += '    </button>';
                        eventIngList += '</li>';

                    }
                }
                $("#newsListWrap").removeClass("none");
                $(".viknewslist").html(eventIngList);
        	    exWNHideIndicator();
        	}else{
        		MPopup.alert(msg);
        	}
        };

        pageInit();
    },
    setEventListner: function(){
        // do something.. 
    } 
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        COMMON_FUNCTION.TOOL.DEBUG.showTalk("onReady page : "+PGV.currentPage); 
        KIA_RNW_430_0000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
