/**

@파일명 : KIA_RNW_500_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : EV 탭 (AS-IS : "전기차 충전" 탭) 
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] )
*********************   EV 메인 진입 이전 Flow   *********************
전체메뉴/하단 EV 메뉴 클릭 시 처리
*   1. EV멤버쉽 회원 유무
*       1-1. EV멤버스 EV카드 여부
*       1-2. SK일렉링크 회원 여부
*********************   EV 메인 진입 이후 Flow   *********************
chkAuthPage() 에서 처리
*   1. 에스트래픽 회원 유무
*   2. CCS 연동 가능 여부
*       2-1. 필수 동의 여부
*       2-2. 약관 변경 여부
***************************************************************
*/ 
var EV;
var KIA_RNW_500_0000 ={
    currentScopeSelectCar: null,
    init: function(){
        EV = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //차량 선택 팝업 set
        var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000);
        COMMON_FUNCTION.TOOL.UI.setVehicleInfoBox(currentScopeSelectCar, "#mykia-mycar-ev-car-select-box");
        EV.gVals = CMM_HOME.homePgvObj;
        //EV 메인 진입 권한여부

        EV.chkAuthPage()
        .then(function(){
            //Evt
            EV.setEventListner();
            console.log("evtap hide")
            exWNHideIndicator();
        });

    },
    setEventListner: function(){

        var riderYn = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).rdmYn;

        //차량 선택 영역
        $("#mykia-mycar-ev-car-select-box").off("click").on("click", function(){
            EV.showEvCarSelectionPopup(KIA_RNW_500_0000);
        });

        //약관 재동의
        $("#termsBtn").on("click", function(){
            //CCS측 약관 화면 이동
            EV.dataHubTermsPopup();
        });

        //최근 업데이트 시간 새로고침
        $("#refreshBtn").off("click").on("click", function(){

            //배터리 영역 애니메이션을 그리기 위해 초기세팅
            $('.battery-info .gage-box').find('.ico-battery span').css('width','0%');
            $("#chrgSoc em").text(0);
            //전기차 상태 조회 (배터리잔량, 충전상태, 주행가능거리)
            if(EV.gVals.AOD.aodYn == "Y") {
                EV.AODbattery();
                exWNHideIndicator();
            }else {
                EV.evBattery()
                    .then(function (obj) {
                        if (obj.soc) {
                            return Promise.all([
                                //충전 상태 조회
                                EV.evCharging(obj),
                                //주행 가능 거리 조회 , 2023.12.18 조회 api 변경
                                EV.getDte(),
                            ])
                        }
                    })
                    .then(function () {
                        //해당영역 노출이 되고나서 애니메이션 주기 위함
                        EV.counterEv();
                        exWNHideIndicator();
                    })
            }
        });

        //가까운 충전소 검색
        $("#chrgSrchBtn").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_580_0000.path});
        });

        //가까운 충전소 검색
        $("#EVcreditList").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_500_1100.path});
        });

        //데이터 허브 연동
        $("#dataHubBtn").on("click", function(){
            //팝업 노출
            EV.dataHubPopup();
        });

        //AOD 연동
        $("#AODBtn").on("click", function(){
            //팝업 노출
            EV.AODPopup();
        });

        $("#connectBtn").on("click", function (){
            MPage.activity({
                className: "WebviewActivity",
                param: {
                    method: CONSTANT.NET_MTHD.GET,
                    requestURL: CONSTANT.LINK_URL.KIA_RNW_331_8001.URL,
                    setCookie : isEmpty(PGV.loginInfo) ? false : true
                }
            });
        });

        //충전 현황
        $("#chrgStatBtn").on("click", function(){
            EV.getSscCardKey()
                .then(function(response){
                    //약관 변경 확인
                    if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                        if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("CHRGSTAT");
                        }else{
                            MPage.html({url: PATH_MANAGER.KIA_RNW_5B0_0000.path});
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else {
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx) {
                                    if (idx == 0) {
                                        MPage.html({
                                            url: PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate: "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

        //NFC 태깅
        $("#nfcBtn").on("click", function(){
            var _os = MNavigator.os().toLowerCase();
            if( _os == "ios"){
                MPopup.confirm({
                    message : "지원하지 않는 OS 입니다.",
                    buttons : ['닫기'],
                });
                return;
            }

            EV.getSscCardKey()
              .then(function(response){
              //약관 변경 확인
                  if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                      if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("NFC");
                      }else{
                            MPage.html({url: PATH_MANAGER.KIA_RNW_510_0000.path});
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else {
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx) {
                                    if (idx == 0) {
                                        MPage.html({
                                            url: PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate: "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

        //QR 스캔
        $("#qrScan").on("click", function(){
                EV.getSscCardKey()
                  .then(function(response){
                  //약관 변경 확인
                      if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                          if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("QR");
                          }else{
                            EV.qrScan();
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else {
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx) {
                                    if (idx == 0) {
                                        MPage.html({
                                            url: PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate: "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

        //QR 생성
        $("#qrCreate").on("click", function(){
                EV.getSscCardKey()
                  .then(function(response){
                    //약관 변경 확인
                  if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                    if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("CQR");
                        }else{
                            MPage.html({url: PATH_MANAGER.KIA_RNW_530_0000.path, animate: 'SLIDE_LEFT'});
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else {
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx) {
                                    if (idx == 0) {
                                        MPage.html({
                                            url: PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate: "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

        //충전 서비스 설정
        $("#chrgSvcBtn").on("click", function(){
            EV.getSscCardKey()
                .then(function(response){
                    //약관 변경 확인
                    if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                        if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("CSS");
                        }else{
                            MPage.html({url: PATH_MANAGER.KIA_RNW_570_0000.path});
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else {
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx) {
                                    if (idx == 0) {
                                        MPage.html({
                                            url: PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate: "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

        //주간 충전 리포트
        EV.scrollChartEvt();

        //나만의 충전소
        $("#myStation").closest(".div-item").on("click", function(){
             MPage.html({url: PATH_MANAGER.KIA_RNW_550_0000.path});
        });

        //충전소 검색/예약
        $("#srchStation").closest(".div-item").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_580_0000.path});
        });

        //충전소 예약 현황/내역
        $("#reservStation").closest(".div-item").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_540_0000.path});
        });

        //충전 내역
        $("#historyStation").closest(".div-item").on("click", function(){
            EV.getSscCardKey()
                .then(function(response){
                    //약관 변경 확인
                    if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                        if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("HISTORY");
                        }else{
                            MPage.html({url: PATH_MANAGER.KIA_RNW_560_0000.path});
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else{
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx){
                                    if(idx == 0){
                                        MPage.html({
                                            url : PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate : "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

        //온디맨드 픽업충전 서비스
        $("#onDemand").closest(".div-item").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_590_0000.path});
        });

        //E-pit
        $("#ePit").closest(".div-item").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_5A0_0000.path});
        });

        //충전로밍·구독형 충전 프로그램 (2022-06-22)
        $("#subsProduct").closest(".div-item").on("click", function(){
            EV.getSscCardKey()
                .then(function(response){
                    //약관 변경 확인
                    if(response.resultCode == "200"  && response.evMemRegYn == "Y"){
                        if(response.evMemTermsYn == "Y"){
                            EV.getChrgeTerms("subscribe");
                        }else{
                            MPage.html({url: PATH_MANAGER.KIA_RNW_5F2_0000.path});
                        }
                    }else if(response.resultCode == "200"  && response.evMemRegYn == "N"){
                        if("Y" == riderYn){
                            MPopup.confirm({
                                message: "충전 로밍 서비스 및 구독형 충전 요금제는 기아 EV멤버스 또는 EV멤버스 택시 카드를 발급 받은 카드 명의자 본인만 이용 가능합니다",
                                buttons: ["확인"]
                            });
                        }else {
                            MPopup.confirm({
                                message: "충전 로밍 서비스를 사용하기 위해서는 SK일렉링크 회원가입이 필요합니다. SK일렉링크 회원가입 화면으로 이동하시겠습니까?",
                                buttons: ["확인", "취소"],
                                callback: function (idx) {
                                    if (idx == 0) {
                                        MPage.html({
                                            url: PATH_MANAGER.KIA_RNW_5E0_0000.path,
                                            animate: "MODAL_UP"
                                        });
                                    }
                                }
                            });
                        };
                    }else{
                        MPopup.confirm({
                            message: "일시적인 시스템 오류입니다. 고객센터로 문의 부탁드립니다. " + "\r\n" + "※ SK일렉링크 고객센터(1566-1704, 24시간 운영)",
                            buttons: ["확인"]
                        });
                    }
                });
        });

    },
    connectCcs: function(){
//        var options = {
//            isMock: false, indicatorYn: "N", path: _API.HUB.carMaster.verifyUrl(PGV.loginInfo.ccspId, COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).vin).path, method: CONSTANT.NET_MTHD.GET,
//        };
//        return MNet_Hub.httpSendAsync(options);
        return COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000);
    },
    agreements: function(){
        var options = {
            isMock: false, indicatorYn: "N", path: _API.HUB.agreements.verifyUrl(PGV.loginInfo.ccspId, COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId, PGV.loginInfo.accessToken).path, method: CONSTANT.NET_MTHD.GET,
        };

        return MNet_Hub.httpSendAsync(options);
    },
    getChrgInfo: function(key){
        return new Promise(function (resolve) {

            // 2024.01.17 HOME에서 담은 global 변수
            var charging = EV.gVals.ccs.ev.charging;

            // 충전 중일 경우
            if (!isEmpty(charging) && charging.batteryCharge) {
                //애스트래픽
                var sendData = {evTrafficCardNo: key};

                MNet_SSC.httpSend({
                    path: SSC_API.progressChrgInfo.url,
                    sendData: sendData,
                    callback: function (response) {
                        if (response.resultCode == "0000" && (response.chargeProgressInfo && response.chargeProgressInfo.length > 0)) {
                            $("#chargerCon").show();
                        }
                        resolve();
                    }
                });
            } else {
                resolve();
            }
        });
    },
    getSscCardKey: function(){
        return new Promise(function (resolve) {
            //실시간 에스트래픽 회원카드 정보 조회 (그린패스 추가로 서버API 호출)
            var sendData = {
                apiId: 'RNW-EVC-4001',
                mbrId: PGV.loginInfo.mbrId
            }

            MNet.httpSendAsync({
                path: _API.SVR.EV.evmng.sscMemCardInfoReq,
                indicatorYn: "N",
                sendData: sendData,
                isMock: false
            }).then(function (response) {

                if(response.resultCode == "200"){

                    resolve(response);
                }
            })
        })
    },
    getEvAuthCheck: function(){
        return new Promise(function (resolve) {
            var evAuthCheck = MData.global("evAuthCheck");
            MData.removeGlobal("evAuthCheck");
            resolve(evAuthCheck);
        })
    },
    chkAuthPage:function(){
        return new Promise(function (resolve) {
            //전역 데이터
            var passData = MData.global("passData");

            //보유차량 중 EV차량 존재여부 (로그인 정보로 판단)
            if(passData.car.myCarInfoListResDto && passData.car.isEv){
                exWNShowIndicator();
                return Promise.all([
                    EV.getEvAuthCheck().then(function(obj){
                        return Promise.all([
                            //충전현황 노출 여부
                            EV.getChrgInfo(obj.evTrafficCardNo && obj.evTrafficCardNo),
                            //Kia EV Members 카드 조회
                            EV.memEvCard(),
                            EV.getSubscribeProduct(obj),
                            //주간 충전 리포트
                            EV.setWeekChrgRpt(),
                            EV.getCredit(),
                        ])
                    }).then(function () {
                        var selectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000);
                        var tassYn = selectCar.tassYn;
                        if(tassYn == "Y"){
                            EV.AODbattery();
                        }else {
                            //연동 불가,
                            if (selectCar.carId != null && selectCar.master == "Y") {
                                //필수 동의 여부
                                return EV.agreements().then(function (isAgree) {
                                        //필수 동의 여부 && datahub 지원 차종 여부 확인
                                        if(isAgree.result_message == "success" && isAgree.data.supportedYn) {
                                            if (isAgree.data.ccsSubAgreeYn == 1) {
                                                //약관 변경여부판단 (추후 변경 필요(?))
                                                if (isAgree.data.result == 0) {
                                                    $("#termsReCon").show();
                                                } else {
                                                    //변경된 약관이 없을 때,,,,,,,,,,,,,,,,,,,,
                                                    //전기차 상태 조회 (배터리잔량, 충전상태, 주행가능거리)
                                                    return EV.evBattery().then(function (obj) {
                                                        if (obj.soc) {
                                                            return Promise.all([
                                                                //충전 상태 조회
                                                                EV.evCharging(obj),
                                                                //주행 가능 거리 조회 , 2023.12.18 조회 api 변경
                                                                EV.getDte(),
                                                                $("#batteryCon").show()
                                                            ])
                                                        }
                                                    })
                                                    .then(function () {
                                                        //해당영역 노출이 되고나서 애니메이션 주기 위함
                                                        EV.counterEv();
                                                    })
                                                }
                                            } else {
                                                //필수 미동의
                                                $("#dataHubCon").show();
                                            }
                                        }
                                    })
                            }
                        }
                    })
                ])
                .then(function(){
                    resolve();
                })

            }else{
                COMMON_FUNCTION.TOOL.UI.showNoCarPopup(function(){
                    resolve();
                    MyKiaBottomTab.open('home');
                })
            }
        })
    },
    getCredit: function(){
        EV.getSscCardKey()
            .then(function(response) {
                if(response.resultCode == "200"  && response.evMemRegYn == "Y") {
                    return new Promise(function (resolve) {
                        MNet.httpSendAsync({
                            path: _API.SVR.EV.evmng.sccCredit,
                            sendData: {
                                apiId: "RNW-EVC-5001",
                                mbrId: PGV.loginInfo.mbrId
                            },
                            isMock: false
                        }).then(function (response) {

                            console.log("response.resultCode == >> " + response.resultCode);

                            if (response.resultCode == "200") {

                                var balanceAmount = response.balanceAmount;
                                balanceAmount = balanceAmount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
                                var totalCredit = balanceAmount + '<i class="icon-credit">C</i>';
                                $('#nowCash').html(totalCredit);
                                $('#sscCredit').show();
                            }

                            resolve();
                        })
                    })
                }
            })
    },
    scrollChartEvt: function(){
        // ------------------------------
        // 	Scroll
        // ------------------------------
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();

        // 한번만 실행
        var activeScrollFlag1 = true;
        var activeScrollFlag2 = true;
        var activeScrollFlag3 = true;

        $('[class^="section-"]').each(function(idx, item) {
            nScrollPos[nScrollPosNum] = $(this).offset().top - 450;
            nScrollPosNum++;
        });

        $(window).scroll(function(e) {
            var $nowTop = $(this).scrollTop();

            for (var i = 0; i< nScrollPos.length; i++) {
                if ($nowTop > nScrollPos[i]) {
                    $('[class^="section-"]').eq(i).addClass('active--scroll');

                    // if ($('.section-03').hasClass('active--scroll') && activeScrollFlag1) {
                    // 	fnSetMonthExpendProgress();
                    // 	activeScrollFlag1 = false;
                    // }
                    if ($('.section-07').hasClass('active--scroll') && activeScrollFlag2) {
                        EV.setEvChart();
                        activeScrollFlag2 = false;
                    }
                    // if ($('.section-05').hasClass('active--scroll') && activeScrollFlag3) {
                    // 	fnSetCarExpendProgress();
                    // 	activeScrollFlag3 = false;
                    // }

                }
            }

            // 탭버튼영역 스크롤시 상단 고정
            if ($nowTop > $headerHeight) {
                $('body').addClass('js-mycar-tabs-fixed');
            }
            else {
                $('body').removeClass('js-mycar-tabs-fixed');
            }


            $winTop = $nowTop;

        });
    },
    setEvChart:function(){
        // 항목별 평균 지출 내역 영역
        var _echartsCaseExpend = echarts.init(document.getElementById('evEchartsCaseExpend'));
        var _echartsCaseExpend_option;
        var _echartsCaseExpend_colors = ['#5d7d2b','#f3c300'];

        _echartsCaseExpend_option = {
            grid: {
                left:'0%',
                right:'0%',
                top:'0%',
                bottom:'0%',
                containLabel: true
            },
            tooltip: {
                show:false,
                //trigger: 'item',

            },
            legend: {
                show:false,
            },

            series: [
                {
                type: 'pie',
                radius: ['40%', '70%'],
                avoidLabelOverlap: true,
                label: {
                    show: false,
                    position: 'outside'
                },
                labelLine: {
                    //show:true,
                    show:false
                },
                emphasis: {
                    label: {
                    show: false
                    }
                },
                labelLine: {
                    show: false
                },
                data: EV.chartData
                }
            ]
        };

        _echartsCaseExpend.setOption(_echartsCaseExpend_option);
    },
    dataHubTermsPopup: function(){
        var loginInfo =PGV.loginInfo;
        var carId = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId;
        var url= _API.HUB.agreementsWeb.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);

        MPage.activity({
            className : "WebviewActivity",
            param : {
                method : "GET",
                requestURL : url.path,
                bottomLayer : "disable"
            }
        });
    },
    dataHubPopup: function(){
        var loginInfo =PGV.loginInfo;
        var carId = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId;
        var url= _API.HUB.web.verifyUrl(loginInfo.accessToken, loginInfo.ccspId, carId);

        MPage.activity({
            className : "WebviewActivity",
            param : {
                method : "GET",
                requestURL : url.path,
                bottomLayer : "disable"
            }
        });
    },
    AODPopup: function(){
        MPage.html({
            path: PATH_MANAGER.KIA_RNW_0D3_1800.path
        });
    },
    evBattery: function(){
        return new Promise(function (resolve) {
            //전기차 배터리 잔량 조회
            var carId = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId;

            MNet_Hub.httpSendAsync({
                path: _API.HUB.evBattery.verifyUrl(carId).path,
                method: CONSTANT.NET_MTHD.GET,
                indicatorYn: "N",
                isMock: false
            }).then(function (response) {

                resolve(response);

            });
        });
    },
    evCharging: function(obj){
        return new Promise(function (resolve) {
            //전기차 충전 상태 조회
            var carId = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId;

            MNet_Hub.httpSendAsync({
                path: _API.HUB.evCharging.verifyUrl(carId).path,
                method: CONSTANT.NET_MTHD.GET,
                indicatorYn: "N",
                isMock: false
            }).then(function (response) {

                $("#targetSoc").show();
                $("#chrgSrchBtn").closest('.btn-block').show();

                /* evBattery 함수로부터 받아온 배터리 잔량 Start */
                //배터리 잔량
                var soc = obj.soc;
                //배터리 컬러
                var backColor = "";

                //충전 여부
                var batteryCharge = response.batteryCharge;
                //차량 전송 시간
                var resTime = parseDate3(response.timestamp);
                //배터리 잔량에 따른 문구
                var statusTxt = "";

                //배터리 잔량 background 컬러
                if(soc == 0){
                    statusTxt = "<b>배터리 잔량이 없습니다. <br>배터리 성능을 위해 충전해 주세요.</b>";
                }else if(soc > 0 && soc <= 10){
                    backColor = "#ea0029";
                    statusTxt = "<b>배터리 잔량이 부족합니다. <br>가까운 충전소를 찾아보세요!</b>";
                }else if(soc > 10 && soc <= 50){
                    backColor = "#f3c300";
                    statusTxt = "<b>배터리 잔량이 조금 남았어요. <br>가까운 충전소를 찾아보세요!</b>";
                }else if(soc > 50 && soc <= 70){
                    backColor = "#5d7d2b";
                    statusTxt = "<b>원활한 운전을 위해 <br>미리 충전소를 예약해 보세요.</b>";
                }else if(soc > 70){
                    backColor = "#5d7d2b";
                    statusTxt = "<b>배터리 잔량이 충분해요. <br>오늘도 안전운전 하세요!</b>";

                    //충전소 검색 미노출
                    $("#chrgSrchBtn").closest('.btn-block').hide();
                }
                /* evBattery 함수로부터 받아온 배터리 잔량 End */


                /* 충전 상태별 노출 Start */
                if(batteryCharge){

                    statusTxt = "<b>배터리 충전중 입니다. <br>남은 시간까지 잠시 기다려 주세요.</b>";

                    //목표 충전까지 남은 시간
                    var timeTxt = "";
                    if(response.remainTime.unit == 0){
                        timeTxt = "시간";
                    }else if(response.remainTime.unit == 1){
                        timeTxt = "분";
                    }else if(response.remainTime.unit == 2){
                        timeTxt = "미리초";
                    }else{
                        timeTxt = "초";
                    }

                    $(".ico-battery").addClass('charging');
                    $("#targetSoc").show();
                    $("#chrgSrchBtn").closest('.btn-block').hide();

                    if(response.targetSOC){
                        //목표충전량
                        $("#targetSoc dl:first").show();
                        $("#targetSoc dl:first dd:last b").text(response.targetSOC.targetSOClevel + "%");
                    }else{
                        $("#targetSoc dl:first").hide();
                    }

                    if(response.remainTime){
                        //남은시간
                        $("#targetSoc dl:last dd:last b").text(response.remainTime.value + timeTxt);
                    }

                }else{
                    $(".ico-battery").removeClass('charging');
                    $("#targetSoc").hide();
                }
                /* 충전 상태별 노출 End */

                //화면에 뿌릴 데이터
                $("#statusTxt").html(statusTxt);
                $("#chrgColor").css("background", backColor);
                /*$("#chrgColor").css("width", soc+"%");*/
                $("#chrgColor").closest('.gage-box').attr('data-eg', soc);
                $("#updateTime").text(moment(resTime).format("YYYY년 MM월 DD일 HH:MM"));

                resolve();
            });
        })
    },
    evDte: function(){
        return new Promise(function (resolve) {
            //전기차 주행 가능 거리 조회
            var carId = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId;

            MNet_Hub.httpSendAsync({
                path: _API.HUB.evStatus.verifyUrl(carId).path,
                method: CONSTANT.NET_MTHD.GET,
                indicatorYn: "N",
                isMock: false
            }).then(function (response) {

                //주행가능거리 노출
                var dist = (response.dte && response.dte.distance) && response.dte.distance.value;
                var unit = (response.dte && response.dte.distance) && response.dte.distance.unit;

                $("#chrgDte").text((dist && dist || "-") + ((unit && unit == 1) && "km" || "m"));

                resolve();
            });
        })
    },
    //2023.12.18 주행가능 거리 조회 api 변경
    getDte: function(){
        return new Promise(function (resolve) {
            //전기차 주행 가능 거리 조회
            var carId = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar(KIA_RNW_500_0000).carId;

            MNet_Hub.httpSendAsync({
                path: _API.HUB.dte.verifyUrl(carId).path,
                method: CONSTANT.NET_MTHD.GET,
                indicatorYn: "N",
                isMock: false
            }).then(function (response) {
                //주행가능거리 노출
                var dist = response.value;
                var unit = response.unit;

                $("#chrgDte").text((dist || "-") + ((unit && unit == 1) && "km" || "m"));

                resolve();
            });
        })
    },
    memEvCard: function(){
        return new Promise(function (resolve) {
            //Kia EV Members 카드 조회
            var sendData = {
                apiId: 'RNW-CRD-1001',
                mbrId: PGV.loginInfo.mbrId
            }

            MNet.httpSendAsync({
                path: _API.SVR.CMM.crd.holdCardReq,
                sendData: sendData,
                isMock: false
            }).then(function (response) {
                /** 카앤라이프 호출 시, 글로벌 변수 저장하기 위함 **/
                COMMON_FUNCTION.TOOL.DATA.setGlobalCardList(response);

                if(response.resultCode == "200"){
                    var cardList = response.cardMemberRnwResDto;

                    if(cardList){
                        for (card of cardList) {
                            const {cardImgUrl, milgMbrNo, crdTypeCd, redPoint} = card;
                            // 첫번째 EV 카드만 표출
                            if (EV_CARD_TYPE.includes(crdTypeCd)) {
                                $("#myCardCon").show();
                                //카드번호 정규식
                                const convertedMilgMbrNo = milgMbrNo.match(/[0-9*]{1,4}/g)?.join(' ');

                                $("#cardImg").attr('src', cardImgUrl);
                                $("#cardImg").css('width','100%');
                                $("#milgMbrNo").text(convertedMilgMbrNo);
                                $("#redPoint").text(comma.add(redPoint) || 0);

                                break;
                            }
                        }
                    }
                }

                resolve();
            });
        })
    },
    getSubscribeProduct: function(obj){

        console.log(JSON.stringify(obj))
        /*obj.productStatus = "O";
        obj.productName = "TEST 임시";
        obj.productStartDate = "20220621122247";
        obj.productExpireDate = "20220622123720";*/

        if(obj.productStatus && (obj.productStatus == "O" || obj.productStatus == "X" || obj.productStatus == "OE" || obj.productStatus == "OC")){
            var prdtStatus = obj.productStatus;
            var prdtName = obj.productName;
            var prdtStrtDt = obj.productStartDate && moment(obj.productStartDate).format("YYYY.MM.DD");
            var prdtEndDt = obj.productExpireDate && moment(obj.productExpireDate).format("YYYY.MM.DD");
            var prdtTxt = "";
            var prdtClass = "";

            if(prdtStatus == "O"){
                prdtTxt = "구독중";
            }else if(prdtStatus == "X"){
                prdtTxt = "미구독";
                prdtClass = "type2";
            }else if(prdtStatus == "OE"){
                prdtTxt = "해지예약";
                prdtClass = "type3";
            }else if(prdtStatus == "OC"){
                prdtTxt = "변경예약";
                prdtClass = "type3";
            }

            if(prdtStatus == "X"){
                $("#greenPassCon .history-box").html("<p>기아 그린패스에 가입되어 있지 않습니다.</p>");
            }else{
                $("#greenPassCon #prdtNm").text(prdtName);
                $("#greenPassCon #prdtDate").text(prdtStrtDt + " ~ " + prdtEndDt);
            }
            $("#greenPassCon #prdtStatus").addClass(prdtClass);
            $("#greenPassCon #prdtStatus").text(prdtTxt);
            $("#greenPassCon").show();
        }
    }, getChrgeTerms: function(flag){
            MPopup.confirm({
                message: "충전 로밍 서비스 약관이 변경되었습니다.\n서비스 이용을 위한 약관 동의 부탁드립니다.",
                buttons: ["확인", "취소"],
                callback: function (idx){
                    if(idx == 0){
                        MPage.html({
                            url : PATH_MANAGER.KIA_RNW_5E0_0000.path,
                            animate : "MODAL_UP",
                            param: {
                                justTerms: flag
                            }
                        });
                    }
                }
            });
    },
    setWeekChrgRpt: function(){
        return new Promise(function (resolve) {
            var startDate = moment().add('-7', 'day').format('YYYY-MM-DD');
            var endDate = moment().format('YYYY-MM-DD');

            //주간 충전 리포트
            var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                        : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);
            var sendData = {
                ci: encCi,
                startDate: startDate,
                endDate: endDate
            }

            MNet_SSC.httpSend({
                path: SSC_API.chargeSumList.url,
                sendData: sendData,
                callback: function(response){
                    if(response.resultCode == "0000"){

                        var slowColor = "#eaeaea";
                        var fastColor = "#eaeaea";

                        if(response.slowSpeedCount != "" && response.slowSpeedCount != "0"){
                            slowColor = "#f3c300";
                        }else{
                            response.slowSpeedCount = 0;
                        }

                        if(response.fastSpeedCount != "" && response.fastSpeedCount != "0"){
                            fastColor = "#5d7d2b";
                        }else{
                            response.fastSpeedCount = 0;
                        }

                        EV.chartData = [
                            { value: response.slowSpeedCount, name: '완속',itemStyle:{color:slowColor} },
                            { value: response.fastSpeedCount, name: '급속',itemStyle:{color:fastColor} }
                        ]

                        var slowRate = ((response.slowSpeedCount / response.totalCount) * 100).toFixed(1);
                        var fastRate = ((response.fastSpeedCount / response.totalCount) * 100).toFixed(1);
                        if(isNaN(slowRate)){
                            slowRate = 0;
                        }
                        if(isNaN(fastRate)){
                            fastRate = 0;
                        }

                        $("#srchDate").text("최근 7일 (" + startDate + " ~ " + endDate + ")");
                        $("#totalCount").text(response.totalCount + "회");
                        $("#chrgSpd01").text(slowRate + "%" + " (" + response.slowSpeedCount + "회)");
                        $("#chrgSpd02").text(fastRate + "%" + " (" + response.fastSpeedCount + "회)");
                        $("#evChargeAmount").text(response.evChargeAmount + "kwh");
                        $("#totalCost").text(((response.totalCost != "0") ? comma.add(response.totalCost) : 0) + "원");
                        $("#averageUnitPrice").text(((response.averageUnitPrice != "0") ? comma.add(response.averageUnitPrice) : 0) + "원");

                        //페이지 진입 시, 주간 충전 리포트가 최상위 메뉴(차량선택 제외)일 때, 차트 바로 그려주기 위함(2022-05-03 추가)
                        if($(".content-evtab .content-inner").find('section:visible').eq(1).attr('class') == "section-07"){
                            EV.setEvChart();
                        }
                    }

                    resolve();
                }
            })
        })
    },
    showEvCarSelectionPopup: function(parentPage){
        //EV차량만 노출시키기 위함
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_0E0_0000.path, function(){
            //var carList = PGV.car && PGV.car.myCarInfoListResDto;
            var carList = PGV.passData.car && PGV.passData.car.myCarInfoListResDto;
            var selectListOverlay = $(this);
            var selectList = selectListOverlay.find('.select-list');
            var htmlString = "";
            var evCarList = [];
            if(!isEmpty(carList)){
                for(var i = 0; i < carList.length; i++){
                    var curNode = carList[i];
                    /* 케이스마텍 추헌남 - vin 넘버가 없는 계약 차량은 선택 목록에서 제외 */
                    if (curNode && curNode.vin && curNode.vin.length > 0){
                        var curCarNickname = curNode.carAlias && (curNode.carAlias + " ") || "";
                        var curCarModelName = curNode.mdlNm && (curNode.mdlNm + " ") || "";
                        var curCarNumber = curNode.carRgstNo && curNode.carRgstNo;
                        var curMemEvYn = curNode.memEvYn;
                        //EV 차량만
                        if(curMemEvYn != "N"){

                            evCarList.push(curNode);
                            htmlString += (function(curCarNickname, carModelName, carNumber, curIndex){
                                var templateString =
                                        '<li>' +
                                            '<button type="button" class="btn-link" data-car-select-index="' + curIndex + '">' +
                                            curCarNickname + " " + carModelName + " " + carNumber +
                                            '</button>' +
                                        '</li>';
                                return templateString;
                            })(curCarNickname, curCarModelName, curCarNumber, i);
                        }
                    }
                }
                selectList.html(htmlString);

                RNW_UI.popupLayer_selectBox({selId : '#popup_0E0_0000'}); // 팝업열기

                $('[data-car-select-index]').off("click").on("click", function(){
                    var carList = PGV.passData.car && PGV.passData.car.myCarInfoListResDto;
                    var curIndex = $(this).data('car-select-index');
                    var curNode = carList[curIndex];
                    parentPage.currentScopeSelectCar = curNode;
                    COMMON_FUNCTION.TOOL.DATA.setCurrentScopeSelectCar(parentPage);

                    selectListOverlay.fadeOut('fast');
                    selectListOverlay.find('.popup-wrap').removeClass('is-ani');

                    $('body').removeClass('js-overflow-hidden');

                    KIA_RNW_500_0000.init();
                })
            }
        });
    },
    counterEv: function(){
        //배터리 충전 게이지, 숫자 카운터
        var $tg = $('.battery-info .gage-box');
        var $cnt = 0;
        var $eg = $tg.attr('data-eg');

        var $set_int = setInterval(countFn, 20);

        function countFn(){
            $cnt++;
            if($cnt > $eg){
                clearInterval($set_int);
            }else{
                $tg.find('.num em').text($cnt);
                $tg.find('.ico-battery span').css('width',$cnt + '%');
            }
        }
    },
    qrScan: function(){
        //iOS QR스캔 플러그인 사용 시 카메라 권한 체크가 되지 않아 별도 인터페이스 구형
        if(M.page.info("device.os") == "iOS"){
            var permitStatus = exWNCameraPermissionCheckForiOS();

            if (permitStatus == "Denied" || permitStatus == "Restricted"){
                MPopup.alert('카메라에 대한 권한 설정은 아이폰 > 설정 > Kia VIK 혹은 아이폰 > 설정 > 개인정보의 설정을 확인 해 주세요.');
                return;
            }else if (permitStatus == "NotDetermined"){
                return;
            }
        }

        /*
         * Qr코드/바코드 스캔
         * Qr코드/바코드를 스캔한다.
         *
         * M.plugin("qr").scan
         * @param {object} object 스캔을 위한 설정 정보
         * @param {bool} object.flash 플래시 사용 여부
         * @param {bool} object.fadeToggle 버튼 메뉴 애니메이션
         * @param {select} object.orientation 화면 방향 [DEFAULT:Manifest.xml에서 적용한 값,PORTRAIT:세로모드, 홈버튼이 아래인 세로 방향으로 회전 유지,LANDSCAPE:가로모드, 왼쪽 회전된 상태 유지,PORTRAIT|REVERSE:세로모드, 세로 방향만 허용, 회전 가능,LANDSCAPE|REVERSE:가로모드, 가로 방향만 허용, 회전 가능,ALL:모든 방향으로 허용]
         * @param {object} object.captureScale 캡쳐 범위 크기
         * @param {float} object.captureScale.width 가로 크기 (0~1.0)
         * @param {float} object.captureScale.height 세로 크기 (0~1.0)
         * @param {select} object.fileterType 바코드 타입 [NONE:제한없음,PARTIAL:PARTIAL,EAN8:EAN8,UPCE:UPCE,ISBN10:ISBN10,UPCA:UPCA,EAN13:EAN13,ISBN13:ISBN13,I25:I25,DATABAR:DATABAR,DATABAR_EXP:DATABAR_EXP,CODABAR:CODABAR,CODE39:CODE39,PDF417:PDF417,QRCODE:QRCODE,CODE93:CODE93,CODE128:CODE128]
         * @param {bool} object.useGuideLine 가이드 라인 표시 여부
         * @param {function} object.callback 스캔 결과 콜백 함수
         */
        M.plugin("qr").scan({
            flash:false,
            page: "CustomQRActivity",
            orientation:"PORTRAIT",
            filterType:"QRCODE",
            useGuideLine:false,
            callback:function(result){

                var status = result.status;


                if(status == "SUCCESS"){
                    try{
                        // 2023.12.11 QR scan 버그 수정
                        // var data = JSON.parse(result.text);
                        var data = typeof result.text == "string" ? JSON.parse(result.text) : result.text;

                        if(data.gid == undefined || data.bid == undefined || data.sid == undefined || data.cid == undefined ){
                            MPopup.confirm({
                               title : '알림',
                               buttons : ['닫기'],
                               message : "지원하지 않는 형식의 QR입니다. 다시 확인해주세요.",
                           });
                        }else {
                           // 파라미터 암호화
                            var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                                        : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);
                            var param = {ci : encCi };

                            // [STraffic] STraffic 회원 카드 정보 조회 (EV-교통카드 번호)
                            evCardKey(param, function(receivedData1){
                                param = { evTrafficCardNo : receivedData1.evTrafficCardNo
                                        ,   gid : data.gid
                                        ,   bid : data.bid
                                        ,   sid : data.sid
                                        ,   cid : data.cid };

                                // [STraffic] QR Read 처리 요청
                                readQrRequest(param, function(receivedData2){
                                    var code = receivedData2.resultCode;
                                    var msg = receivedData2.resultMessage;
                                    if(code != "0000"){
                                        MPopup.confirm({
                                           title : '알림',
                                           buttons : ['닫기'],
                                           message : msg+"("+code+")",
                                       });
                                    }else {
                                        MPopup.confirm({
                                          title : '알림',
                                          buttons : ['확인'],
                                          message : "인증이 완료되었습니다. 충전기를 확인해주세요. (최대 1분이 소요됩니다.)",
                                      });
                                   }
                                }, function(code, msg){
                                   MPopup.confirm({
                                       title : '알림',
                                       buttons : ['닫기'],
                                       message : msg+"("+code+")",
                                   });
                               });
                            }, function(code, msg){
                                MPopup.confirm({
                                    title : '알림',
                                    buttons : ['닫기'],
                                    message : msg+"("+code+")",
                                });
                            });
                        }
                    }catch(e){
                         MPopup.confirm({
                            title : '알림',
                            buttons : ['닫기'],
                            message : "지원하지 않는 형식의 QR입니다. 다시 확인해주세요.",
                        });
                    }
                }else if(status == "FAIL" && result.message.indexOf("Denied") > 0){
                    exWNHideIndicator();

                    if(M.page.info("device.os") == "iOS"){
                        MPopup.alert('카메라에 대한 권한 설정은 아이폰 > 설정 > Kia VIK 혹은 아이폰 > 설정 > 개인정보의 설정을 확인 해 주세요.');
                    }else{
                        MPopup.alert('카메라에 대한 권한 설정은 단말기 환경설정 > Kia VIK > 권한을 확인 해 주세요.');
                    }
                }else if(result.message != "canceled" && status != "CANCEL"){
                    MPopup.alert('카메라를 가져오는데 실패하였습니다.');
                }
            }
        });
    },
    AODbattery : function (){
        if(EV.gVals.AOD.agreeYn == "Y"){
            $("#targetSoc").show();
            $("#chrgSrchBtn").closest('.btn-block').show();

            /* evBattery 함수로부터 받아온 배터리 잔량 Start */
            //배터리 잔량
            var soc = EV.gVals.AOD.batteryStatus||"0";
            soc = Number(soc);
            //배터리 컬러
            var backColor = "";

            //충전 여부
            var batteryCharge = EV.gVals.AOD.batteryCharge;
            //차량 전송 시간
            var resTime = parseDate3(EV.gVals.AOD.regDtm)||moment();
            //배터리 잔량에 따른 문구
            var statusTxt = "";

            //배터리 잔량 background 컬러
            if(soc == 0){
                statusTxt = "<b>배터리 잔량이 없습니다. <br>배터리 성능을 위해 충전해 주세요.</b>";
            }else if(soc > 0 && soc <= 10){
                backColor = "#ea0029";
                statusTxt = "<b>배터리 잔량이 부족합니다. <br>가까운 충전소를 찾아보세요!</b>";
            }else if(soc > 10 && soc <= 50){
                backColor = "#f3c300";
                statusTxt = "<b>배터리 잔량이 조금 남았어요. <br>가까운 충전소를 찾아보세요!</b>";
            }else if(soc > 50 && soc <= 70){
                backColor = "#5d7d2b";
                statusTxt = "<b>원활한 운전을 위해 <br>미리 충전소를 예약해 보세요.</b>";
            }else if(soc > 70){
                backColor = "#5d7d2b";
                statusTxt = "<b>배터리 잔량이 충분해요. <br>오늘도 안전운전 하세요!</b>";

                //충전소 검색 미노출
                $("#chrgSrchBtn").closest('.btn-block').hide();
            }
            /* evBattery 함수로부터 받아온 배터리 잔량 End */


            /* 충전 상태별 노출 Start */
            if(batteryCharge == "Y"){

                statusTxt = "<b>배터리 충전중 입니다. <br>남은 시간까지 잠시 기다려 주세요.</b>";

                //목표 충전까지 남은 시간
                var timeTxt = "분";
                var remainTime = EV.gVals.AOD.remainTime||"-";

                $(".ico-battery").addClass('charging');
                $("#targetSoc").show();
                $("#chrgSrchBtn").closest('.btn-block').hide();
                $("#targetSoc dl:first").show();
                $("#targetSoc dl:first dd:last b").text(soc + "%");
                $("#targetSoc dl:last dd:last b").text(remainTime + timeTxt);

            }else{
                $(".ico-battery").removeClass('charging');
                $("#targetSoc").hide();
            }
            /* 충전 상태별 노출 End */

            var drvDist = EV.gVals.AOD.drvDistance||"-";
            //화면에 뿌릴 데이터
            $("#statusTxt").html(statusTxt);
            $("#chrgColor").css("background", backColor);
            $("#chrgColor").closest('.gage-box').attr('data-eg', soc);
            $("#updateTime").text(moment(resTime).format("YYYY년 MM월 DD일 HH:MM"));
            $("#chrgDte").text(drvDist+"km");
            $("#batteryCon").show();
            EV.counterEv();
        }else{
            $("#AODCon").show();
        }
    }
}


KIA_RNW_500_0000.init();

COMMON_FUNCTION.TOOL.MStatusControl.addMStatusFunction("onRestore", "KIA_RNW_500_0000", function(){
    if($("[data-tab-name=mykia-tab-EV]:visible").length > 0){
        //Home 진입은 무조건 실시간
        //KIA_RNW_500_0000.chkAuthPage();
        var flag = MData.param('flag');
        flag && MData.removeParam('flag');

        if(flag == 'NFC'){
            MPage.html({url: PATH_MANAGER.KIA_RNW_510_0000.path});
        }else if(flag == 'QR'){
            EV.qrScan();
        }else if(flag == 'CQR'){
            MPage.html({url: PATH_MANAGER.KIA_RNW_530_0000.path, animate: 'SLIDE_LEFT'});
        }else if(flag == 'CSS'){
            MPage.html({url: PATH_MANAGER.KIA_RNW_570_0000.path});
        }else if(flag == 'subscribe'){
            MPage.html({url: PATH_MANAGER.KIA_RNW_5F2_0000.path});
        }else if(flag == 'CHRGSTAT'){
            MPage.html({url: PATH_MANAGER.KIA_RNW_5B0_0000.path});
        }else if(flag == 'HISTORY'){
            MPage.html({url: PATH_MANAGER.KIA_RNW_560_0000.path});
        }
    }
})

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
/*var MStatus = {
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_500_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; */
