/**

 @파일명 : KIA_RNW_580_0000.js
 @작성자 :
 @생성일 : 2022.01.26
 @메뉴명 : 충전소 검색
 @DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] )
 *************************************************************************
 추천충전소 - 선택된 카테고리에 따라 show/hide
 가까운충전소 - 카테고리 선택 할 때마다 서버에서 데이터 조회 (2022-04-06 추가)
 *************************************************************************
 */
var CurrPage;
var pageSize = 100;
var totalCount = 0;
var KIA_RNW_500_1100 = {
    init: function(){
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        CurrPage.getCredit();
        //리스트 init
        CurrPage.getCreditUseList(1,pageSize);
        CurrPage.setEventListner();

        var parentThis = this;
        COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(this.handleLoadMore);
    },
    pageMeta: {
        nowPage: 1,
        pageSize: pageSize,
        stopLoadingMore: false,
        caseNo: "4"
    },

    setEventListner: function(){
        $('#oneWeek').off("click").on("click", function(){
            $('#oneWeek').addClass("active");
            $('#oneMonth').removeClass("active");
            $('#thMonth').removeClass("active");
            $('#oneYear').removeClass("active");
            $('#creditHistory').empty();
            CurrPage.getCreditUseList(1,pageSize,"1");

        })

        $('#oneMonth').off("click").on("click", function(){
            $('#oneWeek').removeClass("active");
            $('#oneMonth').addClass("active");
            $('#thMonth').removeClass("active");
            $('#oneYear').removeClass("active");
            $('#creditHistory').empty();
            CurrPage.getCreditUseList(1,pageSize,"2");
        })

        $('#thMonth').off("click").on("click", function(){
            $('#oneWeek').removeClass("active");
            $('#oneMonth').removeClass("active");
            $('#thMonth').addClass("active");
            $('#oneYear').removeClass("active");
            $('#creditHistory').empty();
            CurrPage.getCreditUseList(1,pageSize,"3");

        })

        $('#oneYear').off("click").on("click", function(){
            $('#oneWeek').removeClass("active");
            $('#oneMonth').removeClass("active");
            $('#thMonth').removeClass("active");
            $('#oneYear').addClass("active");
            $('#creditHistory').empty();
            CurrPage.getCreditUseList(1,pageSize,"4");
        })
    },
    getCredit: function(){
        MNet.httpSendAsync({
            path: _API.SVR.EV.evmng.sccCredit,
            sendData: {
                apiId: "RNW-EVC-5001",
                mbrId: PGV.loginInfo.mbrId
            },
            isMock: false
        }).then(function (response) {
            if(response.resultCode == "200"){

                var expireDate = response.expireDate;
                expireDate = expireDate.substring(0,10);
                expireDate = expireDate.replace(/-/gi,".");
                var expireExpectBalance = response.expireExpectBalance.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
                var balanceAmount = response.balanceAmount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
                var cumulativeUseCreditAmount = response.cumulativeUseCreditAmount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');

                $('#nowCash').text(balanceAmount);
                $('#exDate').text("(소멸 예정일 "+expireDate+")");
                $('#exCash').text(expireExpectBalance+"C");
                $('#sumCash').text(cumulativeUseCreditAmount+"C");

                return;

            }
        })
    },
    getCreditUseList: function(nowPage, pageSize, caseNo, loadMoreMode){
        var parentThis = this;
        if(isEmpty(caseNo)){
            caseNo = "4";
        }
        var toDay = CurrPage.getToday();
        var someDay = CurrPage.getSomeDay(caseNo);
        return new Promise(function(resolve, reject) {
            MNet.httpSendAsync({
                path: _API.SVR.EV.evmng.sccCreditUseList,
                sendData: {
                    apiId: "RNW-EVC-5002",
                    mbrId: PGV.loginInfo.mbrId,
                    startDate: someDay,
                    endDate: toDay,
                    currentPageNo: nowPage || 1,
                    recordsPerPage: pageSize || 100
                },
                isMock: false
            }).then(function (response) {

                if (response.resultCode == "200") {

                    var sscCreditUseList = response.sscCreditUseInfoList;

                    if (!isEmpty(sscCreditUseList)) {
                        totalCount = sscCreditUseList.length;
                    }
                    var totalAmount = response.totalAmount;

                    console.log("totalAmount === >> "+totalAmount);
                    $('#totalCount').text(totalCount);

                    var creditList = "";

                    if (sscCreditUseList && sscCreditUseList.length > 0) {

                        for (var i = 0; i < sscCreditUseList.length; i++) {

                            if (loadMoreMode) {
                                parentThis.pageMeta.nowPage++;
                                parentThis.pageMeta.caseNo = caseNo;
                            } else {
                                //1페이지 2번 호출을 방지하기 위함.(2022-06-14)
                                (nowPage == 1) && nowPage++;
                                parentThis.pageMeta.nowPage = nowPage;
                                parentThis.pageMeta.stopLoadingMore = false;
                                $('#creditHistory').empty();
                            }

                            var currentNode = sscCreditUseList[i];
                            var userCreditDate = currentNode.useCreditDate.substring(0, 10);
                            userCreditDate = userCreditDate.replace(/-/gi, ".");
                            var addCreditAmount = currentNode.addCreditAmount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
                            addCreditAmount = "+" + addCreditAmount;
                            var useCreditAmount = currentNode.useCreditAmount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',');
                            useCreditAmount = "-" + useCreditAmount;

                            //memo값 사용이 아닌 name 값이 변경되어 표시 된다고 전달 받음 22-10-13

                            creditList += '<li>';
                            creditList += '<p class="date">' + userCreditDate + '</p>';
                            creditList += '<div class="cont">';
                            creditList += '<p class="tit">' + currentNode.name + '</p>';
                            if (currentNode.amountSe == "3") {
                                creditList += '<strong class="amount">' + addCreditAmount + 'C</strong>';
                            } else if (currentNode.amountSe == "4") {
                                creditList += '<strong class="amount">' + useCreditAmount + 'C</strong>';
                            } else if (currentNode.amountSe == "5") {
                                creditList += '<strong class="amount">' + useCreditAmount + 'C</strong>';
                            } else if (currentNode.amountSe == "E") {
                                creditList += '<strong class="amount">' + useCreditAmount + 'C</strong>';
                            }
                            creditList += '</div>';
                            creditList += '</li>';

                        }
                    } else {
                        if (loadMoreMode) {
                            parentThis.pageMeta.stopLoadingMore = true;
                        }else{
                            creditList = '<li>'
                            creditList +=    '<p>'
                            creditList +=        '해당 기간 내 크레딧 조회 내역이 없습니다.'
                            creditList +=    '</p>'
                            creditList += '</li>'
                        }
                    }

                    $('#creditHistory').append(creditList);

                }else{
                    creditList = '<li>'
                    creditList +=    '<p>'
                    creditList +=        '해당 기간 내 크레딧 조회 내역이 없습니다.'
                    creditList +=    '</p>'
                    creditList += '</li>'

                    $('#creditHistory').append(creditList);
                }

                COMMON_FUNCTION.TOOL.UI.setBottomReachedEventListener(parentThis.handleLoadMore);
                exWNHideIndicator();
                resolve();
            })
        })
    },
    getToday: function(){
        var today = new Date();

        var year = today.getFullYear();
        var month = ('0' + (today.getMonth() + 1)).slice(-2);
        var day = ('0' + today.getDate()).slice(-2);

        var dateString = year + '-' + month  + '-' + day;

        return dateString;

    },
    getSomeDay: function(caseNo){
        var toDay = new Date();
        var Dday = "";
        if(caseNo == "1"){
            Dday = new Date(toDay.setDate(toDay.getDate() - 7));	// 일주일 전
        }else if(caseNo == "2"){
            Dday = new Date(toDay.setMonth(toDay.getMonth() - 1));	// 한달 전
        }else if(caseNo == "3") {
            Dday = new Date(toDay.setMonth(toDay.getMonth() - 3));	// 세달 전
        }else if(caseNo == "4") {
            Dday = new Date(toDay.setFullYear(toDay.getFullYear() - 1));	// 일년 전
        }

        var year = Dday.getFullYear();
        var month = ('0' + (Dday.getMonth() + 1)).slice(-2);
        var day = ('0' + Dday.getDate()).slice(-2);

        var DdayAgo = year + '-' + month  + '-' + day;

        return DdayAgo;
    },
    setPublisherEventListener: function(){
        // ------------------------------
        // 	Scroll
        // ------------------------------
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        var $tabsContTop = $('.tabs-cont').offset().top;

        $(window).scroll(function(e) {
            var $nowTop = $(this).scrollTop();

            // 스크롤시 탭영역 고정
            if ($nowTop >= ($tabsContTop - $headerHeight)) {
                $('.wrapper').addClass('is-top-fixed');
                $('.tabs-cont').addClass('top-fixed-area');
            }
            else {
                $('.wrapper').removeClass('is-top-fixed');
                $('.tabs-cont').removeClass('top-fixed-area');
            }

            $winTop = $nowTop;

        });
    },
    handleLoadMore: function(){
        if(!KIA_RNW_500_1100.pageMeta.stopLoadingMore){
            var nowPage = KIA_RNW_500_1100.pageMeta.nowPage;
            var pageSize = KIA_RNW_500_1100.pageMeta.pageSize;
            var caseNo = KIA_RNW_500_1100.pageMeta.caseNo;
            KIA_RNW_500_1100.getCreditUseList(nowPage, pageSize, caseNo, true);
        }
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_500_1100.init();
    },
    onHide : function(event){},
    onRestore : function(event){},
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    // onBack : function(){},
    onDestroy : function(event){},
    onPause : function(event){},
    onResume : function(event){}
};
