/**

@파일명 : KIA_RNW_510_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : NFC 태깅 팝업 
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage;
var nfcTimerFlag = false;
var reTry = 0;
var KIA_RNW_510_0000 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        var pageInit = function(){
            setUIEvent();

            nfcAuthorChk();
        }

        pageInit();
    },
    setEventListner: function(){
        // do something..
    }
}

/**
 * @name        : setUIEvent
 * @description : UI에서 사용하는 이벤트 및 초기설정 수행
 * @date        : 2021.06.21
 * @author      : 네이버시스템-강보경
 */
var setUIEvent = function(){
//    $("#btn-close").on("click", function(){
//    //    MPage.remove("../1000/KIA_MOB_1000_1000.html");
//        MPage.back({
//            animation : "SLIDE_RIGHT"});
//    });

    $(".animate-area div a").click(function(){
        $(".machineAnimate").toggleClass("on");
        $(".cardAnimate").toggleClass("on");
        if($(".cardAnimate").hasClass("on")){
            $(".animate-area div a").text("가이드 보기");
        }else{
            $(".animate-area div a").text("가이드 닫기");
        }
    })

    $(".btn-close").on("click", function(){
        exWNNFCDisable();
//        exWNStopVibration();
        MPage.back({
            animate : "SLIDE_RIGHT"
        });
//        $(".btn-close").click();
    });
};

/**
 * @name        : nfcAuthorChk
 * @description : NFC 권한 결과에 따른 action
 * @date        : 2021.06.21
 * @author      : 네이버시스템-강보경
 */
var nfcAuthorChk = function(){

    // [Native] NFC Init (return: NFC Permission)
    var nfcAuthor = exWNNFCModuleInit();

    // "t" 정상
    if(nfcAuthor == "t"){
        reTry = 0;
        // 파라미터 암호화
        var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                    : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);
        var param = {ci : encCi };

        // [STraffic] STraffic 회원 카드 정보 조회 (EV-교통카드 번호)
        evCardKey(param, function(receivedData){
            var cardKey = receivedData.evTrafficCardNo;

            // [Native] NFC 인증요청
            exWNCardAuthenticate(cardKey, 'V'); // real:'VIK'
//            exWNCardAuthenticate('2095257001644568', 'V' ); // real:'VIK'
            // [STraffic] OTP QR 생성
        }, function(code, msg){
            MPopup.confirm({
                title : '알림',
                message : msg+"("+code+")",
                buttons : ['닫기'],
                callback : function(idx){
                    MPage.back({
                        animate : "SLIDE_RIGHT",
                    });
                }
            });
        });
    }else if(nfcAuthor == "p"){
    // "p" 권한없음
        reTry = 0;

        // 2024.01.09 아래 정의 되지 않은 options 으로 인해 에러 발생
        // sendSTrafficApiErrorLog(options.path, errorCode, errorMessage, options.backup, options.sendData, PGV.loginInfo ? PGV.loginInfo.accessToken : "");

        MPopup.confirm({
            title : '모바일 결제 설정',
            message : "NFC로 결제 하시려면 설정으로 이동하셔서 기본 모바일 결제 서비스로 설정하시거나 \'현재 열려있는 앱으로 결제\' 기능을 켜주세요.",
            buttons : [ '설정으로 이동', '결제 취소'],
            callback : function(idx){
                if(idx == 0){
                    // 설정버튼 클릭 시
                    // [Native] NFC 권한 설정 이동
                    exWNShowPermissionSetting();
                }else {
                    // 취소 클릭 시
                    MPage.back({
                        animate : "SLIDE_RIGHT",
                    });
                }
            }
        });
    }else if(nfcAuthor == "d"){
    // "d" NFC활성화 안됨

        reTry = 0;

        MPopup.confirm({
            title : '모바일 결제 설정',
            message : "NFC로 결제 하시려면 설정으로 이동하셔서 NFC를 활성화해주세요.",
            buttons : [ '설정으로 이동', '결제 취소'],
            callback : function(idx){
                if(idx == 0){
                    // 설정버튼 클릭 시
                    // [Native] NFC 활성화를 설정할 수 있는 페이지로 이동
                    exWNNFCEnableSetting();
                }else {
                    // 취소 클릭 시
                    MPage.back({
                        animate : "SLIDE_RIGHT",
                    });
                }
            }
        });
    }else if(nfcAuthor == "e"){
        if(reTry < 3){
            MPopup.confirm({
                title   : '알림',
                message : 'NFC인증 중 문제가 발생했습니다.\n다시 호출하겠습니다.',
                callback : function(idx){
                    if(idx ==1){
                        reTry = reTry +1;
                        nfcAuthorChk();
                    }
                }
            });
        }else{
            reTry = 0;

            //NFC를 지원하지 않는 단말
            M.pop.alert({
                title   : '알림',
                message : '해당 기기는 NFC인증을 지원하지 않습니다.',
                buttons : [ '닫기'],
                callback : function(){
                    MPage.back({
                        animate : "SLIDE_RIGHT"
                    });
                }
            });
        }
    }else{
        if(reTry <3){
            reTry = reTry +1;
            setTimeout(function(){nfcAuthorChk()},500);
        }else{
            reTry = 0;

            //NFC를 지원하지 않는 단말
            M.pop.alert({
                title   : '알림',
                message : '해당 기기는 NFC인증을 지원하지 않습니다.',
                buttons : [ '닫기'],
                callback : function(){
                    MPage.back({
                        animate : "SLIDE_RIGHT"
                    });
                }
            });
        }
    }

};

/**
 * @name        : onNFCAuthenticate
 * @description : NFC 인증결과
 * @date        : 2021.06.21
 * @author      : 네이버시스템-강보경
 */
var onNFCAuthenticate= function(result, msg){

    result = result.toLowerCase();
//    console.log(result);
    if(result == 't'){
        if(!nfcTimerFlag){
            nfcTimerFlag = true;
            startTimer();
        }else{
            MPage.back({
                animate : "SLIDE_RIGHT"
            });
        }
    }else {
        M.pop.alert({
            title   : '알림',
            message : msg,
            buttons : [ '돌아가기'],
            callback : function(){
                MPage.back({
                    animate : "SLIDE_RIGHT"
                });
            }
        });
    }
}

/**
 * @name        : onNFCTagInfo
 * @description : NFC 태그결과
 * @date        : 2021.06.21
 * @author      : 네이버시스템-강보경
 */
var onNFCTagInfo= function(result){
     MPage.back({
         animate : "SLIDE_RIGHT",
     });
}

/**
 * @name        : startTimer
 * @description : 50초 타이머 실행
 * @date        : 2021.06.21
 * @author      : 네이버시스템-강보경
 */
var startTimer = function(){
    var time = 49;

    $(".animatePath").show();

    // 50초 타이머 생성 및 매 초 반복
    var timer = function(){
        setTimeout(function(){
            $("#sec").text(time);

            if(time > 0){
                time = time-1;
                timer();
            }else {
                // [Native] NFC 및 바이브레이션 비활성화
                exWNNFCDisable();
                MPage.back({
                    animate : "SLIDE_RIGHT",
                });
            }

        }, 1000);
    };

    timer();
};

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_510_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    onBack : function(){
        // [Native] NFC 및 바이브레이션 비활성화
        exWNNFCDisable();
        //exWNStopVibration();
        MPage.back({
            animate : "SLIDE_RIGHT"
        });
    },
    onDestroy : function(event){}, 
    onPause : function(event){
        // [Native] NFC 및 바이브레이션 비활성화
        exWNNFCDisable();
        exWNStopVibration();
    },
    onResume : function(event){
        nfcAuthorChk();
    }
}; 
