/**

@파일명 : KIA_RNW_540_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전 예약 현황 
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_540_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        garbageAll();

        //set evt
        CurrPage.setEventListner();

        //예약 현황 조회
        CurrPage.getResvSttusList()
        .then(function(){
            exWNHideIndicator();
        });
    },
    pageNo: 1,
    setEventListner: function(){

        //scroll evt
        CurrPage.scrollEvt();

        //검색 조건 필터
        $("#statusCd button").on("click",function(){
            //페이지 번호 및 스크롤(T/F) 초기화
            CurrPage.pageNo = 1;
            CurrPage.scrollIsOk = true;

            var statusCd = $(this).data('status-cd');

            CurrPage.getResvSttusList(statusCd)
            .then(function(){
                exWNHideIndicator();
            });
        });

        //충전소 예약 상세 가기
        $("#dummyDivCon dt button").on("click",function(){
            var options = {
                url: PATH_MANAGER.KIA_RNW_541_0000.path,
                param: {
                    name : $(this).data('name'),
                    daddr : $(this).data('daddr'),
                    connectType : $(this).data('connectType'),
                    operTime: $(this).data('operTime'),
                    rsvDayTxt: $(this).data('rsvDayTxt'),
                    cid: $(this).data('cid'),
                    rsvNo : $(this).data('rsvNo'),
                    rsvGubun : $(this).data('rsvGubun')
                }
            }
            MPage.html(options);
        });
    },
    scrollIsOk: true,
    scrollEvt: function(){
        $(window).scroll(function(){
            var $ws = $(window).scrollTop();
            var $wh = $(window).height();
            var $dh = $(document).height();

            if(Math.floor($ws) == $dh - $wh){
                if(CurrPage.scrollIsOk){
                    CurrPage.scrollIsOk = false;
                    ++CurrPage.pageNo;
                    //카테고리 상태코드 조회
                    var statusCd = $("#statusCd .active").data('status-cd');

                    CurrPage.getResvSttusList(statusCd)
                    .then(function(){
                        exWNHideIndicator();
                    });

                }
            }
        });
    },
    getResvSttusList: function(statusCd){
        return new Promise(function (resolve) {

            console.log(statusCd)
            // [STraffic] STraffic 충전 예약 현황 조회
            var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                    : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);

            var sendData = {
                ci: encCi,
                currentPageNo: CurrPage.pageNo,
                recordsPerPage: 10,
                reservationStatus: (typeof statusCd != 'undefined' ? statusCd : "")
            }

            MNet_SSC.httpSend({
                path: SSC_API.evChrgrResvReqList.url,
                sendData: sendData,
                callback: function(response){
                    console.log(JSON.stringify(response))

                    if(response.resultCode == "0000"){

                        var rsvList =  response.reservationInfoList;

                        //초기화
                        if(CurrPage.pageNo == 1){
                            $("#chrgList").html('');
                        }

                        if(rsvList.length > 0){
                            //스크롤 시 다음 데이터를 불러오기 위함
                            CurrPage.scrollIsOk = true;

                            var dlCon = $("#dummyDivCon dl").clone(true);
                            $(".nodata-area").hide();

                            rsvList.forEach(function(item){
                                var tmpDlCon = $(dlCon).clone(true);
                                var rsvCdNm = "";
                                var rsvGubun = "";
                                //운영 시간
                                var operTime = moment(item.useStartTime,'HHmm').format('HH:mm') + " ~ " + moment(item.useEndTime,'HHmm').format('HH:mm');
                                //날짜 형식
                                var rsvDate = moment(item.reservationDate).format('YYYY.MM.DD');
                                var day = changeDate(rsvDate.replace(/\./g, ""));
                                var rsvDayTxt = rsvDate + " " + day + " " + item.reservationTime;

                                // 예약상태코드
                                if (item.reservationStatusCode == '88' || item.reservationStatusCode == '08' || item.reservationStatusCode == '18'){
                                    rsvCdNm = "취소";
                                    rsvGubun = "1";
                                    $(tmpDlCon).addClass('off');
                                }else{
                                    rsvCdNm = "이용";
                                    //방문 일정이 현재~미래일 경우 구분,
                                    var nowTime = moment().format('YYYY.MM.DD HH:mm');
                                    var compTime = rsvDate + " " + item.reservationTime;
                                    console.log(nowTime)
                                    console.log("----------------------------")
                                    console.log(compTime)
                                    if(nowTime < compTime){
                                        rsvGubun = "2";
                                    }else{
                                        rsvGubun = "3";
                                    }
                                }

                                $(tmpDlCon).find('dt').find('.text-scale-04 b').text(item.name);
                                //충전소 상세 팝업에 전송할 파라미터
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('name', item.name);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('daddr', item.daddr);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('connectType', item.connectType);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('operTime', operTime);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('rsvDayTxt', rsvDayTxt);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('cid', item.cid);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('rsvNo', item.reservationNo);
                                $(tmpDlCon).find('dt').find('.text-scale-04 button').data('rsvGubun', rsvGubun);

                                $(tmpDlCon).find('dd').find('.cell-01 em').text(rsvDayTxt);
                                $(tmpDlCon).find('dd').find('.cell-02 em').text(rsvCdNm);

                                $("#chrgList").append(tmpDlCon);
                            });
                        }else{
                            //다음페이지 데이터가 없을 경우를 대비
                            if($("#chrgList dl").length < 1){
                                $(".nodata-area").show();
                            }
                        }
                    }else{
                        //데이터가 없을 경우를 대비
                        if($("#chrgList dl").length < 1){
                            $("#chrgList").html('');
                            $(".nodata-area").show();
                        }
                    }

                    resolve();
                }
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_540_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
