/**

@파일명 : KIA_RNW_541_0000.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전소 예약 내역 상세
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[X]	내연보유[X]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_541_0000 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        //set evt
        CurrPage.setEventListner();

        //이전 페이지에서 받아온 데이터 화면에 뿌리기
        CurrPage.setDataInit();
    }, 
    setEventListner: function(){

        //예약 취소
       $(".btn-block button").on("click", function(){
            MPopup.confirm({
                message: "충전 예약을 취소하시겠습니까?",
                buttons: ["네", "아니오"],
                callback: function (idx){
                    if(idx == 0){
                        //삭제
                        CurrPage.reservCancle();
                    }
                }
            });
        })
    },
    setDataInit: function(){

        var name = MData.param('name');
        var daddr = MData.param('daddr');
        var connectType = MData.param('connectType');
        var operTime = MData.param('operTime');
        var rsvDayTxt = MData.param('rsvDayTxt');
        var cid = MData.param('cid');
        var rsvGubun = MData.param('rsvGubun');
        var subTit = "";

        if(rsvGubun == "1"){
            subTit = "예약이 취소된 내역입니다.";
        }else if(rsvGubun == "2"){
            subTit = "예약된 충전소 내역이 있습니다.<br>방문 일정을 확인해 주세요.";
            $(".btn-block").show();
        }else if(rsvGubun == "3"){
            subTit = "이용이 완료된 내역입니다.";
        }

        $("#subTit").html(subTit);
        $("#name").text(name);
        $("#daddr").text(daddr);
        $("#cid").text(cid);
        $("#operTime").text(operTime);
        $("#rsvDayTxt").text(rsvDayTxt);

        //충전기 타입 코드에 따라 아이콘 활성화
        var arrType = connectType.split(",");
        arrType.forEach(function(type){
            if(type == "01"){
                $(".ico-charge2").addClass('active');
            }else if(type == "02"){
                $(".ico-charge4").addClass('active');
            }else if(type == "03"){
                $(".ico-charge2, .ico-charge3").addClass('active');
            }else if(type == "04"){
                $(".ico-charge1").addClass('active');
            }else if(type == "05"){
                $(".ico-charge1, .ico-charge2").addClass('active');
            }else if(type == "06"){
                $(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
            }else if(type == "07"){
                $(".ico-charge3").addClass('active');
            }
        });
    },
    reservCancle: function(){

        var param = {
            reservationNo : MData.param('rsvNo')
        }

        canclEvChrgrResv(param, function(receivedData){
            console.log(receivedData);
            MPopup.alert({
                message : "충전 예약이 취소되었습니다."
                , callback : function(index){
                    MPage.html({url: PATH_MANAGER.KIA_RNW_540_0000.path});
                }
            });
        }, function(code, msg){
            MPopup.alert(msg);
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_541_0000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
