/**

@파일명 : KIA_RNW_550_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 나만의 충전소 
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_550_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        //set evt
        CurrPage.setEventListner();

        //나만의 충전소 조회
        CurrPage.getMyStationList()
        .then(function(){
            exWNHideIndicator();
        });
    }, 
    setEventListner: function(){

        //주소 복사 evt
        $(".btn-copy").on("click", function(){
            //주소 복사
            COMMON_FUNCTION.TOOL.UI.copyToClipboard($(this).closest("p"), "복사되었습니다.");
        });

        //위치전송 팝업
        $(".btn-send").on("click", function(){
            var stationName = $(this).data('stationName');
            var stationCoord = {
                lat : $(this).data('lat'),
                lng : $(this).data('lng')
            }
            CurrPage.onClickSendLocation(stationName, stationCoord);
        });


        //충전소 상세보기
        $(".btn-arrow-right").closest('.text-scale-04').find('b, button').on("click",function(){

            var bid = $(this).closest('dt').data('bid');
            var sid = $(this).closest('dt').data('sid');
            var lat = $(this).closest('dt').data('lat');
            var lng = $(this).closest('dt').data('lng');

            if(!(lat && lng)){
                MPopup.alert("위치정보가 존재하지 않습니다.");
                return false;
            }

            var options = {
                url: PATH_MANAGER.KIA_RNW_583_0000.path,
                param: {
                    bid: bid,
                    sid: sid,
                    lat: lat,
                    lng: lng
                },
                animate : "MODAL_UP"
            }

            MPage.html(options);
        });
    },
    pageNo: 1,
    scrollIsOk: true,
    scrollEvt: function(){
        $(window).scroll(function(){
            var $ws = $(window).scrollTop();
            var $wh = $(window).height();
            var $dh = $(document).height();

            if(Math.floor($ws) == $dh - $wh){
                if(CurrPage.scrollIsOk){
                    CurrPage.scrollIsOk = false;
                    ++CurrPage.pageNo;
                    CurrPage.getMyStationList()
                    .then(function(){
                        exWNHideIndicator();
                    });
                }
            }
        });
    },
    getMyStationList: function(){
        return new Promise(function (resolve) {
            var sendData = {
                apiId: 'RNW-EVC-1001',
                mbrId: PGV.loginInfo.mbrId,
                currentPageNo: CurrPage.pageNo,
                pageSize: 10
            }

            MNet.httpSendAsync({
                path: _API.SVR.EV.evCharger.schEvChargerFavoriteList,
                sendData: sendData,
                isMock: false
            }).then(function (response) {
                console.log(JSON.stringify(response))

                if(response.resultCode == "200"){
                    var myChgrList = response.evMyChgrSchRnwResDto;
                    $("#myStationCon").html('');

                    if(myChgrList.length > 0){
                        //스크롤 시 다음 데이터를 불러오기 위함
                        CurrPage.scrollIsOk = true;

                        var dlCon = $("#dummyDlCon").clone(true);
                        $("section .mycharg-cont").show();
                        $("section .inner-info").show();
                        $("section .nodata-area").hide();

                        myChgrList.forEach(function(item){
                            var tmpDlCon = $(dlCon).clone(true);

                            //충전소 상세보기를 위한 데이터 담기
                            $(tmpDlCon).find('dt').data('bid',item.bid);
                            $(tmpDlCon).find('dt').data('sid',item.sid);
                            $(tmpDlCon).find('dt').data('lat',item.lat);
                            $(tmpDlCon).find('dt').data('lng',item.lng);

                            $(tmpDlCon).find('dt em').text(item.bName);
                            $(tmpDlCon).find('dt .text-scale-04 b').text(item.name);

                            var tmpBtn = $(tmpDlCon).find('dd .btn-copy').clone(true);
                            $(tmpDlCon).find('dd p').text(item.dAddr ? item.dAddr  : "");
                            $(tmpDlCon).find('dd p').append(tmpBtn);

                            //위치전송 버튼에 데이터 담기
                            $(tmpDlCon).find('dd .btn-send').data('stationName', item.name);
                            $(tmpDlCon).find('dd .btn-send').data('lat', item.lat);
                            $(tmpDlCon).find('dd .btn-send').data('lng', item.lng);

                            $(tmpDlCon).show();
                            $("#myStationCon").append(tmpDlCon);
                        });

                    }else{
                        //다음페이지 데이터가 없을 경우를 대비
                        if($("#myStationCon dl").length < 1){
                            $("section .mycharg-cont").hide();
                            $("section .inner-info").hide();
                            $("section .nodata-area").show();
                        }
                    }
                }else{
                    //통신 오류 시,
                    $("section .mycharg-cont").hide();
                    $("section .inner-info").hide();
                    $("section .nodata-area").show();
                }
            })

            resolve();
        })
    },
    onClickSendLocation: function(stationName, stationCoord){
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_242_1000.path, function () {
            var parentThis = this;
            var closePopup = function (e, parentThis) {
                e.preventDefault();

                parentThis.fadeOut('fast');
                parentThis.find('.popup-wrap').removeClass('is-ani');

                $('body').removeClass('js-overflow-hidden');
            }
            this.find("ul li").off("click").on("click", function (e) {
                var targetApp = $(this).data('target-app');
                switch(targetApp){
                    case "kakaomap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('k', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "tmap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('t', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "kia-connect":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('kc', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                }
                closePopup(e, parentThis);
            })
            this.find('#mykia-close-popup').off("click").on("click", function (e) {
                closePopup(e, parentThis);
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_550_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        //나만의 충전소 조회
        CurrPage.getMyStationList()
        .then(function(){
            exWNHideIndicator();
        });
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
