/**

@파일명 : KIA_RNW_560_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 :  충전 내역
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_560_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        //set evt
        CurrPage.setEventListner();

        //충전 완료 정보 합계 조회
        CurrPage.getChrgSum()
        .then(function(){
            //충전 완료 정보 목록 조회
            return CurrPage.getChrgList();
        })
        .then(function(){
            exWNHideIndicator();
        })

    }, 
    setEventListner: function(){

        //슬라이더 evt
        CurrPage.setSliderEvt();

        //scroll evt
        CurrPage.scrollEvt();

        //조회 기간evt
        $("#dataGb button").on("click", function(){
            //페이지 번호 및 스크롤(T/F) 초기화
            CurrPage.pageNo = 1;
            CurrPage.scrollIsOk = true;

            var dateCnt = $(this).data('datecnt');
            CurrPage.dateCnt = dateCnt;

            //충전 완료 정보 합계 조회
            CurrPage.getChrgSum()
            .then(function(){
                //충전 완료 정보 목록 조회
                return CurrPage.getChrgList();
            })
            .then(function(){
                exWNHideIndicator();
            })
        })
    },
    pageNo: 1,  //현재 페이지
    scrollIsOk: true,
    scrollEvt: function(){
        $(window).scroll(function(){
            var $ws = $(window).scrollTop();
            var $wh = $(window).height();
            var $dh = $(document).height();

            if(Math.floor($ws) == $dh - $wh){
                if(CurrPage.scrollIsOk){
                    CurrPage.scrollIsOk = false;
                    ++CurrPage.pageNo;

                    CurrPage.getChrgList()
                    .then(function(){
                        exWNHideIndicator();
                    })
                }
            }
        });
    },
    dateCnt: 14,    //조회할 날짜 카운트(default 2주:14일)
    setSliderEvt: function(){
        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)
            _sliderFilterList.slideTo(getSlideIdx, 300, false);
            $('.slider-filter-list').find('.active').removeClass('active');
            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
        });
    },
    getChrgSum: function(){
        return new Promise(function (resolve, reject) {
            //종료날짜(오늘)
            var endDate = moment().format('YYYY-MM-DD');
            //시작날짜(오늘-dateCnt)
            var startDate = moment(endDate).add(-CurrPage.dateCnt,'day').format('YYYY-MM-DD');

            // [STraffic] STraffic 충전 내역 조회
             var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                    : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);

            var sendData = {
                ci: encCi,
                startDate: startDate,
                endDate: endDate
            }

            MNet_SSC.httpSend({
                path: SSC_API.chargeSumList.url,
                sendData: sendData,
                callback: function(response){
                    console.log(JSON.stringify(response))

                    if(response.resultCode == "0000"){
                        $("#totalCost").text(comma.add(response.totalCost) || "0");
                        $("#pointUseCost").text(comma.add(response.pointUseCost) || "0");
                        $("#evChargeAmount").text(response.evChargeAmount || "0");
                        $("#totalCount").text((response.totalCount || "0") + "건");

                        //AS-IS: totalCount == 0 으로 데이터 존재 유무 비교
                        if(response.totalCount != "0"){
                            $("#chrgList").html('');
                        }else{
                            $("#chrgList").hide();
                            $(".nodata-area").show();
                        }
                    }else{
                        $("#chrgList").hide();
                        $(".nodata-area").show();
                    }

                    resolve();
                }
            })
        })
    },
    getChrgList: function(){
        return new Promise(function (resolve) {
            //종료날짜(오늘)
            var endDate = moment().format('YYYY-MM-DD');
            //시작날짜(오늘-dateCnt)
            var startDate = moment(endDate).add(-CurrPage.dateCnt,'day').format('YYYY-MM-DD');

            // [STraffic] STraffic 충전 내역 조회
            var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                    : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);

            //충전 완료 정보 목록 조회
            var sendData = {
                ci: encCi,
                startDate: startDate,
                endDate: endDate,
                currentPageNo: CurrPage.pageNo,
                recordsPerPage: 10,
                sorting: "D"
            }

            console.log(JSON.stringify(sendData))
            MNet_SSC.httpSend({
                path: SSC_API.chargeInfoList.url,
                sendData: sendData,
                callback: function(response){
                    console.log(JSON.stringify(response))
                    if(response.resultCode == "0000"){
                        var dataHtml = "";
                        var chrgList = response.chargeUseInfo;
                        if(chrgList.length > 0){

                            $(".nodata-area").hide();

                            if(CurrPage.pageNo == 1){
                                $("#chrgList").html('');
                            }

                            CurrPage.scrollIsOk = true;

                            chrgList.forEach(function(item){
                                dataHtml += "<div class='div-item'>"
                                dataHtml +=     "<div class='place'>"
                                dataHtml +=         "<span>" + parseDate2(item.evChargeCompleteDate) + "</span>"
                                dataHtml +=         "<strong>" + item.evStationName + "</strong>"
                                dataHtml +=     "</div>"
                                dataHtml +=     "<dl>"
                                dataHtml +=         "<dt>충전금액</dt>"
                                dataHtml +=         "<dd><em>" + (comma.add(item.totalCost) || 0) + "</em>원</dd>"
                                dataHtml +=     "</dl>"
                                dataHtml +=     "<dl>"
                                dataHtml +=         "<dt>사용포인트</dt>"
                                dataHtml +=         "<dd><em>" + (comma.add(item.pointUseRequestCost) || 0) + "</em>P</dd>"
                                dataHtml +=     "</dl>"
                                dataHtml +=     "<dl>"
                                dataHtml +=         "<dt>충전량</dt>"
                                dataHtml +=         "<dd><em>" + item.evChargeAmount + "</em>kWh</dd>"
                                dataHtml +=     "</dl>"
                                dataHtml += "</div>";

                            })

                            $("#chrgList").append(dataHtml);
                            $("#chrgList").show();
                        }
                    }

                    resolve();
                }
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_560_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
