/**

@파일명 : KIA_RNW_570_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전서비스 설정 
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_570_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //set evt
        CurrPage.setEventListner();

        Promise.all([
            //ev point 조회
            CurrPage.getPointInfo(),
            //ev카드 정보 조회
            CurrPage.getCardInfo()
        ])
        .then(function(){
            exWNHideIndicator();
        })

    }, 
    setEventListner: function(){
        //포인트 사용 evt
        CurrPage.setPointEvt();

        //차감 비율 저장
        $("#saveRate").on("click", function(){
            CurrPage.setPointRate();
        });

        //카드 변경
        $("#chngCard").on("click", function(){
            MPage.html({
                url: PATH_MANAGER.KIA_RNW_5E1_0000.path,
                param : {
                    isChgCard : "Y"
                }
            });
        });
    },
    setPointEvt: function(){

        $('.content-evtab .service-cont .switch-cont input').on('click', function(){
            var $this = $(this);
            if($this.prop('checked')){
                $this.closest('.div-item').find('.point-range-box').css('display','block');
            }else{
                $this.closest('.div-item').find('.point-range-box').css('display','none');
            }

            //포인트 사용 유무 변경 시, 해당 값 저장하기 위함. (2022-05-26)
            CurrPage.setPointRate("txtPointYn");
        });

        // 포인트 사용율 슬라이드
        $(function(){
            var $handle = $('.point-range-slider .ui-slider-handle');
            var $num = $('.range-num');

            $('.point-range-slider .graph').slider({
                min: 10,
                step: 10,
                create: function(){
                    $num.text($(this).slider('value'));
                },
                change: function(){

                    var val = $(this).slider('value');

                    $num.text(val);
                    if(val <15){
                        $('.graph-fill').attr('style','width:' + (val - 10) + '%');
                    }else if(val <51){
                        $('.graph-fill').attr('style','width:' + (val - 8) + '%');
                    }else{
                        $('.graph-fill').attr('style','width:' + val + '%');
                    }
                }
            });
        });
    },
    getPointInfo: function(){
        return new Promise(function(resolve){
            var encCi = CONFIG.IS_DEV ? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                       : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);
            var param = {ci : encCi};

            //기아 멤버스 포인트 사용 기준 정보 조회
            getPointCriteria(param, function(useYn, usePercent){
                console.log(useYn)
                console.log(usePercent)

                if(useYn){
                    $(".graph").slider("value", usePercent);
                    if(useYn == "Y"){
                        $("#chkOption1").prop('checked', true);
                        $("#chkOption1").closest('.div-item').find('.point-range-box').css('display','block');
                    }
                }

                resolve();

            }, function(code, msg){
                MPopup.confirm({
                    title : '알림',
                    message : msg,
                    buttons : ["확인"],
                    callback : function(idx){
                        //MPage.back({});
                    }
                });
            });
        })
    },
    getCardInfo: function(){
        return new Promise(function(resolve){
            var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                        : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);
            var param = {ci : encCi };

            //SK일렉링크 회원 카드 정보 조회
            evCardKey(param, function(receivedData){

                console.log(JSON.stringify(receivedData))

                var tagHtml = "";
                if(receivedData){

                    var protectedPrivacy = CurrPage.getProtectedPrivacy(receivedData);

                    tagHtml =   "<p>"
                            +       "<b>" + protectedPrivacy + "</b>"
                            +   "</p>"
                            +   "<span>" + receivedData.cardName + "</span>";
                }

                $("#creditNo").html(tagHtml);

                resolve();

            }, function(code, msg){
                 MPopup.confirm({
                     title : '알림',
                     message : msg,
                     callback : function(idx){
                         //MPage.back({});
                     }
                 });
            });
        })
    },
    getProtectedPrivacy: function(obj){
        return obj.creditCardNo.match(/[0-9*]{1,4}/g)?.join(' - ').replace("$","*");
    },
    setPointRate: function(txtPointYn){

        //포인트 사용 유무 판단
        var pointUseYn = $("#chkOption1").is(":checked") ? "Y" : "N";
        var pointUseRatio = $(".range-num").text();
        var encCi = CONFIG.IS_DEV ? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                   : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);

        var param = {
            ci : encCi,
            pointUseYn : pointUseYn,
            pointUseRatio : pointUseRatio
        };

        //기아 멤버스 포인트 사용 기준 정보 변경
        uptPointCriteria(param, function(receivedData){
            console.log(JSON.stringify(receivedData));
            var txt = txtPointYn && "포인트 사용 설정이 완료되었습니다." || "차감 비율이 변경되었습니다."

            exWNHideIndicator();
            MPopup.instance(txt);

        }, function(code, msg){
        console.log(code)
            MPopup.confirm({
                title : '알림',
                message : msg,
                buttons : ["확인"],
                callback : function(idx){
                    //MPage.back({});
                }
            });
        });
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_570_0000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){
        //ev카드 정보 조회
        CurrPage.getCardInfo();
    },
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
