/**

 @파일명 : KIA_RNW_580_0000.js
 @작성자 :
 @생성일 : 2022.01.26
 @메뉴명 : 충전소 검색
 @DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] )
 *************************************************************************
 추천충전소 - 선택된 카테고리에 따라 show/hide
 가까운충전소 - 카테고리 선택 할 때마다 서버에서 데이터 조회 (2022-04-06 추가)
 *************************************************************************
 */
var CurrPage;
var KIA_RNW_580_0000 ={
    init: function(){
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");

        var indicatorMaintainer = setInterval(function(){
            exWNShowIndicator();
        }, 500)

        //set evt
        CurrPage.setEventListner();
        CurrPage.setLocationConn("4");
        //최초 좌표 init
        CurrPage.initCoords()
            .then(function(){
                //routo Map setting
                CurrPage.mapsManager.init_async('routoMap')
                    .then(function(){
                        /* 2023.12.12 지도 loading 실패 시 mapObject 에 작업 생략 */
                        if (CurrPage.mapsManager.mapObject) {
                            return Promise.all([
                                //최초위치(gps or 본사) 마커 생성
                                CurrPage.setRoutoMarker(),
                                //routo center 설정
                                CurrPage.setRoutoCenter(),
                                //지도 area evt (클릭이벤트 포함)
                                CurrPage.fnMapAreaCtrl(),
                                //추천 충전소 데이터 setting
                                CurrPage.setRecomData()
                                    .then(function () {
                                        clearInterval(indicatorMaintainer);
                                        exWNHideIndicator();
                                    })
                            ]);
                        } else {
                            return Promise.all([
                                //지도 area evt (클릭이벤트 포함)
                                CurrPage.fnMapAreaCtrl(),
                                //추천 충전소 데이터 setting
                                CurrPage.setRecomData()
                                    .then(function () {
                                        clearInterval(indicatorMaintainer);
                                        exWNHideIndicator();
                                    })
                            ]);
                        }
                    })
                    .then(function(){
                        clearInterval(indicatorMaintainer);
                        exWNHideIndicator();
                    })
            })
    },
    setEventListner: function(){

        // scroll Evt
        CurrPage.scrollEvt();

        //나만의 충전소
        $("#myStation").on("click", function(){
            MPage.html({url: PATH_MANAGER.KIA_RNW_550_0000.path});
        });

        //충전소 키워드 검색
        $("#srchStation").on("click", function(){

            //마지막 검색한 좌표값 전송
            var param = {
                lat: CurrPage.lat,
                lng: CurrPage.lng
            };

            MPage.html({
                url : PATH_MANAGER.KIA_RNW_582_0000.path,
                param : param
            });
        });

        //tab에 따라 추천 충전소 or 가까운 충전소
        $("#srchTit li").on("click", function(){
            //페이지 번호 및 스크롤(T/F) 초기화
            CurrPage.pageNo = 1;
            CurrPage.scrollIsOk = true;

            //하위 카테고리 영역은 '전체'로 설정
            $("#dataGb .swiper-slide").removeClass('active');
            $("#dataGb .swiper-slide").eq(0).addClass('active');
            $(".js-floating-layer-body").scrollTop(0);

            //선택 tab 영역의 코드
            var tabCd = $(this).data("cd");

            if(tabCd == "recom"){

                CurrPage.setRecomData()
                    .then(function(){
                        exWNHideIndicator();
                    })
            }else if(tabCd == "near"){

                CurrPage.setNearData()
                    .then(function(){
                        exWNHideIndicator();
                    })
            }

        });

        //조회 카테고리 영역 evt
        $("#dataGb button").on("click", function(){
            //페이지 번호 및 스크롤(T/F) 초기화
            CurrPage.pageNo = 1;
            CurrPage.scrollIsOk = true;

            $(".js-floating-layer-body").scrollTop(0);

            //조회 카테고리 영역의 코드
            var cateCd = $(this).data("cd");

            //현재 탭 코드
            var tabCd = $("#srchTit .active").data("cd");

            if(tabCd == "recom"){
                CurrPage.showHideEvt(cateCd)
                    .then(function(){
                        exWNHideIndicator();
                    })
            }else if(tabCd == "near"){
                CurrPage.setNearData(cateCd)
                    .then(function(){
                        exWNHideIndicator();
                    })
            }

        });

        //주소 복사 evt
        $(".btn-copy").on("click", function(){
            //주소 복사
            COMMON_FUNCTION.TOOL.UI.copyToClipboard($(this).closest("p"), true);
        });

        //위치전송 팝업
        $(".btn-send").on("click", function(){
            var stationName = $(this).data('stationName');
            var stationCoord = {
                lat : $(this).data('lat'),
                lng : $(this).data('lng')
            }
            CurrPage.onClickSendLocation(stationName, stationCoord);
        });

        //충전소 상세보기
        $(".btn-arrow-right").closest('.text-scale-04').find('b, button').off("click").on("click",function(){

            var bid = $(this).closest('dt').data('bid');
            var sid = $(this).closest('dt').data('sid');
            var lat = $(this).closest('dt').data('lat');
            var lng = $(this).closest('dt').data('lng');

            if(!(lat && lng)){
                MPopup.alert("위치정보가 존재하지 않습니다.");
                return false;
            }

            var options = {
                url: PATH_MANAGER.KIA_RNW_583_0000.path,
                param: {
                    bid: bid,
                    sid: sid,
                    lat: lat,
                    lng: lng
                },
                animate : "MODAL_UP"
            }

            MPage.html(options);
        });
    },
    mapsManager: COMMON_FUNCTION.ROUTO.mapsManager,
    setRoutoMarker: function(){
        return new Promise(function (resolve) {
            //최초위치(gps or 본사) 마커 생성
            new KIA_ROUTO.Marker({
                position : {lat: Math.abs(parseFloat(CurrPage.initLat)), lng: Math.abs(parseFloat(CurrPage.initLng))},
                map: CurrPage.mapsManager.mapObject,
                icon:"../../img/rnw/main/mycar/icon_map_currentLocation.svg",
                opacity:0,
                zIndex:9999
            });

            resolve();
        })
    },
    setRoutoCenter: function(){
        return new Promise(function (resolve) {
            console.log("지도 그립시다 :::::::::::::::::::::::" + CurrPage.lat)
            console.log("지도 그립시다 :::::::::::::::::::::::" + CurrPage.lng)

            //CurrPage.mapsManager.mapObject의 내장함수가 정상적으로 load되지 않았을 경우를 감안한  setInterval
            var loadCounter = 0;
            var chkMapObj = setInterval(function(){
                if(loadCounter === 100){
                    MPopup.confirm({
                        message : "지도 불러오기에 실패하였습니다. 잠시 후 다시 시도해주세요.",
                        buttons : ["확인"],
                        callback : function(idx){
                            MPage.back();
                        }
                    });
                    console.error("mapsManager : routo 로딩 타임 아웃");
                }

                loadCounter++;

                /** floating-layer 위로 마커를 지도 중앙에 맞추기 위함(2022-05-09) **/
                    //조회하려는 위경도의 원 좌표 확인
                var fromLonLat = KIA_ROUTO_ORIGINAL.proj.fromLonLat([CurrPage.lng, CurrPage.lat]);
                //원 좌표를 픽셀로 표현
                var getPixelFromCoordinate = CurrPage.mapsManager.mapObject.getPixelFromCoordinate([fromLonLat[0], fromLonLat[1]]);

                if(getPixelFromCoordinate != null){
                    //x축 pixel
                    var pixelX = getPixelFromCoordinate[0];
                    //y축 pixel
                    var pixelY = getPixelFromCoordinate[1];

                    console.log("픽셀::::::::::::::::::::::::"+pixelX)
                    console.log("픽셀::::::::::::::::::::::::"+pixelY)

                    //routo 영역 총 높이 / 2
                    var mapAreaHeight = $(".map-area").outerHeight() / 2;
                    //센터를 잡을 지도 영역 높이 / 2
                    var mapConHeight = $(".map-cont").outerHeight() / 2 ;

                    //center를 맞추기 위한 높이 계산
                    var reqHeight = pixelY + Math.abs(mapAreaHeight - mapConHeight);

                    //센터로 잡을 원 좌표값 구하기
                    var centerPrj = CurrPage.mapsManager.mapObject.getCoordinateFromPixel([pixelX,reqHeight]);
                    //원 좌표 -> 위,경도
                    var lng = KIA_ROUTO_ORIGINAL.proj.toLonLat(centerPrj)[0];
                    var lat = KIA_ROUTO_ORIGINAL.proj.toLonLat(centerPrj)[1];

                    CurrPage.mapsManager.mapObject.setCenter({lat: lat, lng: lng});

                    clearInterval(chkMapObj);

                    resolve();
                }
            }, 100);
        })
    },
    showHideEvt: function(cateCd){
        return new Promise(function (resolve) {
            //추천 충전소는 스크롤로 인한 페이징 처리 없음
            CurrPage.scrollIsOk = false;

            //필터 영역에 해당되는 데이터만 노출
            $("#stationListCon .div-item").each(function(){

                if(cateCd == "CHG"){
                    //즉시 충전 가능
                    if($(this).data("chgYn") == "Y"){
                        $(this).show();
                    }else{
                        $(this).hide();
                    }
                }else if(cateCd == "RSV"){
                    //예약가능
                    if($(this).data("rsvYn") == "Y"){
                        $(this).show();
                    }else{
                        $(this).hide();
                    }
                }else{
                    //전체
                    $(this).show();
                }
            })

            //데이터 없을 시,
            if($("#stationListCon .div-item:visible").length < 1){
                $("#noDataCon").show();
            }else{
                $("#noDataCon").hide();
            }

            resolve();
        })
    },
    pageNo: 1,
    lat: null,  //위도
    lng: null,  //경도
    noGpsCoords: false,
    initCoords: function(){
        return COMMON_FUNCTION.TOOL.GPS.getGPSCoordsAsync(CurrPage)/** gps정보획득 */
            .then(/** gps 주소명 획득 */
                function (gps) {
                    //검색 할 좌표 값
                    CurrPage.lat = gps.latitude;
                    CurrPage.lng = gps.longtitude;
                    //초기 좌표 값
                    CurrPage.initLat = gps.latitude;
                    CurrPage.initLng = gps.longtitude;
                }
            )
    },
    setRecomData: function(){
        return new Promise(function (resolve) {

            console.log("현재 위도로 추천 충전소 검색::::::::::::::::::::"+CurrPage.lat)
            console.log("현재 경도로 추천 충전소 검색::::::::::::::::::::"+CurrPage.lng)



            /* 추천 충전소 */
            //추천 충전소는 스크롤로 인한 페이징 처리 없음
            CurrPage.scrollIsOk = false;
            //충전소 필터팝업에서 선택한 데이터 존재 시, 해당 조건으로 조회
            var defaultBid = ["BG","BT","CB","CT","CU","CV","DE","DG","E0","EG","EI","EM","EN","EP","EV","EZ","G1","G2","GN","GP","GS",
                "HB","HE","HL","HM","IK","JC","JD","JE","JH","JJ","JN","JT","JU","KC","KE","KL","KN","KP","KT","KU","LH",
                "MA","ME","MO","OB","PI","PW","RE","S1","SA","SC","SE","SF","SG","SK","SM","SP","SS","ST","TD","TL","TM"]

            //충전소 필터팝업으로 검색한 충전타입이 존재할 때, 매핑하기 위함(추천충전소만 해당)
            var chrgType = [];
            if(CurrPage.arrChrgType){
                if(CurrPage.arrChrgType.includes("A")) chrgType.push("01","03","05","06");
                if(CurrPage.arrChrgType.includes("B")) chrgType.push("04","05","06");
                if(CurrPage.arrChrgType.includes("C")) chrgType.push("02");
                if(CurrPage.arrChrgType.includes("D")) chrgType.push("03","06","07");

                //중복값 제거
                chrgType = chrgType.filter(function(val,idx){
                    return chrgType.indexOf(val) === idx;
                });
            }

            console.log(chrgType)

            var sendData = {
                chgrType: CurrPage.arrChrgType ? chrgType : ["01","02","03","04","05","06","07"],
                chgrBid: CurrPage.arrChrgType ? CurrPage.arrBid : defaultBid,
                lat: CurrPage.lat,
                lon: CurrPage.lng
            }

            //추천충전소 조회
            MNet_SSC.httpSend({
                path: SSC_API.reqChrgLocation.url,
                sendData: sendData,
                callback: function(response){
                    console.log(response)
                    console.log(JSON.stringify(response))

                    if(response.resultCode == "0000"){
                        //초기화
                        $("#stationListCon").html('');

                        if(response.data.length > 0){
                            /* 2023.12.12 지도 loading 실패 시 mapObject 에 작업 생략 */
                            if (CurrPage.mapsManager.mapObject) {
                                CurrPage.setRoutoInfoWindow(response.data);
                            }
                            //컨테이너 복사
                            var dlCon = $("#dummyDlCon .div-item").clone(true);
                            $("#noDataCon").hide();

                            response.data.forEach(function(item){

                                var greenPassMode = $('#greenpassToggle').prop('checked');
                                var greenPass = item.greenPassAt;

                                if(!greenPassMode || greenPass == "Y"){

                                    var tmpDlCon = $(dlCon).clone(true);

                                    //운영상태 일 때만 노출,
                                    if(item.chargerStationOperationCode == "Y"){

                                        //충전소 상태가 원할이거나 보통일 때, (필터 영역 시, 해당 데이터만 노출시기기 위함)
                                        if(item.chargerStationStatus == "PLEASANT" || item.chargerStationStatus == "NORMAL"){
                                            $(tmpDlCon).data("chgYn", "Y");
                                            $(tmpDlCon).find("dd .tag").text("충전가능");
                                        }

                                        //예약상태가 가능할 때, (필터 영역 시, 해당 데이터만 노출시기기 위함)
                                        if(item.reservationYn == "Y"){
                                            $(tmpDlCon).data("rsvYn", "Y");
                                        }

                                        //상세페이지에 보낼 param > <dt> Tag에 담기
                                        $(tmpDlCon).find('dt').data('bid', item.bid);
                                        $(tmpDlCon).find('dt').data('sid', item.chargerStationId);
                                        $(tmpDlCon).find('dt').data('lat', item.gpsLatitude);
                                        $(tmpDlCon).find('dt').data('lng', item.gpsLongitude);

                                        if(CurrPage.noGpsCoords){
                                            $(tmpDlCon).find('dt').find('.d-flex b').remove();
                                        }else{
                                            //거리가 천단위 일 경우, km 표현
                                            if(item.distance >= 1000){
                                                var distance = (item.distance / 1000).toFixed(1);
                                                $(tmpDlCon).find('dt').find('.d-flex b').text(distance+"km");
                                            }else{
                                                $(tmpDlCon).find('dt').find('.d-flex b').text(item.distance+"m");
                                            }
                                        }


                                        if(item.greenPassAt == "Y"){
                                            $(tmpDlCon).find('dt').find('.d-flex em').text(item.serviceProviderName + " | ");
                                            $(tmpDlCon).find('dt').find('.d-flex strong').text('\u00A0' +"기아 그린패스 충전소");
                                        }else{
                                            $(tmpDlCon).find('dt').find('.d-flex em').text(item.serviceProviderName);
                                            $(tmpDlCon).find('dt').find('.d-flex strong').text("");
                                        }
                                        $(tmpDlCon).find('dt').find('.text-scale-04 b').text(item.chargerStationName);
                                        //위치전송 버튼에 데이터 담기
                                        $(tmpDlCon).find('dd .btn-send').data('stationName', item.chargerStationName);
                                        $(tmpDlCon).find('dd .btn-send').data('lat', item.gpsLatitude);
                                        $(tmpDlCon).find('dd .btn-send').data('lng', item.gpsLongitude);

                                        var tmpBtn = $(tmpDlCon).find('dd .group-01 .btn-copy').clone(true);
                                        $(tmpDlCon).find('dd').find('.group-01 p').text(item.adrs ? item.adrs  : "");
                                        $(tmpDlCon).find('dd').find('.group-01 p').append(tmpBtn);

                                        //충전기 타입 코드에 따라 아이콘 활성화
                                        var arrType = item.chargerType.split(",");
                                        arrType.forEach(function(type){
                                            if(type == "01"){
                                                $(tmpDlCon).find(".ico-charge2").addClass('active');
                                            }else if(type == "02"){
                                                $(tmpDlCon).find(".ico-charge4").addClass('active');
                                            }else if(type == "03"){
                                                $(tmpDlCon).find(".ico-charge2, .ico-charge3").addClass('active');
                                            }else if(type == "04"){
                                                $(tmpDlCon).find(".ico-charge1").addClass('active');
                                            }else if(type == "05"){
                                                $(tmpDlCon).find(".ico-charge1, .ico-charge2").addClass('active');
                                            }else if(type == "06"){
                                                $(tmpDlCon).find(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
                                            }else if(type == "07"){
                                                $(tmpDlCon).find(".ico-charge3").addClass('active');
                                            }
                                        });

                                        $("#stationListCon").append(tmpDlCon);
                                    }
                                }
                            })
                        }else{
                            $("#noDataCon").show();
                        }
                    }
                    resolve();
                }
            })
        })
    },
    setLocationConn: function(num){
        var sendData = {
            apiId: 'RNW-CMM-9100',
            mbrId: PGV.loginInfo.mbrId,
            funnels: num
        }

        MNet.httpSend({
            path: _API.SVR.CMM.code.locationConnCsmrInfoRgst,
            indicatorYn: "N",
            sendData: sendData,
            isMock: false,
            callback : function(receivedData){
            }
        })
    },
    setNearData: function(cateCd){
        return new Promise(function (resolve) {
            console.log("현재 위도로 가까운 충전소 검색::::::::::::::::::::"+CurrPage.lat)
            console.log("현재 경도로 가까운 충전소 검색::::::::::::::::::::"+CurrPage.lng)

            /* 가까운 충전소 */
            //충전소 필터팝업에서 선택한 데이터 존재 시, 해당 조건으로 조회
            var arrChrgType = CurrPage.arrChrgType;
            var arrBid = CurrPage.arrBid;

            //카테고리 코드
            if(!cateCd){
                cateCd = $("#dataGb .active button").data("cd");
            }

            var sendData = {};

            if(arrChrgType){
                sendData = {
                    apiId: 'RNW-EVC-2001',
                    mbrId: PGV.loginInfo.mbrId,
                    schCd: "02",
                    cateCd: cateCd || "ALL",
                    chgrType: arrChrgType,
                    chgrBid: arrBid,
                    lat: CurrPage.lat,
                    lng: CurrPage.lng,
                    currentPageNo: CurrPage.pageNo,
                    pageSize: 10
                }
            }else{
                sendData = {
                    apiId: 'RNW-EVC-2001',
                    mbrId: PGV.loginInfo.mbrId,
                    schCd: "01",
                    cateCd: cateCd || "ALL",
                    lat: CurrPage.lat,
                    lng: CurrPage.lng,
                    currentPageNo: CurrPage.pageNo,
                    pageSize: 10
                }
            }


            MNet.httpSendAsync({
                path: _API.SVR.EV.evCharger.schEvChargerStation,
                sendData: sendData,
                isMock: false
            }).then(function (response) {

                console.log(JSON.stringify(response))

                //초기화
                if(CurrPage.pageNo == 1){
                    $("#stationListCon").html('');
                }

                if(response.resultCode == "200"){

                    var evChgrList = response.evChgrListRnwResDto;

                    if(evChgrList.length > 0){
                        if(CurrPage.pageNo == 1){
                            /* 2023.12.12 지도 loading 실패 시 mapObject 에 작업 생략 */
                            if (CurrPage.mapsManager.mapObject) {
                                //마커찍기
                                CurrPage.setRoutoInfoWindow(evChgrList);
                            }
                        }

                        //컨테이너 복사
                        var dlCon = $("#dummyDlCon .div-item").clone(true);
                        $("#noDataCon").hide();



                        evChgrList.forEach(function(item){
                            var greenPassMode = $('#greenpassToggle').prop('checked');
                            var greenPass = item.greenPassAt;

                            if(!greenPassMode || greenPass == "Y"){


                                var tmpDlCon = $(dlCon).clone(true);
                                var statusClass = "";
                                var statusTxt = "";

                                //상세페이지에 보낼 param > <dt> Tag에 담기
                                $(tmpDlCon).find('dt').data('bid', item.bid);
                                $(tmpDlCon).find('dt').data('sid', item.sid);
                                $(tmpDlCon).find('dt').data('lat', item.lat);
                                $(tmpDlCon).find('dt').data('lng', item.lng);

                                if(CurrPage.noGpsCoords){
                                    $(tmpDlCon).find('dt').find('.d-flex b').remove();
                                }else{
                                    $(tmpDlCon).find('dt').find('.d-flex b').text(Number(item.dist) + "km");
                                }

                                //$(tmpDlCon).find('dt').find('.d-flex em').text(item.bName);
                                if(greenPass == "Y"){
                                    $(tmpDlCon).find('dt').find('.d-flex em').text(item.bName + " | ");
                                    $(tmpDlCon).find('dt').find('.d-flex strong').text('\u00A0' +"기아 그린패스 충전소");
                                }else{
                                    $(tmpDlCon).find('dt').find('.d-flex em').text(item.bName);
                                    $(tmpDlCon).find('dt').find('.d-flex strong').text("");
                                }

                                $(tmpDlCon).find('dt').find('.text-scale-04 b').text(item.name);
                                //위치전송 버튼에 데이터 담기
                                $(tmpDlCon).find('dd .btn-send').data('stationName', item.name);
                                $(tmpDlCon).find('dd .btn-send').data('lat', item.lat);
                                $(tmpDlCon).find('dd .btn-send').data('lng', item.lng);

                                var tmpBtn = $(tmpDlCon).find('dd .group-01 .btn-copy').clone(true);
                                $(tmpDlCon).find('dd').find('.group-01 p').text(item.dAddr ? item.dAddr  : "");
                                $(tmpDlCon).find('dd').find('.group-01 p').append(tmpBtn);

                                /* 충전소 상태
                                '사용중','대기중','통신이상','사용불가','운영중지','예약중','상태미확인','점검중'
                                그 외는 '미조회'
                                */
                                if(item.status == "대기중"){
                                    statusClass = "type1";
                                    statusTxt = "충전가능";
                                }else if(item.status == "사용중" || item.status == "예약중"){
                                    statusClass = "type2";
                                    statusTxt = "사용중";
                                }else{
                                    statusClass = "type3";
                                    statusTxt = "상태 미확인";
                                }
                                $(tmpDlCon).find('dd .tag').addClass(statusClass);
                                $(tmpDlCon).find('dd .tag').text(statusTxt);

                                //충전기 타입 코드에 따라 아이콘 활성화
                                var arrType = item.chgrType.split(",");
                                arrType.forEach(function(type){
                                    if(type == "01"){
                                        $(tmpDlCon).find(".ico-charge2").addClass('active');
                                    }else if(type == "02"){
                                        $(tmpDlCon).find(".ico-charge4").addClass('active');
                                    }else if(type == "03"){
                                        $(tmpDlCon).find(".ico-charge2, .ico-charge3").addClass('active');
                                    }else if(type == "04"){
                                        $(tmpDlCon).find(".ico-charge1").addClass('active');
                                    }else if(type == "05"){
                                        $(tmpDlCon).find(".ico-charge1, .ico-charge2").addClass('active');
                                    }else if(type == "06"){
                                        $(tmpDlCon).find(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
                                    }else if(type == "07"){
                                        $(tmpDlCon).find(".ico-charge3").addClass('active');
                                    }
                                });

                                $("#stationListCon").append(tmpDlCon);
                            }
                        });
                    }else{
                        if($("#stationListCon .div-item").length < 1){
                            $("#noDataCon").show();
                        }
                    }
                    //var map = new routo.maps.Map("map");  // 지도 생성

                }else{
                    if($("#stationListCon .div-item").length < 1){
                        $("#noDataCon").show();
                        /* 2023.12.12 지도 loading 실패 시 mapObject 에 작업 생략 */
                        if (CurrPage.mapsManager.mapObject) {
                            CurrPage.setRoutoInfoWindow();
                        }
                    }
                }

                resolve();
            })
        })
    },
    scrollIsOk: true,
    scrollEvt: function(){
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $headerHeight = $('.header').outerHeight();
        var $floatingLayerBody = $('.js-floating-layer-body');

        /* 20220408//(Ina)$floatingLayerBody영역 scrollend 스크립트 추가(s) */
        $floatingLayerBody.scroll(function(e) {
            var $nowTop = $(this).scrollTop();

            if (($floatingLayerBody[0].scrollHeight - Math.ceil($floatingLayerBody.scrollTop())) <= Math.floor($floatingLayerBody.outerHeight())) {
                if(CurrPage.scrollIsOk){
                    console.log('scrollEnd');
                    CurrPage.scrollIsOk = false;
                    ++CurrPage.pageNo;
                    CurrPage.setNearData()
                        .then(function(){
                            exWNHideIndicator();
                        })
                }
            }

            $winTop = $nowTop;
        });
    },
    fnMapAreaCtrl: function(){
        return new Promise(function (resolve) {
            /* 20220414//(Ina)routoMap 생성시 map조작오류 수정 */
            //fnSetRoutoMap(); // routoMap지도를 생성한다
            fnSetMapCont(); //.map-cont div를 동적으로 생성한다
            //fnCtrlMapFloatingLayer(); //.floating-layer영역을 제어한다

            // ------------------------------
            // 	Slider
            // ------------------------------
            if ($('.slider-filter-list').is(':visible')) {
                var _sliderFilterList = new Swiper('.slider-filter-list', {
                    spaceBetween:0,
                    slidesPerView:'auto',
                    //centeredSlides:true,
                    loopedSlides:1,
                    loop: false,
                    speed:300,
                    grapCursor:true,
                    observer:true,
                    observParents:true,
                    resistanceRatio:0 //드래그 저항비율 제어
                });

                $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
                    e.preventDefault();
                    var getSlideIdx = $(this).data('slide-index');
                    //console.log('getSlideIdx', getSlideIdx)
                    _sliderFilterList.slideTo(getSlideIdx, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
                });

            }


            // ------------------------------
            // 	Map
            // ------------------------------
            function fnSetMapCont() {
                var _mapCont;

                _mapCont = '';
                _mapCont += '<div class="map-cont js-map-cont">';
                _mapCont += 	'<div class="nav-map-btns js-nav-map-btns">';
                _mapCont += 		'<button type="button" class="btn-map-current" id="btnMapcurrent"><em class="blind">현위치로 이동</em></button>';
                //_mapCont += 		'<button type="button" class="btn-map-search js-hidden" id="btnMapSearch">현 지도에서 검색</button>';
                _mapCont += 		'<button type="button" class="btn-map-research" id="btnMapReSearch">현 위치에서 재검색</button>';
                _mapCont += 		'<button type="button" class="btn-map-filter"><em class="blind">팝업 필터</em></button>';
                _mapCont += 		'<div class="greenpass-toggle">';
                _mapCont += 			'<span class="txt-greenpass">그린패스</span>';
                _mapCont += 			'<input type="checkbox" id="greenpassToggle" hidden>';
                _mapCont += 			'<label for="greenpassToggle" class="toggle-switch">';
                _mapCont += 				'<span class="toggle-state on">ON</span>';
                _mapCont += 				'<span class="toggle-button"></span>';
                _mapCont += 				'<span class="toggle-state off">OFF</span>';
                _mapCont += 			'</label>';
                _mapCont += 		'</div>';
                _mapCont += 	'</div>';
                _mapCont += '</div>';

                $('#routoMap').find('.ol-viewport').append(_mapCont);

                //현위치로 이동
                $(".map-cont .btn-map-current").on("click", function(){
                    CurrPage.initCoords()
                    .then(function(obj){
                        //routo Map setting
                        CurrPage.setRoutoCenter();
                    })
                });

                $('#greenpassToggle').change(function(){
                    $(".map-cont .btn-map-research").trigger('click');
                });

                /*현 지도에서 검색
                $(".map-cont .btn-map-search").on("click", function(){
                    CurrPage.pageNo = 1;
                    CurrPage.scrollIsOk = true;

                    //getCenter() 중심좌표 값으로 조회하고 있는 탭 (click -> 조회)
                    CurrPage.lat = CurrPage.mapsManager.mapObject.getCenter().lat;
                    CurrPage.lng = CurrPage.mapsManager.mapObject.getCenter().lng;

                    //하위 카테고리 영역은 '전체'로 설정
                    $("#dataGb .swiper-slide").removeClass('active');
                    $("#dataGb .swiper-slide").eq(0).addClass('active');
                    $(".js-floating-layer-body").scrollTop(0);
                    //선택 tab 영역의 코드
                    var tabCd = $("#srchTit .active").data("cd");

                    if(tabCd == "recom"){
                        CurrPage.setRecomData()
                        .then(function(){
                            exWNHideIndicator();
                        })
                    }else if(tabCd == "near"){
                        CurrPage.setNearData()
                        .then(function(){
                            exWNHideIndicator();
                        })
                    }
                });
                 */

                //현 지도에서 검색
                $(".map-cont .btn-map-research").on("click", function(){
                    CurrPage.pageNo = 1;
                    CurrPage.scrollIsOk = true;

                    //getCenter() 중심좌표 값으로 조회하고 있는 탭 (click -> 조회)
                    CurrPage.lat = CurrPage.mapsManager.mapObject.getCenter().lat;
                    CurrPage.lng = CurrPage.mapsManager.mapObject.getCenter().lng;

                    //하위 카테고리 영역은 '전체'로 설정
                    $("#dataGb .swiper-slide").removeClass('active');
                    $("#dataGb .swiper-slide").eq(0).addClass('active');
                    $(".js-floating-layer-body").scrollTop(0);
                    //선택 tab 영역의 코드
                    var tabCd = $("#srchTit .active").data("cd");

                    if(tabCd == "recom"){
                        CurrPage.setRecomData()
                            .then(function(){
                                exWNHideIndicator();
                            })
                    }else if(tabCd == "near"){
                        CurrPage.setNearData()
                            .then(function(){
                                exWNHideIndicator();
                            })
                    }
                });

                //필터 검색 팝업
                $(".map-cont .btn-map-filter").on("click", function(){
                    CurrPage.filterPop();
                });

                //지도 클릭 evt
                $(".map-cont").on("click", function(){
                    fnClickStatusChange($(this));
                });
            }

            // ------------------------------
            // 	floatingLayer제어
            // ------------------------------
            var $homeHeaderHeight = $('#homeHeader').outerHeight();
            var $searchContentHeight = $('#searchContent').outerHeight();
            var $mapCont = $('.js-map-cont');
            var $navMapBtns = $mapCont.find('.js-nav-map-btns');
            var $floatingLayer = $('.js-floating-layer');
            var $draggableBtn = $floatingLayer.find('.js-draggable-btn');
            var $floatingLayerBody = $floatingLayer.find('.js-floating-layer-body');
            var $tabsCont = $floatingLayer.find('.tabs-cont');
            var $sliderFilterCont = $floatingLayer.find('.slider-filter-cont');
            var $draggableBtnHeight = $floatingLayer.find('.js-draggable-btn').outerHeight();
            var $gripAreaHeight = $floatingLayer.find('.grip-area').outerHeight();

            var floatingLayerInitTop = 42; // $floatingLayer의 초기값Top
            //var floatingLayerMinTop = 100; // $floatingLayer의 mintop
            //var floatinglayerMaxTop = $searchContentHeight - $draggableBtnHeight; // $floatingLayer의 maxtop

            var floatingLayerInitTop = 36; // $floatingLayer의 초기값Top
            var floatingLayerMinTop = 24; // $floatingLayer의 mintop
            var floatinglayerMaxTop = fnCheckDevice() == 'android' ? ($searchContentHeight - ($homeHeaderHeight + $gripAreaHeight)) : ($searchContentHeight - ($homeHeaderHeight + ($gripAreaHeight * 2.1))); // $floatingLayer의 maxtop

            // $floatingLayer의 상태
            var _dataLayerStatus = $floatingLayer.attr('data-layer-status'); // middleOpen : 중간펼침상태(디폴트), folded : 접힘상태, extendOpen : 확장펼침상태

            // 접힘상태 위치
            var foldedPosition = floatingLayerMinTop
            foldedPosition = (foldedPosition / 10) ; //rem

            // 확장펼침상태 위치
            var extendOpenPosition = floatinglayerMaxTop;
            extendOpenPosition = (extendOpenPosition / 10); //rem

            fnLayerBodyHeight(); //$floatingLayer의 높이값 세팅

            // ------------------------------


            /* swipe 이벤트 */
            /* ------------------------------ */

            $draggableBtn.swipe({
                swipeUp:function(event, direction, distance, duration) {
                    //console.log('up distance :::' + distance)

                    if ($floatingLayer.attr('data-layer-status') == 'middleOpen') {
                        TweenMax.to($floatingLayer, 0.3, {top: foldedPosition+'rem', ease:Linear.out});
                        fnLayerStatusFolded();
                    }
                    else if ($floatingLayer.attr('data-layer-status') == 'extendOpen') {
                        TweenMax.to($floatingLayer, 0.3, {top: floatingLayerInitTop+'rem', ease:Linear.out});
                        fnLayerStatusMiddleOpen();
                    }

                },
                swipeDown:function(event, direction, distance, duration) {
                    //console.log('down distance :::' + distance)

                    if ($floatingLayer.attr('data-layer-status') == 'folded') {
                        TweenMax.to($floatingLayer, 0.3, {top: floatingLayerInitTop+'rem', ease:Linear.out});
                        fnLayerStatusMiddleOpen();
                    }
                    else if ($floatingLayer.attr('data-layer-status') == 'middleOpen') {
                        TweenMax.to($floatingLayer, 0.3, {top: extendOpenPosition+'rem', ease:Linear.out});
                        fnLayerStatusExtendOpen();
                    }

                },
                swipeStatus:function(event, phase, direction, distance, duration) {
                    if (phase == 'move') {
                        $('#routoMap').unbind('touchmove');
                    }
                    if (phase == 'end') {
                        $('#routoMap').bind('touchmove');
                    }
                },

                threshold:100,
                allowPageScroll:'vertical'
            });

            // $floatingLayer의 중간펼침상태(디폴트)
            function fnLayerStatusMiddleOpen() {
                console.log('디폴트>>>>>')

                _dataLayerStatus = $floatingLayer.attr('data-layer-status', 'middleOpen');

                // 높이값
                $('.js-map-cont').css('height', floatingLayerInitTop+'rem');
                fnLayerBodyHeight();

                // 버튼상태
                $('#btnMapSearch').addClass('js-hidden');
                $('#btnMapcurrent').removeClass('js-hidden');

                // 탭상태
                $tabsCont.css('opacity', 1);

                // 맵 제어 true
                $('#routoMap').css('pointer-events', 'inherit');

            }
            // $floatingLayer의 접힘상태
            function fnLayerStatusFolded() {
                console.log('접힘상태>>>>>')

                _dataLayerStatus = $floatingLayer.attr('data-layer-status', 'folded');

                // 높이값
                $('.js-map-cont').css('height', foldedPosition+'rem');
                fnLayerBodyHeight();

                // 버튼상태
                $('#btnMapSearch').addClass('js-hidden');
                $('#btnMapcurrent').addClass('js-hidden');

                // 탭상태
                $tabsCont.css('opacity', 1);

                // 맵 제어 false
                $('#routoMap').css('pointer-events', 'none');
            }
            // $floatingLayer의 확장펼침상태
            function fnLayerStatusExtendOpen() {
                console.log('확장펼침>>>>>')
                _dataLayerStatus = $floatingLayer.attr('data-layer-status', 'extendOpen');

                // 높이값
                $('.js-map-cont').css('height', extendOpenPosition+'rem');
                fnLayerBodyHeight();

                // 버튼상태
                $('#btnMapSearch').removeClass('js-hidden');
                $('#btnMapcurrent').removeClass('js-hidden');

                // 탭상태
                $tabsCont.css('opacity', 0);

                // 맵 제어 true
                $('#routoMap').css('pointer-events', 'inherit');
            }

            /* click 이벤트 */
            /* ------------------------------ */
            function fnClickStatusChange(event) {

                var _dataLayerStatusClick = $floatingLayer.attr('data-layer-status');

                // $floatingLayer 중간펼침상태 -> 확장펼침상태
                if (_dataLayerStatusClick == 'middleOpen') {

                    TweenMax.to($floatingLayer, 0.3, {top: extendOpenPosition+'rem', ease:Linear.out});
                    fnLayerStatusExtendOpen();

                }
            }

            /* ------------------------------ */
            /* ------------------------------ */

            // $floatingLayer의 높이값을 잡아준다
            function fnLayerBodyHeight() {
                console.log('레이어 높이셋팅 호출');

                setTimeout(function() {

                    // floating-layer-body 높이값을 구한다
                    var floatingLayerBodyHeight = $searchContentHeight - ($floatingLayer.offset().top + $gripAreaHeight + $homeHeaderHeight);
                    floatingLayerBodyHeight = (floatingLayerBodyHeight / 10); //rem

                    $floatingLayerBody.css('height', floatingLayerBodyHeight+'rem');

                }, 400);

            }

            resolve();
        })
    },
    onClickSendLocation: function(stationName, stationCoord){
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_242_1000.path, function () {
            var parentThis = this;
            var closePopup = function (e, parentThis) {
                e.preventDefault();

                parentThis.fadeOut('fast');
                parentThis.find('.popup-wrap').removeClass('is-ani');

                $('body').removeClass('js-overflow-hidden');
            }
            this.find("ul li").off("click").on("click", function (e) {
                var targetApp = $(this).data('target-app');
                switch(targetApp){
                    case "kakaomap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('k', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "tmap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('t', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "kia-connect":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('kc', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                }
                closePopup(e, parentThis);
            })
            this.find('#mykia-close-popup').off("click").on("click", function (e) {
                closePopup(e, parentThis);
            })
        })
    },
    setChkBoxEvt: function(){
        // 0. 그린 패스
        // 모두 체크
        $('.content-evtab .section-00 .chargFilter-cont .chkAll').on('click',function(){
            var $this = $(this);
            var cid = $('input[value=KP]').attr("id");
            if($this.prop('checked')){
                $this.closest('.chk-form-list').siblings('.greenPass').find('button').addClass('active');
                $('#'+cid).prop('checked', true);
            }else{
                $this.closest('.chk-form-list').siblings('.greenPass').find('button').removeClass('active');
            }
        });

        // 그린 패스 버튼 체크
        $('.content-evtab .chargFilter-cont .greenPass button').on('click',function(){
            var $this = $(this);
            var cid = $('input[value=KP]').attr("id");
            if($this.hasClass('active')){
                $this.removeClass('active');
                $('.content-evtab .section-00 .chargFilter-cont .chkAll').prop('checked', false);
            }else{
                $this.addClass('active');
                $('#'+cid).prop('checked', true);
                $('.content-evtab .section-00 .chargFilter-cont .chkAll').prop('checked', true);
            }
        });

        // 1. 충전 타입
        // 모두 체크
        $('.content-evtab .section-01 .chargFilter-cont .chkAll').on('click',function(){
            var $this = $(this);
            if($this.prop('checked')){
                $this.closest('.chk-form-list').siblings('.charge-type').find('button').addClass('active');
                $this.closest('.chk-form-list').siblings('.txt-error').hide();
            }else{
                $this.closest('.chk-form-list').siblings('.charge-type').find('button').removeClass('active');
                $this.closest('.chk-form-list').siblings('.txt-error').show();
            }
        });

        // 충전 타입 버튼 체크
        $('.content-evtab .chargFilter-cont .charge-type button').on('click',function(){
            var $this = $(this);

            if($this.hasClass('active')){
                $this.removeClass('active');
            }else{
                $this.addClass('active');
            }

            if(!$('.content-evtab .chargFilter-cont .charge-type button.active').length){
                $this.closest('.charge-type').siblings('.txt-error').show();
            }else{
                $this.closest('.charge-type').siblings('.txt-error').hide();
            }

            // 충전 타입 4개 체크시 전체 체크박스에 체크
            var state = 1;

            $('.content-evtab .chargFilter-cont .charge-type button').each(function(i,el){
                if($(el).hasClass('active')) state *= 1;
                else state *= 0;
            });
            $('.content-evtab .section-01 .chargFilter-cont .chkAll').prop('checked', state);

        });

        // 2. 충전소 운영 기관
        // 모두 체크
        $('.content-evtab .section-02 .chargFilter-cont .chkAll').on('click',function(){
            var $this = $(this);
            if($this.prop('checked')){
                $this.closest('.chk-cont').siblings('.chk-cont-wrap').find('input').prop('checked', true);
            }else{
                $this.closest('.chk-cont').siblings('.chk-cont-wrap').find('input').prop('checked', false);
            }
        });

        // 충전 타입 버튼 체크
        $('.content-evtab .chargFilter-cont .chk-cont-wrap input').on('click',function(){

            // 충전 타입 4개 체크시 전체 체크박스에 체크
            var state = 1;

            $('.content-evtab .chargFilter-cont .chk-cont-wrap input').each(function(i,el){
                if($(el).prop('checked')) state *= 1;
                else state *= 0;
            });
            $('.content-evtab .section-02 .chargFilter-cont .chkAll').prop('checked', state);

        });
    },
    filterPop: function(){

        customPopup.get(PATH_MANAGER.KIA_RNW_581_0000.path, $("#popup_581_0000"), function(item){

            //누적 주행거리 입력 팝업 생성
            if($("#popup_581_0000").length < 1){
                var screenHtml = $("<div></div>");
                screenHtml.append(item);
                $('body').append(screenHtml.find('#popup_581_0000'));

                //운영기관 list
                CurrPage.getStationList();
                exWNHideIndicator();

                //선택한 필터값들로 조회
                $(".popup-btn .btn-primary").on("click", function(){
                    CurrPage.getFilterList();
                })
            }else{
                if(CurrPage.arrChrgType && CurrPage.arrChrgType.length > 0){
                    $('.charge-type > button').each(function(){
                        var dataType = $(this).data('type');
                        var isTrue = CurrPage.arrChrgType.some(function(el){return el == dataType});

                        if(isTrue){
                            $(this).addClass('active');
                        }else{
                            $(this).removeClass('active');
                        }
                    });

                    var typeLng = $('.charge-type > button').length;
                    var activeLng = $('.charge-type > button.active').length;

                    if(typeLng == activeLng){
                        $('#chargOption1-1').prop('checked', true);
                        $(".txt-error").hide();
                    }else if(activeLng > 0){
                        $('#chargOption1-1').prop('checked', false);
                        $(".txt-error").hide();
                    }else if(activeLng == 0){
                        $('#chargOption1-1').prop('checked', false);
                        $(".txt-error").show();
                    }
                }else{
                    $(".txt-error").hide();
                    $('#chargOption1-1').prop('checked', true);
                    $('.charge-type > button').addClass('active');
                }

                if(CurrPage.arrBid && CurrPage.arrBid.length > 0){
                    $('#chkContWrap input').each(function(){
                        var dataVal = $(this).val();
                        var isTrue = CurrPage.arrBid.some(function(el){return el == dataVal});

                        if(isTrue){
                            $(this).prop('checked', true);
                        }else{
                            $(this).prop('checked', false);
                        }
                    });

                    var typeLng = $('#chkContWrap input').length;
                    var checkedLng = $('#chkContWrap input:checked').length;

                    if(typeLng == checkedLng){
                        $('#chargOption2-1').prop('checked', true)
                    }else{
                        $('#chargOption2-1').prop('checked',false)
                    }
                }else{
                    $('#chargOption2-1').prop('checked', true);
                    $('#chkContWrap input').prop('checked',true);
                }

            }
            if($('#greenpassToggle').prop('checked')){
                var cid = $('input[value=KP]').attr("id");
                $('#chargOption1-0').prop('checked', true);
                $('#'+cid).prop('checked', true);
                $('.greenPass > button').addClass('active');
            }else{
                $('#chargOption1-0').prop('checked', false);
                $('.greenPass > button').removeClass('active');
            }
            RNW_UI.popupLayer({selId : '#popup_581_0000'});

        });
    },
    getStationList: function(){

        //전체 운영기관 리스트
        var sendData = {ccd : null, ccdClsId : "10070"}

        MNet.httpSendAsync({
            path: _API.SVR.CMM.code.selectList,
            sendData: sendData,
            isMock: false
        }).then(function (response) {
            /*
            ["BG","BT","CB","CT","CU","CV","DE","DG","E0","EG","EI","EM","EN","EP","EV","EZ","G1","G2","GN","GP","GS"
            ,"HB","HE","HL","HM","IK","JC","JD","JE","JH","JJ","JN","JT","JU","KC","KE","KL","KN","KP","KT","KU","LH"
            ,"MA","ME","MO","OB","PI","PW","RE","S1","SA","SC","SE","SF","SG","SK","SM","SP","SS","ST","TD","TL","TM"];
            */
            console.log(JSON.stringify(response))

            if(response.resultCode == "200"){

                var chgrList = response.list;
                var chgrListHtml = "";

                if(chgrList){
                    chgrList.forEach(function(item, idx){
                        //에스트래픽은 디폴트이므로 예외처리
                        if(item.ccd == 'ST'){
                            return;
                        }
                        chgrListHtml += "<div class='chk-cont chk-size-m'>"
                            +       "<input type='checkbox' name='chargOption2-" + (idx+2) + "' id='chargOption2-" + (idx+2) + "' value=" + item.ccd +" checked>"
                            +           "<label for='chargOption2-" + (idx+2) + "'>"
                            +           "<span>" + item.ccdNm + "</span>"
                            +       "</label>"
                            +   "</div>";

                    });
                    $("#chkContWrap").append(chgrListHtml);
                }
                //체크박스 evt
                CurrPage.setChkBoxEvt();
            }
        })
    },
    getFilterList: function(){

        //충전타입 체크
        var arrChrgType = [];
        if($("#popup_581_0000 .charge-type button.active").length > 0){

            $("#popup_581_0000 .charge-type button.active").each(function(){
                var dataType = $(this).data('type');
                arrChrgType.push(dataType);
            });
        }else{
            MPopup.alert("충전타입을 최소 1개 이상 선택해주세요.");
            return;
        }

        //충전소 운영기관 arr (에스트래픽 디폴트)
        var arrBid = ['ST'];
        $("#chkContWrap .chk-size-m").each(function(){
            var bid = $(this).find('input[type=checkbox]:checked').val();
            bid && arrBid.push(bid);
        })

        CurrPage.pageNo = 1;
        CurrPage.scrollIsOk = true;

        CurrPage.arrChrgType = arrChrgType;
        CurrPage.arrBid = arrBid;

        //선택 tab 영역의 코드
        var tabCd = $("#srchTit .active").data("cd");

        if(tabCd == "recom"){
            CurrPage.setRecomData()
                .then(function(){
                    exWNHideIndicator();
                })
        }else if(tabCd == "near"){
            CurrPage.setNearData()
                .then(function(){
                    exWNHideIndicator();
                })
        }

        if($('.content-evtab .section-00 .chargFilter-cont .chkAll').prop('checked')){
            $('#greenpassToggle').prop('checked', true);
        }else{
            $('#greenpassToggle').prop('checked', false);
        }

        //팝업닫기
        $("#popup_581_0000 .js-popup-close-btn").click();
    },
    setRoutoInfoWindow: function(stationList){

        //말풍선/마커 닫기 (스크롤로 다음 페이지를 불러올때는 그대로 노출시키기 위함)
        //말풍선 -> 마커로 다시 변경(2022-05-11)
        if(CurrPage.pageNo == 1){
            CurrPage.mapsManager.mapObject.clearMarker();
            CurrPage.mapsManager.infoWindowSettingsArray.map(function(el){el.object.close();});
            //gps 마커도 지워지기 때문에 재생성
            CurrPage.setRoutoMarker();
        }

        //기관별 이미지
        var bidMarkerList = new Map();
        bidMarkerList.set("BT", "marker-botary");
        bidMarkerList.set("CV", "marker-dycb");
        bidMarkerList.set("DE", "marker-daegu");
        bidMarkerList.set("DG", "marker-daegu");
        bidMarkerList.set("EP", "marker-ep-new");
        bidMarkerList.set("EV", "marker-everon");
        bidMarkerList.set("G1", "marker-kwangju");
        bidMarkerList.set("G2", "marker-kwangju");
        bidMarkerList.set("GN", "marker-gntel");
        bidMarkerList.set("GP", "marker-gunpo");
        bidMarkerList.set("GS", "marker-gs");
        bidMarkerList.set("HE", "marker-kevcs-3");
        bidMarkerList.set("IK", "marker-iksan");
        bidMarkerList.set("JD", "marker-jejudo");
        bidMarkerList.set("JE", "marker-jeju");
        bidMarkerList.set("JJ", "marker-jeonju");
        bidMarkerList.set("JN", "marker-jncplan");
        bidMarkerList.set("JU", "marker-jeongeup");
        bidMarkerList.set("KN", "marker-keco");
        bidMarkerList.set("KP", "marker-kepco");
        bidMarkerList.set("KP_GREEN", "marker-kepco-green");
        bidMarkerList.set("KT", "marker-kt");
        bidMarkerList.set("ME", "marker-korea");
        bidMarkerList.set("PI", "marker-chargev");
        bidMarkerList.set("PW", "marker-pwrcube-new");
        bidMarkerList.set("SE", "marker-seoul");
        bidMarkerList.set("SG", "marker-signet");
        bidMarkerList.set("ST", "marker-straffic");
        bidMarkerList.set("ST_GREEN", "marker-straffic-green");
        bidMarkerList.set("YY", "marker-yangyang");


        stationList && stationList.forEach(function(item){
            var greenPassMode = $('#greenpassToggle').prop('checked');
            var greenPass = item.greenPassAt;

            if(!greenPassMode || greenPass == "Y"){
                var name = item.chargerStationName || item.name;
                var lat = item.gpsLatitude || item.lat;
                var lng = item.gpsLongitude || item.lng;
                var bid = item.bid;
                var sid = item.chargerStationId || item.sid;
                var imgNm = bidMarkerList.get(bid);


                if(item.greenPassAt == "Y"){
                    imgNm = bidMarkerList.get(bid+"_GREEN");
                }

                var statusClass = "01";

                //추천충전소는 '충전가능'만 데이터를 주기 때문에 가까운 충전소만 처리
                if(item.status){
                    if(item.status == "대기중"){
                        statusClass = "01";
                    }else if(item.status == "사용중" || item.status == "예약중"){
                        statusClass = "02";
                    }else{
                        statusClass = "03";
                    }
                }

                //운영기관 별 마커 생성
                var marker = new KIA_ROUTO.Marker({
                     position : {lat: Math.abs(parseFloat(lat)), lng: Math.abs(parseFloat(lng))},
                     map: CurrPage.mapsManager.mapObject,
                     icon:"../../img/rnw/marker/"+ (imgNm || "marker-nocharge") + statusClass + ".svg",
                     opacity:0,
                     zIndex:9998
                });

                //충전소 말풍선 생성
                var _markerContents;
                _markerContents = '';

                _markerContents +=  '<section class="ol-popup overlay_container" data-bid="' + bid + '" data-sid="' + sid + '" data-lat="' + lat + '" data-lng="' + lng + '">';
                _markerContents +=      '<div>';
                _markerContents += 		    '<p>' + name + '</p>';
                _markerContents +=      '</div>';
                _markerContents += '</section>';

                var infoWindow = new KIA_ROUTO.InfoWindow({
                    content: _markerContents
                });

            //새로 검색할 때, 말풍선 닫기 위함
                CurrPage.mapsManager.infoWindowSettingsArray.push({
                    object: infoWindow
                });

                infoWindow.open({
                    anchor: marker,
                    map : CurrPage.mapsManager.mapObject
                });

                //마커 클릭 시, 충전소 상세 팝업 evt
                marker.addListener('click', function(e) {
                    var param = {
                        bid: bid,
                        sid: sid,
                        lat: lat,
                        lng: lng
                    }

                    if(!(param.lat && param.lng)){
                        MPopup.alert("위치정보가 존재하지 않습니다.");
                        return false;
                    }

                    var options = {
                        url: PATH_MANAGER.KIA_RNW_583_0000.path,
                        param: param,
                        animate : "MODAL_UP"
                    }

                    MPage.html(options);
                });
            }
        });


        //말풍선 클릭 시, 충전소 상세 팝업 evt
        $(".overlay_container").on("off").on("click",function(){
            var param = {
                bid: $(this).closest('.ol-overlay-container').find('section').data('bid'),
                sid: $(this).closest('.ol-overlay-container').find('section').data('sid'),
                lat: $(this).closest('.ol-overlay-container').find('section').data('lat'),
                lng: $(this).closest('.ol-overlay-container').find('section').data('lng')
            }

            if(!(param.lat && param.lng)){
                MPopup.alert("위치정보가 존재하지 않습니다.");
                return false;
            }

            var options = {
                url: PATH_MANAGER.KIA_RNW_583_0000.path,
                param: param,
                animate : "MODAL_UP"
            }

            MPage.html(options);
        });
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_580_0000.init();
    },
    onHide : function(event){},
    onRestore : function(event){},
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){},
    onPause : function(event){},
    onResume : function(event){}
}; 
