/**

@파일명 : KIA_RNW_582_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전소 검색_검색 
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[X]	내연보유[X]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_582_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        //evt
        CurrPage.setEventListner();

        //스토리지에 저장된 검색어 조회
        CurrPage.getSrchKwdList();

        //최초 진입 시, 입력창 포커스
        $("#nearSearchInput").focus();
    },
    pageNo: 1,
    setEventListner: function(){

        //슬라이더 evt
        CurrPage.sliderEvt();

        //scroll evt
        CurrPage.scrollEvt();

        //검색
        $(".btn-search").on("click", function(){
            //페이지 번호 및 스크롤(T/F) 초기화
            CurrPage.pageNo = 1;
            CurrPage.scrollIsOk = true;

            CurrPage.getSrchStation()
            .then(function(){
                exWNHideIndicator();
            });
        });

        //엔터 클릭 시,
        $('#nearSearchInput').on("keyup", function (e) {
            if (e.keyCode === 13) {
                //페이지 번호 및 스크롤(T/F) 초기화
                CurrPage.pageNo = 1;
                CurrPage.scrollIsOk = true;

                CurrPage.getSrchStation()
                .then(function(){
                    exWNHideIndicator();
                });
            }
        });

        //조회 카테고리 영역 evt
        $("#dataGb button").on("click", function(){
            //페이지 번호 및 스크롤(T/F) 초기화
            CurrPage.pageNo = 1;
            CurrPage.scrollIsOk = true;
            var cateCd = $(this).data("cd");

            CurrPage.getSrchStation(cateCd)
            .then(function(){
                exWNHideIndicator();
            });
        })

        //주소 복사 evt
        $(".btn-copy").on("click", function(){
            //주소 복사
            COMMON_FUNCTION.TOOL.UI.copyToClipboard($(this).closest("p"), true);
        });

        //위치전송 팝업
        $(".btn-send").on("click", function(){
            var stationName = $(this).data('stationName');
            var stationCoord = {
                lat : $(this).data('lat'),
                lng : $(this).data('lng')
            }
            CurrPage.onClickSendLocation(stationName, stationCoord);
        });

        //충전소 상세보기
        $(".btn-arrow-right").closest('.text-scale-04').find('b, button').on("click",function(){

            var bid = $(this).closest('dt').data('bid');
            var sid = $(this).closest('dt').data('sid');
            var lat = $(this).closest('dt').data('lat');
            var lng = $(this).closest('dt').data('lng');

            if(!(lat && lng)){
                MPopup.alert("위치정보가 존재하지 않습니다.");
                return false;
            }

            var options = {
                url: PATH_MANAGER.KIA_RNW_583_0000.path,
                param: {
                    bid: bid,
                    sid: sid,
                    lat: lat,
                    lng: lng
                },
                animate : "MODAL_UP"
            }

            MPage.html(options);
        });
    },
    pageNo: 1,  //현재 페이지
    scrollIsOk: true,
    scrollEvt: function(){
        $(window).scroll(function(){
            var $ws = $(window).scrollTop();
            var $wh = $(window).height();
            var $dh = $(document).height();

            if(Math.floor($ws) == $dh - $wh){
                if(CurrPage.scrollIsOk){
                    CurrPage.scrollIsOk = false;
                    ++CurrPage.pageNo;
                    CurrPage.getSrchStation()
                    .then(function(){
                        exWNHideIndicator();
                    });
                }
            }
        });
    },
    sliderEvt: function(){

        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)
            _sliderFilterList.slideTo(getSlideIdx, 300, false);
            $('.slider-filter-list').find('.active').removeClass('active');
            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+ getSlideIdx +']').addClass('active');
        });
    },
    getSrchKwdList: function(){

        var tagHtml = "";
        var srchKwdList = MData.storage('srchKwdList');

        if(srchKwdList.length > 0){

            //마지막에 담긴 값부터 노출하기 위함..
            srchKwdList = srchKwdList.reverse();

            tagHtml +=  "<div class='div-title'>"
                    +       "<h6 class='text-scale-06'><b>최근 검색</b></h6>"
                    +   "</div>"
                    +   "<div class='div-body'>"
                    +       "<ul>"

            srchKwdList.forEach(function(item){
                tagHtml +=          "<li>"
                        +               "<span class='text-scale-05 storeKwd'>" + item + "</span>"
                        +               "<button type='button' class='btn-delete'><em class='blind'>삭제</em></button>"
                        +           "</li>";
            });

            tagHtml +=      "</ul>"
                    +   "</div>";

        }else{

            tagHtml +=  "<div class='div-title'>"
                    +       "<h6 class='text-scale-06'><b>최근 검색</b></h6>"
                    +   "</div>"
                    +   "<div class='div-body'>"
                    +       "<div class='nodata-area'>"
                    +           "<p>최근 검색 내역이 없습니다.</p>"
                    +       "</div>"
                    +   "</div>";
        }

        $("#srchKwdCon").html(tagHtml);

        //저장된 검색어 클릭 evt
        $(".storeKwd").on("click", function(){
            $("#nearSearchInput").val($(this).text());
            CurrPage.getSrchStation()
            .then(function(){
                exWNHideIndicator();
            });
        });

        //삭제 evt
        $(".btn-delete").on("click", function(){
            var delKwd = $(this).prev('span').text();
            var arrIdx = srchKwdList.indexOf(delKwd);
            srchKwdList.splice(arrIdx, 1);

            $(this).closest('li').remove();
            MData.storage('srchKwdList', srchKwdList);
        });
    },
    getSrchStation: function(cateCd){
        return new Promise(function (resolve) {
            var tagHtml = "";
            var keyword = $("#nearSearchInput").val();

            if(keyword == null || keyword == "" || keyword == undefined){
                MPopup.instance("검색어를 입력해 주세요");
                $("#nearSearchInput").focus();
                return false;
            }

            //저장된 검색어
            var srchKwdList = MData.storage('srchKwdList');

            if(srchKwdList){
                //현재 검색어가 저장된 값인지 체크
                if(srchKwdList.includes(keyword)){
                    var arrIdx = srchKwdList.indexOf(keyword);
                    srchKwdList.splice(arrIdx, 1);
                    srchKwdList.push(keyword);
                }else{
                    srchKwdList.push(keyword);
                }

                //최대 3개까지만 저장
                if(srchKwdList.length > 3){
                    //오래된 데이터 삭제
                    srchKwdList.shift();
                }
            }else{
                srchKwdList = [keyword];
            }
            //저장소 새로 담기
            MData.storage('srchKwdList', srchKwdList);

            //검색 카테고리
            cateCd = cateCd ? cateCd : $("#dataGb .active button").data("cd");
            var sendData = {
                apiId: 'RNW-EVC-2001',
                mbrId: PGV.loginInfo.mbrId,
                schCd: "03",
                cateCd: cateCd ? cateCd : "ALL",
                keyword: keyword,
                lat: MData.param('lat'),
                lng: MData.param('lng'),
                currentPageNo: CurrPage.pageNo,
                pageSize: 10
            }

            MNet.httpSendAsync({
                path: _API.SVR.EV.evCharger.schEvChargerStation,
                sendData: sendData,
                isMock: false
            }).then(function (response) {

                console.log(JSON.stringify(response))

                if(response.resultCode == "200"){

                    var evChgrList = response.evChgrListRnwResDto;
                    $(".search-keyword-cont").addClass('result');

                    //첫페이지 초기화
                    if(CurrPage.pageNo == 1){
                        $("#srchKwdCon").html('');
                    }

                    if(evChgrList.length > 0){
                        $(".nodata-area").remove();
                        CurrPage.scrollIsOk = true;
                        $(".slider-filter-cont").show();

                        var divCon = $("#dummyDivCon .div-item").clone(true);

                        evChgrList.forEach(function(item){

                            var tmpDivCon = $(divCon).clone(true);
                            var statusClass = "";
                            var statusTxt = "";

                            //상세페이지에 보낼 param > <dt> Tag에 담기
                            $(tmpDivCon).find('dt').data('bid', item.bid);
                            $(tmpDivCon).find('dt').data('sid', item.sid);
                            $(tmpDivCon).find('dt').data('lat', item.lat);
                            $(tmpDivCon).find('dt').data('lng', item.lng);

                            //화면에 데이터 노출
                            $(tmpDivCon).find('dt').find('.d-flex em').text(item.bName);
                            $(tmpDivCon).find('dt').find('.text-scale-04 b').text(item.name);

                            //위치전송 버튼에 데이터 담기
                            $(tmpDivCon).find('dd .btn-send').data('stationName', item.name);
                            $(tmpDivCon).find('dd .btn-send').data('lat', item.lat);
                            $(tmpDivCon).find('dd .btn-send').data('lng', item.lng);

                            var tmpBtn = $(tmpDivCon).find('dd .group-01 .btn-copy').clone(true);
                            $(tmpDivCon).find('dd').find('.group-01 p').text(item.dAddr ? item.dAddr  : "");
                            $(tmpDivCon).find('dd').find('.group-01 p').append(tmpBtn);


                            /* 충전소 상태
                            '사용중','대기중','통신이상','사용불가','운영중지','예약중','상태미확인','점검중'
                            그 외는 '미조회'
                            */
                            if(item.status == "대기중"){
                                statusClass = "type1";
                                statusTxt = "충전가능";
                            }else if(item.status == "사용중" || item.status == "예약중"){
                                statusClass = "type2";
                                statusTxt = "사용중";
                            }else{
                                statusClass = "type3";
                                statusTxt = "상태 미확인";
                            }
                            $(tmpDivCon).find('dd .tag').addClass(statusClass);
                            $(tmpDivCon).find('dd .tag').text(statusTxt);


                            //충전기 타입 코드에 따라 아이콘 활성화
                            var arrType = item.chgrType.split(",");
                            arrType.forEach(function(type){
                                if(type == "01"){
                                    $(tmpDivCon).find(".ico-charge2").addClass('active');
                                }else if(type == "02"){
                                    $(tmpDivCon).find(".ico-charge4").addClass('active');
                                }else if(type == "03"){
                                    $(tmpDivCon).find(".ico-charge2, .ico-charge3").addClass('active');
                                }else if(type == "04"){
                                    $(tmpDivCon).find(".ico-charge1").addClass('active');
                                }else if(type == "05"){
                                    $(tmpDivCon).find(".ico-charge1, .ico-charge2").addClass('active');
                                }else if(type == "06"){
                                    $(tmpDivCon).find(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
                                }else if(type == "07"){
                                    $(tmpDivCon).find(".ico-charge3").addClass('active');
                                }
                            });

                            $("#srchKwdCon").append(tmpDivCon);
                        })

                    }else{
                        if($("#srchKwdCon div").length < 1 && $(".nodata-area").length < 1){
                            $(".search-keyword-cont").addClass('result');
                            $(".slider-filter-cont").hide();

                            tagHtml =   "<div class='nodata-area'>"
                                    +       "<div class='ico-cont'>"
                                    +           "<i class='ico-nodata-charging'></i>"
                                    +       "</div>"
                                    +       "<p>검색 내역이 없습니다.</p>"
                                    +   "</div>";

                            $("#srchKwdCon").html('').closest('.inner-cont').append(tagHtml);
                            MPopup.instance("검색 결과가 없습니다.");
                        }
                    }
                }else{
                    if($(".nodata-area").length < 1){
                        $(".search-keyword-cont").addClass('result');
                        $(".slider-filter-cont").hide();

                        tagHtml =   "<div class='nodata-area'>"
                                +       "<div class='ico-cont'>"
                                +           "<i class='ico-nodata-charging'></i>"
                                +       "</div>"
                                +       "<p>검색 내역이 없습니다.</p>"
                                +   "</div>";
    　
                        $("#srchKwdCon").html('').closest('.inner-cont').append(tagHtml);
                        MPopup.instance("검색 결과가 없습니다.");
                    }
                }

                resolve();
            });
        })
    },
    onClickSendLocation: function(stationName, stationCoord){
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_242_1000.path, function () {
            var parentThis = this;
            var closePopup = function (e, parentThis) {
                e.preventDefault();

                parentThis.fadeOut('fast');
                parentThis.find('.popup-wrap').removeClass('is-ani');

                $('body').removeClass('js-overflow-hidden');
            }
            this.find("ul li").off("click").on("click", function (e) {
                var targetApp = $(this).data('target-app');
                switch(targetApp){
                    case "kakaomap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('k', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "tmap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('t', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "kia-connect":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('kc', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                }
                closePopup(e, parentThis);
            })
            this.find('#mykia-close-popup').off("click").on("click", function (e) {
                closePopup(e, parentThis);
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_582_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
