/**

@파일명 : KIA_RNW_583_0000.js 
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 :  충전소 상세 팝업
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[X]	내연보유[X]	EV보유[O]

*   1. 충전소 정보는 서버에서 가져옴
*   2. 충전기 정보는 에스트래픽 일 때만, 에스트래픽 실시간 조회
*/ 
var CurrPage;
var greenPass;
var KIA_RNW_583_0000 ={ 
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        exWNShowIndicator();
        //set evt
        CurrPage.setEventListner();

        //충전소 상세조회
        CurrPage.getStationDtl()
        .then(function(response){
            //충전기 정보는 에스트래픽 일 때만, 에스트래픽 실시간 조회
            if(response.evChgrDtlRnwResDto.bid == "ST"){
                return CurrPage.getSscChrgList();
            }else{
                return CurrPage.getChrgList(response);
            }
        })
        .then(function(){
            //routo Map 최초 좌표 init
            CurrPage.initCoords()
            .then(function(){
                CurrPage.mapsManager.init_async('routoMap')
                .then(function(){
                    /* 2023.12.12 지도 loading 실패 시 mapObject 에 작업 생략 */
                    if (CurrPage.mapsManager.mapObject) {
                        //충전소 routo map
                        CurrPage.setRoutoCenter();

                        //최초 좌표 및 충전소 마커
                        CurrPage.setRoutoMarkerInit();

                        //지도 area evt (클릭이벤트 포함)
                        CurrPage.fnSetMapCont();
                    }
                    exWNHideIndicator();
                })
            })
        })


    }, 
    setEventListner: function(){

        //나만의 충전소 등록/해제
        $("#myChgrYn").on("click", function(){
            var myChgrYn = $("#myChgrYn").data("myChgrYn");
            if(myChgrYn == "Y")
            {
                CurrPage.setFavoriteStation("D");
            }else{
                CurrPage.setFavoriteStation("I");
            }
        });

        //주소 복사 evt
        $(".btn-copy").on("off").on("click", function(){
            //주소 복사
            COMMON_FUNCTION.TOOL.UI.copyToClipboard($(this).closest("p"), true);
        });

        //위치전송 팝업
        $("#btnSend").on("click", function(){
            var stationName = $(this).data('stationName');
            var stationCoord = {
                lat : $(this).data('lat'),
                lng : $(this).data('lng')
            }
            CurrPage.onClickSendLocation(stationName, stationCoord);
        });

        //충전기 상태 새로고침
        $(".btn-refresh").on("click", function(){
            //충전소 상세조회
            CurrPage.getStationDtl()
            .then(function(response){
                //충전기 정보는 에스트래픽 일 때만, 에스트래픽 실시간 조회
                if(response.evChgrDtlRnwResDto.bid == "ST"){
                    return CurrPage.getSscChrgList();
                }else{
                    return CurrPage.getChrgList(response);
                }
            })
            .then(function(){
                /* 2023.12.12 지도 loading 실패 시 mapObject 에 작업 생략 */
                if (CurrPage.mapsManager.mapObject) {
                    //충전소 routo map
                    CurrPage.setRoutoCenter();

                    //최초 좌표 및 충전소 마커
                    CurrPage.setRoutoMarkerInit();
                }

                exWNHideIndicator();

            })
        });

        //충전 예약 클릭 evt
        $(".btn-block .btn-default").on("off").on("click", async function(){
            if (!(await isAvailableSSCharger())) return;

            var cid = $(this).data('cid');
            var type = $(this).data('type');

            var options = {
                url: PATH_MANAGER.KIA_RNW_583_3000.path,
                param: {
                    name: $("#name").text(),
                    dAddr: $("#dAddr").text(),
                    sid: MData.param('sid'),
                    cid: cid,
                    type: type
                }
            }
            MPage.html(options);
        })
    },
    setFavoriteStation: function(regCd){
        var sendData = {
            apiId: 'RNW-EVC-1002',
            mbrId: PGV.loginInfo.mbrId,
            regCd: regCd,
            bid: MData.param('bid'),
            sid: MData.param('sid')
        }

        MNet.httpSendAsync({
            path: _API.SVR.EV.evCharger.evChargerFavoriteReg,
            sendData: sendData,
            indicatorYn: "N",
            isMock: false
        }).then(function (response) {
            console.log(JSON.stringify(response))

            if(response.resultCode == "200"){
                if(response.evMyChgrRegRnwResDto.regDelYn == 'Y'){

                    if(regCd == "I"){
                        $("#myChgrYn").data("myChgrYn", "Y");
                        $("#myChgrYn").addClass('active');
                        MPopup.instance("나만의 충전소로 등록되었습니다.");
                    }else if(regCd == "D"){
                        $("#myChgrYn").data("myChgrYn", "N");
                        $("#myChgrYn").removeClass('active');
                        MPopup.instance("나만의 충전소가 삭제되었습니다.");
                    }

                }else{
                    if($("#myChgrYn").data("myChgrYn") == "Y"){
                        $("#myChgrYn").addClass('active');
                    }else{
                        $("#myChgrYn").removeClass('active');
                    }

                    MPopup.instance("저장 실패 했습니다.");
                }
            }
        })
    },
    onClickSendLocation: function(stationName, stationCoord){
        COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_242_1000.path, function () {
            var parentThis = this;
            var closePopup = function (e, parentThis) {
                e.preventDefault();

                parentThis.fadeOut('fast');
                parentThis.find('.popup-wrap').removeClass('is-ani');

                $('body').removeClass('js-overflow-hidden');
            }
            this.find("ul li").off("click").on("click", function (e) {
                var targetApp = $(this).data('target-app');
                switch(targetApp){
                    case "kakaomap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('k', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "tmap":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('t', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                    case "kia-connect":
                        COMMON_FUNCTION.TOOL.GPS.callNavigationApp('kc', stationName, stationCoord.lng, stationCoord.lat);
                        break;
                }
                closePopup(e, parentThis);
            })
            this.find('#mykia-close-popup').off("click").on("click", function (e) {
                closePopup(e, parentThis);
            })
        })
    },
    getStationDtl: function(){
        return new Promise(function (resolve) {

            var sendData = {
                apiId: 'RNW-EVC-2002',
                mbrId: PGV.loginInfo.mbrId,
                bid: MData.param('bid'),
                sid: MData.param('sid'),
                lat: MData.param('lat'),
                lng: MData.param('lng')
            }

            MNet.httpSendAsync({
                path: _API.SVR.EV.evCharger.schEvChargerStationDtl,
                sendData: sendData,
                isMock: false
            }).then(function (response) {
                console.log(JSON.stringify(response))

                if(response.resultCode == "200"){

                    var data = response.evChgrDtlRnwResDto;
                    greenPass = data.greenPassAt;
                    /*!CurrPage.noGpsCoords && data.dist && $("#dist").text(data.dist + "km");*/
                    if(greenPass == "Y"){
                        $("#bName").text(data.bName + " | ");
                        $("#greenPassAt").text('\u00A0' +"기아 그린패스 충전소");
                    }else{
                        $("#bName").text(data.bName);
                        $("#greenPassAt").text("");
                    }
                    $("#name").text(data.name);

                    //즐겨찾기한 충전소일 경우,
                    if(data.myChgrYn == "Y")
                    {
                        $("#myChgrYn").addClass("active");
                    }
                    $("#myChgrYn").data("myChgrYn", data.myChgrYn);
                    var tmpBtn = $("#dAddr").find('.btn-copy').clone(true);
                    $("#dAddr").text(data.dAddr);
                    $("#dAddr").append(tmpBtn);

                    //위치 전송 데이터 담기기
                    $("#btnSend").data('lat', MData.param('lat'));
                    $("#btnSend").data('lng', MData.param('lng'));
                    $("#btnSend").data('stationName', data.name);


                    resolve(response);


                }else{
                    MPopup.alert({
                        message: "죄송합니다. 충전소 정보를 찾을 수 없습니다.\n다른 충전소를 이용해 주세요.",
                        callback : function(){
                            MPage.back();
                        }
                    });
                }
            })
        })
    },
    getChrgList: function(response){
        return new Promise(function(resolve){
            //충전기 리스트
            var data = response.evChgrDtlRnwResDto;
            var chrgList = response.chargerList;
            var updateTime = chrgList[0].updateTime;
            var formatTime = moment(updateTime, "YYYYMMDDHHmmss").format('YYYY-MM-DD HH:mm:ss');
            $("#updateTime").text(formatTime);

            //에스트래픽은 충전기 기준, 그 외는 충전소 상태값으로 marker 이미지 지정하기 위함
            $("#name").data('status', data.status);

            if(chrgList){
                $("#chargerList").html("");
                var divCon = $("#dummyDivCon").clone(true);

                //초급속, 급속, 완속 카운트
                //$("#superFastCnt").text(0);
                $("#fastCnt").text(data.rpdChgrCnt);
                $("#slowCnt").text(data.slwChgrCnt);
                //DC콤보, DC차데모, AC상, 완속 카운트
                $("#dcCmbCnt em").text(data.dcCmbCnt);
                $("#dcDmCnt em").text(data.dcDmCnt);
                $("#acCnt em").text(data.acCnt);
                $("#acSlwCnt em").text(data.acSlwCnt);

                chrgList.forEach(function(item, idx){
                    var tmpDivCon = $(divCon).clone(true);
                    var statusTxt = "";
                    //디폴트 급속
                    var speedTxt = "급속";

                    $(tmpDivCon).find('.div-table .cell-01 .num').text(item.cid);

                    //충전기 상태 코드
                    if(item.status == "0"){
                        $(tmpDivCon).addClass('type3');
                        statusTxt = "알수없음";
                    }else if(item.status == "1"){
                        $(tmpDivCon).addClass('type3');
                        statusTxt = "통신이상";
                    }else if(item.status == "2"){
                        $(tmpDivCon).addClass('type2');
                        statusTxt = "충전대기";
                    }else if(item.status == "3"){
                        $(tmpDivCon).addClass('type1');
                        statusTxt = "충전중";
                    }else if(item.status == "4"){
                        $(tmpDivCon).addClass('type3');
                        statusTxt = "운영중지";
                    }else if(item.status == "5"){
                        $(tmpDivCon).addClass('type3');
                        statusTxt = "점검중";
                    }else if(item.status == "6"){
                        $(tmpDivCon).addClass('type1');
                        statusTxt = "예약중";
                    }else if(item.status == "9"){
                        $(tmpDivCon).addClass('type3');
                        statusTxt = "상태 미확인";
                    }

                    //충전기 예약 가능 여부
                    if(item.reservYn == "Y"){
                        $(tmpDivCon).find('.btn-block').show();
                        $(tmpDivCon).find('.btn-block .btn-default').data('cid', item.cid);
                        $(tmpDivCon).find('.btn-block .btn-default').data('type', item.chgrType);
                    }

                    $(tmpDivCon).find('.div-table .cell-02 p').text(statusTxt);

                    //충전기 타입 코드에 따라 아이콘 활성화
                    if(item.chgrType == "01"){
                        $(tmpDivCon).find(".ico-charge2").addClass('active');
                    }else if(item.chgrType == "02"){
                        speedTxt = "완속";
                        $(tmpDivCon).find(".ico-charge4").addClass('active');
                    }else if(item.chgrType == "03"){
                        $(tmpDivCon).find(".ico-charge2, .ico-charge3").addClass('active');
                    }else if(item.chgrType == "04"){
                        $(tmpDivCon).find(".ico-charge1").addClass('active');
                    }else if(item.chgrType == "05"){
                        $(tmpDivCon).find(".ico-charge1, .ico-charge2").addClass('active');
                    }else if(item.chgrType == "06"){
                        $(tmpDivCon).find(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
                    }else if(item.chgrType == "07"){
                        $(tmpDivCon).find(".ico-charge3").addClass('active');
                    }

                    $(tmpDivCon).find('.div-table .cell-02 span').text(speedTxt);

                    $(tmpDivCon).show();
                    $("#chargerList").append(tmpDivCon);
                });
            }

            resolve();
        })
    },
    getSscChrgList: function(){
        return new Promise(function(resolve){
                //에스트래픽 충전기 실시간 정보 요청
                var sendData = {
                    bid: MData.param('bid'),
                    sid: MData.param('sid')
                }

                MNet_SSC.httpSend({
                    path: SSC_API.basicChrgInfo.url,
                    sendData: sendData,
                    callback: function(response){
                        console.log(response)
                        console.log(JSON.stringify(response))

                        if(response.resultCode == "0000"){
                            $("#updateTime").text(moment(response.responseDate).format('YYYY-MM-DD HH:mm:ss'));
                            //초급속, 급속, 완속 카운트
                            //var superFastCnt = 0;
                            var fastCnt = 0;
                            var slowCnt = 0;

                            //DC콤보, DC차데모, AC상, 완속 카운트
                            var dcCmbCnt = 0;
                            var dcDmCnt = 0;
                            var acCnt = 0;
                            var acSlwCnt = 0;

                            //에스트래픽은 충전기 기준, 그 외는 충전소 상태값으로 marker 이미지 지정하기 위함
                            $("#name").data('status', "");

                            if(response.chargerStationInfoList.length > 0){
                                //해당 충전소
                                var stationInfo = response.chargerStationInfoList;
                                //충전기 리스트
                                var chrgList = stationInfo[0].chargerInfoList;

                                //에스트래픽은 충전기 기준, 그 외는 충전소 상태값으로 marker 이미지 지정하기 위함
                                var reservOk = chrgList.some(function(el){if(el.status == "2"){return true;}});

                                if(reservOk){
                                    $("#name").data('status', "대기중");
                                }else{
                                    var useOk = chrgList.some(function(el){if(el.status == "3" || el.status == "6"){return true;}});

                                    if(useOk){
                                        $("#name").data('status', "사용중");
                                    }
                                }

                                if(chrgList){
                                    $("#chargerList").html("");
                                    var divCon = $("#dummyDivCon").clone(true);

                                    //충전기 번호로 내림차순하기 위함
                                    chrgList.sort(function(a,b){
                                        if(a.cid < b.cid) return -1;
                                    })

                                    chrgList.forEach(function(item, idx){
                                        var tmpDivCon = $(divCon).clone(true);
                                        var statusTxt = "";
                                        var speedTxt = "";

                                        $(tmpDivCon).find('.div-table .cell-01 .num').text(item.cid);

                                        //충전기 상태 코드
                                        if(item.status == "0"){
                                            $(tmpDivCon).addClass('type3');
                                            statusTxt = "알수없음";
                                        }else if(item.status == "2"){
                                            $(tmpDivCon).addClass('type2');
                                            statusTxt = "충전대기";
                                        }else if(item.status == "3"){
                                            $(tmpDivCon).addClass('type1');
                                            statusTxt = "충전중";
                                        }else if(item.status == "4"){
                                            $(tmpDivCon).addClass('type3');
                                            statusTxt = "운영중지";
                                        }else if(item.status == "5"){
                                            $(tmpDivCon).addClass('type3');
                                            statusTxt = "점검중";
                                        }else if(item.status == "6"){
                                            $(tmpDivCon).addClass('type1');
                                            statusTxt = "예약중";
                                        }else if(item.status == "9"){
                                            $(tmpDivCon).addClass('type3');
                                            statusTxt = "상태 미확인";
                                        }

                                        //충전기 예약 가능 여부
                                        if(item.reservyn == "Y"){
                                            $(tmpDivCon).find('.btn-block').show();
                                            $(tmpDivCon).find('.btn-block .btn-default').data('cid', item.cid);
                                            $(tmpDivCon).find('.btn-block .btn-default').data('type', item.type);
                                        }

                                        $(tmpDivCon).find('.div-table .cell-02 p').text(statusTxt);

                                        //충전속도 TEXT
                                        if(item.chargerSpeed == "01"){
                                            speedTxt = "완속";
                                            ++slowCnt;
                                        }else if(item.chargerSpeed == "02"){
                                            speedTxt = "급속";
                                            ++fastCnt;
                                        }/*else if(item.chargerSpeed == "3"){
                                            speedTxt = "초급속";
                                            ++superFastCnt;
                                        }*/

                                        $(tmpDivCon).find('.div-table .cell-02 span').text(speedTxt);


                                        //충전기 타입 코드에 따라 아이콘 활성화
                                        var arrType = item.type.split(",");
                                        arrType.forEach(function(type){
                                            if(item.type == "01"){
                                                ++dcDmCnt;
                                                $(tmpDivCon).find(".ico-charge2").addClass('active');
                                            }else if(item.type == "02"){
                                                ++acSlwCnt;
                                                $(tmpDivCon).find(".ico-charge4").addClass('active');
                                            }else if(item.type == "03"){
                                                ++dcDmCnt;
                                                ++acCnt;
                                                $(tmpDivCon).find(".ico-charge2, .ico-charge3").addClass('active');
                                            }else if(item.type == "04"){
                                                ++dcCmbCnt;
                                                $(tmpDivCon).find(".ico-charge1").addClass('active');
                                            }else if(item.type == "05"){
                                                ++dcCmbCnt;
                                                ++dcDmCnt;
                                                $(tmpDivCon).find(".ico-charge1, .ico-charge2").addClass('active');
                                            }else if(item.type == "06"){
                                                ++dcCmbCnt;
                                                ++dcDmCnt;
                                                ++acCnt;
                                                $(tmpDivCon).find(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
                                            }else if(item.type == "07"){
                                                ++acCnt;
                                                $(tmpDivCon).find(".ico-charge3").addClass('active');
                                            }
                                        });

                                        $(tmpDivCon).show();
                                        $("#chargerList").append(tmpDivCon);
                                    });
                                }
                            }

                            //$("#superFastCnt").text(superFastCnt);
                            $("#fastCnt").text(fastCnt);
                            $("#slowCnt").text(slowCnt);
                            $("#dcCmbCnt em").text(dcCmbCnt);
                            $("#dcDmCnt em").text(dcDmCnt);
                            $("#acCnt em").text(acCnt);
                            $("#acSlwCnt em").text(acSlwCnt);
                        }
                        resolve();
                    }
                })
        })
    },
    mapsManager: COMMON_FUNCTION.ROUTO.mapsManager,
    noGpsCoords: false,
    initCoords: function(){
        return COMMON_FUNCTION.TOOL.GPS.getGPSCoordsAsync(CurrPage)/** gps정보획득 */
        .then(/** gps 주소명 획득 */
            function (gps) {
                //초기 좌표 값
                CurrPage.initLat = gps.latitude;
                CurrPage.initLng = gps.longtitude;
            }
        )
    },
    setRoutoCenter: function(obj){

        console.log("지도 그립시다 :::::::::::::::::::::::" + MData.param('lat'))
        console.log("지도 그립시다 :::::::::::::::::::::::" + MData.param('lng'))

        //CurrPage.mapsManager.mapObject의 함수가 정상적으로 load되지 않았을 경우를 감안한  setInterval
        var loadCounter = 0;
        var chkMapObj = setInterval(function(){
            if(loadCounter === 100){
                MPopup.confirm({
                    message : "지도 불러오기에 실패하였습니다. 잠시 후 다시 시도해주세요.",
                    buttons : ["확인"],
                    callback : function(idx){
                        MPage.back();
                    }
                });
                console.error("mapsManager : routo 로딩 타임 아웃");
            }

            loadCounter++;

            /** floating-layer 위로 마커를 지도 중앙에 맞추기 위함(2022-05-09) **/
            var lat,lng;
            lat = obj && obj.lat || MData.param('lat');
            lng = obj && obj.lng || MData.param('lng');

            //조회하려는 위경도의 원 좌표 확인
            var fromLonLat = KIA_ROUTO_ORIGINAL.proj.fromLonLat([Math.abs(parseFloat(lng)), Math.abs(parseFloat(lat))]);
            //원 좌표를 픽셀로 표현
            var getPixelFromCoordinate = CurrPage.mapsManager.mapObject.getPixelFromCoordinate([fromLonLat[0], fromLonLat[1]]);

            if(getPixelFromCoordinate != null){
                //x축 pixel
                var pixelX = getPixelFromCoordinate[0];
                //y축 pixel
                var pixelY = getPixelFromCoordinate[1];

                console.log("픽셀::::::::::::::::::::::::"+pixelX)
                console.log("픽셀::::::::::::::::::::::::"+pixelY)

                //routo 영역 총 높이 / 2
                var mapAreaHeight = $(".map-area").outerHeight() / 2;
                //센터를 잡을 지도 영역 높이 / 2
                var mapConHeight = $(".map-cont").outerHeight() / 2 ;

                //center를 맞추기 위한 높이 계산
                var reqHeight = pixelY + Math.abs(mapAreaHeight - mapConHeight);

                //센터로 잡을 원 좌표값 구하기
                var centerPrj = CurrPage.mapsManager.mapObject.getCoordinateFromPixel([pixelX,reqHeight]);
                //원 좌표 -> 위,경도
                lng = KIA_ROUTO_ORIGINAL.proj.toLonLat(centerPrj)[0];
                lat = KIA_ROUTO_ORIGINAL.proj.toLonLat(centerPrj)[1];

                CurrPage.mapsManager.mapObject.setCenter({lat: lat, lng: lng});

                clearInterval(chkMapObj);
            }
        }, 100);
    },
    setRoutoMarkerInit: function(){

        CurrPage.mapsManager.mapObject.clearMarker();
        CurrPage.mapsManager.infoWindowSettingsArray.map(function(el){el.object.close();});

        //기관별 이미지
        var bidMarkerList = new Map();
        bidMarkerList.set("BT", "marker-botary");
        bidMarkerList.set("CV", "marker-dycb");
        bidMarkerList.set("DE", "marker-daegu");
        bidMarkerList.set("DG", "marker-daegu");
        bidMarkerList.set("EP", "marker-ep-new");
        bidMarkerList.set("EV", "marker-everon");
        bidMarkerList.set("G1", "marker-kwangju");
        bidMarkerList.set("G2", "marker-kwangju");
        bidMarkerList.set("GN", "marker-gntel");
        bidMarkerList.set("GP", "marker-gunpo");
        bidMarkerList.set("GS", "marker-gs");
        bidMarkerList.set("HE", "marker-kevcs-3");
        bidMarkerList.set("IK", "marker-iksan");
        bidMarkerList.set("JD", "marker-jejudo");
        bidMarkerList.set("JE", "marker-jeju");
        bidMarkerList.set("JJ", "marker-jeonju");
        bidMarkerList.set("JN", "marker-jncplan");
        bidMarkerList.set("JU", "marker-jeongeup");
        bidMarkerList.set("KN", "marker-keco");
        bidMarkerList.set("KP", "marker-kepco");
        bidMarkerList.set("KP_GREEN", "marker-kepco-green");
        bidMarkerList.set("KT", "marker-kt");
        bidMarkerList.set("ME", "marker-korea");
        bidMarkerList.set("PI", "marker-chargev");
        bidMarkerList.set("PW", "marker-pwrcube-new");
        bidMarkerList.set("SE", "marker-seoul");
        bidMarkerList.set("SG", "marker-signet");
        bidMarkerList.set("ST", "marker-straffic");
        bidMarkerList.set("ST_GREEN", "marker-straffic-green");
        bidMarkerList.set("YY", "marker-yangyang");

        var bid = MData.param('bid');
        var imgNm = bidMarkerList.get(bid);

        if(greenPass == "Y"){
            imgNm = bidMarkerList.get(bid+"_GREEN");
        }
        //충전소 상태값
        var status = $("#name").data('status');
        var statusClass;


        console.log(status)

        if(status == "대기중"){
            statusClass = "01";
        }else if(status == "사용중" || status == "예약중"){
            statusClass = "02";
        }else{
            statusClass = "03";
        }

        //최초위치(gps or 본사) 마커 생성
        new KIA_ROUTO.Marker({
             position : {lat: Math.abs(parseFloat(CurrPage.initLat)), lng: Math.abs(parseFloat(CurrPage.initLng))},
             map: CurrPage.mapsManager.mapObject,
             icon:"../../img/rnw/main/mycar/icon_map_currentLocation.svg",
             opacity:0,
             zIndex:9999
        });

        //운영기관 별 마커 생성
        var marker = new KIA_ROUTO.Marker({
             position : {lat: Math.abs(parseFloat(MData.param('lat'))), lng: Math.abs(parseFloat(MData.param('lng')))},
             map: CurrPage.mapsManager.mapObject,
             icon:"../../img/rnw/marker/"+ (imgNm || "marker-nocharge") + statusClass + ".svg",
             opacity:0,
             zIndex:9998
        });

        //충전소 말풍선 생성
        var _markerContents;
        _markerContents = '';

        _markerContents +=  '<section class="ol-popup overlay_container">';
        _markerContents +=      '<div>';
        _markerContents += 		    '<p>' + $("#name").text() + '</p>';
        _markerContents +=      '</div>';
        _markerContents += '</section>';

        var _infowindow = new KIA_ROUTO.InfoWindow({
            content: _markerContents
        });

        //새로 검색할 때, 말풍선 닫기 위함
        CurrPage.mapsManager.infoWindowSettingsArray.push({
            object: _infowindow
        });

        _infowindow.open({
            anchor: marker,
            map : CurrPage.mapsManager.mapObject
        });
    },
    fnSetMapCont: function() {
        var _mapCont;

        _mapCont = '';
        _mapCont += '<div class="map-cont js-map-cont">';
        _mapCont += 	'<div class="nav-map-btns js-nav-map-btns">';
        _mapCont += 		'<button type="button" class="btn-map-current"><em class="blind">현위치로 이동</em></button>';
        _mapCont += 		'<button type="button" class="btn-map-search">충전소 위치로 이동</button>';
        _mapCont += 		'<button type="button" class="btn-map-close"><em class="blind">팝업 닫기</em></button>';
        _mapCont += 	'</div>';
        _mapCont += '</div>';

        $('#routoMap').find('.ol-viewport').append(_mapCont);

        //현위치로 이동
        $(".map-cont .btn-map-current").on("click", function(){
            CurrPage.initCoords()
            .then(function(){
                //충전소 routo map
                CurrPage.setRoutoCenter({lat: CurrPage.initLat, lng: CurrPage.initLng});
            })

        });

        //충전소 위치로 이동
        $(".map-cont .btn-map-search").on("click", function(){

            CurrPage.setRoutoCenter();
        });

        //팝업 닫기 버튼
        $(".map-cont .btn-map-close").on("click", function(){
            MPage.back({animate : "MODAL_DOWN"});
        });
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_583_0000.init(); 
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
