/**

@파일명 : KIA_RNW_583_3000.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전소 예약 시간 선택
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_583_3000 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START");

        //set evt
        CurrPage.setEventListner();

        //예약 가능한 충전기 시간 조회
        CurrPage.getPossibleTime()
        .then(function(){
            exWNHideIndicator();
        });
    }, 
    setEventListner: function(){
        //오늘 날짜 default
        $("#todayDt").text(moment().format('YYYY년 MM월 DD일'));

        //다음 페이지
        $("#nextBtn").on("click", function(){

            if(!$(this).hasClass('disabled')){
                //다음 페이지로 보낼 데이터 세팅
                CurrPage.setNextData();
            }
        });
    },
    setNextData: function(){

        /**
            name: 충전소명
            dAddr: 충전소 주소
            sid: 충전소 id
            visitTime: 방문일정 (visitDate)
            cid: 충전기 번호 (cid)
            type: 충전 타입 (type)
        **/

        var visitTime = $("input[type=radio]:checked").val();

        var options = {
            url: PATH_MANAGER.KIA_RNW_583_4000.path,
            param: {
                name: MData.param('name'),
                dAddr: MData.param('dAddr'),
                sid: MData.param('sid'),
                visitTime: visitTime,
                cid: MData.param('cid'),
                type: MData.param('type')
            }
        }

        MPage.html(options);
    },
    getPossibleTime: function(){
        return new Promise(function (resolve) {
            var sendData = {
                sid: MData.param('sid'),
                cid: MData.param('cid'),
                reservationDate: moment().format('YYYY-MM-DD')
            }

            MNet_SSC.httpSend({
                path: SSC_API.possibletime.url,
                sendData: sendData,
                callback: function(response){
                    console.log(JSON.stringify(response))

                    if(response.resultCode == "0000"){
                        var resvList = response.possibleReservationTimeInfo;

                        if(resvList.length > 0){
                            resvList.forEach(function(item, idx){
                                var posiHtml = "";
                                var posiNo = item.no;
                                //현재시각
                                var nowFullTime = moment();
                                //1시간 뒤 시간
                                var lateFullTime = moment(nowFullTime).add('1', 'H');
                                //에스트래픽에서 받아온 가능한 시간
                                var posiFullTime = moment(item.possibleReservationTime);

                                //AS-IS: 지금 시간으로부터 1시간 이내만 예약 가능
                                if(nowFullTime < posiFullTime && lateFullTime > posiFullTime){
                                    var posiTime = moment(item.possibleReservationTime).format("HH:mm");

                                    posiHtml += "<li>"
                                    posiHtml +=     "<label class='radio-input' for='time"+ posiNo +"'>"
                                    posiHtml +=         "<input type='radio' id='time" + posiNo + "' name='time' value='" + posiTime + "'>"
                                    posiHtml +=         "<span>" + posiTime + "</span>"
                                    posiHtml +=     "</label>"
                                    posiHtml += "</li>";

                                    $(".txtinput-type").append(posiHtml);
                                }
                            });

                            //시간 선택 시 다음버튼 활성화
                            $(".txtinput-type li").on("click", function(){
                                $("#nextBtn").removeClass('disabled');
                            });

                        }else{
                            $(".txtinput-type").html("<p>예약 가능한 시간이 없습니다.</p>");
                        }
                    }else{
                        $(".txtinput-type").html("<p>예약 가능한 시간이 없습니다.</p>");
                    }

                    resolve();
                }
            })
        })
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_583_3000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
