/**

@파일명 : KIA_RNW_583_4000.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전 예약 확인
@DESC : 전체메뉴노출	[X]   계약차량보유	[X]   내연보유	[X]   EV보유	[O] ) 
*/ 
var CurrPage; 
var KIA_RNW_583_4000 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        //set evt
        CurrPage.setEventListner();

        //충전소 상세 정보 set
        CurrPage.setStationDtl();
    }, 
    setEventListner: function(){

        //예약 신청
        $("#reservBtn").on("click", function(){
            MPopup.confirm({
                message: "충전 예약 하시겠습니까?\n(예약 확정까지 최대 1분 소요됩니다.)",
                buttons: ["확인", "취소"],
                callback: function (idx){
                    if(idx == 0){
                        //예약하기
                        CurrPage.reqChrgReserv();
                        exWNHideIndicator();
                    }
                }
            })
        });
    },
    reTry: 0,
    setStationDtl: function(){

        //이전 이전 페이지에서 가져온 파라미터
        var today = moment().format('YYYYMMDD');
        var day = changeDate(today);
        var dayTxt = moment().format('YYYY-MM-DD') + " " + day + " " + MData.param('visitTime');

        $("#name").text(MData.param('name'));
        $("#dAddr").text(MData.param('dAddr'));
        $("#visitDate").text(dayTxt);
        $("#cid").text(MData.param('cid'));

        //충전기 타입 코드에 따라 아이콘 활성화
        var arrType = MData.param('type').split(",");
        arrType.forEach(function(type){
            if(type == "01"){
                $(".ico-charge2").addClass('active');
            }else if(type == "02"){
                $(".ico-charge4").addClass('active');
            }else if(type == "03"){
                $(".ico-charge2, .ico-charge3").addClass('active');
            }else if(type == "04"){
                $(".ico-charge1").addClass('active');
            }else if(type == "05"){
                $(".ico-charge1, .ico-charge2").addClass('active');
            }else if(type == "06"){
                $(".ico-charge1, .ico-charge2, .ico-charge3").addClass('active');
            }else if(type == "07"){
                $(".ico-charge3").addClass('active');
            }
        });
    },
    reqChrgReserv: function(){

        var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                    : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);

        var sendData = {
            ci: encCi,
            sid: MData.param('sid'),
            cid: MData.param('cid'),
            reservationDate: moment().format('YYYY-MM-DD'),
            reservationTime: MData.param('visitTime')
        }

        //AS-IS 소스 인용
        reqEvChrgrResv(sendData, function(receivedData){
            console.log(receivedData);


            // 예약번호
            var reservationNo = receivedData.reservationNo;
            CurrPage.resvStatusChk(reservationNo);

        }, function(code, msg){
            MPopup.alert({
                title : '알림',
                message : msg+"("+code+")",
            });
       });
    },
    resvStatusChk: function(reservationNo){
        var param  = { reservationNo : reservationNo};

        reqResvStatus(param, function(receivedData){
            var code = receivedData.reservationStatusCode*1;
            if(code == 21){
                MPopup.alert({
                    message : "예약이 완료되었습니다."
                    , callback : function(index){
                        exWNHideIndicator();

                        var options = {
                            url: PATH_MANAGER.KIA_RNW_583_5000.path,
                            param: {
                                name: $("#name").text(),
                                dAddr: $("#dAddr").text(),
                                visitDate: $("#visitDate").text(),
                                cid: $("#cid").text(),
                                type: MData.param('type')
                            }
                        }

                        MPage.html(options);
                    }
                });
            }else if(code < 21){
                if(CurrPage.reTry <5){
                    CurrPage.reTry = CurrPage.reTry +1;
                    setTimeout(function(){CurrPage.resvStatusChk(reservationNo);},5000);
                }else{
                    //예약 취소요청
                    canclEvChrgrResv(param, function(receivedData){
                        MPopup.alert({
                            message : "충전기가 응답하지않아 예약이 자동취소되었습니다.\n충전예약 현황목록을 확인해주세요."
                            , callback : function(index){
                                MPage.html({url : PATH_MANAGER.KIA_RNW_540_0000.path});
                            }
                        });
                    }, function(code, msg){
                        MPopup.alert(msg);
                    })
                }
            }else{
                exWNHideIndicator();

                MPopup.alert({
                    message : "충전예약에 실패하였습니다.\n충전예약 현황목록을 확인해주세요."
                    , callback : function(index){
                        MPage.html({url : PATH_MANAGER.KIA_RNW_540_0000.path});
                    }
                });
            }
        }, function(code, msg){
            exWNHideIndicator();
            MPopup.alert({
                title : '알림',
                message : msg+"("+code+")",
            });
       });
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_583_4000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
