/**

@파일명 : KIA_RNW_5B0_0000.js
@작성자 : 
@생성일 : 2022.01.26 
@메뉴명 : 충전 현황
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[X]	내연보유[X]	EV보유[O] 
*/ 
var CurrPage; 
var KIA_RNW_5B0_0000 ={
    init: function(){ 
        CurrPage = this; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 

        //set evt
        CurrPage.setEventListner();

        //ev카드 조회 후 충전 정보 가져오기
        CurrPage.getEvCardKey()
        .then(function(key){
            return CurrPage.getChrgInfo(key);
        })
        .then(function(){
            exWNHideIndicator();
        })
    },
    setEventListner: function(){

        //새로고침 버튼
        $("#homeHeader .btn-refresh").on("click", function(){
            CurrPage.getEvCardKey()
            .then(function(key){
                CurrPage._sliderVisual && CurrPage._sliderVisual.destroy();
                return CurrPage.getChrgInfo(key);
            })
            .then(function(){
                exWNHideIndicator();
            })
        });

        //swiper evt
        //CurrPage.swiperEvt();
    },
    swiperEvt: function(){
        // ------------------------------
        // 	Slider
        // ------------------------------
        CurrPage._sliderVisual = new Swiper('.slider-chargStatus', {
            slidesPerView:1,
            loop:true,
            speed:300,
            //grabCursor:true,
            touchRatio: $('.slider-chargStatus .swiper-slide').length > 1 ? true : false, // 슬라이드 영역 1개일경우 드래그 금지
            pagination: {
                el: '.chargStatus-cont .swiper-pagination',
                clickable: true,
            },
            // autoplay: {
            // 	delay:4000,
            // 	disableOnInteraction: false, // 사용자가 슬라이드 수동전환 하는경우 자동재생 멈추게 한다:true
            // },
            on: {
                slideChange: function () {

                    var idx = this.activeIndex;
                    var obj = this.$el.find('#chrgList .echarts').eq(idx);
                    var soc = $(obj).data('soc');

                    //슬라이드 변경 시, 차트 그림
                    if(soc){
                        CurrPage.fnSetEchartsCaseExpend(obj, soc);
                    }
                }
            }
        });
    },
    getEvCardKey: function(){
        return new Promise(function (resolve) {

            // [STraffic] STraffic 회원 카드 정보 조회 (EV-교통카드 번호)
            var encCi = CONFIG.IS_DEV? exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                        : exWNEncryptString(PGV.loginInfo.ci, CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);

            var sendData = {
                ci: encCi
            }

            MNet_SSC.httpSend({
                path : SSC_API.userCardInfo.url,
                sendData : sendData,
                callback: function(response){
                    console.log(JSON.stringify(response))
                    if(response.resultCode == "0000"){
                        resolve(response.evTrafficCardNo);
                    }else{
                        resolve();
                    }
                }
            });
        })
    },
    getChrgInfo: function(key){
        return new Promise(function (resolve) {
            console.log(key)
            var sendData = { evTrafficCardNo : key};

            MNet_SSC.httpSend({
                path: SSC_API.progressChrgInfo.url,
                sendData: sendData,
                callback: function(response){

                    $(".inner-info").show();

                    console.log(JSON.stringify(response))
                    if(response.resultCode == "0000"){

                        var chrgProgressList = response.chargeProgressInfo;
                        $(".main-visual-cont").show();
                        $(".nodata-area").hide();

                        if(chrgProgressList.length > 0){

                            var divCon = $("#dummyDivCon .swiper-slide").clone(true);
                            $("#chrgList").html('');

                            chrgProgressList.forEach(function(item,idx){
                                var tmpDivCon = $(divCon).clone(true);
                                var batteryCol = "case3";

                                //급속 충전기 경우 배터리량에 따라 색상 상이 (Default: 급속이 아닌 경우)
                                if(item.socBattery){

                                    //슬라이드 변경 시, 차트 그리기 위한 데이터 적재
                                    $(tmpDivCon).find('.echarts').attr('data-soc', item.socBattery);

                                    if(item.socBattery > 0 && item.socBattery <= 10){
                                        batteryCol = "";
                                    }else if(item.socBattery > 10 && item.socBattery <= 50){
                                        batteryCol = "case2";
                                    }else if(item.socBattery > 50 && item.socBattery <= 100){
                                        batteryCol = "case3";
                                    }

                                    var chrgHtml =  "<div class='div-table'>"
                                                +       "<div class='div-table-cell'>"
                                                +           "<strong>" + item.socBattery + "</strong>"
                                                +           "<em>충전중</em>"
                                                +       "</div>"
                                                +   "</div>";


                                    $(tmpDivCon).find('.echart-info').html(chrgHtml);
                                }

                                $(tmpDivCon).find('.echarts-cont').addClass(batteryCol);

                                var updDate = moment(item.lastDt).format('YYYY.MM.DD HH:mm:ss');
                                var elctcExpectTime = "";
                                if(item.elctcExpectTime && item.elctcExpectTime.length == 4){
                                    elctcExpectTime = moment(item.elctcExpectTime, 'HH:mm').format("HH:mm");
                                }else if(item.elctcExpectTime && item.elctcExpectTime.length == 6){
                                    elctcExpectTime = moment(item.elctcExpectTime, 'HH:mm:ss').format("HH:mm:ss");
                                }

                                $(tmpDivCon).find('.rapidTxt').html("<span>최근업데이트</span> " + updDate);
                                $(tmpDivCon).find('.name').text(item.chargerStationName);
                                $(tmpDivCon).find('.startDt').text(item.chrStartDate && item.chrStartDate || "-");
                                $(tmpDivCon).find('.expectTime').text(elctcExpectTime);
                                $(tmpDivCon).find('.chrgAmount').text(item.evChargeAmount + " kWh");

                                $("#chrgList").append(tmpDivCon);
                            });

                            //swiper evt
                            CurrPage.swiperEvt();
                        }else{
                            $(".chargStatus-cont").prop('class','chargStatus-cont');
                            $(".main-visual-cont").hide();
                            $(".nodata-area").show();
                        }
                    }else{
                        $(".chargStatus-cont").prop('class','chargStatus-cont');
                        $(".main-visual-cont").hide();
                        $(".nodata-area").show();
                    }

                    resolve();
                }
            })
        })
    },
    fnSetEchartsCaseExpend: function(obj, $now){


        var _echartsCaseExpend = echarts.init($(obj)[0]);
        //이미 그려진 차트가 있을수 있으므로 초기화
        _echartsCaseExpend.clear();
        var _echartsCaseExpend_option;
        var _echartsCaseExpend_colors = ['#5d7d2b','#f3c300'];

        //var $now = 0; //현재 충전량
        var $total = 100 - $now //남은 충전량
        var $color = '#5d7d2b';

        if($now < 11 && $now > 0){
            $color = '#ea0029'
        }else if($now < 51 && 10 < $now){
            $color = '#f3c300'
        }else{
            $color = '#5d7d2b'
        }


        _echartsCaseExpend_option = {
            grid: {
                left:'0%',
                right:'0%',
                top:'0%',
                bottom:'0%',
                containLabel: true
            },
            tooltip: {
                show:false,
                //trigger: 'item',

            },
            legend: {
                show:false,
            },

            series: [
                {
                type: 'pie',
                radius: ['70%', '83%'],
                avoidLabelOverlap: true,
                label: {
                    show: false,
                    position: 'outside'
                },
                labelLine: {
                    //show:true,
                    show:false
                },
                emphasis: {
                    label: {
                    show: false
                    }
                },
                labelLine: {
                    show: false
                },
                data: [
                    { value: $now, name: '현재 충전량',itemStyle:{color:$color} },
                    { value: $total, name: '남은 충전량',itemStyle:{color:'#f4f4f1'} }
                ]
                }
            ],
        };

        _echartsCaseExpend.setOption(_echartsCaseExpend_option);
    }
} 

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
var MStatus = { 
    onReady : function(event){ 
        console.log("onReady page : "+PGV.currentPage); 
        KIA_RNW_5B0_0000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
