/**

@파일명 : KIA_RNW_5E4_0000.js
@작성자 :
@생성일 : 2022.01.26
@메뉴명 :  에스트래픽 충전카드 발급
@DESC : 전체메뉴노출[X]	미로그인[X]	차량미보유[X]	계약차량보유[X]	내연보유[X]	EV보유[O]
*/
var CurrPage;
var KIA_RNW_5E4_0000 ={
    init: function(){
        CurrPage = this;
        console.log("page : " + PGV.currentPage + "initiolizing START");
        var pageInit = function(){
        	/**
        	 * 초기화
        	 */
        	stackRemove("KIA_RNW_5E4_0000.html");
        	stackRemove("KIA_RNW_5E1_0000.html");
            paramSet();     //api 파라미터 세팅

        	/**
        	 * 화면 이벤트
        	 */
        	setEvent();
        };

        /**
         * @name        : setUIEvent
         * @description : UI에서 사용하는 이벤트 및 초기설정 수행
         * @date        : 2021. 6. 28
         * @author      : 네이버시스템-주해원
         */
        var setEvent = function(){
            $("#confirmBtn").on("click", function(){
                var _param = {};
                if(!isEmpty(MData.param("evtYn"))){        // 이벤트 페이지 돌아갈때 중복선택 방지용
                    _param.baseBallYn = "Y";
                    _param.evtYn = MData.param("evtYn");
                }
                MPage.back({
                    animate : "MODAL_DOWN",
                    param : _param
                });
            });
        };

        /**
         * @name        : paramSet
         * @description : 에스트래픽 api 파라미터 세팅
         * @date        : 2021. 6. 28
         * @author      : 네이버시스템-주해원
         */
        var paramSet = function(){
            var param = {
                ci : PGV.loginInfo.ci,
                billkey : MData.param("billkey"),
                name : PGV.loginInfo.mbrNm,
                contactNo : PGV.loginInfo.hpno,
                vehicleType : MData.param("vehicleType"),
                cardNo : MData.param("cardNo"),
                cardName : MData.param("cardName"),
                cardCode : MData.param("cardCode"),
                cardCl : MData.param("cardCl")
            };
            console.log(JSON.stringify(param));

            //파라미터 암호화
            var encData = CONFIG.IS_DEV ? exWNEncryptString(JSON.stringify(param), CONSTANT.STRAFFIC_DEV_CRTEC_KEY, CONSTANT.STRAFFIC_DEV_IV_KEY)
                        : exWNEncryptString(JSON.stringify(param), CONSTANT.STRAFFIC_REAL_CRTEC_KEY, CONSTANT.STRAFFIC_REAL_IV_KEY);
            var encParam = {data : encData};
            joinST(encParam);   //에스트래픽 회원 등록
        };

        /**
         * @name        : joinST
         * @description : SSCharge 회원 가입 등록
         * @date        : 2021. 6. 28
         * @author      : 네이버시스템-주해원
         */
        var joinST = function(encParam){
            //SSCharge 회원 가입 등록
            joinMem(encParam, function(receivedData){
                regEvMng(regEvCallback);   //EV멤버스 등록
            }, function(code, msg){
                MPopup.confirm({
                    title : '알림',
                    message : msg,
                    buttons : ["확인"],
                    callback : function(idx){
                        MPage.back();
                    }
                });
            });
        };


        /**
         * @name        : regEvMng
         * @description : EV멤버스 api 콜백
         * @date        : 2021. 7. 2
         * @author      : 네이버시스템-주해원
         */
        var regEvCallback = function(receivedData){
        	exWNHideIndicator();
        	var code = receivedData.resultCode;
        	var msg = receivedData.resultMsg;

        	if(code == "200"){
        	    PGV.loginInfo.evMemRegYn = "Y";
        	    MData.global('loginInfo', PGV.loginInfo);
                $(".charge-loading").addClass("none");
                $(".afRegist").removeClass("none");
        	}else{
        		console.log("evMngReg error code=" + code + ", msg=" + msg);
        		MPopup.confirm({
                    title : '알림',
                    message : CONSTANT.NETWORK_ERR_MSG,
                    buttons : ["확인"],
                    callback : function(idx){
                        MPage.back();
                    }
                });
        	}
        };

        pageInit();
    },
    setEventListner: function(){
        // do something..
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
    onReady : function(event){
        console.log("onReady page : "+PGV.currentPage);
        KIA_RNW_5E4_0000.init();
    }, 
    onHide : function(event){}, 
    onRestore : function(event){}, 
    // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
    // onBack : function(){}, 
    onDestroy : function(event){}, 
    onPause : function(event){}, 
    onResume : function(event){} 
}; 
