/**

@파일명 : KIA_RNW_600_0000.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.16
@메뉴명 : 전체메뉴 탭
@DESC : 권한 확인 중
*/ 
var KIA_RNW_600_0000 ={
    menuHistoryManager: COMMON_FUNCTION.TOOL.UI.myKiaAllMenuInterface.menuHistoryManager,
    init: function(){
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        COMMON_FUNCTION.TOOL.DATA.setCurrentScopeSelectCar();

        /**
         * !!! 선행개발팀 추헌남 - 프로필 항목과 자주 찾는 메뉴, 접근 불가 항목 자동 숨김 처리에 대해
         * bottomTabNavigation.js 파일의 navMeta 객체 - allMenu 항목에서 interceptFunction을 통해
         * 미리 프로필 항목과 자주 찾는 메뉴,접근 불가 항목 html string 상에서 사전 변경하여 렌더링합니다.
         */
        this.setEventListeners();
        this.setPublisherEventListeners();
        this.setEVOnlyBadge();

        this.onClickBookmarkMenuButton(); 
        this.onClickBookmarkMenuPin();
        exWNHideIndicator();
    },

    setEventListeners: function() {
        var parentThis = this;
        $('.btn-login').off("click").on("click", function(){
            ccspLogin();
        });
        this.onClickMenuButton();
    },

    customMenuButtonMetadata: {
        /* !!! 케이스마텍 추헌남 type: "onlyFunction" 이고 html 상에서 data-menu-forced-run === "Y"일 경우 */
        /* customFunction에서 truthy value로 리턴 시 즐겨찾기 기록이 남고, falsy value로 리턴시 즐겨찾기 기록이 남지 않습니다.  */
        "KIA_RNW_127_0000": {
            type: "screenid",
            options:{
                path: PATH_MANAGER.KIA_RNW_127_0000.path,
                param: {
                    passCar: COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar()
                }
            }
        },
        "KIA_RNW_943_0000": {
            type: "onlyFunction",
            customFunction: function(){
                /*
                    VIK 앱 메뉴의 온디맨드 서비스 클릭 시
                    i. 데이터허브 미연동 && DKC 미가입 : 클릭 시 안내문구 (“DKC 가입 후 이용가능한 서비스입니다”) →  모바일 기아멤버스 온디맨드 소개페이지 웹뷰 표출
                    ii. 데이터허브 미연동 && DKC 가입: 클릭 시 데이터허브 창 연결 → 가능
                    iii. 데이터허브 연동 && DKC 미가입: 클릭 시 안내문구 (“DKC 가입 후 이용가능한 서비스입니다”) →  모바일 기아멤버스 온디맨드 소개페이지 웹뷰 표출
                    iv. 데이터허브 연동 && DKC 가입 : 클릭 시 데이터허브 창 연결 → 가능
                    20211217 전체메뉴 DKC 온디맨드 클릭시
                    kia connect 가입 안된경우 > 웹뷰 온디맨드 소개 페이지 연결
                    kia connect 가입, 데이터허브 미연동, DKC 미가입 > 데이터허브 가입 페이지 연결
                    kia connect 가입, 데이터허브 연동, DKC 미가입 > 데이터허브 DKC 소개(가입)페이지 연결
                    kia connect 가입, 데이터허브 연동, DKC 가입 > 데이터허브 메인 페이지 연결
        
                    !!! 선행개발팀 추헌남 - AS-IS 분석 결과 DKC 진입 가능자를 제외 모두 같은 인트로 페이지로 이동합니다. (출력되는 메시지만 간혹 다릅니다)
                    (임시 노트)
                    isMaster 트루고 카 아이디가 있으면 = 연동되었거나 연동 가능한 차량 
                        +
                    선택된 차량의 carId가 있으면

                    agreementCode는 11로 시작하여야 함.
                    1은 통과 가능한 상태
                    1은 디지털키를 조회할 때 필요한 약관
                */
        
                var dkcConnectionDict = {
                    "00": "intro",
                    "01": "intro",
                    "02": "intro",
                    "03": "dkcHome",
                    "10": "dkcHome"
                }
                var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
                var hasLoggedIn = !isEmpty(PGV.loginInfo);
                // 주의: carId 플래그 값 변경 시, isAvailableDataHub 수정 필요
                var hasJoinedKiaConnect = !isEmpty(PGV.loginInfo) &&
                                          !isEmpty(PGV.loginInfo.ccspId) &&
                                          isAvailableDataHub(currentScopeSelectCar.carId) || false;
                var hasJoinedDataHub = isAvailableDataHub(currentScopeSelectCar.carId) ||
                                       !isEmpty(PGV.passData) &&
                                       !isEmpty(PGV.passData.ccs) &&
                                       !isEmpty(PGV.passData.ccs.isMaster) &&
                                       PGV.passData.ccs.isMaster && PGV.passData.ccs.carId || false;
                var hasAgreedDataHubAgreement = !isEmpty(PGV.passData) &&
                                                !isEmpty(PGV.passData.display) &&
                                                !isEmpty(PGV.passData.display.agreementCode) &&
                                                PGV.passData.display.agreementCode[0] === "1" &&
                                                PGV.passData.display.agreementCode[1] === "1" || false;
                var DKCType = !isEmpty(PGV.passData) &&
                                   !isEmpty(PGV.passData.car) &&
                                   !isEmpty(PGV.passData.car.dkc) &&
                                   !isEmpty(PGV.passData.car.dkc.registerInfo) &&
                                   dkcConnectionDict[PGV.passData.car.dkc.registerInfo.data];

                if(!hasLoggedIn){
                    COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_080_0000.path, null, [null, function(){
                        ccspLogin();
                    }]);
                    return false;
                }

                if(PGV.passData.car && PGV.passData.car.myCarInfoListResDto && !(PGV.passData.car.myCarInfoListResDto.length > 0)){
                    MPopup.alert("등록된 차량이 없습니다.");
                    return false;
                }

                if(!hasJoinedKiaConnect){
                    MPopup.alert({
                        message : "지원 대상 차량이 아닙니다. (Kia Connect (구 UVO) 고객만 사용 가능한 메뉴입니다)",
                        callback : function(idx){
                            MApps.browser(CONSTANT.LINK_URL.KIA_MOB_750_1700.URL);
                        }
                    });
                    return false;
                }

                if(!(hasJoinedDataHub && hasAgreedDataHubAgreement)){
                    var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
                    var getAgreementsWeb = function(token, userId, carId){
                        return String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service/agreements?token={0}&userId={1}&carId={2}',token, userId, carId);
                    }
                    MPage.activity({
                        className : "WebviewActivity",
                        param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(
                            "GET",
                            getAgreementsWeb(PGV.loginInfo.accessToken, PGV.loginInfo.ccspId, currentScopeSelectCar.carId),
                            null,
                            "disable"
                        )
                    });
                    return false;
                }

                if(DKCType === "intro"){
                    MPopup.alert({
                        message : "기아 디지털키 가입 후 이용 가능 서비스 입니다.",
                        callback : function(idx){
                            MApps.browser(CONSTANT.LINK_URL.KIA_MOB_750_1700.URL);
                        }
                    });
                    return false;
                }
                
                var getDkcWeb = function(token, userId, carId){ // dkc 데이터허브 URL
                    return String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service/dkc-introduce?token={0}&carId={1}&userId={2}',token, carId, userId);
                }
                MPage.activity({
                    className : "WebviewActivity",
                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(
                        "GET",
                        getDkcWeb(PGV.loginInfo.accessToken, PGV.loginInfo.ccspId, currentScopeSelectCar.carId),
                        null,
                        "disable"
                    )
                });
                return true;
            }
        },
        "KIA_RNW_500_0000": {
            type: "onlyFunction",
            customFunction: function(){

                MyKiaBottomTab.open('EV', true);
                return true;
            }
        },
        "KIA_RNW_121_0000": {
            type: "onlyFunction",
            customFunction: function(){
                var currentScopeSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
                var hasLoggedIn = !isEmpty(PGV.loginInfo);
                // 주의: carId 플래그 값 변경 시, isAvailableDataHub 수정 필요
                var hasJoinedKiaConnect = !isEmpty(PGV.loginInfo) &&
                                          !isEmpty(PGV.loginInfo.ccspId) &&
                                          isAvailableDataHub(currentScopeSelectCar.carId) || false;
                var hasJoinedDataHub = isAvailableDataHub(currentScopeSelectCar.carId) ||
                                       !isEmpty(PGV.passData) &&
                                       !isEmpty(PGV.passData.ccs) &&
                                       !isEmpty(PGV.passData.ccs.isMaster) &&
                                       PGV.passData.ccs.isMaster && PGV.passData.ccs.carId || false;

                if (!hasLoggedIn) {
                    COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_080_0000.path, null, [null, function(){
                        ccspLogin();
                    }]);
                    return;
                } else {
                    var carList = PGV.passData.car.myCarInfoListResDto;
                    if (isEmpty(PGV.passData.car) && isEmpty(carList)) {
                        MPopup.alert("등록된 차량이 없습니다.");
                        return;
                    }
                    if(!(hasJoinedKiaConnect && hasJoinedDataHub)){ // 마지막 조건은 일단 임의 추가
                        // 약관 동의 여부를 체크해야 하는가?
                        MPopup.alert("지원 대상 차량이 아닙니다. (Kia Connect (구 UVO) 고객만 사용 가능한 메뉴입니다)");
                        return;
                    }
                }

                MPage.activity({
                    className : "WebviewActivity",
                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(
                        "GET",
                        String.format(CONSTANT.CCS_DATA_HUB + '/web/v1/data-service?token={0}&userId={1}&carId={2}', PGV.loginInfo.accessToken, PGV.loginInfo.ccspId, currentScopeSelectCar.carId),
                        null,
                        "disable"
                    )
                });
            }
        },
        "KIA_RNW_230_0000": {
            type: "onlyFunction",
            customFunction: function(){
                var isEVCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar().memEvYn !== "N";
                if(isEVCar){
                    MPopup.alert("내연 차량 전용 서비스입니다.");
                    return false;
                }
                else{
                    COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.openSubtabGlobally(MyKiaBottomTab, "mycar", 2);
                    return true;
                }
            }
        },
        "test": {
                      type: "onlyFunction",
                      customFunction: function(){
                          MPage.html({
                            url : "../400/KIA_RNW_411_1100.html",
                            animate : "MODAL_UP",
                            param : {
                                baseEvtNo : PGV.evtNo
                            }
                        });
                      }
                  },
        "KIA_RNW_242_0000": {
            type: "onlyFunction",
            customFunction: function(){
                MPage.html({
                    path: PATH_MANAGER.KIA_RNW_242_0000.path,
                    param: {
                        currentScopeSelectCar : COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar()
                    }
                })
            }
        },
        "KIA_RNW_810_0000": {
            type: "onlyFunction",
            customFunction: function(){
             		if(isEmpty(PGV.loginInfo)){
            			COMMON_FUNCTION.TOOL.UI.showNotiLoginPopup();
                    }else{
                        MPage.html({
                            url : PATH_MANAGER.KIA_RNW_810_0000.path,
                            param : {
                                rUrl : CONSTANT.AUTON_URL_PREFIX ,
                                evtYN : "N"
                            }
                        });
                    }

            }
        },
        "KIA_MOB_900_2000": {
            type: "onlyFunction",
            customFunction: function() {
                MPage.activity({
                    className : "WebviewActivity",
                    param : {
                        method : CONSTANT.NET_MTHD.GET,
                        requestURL : CONSTANT.LINK_URL.KIA_MOB_900_2000.URL
                    }
                });
            }
        },
        "KIA_RNW_5F2_0000": {
            type: "onlyFunction",
            customFunction: function(){
                MPage.html({
                    url: PATH_MANAGER.KIA_RNW_5F2_0000.path
                });
                return;
            }
        },
        "KIA_RNW_731_0000": {
            type: "onlyFunction",
            customFunction: function(){
                MPage.activity({
                    className: "WebviewActivity",
                    param: {
                        method: CONSTANT.NET_MTHD.GET,
                        requestURL: "https://m.members.kia.com/kr/view/web/kutl/kutl_event_lifecare_index.do"
                    }
                });
            }
        }
    },

    setPublisherEventListeners: function(){
        var $winWidth = $(window).width();
        var $homeHeaderHeight = $('div#homeHeader').outerHeight(); // 케이스마텍 추헌남 - 원활한 동작을 위해 쿼리문 수정하였습니다.
        var $filterListContHeight = fnCheckDevice() == 'android' ? $('.slider-filter-cont').outerHeight() * 1.3 : $('.slider-filter-cont').outerHeight() * 2;
        var $allMenuContTop = $('.allMenu-cont').offset().top - 200;


        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:0,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();			
            //var currentIndex = $(this).index();			
            var getSlideIdx = $(this).data('slide-index');	

            if ($('.slider-filter-cont').hasClass('is-sticky')) {
                var $divItemTop;
                var $scrollEnd = $(document).height() - $(window).height();	
                
                if (!$('body').hasClass('js-filter-list-fixed')) {
                    $divItemTop = $('#divItem_'+getSlideIdx).offset().top - ($filterListContHeight * 2);
                }
                else {
                    $divItemTop = $('#divItem_'+getSlideIdx).offset().top - $filterListContHeight;
                }

                if (getSlideIdx == 0) {
                    var $filterListContHeight0 = fnCheckDevice() == 'android' ? $('.slider-filter-cont').outerHeight() * 1.2 : $('.slider-filter-cont').outerHeight() * 1.5;
                    $divItemTop = $('#divItem_'+getSlideIdx).offset().top - $filterListContHeight0;
                    $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index='+getSlideIdx+']').addClass('active');
                    $('html, body').stop().animate({scrollTop:($divItemTop - $filterListContHeight0)}, 300, 'swing');
                }
                else if ( getSlideIdx === (nScrollPos.length - 1) || 
                          getSlideIdx === (nScrollPos.length - 2) ||
                          getSlideIdx === (nScrollPos.length - 3)) {
                    $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index='+getSlideIdx+']').addClass('active');
                    _sliderFilterList.slideTo(getSlideIdx, 300, false);
                    if(getSlideIdx === (nScrollPos.length - 1)){
                        $('html, body').stop().animate({scrollTop:$scrollEnd}, 300, 'swing');
                    }
                    else{
                        $('html, body').stop().animate({scrollTop:$divItemTop}, 300, 'swing');    
                    }
                }
                else {
                    var currentScopeNowTop = $(window).scrollTop();
                    var currentScopeScrollEnd = ($(document).height() - $(window).height());
                    if ( (currentScopeNowTop + 40 >= currentScopeScrollEnd) && getSlideIdx === (nScrollPos.length - 3)){
                        $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                        $('.slider-filter-list').find('.swiper-slide[data-slide-index='+(nScrollPos.length - 3)+']').addClass('active');
                    }
                    $('html, body').stop().animate({scrollTop:$divItemTop}, 300, 'swing');
                }                    
            }

        });

        // ------------------------------
        // 	Scroll
        // ------------------------------
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $allMenuContTop = $('.allMenu-cont').offset().top - ($homeHeaderHeight * 2);
        //console.log('allMenuContTop', $allMenuContTop)

        $('.allMenu-list .div-item:visible').each(function(idx, item) {
            nScrollPos[nScrollPosNum] = $(this).offset().top - 200;
            nScrollPosNum++;
        });

        var runWhenScrollStoppedTimer = null;

        $(window).scroll(function(e) {
            var $nowTop = $(this).scrollTop();
            var $scrollEnd = ($(document).height() - $(window).height());

            if(runWhenScrollStoppedTimer !== null){
                clearTimeout(runWhenScrollStoppedTimer);
            }

            runWhenScrollStoppedTimer = setTimeout(function(){        
                if ($nowTop < nScrollPos[0]){
                    $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                    _sliderFilterList.slideTo(0, 300, false);
                }

                for (var i = 0; i< nScrollPos.length; i++) {
                    var nextEachPartScrollTop = i === nScrollPos.length - 1 ? ($(document).height() - $(window).height()) : nScrollPos[i + 1];
                    var eachPartScrollTop = nScrollPos[i];                        
                    
                    if (eachPartScrollTop < $nowTop + 5) { // && $nowTop - 5 < nextEachPartScrollTop
                        var getItemId = $('.allMenu-list .div-item:visible').eq(i).attr('id');
                        var idLastNum = getItemId.charAt(getItemId.length - 1);
                        if (Math.floor($nowTop) + 10 >= $scrollEnd) {
                            // var currentCheckTarget = $('.slider-filter-list .swiper-slide[data-slide-index='+(nScrollPos.length - 3)+']');
                            var currentCheckTarget = $('.slider-filter-list .swiper-slide[data-slide-index='+(nScrollPos.length - 1)+']');
                            if(currentCheckTarget.is(":not(.active)") &&
                               $('.slider-filter-list .swiper-slide.active').index() > 2){
                                break;
                            }
                            $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+(nScrollPos.length - 1)+']').addClass('active');
                            // $('.slider-filter-list').find('.swiper-slide[data-slide-index='+(nScrollPos.length - 3)+']').addClass('active');
                            _sliderFilterList.slideTo((nScrollPos.length - 1), 300, false);
                        }
                        else {
                            $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                            $('.slider-filter-list').find('.swiper-slide[data-slide-index='+idLastNum+']').addClass('active');
                            _sliderFilterList.slideTo(idLastNum, 300, false);
                        }                        
                    }
                }
            }, 50);

            // 필터 리스트 항상 상위에 위치하게 만들기
            if ($nowTop > $allMenuContTop) {
                $('body').addClass('js-filter-list-fixed');
            }
            else {
                // scroll up
                if ($nowTop < $winTop) {
                    $('body').removeClass('js-filter-list-fixed');
                    // _sliderFilterList.slideTo(0, 300, false);
                    // $('.slider-filter-list').find('.swiper-slide').removeClass('active');
                    // $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                }
            }
            
            $winTop = $nowTop;
        });
    },

    setBookmarkMenus: function(){
        var parentThis = this;
        var currentPermission = COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission();
        var getBookmarkEntry = function(screenid, pinned, index){
            var objectCandidates = [$(".allMenu-list li [data-menu-screenid=" + screenid + "]"),  //:not(.none)
                                    $(".allMenu-list li [data-menu-link=" + screenid + "]"),   //:not(.none)
                                    $(".allMenu-list li [data-menu-custom=" + screenid + "]")];  //:not(.none)
            var currentMenuObject = _.find(objectCandidates, function(element){return element.length > 0});
            var isLink = objectCandidates[1].length > 0;
            var isCustom = objectCandidates[2].length > 0;
            var isLuxuryMenu = currentMenuObject && typeof currentMenuObject.data("luxury-menu") !== "undefined" || false;
            var isEV9Menu = currentMenuObject && typeof currentMenuObject.data("EV9-menu") !== "undefined" || false;

            /* 일단 모든 북마크 Entry 기억하도록 설정하여 하단 로직 주석처리 */
            if(!currentMenuObject){
                return null;
            }

            var currentTitle = currentMenuObject.text().trim();
            var currentTab = currentMenuObject.data("tab");
            var currentSubtab = currentMenuObject.data("subtab");
            var currentMenuPermission = currentMenuObject.data("permission");
            var currentMenuForcedRun = currentMenuObject.data("menu-forced-run") === "Y";
            
            var templateString =
                '<li ' +
                    'class="d-flex justify-content-between align-items-center mykia-bookmark-li ' + (pinned ? 'active' : '') +'">' +
                    '<span>' + currentTitle + '</span>' +
                    '<button type="button" class="btn-pin js-toggle-btn" ' +
                
                        (isLink ? 'data-menu-link="' + screenid +'" ' : '') + 
                        (isCustom?  'data-menu-custom="' + screenid +'" ' : '') +
                        (!isLink && !isCustom ? 'data-menu-screenid="' + screenid +'" ' : '') +
                        (isLuxuryMenu ? "data-luxury-menu " : "") +
                        (isEV9Menu ? "data-EV9-menu " : "") +
                        (currentMenuForcedRun ? 'data-menu-forced-run="Y" ' : '') +

                        (currentTab ? 'data-tab="' + currentTab + '" ' : '') +
                        (currentSubtab || currentSubtab===0 ? 'data-subtab="'+ currentSubtab +'" ' : '') + 
                        (currentMenuPermission ? 'data-permission="' + currentMenuPermission + '" ' : '') + 
                        'data-index="' + index + '">' +
                            '<i class="ico-pin"></i>' + 
                    '</button>' +
                '</li>';
                return $(templateString);
                
            /* !!! 케이스마텍 추헌남 - 즐겨찾는 메뉴에서 권한이 없어 숨겨진 메뉴 한정으로는 기록을 제거하려고 하였으나 일괄 존치로 결정되어 해당 로직 임시 주석처리 함 */
            // var doesMeetCurrentPermission = currentMenuPermission !== "all" && !_.contains(currentMenuPermissionList, currentPermission);
            // if(!currentMenuObject && !doesMeetCurrentPermission){
            //     return null;
            // }
            // else{
            //     /* !!! 케이스마텍 추헌남 - 차량 미보유 시 / 로그아웃했을 때 로그인 메시지 띄우기 */
            //     /* !!! 케이스마텍 추헌남 - EV 차량이 아닌 경우에도 즐겨찾는 목록에서 삭제해야 함 */
            //     // if(_.contains(currentMenuPermissionList, "owner-ev") || _.contains(currentMenuPermissionList, "rider-ev") &&
            //     //    !_.contains(["owner-ev", "rider-ev"], currentPermission)){
            //     //     return null;
            //     // }
            // }
        }

        currentMenuHistoryList = this.menuHistoryManager.load();

        if (currentMenuHistoryList.length > 0){
            var bookmarkMenuDom = $("#mykia-bookmark-menu-history");
            var listContainer = $("<ul></ul>");
            var bookmarkEntryList  = [];
            for (var i = 0; i < currentMenuHistoryList.length; i++){
                var curNode = currentMenuHistoryList[i];
                var currentBookmarkEntry = getBookmarkEntry(curNode.screenid, curNode.pinned, i);

                currentBookmarkEntry && bookmarkEntryList.push(currentBookmarkEntry);
                /* 일단 모든 북마크 Entry 기억하도록 설정하여 하단 로직 주석처리 */
                // if(currentBookmarkEntry){
                //     bookmarkEntryList.push(currentBookmarkEntry); 
                // }
                // else{
                //     this.menuHistoryManager.deleteHistory(curNode.screenid);
                // }
            }
            if(bookmarkEntryList.length > 0){
                bookmarkMenuDom.empty();
                listContainer.append(bookmarkEntryList);
                bookmarkMenuDom.append(listContainer);
            }
            this.onClickBookmarkMenuButton();
            this.onClickBookmarkMenuPin();
        }
    },

    setEVOnlyBadge: function(){
        var currentPermission = COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission();
        if (_.contains(["rider-ev", "owner-ev"], currentPermission)){
            $('#mykia-ev-only-badge').hide();
        }
    },

    handleClickCommonMenuButtons: function(element, customParam){
        var parentThis = this;
        var registerBookmark = function(targetScreenid){
            parentThis.menuHistoryManager.addHistory({
                screenid: targetScreenid,
                pinned: false
            });
            parentThis.setBookmarkMenus();
        }

        var currentButton = $(element).find('button');
        var currentScreenId = currentButton.data("menu-screenid");
        var currentMenuLink = currentButton.data("menu-link");
        var currentMenuLinkCustom = currentButton.data("menu-link-custom");
        var currentCustomMenu = currentButton.data("menu-custom");
        var currentTab = currentButton.data('tab') || null;
        var currentSubTab = currentButton.data('subtab');
        var isLuxuryMenu = typeof currentButton.data("luxury-menu") !== "undefined";
        var isForcedRun = currentButton.data("menu-forced-run") === "Y";
        var isEV9Menu = typeof currentButton.data("EV9-menu") !== "undefined";

        
        /* !!! 케이스마텍 추헌남 - 아래 주석처리한 부분까지 모두 현재는 임시 무시하기 */
        /* !!! 케이스마텍 추헌남 - 권한 처리 관련 함수 비활성화로 인한 EV 메뉴 버튼 한정 권한 처리 */
        /* !!! 케이스마텍 추헌남 - 차량 미보유 시 / 로그아웃했을 때 로그인 메시지 띄우기 */
        // var currentPermission = COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission();
        // var currentMenuPermissionList = currentMenuPermission.split(" ");
        // if((_.contains(currentMenuPermissionList, "owner-ev") || _.contains(currentMenuPermissionList, "rider-ev")) && 
        //     !_.contains(["owner-ev", "rider-ev"], currentPermission)){
            //     MPopup.alert("EV 차량 전용 서비스입니다.");
            //     return;
            // }
            
            /* !!! 케이스마텍 추헌남 - 권한이 없으면 이미 메뉴가 숨겨지기 때문에 주석처리하였습니다. */
            // var permissionFulfilled = true;
        
        if(isLuxuryMenu){
            var currentSelectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar()
            if(currentSelectCar.luxuryYn !== "Y"){
                MPopup.alert("고급 차량만 진입 가능한 메뉴입니다.");
                return;
            }
        }
        if (isEV9Menu){
            var selectCar = COMMON_FUNCTION.TOOL.DATA.getCurrentScopeSelectCar();
            if (selectCar.vehlRepnCd !== "MV") {
                MPopup.alert("EV9 차량만 진입 가능한 메뉴입니다.");
                return;
            }
        }
        
        var currentMenuPermission = currentButton.data('permission');
        var currentPermission = COMMON_FUNCTION.TOOL.AUTH.getCurrentPermission();
        var permissionFulfilled = this.checkPermissionAndShowErrorMessage(currentMenuPermission, currentPermission);

        if(permissionFulfilled){
            if (currentMenuLink || currentScreenId || currentCustomMenu){
                registerBookmark(currentMenuLink || currentScreenId || currentCustomMenu);
            }

            if(currentTab && (typeof currentSubTab === "number" || typeof currentSubTab === "string")){
                COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.openSubtabGlobally(MyKiaBottomTab, currentTab, parseInt(currentSubTab));
            }
            else{
                if(currentScreenId){
                    var tempOptions = {};
                    if(currentScreenId) tempOptions["path"] = PATH_MANAGER[currentScreenId].path;
                    MPage.html(tempOptions);
                }

                if(currentMenuLink){
                    MPage.activity({
                        className : "WebviewActivity",
                        param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, CONSTANT.LINK_URL[currentMenuLink].URL)
                    });
                }



                if(currentMenuLinkCustom){
                    var _appVersion = Number(PGV.appInfo.app.version.replace(/[^0-9]/g,"").replace(/(\d{3})(\d*)/, "$1"));	// 앱 버전
                    var activityName = "WebviewActivity";

                    MPage.activity({
                        className : activityName,
                        param: {
                            method: CONSTANT.NET_MTHD.GET,
                            requestURL: CONSTANT.LINK_URL[currentMenuLinkCustom].URL ,
                            setCookie : isEmpty(PGV.loginInfo) ? false : true
                        }
                    });
                }


                if(currentCustomMenu){
                    var curNode = this.customMenuButtonMetadata[currentCustomMenu];
                    if(curNode){
                        if(curNode.options){
                            if(curNode.type === "link"){
                                MPage.activity(curNode.options)
                            }
                            if(curNode.type === "screenid"){
                                MPage.html(curNode.options);
                            }
                        }
                    }
                }
                if(currentCustomMenu){
                    typeof this.customMenuButtonMetadata[currentCustomMenu].customFunction === "function" && this.customMenuButtonMetadata[currentCustomMenu].customFunction();
                }
            }
            return;
        }

        if(isForcedRun){
            if(currentCustomMenu){
                var currentCustomFunction = this.customMenuButtonMetadata[currentCustomMenu].customFunction;
                if(typeof currentCustomFunction === "function" && currentCustomFunction()){
                    registerBookmark(currentCustomMenu);
                };
            }
            return;
        }
    },

    checkPermissionAndShowErrorMessage: function(currentMenuPermission, currentPermission){
        /*
            모두 접근 가능 = all
            미로그인 = non-login
            차량 미보유 = non-car
            계약 대기 = wait-contract
            실운행자 - 내연 차량 = rider-engine
            실운행자 - EV 차량 = rider-ev
            실소유주 - 내연 차량 = owner-engine
            실소유주 - EV 차량 = owner-ev
        */
        var result = true;
        var currentMenuPermissionList = currentMenuPermission.split(" ");
        var ifAllowedAll = currentMenuPermission === "all";
        var checkerFunction = function(targetPermission, errorCallback){
            if (currentPermission === targetPermission){
                // 오류 팝업을 출력할 조건 설정 ( 권한이 all이거나 / 권한 목록에 포함되었을 때 )
                if (ifAllowedAll || _.contains(currentMenuPermissionList, targetPermission)){
                    result = true;
                }
                else {
                    typeof errorCallback === "function" && errorCallback();
                    result = false;
                }
            }
        }

        var showNoEVErrorMessage = function(){
            MPopup.alert('EV 차량 전용 서비스입니다.');
        }

        var checkForEV = function(){
            var doesContainEVs = _.contains(currentMenuPermissionList, "rider-ev") || _.contains(currentMenuPermissionList, "owner-ev");
            var doesContainEngines = _.contains(currentMenuPermissionList, "owner-engine") || _.contains(currentMenuPermissionList, "rider-engine");
            if( doesContainEVs && !doesContainEngines ){
                showNoEVErrorMessage();
                return true;
            }
            return false;
        };

        /* 각 권한 상황별 체크하는 함수들 목록입니다. */
        checkerFunction("non-login", function(){
            COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_080_0000.path, null, [null, function(){
                ccspLogin();
            }]);
        });
        checkerFunction("non-car", function(){
            COMMON_FUNCTION.TOOL.UI.showNoCarPopup();

        })
        checkerFunction("wait-contract", function(){
            COMMON_FUNCTION.TOOL.UI.showNoCarPopup();
        })
        checkerFunction("rider-engine", function(){
            if(!checkForEV()){
                COMMON_FUNCTION.TOOL.UI.showNoCarPopup();
            };
        })
        checkerFunction("rider-ev", function(){
            COMMON_FUNCTION.TOOL.UI.showNoCarPopup();
        })
        checkerFunction("owner-engine", function(){
            checkForEV();
            // 이외에 발생하는 오류 팝업이 없음
        })
        checkerFunction("owner-ev", function(){
            // 발생하는 오류 팝업이 없음
        })

        return result;
    },

    onClickMenuButton: function(){
        var parentThis = this;
        $('.allMenu-list li').off("click").on('click', function(e){
            e.preventDefault();
            e.stopPropagation();
            parentThis.handleClickCommonMenuButtons(this);
        })

        $('button.btn-default').off("click").on("click", function(){
            var currentScreenId = $(this).data("menu-screenid");
            currentScreenId && MPage.html({path: PATH_MANAGER[currentScreenId].path});
        })
    },

    onClickBookmarkMenuButton: function(){
        var parentThis = this;
        $('li.mykia-bookmark-li').on("click", function(){
            parentThis.handleClickCommonMenuButtons(this);
        })
    },

    onClickBookmarkMenuPin: function(){
        var parentThis = this;
        var $toggleBtn = $('.js-toggle-btn');
        $toggleBtn.on('click', function(e) {
            e.preventDefault();
            var currentObject = $(this);
            var currentItem = currentObject.closest('li')
            currentItem.toggleClass('active');
            var currentScreenId = currentObject.data("menu-screenid") || currentObject.data("menu-link") || currentObject.data("menu-custom");
            var currentMenuHistory = parentThis.menuHistoryManager.load();
            for (var i = 0; i < currentMenuHistory.length; i++){
                var curNode = currentMenuHistory[i];
                if(curNode.screenid === currentScreenId){
                    curNode.pinned = currentItem.hasClass('active');
                }
            }

            var menuHistoryManager = parentThis.menuHistoryManager;
            var sortedMenuHistoryList = menuHistoryManager.sort(currentMenuHistory);
            menuHistoryManager.save(sortedMenuHistoryList);
            parentThis.setBookmarkMenus();
        });

    },
} 

KIA_RNW_600_0000.init();
