/**

@파일명 : KIA_RNW_600_0000_2.js 
@작성자 : 케이스마텍 추헌남
@생성일 : 2022.03.16 
@메뉴명 : 전체메뉴 탭 (로그인)
@DESC : 권한 확인 중
*/ 
var Menu;
var KIA_RNW_600_0000_2 ={
	menuHistoryManager: {
        //menuHistoryList: {name: "내 카드/포인트", screenid: "", tab:"", subtab:"", permission:"", pinned: false}
        load: function(){
            var tempStorage = M.data.storage('mykiaRenewal');
            return tempStorage && tempStorage.allMenu && tempStorage.allMenu.menuHistoryList || [];;
        },
        addHistory: function(element){
            var loadedMenuHistoryList = this.load();
            var totalHistorySize = 3;
            var pinnedHistorySize = _.countBy(loadedMenuHistoryList, function(o){return o.pinned}).true || 0;
            var availableHistorySize = parseInt(totalHistorySize) - parseInt(pinnedHistorySize);
            
            var tempPinnedHistoryArray = loadedMenuHistoryList.slice(0, pinnedHistorySize);
            var tempHistoryArray = loadedMenuHistoryList.slice(pinnedHistorySize, totalHistorySize);

            var isElementInPinnedHistoryLength = _.filter(tempPinnedHistoryArray, function(o){return o.screenid === element.screenid});
            isElementInPinnedHistoryLength = isElementInPinnedHistoryLength && isElementInPinnedHistoryLength.length || 0;

            if (!(isElementInPinnedHistoryLength > 0)){
                tempHistoryArray = _.filter(tempHistoryArray, function(o){return !(o.screenid === element.screenid)});
                tempHistoryArray.push(element);
            }

            tempHistoryArray = tempHistoryArray.slice(0 - availableHistorySize);

            if(tempPinnedHistoryArray.length < 3) {
                loadedMenuHistoryList = this.sort(tempPinnedHistoryArray.concat(tempHistoryArray));
                this.save(this.sort(tempPinnedHistoryArray.concat(tempHistoryArray)));
            }

            return;
        },
        sort: function(currentMenuHistoryList){
            var tempMenuHistoryList = _.sortBy(currentMenuHistoryList, function(o){
                return !o.pinned;
            })

            return tempMenuHistoryList;
        },
        uniq: function(menuHistoryList){
            var tempMenuHistoryList = _.uniq(menuHistoryList, "screenid");
            menuHistoryList = tempMenuHistoryList;
            return;
        },
        save: function(currentMenuHistoryList){
            var tempStorage = M.data.storage('mykiaRenewal');
            if (!(tempStorage && tempStorage.allMenu)){
                if(!tempStorage){
                    tempStorage = {};
                }
                tempStorage = $.extend({}, tempStorage, {allMenu: {menuHistoryList: currentMenuHistoryList}});
            }
            else{
                tempStorage.allMenu["menuHistoryList"] = currentMenuHistoryList;
            }
            M.data.storage('mykiaRenewal', tempStorage);

            return;
        }
    },
    init: function(){
        Menu = this;
        var defaultHistory = []; 
        console.log("page : " + PGV.currentPage + "initiolizing START"); 
        Menu.setEVOnlyBadge();
		Menu.setProfileCardSection();
        Menu.setEventListeners();
    },
    setEventListeners: function() {
        $('#mykia-menu-login').on("click", function(){
            ccspLogin();
        })
        this.publishEventListeners();
        this.onClickMenuButton();
        this.setBookmarkMenus();
    },

	setProfileCardSection: function(){
		if(!isEmpty(PGV.loginInfo)){
			$('.#mykia-allmenu-username').text(PGV.loginInfo.mbrNm);
			$('.#mykia-allmenu-email').text(PGV.loginInfo.mbrId);
		}
	},

    getCurrentPermission: function(){
        /*
            모두 접근 가능 = all
            미로그인 = non-login
            차량 미보유 = non-car
            계약 대기 = wait-contract
            실운행자 - 내연 차량 = rider-engine
            실운행자 - EV 차량 = rider-ev
            실소유주 - 내연 차량 = owner-engine
            실소유주 - EV 차량 = owner-ev
        */
        console.error('for debug');
        return "non-login";
    },

    checkPermissionAndShowErrorMessage: function(currentMenuPermission, currentPermission){
        /*
            모두 접근 가능 = all
            미로그인 = non-login
            차량 미보유 = non-car
            계약 대기 = wait-contract
            실운행자 - 내연 차량 = rider-engine
            실운행자 - EV 차량 = rider-ev
            실소유주 - 내연 차량 = owner-engine
            실소유주 - EV 차량 = owner-ev
        */
        var result = true;
        currentMenuPermission = currentMenuPermission.split(" ");
        var ifAllowedAll = _.contains(currentMenuPermission, "all");
        var checkerFunction = function(targetPermission, errorCallback){
            if (currentPermission === targetPermission){
                // 오류 팝업을 출력할 조건 설정 ( 권한이 all이 아니거나 / 권한 목록에 포함되지 않을 때 )
                if (!ifAllowedAll || _.contains(currentMenuPermission, targetPermission)){
                    errorCallback && errorCallback();
                    result = false;
                }
                else {
                    result = true;
                }
            }
        }
        var showNoCarsErrorMessage = function(){
            M.pop.alert({
                title : '등록된 차량이 없어, 서비스 이용이 불가합니다.',
                message : ('· 계약 및 출고 내역은 1일 1회 업데이트되며, 계약일로부터 1~3일 이후에 조회가 가능합니다.\n' +
                           '· 보유하신 차량이 조회되지 않는 경우, 가까운 Auto Q를 방문하여 차량 인증을 받아주세요.\n' +
                           '인증일로부터 1~3일 이후에 조회가 가능합니다.'),
                buttons: ["확인"],
            });
        }

        var showNoEVErrorMessage = function(){
            MPopup.alert('EV 차량 전용 서비스입니다.');
        }

        var checkForEV = function(){
            var doesContainEVs = _.contains(currentMenuPermission, "rider-ev") || _.contains(currentMenuPermission, "owner-ev");
            var doesContainEngines = _.contains(currentMenuPermission, "owner-engine") || _.contains(currentMenuPermission, "rider-engine");
            if( doesContainEVs && !doesContainEngines ){
                showNoEVErrorMessage();
                return true;
            }
            return false;
        };

        /* 각 권한 상황별 체크하는 함수들 목록입니다. */
        checkerFunction("non-login", function(){
            COMMON_FUNCTION.TOOL.POPUP.toggle(PATH_MANAGER.KIA_RNW_080_0000.path, null, [null, function(){
                ccspLogin();
            }]);
        });
        checkerFunction("non-car", function(){
            if(!checkForEV()){
                showNoCarsErrorMessage();
            };

        })
        checkerFunction("wait-contract", function(){
            if(!checkForEV()){
                showNoCarsErrorMessage();
            };
        })
        checkerFunction("rider-engine", function(){
            if(!checkForEV()){
                showNoCarsErrorMessage();
            };
        })
        checkerFunction("rider-ev", function(){
            showNoCarsErrorMessage();
        })
        checkerFunction("owner-engine", function(){
            checkForEV();
            // 이외에 발생하는 오류 팝업이 없음
        })
        checkerFunction("owner-ev", function(){
            // 발생하는 오류 팝업이 없음
        })

        return result;
    },

    handleClickCommonMenuButtons: function(element){
        var currentButton = $(element).find('button');
        var currentScreenId = currentButton.data('screenid');
        var currentTab = currentButton.data('tab') || null;
        var currentSubTab = currentButton.data('subtab');
        var currentMenuPermission = currentButton.data('permission');

        var currentPermission = this.getCurrentPermission();
        var permissionFulfilled = this.checkPermissionAndShowErrorMessage(currentMenuPermission, currentPermission);
        
        if(permissionFulfilled){
            if (currentScreenId){
                this.menuHistoryManager.addHistory({
                    name: $(element).text(),
                    screenid: currentScreenId,
                    tab: currentTab,
                    subtab: currentSubTab,
                    permission: currentMenuPermission,
                    pinned: false
                });
            }
            this.setBookmarkMenus();
            if(currentTab){
                MyKiaBottomTab.open(currentTab).then(function(){
                    var subTabOpenerCounter = 0;
                    var subTabOpener = setInterval(function(){
                        var curTabularNav = COMMON_FUNCTION.TOOL.NAVIGATOR_TABULAR.storage[MyKiaBottomTab.currentPage];
                        subTabOpenerCounter++;
                        if(subTabOpenerCounter === 100){
                            clearInterval(subTabOpener);
                            console.error('ALLMENU : 해당 탭 로드 시도하였으나 타임 아웃 (at KIA_RNW_600_0000.js)');
                        }    
                        if(MyKiaBottomTab.currentPage === currentTab){
                            if(curTabularNav){
                                clearInterval(subTabOpener);
                                curTabularNav.open(currentSubTab);
                                for (var i = 0; i < curTabularNav.tabs.length; i++){
                                    var currentSubTabObject = $(curTabularNav.tabs[i]);
                                    if (i === currentSubTab){
                                        currentSubTabObject.addClass('active');
                                    }
                                    else{
                                        currentSubTabObject.removeClass('active');
                                    }
                                }
                            }
                        }
                    }, 100);
                });
            }
            else if(currentScreenId){
                MPage.html({path: PATH_MANAGER[currentScreenId].path});
            }
        }
        else{

        }
    },

    onClickMenuButton: function(){
        var parentThis = this;
        $('.allMenu-list li').on('click', function(){
            parentThis.handleClickCommonMenuButtons(this);
        })

        $('button.btn-default').on("click", function(){
            var currentScreenId = $(this).data('screenid');
            currentScreenId && MPage.html({path: PATH_MANAGER[currentScreenId].path});
        })
    },

    onClickBookmarkMenuButton: function(){
        var parentThis = this;
        $('li.mykia-bookmark-li').on("click", function(){
            parentThis.handleClickCommonMenuButtons(this);
        })
    },

    onClickBookmarkMenuPin: function(){
        var parentThis = this;
        var $toggleBtn = $('.js-toggle-btn');
        $toggleBtn.on('click', function(e) {
            e.preventDefault();
            var currentItem = $(this).closest('li')
            currentItem.toggleClass('active');
            var currentScreenId = $(this).data('screenid');
            var currentMenuHistory = parentThis.menuHistoryManager.load();
            for (var i = 0; i < currentMenuHistory.length; i++){
                var curNode = currentMenuHistory[i];
                if(curNode.screenid === currentScreenId){
                    curNode.pinned = currentItem.hasClass('active');
                }
            }

            var menuHistoryManager = parentThis.menuHistoryManager;
            var sortedMenuHistoryList = menuHistoryManager.sort(parentThis.menuHistoryManager.menuHistoryList);
            menuHistoryManager.save(sortedMenuHistoryList);
            parentThis.setBookmarkMenus();
        });

    },

    setBookmarkMenus: function(){
        var bookmarkTemplate = function(title, screenid, pinned, tab, subtab, permission){
            var templateString =
                '<li ' +
                    'class="d-flex justify-content-between align-items-center mykia-bookmark-li ' + (pinned ? 'active' : '') +'">' +
                    '<span>' + title + '</span>' +
                    '<button type="button" class="btn-pin js-toggle-btn" ' +
                        'data-screenid="' + screenid +'" ' + 
                        (tab ? 'data-tab="' + tab + '" ' : '') +
                        (subtab || subtab===0 ? 'data-subtab="'+ subtab +'"' : '') + 
                        (permission ? 'data-permission="' + permission + '" ' : '') + '>' +
                        '<i class="ico-pin"></i>' + 
                    '</button>' +
                '</li>';
            return $(templateString);
        }

        currentMenuHistoryList = this.menuHistoryManager.load();

        if (currentMenuHistoryList.length > 0){
            var bookmarkMenuDom = $("#mykia-bookmark-menu-history");
            bookmarkMenuDom.empty();
            var listContainer = $("<ul></ul>");
            for (var i = 0; i < currentMenuHistoryList.length; i++){
                var curNode = currentMenuHistoryList[i];
                listContainer.append(bookmarkTemplate(curNode.name, curNode.screenid, curNode.pinned, curNode.tab, curNode.subtab, curNode.permission));
            }
            bookmarkMenuDom.append(listContainer);
            this.onClickBookmarkMenuButton();
            this.onClickBookmarkMenuPin();
        }
    },

    setEVOnlyBadge: function(){
        var currentPermission = this.getCurrentPermission();
        if (_.contains(["rider-ev", "owner-ev"], currentPermission)){
            $('#mykia-ev-only-badge').hide();
        }
    },
    publishEventListeners: function(){  
        
        /* 20220401//(Ina)수정 */       
        var $winWidth = $(window).width();
        var $homeHeaderHeight = $('div#homeHeader').outerHeight(); // 케이스마텍 추헌남 - 원활한 동작을 위해 쿼리문 수정하였습니다.
        var $filterListContHeight = fnCheckDevice() == 'android' ? $('.slider-filter-cont').outerHeight() * 1.3 : $('.slider-filter-cont').outerHeight() * 2;
        var $allMenuContTop = $('.allMenu-cont').offset().top - 200;

        // ------------------------------
        // 	Slider
        // ------------------------------
        var _sliderFilterList = new Swiper('.slider-filter-list', {
            spaceBetween:0,
            slidesPerView:'auto',
            //centeredSlides:true,
            loopedSlides:1,
            loop: false,
            speed:300,
            grapCursor:true,
            observer:true,
            observParents:true,
            resistanceRatio:0 //드래그 저항비율 제어
        });

        $('.slider-filter-list .swiper-slide').on('mousedown', function(e) {
            e.preventDefault();			
            var getSlideIdx = $(this).data('slide-index');
            //console.log('getSlideIdx', getSlideIdx)

            if ($('.slider-filter-cont').hasClass('is-sticky')) {
                var $divItemTop;
                var $scrollEnd = $(document).height() - $(window).height();

                if (getSlideIdx == 0) {
                    _sliderFilterList.slideTo(0, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                    $('html, body').stop().animate({scrollTop:$allMenuContTop}, 300, 'swing');
                }
                else if (getSlideIdx == 1) {
                    $divItemTop = $('#divItem_1').offset().top - ($filterListContHeight * 2);
                    $('html, body').stop().animate({scrollTop:$divItemTop}, 300, 'swing');
                }
                else if (getSlideIdx == 6) {
                    $('html, body').stop().animate({scrollTop:$scrollEnd - ($winWidth <= 480 ? 100 : 300)}, 300, 'swing');
                }
                else if (getSlideIdx == 7) {
                    $('html, body').stop().animate({scrollTop:$scrollEnd - 80}, 300, 'swing');
                }
                else if (getSlideIdx == 8) {
                    $('html, body').stop().animate({scrollTop:$scrollEnd}, 300, 'swing');
                }
                else {
                    $divItemTop = $('#divItem_'+ getSlideIdx +'').offset().top - $filterListContHeight;
                    $('html, body').stop().animate({scrollTop:$divItemTop}, 300, 'swing');
                }
            }

        });

        // ------------------------------
        // 	Scroll
        // ------------------------------
        var nScrollPos = [];
        var nScrollPosNum = 0;
        var $winTop = $(window).scrollTop();
        var $allMenuContTop = $('.allMenu-cont').offset().top - ($homeHeaderHeight * 2);
        console.log('allMenuContTop', $allMenuContTop)

        $('.allMenu-list .div-item').each(function(idx, item) {
            nScrollPos[nScrollPosNum] = $(this).offset().top - 200;
            nScrollPosNum++;
        });

        $(window).scroll(function(e) {
            var $nowTop = $(this).scrollTop();
            var $scrollEnd = $(document).height() - $(window).height();

            //console.log('$nowTop', $nowTop)
            //console.log('$scrollEnd', $scrollEnd)

            for (var i = 0; i< nScrollPos.length; i++) {
                if ($nowTop > nScrollPos[i]) {
                    var getItemId = $('.allMenu-list .div-item').eq(i).attr('id');
                    var idLastNum = getItemId.charAt(getItemId.length - 1);

                    //console.log('idLastNum', idLastNum)
                    
                    _sliderFilterList.slideTo(idLastNum, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=' + idLastNum + ']').addClass('active');

                    if ($nowTop >= $scrollEnd - ($winWidth <= 480 ? 100 : 300)) {
                        _sliderFilterList.slideTo(6, 300, false);
                        $('.slider-filter-list').find('.active').removeClass('active');
                        $('.slider-filter-list').find('.swiper-slide[data-slide-index=6]').addClass('active');
                    }
                    if ($nowTop >= $scrollEnd - 80) {
                        _sliderFilterList.slideTo(7, 300, false);
                        $('.slider-filter-list').find('.active').removeClass('active');
                        $('.slider-filter-list').find('.swiper-slide[data-slide-index=7]').addClass('active');
                    }
                    if ($nowTop == $scrollEnd) {
                        _sliderFilterList.slideTo(8, 300, false);
                        $('.slider-filter-list').find('.active').removeClass('active');
                        $('.slider-filter-list').find('.swiper-slide[data-slide-index=8]').addClass('active');
                    }

                }
            }
        
            if ($nowTop > $allMenuContTop) {
                $('body').addClass('js-filter-list-fixed');
            }
            else {
                // scroll up
                if ($nowTop < $winTop) {
                    $('body').removeClass('js-filter-list-fixed');
                    _sliderFilterList.slideTo(0, 300, false);
                    $('.slider-filter-list').find('.active').removeClass('active');
                    $('.slider-filter-list').find('.swiper-slide[data-slide-index=0]').addClass('active');
                }
            }
            
            $winTop = $nowTop;
            
        });

    }
} 

KIA_RNW_600_0000_2.init();

/** 
 * 모피어스 화면 상태 이벤트 함수 
 */ 
// var MStatus = { 
//     onReady : function(event){ 
//         console.log("onReady page : "+PGV.currentPage); 
//         KIA_RNW_600_0000.init(); 
//     }, 
//     onHide : function(event){}, 
//     onRestore : function(event){}, 
//     // onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용 
//     // onBack : function(){}, 
//     onDestroy : function(event){}, 
//     onPause : function(event){}, 
//     onResume : function(event){} 
// }; 
