/**
 * @파일명 : AS-IS :  KIA_MOB_710_1000.js / RENEWAL : KIA_RNW_620_0000.js
 * @작성자 : 이현석, (리뉴얼) 케이스마텍 추헌남
 * @생성일 : 2022.03.17
 * @메뉴명 : 공지사항
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	// 전체 메뉴 스택정리
	var backFlag = MData.param("backFlag");
	if(backFlag != "Y"){
		garbageCollector();
	}
	// TODO : 외부(메세지, 푸시, 이벤트 등)에서 타고 들어오는 공지사항 로직 추가
	notificationListInit();
	
	/**
	 * 화면 이벤트
	 */
	setEvent();
	//screenViewGa(gaSendUrl["KIA_MOB_710_1000"].pageNm);//2020 공통으로 변경
};

function setEvent() {
/*
	// 공지사항 클릭 시 상세 화면으로 이동
	$(document).on("click", ".btn-notic", function(){
		var _notiNo = $(this).parent().attr("data-noti-no");
		var _notiTitle = $(this).children(".lst-ttl").text();
		var _notiDate = $(this).children(".lst-date").text();
		
		MPage.html({
			url : "../710/KIA_MOB_710_1010.html",
			param : {
				notiNo : _notiNo
			}
		});
	});
*/
    //탭 콘텐츠 펼침
    $(document).on('click', '.accordion .title', function(){
        if($(this).parent('.accordion').hasClass('on')){
            $(this).parent('.accordion').removeClass('on');
        } else {
            $('.accordion').removeClass('on');
            $(this).parent('.accordion').addClass('on');
            var _notiNo = $(this).parent().attr("data-noti-no");
            selectNotificationDetail(_notiNo);
        }
    });

    //공지사항 아코디언 자동 스크롤
    $(document).on('click', '.type-faq .accordion', function(){
        var x = $(this).offset();
        var now=$('.content').scrollTop();
        var top = $('.header').offset().top;
        //console.log("--" + x.top + ' - -' + now + ' 헤더' + top);
        $('.content').animate({scrollTop : (x.top - (top + 56) + now)}, 300);
    });

    // 컨텐츠내의 a태그 return;
    $(document).on("click", "a", function(e){
        e.preventDefault();
        return false;
    });

    // 컨텐츠 내의 URL 클릭 시
    $(document).on("click", ".tag-url", function(){
        var _url = $(this).text();
        MPage.activity({
            className : "WebviewActivity",
            param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, _url)
        });
    });

    $(document).on("click", "a", function(){
        var _url = $(this).attr("href");
        MPage.activity({
            className : "WebviewActivity",
            param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, _url)
        });
    });
}


var notificationListInit = function(){
	PGV.currentPageNo = 1;			// 현재 페이지 번호
	PGV.pageSize = 100;				// 받은 페이지의 총 개수
	PGV.totCnt = null;
	PGV.pageStart = null;
	PGV.pageEnd = null;
	
	$("#noticeList").empty();
	
	selectNotificationList();	
};

/**
 * 공지사항 목록 조회
 */
var selectNotificationList = function(){
	MNet.httpSendAsIs({
		path : inf.notification.select.url,
		sendData : {
			currentPageNo : PGV.currentPageNo,
			pageSize : PGV.pageSize
		},
		callback : selectNotificationListCallback
	});
};

/**
 * 공지사항 목록 조회 콜백 함수
 */
var selectNotificationListCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	
	if(code == "200"){
		appendNotificationList(receivedData.notificationListResDto);
		
		PGV.totCnt  = receivedData.totCnt;
		PGV.pageStart = receivedData.pageStart;
		PGV.pageEnd = receivedData.pageEnd;
	} else {
		$(".no-data").removeClass('none');
		$("#notificationList").addClass('none');
		MPopup.alert(msg);
	}
};

var appendNotificationList = function(list){
	var strBuff = "";
	
	if(list.length > 0){
		$(".no-data").addClass('none');
		$("#notificationList").removeClass('none');
	}else{
		$(".no-data").removeClass('none');
		$("#notificationList").addClass('none');
		return;
	}

	for(var i=0; i<list.length; i++){
		var _title = "";
		if(list[i].notiGbnCcd == "1"){		// 1 : 공지게시물, 2 : 일반게시물
			_title = "[공지] " + list[i].title;
		}else{
			_title = list[i].title;
		}

        strBuff += '<li>';
        strBuff += '    <div class="btn-notic accordion" data-noti-no="' + list[i].notiNo + '">';
        strBuff += '        <div class="title">';
        strBuff += '            <p class="notice-ttl">' + _title + '</p>';
        strBuff += '            <span class="lst-date">' + DateUtil.getYMD(list[i].creDtm) + '</span>';
        strBuff += '        </div>';
        strBuff += '        <div class="inbox">';
        strBuff += '            <div class="accordion-wrap">';
        strBuff += '                <div class="notic-answrap">';
        strBuff += '                    <p class="notic-tit">'+_title+'</p>';
        strBuff += '                    <p class="notic-ans" name="' + list[i].notiNo+'">';
        strBuff += '                    </p>';
        strBuff += '                </div>';
        strBuff += '            </div>';
        strBuff += '        </div>';
        strBuff += '    </div>';
        strBuff += '</li>';

	}
	
	$("#notificationList").append(strBuff);

    // 20201228 공지사항 번호가 조회된다면 상세 표시하도록 체크
    // order by noti_gbn_ccd asc, cre_dtm desc, title asc 라서 역순정렬 아님
    // 타고 들어오는 번호의 경우 최신 10건 내에 조회된다는 가정, 위의 조회조건상 최신 10건 이후 공지사항은 펼쳐지기 어려움
	if(!isEmpty(MData.param("notiNo"))){
	    var pNotiNo = MData.param("notiNo");
        if(!isEmpty($('[data-noti-no="'+pNotiNo+'"]'))){
            $('.accordion').removeClass('on');
            $('[data-noti-no="'+pNotiNo+'"]').addClass('on');
            selectNotificationDetail(pNotiNo);
            $('.content').animate({scrollTop : $('[data-noti-no="'+pNotiNo+'"]').offset().top-parseInt($('.content-wrap').css('padding-top').replace(/px/g,''))});
        }else{
            MData.removeParam("notiNo");
        }
	}
};

/**
 * 하단 스크롤시 더보기 이벤트
 */
var selectMoreListData = function(){
	var totalPageCnt = Math.ceil(PGV.totCnt/PGV.pageSize);	// 전체 페이지 수
	
	if(totalPageCnt > PGV.currentPageNo){
		PGV.currentPageNo = PGV.pageEnd/PGV.pageSize + 1;
		selectNotificationList();
	}
};

/**
 * 공지사항 상세 내용 조회
 */
var selectNotificationDetail = function(_notiNo){
	console.log("notiNo === > "+_notiNo);
	MNet.httpSendAsIs({
		path : inf.notification.detail.url,
		sendData : {
			notiNo : _notiNo
		},
		callback : selectNotificationDetailCallback
	});
};

/**
 * 공지사항 상세 내용 콜백
 */
var selectNotificationDetailCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;

	if(code == "200"){
		//$("#notiTitle").html(receivedData.title);					// 공지사항 제목
		//$("#notiDate").html(DateUtil.getYMD(receivedData.creDtm));	// 공지사항 날짜
		//$("#notiContWrap").html(receivedData.cont);					// 내용

		console.log("receivedData.cont == >> "+receivedData.cont);

		var notiContent = receivedData.cont;
			notiContent = notiContent.replace(/&quot;/gi, "\"");

		$('[name="'+this.sendData.notiNo+'"]').html(notiContent);

        if(!isEmpty(MData.param("notiNo"))){
        //    var pNotiNo = MData.param("notiNo");
            MData.removeParam("notiNo");

            $('[data-noti-no="'+this.sendData.notiNo+'"]').trigger("click");
        }
	}else{
		MPopup.alert(msg);
	}
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};
