/**
 * @파일명 : KIA_MOB_320_1010.js / 리뉴얼 - KIA_RNW_721_0000_1.js
 * @작성자 : 이현석 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2022-03-25
 * @메뉴명 : 각 이벤트 상세보기
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	
	PGV.evtNo = MData.param("evtNo"); //  상세 페이지 불러 오기 
	PGV.eventType = MData.param("eventType") || "ing"; //  이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
//	MData.removeParam("evtNo");
//	MData.removeParam("eventType");
	PGV.currentDate = moment().format("YYYYMMDDHH");

	if(PGV.eventType == "ing"){
		$("#evtTitleText").text("진행 중 이벤트");
		screenViewGa(gaSendUrl["KIA_MOB_320_1010"].pageNm); //진행중인
	}else if(PGV.eventType == "end"){
		$("#evtTitleText").text("종료된 이벤트");
		screenViewGa(gaSendUrl["KIA_MOB_320_1110"].pageNm); //종료
	}else if(PGV.eventType == "msg"){
		$("#evtTitleText").text("");
	}else if(PGV.eventType == "ingPrg"){
		$("#evtTitleText").text("진행 중 프로그램");
	}else if(PGV.eventType == "endPrg"){
		$("#evtTitleText").text("종료된 프로그램");
	}
	evtChk();
	selectDetailEvent();
	
	/**
	 * 화면 이벤트
	 */
	setEvent();
};


var setEvent = function() {
};

var evtChk = function(){
	MNet.httpSendAsIs({
		path : inf.event.getEventDate.url,
		sendData : {
		},
		callback : evtChkCallback
	});
}

var evtChkCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == "200"){
		var serverTime = receivedData.curDtm;
		if(serverTime.length == 14){ //.slice(0,10)
			PGV.currentDate = serverTime.slice(0,10);
		}else{
			PGV.currentDate = moment().format("YYYYMMDDHH");
		}
	}else{
		PGV.currentDate = moment().format("YYYYMMDDHH");
	}
};

/**
 * 상세 이벤트 조회
 */
var selectDetailEvent = function(){
	var _inf = inf.event.detailEvent.url;
	
	MNet.httpSendAsIs({
		path : _inf,
		sendData : {
			evtNo : PGV.evtNo
		},
		callback : selectDetailEventCallback
	});
};

/**
 * 상세 이벤트 조회 콜백
 */
var selectDetailEventCallback = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;

	if(code == "200"){
		var startTime = receivedData.evtStartDtm.split(" ")[0];
		var endTime = receivedData.evtEndDtm.split(" ")[0];
		$("#titleHtml").html(receivedData.evtNm);
		$("#dateHtml").html(startTime+' ~ '+endTime);
		var nowTm = moment(PGV.currentDate).format("YYYYMMDD");
		var chkEndTm = moment(endTime).format("YYYYMMDD");
		if(PGV.eventType == "msg"){
		    if(nowTm > chkEndTm){
                PGV.eventType = "end";
                $("#evtTitleText").text("종료된 이벤트");
                screenViewGa(gaSendUrl["KIA_MOB_320_1110"].pageNm); //종료
			}else{
			    PGV.eventType = "ing";
                $("#evtTitleText").text("진행 중 이벤트");
                screenViewGa(gaSendUrl["KIA_MOB_320_1010"].pageNm); //진행중인
			}
		};
		var _os = MNavigator.os().toLowerCase();
		if(PGV.evtNo == CONSTANT.EVT_NOI){
			$("#htmlTypeWrap").remove();
			$("#linkTypeWrap").remove();
			$("#eventDeatail").removeClass("fix").addClass("scroll");
			setIosEvt();
			return;
		}else if(receivedData.evtDescHtmlYn == "Y"){	// 데이터 타입이 html로 내려오는 경우
			$("#htmlTypeWrap").html(receivedData.evtDesc);
			$("#linkTypeWrap").remove();
			$("#inwrapDiv").remove(); //화끈한빅
			$("#eventDeatail").removeClass("fix").addClass("scroll");
		}else{		// 데이터 타입이 link url 로 내려오는 경우
			$("#linkTypeWrap").attr("src", CONSTANT.IMG_URL_PREFIX + receivedData.lingUrl);
			$("#htmlTypeWrap").remove();
			$("#inwrapDiv").remove(); //화끈한빅
		    setresize();	// iOS 상세페이지 하단 잘림 현상 수정 
		};
	}else{
		MPopup.alert(msg);
	}
};

var setIosEvt = function(){
	// 화끈한 빅 이벤트 화면 그려주기 
	setIosMenu();

    $(".btn-price").on("click", function(){
        var $this = $(this);
        var tm = moment().format("YYYYMMDDHHmm");
        var nowtime = tm.slice(8,12);
        var code = $this.attr("id");

        if($("#"+code).prop("disabled")){
        	return;
        };

        if(PGV.eventType == "end"){
            alert('종료된 이벤트 입니다.'); // 
            return;
        }
 		
 		if(isEmpty(PGV.loginInfo)){
			COMMON_FUNCTION.TOOL.UI.showNotiLoginPopup();

 		}else if(code != "" && PGV.evtNum > 0 && nowtime >= "1500"){
        	MData.global("autonPath", "https://carnlife.auton.kr/product/category/product_view/" + code);
			MPage.html({
				url : "../600/KIA_MOB_600_1000.html",
				param : {
					rUrl : "https://carnlife.auton.kr/a/P000000",
					evtCd : code
				}
			});
        }else{ // 응모시간이 아직 아닐때 15시
        	code = ""; // 상품 코드
            $("#checkLayerPopWrap").removeClass("none");
            $("#checkCompletePop").removeClass("none");
            return;
        }


    });

    $("#checkCompleteOkBtn").on("click", function(){
        $("#checkLayerPopWrap").addClass("none");
        $("#checkCompletePop").addClass("none");
    });

}
// 화끈한 빅 재고 확인 
function hotCnt(evtCode){
	//소스보안점검 주석처리.
	//20220425==> 1회성 이벤트를 위한 임시개발, 미사용확인함.
    // $.ajax.call($, {
	//   	url: "http://nflab.auton.kr/api/front/ec/red/product/event/stock",
	//   	data: {eventCode : evtCode},
	//   	success: function(_data) {
	//   		exWNHideIndicator();
	// 		var list = _data.data;
	//        	for (var i = 0; i < list.length; i++) {
	//        		var obj = list[i];
	//        		if(obj.stock == 0 || obj.pid == 56034){
	//        			$("#"+obj.pid+"_mark").addClass("mark");
	//        			$("#"+obj.pid).prop("disabled", true);
	//        		}
	//        	}
	// 	},
	// 	error: function(_data) {
	//   		exWNHideIndicator();
	//   		// alert("error");
	// 	}
	// });
};
// 화끈한 빅 화면 그려주기 
var setIosMenu = function(){
	serverTime = PGV.currentDate.slice(0,8);
    var hour = PGV.currentDate.slice(8,10);
    PGV.evtNum = 0;
    if(serverTime >= "20190926" && serverTime <= "20190927"){ // 1차
    	$("#showEvtOne").removeClass("none");
    	$("#firstEvt").removeClass("none");
    	$("#commonDiv").removeClass("none");
    
    	if(serverTime == "20190927"){
    		PGV.evtNum = 1;
    	};

    	if(serverTime <= "20190927" && hour >= "15"){
    		hotCnt("19$01");
    	}
    }else if(serverTime >= "20191003" && serverTime <= "20191004"){ //2차
    	$("#showEvtOne").removeClass("none");
    	$("#secondEvt").removeClass("none");
    	$("#commonDiv").removeClass("none");
    	
    	if(serverTime == "20191004"){
    		PGV.evtNum = 2;
    	};

    	if(hour >= "15" && serverTime <= "20191004"){
    		hotCnt("19$02");
    	}        
    }else if(serverTime >= "20191010" && serverTime <= "20191011"){ //3차
		$("#showEvtOne").removeClass("none");
    	$("#thirdEvt").removeClass("none");
    	$("#commonDiv").removeClass("none");
    	
    	if(serverTime == "20191011"){
    		PGV.evtNum = 3;
    	};

    	if(hour >= "15"){
    		hotCnt("19$03");
    	}
    }else if(serverTime >= "20191017" && serverTime <= "20191018"){ //4차
    	$("#showEvtOne").removeClass("none");
    	$("#fourthEvt").removeClass("none");
    	$("#commonDiv").removeClass("none");

    	if(serverTime == "20191018"){
    		PGV.evtNum = 4;
    	};

    	if(hour >= "15" && serverTime <= "20191018"){
    		hotCnt("19$04");
    	}                    	
    }else{
    	$("#noShow").removeClass("none");
    	$("#commonDiv").removeClass("none");
    	PGV.evtNum = 0;
    }
}

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){
		// 개인정보 동의 
		if(MData.param("agreeYn") == "Y"){
			MData.removeParam("agreeYn");
			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "chkEvent",
				responseData : {
					agreeYn : "Y"
				}
			}, CONSTANT.IFRM_TGT_ASTR);
		}else if(MData.param("agreeYn") == "N"){
			MData.removeParam("agreeYn");
			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "chkEvent",
				responseData : {
					agreeYn : "N"
				}
			}, CONSTANT.IFRM_TGT_ASTR);
		}
		var mbrEnt = ""; // 가입일 
		if(!isEmpty(PGV.loginInfo)){
			mbrEnt = PGV.loginInfo.mbrEntDtm;
		}
		// 마케팅 동의 
		if(MData.param("mkYn") == "Y"){
			MData.removeParam("mkYn");
			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "mkEvent",
				responseData : {
					mkYn : "Y",
					mbrEntDtm : mbrEnt
				}
			}, CONSTANT.IFRM_TGT_ASTR);
		}else if(MData.param("mkYn") == "N"){
			MData.removeParam("mkYn");
			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "mkEvent",
				responseData : {
					mkYn : "N",
					mbrEntDtm : mbrEnt
				}
			}, CONSTANT.IFRM_TGT_ASTR);
		}else{
			MData.removeParam("mkYn");
			var _loginYn = "";
			if(!isEmpty(PGV.loginInfo)){
				_loginYn = "Y";
			};

			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "mkEvent",
				responseData : {
					mkYn : "",
					_loginYn : _loginYn,
					mbrEntDtm : mbrEnt
					
				}
			}, CONSTANT.IFRM_TGT_ASTR);
		}
		// 야구이벤트 화면 
		if(MData.param("baseBallYn") == "Y"){
			MData.removeParam("baseBallYn");
			var _param = {baseBallYn : "Y"};
            if(!isEmpty(MData.param("evtYn"))){        // 20211126 KIAVIK-955 타 페이지에서 이벤트 상세 페이지로 돌아올때 quizYn 사용안하고 이벤트 참여완료 했을경우 중복접근 제어용
                _param = $.extend(_param, {evtYn : MData.param("evtYn")});
            }
			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "baseBallYn",
				responseData : _param
			}, CONSTANT.IFRM_TGT_ASTR);
		}else if(MData.param("baseBallQuizYn") == "Y"){
			PGV.baseBallQuizYn = "Y";
			MData.removeParam("baseBallQuizYn");
			$("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
				evtType : "baseBallQuizYn",
				responseData : {
					baseBallQuizYn : "Y"
				}
			}, CONSTANT.IFRM_TGT_ASTR);
		}
		
		// 휴면회원 이벤트 정상동작시
		if(!isEmpty(MData.global("pageClick"))){
			var _evtNo = MData.global("pageClick").evtNo;
            var _clickYn = (isEmpty(MData.global("pageClick")) ? "N" : "Y");
            MData.removeGlobal("pageClick");
            $("#linkTypeWrap").get(0).contentWindow.postMessage.call($("#linkTypeWrap").get(0).contentWindow, {
                evtType : "pageClick",
                responseData : {
                    clickYn : _clickYn,
                    evtNoYn : (PGV.evtNo == _evtNo ? "Y" : "N")
                }
            }, CONSTANT.IFRM_TGT_ASTR);
		}
	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};