/**
 * @파일명 : KIA_MOB_520_1040.js / 리뉴얼 - KIA_RNW_731_0000.js
 * @작성자 : 이현석 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2022-03-25
 * @메뉴명 : 이벤트-진행중
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	// 전체 메뉴 스택정리
	var backFlag = MData.param("backFlag");
	if(backFlag != "Y"){
		garbageCollector();
	}
	PGV.evtCd = "LIFECARE";//"EVLIFECARE";         //ALL':이벤트전체, 'JOIN':참여, 'PARTNER':제휴 'CARCARE', 'LIFECARE'
    PGV.tabType = '';       // ty1 : ing, ty2 : end
    nowServerTime(); // 서버 시간 20190612
    eventListInit();
    setEvent();
    /**
     * 화면 이벤트
     */
};

var eventListInit = function(){
    PGV.currentPageNo = 1;			// 현재 페이지 번호
    PGV.pageSize = 10;				// 받은 페이지의 총 개수
    PGV.totCnt = null;
    PGV.pageStart = null;
    PGV.pageEnd = null;

    // 리스트 초기화
    $('.evtlist').empty();
    $('.end-evtlist').empty();

    $("[data-tab-type]").each(function(e){
        var $li = $(this).parent();

        if($li.hasClass('on')){
            PGV.tabType = $(this).data("tabType");
//            PGV.tabType == 'ty1' ? selectEventList() : selectEndEventList();
            selectEventList();
            return;
        }
    });

};

var setScrollEvent = function(){
    //스크롤 반응 HEADER
    var lastScrollTop = 0,
    delta = 15;
    $('.scroll-loading').scroll(function (event) {
        var st = $(this).scrollTop();
        //console.log("--" + st);

        lastScrollTop = st;
    });
};

var setEvent = function() {
    // 탭 변경
    $(document).on("click", "[data-tab-type]", function(){
        if($(this).parent().hasClass('on')) return;
        // 탭 클래스 변경
        $(".function-tab li button").parent().removeClass("on");
        PGV.tabType = $(this).data('tabType');
        $('[data-tab-type="' + PGV.tabType + '"]').parent().addClass("on");

        //ty1 : ing, ty2 : end
        if(PGV.tabType == "ty1"){
//        	screenViewGa(gaSendUrl["KIA_MOB_520_1040"].pageNm);
            $('[data-content-type="ty2"]').addClass('none');
            $('[data-content-type="ty1"]').removeClass('none');
            
            PGV.evtCd = "LIFECARE";
        }else{
//        	screenViewGa(gaSendUrl["KIA_MOB_520_1041"].pageNm);
            $('[data-content-type="ty1"]').addClass('none');
            $('[data-content-type="ty2"]').removeClass('none');
            
            PGV.evtCd = "EVLIFECARE";
        }

        eventListInit();
    });

    $(document).on("click", ".evtlist > li button, .end-evtlist > li button", function(){	//리스트 클릭 이벤트
        var that = $(this);
        var _evtNo = that.parent().data('evtNo');

        if(_evtNo == "web"){
            var _url = that.parent().attr("data-web-url");
            var carNlifeChek = _url.split("@");

            if(!isEmpty(carNlifeChek[0]) && carNlifeChek[0] == "carnLife"){     // 카앤라이프일경우 이벤트 등록 형식 carnLife@/a/M070100@621
                MPage.html({
                    url : PATH_MANAGER.KIA_RNW_810_0000.path,
                    param : {
                        rUrl : CONSTANT.AUTON_URL_PREFIX + carNlifeChek[1],
                        evtCd : isEmpty(carNlifeChek[2]) ? "" : carNlifeChek[2],
                        evtYN : "B"
                    }
                });
            }else{
                MPage.activity({
                    className : "WebviewActivity",
                    param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, _url)
                });
            }
        }else{
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_721_0000_1.path,       // 카_라이프 케어 상세 페이지는 이벤트 상세 페이지와 동일하게 공유
                param : {
                    evtNo : _evtNo,		// 이벤트 번호
                    eventType : !that.hasClass("disabled") ? "ingPrg" : "endPrg"	// 이벤트 타입 (진행 : ing, 종료 : end, 당첨자 : pick)
                }
            });
        }

    });

    // 필터 클릭 이벤트 - 기아멤버스
	$(document).on('click','input:radio[name="members"]', function(){
	    PGV.evtCd = $(this).attr('data-type');
	    PGV.mState = $(this).attr('data-id');
	    eventListInit();
	});

	// 필터 클릭 이벤트 - EV멤버스
    $(document).on('click','input:radio[name="evm"]', function(){
        PGV.evtCd = $(this).attr('data-type');
        PGV.evState = $(this).attr('data-id');
	    eventListInit();
    });

    setScrollEvent();

};

/**
 * 진행중 이벤트 목록 조회
 */
var selectEventList = function(){
	if (PGV.evtCd == null || PGV.evtCd == undefined)
        PGV.evtCd = "LIFECARE";

    // CARCARE인 경우 mState, EVCARCARE인 경우 evState
    PGV.state = null;
    if  (PGV.evtCd == "LIFECARE")
        PGV.state = PGV.mState;
    else
        PGV.state = PGV.evState;

    if (PGV.state == null || PGV.state == undefined)
        PGV.state = "ALL";
    console.log("PGV.evtCd=" + PGV.evtCd + ", PGV.state=" + PGV.state);
    MNet.httpSendAsIs({
        path : inf.event.allEventCareList.url,
        sendData : {
            currentPageNo : PGV.currentPageNo,
            pageSize : String(PGV.pageSize),
            evtCd : PGV.evtCd,
            state : PGV.state
        },
        callback : selectEventListCallBack
    });
};

var selectEventListCallBack = function(receivedData){
    exWNHideIndicator();
    var code = receivedData.resultCode;
    var msg = receivedData.resultMsg;
    if(code == '200'){
        PGV.totCnt  = receivedData.totCnt;
        PGV.pageStart = receivedData.pageStart;
        PGV.pageEnd = receivedData.pageEnd;

        if(receivedData.allEventCareListResDto.length > 0){
            appendIngList(receivedData.allEventCareListResDto);
        }else{
        	$("#noDataDiv").removeClass("none");
        	$("#noDataDiv2").removeClass("none");
            $(".evtlist").addClass("none");

            if (PGV.state == "N")
                $(".txtgr6").text("종료된 프로그램이 없습니다.");
            else
                $(".txtgr6").text("진행 중인 프로그램이 없습니다.");
        }

    }else {
        MPopup.alert(msg);
    }
};

var appendIngList = function(list){
    var eventIngList = "";

    for(var i=0; i< list.length; i++){
        var obj = list[i];
        var startTime = obj.evtStartDtm.split(" ")[0];
        var endTime = obj.evtEndDtm.split(" ")[0];
        var imgPath = CONSTANT.IMG_URL_PREFIX + obj.savedFilePath + obj.savedFileNm;
        if(obj.irsLinkYn == "Y"){ // 배너만으로 이동 이벤트 추가 20190729
            eventIngList += '<li data-evt-no="web" data-web-url= "'+obj.lingUrl+'">';
        }else{
            eventIngList +=	'<li data-evt-no="'+obj.evtNo+'">';
        }
        eventIngList +=	'   <button type="button" class="event-wrap ' + (obj.state == "Y" ? '' : 'disabled') + '">';
        eventIngList += '       <div class="top-box">';
        if(!isEmpty(obj.savedFilePath)){
            eventIngList +=			'<img src="'+imgPath+'" class="event-img" alt="'+obj.evtNm+'" />';
        }
        eventIngList += '       </div>';
        eventIngList += '       <div class="btm-box">';
        eventIngList +=	'           <p class="main-txt">'+obj.evtNm+'</p>';
        eventIngList +=	'           <p class="sub-tit4">'+startTime+' ~ '+endTime+'</p>';
        eventIngList += '       </div>';
        eventIngList +=	'   </button>';
        eventIngList +=	'</li>';
    }

    $(".evtlist").append(eventIngList);

    $("#noDataDiv").addClass("none");
    $("#noDataDiv2").addClass("none");
    $(".evtlist").removeClass("none");

    if (PGV.state == "N")
        $(".txtgr6").text("종료된 프로그램이 없습니다.");
    else
        $(".txtgr6").text("진행 중인 프로그램이 없습니다.");
}
/**
 * 진행중 이벤트 목록 조회 종료
 */

/**
 * 종료 이벤트 목록 조회
 */
var selectEndEventList = function(){
    MNet.httpSendAsIs({
        path : inf.event.careEndEventList.url,
        sendData : {
            currentPageNo : PGV.currentPageNo,
            pageSize : String(PGV.pageSize),
            evtCd : "LIFECARE"
        },
        callback : selectEndEventListCallBack
    });
};

var selectEndEventListCallBack = function(receivedData){
    exWNHideIndicator();
    var code = receivedData.resultCode;
    var msg = receivedData.resultMsg;
    if(code == '200'){
        PGV.totCnt  = receivedData.totCnt;
        PGV.pageStart = receivedData.pageStart;
        PGV.pageEnd = receivedData.pageEnd;

        if(receivedData.eventEndInfoListResDto.length > 0){
            appendFinishList(receivedData.eventEndInfoListResDto);
        }else{
            $("#noDataEndDiv").removeClass("none");
            $(".evtdone").addClass("none");
        }


    }else {
        MPopup.alert(msg);
    }
};

/**
 * 종료이벤트 목록 조회
 */
var appendFinishList = function(list){
    var strBuff = "";

    for(var i=0; i<list.length; i++){
        if(list[i].irsLinkYn == "Y"){ // 배너만으로 이동 이벤트 추가 20190729
            strBuff += '<li data-evt-no="web" data-web-url= "'+list[i].lingUrl+'">';
        }else{
            strBuff += '<li data-evt-no="' + list[i].evtNo + '">';
        }
        strBuff += '	<button type="button">';
        strBuff += '	    <p class="sub-tit8">' + list[i].evtNm + '</p>';
        strBuff += '	    <p class="sub-tit5">' + DateUtil.getYMD(list[i].evtStartDtm) + ' ~ ' +  DateUtil.getYMD(list[i].evtEndDtm) + '</p>';
        strBuff += '	</button>';
        strBuff += '</li>';
    }

    $(".end-evtlist").append(strBuff);

    $("#noDataEndDiv").addClass("none");
    $(".evtdone").removeClass("none");
};


/**
 * 하단 스크롤시 더보기 이벤트
 */
var selectMoreListData = function(){
    var totalPageCnt = Math.ceil(PGV.totCnt/PGV.pageSize);	// 전체 페이지 수
    console.log("totalPageCnt=" + totalPageCnt + ", PGV.currentPageNo=" + PGV.currentPageNo);
    if(totalPageCnt > PGV.currentPageNo){
        PGV.currentPageNo = PGV.pageEnd/PGV.pageSize + 1;
        $("[data-tab-type]").each(function(e){
            var $li = $(this).parent();
            var type = '';

            if($li.hasClass('on')){
                var type = $(this).data("tabType");
//                type == 'ty1' ? selectEventList() : selectEndEventList();
                selectEventList();
                return;
            }
        });

    }
};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){
		nowServerTime(); // 서버 시간 20190612
	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};