/**
 * @파일명 : KIA_MOB_810_1060.js
 * @작성자 : 이현석
 * @생성일 : 2018. 8. 22. 오후 7:53:48
 * @메뉴명 : 지문 인증
 */
var pageInit = function(){
	/**
	 * 초기화
	 */
	PGV.returnLoginParam = MData.param();	//로그인 후 이동해야할 페이지가 있는지 확인
	MData.removeParam();
	PGV.errorMsg = "잠시 후 다시 시도 해 주세요.";
	if(!isEmpty(PGV.loginInfo)){
		$("#userId").prop('disabled', true);
		$("#userId").val(PGV.loginInfo.mbrId);
	}
	$("#infoModifyCheckBtn").prop('disabled', true);
	/**
	 * 화면 이벤트
	 */
	setEvent();
	//screenViewGa(gaSendUrl["KIA_MOB_810_1060"].pageNm); //2020 공통으로 변경
};


var setEvent = function () {
	$(document).on("click", "#infoModifyCheckBtn", function(){	//정보수정
		var userId = $.trim($("#userId").val());
		var userPw = $("#userPw").val();
		if(!emailCheck(userId)){
			MPopup.alert('입력하신 아이디 또는 비밀번호가 일치하지 않습니다.');
			return false;
		}else if(!isEmpty(userPw) && userPw.length > 7){
			MNet.httpSend({
				path : inf.member.login.url,
				sendData : {
					mbrId : userId.toLowerCase(),
					pw : userPw
				},
				callback : loginCallBack
			});
			return false;
		}else{
			MPopup.alert('입력하신 아이디 또는 비밀번호가 일치하지 않습니다.');
			return false;
		}
	});

	$(document).on("keyup", "#userPw, #userId", function(){	//지문 등록 버튼 활성화 
		var userId = $.trim($("#userId").val());
		var userPw = $("#userPw").val();
		var that = $("#infoModifyCheckBtn");
		var strSpace = /\s/;  // 공백체크
	    if(strSpace.exec($("#userPw").val())) { //공백 체크
			$("#userPw").focus();
			$("#userPw").val($("#userPw").val().replaceAll(' ','')); // 공백제거
	        return false;
	    }

		if((!isEmpty(userPw) && !isEmpty(userId)) && userPw.length > 7){
			that.prop('disabled', false);
		}else{
			that.prop('disabled', true);
		}
	});	

}

//인증 콜백
var loginCallBack = function(receivedData) {
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	var pwflag = receivedData.pwStCcd;
	var _mbrId = $.trim($("#userId").val()).toLowerCase();
	var _mbrPw = $("#userPw").val();
	PGV.tempLoginInfo = receivedData;
	PGV.faceId = "N";
	if(code == "200"){ // 인증 성공시
		var randomNum = 0;
		$("#userPw").val("");
		$("#infoModifyCheckBtn").prop('disabled', true);

		if(M.page.info("device.os") == "iOS" && isEmpty(MData.storage("faceIdChk")) && MData.storage("faceIdChk") != "FACEID" ){
			PGV.faceId = "Y";
			MData.storage("faceIdChk", getSupportType());
		}

		// 비밀번호 5회 틀렸을시 
		if(pwflag == "2"){
			$("#userPw").val("");
			$("#infoModifyCheckBtn").prop('disabled', true);
			wrongPw("로그인 비밀번호 5회 오류 입니다.");
			return;
		};
		if(isAvailableFIDO() == 'true'){
			//지문 로그인 콜백
		var fidoRegistCallBack = function(code, errMessage, _token) {
			exWNHideIndicator();
			if(code == 0) {
				if(!isEmpty(MData.storage("faceIdChk"))){
					MData.removeStorage("faceIdChk");
				};
				// 팝업 강제 종료 하는경우 
				MData.storage("fidoLogin", "Y");
				MData.storage("fidoLoginPw", _mbrPw);
				MData.storage("fidoLoginId", _mbrId);
				MData.storage("fidoErrFlag", "success");
				MData.storage("fidoReset", "NO");

				setLoginInfo(PGV.tempLoginInfo);
				// 성공
				MPopup.alert({
					message : "지문이 성공적으로 등록되었습니다.",
					callback : function(){
						if(Object.keys(PGV.returnLoginParam).length > 0 && PGV.returnLoginParam.fidoErrorFlag != "Y"){
							var returnLoginParam = PGV.returnLoginParam;
							if(returnLoginParam.returnLink.includes('http://') || returnLoginParam.returnLink.includes('https://')){
								MPage.activity({
									className : "WebviewActivity",
									param : {
										method : "GET",
										requestURL : returnLoginParam.returnLink,
										headerName : "webview",
										postData : returnLoginParam.returnParams
									}
								});
							}else{
								MPage.html({
									url : returnLoginParam.returnLink,
									param : returnLoginParam.returnParams,
									action : 'CLEAR_TOP'
								});
							}
						}else{
							
							MPage.html({
								url : "../000/KIA_MOB_000_1110.html",
								action : 'CLEAR_TOP'
							});
						}
							}
					});
				
					return false;
				}else if(code == 999 || code == 6000){// 취소 눌렀을시 // TODO: 문구 변경 
					exWNHideIndicator();
					if(M.page.info("device.os") == "iOS" && MData.storage("faceIdChk") == "FACEID" && PGV.faceId == "Y"){
						MPopup.alert('Face ID 사용을 허용하지 않으셨습니다.\nFace ID를 사용하시려면 단말기 환경설정 > Face ID 및 암호 메뉴에서 변경 해 주세요.');
					}
					return false; 
				}else if(code == 1008){ //등록된 사용자가 등록하는경우 
					MPopup.confirm({
								message : "이미 등록된 지문로그인 정보가 있습니다.\n기존 등록된 지문정보를 삭제 후 재 등록 하시겠어요?\n재 등록하시더라도 디바이스에 등록된 지문정보가 삭제되지 않습니다.",
								buttons : ["취소", "재등록"],
								callback : function(index){
									if(index == 1){
										alreadyUserDeregistFido(_mbrId);
										return false;
									}else{
										return false;
									}
								}
							});
					return false; 
				}else if(code == 5000){
					if(M.page.info("device.os") == "iOS"){
						MPopup.confirm({
								message : "아이폰에서 제공하는 지문 시도 횟수가 초과되어 서비스 이용이 제한됩니다.\n'아이폰설정 > Touch ID암호'에서 잠금해제 또는 지문을 등록 후 지문인증 서비스를 다시 등록하셔야 합니다.\n스마트폰 설정 화면으로 이동 하시겠어요?",
								callback : function(index){
									if(index == 1){
										fiodAgree();
										exWNMoveToSettingMain(); //셋팅화면으로 보냄 
										return false;
									}else{
										return false;
									}
								}
							});
					}else{
						fiodAgree();
						MPopup.alert("지문 등록이 실패 하였습니다.\n잠시후 다시 시도 해주세요.");
						return false;
					};
				}else if(code == 1010){
					exWNHideIndicator();
					if(M.page.info("device.os") == "iOS"){
						MPopup.alert('지문에 관련 권한 설정은 아이폰 > 설정 > MyKia 혹은 아이폰 > 설정 > 개인정보의 설정을 확인 해 주세요.');
					}else{
						MPopup.alert('지문에 관련 권한 설정은 단말기 환경설정 > MyKia > 권한을 확인 해 주세요.');
					}
					return false;
				}else{
					MPopup.alert(PGV.errorMsg); 
					return false;
				}
			
		};
		
		}else if(MData.storage("faceIdChk") == "FACEID"){
			MPopup.alert('Face ID 사용을 허용하지 않으셨습니다.\nFace ID를 사용하시려면 단말기 환경설정 > Face ID 및 암호 메뉴에서 변경 해 주세요.');
			return false;
		}else{
			MPopup.alert("고객님이 사용하시는 단말기는 지문인증이 지원되지 않습니다."); 
			return false;
		}
		var fidoLoginCallBack = function(receivedData) {
			randomNum = receivedData.randomNum;
			
			if(receivedData.resultCode == 200 && randomNum){ // 랜덤 숫자 생성 성공
				registFIDO(PGV.tempLoginInfo.mbrId, randomNum, fidoRegistCallBack);
			}else{
				exWNHideIndicator();
				MPopup.alert(PGV.errorMsg);
			} 
		};

		MNet.httpSend({
			path : inf.fido.selectFidoCertInfo.url,
			sendData : {
				mbrId : _mbrId
			},
			callback : fidoLoginCallBack
		});
		
	}else if(code == "102"){
		MPopup.alert(msg);
		$("#userPw").val("");
		$("#infoModifyCheckBtn").prop('disabled', true);
		$("#userPw").focus();
		return false;

	}else if(code == "104"){ // 휴면 계정인경우 
		MPage.html({
			url : "../000/KIA_MOB_000_1330.html",
			animate : "MODAL_UP",
			param : {
				mbrId : _mbrId
			}
		});
		return false;

	}else if(code == "106"){ // 통합회원 가입상태 추가정보 등록
		$("#userPw").val("");
		$("#infoModifyCheckBtn").prop('disabled', true);
		MPopup.confirm({
				message : msg,
				buttons : ["취소", "가입하기"],
				callback : function(index){
					if(index == 1){
						var _url = CONSTANT.LINK_URL.KIA_MOB_810_1045.URL;
						MPage.activity({
							className : "WebviewActivity",
							param : {
								method : "POST",
								requestURL : _url,
								postData : {
									mbrId : receivedData.mbrId,
									ccspId : receivedData.ccspId,
									mbrPw : _mbrPw
								}
							}
						});
					}else{
						return false;
					}
				}
			});
		return false;
	}else if(code == "108"){ // 로그인 비밀번호 5회 오류입니다.
		$("#userPw").val("");
		$("#infoModifyCheckBtn").prop('disabled', true);
		wrongPw(msg);
		return false;
	}else{
		$("#userPw").val("");
		$("#infoModifyCheckBtn").prop('disabled', true);
		MPopup.alert(msg);
		return false;
	} 
};

var fiodAgree = function(){
	if(!isEmpty(MData.storage("fidoLogin"))){
		MData.removeStorage("fidoLogin");
		MData.removeStorage("fidoLoginPw");
		MData.removeStorage("fidoLoginId");
		MData.storage("fidoLogin", "N");
	}
}

// 이미 등록된 사용자  등록 해제 
var alreadyUserDeregistFido = function(mbrId) {
	var randomNum = 0;
	var resetDeregistFidoCallBack = function(code, errMessage){
		exWNHideIndicator();
		if(code == 0) {
			var data = {
				resultCode : "200"
			}
			loginCallBack(data);
		}else{
			MPopup.alert("지문 등록 해제에 실패하셨습니다");
		};
	};
	var resetDeregistCallBack = function(receivedData) {
		var code = receivedData.resultCode;
		var msg = receivedData.resultMsg;
		randomNum = receivedData.randomNum;
		
		if(code == 200 && randomNum){ // 랜덤 숫자 생성 성공
			deregistFIDO(MData.storage("fidoLoginId"), randomNum, resetDeregistFidoCallBack);
		}else{
			exWNHideIndicator();
			MPopup.alert(PGV.errorMsg);
		} 
	};
	
	MNet.httpSend({
		path : inf.fido.selectFidoCertInfo.url,
		sendData : {
			mbrId : MData.storage("fidoLoginId")
		},
		callback : resetDeregistCallBack
	});

};

/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){

	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};