/**
 * @파일명 : KIA_MOB_600_1100.js / 리뉴얼 - KIA_RNW_910_0000.js
 * @작성자 : 김현정 / 리뉴얼 - 케이스마텍 추헌남
 * @생성일 : 2021. 01. 19. 오후 03:05:05 / 리뉴얼 - 2022.03.30
 * @메뉴명 : 기아브랜드관
 */
 var pageInit = function(){
	/**
	 * 초기화
	 */
	// 전체 메뉴 스택정리
	var backFlag = MData.param("backFlag");
	if(backFlag != "Y"){
		garbageCollector();
	}

	nowServerTime(); // 서버 시간 20190612
	eventListInit();

	setEvent();
	/**
	 * 화면 이벤트
	 */
};

var eventListInit = function(){
	PGV.currentPageNo = 1;			// 현재 페이지 번호
	PGV.pageSize = 10;				// 받은 페이지의 총 개수
	PGV.totCnt = null;
	PGV.pageStart = null;
	PGV.pageEnd = null; 

    // 리스트 초기화
    $('.evtlist').empty();
    selectEventList();
};

var setEvent = function() {

	// 리스트 이벤트 클릭
	$(document).on("click", ".evtlist > li button, .end-evtlist > li button", function(){
		var $that = $(this);
		var webUrl = $that.parent().data('webUrl');       // 기아브랜드관 오토앤 링크인경우 600_1000(로그인연동), 나머지 웹뷰
		var _url = webUrl.split("+")[0], _sUri = isEmpty(webUrl.split("+")[1]) ? "" : webUrl.split("+")[1];
		// admin 등록 url 형식 url+subUri - https://carnlife.auton.kr/a/A020100+1873,1874

        if(_url.startsWith(CONSTANT.AUTON_URL_PREFIX)){
            MPage.html({
                url : PATH_MANAGER.KIA_RNW_810_0000.path,
                param : {
                    rUrl : _url,
                    evtCd : _sUri,
                    evtYN : "B"
                }
            });
        }else{
            MPage.activity({
                className : "WebviewActivity",
                param : COMMON_FUNCTION.TOOL.DATA.getWebviewActivityParam(CONSTANT.NET_MTHD.GET, _url)
            });
        }
	});

};

/**
 * 진행중 이벤트 목록 조회
 */
var selectEventList = function(){
	MNet.httpSendAsIs({
		path : inf.event.kiaBrandServiceList.url,
		sendData : {
            currentPageNo : String(PGV.currentPageNo),
            stsCd : "ING",
            pageSize : String(PGV.pageSize),
            svcCd : "02"
        },
		callback : eventListCallBack
	});
};

var eventListCallBack = function(receivedData){
	exWNHideIndicator();
	var code = receivedData.resultCode;
	var msg = receivedData.resultMsg;
	if(code == '200'){
		PGV.totCnt  = receivedData.totCnt;
		PGV.pageStart = receivedData.pageStart;
		PGV.pageEnd = receivedData.pageEnd;

		if(receivedData.carCareServiceListResDto.length > 0){
			appendIngList(receivedData.carCareServiceListResDto);
		}else{ // 데이터 없을경우
            $("#noDataDiv").removeClass("none");
            $(".evtlist").addClass("none");
		}
	}else {
		MPopup.alert(msg);
	}
};

var appendIngList = function(list){
	var eventIngList = "";

	if(list.length > 0){
		for(var i=0; i< list.length; i++){
			var obj = list[i];
			var startTime = obj.svcStartDtm;
			var endTime = obj.svcEndDtm;
			var imgPath = CONSTANT.IMG_URL_PREFIX + obj.savedFilePath + obj.savedFileNm;
			var dday = dDayDiff(startTime, endTime);
            eventIngList +=	'<li data-evt-no="'+obj.svcNo+'" data-web-url= "'+obj.lingUrl+'">';     // 무조건 링크연결
			eventIngList += '   <button type="button" class="event-wrap">';
			eventIngList += '       <div class="top-box">';
			if(!isEmpty(obj.savedFilePath)){
				eventIngList +=	'           <img src="'+imgPath+'" class="event-img" alt="'+obj.svcNm+'" />';
			}
			eventIngList += '       </div>';
            eventIngList += '       <div class="btm-box">';
            eventIngList += '           <p class="main-txt">' + obj.svcNm + '</p>';
            eventIngList += '       </div>';
			eventIngList +=	'   </button>';
			eventIngList +=	'</li>';	
		}
	}
	
	$(".evtlist").append(eventIngList);
	
	$("#noDataDiv").addClass("none");
    $(".evtlist").removeClass("none");
}
/**
 * 진행중 이벤트 목록 조회 종료 
 */


/**
 * 하단 스크롤시 더보기 이벤트
 */
var selectMoreListData = function(){
	var totalPageCnt = Math.ceil(PGV.totCnt/PGV.pageSize);	// 전체 페이지 수
	
	if(totalPageCnt > PGV.currentPageNo){
		PGV.currentPageNo = PGV.pageEnd/PGV.pageSize + 1;
		selectEventList();
	}
};


/**
 * 모피어스 화면 상태 이벤트 함수
 */
var MStatus = {
	onReady : function(event){
		pageInit();
	},

	onHide : function(event){

	},

	onRestore : function(event){
		nowServerTime(); // 서버 시간 20190612
	},
	
	// onBack : 하드웨어 백키시 이벤트로 mcore_api.js 에서 공통으로 처리, 백키 이벤트시 이벤트 처리해야 되는 경우 주석을 풀고 사용
//	onBack : function(){
//
//	},

	onDestroy : function(event){

	},

	onPause : function(event){

	},

	onResume : function(event){

	}
};